;Zadanie c.1.
;Napte program, ktor nata z klvesnice reazec znakov (max.100 znakov) a poda ;ponkanho menu vykon  jednu z monost:
;A
;a) vype reazec znakov na obrazovku         OK
;b) vype poradov slo miesta, kde sa nachdza prv medzera,     OK
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX   OK
;d) njde znak s max. hodnotou a vype tento znak     OK
;e) zarovn text zava (vynech prv medzery)     OK
;f) vype retazec v obrtenom porad,      OK
;g) ukon vykonvanie programu.       OK

;Autor:  DALIMIR ORFANUS (copyright)2000
;Termin odovzdania: 24.10.2000
;2.ro.,k.rok 2000/2001

                zas     segment stack                      ; definicia stakoveho segmentu
                dw      64 dup(?)
                zas     ends    
;=================================
                data    segment                            ; definicia dataveho segmentu
text1           db      'Zadaj retazec: $'
text2           db      'Nenasiel som ziadnu medzeru!!!', 0dh, 0ah, '$'
text3           db      'Zadaj znak: $'

text4           db      'Retazec: $'
text5           db      'Medzera je na mieste: $'
text6           db      'Znak s maximalnou hodnotou: $'
text7           db      'Zarovnany text:$'
text8           db      'Obratene poradie: $'
text9           db      0dh, 0ah, 'Stlac klaves...'
nl              db      0dh, 0ah, '$'
menu            db      'ͻ', 0dh, 0ah
                db      ' Menu:                                ', 0dH, 0ah
		db	'͹', 0dh, 0ah
                db      ' Pis retazec........................a ', 0dh, 0ah
                db      ' Poradove cislo prvej medzeri.......b ', 0dh, 0ah
                db      ' Hladaj znak........................c ', 0dh, 0ah
                db      ' Hladaj znak s max. Hodnotou........d ', 0dh, 0ah
                db      ' Zarovna text zlava.................e ', 0dh, 0ah
                db      ' Vypise retazec v obratenom poradi..f ', 0dh, 0ah
                db      ' Koniec..........q                    ', 0dh, 0ah
		db	'ͼ', 0dh, 0ah
                db      'Vyber: $'
buff1           db      100
pocet1          db      0  
                db      100 dup('$')
buff2           db      101 dup(?)

                data    ends
;------------------------------------
                code    segment                            ; definicia "kodesegu"
                assume  cs:code, ds:data, ss: zas

START:                                                     ;       zeby?
                mov     ax, seg data
                mov     ds, ax

CITAJ_RETAZEC:          
                mov     ah, 09h
                mov     dx, offset text1
                int     21h                                ; vypise zadaj...
                mov     dx, offset buff1
                mov     ah, 0ah
                int     21h                                ; raci nacitat retazec
                mov     dx, offset text9                   ; ze ma juzer stlacit klaves
                mov     ah, 09h
                int     21h

PIS_MENU:                                                  ;       vypise menu
                call    CAKAJ
                call    CISTI_OUTPUT
                mov     dx, offset menu
                mov     ah, 09h                                                                 
                int     21h                                                                     

                mov     ah, 01h                            ; key input                          
                int     21h                                                                     

                push    ax                                 ; odlozi si key                      
                mov     dx, offset nl                      ; lebo musi qoli korektnosti zacat ulohu od
                mov     ah, 09h                            ; od noveho riadku                   
                int     21h                                                                     
                pop     ax                                                                      

                cmp     al, 'a'                            ; co vlastne juzer xe - vypis retazca
                jne     dalej_1                            ; tato technika skokov je pouzita preto, 
                jmp     ULOHA_1                            ; lebo podmiene skoky skacu +127 a -128B
                                                           ; a JMP-u je to jedno
DALEJ_1:                
                cmp     al, 'b'
                jne     dalej_2
                jmp     ULOHA_2                            ; skok na "index 1. medzery"

DALEJ_2:                
                cmp     al, 'c'
                jne     dalej_3
                jmp     ULOHA_3                            ; skok na hladany pocet znaku v retazci

DALEJ_3:                
                cmp     al, 'd'
                jne     dalej_4
                jmp     ULOHA_4                            ; skok na "najvaetsi znak"

DALEJ_4:                
                cmp     al, 'e'
                jne     dalej_5
                jmp     ULOHA_5                            ; skok na "zarovnavanie"

DALEJ_5:                
                cmp     al, 'f'
                jne     dalej_6
                jmp     ULOHA_6                            ; skok na "obratene poradie"

DALEJ_6:                
                cmp     al, 'q'
                jne     PIS_MENU                           ; ak nexem terminate program, tak
                                                           ; opakuj tento rozhodovaci (switch - case) znova
KONIEC:                 
                mov     ax, 4c00h                          ; surove ukoncenie programu s exitcode==0
                int     21h                                ; "good bye blue sky..."

;----------------------------------
CISTI_OUTPUT:           
                mov     ah, 00h                            ; vycisti obrazovku
                mov     al, 02h                            ; a to tak, ze prepne do ineho
                int     10h                                ; textoveho modu
                mov     ah, 0h                             ; a potom zase naspat 
                mov     al, 03h
                int     10h  
                ret      
;-----------------------------------
CAKAJ:                  
                mov     ah, 01h                            ; pocka na stlacenie klavesu
                int     21h  
                ret      
;-----------------------------------
ULOHA_1:                
                mov     dx, offset text4
                mov     ah, 09h
                int     21h  
                mov     dx, offset buff1                   ; klasika, aby to sluzba dosu vypisala
                add     dx, 2                              ; lebo na 0. max. dlzka a v 1. je poc. nacit. zn.
                mov     ah, 09h
                int     21h
                jmp     PIS_MENU

;------------------------------------
ULOHA_2:                
                mov     dx, offset text5                   ; vypise, ze vypise cislo medzery 
                mov     ah, 09h
                int     21h

                mov     cx, 0
                mov     ax, 0                              ; v AX bude poloha vo volnom BCD
                mov     cl, [pocet1]                       ; v CL je pocet precitanych znakov
                mov     si, offset buff1                   ; do SI offsset 1. nacitaneho znaku
                add     si, 1                              ; preto 1. lebo v cykle sa najprv INC az potom porovnava
                mov     bl, ' '

CYKLY_21:               
                inc     ax                                 ; INC AX
                inc     si                                 ; inc SI
                cmp     [si], bl                           ; porovnavaj
                je      POKRACUJ_21                        ; ak som nasiel, potom skac
                AAA                                        ; korekcia AX na volny BCD po scitani
                LOOP    CYKLY_21                           ; cykluj

KONIEC_CYKLU_21:        
                mov     dx, offset text2                   ; => pis o tom litanie (ze som nic nenasiel)
                mov     ah, 09h
                int     21h
                jmp     PIS_MENU                           ; vrat sa spat do menu

POKRACUJ_21:            
                add     al, 48                             ; vyrob z volneho BCD cislo v ASCII
                add     ah, 48                             ;            -- || --
                push    ax
                cmp     ah, 48
                je      POKRACUJ_22
                mov     dl, ah
                mov     ah, 02h
                int     21h
POKRACUJ_22:
                pop     ax
                mov     dl, al
                mov     ah, 02h
                int     21h
                jmp     PIS_MENU                           ; time to return to menu
;----------------------------------
ULOHA_3:                
                mov     dx, offset text3                   ; vypise: zadaj znak
                mov     ah, 09h
                int     21h
                mov     ah, 01h                            ; inputne do AL znak
                int     21h

                mov     cx, 0                              ; do cx dlzku nacitaneho retazca
                mov     cl, [pocet1]
                mov     bx, 0                              ; v BX bude docasne ten vytuzeny pocet vyskytov
                mov     si, offset buff1
                add     si, 2
CYKLY_31:               
                cmp     al, [si]                           ; Je to ten znak?
                jne     SKOK_31                            ; ak nie => skac
                inc     bx                                 ; ak je, potom inkrementuj pocet
SKOK_31:                
                inc     si                                 ; posun ukazovatel
                LOOP    CYKLY_31                           ; cykluj
                mov     cx, bx                             ; konecne!! v CX je pocet hladaneho znaku
                jmp     PIS_MENU

;-----------------------------------
ULOHA_4:                
                mov     dx, offset text6
                mov     ah, 09h
                int     21h
                mov     si, offset buff1                   ; do SI offset na 1. znak
                add     si, 2
                mov     cx, 0h                             ; do CX pocet nacitanych znakov
                mov     cl, [pocet1]
                mov     al, [si]                           ; predoklad, ze hned 1. je najvaetsi
CYKLY_41:               
                cmp     al, [si]                           ; porovnaj ho s dalsim
                jg      POKRACUJ_41                        ; je AL>ako kde ukazuje SI?
                mov     al, [si]                           ; nie je, teda do AL= znak na offsete SI
POKRACUJ_41:            
                inc     si                                 ; inkrementuj SI
                loop    CYKLY_41

                mov     dl, al                             ; a aby sa nepovedalo, tak ho aj vypis
                mov     ah, 02h
                int     21h   
                jmp     PIS_MENU                           ; back to the future ehm.. menu
;-----------------------------------
ULOHA_5:                

                mov     si, offset buff1                   ; do SI offset na 1. znak
                add     si, 1                              ; 2 nie, lebo v cykle 5.1 je 1. inst. INC

                mov     cx, 0
                mov     cl, [pocet1]
                mov     di, offset buff2                   ; do DI offset na buff2, v ktorom bude obrateny ret.

CYKLY_51:               
                inc     si                                 ; SI zvaetsi
                mov     al, [si]  
                cmp     al, ' '                            ; kym je mederz, tak cykly
                jne     CYKLY_52

                LOOP    CYKLY_51
CYKLY_52:            
                mov     dx, offset text7                   ; komentar, co vlastne pride
                mov     ah, 09h
                int     21h
                mov     dx, si                             ; v SI ostal offset na 1. znak <> od medzeri
                mov     ah, 09h                            ; a da sa to krasne pri vypise vyuzit
                int     21h
                jmp     PIS_MENU
;-----------------------------------
ULOHA_6:          
                mov     ax, 0                              ; AX <- pocet nacit. znakov
                mov     al, [pocet1]

                mov     si, offset buff1                   ; do SI offset na koniec zadaneho retazca
                add     si, 1
                add     si, ax

                mov     di, offset buff2                   ; DI <- offset na ret., ktory bude obrateny
                mov     cx, ax                             ; pre cyklus

CYKLY_61:               
                mov     al, [si]                           ; do [di] <- [si]
                mov     [di], al
                dec     si                                 ; SI zniz
                inc     di                                 ; DI zvys
                LOOP    CYKLY_61

                mov     al, '$'                            ; posli na koniec obrateneho retazca terminate sym.
                mov     [di], al 
                mov      dx, offset text8                   ; aby juzer vedel, co to vlastne ten program
                mov     ah, 09h                            ; "vyplul"
                int     21h
                mov     dx, offset buff2                   ; vypis to
                mov     ah, 09h
                int     21h
                jmp     PIS_MENU
;-----------------------------------
                ends     
                end     start