;ZADANIE c.2
;Vytvorte  program,  ktor  nacta  z  textovho sboru postupnost celch csel (aspon 10) so znamienkom
;v desiatkovej cselnej sstave, potom ich transformuje na csla v dvojkovej cselnej sstave v doplnkovom
;kde a potom podla priania pouzvatela:
;a) vypocta sumu  vetkych csel a vypise ju
;b) 	usporiada csla vzostupne resp. zostupne a zape usporiadan postupnost csel do novho textovho sboru,
;c) vydel dve vybran csla a vype vsledok
;d) vynsob dve csla a vype vsledok
;e) ukonc vykonvanie programu.
;
;-----------------------------------------------------------------------------------------------------------
;Autor: Henrich Hajnal
;2.roc., sk.rok.2000/2001
;Termin odovzdania: 24.10.2000
;-----------------------------------------------------------------------------------------------------------
;OBMEDZENIE V PROGRAME
;Vstupny subor musi zacinat cislom. Prvy znak suboru nesmie byt medzera.
;Program nie je osetreny voci deleniu nulou. 
;-----------------------------------------------------------------------------------------------------------
;V programe som pouzil aj instrukciu 286-tky CWD-ktora zanamena znamienkove rozsirenie. 
;Pouzil som ju pri deleni dvoch cisel.
;Program funguje v rozmedzi od -32767 do 32767

;------------------------------PROGRAM---------------------------------------------------------------------

                JUMPS  
                .286     
                data    segment
cis             db      5				;max pocet jednotlivych cifier v jednom cisle
sk              db      ?				;
numero          db      6 dup(?)			;
delenec         dw      ?				
delitel         dw      ?
cinitel1	dw	?
cinitel2	dw	?
ent             db      13, 10, '$'			;odriadkovanie
pole            db      5 dup('0')
sign            db      0				;znamienko
bit             db      0				;
pocet           dw      0				;pocet cisel v premennej num a num1
vys             db      5 dup(0)			;
source          db      'source.txt', 0	
hasource        dw      ?
dest            db      'dest.txt', 0
hadest          dw      ?
num             dw      100 dup(?)			;premenna v ktorej su uchovane cisla
num1            dw      100 dup(?)			;premenna v ktorej su usporiadane cisla
znak            db      ?				;
ng              db      0				;znamienko nacitavaneho cisla zo suboru
exist           db      'Subor source.txt neexistuje'
menu            db      13, 10, 13, 10, 13, 10, '                     M E N U '
                db      13, 10, 'a) Vyratanie suctu vsetkych cisel '
                db      13, 10, 'b) Usporiadanie cisel zaostupne a ulozenie do suboru dest.txt'
                db      13, 10, 'c) Vydelenie dvoch vybranych cisel '
                db      13, 10, 'd) Vynasobenie dvoch vybranych cisel'
                db      13, 10, 'e) Ukoncenie programu ', 13, 10, '$'
press		db	13, 10, 'Press any key to continue$' 
vyp_1           db      13, 10, 'Sucet vsetkych cisel je: $'
vyp_2           db      13, 10, 'Usporiadane cisla sa nachadzju v subore dest.txt $'
vyp_3           db      'Zostupne usporiadane cisla su :  '
vyp_4           db      13, 10, 'Sucin dvoch vybranych cisel je $'
vyp_5           db      13, 10, 'Su zadane tieto cisla : ', 13, 10, '$'
vyp_6           db      13, 10, 'Zadaj poradove cislo delenca $'
vyp_7           db      13, 10, 'Zadaj poradove cislo delitela $'     
vyp_8           db      13, 10, 'Zadaj poradove cislo cinitela1 $'
vyp_9           db      13, 10, 'Zadaj poradove cislo cinitela2 $'     
vyp_10          db      13, 10, 'Vzniklo pretecenie (prilis velke cisla) $'


                data    ends

                prog    segment
                assume  cs:prog, ds:data
start:                  
                mov     ax, seg data
                mov     ds, ax                             ;nastavenie registra ds
                call    init                               ;nacitanie zo suboru source.txt

vyber:          mov	ax,02h
		int	10h
		mov     dx, offset menu
                mov     ah,09h
                int     21h                                ;vypisanie menu

                mov     ah,08h
                int     21h                                ;cakanie na stlacenu klavesu

                cmp     al, 'a'
                jnz     vyb_b
                jmp     vyb_a1    
vyb_b:          cmp     al, 'b'
                jnz     vyb_c
                jmp     vyb_b1
vyb_c:          cmp     al, 'c'
                jnz     vyb_d
                jmp     vyb_c1
vyb_d:          cmp     al, 'd'
                jnz     vyb_e
                jmp     vyb_d1
vyb_e:          cmp     al, 'e'
                jnz     vyber
                jmp     vyb_e1
                                                           ;podla stlacenej klavesy skok
                                                           ;na jednotlive polozky menu

;--------------scitanie vsetkych cisel--------------------------------------------------------------

vyb_a1:         mov     ah,09h
                mov     dx, offset vyp_1
                int     21h                                ;vypis retazca vyp_1

                mov     si, 0
                mov     bx, 0
a1:             mov     cx, [bx+num]                       ;do CX sa ulozi bx/2-te cislo zo suboru

ad:             add     si, cx                             ;ak ma rovnake znamienko ako cisla ktore
                jno     a2                                 ;sme chceli scitovat, tak sa pripocita k
                jmp     chyba                              ;suctu predchadzajucich cisel


a2:             add     bx, 2                              ;zvasci sa index cisla

                cmp     bx, [pocet]                        ;opakuje sa az do vyskusania vsetkych cisel
                jnz     a1
                call    print                              ;vypise pocet cisel
		call    press1
                jmp     vyber                              ;skoci na menu

;-----------------Usporiadanie postupnosti cisel zostupne do suboru---------------------------------

vyb_b1:	        mov     ah, 3ch
                mov     dx, offset dest
                mov     cx, 0
                int     21h                                ;otvorenie suboru dest.txt na zapis
                mov     bx, ax
                mov     ah, 40h
                mov     dx, offset vyp_3
                mov     cx, 32
                int     21h                                ;zapisanie uvodneho retazca do suboru

                mov     [hadest], bx                        ;ulozenie id cisla do premennej hadest

                mov     ah, 9
                mov     dx, offset vyp_2

                mov     ax, ds
                mov     es, ax
                mov     si, offset num
                mov     di, offset num1
                mov     cx, [pocet]
                rep     movsb                              ;prekopirovanie cisel s premennej num do num1

ca:             mov     bx, 0                              ;vynulovanie indexu BX
                xor     dl, dl                             ;vynulovanie bytu vymeny
cd:             add     bx, 2

                mov     ax, [num1+bx]
                cmp     ax, [num1+bx-2]                    ;porovnanie dvoch vedlajsich cisel
                jle     bf
                xchg    ax, [num1+bx-2]
                mov     [num1+bx], ax                      ;ich vymena ak vascie bolo napravo
                mov     dl, 1                              ;nastavenie bytu vymeny

bf:             mov     cx, bx
                add     cx, 2
                cmp     cx, [pocet]
                jnz     cd                                 ;porovnavanie do vyskusanie vsetkych cisel
                mov     bx, 0
                cmp     dl, 0
                jnz     ca                                 ;opakovanie kym byte vymeny=0

                mov     bx, 0
cc:             mov     si, [num1+bx]                      ;vybratie BX/2-teho cisla do reg SI
                push    bx                                 ;ulozenie reg BX do zasobnika
                mov     dl, 0
                call    prevod                             ;jeho prevedenie do 10-kovej sustavy
                call    vypis_sub                          ;jeho zapis do suboru
                mov     ah, 40h
                mov     cx, 1
                mov     bx, [hadest]
                mov     [ng], ' '
                mov     dx, offset ng
                int     21h                                ;zapis medzery do suboru

                pop     bx                                 ;navrat hodnoty reg BX
                add     bx, 2
                cmp     bx, [pocet]
                jnz     cc                                 ;opakovanie vypisu do vypisania vsetkych cisel

                mov     ah, 3eh
                mov     bx, [hadest]
                int     21h                                ;uzavretie suboru dest.txt

		call	press1
                jmp     vyber                              ;skok na menu

;-----------------vydelenie dvoch vybranych cisel-------------------------------------------------------

vyb_c1:         mov     ah,09h
                mov     dx, offset vyp_5
                int     21h                                ;vypis retazca vyp_5

                mov     bx, 2                              ;nastavenie indexu 2*BX-teho cisla

nav1:           mov     cl, 2
                mov     ax, bx
                div     cl                                 ;index cisla je v AL
                xor     ah, ah
                mov     si, ax                             ;index cisla je v SI
                call    print                              ;vypis indexu cisla na obrazovku
                mov     ah, 02h                            ;sluzba
                mov     dl, ')'
                int     21h
                mov     dl, ' '
                int     21h                                ;vypis ') ' za cislom
                mov     si, [num+bx-2]
                call    print                              ;vypis cisla s prisl indexom
                mov     ah, 2
                mov     dl, 9
                int     21h
                int     21h                                ;vypis dvoch tabulatorov
                add     bx, 2
		mov	dx,bx
		sub	dx,2
                cmp     dx, [pocet]
                jnz     nav1                               ;opakovanie vypisu do vypisania vs. cisel

                mov     ah, 9
                mov     dx, offset vyp_6
                int     21h                                ;vypis retazca vyp_6
                call    vstup                              ;zadanie indexu delenca do reg DX


                mov     cl, 2                              ;vynasobim dx 2
                mov     ax, dx
                mul     cl
                mov     bx, ax                             ; bx je offset delenca

                mov     ax, [num+bx-2]                     ;zapis delenca do reg ax
                mov     [delenec], ax                      ;a do premennej delenec
                mov     ah, 09h
                mov     dx, offset vyp_7
                int     21h                                ;vypis retazca vyp_7
                call    vstup                              ;zadanie indexu delitela do reg DX


                mov     cl, 2
                mov     ax, dx
                mul     cl
                mov     bx, ax
                mov     ax, [num+bx-2]                     ;zapis delitela do reg AX
                mov     [delitel], ax                      ;a do premennej delitel

                mov     ah, 09h
                mov     dx, offset ent
                int     21h                                ;odriadkovanie


                mov     si, [delenec]
                call    print   
                mov     ah, 2
                mov     dl, ':'
                int     21h
                mov     si, [delitel]
                call    print
                mov     ah, 2
                mov     dl, '='
                int     21h                                ;vypis v tvare delenec:delitel=

                xor     dx, dx
                mov     ax, [delenec]
                mov     bx, [delitel]                      ;zapis delenca do ax a delitela do bx
                cwd                                        ;znamienkove rozsirenie z ax do dx:ax
                idiv    bx                                 ;vydelenie (dx:ax)/bx
                push    dx                                 ;ulozenie zvysku do zasobnika


                mov     si, ax
                call    print                              ;vypis vysledku

                mov     ah, 9
                mov     dx, offset ent
                int     21h                                ;odriadkovanie
                mov     ah, 2
                mov     dl, ' '
                int     21h                                ;vypis medzery
                pop     si                                 ;vlozenie zvysku do SI
                call    print                              ;vypis zvysku

		call	press1
                jmp     vyber


;-----------------------Vynasobenie vybranych dvoch cisel-----------------------

vyb_d1:         mov     ah,09h
                mov     dx, offset vyp_5
                int     21h                                ;vypis retazca vyp_5

                mov     bx, 2                              ;nastavenie indexu 2*BX-teho cisla

nav2:           mov     cl, 2
                mov     ax, bx
                div     cl                                 ;index cisla je v AL
                xor     ah, ah
                mov     si, ax                             ;index cisla je v SI
                call    print                              ;vypis indexu cisla na obrazovku
                mov     ah, 02h                            ;sluzba
                mov     dl, ')'
                int     21h
                mov     dl, ' '
                int     21h                                ;vypis ') ' za cislom
                mov     si, [num+bx-2]
                call    print                              ;vypis cisla s prisl indexom
                mov     ah,02h
                mov     dl, 9
                int     21h
                int     21h                                ;vypis dvoch tabulatorov
                add     bx, 2
		mov	dx,bx
		sub	dx,2
                cmp     dx,[pocet]
                jnz     nav2                               ;opakovanie vypisu do vypisania vs. cisel

                mov     ah,09h
                mov     dx, offset vyp_8
                int     21h                                ;vypis retazca vyp_8
                call    vstup                              ;zadanie indexu cinitela1 do reg DX


                mov     cl, 2                              ;vynasobim dx 2
                mov     ax, dx
                mul     cl  
                mov     bx, ax                             ;bx je offset cinitela1

                mov     ax, [num+bx-2]                     ;zapis cinitela1 do reg ax
                mov     [cinitel1], ax                     ;a do premennej cinitel1
                mov     ah, 09h
                mov     dx, offset vyp_9
                int     21h                                ;vypis retazca vyp_9
                call    vstup                              ;zadanie indexu cinitel2 do reg DX

                mov     cl, 2
                mov     ax, dx
                mul     cl  
                mov     bx, ax
                mov     ax, [num+bx-2]                     ;zapis cinitela2 do reg AX
                mov     [cinitel2], ax                     ;a do premennej cinitel2

                mov     ah, 09h     
                mov     dx, offset ent
                int     21h                                ;odriadkovanie

                mov     si, [cinitel1]
                call    print       
                mov     ah,02h				   ;tlacenie znaku na obrazovku		
	        mov     dl, '*'     	
                int     21h         
                mov     si, [cinitel2]
                call    print       
                mov     ah,02h       
                mov     dl, '='     
                int     21h                                ;vypis v tvare cinitel1*cinitel2=

                mov     ax, [cinitel1]
                mov     dx, [cinitel2]                     ;zapis cinitela2 do ax a delitela do bx
                mov     cx, 2710h                          ; 10000 dek.
                imul    dx                                 ;vynasobenie ax*dx
                jno     nav3                               ;zistenie pretecenia
                jmp     chyba       
nav3:           idiv    cx                                 ;vydelenie (dx:ax)/10000
                push    dx                                 ;ulozenie dolnej casti cisla do zasobnika
                push    ax          

nav3_1:         mov     si, ax                             ;ulozenie dolnej casti cisla do SI
                mov     ah, 9       
                mov     dx, offset vyp_4
                int     21h                                ;vypis retazca vyp_4

                mov     si, [cinitel1]
                call    print                              ;vypis suc1
                mov     ah,02h       
                mov     dl, '*'     
                int     21h                                ;vypis '*'
                mov     si, [cinitel2]
                call    print                              ;vypis suc2
                mov     ah, 2       
                mov     dl, '='     
                int     21h                                ;vypis '='

                pop     si          
                cmp     si, 0       
                jz      nav5        
                call    print                              ;vypis hornej casti ak nie je nulova
                mov     dl, 1       
                jmp     nav4        
nav5:           mov     dl, 0       
nav4:                   

                pop     si          
                call    print                              ;vypis dolnej casti sucinu

		call	press1
                jmp     vyber                              ;skok na menu

;--------------------------Koniec----------------------------------------------

vyb_e1:         mov     ah, 4ch     
                int     21h                                ;ukoncenie programu

prevod:                                                    ;cislo  na cifry   ;dl=0 zo znamienkom
                                                           ;dl=1 bez znamienka
                                                           ;SI vstup
                cmp     dl, 0       
                jnz     nav6        
                cmp     si, 0       
                jnl     nav6        
                mov     [sign], 1                          ;nastavenie znamienka na -
                neg     si                                 ;negovanie SI
                jmp     nav7         

nav6:           mov     [sign], 0                          ;nastavenie znamienka na +

nav7:           mov     bx, offset pole
	 	mov di,10
		mov ax,si
 		mov cx,5

nav8: 		xor dx,dx
 		div di
 		add dl,30h
 		mov [bx],dl 				   ;uklananie jednotlivych cifier do pola pole
 		inc bx
 		loop nav8 				   ;az do uplneho rozlozenia SI na cislice
 		ret					   ;vystup - pole pole s jednotlivymi cislicami


vypis_tx:  						;vypis pola pole na obrazovku
 		mov [bit],0 				;inicializacia premennej bit ktora sluzi na zamedzenie vypisu zbytocnych nul
 		cmp [sign],1				;zistenie znamienka cisla, ktore chceme vypisat na obrazovku
 		jnz nav9
		mov ah,2				; sluzba na vypis znaku
 		mov dl,'-'
 		int 21h  				;vypisanie znaku '-' ak cislo ktore chceme vypisat bolo zaporne
nav9: 		mov bx,offset pole			;nastavenie registra bx na adresu na ktorej su cislice, ktore chceme vypisat
 		mov di,4
 		mov ah,2
nav11: 		mov dl,[bx+di] 				;nacitanie bx-tej cifry urcenej na vypis

 		cmp dl,'0'				;zistenie ci dany znak bola '0'
 		jnz vyp

 		cmp [bit],0 				;zistenie ci uz boli vypisovane cisla
 		jnz vyp
 		cmp di,0
 		jz vyp
 		jmp vyp1				;zamedzenie vypisu zbytocnych nul na zaciatku cisla
vyp: 		int 21h 				;vypis bx-tej cifry
 		mov [bit],1 				;nastavenie premennej bit, co znamena, ze uz bolo vypisane nejake cislo
vyp1: 		dec di
 		cmp di,-1
 		jnz nav11

 		ret

							; vypise cislo do suboru kt. je v pole
vypis_sub:
 		mov [bit],0				;vynulovanie premennej, ktora sluzi na zamedzenie vypisu zbytocnych nul
 		cmp [sign],1				;zistenie znamienka cisla, ktore sa bude vypisovat
 		jnz nav10
 		mov ah,40h
 		mov bx,[hadest]				;do registra bx ulozime id vystupneho suboru
 		mov cx,1  				;v cx je pocet znakov, ktore chceme zapisat do suboru (v tomto pripade 1)
 		mov [ng],'-'
 		mov dx,offset ng
 		int 21h 				;zapis znamienka minus do suboru ak cislo, ktore chceme vypisovat bolo zaporne

nav10: 		mov bx,offset pole 			;ro registra bx, ulozime offset pola znakov, ktore budeme vypisovat
 		mov di,4				;v DI je maximalny pocet cislic, ktory sa moze vypisovat
nav12:
 		cmp byte ptr [bx+di],'0'		;zistime ci di-ta cifra je '0'
 		jnz vypf

 		cmp [bit],0 				;zistime ci uz nejaka cifra bola vypisana
 		jnz vypf
		cmp di,0
 		jz vypf
 		jmp vyp1f
vypf:   	mov ah,40h
 		mov dx,bx
 		add dx,di
 		xchg bx,[hadest] 			;v registri BX je id vystupneho suboru
 		mov cx,1
 		int 21h					;zapisanie di tej cifry do suboru
 		xchg bx,[hadest]
 		mov [bit],1 				;nastavenie premennej bit, co znamena ze uz nejaka cifra bola zapisana do suboru
vyp1f: 		dec di
 		cmp di,-1
 		jnz nav12 				;opakujem az do vycerpania vsetkych cislic v poli pole
 		ret

init: 		mov     ah,3dh
 		mov     al,0
 		mov     dx,offset source
 		int     21h 				;otvorenie vstupneho suboru source.txt na citanie
 		mov 	[hasource],ax 			;ulozenie id vstupneho suboru do premennej hasource
 		mov     bx,ax
 		jnc     t1   				;v pripade, ze nedoslo ku otvoreniu vstupneho suboru, nasleduje vypis chyby a ukoncenie programu

 		mov     ah,09h
 		mov     dx,offset exist
 		int     21h				;vypis chyby

 		jmp     vyb_e				;skok na ukocenie programu
t1:     	xor     di,di
 		mov     [ng],0 				;nastavenie plusu

t2:     	mov     ah,3fh
 		mov     dx,offset znak
 		mov     cx,1
 		int     21h   				;nacitanie znaku zo suboru

 		cmp     ax,0
 		je      eof				;skoci na eof ak bol dosianuty koniec suboru

 		mov     si,dx
 		mov     al,[si]
 		cmp     al,' '				;porovnanie nacitaneho znaku s medzerou
 		je      next 				;a pripadny skok na zapis dalsieho znaku
 		cmp     al,'-'   			;porovnanie nacitaneho znaku s '-'
 		jne     cislo   			;propadny skok na zapis kladneho cisla
 		mov     [ng],1   			;nastavit premennu ng, co znamena, ze nacitavane cislo je zaporne
 		jmp     t2   				;skok na nacitanie dalsieho cisla

cislo:     						;cislo sa nacitava do registra DI
 		mov     ax,di
		mov     cx,10
 		mul     cx
 		mov     di,ax  				;vynasobenie reg DI desiatkou
 		mov     al,[si]
 		sub     al,30h   
 		xor     ah,ah
 		add     di,ax  				;pripocitanie dalsej cifry po skonverovani zo znaku na cislo
 		jmp     t2   				;skok na nacitanie dalsej cifry

next:   	push    bx
 		mov     bx,offset num
 		mov     si,[pocet] 			;nastavenie adresy [bx+si] na zapis nacitaneho cisla
 		mov     al,[ng]
 		cmp     al,0
 		je      nav13
 		neg     di   				;v pripade zaporneho cisla spravit zaporny jednotkovy komplement
nav13:    	mov     [si+bx],di			;a jeho zapis do [bx+si]

 		mov     si,offset pocet
 		mov     ax,[si]
 		add     ax,2
 		mov     [si],ax
 		pop     bx
 		jmp     t1
eof: 		mov 	ah,3eh
 		mov 	bx,[hasource]
 		int 	21h
 		ret

vstup: 		xor 	dx,dx
 		xor 	bl,bl
tu: 		mov 	ah,08h
 		int 	21h
 		cmp 	al,13				;bol stlaceny enter?
 		jnz 	pokr
 		ret

pokr: 		cmp 	al,8				;bol backspace?
 		jz 	spat
 		cmp 	bl,3			    	;maximalny pocet vstupnych znakov
 		jz 	tu
 		cmp 	al,'0'  			;znak medzi '0' az '9'
 		jl 	tu
 		cmp 	al,'9'
 		jg 	tu
 		push 	dx
 		mov 	ah,02h 				;vypis znaku v dl
 		mov 	dl,al  				;stlaceny znak
 		int 	21h
 		pop 	dx

 		sub 	al,30h  			;hodnota znaku
 		mov 	ch,al
 		mov 	cl,10
 		mov 	ax,dx
 		mul 	cl      			;ax<- al*cl
 		add 	al,ch
 		mov 	dx,ax  				;vysledok do dx
 		inc 	bl
dal: 		jmp 	tu
spat: 		cmp 	bl,0  				;v bl je skutocny pocet znakov    
 		jz 	tu
 		dec 	bl
 		mov 	ax,dx
 		mov 	cl,10  				;vydeli dx 10 t.j. odstrani posledny znak
 		div 	cl
 		mov 	dl,al
 		push 	dx     				;odlozim dx a vymazem poslednu cifru
 		mov 	ah,02h
 		mov 	dl,8   				;backspace
 		int 	21h
 		mov 	dl,' '   
 		int 	21h
 		mov 	dl,8  
 		int 	21h
 		pop 	dx
 		jmp 	tu


print: 		push 	ax
 		push 	bx
 		push 	cx
 		push 	dx
 		push 	si
 		push 	di
 		mov 	dl,0
 		call 	prevod
 		call 	vypis_tx
 		pop 	di
 		pop 	si
 		pop 	dx
 		pop 	cx
 		pop 	bx
 		pop 	ax
 		ret

chyba: 		mov 	ah,09h
 		mov 	dx,offset vyp_10
 		int 	21h

		call 	press1
 		jmp 	vyber

press1:		mov	ah,09h
		mov	dx,offset press
		int	21h
		mov	ah,08h
		int	21h
		ret
prog    ends
end     start