;ZADANIE C.2
;Text zadania : Vytvorte program, ktroy nacita z textoveho suboru postupnost
;		celych cisel (aspon10) so znamienkom v desiatkovej ciselnej sustave,
;		potom ich transformuje na cisla v dvojkovej ciselnej sustave
;		v doplnkovom kode a potom podla priania uzivatela:
;		a) vypocita sumu vsetkych cisel a vypise ju
;		b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;		   do noveho textoveho suboru
;		c) vydeli dve vybrane cisla a vypise vysledok
;		d) vynasobi dve cisla a vypise vysledok
;		e) ukonci vykonavanie programu
;AUTOR: Tomas Holly (tomiBOY the ultrahardcore programming guru)
;Termin odovzdania: 13.11.2000 - 16.11.2000
;2.roc.,sk.rok 2000/2001

ZAS	SEGMENT		STACK		;definujem stack
	DW		64 DUP(?)
ZAS	ENDS
DAT	SEGMENT				;definujem data
MENU	DB		'1) Suma vsetkych cisel ',0Dh,0Ah
	DB		'2) Usporiadanie cisiel a zapis do suboru (vystup.txt)',0Dh,0Ah
	DB		'3) Delenie dvoch cisiel ',0Dh,0Ah
	DB		'4) Nasobenie dvoch cisiel ',0Dh,0Ah
	DB		'5) Koniec ',0Dh,0Ah,'$'
SUMA	DB		'Suma vsetkych cisel je: $'
OW	DB		'Doslo k preteceniu! Nemozno vypocitat sumu cisel.$'
DEL1	DB		'Napis poradove cislo prveho cisla: $'
DEL2	DB		'Napis poradove cislo druheho cisla: $'
ZV	DB		' zvysok $'
FETEXT	STRUC
	DB		30 DUP(?)
FETEXT	ENDS
FE	FETEXT		<'Function number invalid!$'>
	FETEXT		<'File not found!$'>
	FETEXT		<'Path not found!$'>
	FETEXT		<'No handle available!$'>
	FETEXT		<'Access denied!$'>
	FETEXT		<'Invalid handle!$'>
	FETEXT		5 DUP(<>)
	FETEXT		<'Open mode invalid!$'>
NL	DB		0Dh,0Ah,'$'	;novy riadok
FILEIN	DW		?		;handle vstupneho suboru
FILEOUT	DW		?		;handle vystupneho suboru
FILE	DB		'vstup.txt',0
FILE2	DB		'vystup.txt',0
BUFFER	DB		?		;buffer pre pracu so subormi
ZNAM	DB		0H		;ak je cislo zaporne ZNAM=1, inac ZNAM=0
SORT	DW		100 DUP(?)	;sem ukladam usporiadane cisla
EOF	DB		?		;ak je koniec subora,tak EOF=1, inac EOF=0
DAT	ENDS


CODE	SEGMENT
	ASSUME CS:CODE,SS:ZAS,DS:DAT
FILEERROR	PROC			;procedura vypise text chyby ktora sa udiala pri praci so suborom a ktora sa nachadza v registri ax
	push ax				;v ax sa nachadza cislo chyby, ulozime ho na zasobnik
	mov ah,09h
	mov dx,offset NL
	int 21h				;skocim na novy riadok
	pop ax				;vytiahnem zo zasobnika cislo chyby
	mov bl,SIZE FETEXT		;tu adresujem text chyby, dlzka textu chyby->bl
	dec ax				;dekrementujem ax, pretoze indexovanie sa zacina od 0, ale prva chyba je 1
	mul bl				;vynasobim ax*bl,(bl dlzka textu chyby)
	add ax,offset FE		;k ax pripocitam relativnu adresu FE, cize zaciatok textov chyb
	mov dx,ax			;dx<-ax
	mov ah,09h
	int 21h				;vypisem text na obrazovku
	mov ah,4ch
	int 21h				;ukonci program
FILEERROR	ENDP
READWORD	PROC			;nacita cislo z aktualnej adresy v subore, ktoreho handle je v bx 
	mov ZNAM,0
@RW4:	mov ah,3Fh
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	xor cx,cx
	jnc @RW5			;ak nenastala chyba pri citani tak chod na @RW1, inak
	call FILEERROR			;zavolaj proceduru vypisovania chyb
@RW5:	cmp ax,0
	je @ENDRW2
	cmp BUFFER,02Dh			;zisti, ci je BUFFER znamienko
	jne @RW6			;ak nie skoci na @RW6
	mov ZNAM,1			;ak ano ulozi do ZNAM jednotku, cize cislo bude zaporne
@RW6:	cmp BUFFER,30h			;otestuje, ci je BUFFER>=0
	jb @RW4				;ak nie skoci naspat na @RW4
	cmp BUFFER,39h			;ak ano, otestuje, ci je BUFFER<=9
	jg @RW4				;ak nie, tak nacitava zo suboru az ho najde
	xor ax,ax			;ak ano, vynuluje ax, v ax bude to nacitane cislo aj so znamienkom v doplnkovom kode
	push ax				;vlozi ax na zasobnik
@RW1:	
	pop ax				;vytiahne ax zo zasobnika
	mov cx,10
	mul cx				;vynasobi ax*10
	mov cl,BUFFER
	sub cl,30h
	add al,cl			;a prida k al,dalsiu nacitanu cislicu
	jnc @RW2
	inc ah				;ak nastalo pretecenie z al,incrementuje ah
@RW2:
	push ax				;ulozi ax na zasobnik
	mov ah,3Fh
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	jnc @RW3			;ak nenastala chyba pri citani tak chod na @RW1, inak
	call FILEERROR			;zavolaj proceduru vypisovania chyb
@RW3:	xor cx,cx
	cmp ax,0
	je @ENDRW3
	cmp BUFFER,30h			;zisti, ci je BUFFER(nacitana cislica)>=0
	jb @ENDRW1			;ak nie ukonci nacitanie cisla a skoci na @ENDRW1, cislo je uz cele
	cmp BUFFER,39h			;zisti, ci je BUFFER<=9
	jg @ENDRW1			;ak nie ukocni nacitanie cisla a skoci na @ENDRW1
	jmp @RW1			;ak je BUFFER znova cislica, skoci na @RW1, kde ju dalej spracuje
@ENDRW1:
	mov cx,1
@ENDRW3:
	pop ax				;vytiahne zo zasobnika ax,kde sa nachadza nacitane cislo(zatial, len kladne)
	cmp ZNAM,1			;zisti, ci cislo ma byt zaporne
	jne @ENDRW2			;ak nie skoci na @ENRW2(koniec)
	neg ax				;ak ano zneguje ax,(not(ax)+1),z coho vznikne doplnkovy kod zaporneho cisla ax
@ENDRW2:
	ret
READWORD	ENDP
DRAWWORD	PROC			;vypise cislo v doplnkovom tvare na obrazovku(v desiatkovej sustave)
	mov bh,ah			
	and bh,080h			
	cmp bh,080h			;zisti ci je prvy bit(znamienkovy) 1
	jne @DW4			;ak nie skoci na @DW4, cislo je kladne
	push ax				;ak ano cislo je kladne, ulozi cislo v ax na zasobnik
	mov ah,02h
	mov dl,2Dh
	int 21h				;vypise na obrazovku znak '-'
	pop ax				;vytiahne cislo zo zasobnika
	neg ax				;zneguje cislo na kladne cislo
@DW4:	mov cx,9999			;cx<-9999(pretoze max.cislo ma 5 cislic)
@DW2:	inc cx				;cx<-cx+1
	xor dx,dx			;dx<-0
	div cx				;ax<-ax/cx
	push dx				;teraz sa v ax nachadza x-ta cislica a v dx zvysok, dx ulozime na zasobnik
	cmp al,0			;porovname cislicu s 0
	jne @DW3			;ak sa nerovna, skocime na @DW3
	xor dx,dx			;inac vynulujeme dx
	mov ax,cx			;ax<-cx
	mov bx,10			
	div bx				;vydelime ax desiatimi
	mov cx,ax			;cx<-ax (posunieme sa o jednu cisilicu)
	pop ax				;vytiahneme cislicu zo zasobnika
	loop @DW2			;pokial sme neotestovali aj poslednu cislicu(cx=1) tak skoci na @DW2
	push ax				;vlozi ax na zasobnik
@DW3:
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;napise cislicu na obrazovku
	xor dx,dx			;dx<-0
	mov ax,cx		
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahneme cislo zo zasobnika
	dec cx				;cx<-cx-1
@DW1:	inc cx				;cx<-cx+1
	cmp cx,1			;otestujeme, ci uz nie je poslenda cislica(cx=1)
	je @ENDDW			;ak ano skoci na @ENDDW
	cmp cx,0			;otestuje ci este je nejaka cislica
	je @ENDDW2			;ak nie skoci na @ENDDW2
	xor dx,dx			;dx<-0
	div cx				;ax<-ax/cx
	push dx				;vlozi dx na zasobnik
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;vypise cislicu v al na obrazovku
	xor dx,dx			;dx<-0
	mov ax,cx
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahnem cislo zo zasobnika
	loop @DW1			;ak su este nejake cislice skoci na @DW1

@ENDDW:	mov dl,al			
	add dl,30h
	mov ah,02h
	int 21h				;vypise poslednu cislicu
@ENDDW2:
	ret
DRAWWORD	ENDP
WRITEWORD	PROC			;to iste ako DRAWWORD, ibaze nevypise cislo na obrazovku, ale do suboru, ktory ma handle v bx
	mov cx,bx
	mov bh,ah
	and bh,080h
	cmp bh,080h
	jne @WW4
	push ax
	
	push cx
	mov ah,40h
	mov bx,cx
	mov cx,1
	mov BUFFER,2Dh
	mov dx,offset BUFFER
	int 21h
	pop cx
	pop ax
	neg ax
@WW4:	mov bx,cx
	mov cx,9999
@WW2:	inc cx
	xor dx,dx
	div cx
	push dx
	cmp al,0
	jne @WW3
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop @WW2
	push ax
@WW3:
	push cx
	mov ah,40h
	mov cx,1
	add al,30h
	mov BUFFER,al
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	dec cx
@WW1:	inc cx
	cmp cx,1
	je @ENDWW
	cmp cx,0
	je @ENDWW2
	xor dx,dx
	div cx
	push dx
	push cx
	mov ah,40h
	add al,30h
	mov BUFFER,al
	mov cx,1
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop @WW1

@ENDWW:	mov dl,al
	add dl,30h
	push cx
	mov ah,40h
	mov cx,1
	mov BUFFER,dl
	mov dx,offset BUFFER
	int 21h
	pop cx
@ENDWW2:
	ret
WRITEWORD	ENDP

PROC4		PROC		;nacita poradia dvoch cisel a navzajom ich vydeli
@40:	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call READWORD		;nacita cislo zo suboru
	push cx			
	call DRAWWORD		;zapise cislo na obrazovku
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	cmp cx,0		;otestuje ci nie je koniec suboru(ax=0)
	jne @40			;ak nie skoci na @40
	mov ah,09h
	mov dx,offset DEL1
	int 21h			;vypise text 'Napis poradie prveho cisla: '
	xor cx,cx
@42:	mov ah,01h
	int 21h			;nacita cislicu
	cmp al,13

	je @43			;ak bol stlaceny enter ukonci nacitavanie cisla a skoci na @43

	push ax			;magic engine
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax		;prida nacita cislicu do cx

	jmp @42			;skok na @42
@43:
	push cx
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	pop cx
@41:	
	push cx
	call READWORD		;nacita cislo zo vstupne suboru
	pop cx
	loop @41		;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
	push ax
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru
	xor cx,cx
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	mov ah,09h
	mov dx,offset DEL2
	int 21h			;vypise text 'Zadaj poradie druheho cisla: '
@45:	mov ah,01h		
	int 21h			
	cmp al,13		
	je @44			

	push ax			;magic engine
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax
	jmp @45
@44:	
	push cx
	call READWORD
	pop cx
	loop @44
	push ax
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	mov ah,09h
	mov dx,offset NL
	int 21h			;potialto vsetko rovnake ako pri nacitani prveho cisla
	pop bx
	pop ax
	push ax
	push bx
	push bx			;povytahujem tie 2 cisla zo zasobnika
	call DRAWWORD		;vypise 1. cislo
	mov ah,02h
	mov dl,2Fh
	int 21h			;vypise '/'
	pop ax
	call DRAWWORD		;vypise 2.cislo
	mov ah,02h
	mov dl,0CDh
	int 21h			;vypise '='
	pop bx
	pop ax
	xor dx,dx
	idiv bx			;vydeli 1.cislo 2., v ax bude celociselny vysledok a v dx bude zvysok
	push dx			
	call DRAWWORD		;vypise vysledok
	mov ah,09h
	mov dx,offset ZV
	int 21h			;vypise text 'zvysok'
	pop dx
	mov ax,dx
	call DRAWWORD		;a nakoniec vypise zvysok
	ret
PROC4		ENDP

PROC3		PROC		;nacita poradia dvoch cisel a navzajom ich vynasobi
@30:	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call READWORD		;nacita cislo zo suboru
	push cx			
	call DRAWWORD		;zapise cislo na obrazovku
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	cmp cx,0		;otestuje ci nie je koniec suboru(ax=0)
	jne @30			;ak nie skoci na @30
	mov ah,09h
	mov dx,offset DEL1
	int 21h			;vypise text 'Napis poradie prveho cisla: '
	xor cx,cx
@32:	mov ah,01h
	int 21h			;nacita cislicu
	cmp al,13
	je @33			;ak bol stlaceny enter ukonci nacitavanie cisla a skoci na @33

	push ax			;magic engine
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax		;prida nacita cislicu do ax
	jmp @32			;skok na @32
@33:
	push cx
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	pop cx
@31:	
	push cx
	call READWORD		;nacita cislo zo vstupneho suboru
	pop cx
	loop @31		;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
	push ax
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru
	xor cx,cx
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	mov ah,09h
	mov dx,offset DEL2
	int 21h			;vypise text 'Zadaj poradie druheho cisla: '
@35:	mov ah,01h		
	int 21h			
	cmp al,13		
	je @34			

	push ax			;magic engine (tm) by tomiBOY the ultrahardcore programm guru
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax
	jmp @35
@34:	
	push cx
	call READWORD
	pop cx
	loop @34
	push ax
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	mov ah,09h
	mov dx,offset NL
	int 21h			;potialto vsetko rovnake ako pri nacitani prveho cisla
	pop bx
	pop ax
	push ax
	push bx
	push bx			;povytahujem tie 2 cisla zo zasobnika
	call DRAWWORD		;vypise 1. cislo
	mov ah,02h
	mov dl,2Ah
	int 21h			;vypise '*'
	pop ax
	call DRAWWORD		;vypise 2.cislo
	mov ah,02h
	mov dl,0CDh
	int 21h			;vypise '='
	pop bx
	pop ax
	xor dx,dx
	imul bx			;vynasobi 1.cislo 2., v ax bude celociselny vysledok 
	call DRAWWORD		;vypise vysledok
	mov ah,09h
	ret
PROC3		ENDP

PROC1		PROC
	xor bx,bx		;vynuluje bx, tu bude celkova suma
@11:	push bx
	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call READWORD		;nacita cislo
	pop bx
	add bx,ax		;pripocitam cislo k bx
	jo @13			;ak nastalo pretecenie ukonci scitavanie a skoci na @13
	push bx
	push cx
	call DRAWWORD		;vypise nacitane cislo
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	pop bx
	cmp cx,0		;zisti ci je koniec suboru(cx=0)
	je @12			;ak ano skoci na @12
	jmp @11			;inac pokracuje na @11

@12:
	push bx
	mov ah,09h
	mov dx,offset SUMA
	int 21h			;vypise retazec 'Vypocitana suma: '
	pop ax
	call DRAWWORD		;vypise sumu cisel
	jmp @14
@13:	mov ah,09h
	mov dx,offset OW
	int 21h			;vypise chybu pretecenia
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
@14:	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	ret			;ukonci proceduru
PROC1		ENDP
PROC2		PROC
	mov ah,3ch
	mov al,0		;specifukuje subor ako normal
	mov dx,offset FILE2
	int 21h			;vytvori novy subor s menom 'vystup.txt',ax je handle na tento subor(FILEOUT)			
	jnc @21			;zisti ci nenastala chyba pri spracovani subora
	call FILEERROR		;ak ano vyvola proceduru FILEERROR
@21:	mov FILEOUT,ax		;ulozi handle vystupneho subora do FIELOUT
	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call READWORD		;nacita cislo do vstupneho suboru
	mov cx,0
	mov si,0
	mov SORT[si],ax		;ulozi ho do pola SORT na prve miesto
@22:	inc cx			;inkrementuje cx, v cx je pocet cisel v poli SORT
	mov bx,FILEIN
	push cx
	call READWORD		;nacita cislo zo vstupneho suboru
	mov EOF,cl		
	pop cx
	push cx
	inc cx
	mov si,0
	mov di,0
@24:	cmp ax,SORT[si]		;prejde vsetkymi cislami v SORT, ci je nacitane cislo mensie ako co najmensie cislo v SORT
	jle @25			;ak ano skoci na @25
	jmp @26
@25:
	mov di,1
	mov bx,SORT[si]
	mov SORT[si],ax
	mov ax,bx
	add si,2
	loop @25		;vlozi cislo pred cislo v SORT[si], ktore je najmensie cislo, ktore je vacsie ako dane cislo
	inc cx			;inkrementuje cx
@26:
	add si,2
	loop @24
	sub si,2
	cmp di,1
	je @27
	mov SORT[si],ax		;ak je cislo vacsie ako vsetky cisla v SORT, ulozi ho na koniec
@27:
	pop cx
	cmp EOF,0		;zisti ci nebol koniec suboru
	je @23			;ak ano skoci na @23
	jmp @22			;inac na @22 
@23:	
	mov si,0
	inc cx
@28:	mov bx,FILEOUT
	mov ax,SORT[si]
	push cx
	mov bx,FILEOUT
	call WRITEWORD
	pop cx
	push cx
	cmp cx,1
	je @29			;zapise cislo v poli SORT do vystupneho suboru
	mov ah,40h
	mov cx,1
	mov BUFFER,09h
	mov dx,offset BUFFER
	int 21h			;zapise tabulator do suboru(oddelenie cisel)
@29:	pop cx
	add si,2
	loop @28		;zapise vsetky cisla v SORT
	mov ah,3Eh
	mov bx,FILEOUT
	int 21h			;uzavre vystupny subor
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru 
	
	mov cx,12
	mov si,0
@POKUS:	mov ax,SORT[si]
	push cx
	call DRAWWORD
	mov ah,09h
	mov dx,offset NL
	int 21h			;skocim na novy riadok
	pop cx
	add si,2
	loop @POKUS		;vypise vsetky cisla v poli SORT na obrazovku
	ret
PROC2		ENDP

START:	mov ax,seg DAT
	mov ds,ax			;inicializacia datoveho segmentu DS
	mov ah,3dh
	mov al,0			;specifukuje subor ako read-only
	mov dx,offset FILE
	int 21h				;otvori subor s nazvom 'vstup.txt',ax je handle na tento subor			
	jnc @SUBOK			;zisti ci nenastala chyba pri otvarani subora
	call FILEERROR			;ak ano zavola proceduru FILEERROR
@SUBOK:
	mov FILEIN,ax			;ak nie vlozi do FILEIN handle vstupneho subora
@MENU:
	mov ah,09h
	mov dx,offset NL
	int 21h	
	mov ah,09h
	mov dx,offset MENU
	int 21h				;vypise menu
	mov ah,01h
	int 21h				;nacita klavesu
	push ax
	mov ah,09h
	mov dx,offset NL
	int 21h				;skocim na novy riadok
	pop ax
	cmp al,31h
	je @1				;ak je klavesa '1' skoci na @1
	cmp al,32h
	je @2				;ak je klavesa '2' skoci na @2
	cmp al,33h
	je @3				;ak je klavesa '3' skoci na @3
	cmp al,34h			
	je @4				;ak je klavesa '4' skoci na @4
	cmp al,35h			
	jne @MENU			;ak klavesa nie je '5' skoci nazad do @MENU
	mov ah,3Eh			
	mov bx,FILEIN			;inac
	int 21h				;uzavre vstupny subor
	mov ah,4ch
	int 21h				;a ukonci program
@1:	
	call PROC1
	jmp @MENU
@2:
	call PROC2
	jmp @MENU
@3:
	call PROC4
	jmp @MENU
@4:
	call PROC3
	jmp @MENU
CODE 	ENDS
	END START