;Zadanie c.1.
;Uloha: Napiste program, ktory nacita z klavesnice retazec znakov
;        (max.100 znakov) a podla  menu vykona  jednu z moznosti:
;       1) vypise retazec znakov na obrazovku
;       2) vypise poradove cislo miesta, kde sa nachadza prvy krat znak nacitany
;          z klavesnice,ak ho nenajde vypise o tom spravu.
;       3) vypise retazec v obratenom porad,
;       4) vypise pocet cislic v retazci
;       5) male pismena konvertuje na velke
;       6) velke pismena konvertuje na male
;       7) ukonci vykonavanie programu.
;       Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;
;
;DEADLINE: 26.10.2000
;Autor: Tomas Holly
;rocnik: 2.
;sk.rok 2000/2001
;
title Retazec
data     segment

;Koniec   equ     '$'                                 ;koniec vypisovania na obrazovku


Menu     db      'Vyber:',0dh,0ah
         db      '1 - Vypis retazca na obrazovku',0dh,0ah
         db      '2 - Zistenie poradovne cisla zadaneho znaku v retazci',0dh,0ah
         db      '3 - Vypis retazca v obratenom poradi',0dh,0ah
         db      '4 - Zistenie poctu cislic v retazci',0dh,0ah
         db      '5 - Konverzia malych pismen na velke',0dh,0ah
         db      '6 - Konverzia velkych pisme na male',0dh,0ah
         db      '7 - Koniec',0dh,0ah,'$'

Retazec  db      101                                 ;maximalny pocet znakov 
pocet    db      ?                                   ;pocet nacitanych znakov
R        db      103 dup (?)                         ;dane znaky (3 znaky na novy riadok a '$')
Rvelke   db      103 dup (?)                         ;pom pole znakov pouzivane pri bode 'E'
Rmale    db      103 dup (?)                         ;pom pole znakov pouzivane pri bode 'F'
NR       db      0dh,0ah                             ;novy riadok
Koniec   db      '$'                                 ;koniec vypisovania na obrazovku
Cisla    db      '0123456789'			     ;pouzivane cislice
Buffer   db      3 dup (?),0dh,0ah,'$'                 ;pre vypis cisiel
Obrat    db      0dh,0ah,'Obrateny retazec je:$'
Vypis    db      0dh,0ah,'Zadany retazec je:$'
Cisl     db      0dh,0ah,'Pocet cislic v retazci je:$'
PorCis   db      0dh,0ah,'Znak sa nachadza na mieste cislo:$'
Upper    db      0dh,0ah,'Konvertovany retazec ma tvar:$'
Vyzva    db      'Zadaj uvazovany retazec (maximalne 100 znakov, minimalne 1 znak)',0dh,0ah,'$'
Znak     db      0dh,0ah,'Zadaj hladany znak',0dh,0ah,'$'
Chyba    db      0dh,0ah,'V retazci sa dany znak nenachadza',0dh,0ah,'$'
Chyba2   db      0dh,0ah,'Co keby si zadal ciclo od 1 do 7?',0dh,0ah,'$'

data     ends

code     segment
start:   assume      ds:data,cs:code,es:data
         mov         ax,seg data        ;inicializacia DS registra
         mov         ds,ax
         mov         es,ax

         mov         dx,offset Vyzva    ;vypise 'Zadaj retazec ...'
         mov         ah,09h
         int         21h

         mov         dx,offset Retazec  ;nacita dany retazec (max 100 znakov) a
         mov         ah,0Ah             ;do druheho bytu vrati pocet nacitanych
         int         21h                ;znakov

         mov         dx,offset NR       ;prida novy riadok
         mov         ah,09h
         int         21h

@menu:   mov         dx,offset Menu     ;vypise menu na obrazovku
         mov         ah,09h
         int         21h

qq:      mov         ah,01h             ;nacita znak do registra al
         int         21h

         cmp         al,'1'             ;Zisti, ci nacitany znak v registri al je 'A' alebo 'a'.
         jz          @vypis
	 jnz	     @1

@vypis:  xor         cx,cx              ;prida do retazca 0dh,0ah,'$'
         mov         cl,pocet
         mov         si,cx
         mov         [R+si],10
         inc         si
         mov         [R+si],13
         inc         si
         mov         dl,koniec
         mov         [R+si],dl

         mov         dx,offset Vypis    ;vypise 'Dany retazec je'
         mov         ah,09h
         int         21h

         mov         dx,offset R        ;vypise dany retazec
         mov         ah,09h
         int         21h
         jmp         @menu              ;vrati sa do menu

@1:      cmp         al,'2'             ;Zisti, ci nacitany znak v registri al je 'B' alebo 'b'
         jz          @znak
	 jnz	     @2

@znak:   mov         dx,offset Znak     ;vypise zadaj znak
         mov         ah,09h
         int         21h
         mov         ah,01h             ;nacita znak do reg al
         int         21h

         xor         si,si              ;zisti poradove cislo daneho znaku
         dec         si
         xor         cx,cx
         mov         cl,pocet

@slucka: inc         si             ;cyklus pre prehladavanie retazca
         cmp         [R+si],al
         jnz         @loop
         jmp         @skok
@loop:   loop        @slucka

         jmp         @Chyba

@skok:   mov         ax,si          ;ak sa znak nachadza vypise poradove cislo
         inc         ax
         mov         si,3
@slucka2:dec         si             ;prevod poradoveho cisla z reg ax do bufferu
         mov         bx,10
         xor         dx,dx
         div         bx
         mov         di,dx
	 add 	     dl,30h
;         mov         dl,[cisla+di]
         mov         [buffer+si],dl
         and         ax,ax
         jnz         @slucka2

         mov         dx,offset PorCis;samotny vypis poradoveho cisla
         mov         ah,09h
         int         21h

         mov         dx,offset buffer
         mov         ah,09h
         int         21h

         jmp         @menu           ;navrat do menu

@Chyba:  mov         dx,offset Chyba
         mov         ah,09h
         int         21h
         jmp         @menu           ;navrat do menu

@2:      cmp         al,'3'             ;Zisti, ci nacitany znak v registri al je 'C' alebo 'c'
         jz          @obrat
	 jnz	     @3

@obrat:  mov         dx,offset Obrat ;vypise 'Obrateny retazec je:'
         mov         ah,09h
         int         21h
         xor         cx,cx           ;vypise obrateny retazec
         mov         cl,pocet

@slucka3:dec         cl              ;kvoli indexovaniu v poli
         mov         si,cx
         mov         dl,[R+si]
         mov         ah,02h
         int         21h
         cmp         cx,0
         jnz         @slucka3
         mov         dx,offset NR       ;prida novy riadok
         mov         ah,09h
         int         21h
         jmp         @menu

@3:      cmp         al,'4'             ;Zisti, ci nacitany znak v registri al je 'D' alebo 'd'
         jz          @cisla
	 jnz	     @4

@cisla:  xor         cx,cx             ;zisti pocet cislic v retazci
         mov         cl,pocet          ;nastavanie parametrov pre slucku
         xor         si,si
         dec         si
         xor         bx,bx
@slucka4:inc         si                ;samotna slucka ktora to zistuje
         cmp         [R+si],30h
         jb          @loop2
         cmp         [R+si],39h
         ja          @loop2
         inc         bx                ;pocet cislic ide do registra bx
@loop2:  loop        @slucka4
         mov         dx,offset Cisl    ;vypise 'Pocet cislic v retazci je:'
         mov         ah,09h
         int         21h

         mov         ax,bx
         mov         si,3
@slucka6:dec         si             ;prevod cisla z reg ax do bufferu
         mov         bx,10
         xor         dx,dx
         div         bx
         mov         di,dx
	 add	     dl,30h
;         mov         dl,[cisla+di]
         mov         [buffer+si],dl
         and         ax,ax
         jnz         @slucka6

         mov         dx,offset Buffer   ;vypise pocet cisiel v retazci
         mov         ah,09h
         int         21h

         jmp         @menu              ;spat do menu

@4:      cmp         al,'5'             ;Zisti, ci nacitany znak v registri al je 'E' alebo 'e'
         jz          @upper
	 jnz	     @5

@upper:  xor         cx,cx           ;zmeni male pismena na velke a vypise
         mov         cl,pocet
         mov         si,offset R
         mov         di,offset Rvelke
         repz movsb                  ;kopiruje povodny retazec do Rvelke

         xor         cx,cx           ;nastavovanie reg pre slucku
         mov         cl,pocet
         xor         si,si
         dec         si
@slucka5:inc         si              ;zmena malych pismen na velke
         cmp         [Rvelke+si],61h
         jb          @skok4
         cmp         [Rvelke+si],7Ah
         ja          @skok4
         sub         [Rvelke+si],32
@skok4:  loop        @slucka5
         inc         si              ;pridanie '$' na koniec retazca
         mov         dl,koniec
         mov         [Rvelke+si],dl

         mov         dx,offset Upper ;vypise 'Novy retazec je :'
         mov         ah,09h
         int         21h
         mov         dx,offset Rvelke  ;vypise novy retazec
         mov         ah,09h
         int         21h
         mov         dx,offset NR    ;novy riadok
         mov         ah,09h
         int         21h

         jmp         @menu           ;vrati sa do menu

@5:      cmp         al,'6'             ;Zisti, ci nacitany znak v registri al je 'F' alebo 'f'
         jz          @lower
  	 jnz	     @6

@lower:  xor         cx,cx           ;zmeni velke pismena na male a vypise
         mov         cl,pocet
         mov         si,offset R
         mov         di,offset Rmale
         repz movsb                  ;kopiruje povodny retazec do Rmale

         xor         cx,cx           ;nastavovanie reg pre slucku
         mov         cl,pocet
         xor         si,si
         dec         si
@slucka7:inc         si              ;zmena velkych pismen na male
         cmp         [Rmale+si],41h
         jb          @skok5
         cmp         [Rmale+si],5Ah
         ja          @skok5
         add         [Rmale+si],32
@skok5:  loop        @slucka7
         inc         si              ;pridanie '$' na koniec retazca
         mov         dl,koniec
         mov         [Rmale+si],dl

         mov         dx,offset Upper ;vypise 'Novy retazec je :'
         mov         ah,09h
         int         21h
         mov         dx,offset Rmale  ;vypise novy retazec
         mov         ah,09h
         int         21h
         mov         dx,offset NR    ;novy riadok
         mov         ah,09h
         int         21h

         jmp         @menu           ;vrati sa do menu

@6:      cmp         al,'7'             ;Zisti, ci nacitany znak v registri al je 'Q' alebo 'q'
         jz          @koniec
	 mov         dx,offset Chyba2
         mov         ah,09h
         int         21h
         jmp         qq              ;skok na qq (zase vsetko od znova)

@koniec: mov         ax,4c00h        ;ukoncenie programu
         int         21h             

code     ends
         end         start

; zaver
; Program je funguje na 100% (Pri dodrzani 100 znakoveho retazca...). 
; Bol napisany pod operacnym systemom Microsoft Windows 98 v Notepad-e
; Program vyuziva funkcie BIOS-u a to 01h-nacitanie znaku z klavesnice,
;                                     09h-vypis na obrazovku a
;                                     0Ah-nacitanie znakov z klavesnice
