;
;ZADANIE c.2
;Vytvorte  program,ktory nacita z textoveho suboru postupnost celych
;cisel (aspon 10) so znamienkom  v desiatkovej ciselnej sustave,
;potom ich transformuje na cisla v dvojkovej ciselnej sustave
;v doplnkovom kode a potom podla priania pouzivatela:
;a) vypocita sumu  vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;   do noveho textoveho suboru,
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.
;
;Autor: Stefan Jancar
;Kruzok: INFA/11
;Datum odovzdania:16.11.2000
;
;
;
;
zas segment stack               ;Zasobnikovy segment
        dw 64 dup (?)    
zas ends

DATA SEGMENT                   ;Datovy segment
;menu programu
MENU DB        'a) Vypise sucet cisel',13,10    
     DB        'b) Vzostupne vypise cisla',13,10    
     DB        'c) Vynasobi 2 cisla',13,10
     DB        'd) Vydeli 2 cisla',13,10    
     DB        'e) Koniec',13,10
     DB  13,10,'Vyberte si!','$'
SPRAVA1 DB      13,10,10,'SUMA=  $'                             ;Texty na vypis
SPRAVA2 DB      13,10,10,'CISLA= ',13,10,10,'$'
SPRAVA3 DB      13,10,10,'VZOSTUPNE= ',13,10,10,'$'
SPRAVA5 DB      13,10,10,'CISLA SU= ',13,10,10,'$'
SPRAVA6 DB      13,10,10,'PORADIE CISLA= $'
SPRAVA7 DB      13,10,10,'SUCIN JE=  $'
SPRAVA8 DB      13,10,10,'VYSLEDOK JE= $'
SPRAVA9 DB      13,10,10,'ZOSTATOK JE= $'
CHYBA	DB	13,10,10,10,'PRILIS VELKE! $'
PRIZ   DB    0                
PRIZ2  DB    0
PRIZ3  DB    0
PRIZ5  DB    0
POC2    DB    0
POC1    DW    0                ;pointer na cislo
POC     DB    0                ;pocet cisel
ZNAM    DB    0
POM     DW    0
POM1    DB    6 dup (0)        ;pomocny buf
	  DB	0
FIN       DB    'cisla.txt',0     ;subory
FOUT1  DB    'out1.txt',0
FOUT2  DB    'out2.txt',0
CISLO     DW	255 dup (?)
FILE     DB    701 dup (?)      ;buffer
DATA ENDS                          ;koniec datoveho segmentu


CODE SEGMENT                       ;kodovy segment
     ASSUME  CS:CODE,DS:DATA,ES:DATA,SS:ZAS       ;priradeny segm.reg.

;
;PROCEDURA NA VYPIS CISEL NA OBRAZOVKU
;

VSETKY	   PROC NEAR                
           MOV WORD PTR [POM],BX     ;Uschovaj POM
           MOV CL,BYTE PTR [POC]     ;Nacitanie pocet cisel
           XOR CH,CH                   ;vynuluj ch
	   MOV SI,OFFSET CISLO         ;do si daj adresu cisla
VSETKY2:   MOV AX,WORD PTR [SI]        ;nacita prve cislo
	   PUSH CX                     ;uloz CX do zasobnika
	   PUSH SI                     ;uloz SI do zasobnika
	   CALL OBRAZOVKA              ;zavola proceduru OBRAZOVKA 
           MOV DL,' '                  ;vypis medzeri medzi cisla
           MOV AH,2                    ;vypis na obrazovku
           INT 21H                     ;vykonaj
	   CALL VYPIS                  ;zavolaj proceduru VYPIS
	   POP SI                      ;vrat si zo zasobnika
 	   POP CX                      ;vrat CX zo zasobnika
	   ADD SI,2                    ;k SI pripocita 2
	   LOOP VSETKY2                ;cyklus kym nevypise vsetky
	   RET                         ;koniec
VSETKY     ENDP                        ;procedury

;
;ZAPIS ZNAKU DO SUBORU
;

VYPIS      PROC NEAR
           PUSH AX                  ;uloz AX,BX,CX,DX do zasobnika
           PUSH BX
           PUSH CX
           PUSH DX
           CMP BYTE PTR [PRIZ5],1  ;Je priznak5 nastaveny na 1
	   JE VYPIS1                  ;Ak sa rovna =1 chod na vypis1
	   JMP VYPIS2	              ;Ak nie chod na vypis2
VYPIS1:    MOV BX,WORD PTR [POM]    ;nacitaj pomoc
           MOV BYTE PTR [FILE],dl    ;Nabis dl do bufra
           MOV DX,OFFSET FILE         ;daj do dx offset SUBOR  
           MOV AH,40H                 ;sluzba na zapis do suboru
           MOV CX,1                   ;pocet zapisanych znakov
	   INT 21H                    ;vykonaj
VYPIS2:    POP DX                     ;vrat DX,CX,BX,AX zo zasobnika
	   POP CX
	   POP BX
	   POP AX
	   RET                        ;koniec
VYPIS      ENDP	                      ;procedury

;
;KONVERTOR DECIMALNYCH CISIEL NA BINARNYCH
;

KONV       PROC NEAR
           MOV DI,OFFSET POM1   ;do DI daj adresu POM1
	   MOV AL,0               ;do AL daj 0
	   MOV CX,6               ;do CX daj 6
	   REPNZ SCASB            ;opakovat kym nie je zhoda, teda 0 v POMOC1
	   DEC DI                 ;dekrementuj DI 2-krat
           DEC DI
	   XOR CX,CX              ;vynuluj CX
	   MOV BX,1               ;do BX daj 1
KONV1:	   XOR AH,AH              ;vynuluj AH
	   MOV AL,BYTE PTR ES:[DI];do AL daj hodnotu DI
	   CMP AL,0               ;Ak Al=0
	   JE KONV3               ;tak skok na konv3
	   SUB AL,30H             ;ak nie odcitaj 30h od al
           MUL BX                 ;vynasob bx
           ADD CX,AX              ;k cx pripocitaj ax
	   JC KONV2               ;ak CF=1 skok na konv2
 	   CMP CX,32767           ;Je cx vacsie nez 32767
	   JA KONV3               ;ak cx>32767 skok na konv3
	   DEC DI                 ;ak nie inkrementuj di
	   MOV AX,10              ;do ax daj 10
	   MUL BX                 ;vynasob bx s ax
	   MOV BX,AX              ;do bx daj ax
	   JMP KONV1              ;skok na konv1
KONV2:     MOV BYTE PTR ES:[ZNAM],0       ;vynulovanie znamienka
           RET                            ;vrat sa z proc
KONV3:     CMP BYTE PTR ES:[ZNAM],'-'      ;Ak nie je -
	   JNE KONV4                       ;tak skok na konv4
	   NEG CX                          ;neguj CX
KONV4:     MOV DI,WORD PTR ES:[POC1]     ;nastav ukazovatel na dalsie cislo
	   MOV WORD PTR ES:[DI],CX         ;daj tam cx
           ADD WORD PTR ES:[POC1],2      ;zvacsi o 2
           INC BYTE PTR ES:[POC]         ;ikrementuj pocet 
	   RET                             ;koniec                        
KONV       ENDP                            ;procedury

;
;PROCEDURA NA CAKANIE
;
PAUSE      PROC NEAR
           XOR AX,AX                       ;vynulujem register ax
           INT 16H                         ;zavolam sluzsby pre klavesnicu
           RET                             ;koniec
PAUSE      ENDP                            ;procedury


;
;Procedura na vypisanie cisla
;

OBRAZOVKA  PROC NEAR
	   CMP AX,8000H  ;je ax =32768
	   JB OBR1       ;ak ax<32768 skok na obr1
 	   PUSH AX       ;ak nie daj ax do zasobnika
	   MOV DL,'-'    ;do dl daj -
           MOV AH,2      ;napis na obrazovku
           INT 21H
	   CALL VYPIS    ;zavolaj proceduru vypis
	   POP AX        ;obnov ax zo zasobnika
	   NEG AX        ;logicky neguj ax
OBR1:	   MOV BX,10000              ;do bx daj 
           MOV BYTE PTR [PRIZ2],0    ;nastav priz2 na 0
OBR2:      XOR DX,DX                 ;vynuluj DX
	   DIV BX                    ;vydel AX s BX  AL=podiel,AH=zostatok
           MOV CX,DX                 ;daj dx do CX - uloz zostatok do ch
	   CMP AL,0                  ;ak je 0 skok 
	   JE OBR3                   ;na obr3
           MOV BYTE PTR [PRIZ2],1    ;ak nie nastav priznak2 na 1
OBR3:      CMP BYTE PTR [PRIZ2],0    ; ak priznak2=0
	   JE OBR4                   ;skok na obr4
	   MOV AH,2                  ;
	   ADD AL,30H		     ;pripocitaj k al 30h - konv do ASCII -
	   MOV DL,AL	             ;do dl daj al
	   INT 21H	             ;vypis na obr
	   CALL VYPIS                ;zavolaj proceduru VYPIS
OBR4:	   MOV AX,CX                 ;do ax daj cx
	   PUSH AX                   ;ax daj do zasobnika
	   MOV AX,BX                 ;do ax daj bx
	   XOR DX,DX                 ;vynuluj dx
	   MOV BX,10                 ;do bl daj 10
	   DIV BX                    ;vydel BX s BL
	   MOV BX,AX                 ;uloz al do bl
 	   POP AX	             ;obnov ax zo zas
	   CMP BX,0                  ;ak bx=0 skok na
	   JE OBR5	             ;obr5
	   JMP OBR2	             ;inak skok na obr2
OBR5:      CMP BYTE PTR [PRIZ2],0    ;ak priznak2 nie je nula
	   JNE OBR6                  ;skok na obr6
           MOV AH,2                  ;inak
           MOV DL,30H                ;do dl daj 30h
           INT 21H                   ;vypis na obr
OBR6:	   RET                       ;vrat sa z proc
OBRAZOVKA  ENDP                      ;koniec proc

;
;Triedenie cisiel
;

SORT	   PROC NEAR                
           MOV AL,BYTE PTR [POC]   ;nacitaj pocet cisel do al
	   DEC AL                    ;dekrementuj al 
           MOV BYTE PTR [POC2],AL  ;do poce2 daj al
	   XOR AH,AH                 ;vynuluj ah
SORT3:	   MOV SI,OFFSET CISLO       ;do Si nacitaj adresu cisel
           MOV CL,BYTE PTR [POC2]  ;do cl daj adresu pocet2
	   XOR CH,CH                 ;vynuluj ch
           MOV BYTE PTR [PRIZ3],0 ;do priznak3 daj 0
SORT4:	   MOV AX,WORD PTR [si]      ;do ax daj si
	   MOV BX,WORD PTR [si+2]    ;do bx daj si+2
	   CMP AX,8000h              ;ak je 32768
	   JAE SORT9                 ;ak ax >= skok na sort9
	   CMP BX,8000h              ;ak bx >=
	   JAE SORT10                ;skok na sort10
SORT5:	   CMP BX,AX                 ;ak bx<ax                
	   JB SORT8                  ;skok na sort8
SORT6:	   ADD SI,2                  ;pripocitaj k si 2
	   LOOP SORT4                ;cyklus kym nenacita vsetky
           CMP BYTE PTR [PRIZ3],0 ;ak priznak3 = 0
	   JE SORT7                  ;skok na sort7
           DEC BYTE PTR [POC2]     ;ak nie dekrementuj pocet2
           CMP BYTE PTR [POC2],0   ;ak pocet2 =0
	   JE SORT7                  ;skok na sort7
	   JMP SORT3                 ;ak nie skok na sort3
SORT7:	   RET                       ;vrat sa z proc
SORT8:     MOV WORD PTR [SI],BX      ;do adresy Si daj BX
	   MOV WORD PTR [SI+2],AX    ;do adresy SI+2 daj AX
           MOV BYTE PTR [PRIZ3],1 ;nastav Priznak3=1
	   JMP SORT6                 ;skok na sort6
SORT9:	   CMP BX,8000H              ;ak bx>=32768
	   JAE SORT5                 ;skok na sort5
	   JMP SORT6                 ;inac na sort6
SORT10:    CMP AX,8000h              ;ak ax>=32768
	   JAE SORT5                 ;skok na sort5
	   JMP SORT8                 ;skok na sort8
SORT       ENDP                      ;koniec procedury

;
;OTVORI SUBOR NA CITANIE
;

OTVOR      PROC NEAR
	   MOV AH,3DH                ;funkcia na otvorenie suboru
           MOV DX,OFFSET FIN         ;otvor subor FIN
	   INT 21H                   
	   JNC OTV1                  ;ak CF=0 skok na otv1
	   MOV AH,3CH                ;vytvori
	   MOV CX,0                  ;do cx daj 0
	   INT 21H
OTV1:      RET                       ;vrat sa z proc
OTVOR	   ENDP                      ;koniec proc

;
;OTVORI SUBOR NA PISANIE
;

OTVOROUT1  PROC NEAR
	   MOV AH,3DH              ;funkcia na otvorenie suboru
           MOV DX,OFFSET FOUT1     ;otvor subor FOUT1
	   INT 21H
	   JNC OTV2                ;ak CF=0 skok na otv2
	   MOV AH,3CH              ;vytvori
	   MOV CX,0
	   INT 21H
OTV2:      RET                     ;vrat sa z proc
OTVOROUT1  ENDP                    ;koniec

;OTVORI SUBOR NA PISANIE
OTVOROUT2  PROC NEAR
	   MOV AH,3DH             ;funkcia na otvorenie suboru
           MOV DX,OFFSET FOUT2    ;otvor subor FOUT2
	   INT 21H
	   JNC OTV3               ;ak CF=0 skok na otv3
	   MOV AH,3CH             ;vytvori
	   MOV CX,0
   	   INT 21H
OTV3:      RET                    ;vrat sa z proc
OTVOROUT2  ENDP                   ;koniec

;POMOC PRE OP + A / 
OPERACIA   PROC NEAR
           MOV SI,OFFSET file   ;do si daj offset file
           MOV BYTE PTR [SI],4  ;do adresy si daj 4
           MOV AH,0AH           ;vstup cez buffer
           MOV DX,SI            ;do dx daj si
           INT 21H              ;vykonaj
           ADD SI,2             ;k Si pripocitaj 2
           MOV DI,OFFSET POM1   ;do DI daj Offset pom1
OP1:       LODSB                ;presun retazca do zas
           CMP AL,0DH           ;ak al=0x0d
	   JE OP1               ;skok na op1
	   STOSB                ;presun zas do ret
	   JMP OP2              ;skok na op2
OP2:       MOV AL,0             ;do al daj 0
	   STOSB                ;presun zas do ret
           MOV AX,WORD PTR [POC1]  ;do ax daj pocet cisel
	   PUSH AX                 ;daj Ax do zas
           MOV AX,OFFSET file+100      ;daj do ax subor+100
           MOV WORD PTR [POC1],AX      ;do Pocet1 daj AX
           MOV BYTE PTR [ZNAM],'+'     ;Znamienko je +
	   CALL KONV                   ;zavolaj proc konv
           DEC BYTE PTR [POC]          ;dekrementuj pocet
	   POP AX                      ;obnov ax zo zas
           MOV WORD PTR [POC1],AX      ;daj do pocet ax
           MOV AX,WORD PTR [file+100]  ;do ax adresu daj subor+100
	   DEC AX                      ;dekrementuj ax
           CMP AL,BYTE PTR [POC]       ;ak al< pocet
	   JB OP3                      ;skok na op3
	   MOV AX,0FFFFH               ;do ax daj 65535
OP3:       RET                         ;vrat sa z proc
OPERACIA   ENDP                        ;koniec proc

;
;Zaciatok programu
;
START:	   MOV AX,SEG DATA   ;daj do ax segmentovu adresu
	   MOV DS,AX         ;uloz seg adresu do DS a ES
	   MOV ES,AX
           CMP [PRIZ],1      ;pozri ci je nastaveny priznak=1
	   JE M1             ;ak ano skok na m1 			 
           MOV [PRIZ],1      ;ak nie nastav na1  
	   JMP NAC           ;a skok na nac
M1:        JMP MENU1

;
;NACITANIE CISIEL ZO SUBORU
;

NAC: 	   MOV AL,0         ;do al daj 0
	   CALL OTVOR       ;zavolaj proceduru OTVOR
	   MOV BX,AX        ;do bx daj ax
	   MOV AH,3FH       ;citanie zo suboru
	   MOV CX,700
           MOV DX,OFFSET FILE
           INT 21H             ;vykonaj
           MOV SI,OFFSET FILE  ;do SI daj adr SUBOR
           ADD SI,AX           ;k SI pripocitaj AX
           MOV BYTE PTR [SI],0 ;do SI daj 0
	   MOV AH,3EH          ;zatvor subor
           INT 21H 
           MOV SI,OFFSET FILE          ;do SI daj offset subor
           MOV DI,OFFSET [CISLO]       ;do DI daj adresu cisiel
           MOV WORD PTR ES:[POC1],DI   ;do pocet1 daj DI
           MOV BYTE PTR ES:[POC],0     ;do POCET daj 0
NAC2:      MOV BYTE PTR ES:[ZNAM],'+'  ;Znamienko nastav na +
           CMP BYTE PTR [SI],'-'       ; ak SI nie je -
           JNE NAC3                    ;skok na NAC3
           MOV BYTE PTR ES:[ZNAM],'-'  ;Znamienko nastav na -
	   INC SI                         ;inkrementuj SI
NAC3:      CMP BYTE PTR [SI],'+'          ;ak SI nie je +
	   JNE NAC4                       ;skok na nac4
	   INC SI                         ;inac inkrementuj SI
NAC4:      MOV DI,OFFSET POM1             ;do DI daj adresu POM1
	   XOR CX,CX                      ;vynuluj CX
NAC5:	   LODSB                          ;presun retazec do zas
	   CMP AL,' '                     ;ak je ''
	   JE NAC7                        ;tak skok na nac7
	   CMP AL,13                      ;ak al je enter
	   JE NAC7                        ;skok na nac7
	   CMP AL,0                       ;ak al je 0
	   je NAC7                        ;skok na nac7
	   CMP AL,30h                     ;ak al< 30h
	   JB NAC6                        ;skok na nac6
	   CMP AL,39h                     ;ak al> 39h
	   JA NAC6                        ;skok na nac6
	   STOSB                          ;presun zas do ret
	   INC CX                         ;inkrementuj CX
           CMP CX,6                       ;ak CX je 6
	   JE NAC6	                  ;skok na nac6
	   JMP NAC5                       ;skok na nac5
NAC6:	   JMP KONIEC                     ;skok na koniec
NAC7:      PUSH AX                        ;do zas daj AX,SI,DI
           PUSH SI
           PUSH DI
           MOV AL,0                       ;do al daj 0
           STOSB                          ;presun zas do ret
           CALL KONV                      ;zavolaj proc Konv
           POP DI                         ;obnov zo zas DI,SI,AX
           POP SI
           POP AX
           CMP BYTE PTR ES:[ZNAM],0       ;ak znamienko  je 0
	   JE NAC6                        ;skok na nac6
	   CMP AL,0                       ;ak al je 0
	   JE NAC8                        ;skok na nac8
	   JMP NAC2                       ;inak skok na nac2
NAC8:      JMP MENU1                       ;skok na menu


MENU1:     MOV AX,3                       ;vycisti obrazovku
	   INT 10H
	   MOV AH,9                       ;vypise menu           
	   MOV DX,OFFSET MENU
	   INT 21H			
ST1:	   MOV AH,8                       ;caka na znak 
                                          ;vstup bez echa
	   INT 21H
           CMP AL,'a'                     ;ak je a skok na sum1
	   JE sum1
           CMP AL,'b'                     ;ak je b skok na sum1
	   JE vz1         
           CMP AL,'c'                     ;ak je c skok na vz1
	   JE nas1                 
           CMP AL,'d'                     ;ak je d skok na z11
	   JE del1
           CMP AL,'e'                     ;ak je e skok na kon1
	   JE KON1                        
	   JMP ST1                        ;inak caka dalej

;aby sem nepresahovali
;velkost skoku

SUM1:      JMP SUMA               
del1:       JMP delenie
vz1:	   JMP VZOSTUPNE
nas1:	   JMP SUCIN
KON1:      JMP KONIEC

;
;SUCET CISEL
;

SUMA:	   MOV AH,9 
           MOV DX,OFFSET Sprava1
	   INT 21H                ;vypis na obr nadpis1
           MOV CL,BYTE PTR [POC]  ;do CL daj pocet cisel
	   XOR CH,CH              ;vynuluj CH
	   MOV SI,OFFSET CISLO    ;do SI daj adresu cisiel
	   XOR AX,AX              ;vynuluj ax
SUMA2:     MOV DX,WORD PTR [SI]   ;do dx daj SI
           ADD AX,DX              ;pripocitaj k ax,dx
           ADD SI,2               ;daj k si 2
           LOOP SUMA2             ;cyklus kym vsetky nepocita
           CALL OBRAZOVKA         ;zavolaj OBRAZOVKA 
           CALL pause             ;cakaj
           JMP MENU1               ;skok na menu

;
;TRIEDENIE VZOSTUPNE
;

VZOSTUPNE: CALL SORT              ;zavolaj SORT
	   MOV AL,1               ;do AL daj 1
	   CALL OTVOROUT1         ;otvor subor na out
           MOV BX,AX              ;do bx daj ax
           MOV BYTE PTR [PRIZ5],1   ;nastav priz5 na 1
	   MOV AH,9                 ;vypis na obrazovku sprav3
           MOV DX,OFFSET SPRAVA3
	   INT 21H
	   CALL VSETKY              ;vypis vsetky
           MOV BYTE PTR [PRIZ5],0   ;nastav priz5 na 0
           MOV BX,WORD PTR [POM]    ;do bx daj pom
	   MOV AH,3EH              ;zatvor subor
	   INT 21H        
           CALL pause              ;cakaj
           JMP MENU1                ;skok na menu


;
;SUCIN VYBRANYCH CISIEL
;

SUCIN:	   MOV AH,9                 ;vypise sprava5
           MOV DX,OFFSET SPRAVA5
	   INT 21H
  	   CALL VSETKY              ;vypise vsetky cisla
           MOV AH,9                 
           MOV DX,OFFSET SPRAVA6    ;vypise sprava6
	   INT 21H
           CALL OPERACIA            ;zavola proc OPERACIA
	   CMP AX,0FFFFH            ;ak nie je  65535
	   JNE SUC2                 ;tak skok na suc2
SUC1:      MOV AH,9                
           MOV DX,OFFSET CHYBA      ;vypis chyba
           INT 21H
           CALL PAUSE               ;cakaj
	   JMP MENU1                ;skok na menu
SUC2:      PUSH AX                  ;ax daj do zas
	   MOV AH,9             
           MOV DX,OFFSET SPRAVA6
           INT 21H	            ;vypis sprava6
	   CALL OPERACIA            ;zavolaj op
	   CMP AX,0FFFFH            ;ak ax je 65535
	   JE SUC1                  ;skok na suc1
	   POP BX                   ;zo zas obnov BX
           MOV SI,OFFSET CISLO      ;do si daj adresu cisiel
           MOV DI,SI                ;do di daj si
           ADD SI,AX                ;k si 2-krat pripocitaj ax
           ADD SI,AX              
           MOV AX,WORD PTR [SI]     ;do ax daj si
           ADD DI,BX                ;k di 2-krat pripocitaj bx
           ADD DI,BX
           MOV BX,WORD PTR [DI]     ;do bx daj di
           MOV BYTE PTR [ZNAM],0    ;nastav znam na 0
           CMP AX,8000H              ;ak ax<8000h
           JB SUC3                   ;skok na suc3
           NOT BYTE PTR [ZNAM]       ;logicky neguj znamienko
	   NEG AX                    ;negacia ax
SUC3:      CMP BX,8000H              ;ak bx<8000h
           JB SUC4                   ;skok na suc4
           NOT BYTE PTR [ZNAM]       ;log. neguj znamienko
	   NEG BX                    ;neguj bx
SUC4:      MUL BX                    ;vynasob bx
           CMP DX,0                  ;ak dx je 0
           JE SUC5                   ;skok na suc5
           MOV AH,9                  ;vypis chyba
           MOV DX,OFFSET CHYBA
           INT 21H
           CALL pause                ;cakaj
           JMP MENU1                  ;skok na menu
SUC5:      PUSH AX                   ;ax daj do zasobnika
           MOV AH,9 
           MOV DX,OFFSET SPRAVA7
           INT 21H                   ;vypis sprava7
           POP AX                    ;obnov ax zo zas
           CMP BYTE PTR [ZNAM],0     ;ak znamienko je 0
           JE SUC6                   ;tak suc6
           NEG AX                    ;neguj ax
SUC6:      CALL OBRAZOVKA            ;zavolaj obrazovka
           CALL pause                ;cakaj
           JMP MENU1                  ;skok na menu

;
;DELENIE
;

DELENIE:   MOV AH,9
           MOV DX,OFFSET sprava5
           INT 21H                   ;vypis sprava5
           CALL VSETKY               ;a vsetky
           MOV AH,9
           MOV DX,OFFSET sprava6     ;vypis sprava6
           INT 21H	
	   CALL OPERACIA             ;zavolaj operacia
	   CMP AX,0FFFFH             ;ak nie je 65535
	   JNE DEL3                  ;skok na del3
DEL2:      MOV AH,9                  ;
           MOV DX,OFFSET CHYBA       ;vypis chybu
           INT 21H
           CALL pause                ;cakaj
	   JMP MENU1                  ;skok na menu
DEL3:      PUSH AX                   ;daj ax do zas
           MOV AH,9
           MOV DX,OFFSET sprava6     ;vypis sprava6
           INT 21H
           CALL OPERACIA             ;zavolaj operacia
	   CMP AX,0FFFFH             ;ak ax je 65535
           JE DEL2                   ;skok na del2
           POP BX                    ;obnov bx
           MOV SI,OFFSET CISLO       ;do si daj adresu cisiel
           MOV DI,SI                 ;do di daj si
           ADD SI,AX                 ;k si dvakrat pripocitaj ax
           ADD SI,AX
           MOV AX,WORD PTR [SI]      ;do ax daj si
           ADD DI,BX                 ;k di pripocitaj bx
           ADD DI,BX            
           MOV BX,WORD PTR [DI]      ;do bx daj di
           MOV BYTE PTR [ZNAM],0     ;nastav znamienko na 0
           CMP AX,8000H              ;ak ax <8000h
           JB DEL4                   ;skok na del4
           NOT BYTE PTR [ZNAM]       ;logicky neguj znamienko
           NEG AX                    ;neguj ax
DEL4:      CMP BX,8000H              ;ak bx<8000h
           JB DEL5                   ;skok na del5
           NOT BYTE PTR [ZNAM]       ;logicky neguj znamienko
	   NEG BX                    ;neguj bx
DEL5:      XCHG AX,BX                ;vymen ax a bx
           XOR DX,DX                 ;vynuluj dx
           DIV BX                    ;vydel bx
           PUSH DX                   ;daj dx a ax do zas                   
           PUSH AX
           MOV AH,9
           MOV DX,OFFSET sprava8  
           INT 21H                   ;vypis sprava8
	   POP AX                    ;obnov ax
           CMP BYTE PTR [ZNAM],0     ;ak znamienko je 0
	   JE DEL6                   ;tak skok na del6
	   NEG AX                    ;neguj ax
DEL6:      CALL OBRAZOVKA            ;zavolaj Obrazovka
           MOV AH,9
           MOV DX,OFFSET sprava9
           INT 21H                    ;vypis sprava9
           POP AX                     ;obnov ax
           CALL OBRAZOVKA             ;zavolaj obrazovka
           CALL pause                 ;cakaj
	   JMP MENU1                   ;skok na menu

;
;KONIEC PROGRAMU
;

KONIEC:    MOV AX,4C00H                 ;RIADNE UKONCENIE PROGRAMU
           INT 21H                      ;DO OS BUDE VRATENA HODNOTA 0x00
CODE ENDS
     END START
;
;Program bol napisany pod systemom DOS 7.2(Windows 95 OSR2)
;Prelozeny a testovany v TASM 3.0
;Chyby sa vyskytnu pri deleni a nasobeni velkych zapornych a  
;kladnych cisiel.Pri nasobeni vypocita stvorec toho isteho cisla.
;Program bol testovany tiez pod Windows 2000. 
;Prekladac bol TASM 2.0
;
