;ZADANIE c.2
;Text zadania:

;  Vytvorte  program,  ktory  nacta  z  textovho sboru postupnost
;  celych csel so znamienkom  v desiatkovej cselnej sstave (aspon
;  10), potom ich transformuje na csla v dvojkovej cselnej sstave
;  v doplnkovom kde a potom podla priania uzvatela
;    a) vypocta sumu  vsetkych csel a vypise ju
;    b) usporiada csla zostupne a zapse usporiadan postupnost csel
;       do novho textovho sboru,
;    c) vynasob dve posledne cisla
;    d) vydel dve vybran sla a vype vsledok
;    e) ukonc vykonvanie programu.
;  Na prcu so sbormi mzete pouzit napr. sluzby 3dH, 3eH, 3fH,40H.
;  Vysledky operci treba vypisovat v desiatkovej cselnej sstave.
;  Ak by pri  vypocte sumy v pripade a)  doslo k preteceniu, oznamte
;  prekrocenie ciselneho rozsahu


;==========================================================================

ZAS		SEGMENT	STACK  'STACK'    ;Definicia zasobnikoveho segmentu
		DW	64 DUP(?)
ZAS		ENDS           ;Koniec definicie zasobnikoveho segmentu

;==========================================================================

DAT		SEGMENT        ;Definicia datoveho segmentu

PONUKA	db	13,10,13,10,'Stlac klavesu pozadovanej sluzby :',13,10,13,10
		db 	'  1 - Vypis sumu vsetkych cisel',13,10
		db 	'  2 - Usporiadaj cisla podla velkosti a vysledok '
		db  'zapis do suboru',13,10
		db 	'  3 - Vypis vysledok delenia dvoch vybranych cisel',13,10
		db	'INA - Navrat do DOSu',13,10,'$'

GETCH	db	13,10,13,10,'Stlac klavesu ......',13,10,13,10,'$'
TEXT1	db 	13,10,13,10,'Suma vsetkych cisel je : $'
TEXT2	db	13,10,13,10,'!!!!!!!!!! CHYBA - Nastalo pretecenie !!!!!!!!!!'
		db  13,10,'$'

TEXT3	db	13,10,13,10,'Zadaj znak pri 1. zvolenom cisle.$'
TEXT4	db 	13,10,13,10,'Zadaj znak pri 2. zvolenom cisle.',13,10,'$'
TEXT5	db	13,10,13,10,'Vysledok operacie 1.cislo DIV 2.cislo je $'
TEXT6	db  13,10,13,10,'Vysledok operacie 1.cislo MOD 2.cislo je $'
TEXT7	db	13,10,13,10,'1.cislo = $'
TEXT8	db	13,10,13,10,'2.cislo = $'

VSTUP	db  'vstup.txt',0    ;Nazov vstupneho suboru
VYSTUP	db  'vystup.txt',0   ;Nazov vystupneho suboru


BUF		db  1030 dup(0)      ;Vyhradene pre vstup/vystup z/do suboru
POCCIS	db  0                ;Pocet cisel vo vstupnom subore
CISLA	db	100 dup(0)       ;Tu budu ulozene nacitane cisla
SORT	db  100 dup(0)       ;Tu budu ulozene zotriedene cisla
C10		db  10				 ;Konstanta na nasobenie = 10
C100	db  100				 ;Konstanta na nasobenie = 100



DAT		ENDS     			 ;Koniec datoveho segmentu


;==========================================================================

CODE	SEGMENT               ;Tu zacina segment programoveho kodu
		ASSUME	CS:CODE, DS:DAT, SS:ZAS, ES:DAT



VC		proc          ;procedura vypise cislo,ktore sa nachadza v AX

		push bx       ;ulozenie registrov do stacku
		push cx
		push dx

		mov dx,ax     ;so zadanym cislom sa bude dalej pracova v DX

		mov	bx,10000  ;v BX je ciselny rad s ktorym budeme ratat
		call VC2      ;procedura vypise cislicu,ktora zodpoveda 10000-kam
		mov	bx,1000
		call VC2      ;vypise 1000-ky
		mov	bx,100
		call VC2      ;vypise 100-ky
		mov	bx,10
		call VC2      ;vypise 10-ky
		mov	bx,1
		call VC2      ;vypise jednotky

		pop dx
		pop cx       ;obnovenie registrov
		pop bx

		ret          ;navrat do hlavneho programu
		endp

;----------------------------------------------------------------------------

VC2		proc           ;Procedura vypocita a vypise ASCII kod cislice

		xor	cx,cx      ;Vynulovanie CX
s10:    cmp	dx,bx      ;Porovnanie DX a CX
		jb	s1         ;Ak DX < CX chod na s1
		sub	dx,bx      ;Inak odpocitaj BX od DX
		inc	cl         ;CL zvys o 1
		jmp	s10        ;Opakuj kym DX >= CX
s1:     mov	bl,dl      ;Presun udaj z DL do BL
		mov	dl,cl      ;Do DL daj vyslednu cislicu
		add	dl,30h     ;Uprav cislicu na ASCII znak

		mov	ah,2       ;Vytlac cislicu ktora je v DL
		int	21h

		mov	dl,bl      ;Obnov DL
		ret
		endp

;--------------------------------------------------------------------------

NR		proc		;Tato procedura 2-krat odriadkuje

		mov ah,02h
		mov dl,13
		int 21h        ;vytlaci znak CHR(13)

		mov ah,02h
		mov dl,10
		int 21h        ;vytlaci znak CHR(10)

		ret
		endp

;--------------------------------------------------------------------------

NACITAJ proc					;Procedura nacita textovy subor do pamati

		mov ah,3dh              ; Otvor subor
		mov al,0                ; na citanie
		mov dx,offset VSTUP     ; Do DX daj pointer na meno suboru
		int 21h

		mov dx,offset BUF 		; Do DX daj pointer na zac.vyhrad.miesta
		mov cx,1                ; Citat sa bude 1 znak
		mov bx,ax               ; V BX je handler otvoreneho suboru
CITAJ:	mov ah,3fh              ; Nacitaj polozku zo suboru
		int 21h

		inc dx	                ; Prsun sa na dalsie miesto v pamati

		cmp ax,0                ;Testovanie konca suboru
		jne CITAJ				;Ak nie je koniec,citaj dalsiupolozku

		mov ah,3eh              ;Zavretie suboru
		int 21h

		ret
		endp

;--------------------------------------------------------------------------

PREVED	proc                    ;Procedura prevedie cisla v ASCII
								;na cisla typu BYTE v doplnkovom kode

		mov si,offset BUF       ;SI ukazuje na zac zdoj.textu
		call PREV1				;Zisti pocet cisel v subore
		mov dx,si               ;Uchovaj SI v DX
		mov si,offset POCCIS    ;Do SI daj pointer na pocet cisel
		mov [si],al             ;Uloz pocet cisel na adresu SI
		mov si,dx               ;Obnov SI
		xor cx,cx               ;Vynuluj CX
		mov cl,al               ;V CX je pocet opakovani
		mov bx,offset CISLA     ;Do DX daj cielovu adresu

PREV:	inc si                  ;Posun sa na dalsie cislo
		inc si      			;v pamati
		call PREV1              ;Preved cislo
		mov [bx],al             ;Daj prevedene cislo na cielovu adresu
		inc bx					;Posun sa na dalsiu polozku
		loop PREV				;Opakuj POCCIS krat

		ret

		endp
;--------------------------------------------------------------------------

PREV1	proc                    ;Samotne prevedenie ASCII retazca cisel
								;na cislo v doplnkovom kode
		xor dx,dx               ;Vynuluj DX
		xor ax,ax				;Vynuluj AX
PREV1A: inc si                  ;Posun sa na dalsi ASCII znak
		cmp byte ptr [si],13	;Zisti,ci to nie je EOL
		jne PREV1A              ;Ak nie , opakuj

		push si					;Uchovaj SI

		dec si					;Presun sa na poslednu cislicu a
		mov al,[si]				;nacitaj ju do AL

		sub al,'0'				;Preved ASCII na cislo a
		mov dl,al               ;pripocitaj k DL

		dec si                  ;Presun sa na 10-ky a
		mov al,[si]				;nacitaj ich do AL

		cmp al,'+'              ;Test na znamienko
		je	PREV1C				;Ak je znam. '+',chod na PREV1C
		cmp al,'-'
		je  PREV1B              ;Ak je znam. '-',chod na PREV1B

		sub al,'0'              ;Uprav ASCII na cislo,
		mul [C10]				;vynasob desiatimi a
		add dl,al				;pripocitaj k DL

		dec si                  ;Presun sa na 100-ky a
		mov al,[si]				;nacitaj ich do AL

		cmp al,'+'              ;Test na znamienko
		je	PREV1C
		cmp al,'-'
		je  PREV1B

		sub al,'0'				;Uprav na ASCII,
		mul [C100]				;vynasob stomi a
		add dl,al				;pripocitaj

		dec si                  ;Presun sa na vyhradne znamienkovy rad a
		mov al,[si]				;nacitaj znamienko do AL

		cmp al,'+'              ;Test na znamienko
		je  PREV1C

PREV1B:	not dl                  ;Ak je cislo zaporne,urob doplnok
		inc dl

PREV1C:	pop si                  ;Obnov SI
		mov al,dl               ;Presun DL do AL
		ret

		endp

;--------------------------------------------------------------------------
ZAPIS 	proc                    ;Procedura prevedie zotriedene cisla do
								;ASCII a zapise ich do suboru
		mov si,offset SORT      ;SI ukazuje na zotriedene cisla
		mov di,offset BUF       ;DI ukazuje na vyhradene miesto
		xor cx,cx				;Vynuluj CX
		mov cl,[POCCIS]         ;Do CL daj pocet cisel
ZAPIS1:	mov al,[si]             ;Daj cislo do AL
		push ax                 ;Uchovaj AX
		rcl al,1				;Test znamienka
		pop ax                  ;Obnov AX

		jnc ZAPIS2              ;Ak je znam.kladne,chod na ZAPIS2
		dec al					;Cislo je zaporne,teda
		not al					;urob jeho doplnok  a
		mov [di],'-'			;na ciel daj '-'
		jmp ZAPIS3              ;Skoc na ZAPIS3

ZAPIS2: mov [di],' '            ;Cislo je kladne,teda prvy znak je ' '

ZAPIS3:	inc di					;presun sa na dalsiu ciel.polozku
		xor ah,ah				;Vynuluj AH
		call ZAPCIS             ;Zapis cislo do suboru
		mov [di],13             ;Zapis
		inc di                  ;do suboru
		mov [di],10             ;znaky EOL
		inc di                  ;Presun sa na dalsiu cislicu
		inc si                  ;Presun sa na dalsie cislo
		loop ZAPIS1             ;Opakuj pre dalsie cisla

		mov dx,offset BUF       ;Daj do DX zac vyhr.miesta
		push dx					;Uchovaj DX
		mov cx,di				;Do CX daj DI
		sub cx,dx				;CX = CX - DX,vypocet dlzky bloku dat

		push cx                 ;Uchovaj CX

		xor cx,cx               ;Vynuluj CX,su v nom atributy
		mov ah,3ch              ;Funkcia DOSu : vytvor subor
		mov al,1                ;
		mov dx,offset VYSTUP    ;DX ukazuje na nazov suboru
		int 21h                 ;Vytvor subor

		pop cx                  ;Obnov dlzku dat

		mov bx,ax               ;Do BX daj HANDLE
		mov ah,40h              ;Bude sa zapisovat
		pop dx                  ;Do DX daj zaciatok bloku
		int 21h                 ;Zapis do suboru

		mov ah,3eh              ;Zavri subor
		int 21h

		ret
		endp




;--------------------------------------------------------------------------

ZAPCIS	proc          			;Procedura zapise cislo,ktore
								;sa nachadza v AX do pamati
		push bx     		 	;Ulozenie registrov do stacku
		push cx
		push dx

		mov dx,ax     			;So zadanym cislom sa bude dalej
								;pracovat v DX
		mov bx,10000  			;zapise 10000-ky
		call ZC2
		mov bx,1000             ;Zapise 1000-ky
		call ZC2
		mov	bx,100
		call ZC2      			;Zapise 100-ky
		mov	bx,10
		call ZC2      			;Zapise 10-ky
		mov	bx,1
		call ZC2      			;Zapise jednotky

		pop dx
		pop cx       			;Obnovenie registrov
		pop bx

		ret          			;Navrat do hlavneho programu
		endp

;----------------------------------------------------------------------------

ZC2		proc					;Procedura vyrata cislicu a zapise ju
								;do pamati
		xor	cx,cx      			;vynulovanie CX
Z10:    cmp	dx,bx      			;porovnanie DX a CX
		jb	Z1         			;ak DX < CX chod na Z1
		sub	dx,bx      			;inak odpocitaj BX od DX
		inc	cl         			;CL zvys o 1
		jmp	Z10 	   			;opakuj kym DX >= CX

Z1:		add	cl,30h     			;Uprav cislicu na ASCII znak
		mov [di],cl             ;Uloz cislicu na na akt.ciel.poziciu
		inc di					;Presun sa na

		ret
		endp


;--------------------------------------------------------------------------
SVC		proc           ;Procedura vypisuje cislo so znamienkom


		push ax
		rcl al,1		;Test znamienka
		pop ax

		jnc SVC2
		dec al          ;Ak je zaporne ,urob doplnok
		not al

		push ax
		mov ah,02h      ;Vypis '-'
		mov dl,'-'
		int 21h
		pop ax
		jmp SVC3

SVC2:	push ax
		mov ah,02h
		mov dl,' '     ;Vypis ' '
		int 21h
		pop ax

SVC3:	call VC        ;Vypis cislo

		ret

		endp

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

START:	mov ax,seg DAT      	;Tu zacina hlavny program
		mov ds,ax               ;Inicializacia segmentovych registrov
		mov es,ax

		call NACITAJ			;Nacitaj ASCII zo suboru
		call PREVED				;Preved ASCII na cisla v dop.kode

HLAVNE:	mov	dx,offset GETCH		;Vypis vyzvu na stlac.klavesy
		mov ah,09h
		int 21h

		mov ah,07h				;Cakaj na stlacenie klavesy
		int 21h

		mov dx,offset PONUKA    ;Vypis ponuku funkcii
		mov ah,09h
		int	21h

		mov ah,07h            ;Nacita 1 znak z klavesnice
		int 21h

		push ax
		call NR           ;2 krat odriadkovanie
		pop ax

		cmp al,'1'        ;Ak bol zadany znak 1 ,chod na funkciu 1
		je  F1

		cmp al,'2'
		je  F2

		cmp al,'3'

		jne F4        ;Ak nebol stlaceny klaves 3 ,skoc na navestie F4
		jmp F3		  ;inak chod na funkciu F3

F4:		mov ah,4ch    ;Navrat do DOSu
		int 21h



F1:		xor cx,cx             ;Vynuluj CX
		mov cl,[POCCIS]       ;Do CL daj pocet cisel v bloku
		mov si,offset CISLA   ;Nastav SI na zac bloku cisel
		xor dx,dx             ;Vynuluj DX
F1A:	mov al,[si]           ;Do AL daj cislo
		add dl,al             ;Pripocitaj ho k DL


F1B:    jno F1C               ;Test pretecenia
		jmp PRETEC            ;Ak nastalo,oznam to a skonci

F1C:	inc si                ;Presun sa na dalsiu polozku
		loop F1A			  ;Opakuj pre vsetky cisla
		xor dh,dh             ;Vynuluj DH
		push dx				  ;Uchovaj DX

		mov ah,09h
		mov dx,offset TEXT1   ;Vypis TEXT1
		int 21h

		pop ax
		push ax
		rcl al,1              ;Testuj znamienko
		pop ax
		jnc F1D

		dec al                ;Urob doplnok
		not al

		push ax
		mov dl,'-'            ;Vypis '-'
		mov ah,02h
		int 21h
		pop ax

F1D:	call VC               ;Vypis sucet cisel

		jmp HLAVNE            ;Navrat do hlavneho menu



PRETEC: mov ah,09h
		mov dx,offset TEXT2   ;Oznam pretecenie
		int 21h

		jmp HLAVNE            ; a vrat sa ho hlavneho menu



F2:     xor cx,cx				;Vynuluj CX
		mov cl,[POCCIS]			;Do CL daj pocet cisel
		mov si,offset CISLA     ;source = CISLA
		mov di,offset SORT		;destination = SORT
		cld                     ;Nastavenie smeru sprac.retazcov na inc
		rep movsb				;Prekopiruj CISLA do SORT o dlzke CX



		mov bx,offset SORT		;Nasleduje podprogram na triedenie
		xor cx,cx               ;V CX je 0, v BX zac bloku na triedenie
		mov cl,[POCCIS]			;Do CL daj pocet prvkov na triedenie
F2A:
		push cx
		mov al,[bx]             ;Vonkajsi triediaci cyklus
		mov dx,bx
		dec cx
		mov si,bx
		inc si

		cmp cl,0
		je F2D
F2B:	cmp [si],al
                jle F2C                                 ;Vnutorny triediaci cyklus
		mov al,[si]
		mov dx,si
F2C:	inc si
		loop F2B

F2D:
		mov di,dx
		mov si,bx
		mov al,[si]             ;Vymena prvkov na ktore ukazuju SI a DI
		mov ah,[di]
		mov [di],al
		mov [si],ah

		pop cx
		inc bx
		loop F2A

		call ZAPIS				;Zapis utriedene cisla do suboru

		jmp HLAVNE				;Naspat do hlavneho menu




F3: 	mov si,offset CISLA   ;Nastav SI na zac bloku cisel
		xor cx,cx
		xor bx,bx
		mov cl,[POCCIS]       ;V CX je pocet cisel

F3A:    mov dl,bl
		add dl,'a'            ;Uprava cisla na ASCII
		mov ah,02h            ;a vypis znaku
		int 21h

		mov ah,02h
		mov dl,' '           ;Vypis medzeru
		int 21h

		push si
		xor ax,ax
		mov si,offset CISLA   ;Vypocita adresu cisla
		add si,bx				;a vyberie ho z pamati
		mov al,[si]
		pop si


		call SVC				;Vypise cislo

		inc si
		inc bx

		mov ah,02h
		mov dl,13               ;Vypise EOL
		int 21h

		mov dl,10
		int 21h

		loop F3A                 ;Opakuj pre ostatne cisla

		mov ah,09h
		mov dx,offset TEXT3		  ;Vypis vyzvu na zad.1.znaku
		int 21h

		mov ah,07h                ;Nacitanie 1.znaku
		int 21h

		sub al,'a'
		xor ah,ah
		mov si,offset CISLA       ;Nacitanie zvoleneho cisla z pamati
		push si
		add si,ax
		mov bh,[si]

		mov ah,09h
		mov dx,offset TEXT4			;Vypis vyzvu na zadanie 2.znaku
		int 21h

		mov ah,07h					;Nacitaj 2.znak
		int 21h

		sub al,'a'
		xor ah,ah
		pop si                      ;Nacitanie 2.zvol.cisla z pamati
		add si,ax
		mov bl,[si]

		mov ah,09h
		mov dx,offset TEXT7			;Vypise text a 1.cislo
		int 21h
		mov al,bh
		xor ah,ah
		call SVC

		mov ah,09h
		mov dx,offset TEXT8			;Vypise text a 2. cislo
		int 21h
		mov al,bl
		xor ah,ah
		call SVC

		mov al,bh
		xor ah,ah
		push ax
		rcl al,1                    ;Znamienkovy test
		pop ax
		jnc F3B
		mov ah,255                  ;Ak je zaporne,cele AX preved na zaporne

F3B:	idiv bl						;Vydel zadane cisla

		mov bx,ax

		mov ah,09h
		mov dx,offset TEXT5
		int 21h

		xor ah,ah
		mov al,bl                 ;Vypis 1. DIV 2.
		call SVC

		mov ah,09h
		mov dx,offset TEXT6
		int 21h

		xor ah,ah                 ;Vypis 1. MOD 2.
		mov al,bh
		call SVC

		jmp HLAVNE					;Skoc do hlavneho menu



CODE	ENDS					;Koniec kodoveho segmentu
		END	START				;Program sa spusti od navestia START

;MOZNE KOMPLIKACIE A OBMEDZENIA:
;-cisla vo vstupnom subore musia byt vrozsahu <-128,127>
;-kazde cislo musi mat znamienko (aj 0)
;-pocet cisel v subore je dany prvym cislom v subore,pricom toto cislo sa
; do toho nerata
;-maximalny pocet cisel(odporucany vzhladom k poctu pismen v abecede) je 25
;-tento program nie je blbuvzdorny
