;Zadanie c.3

;Text zadania:
;S vyuzitim retazcovych instrukcii (vsade kde je to mozne)
;vytvorte program, ktory:
;a) nacita z klavesnice dva retazce do dvoch roznych segmentov
;(minimalne 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;c) porovna posunuty retazec s retazcom v druhom segmente, t.j.
;zisti, ci su rovnako dlhe a ci su rovnake,
;d) zisti, ci sa v niektorom z retazcov nachadza zadany
;podretazec.
;Zdrojovy program musi byt PODROBNE OKOMENTOVANY!
;Vysledky ukazte v ladiacom prostredi TurboDebugg.
;Termin odovzdania: na cvicen do 10. tyzdna semestra
;Hodnotenie: maximalne 8 bodov

;Autor: Ludovit Fulop
;Kruzok: Info b-9
;Datum odovzdania: 26.11.1999
;Skolsky rok: 1999/2000

zas	segment	stack
	db	100h	dup(?)
zas	ends
dat1	segment
	zadaj1	db	10,13,'Zadaj prvy retazec: $'
	zadaj2	db	10,13,'Zadaj druhy retazec: $'
	zadaj3	db	'Zadaj hladany podretazec: $'
	info0	db	'Zadane retazce su totozne$'
	info2a	db	'Hladany podretazec sa nachadza v prvom retazci$'
	info2b	db	'Hladany podretazec sa nachadza v druhom retazci$'
	err0	db	'Retazce sa nezhoduju$'
	err1	db	'Podretazec som nenasiel!$'
	nr	db	10,13,'$'
	str1	db	50			; prvy retazec
		db	0
		db      50	dup(?)
	podr	db	50			; hladany podretazec
		db	0
		db	50	dup(?)
dat1	ends
dat2	segment					; druhy datovy segment
	str2	db	50			; druhy retazec
		db	0
		db	50	dup(?)
dat2	ends
;---------------------------------------------------------------------------
code	segment
	assume cs:code, ss:zas
PisRet	proc				; PROCEDURA PRE VYPIS RETAZCA
	push ax
	mov ah,9			; ocakava pripravenost dat v ds:dx
	int 21h
	pop ax
	ret
Pisret	endp

GetStr	proc				; PROCEDURA PRE NACITANIE RETAZCOV
	push seg zadaj1			; "Zadaj prvy retazec"
	pop ds
	mov dx,offset zadaj1
	call PisRet
	mov ah,0ah			; nacitanie retazca
	push seg str1
	pop ds
	mov dx, offset str1
	int 21h
	push seg zadaj2			; "Zadaj druhy retazec"
	pop ds
	mov dx,offset zadaj2
	call PisRet	
	mov ah,0ah		
	push seg str2			; nacitanie retazca
	pop ds
	mov dx, offset str2
	int 21h
	push seg nr			; odriadkovanie
	pop ds
	mov dx,offset nr
	call PisRet
	ret
GetStr	endp

Posun	proc				; PROCEDURA PRE POSUNUTIE PRVEHO RETAZCA
	push seg str1			; zdrojovy retazec: str1- ds:si
	pop ds
	mov si, offset str1
	push ds
	pop es				; cielovy retazec: str1+10 byteov-es:di
	mov di,si
	xor cx,cx
	mov cl,[ds:si+1]		; pocet pismen str1
	add si,cx			; posunutie ukazovatelov 
	add si,2			; es:di a ds:si
	add di,cx			; na koniec retazcov
	add di,2			; str1 a str1+10byte
	add di,10
	add cx,3
	std				; nastavenie smeru - di,si sa budu --
rep	movsb				; kym cx<>0 dst<-src; cx--
	ret
Posun	endp

porovnanie proc				; PROCEDURA PRE POROVNANIE 2 RETAZCOV
	push seg str1			; adresa prveho retazca- ds:si
	pop ds
	mov si, offset str1
	add si,10
	push seg str2			; adresa druheho retazca- es:di
	pop es
	mov di, offset str2
	xor cx,cx
	mov cl,[ds:si+1]		; pocet znakov
	add cx,2
	cld				; clear direction flag, si a di sa ++
repe	cmpsb				; porovnavaj pokym cx<>0 a ZF=1	
	jne rozne			; su vsetky znaky rovnake?
	push seg info0			; ak ano, pis info
	pop ds				; "retazce su totozne"
	mov dx,offset info0
	call pisret
	jmp porkon
rozne:	push seg err0			; inak pis chybu
	pop ds				; "retazce nie su totozne"
	mov dx,offset err0
	call pisret
porkon:	push seg nr			; odriadkovanie
	pop ds
	mov dx,offset nr
	call pisret
	ret
porovnanie endp

hladaj proc				; PROCEDURA PRE HLADANIE PODRETAZCA
        push seg podr			; adresa podretazca- ds:si
        pop ds
        mov si,offset podr
	xor cx,cx
	xor bx,bx
	mov bl,[ds:si+1]		; dlzka podretazca
	mov cl,[es:di+1]		; dlzka retazca
	push di				; odlozenie adresy retazca
	add di,2			; preskocenie 2 bajtov
	add si,2			; - presun priamo na retazec
	mov al,[ds:si]			; al <- prvy znak podetazca
skok4:	cld
repne	scasb				; hladanie prveho pismena
	je skok1			; ak nebolo najdene
	mov ax,0			; procedura vrati v ax 0
	jmp hlkon
skok1: 	inc cx
	cmp cx,bx			; je zvysok retazca < dlzka podretazca?
	dec cx
	jnl skok3			; nie, pokracuj
	mov ax,0			; ano - skonci
	jmp hlkon
skok3:	dec di				; vratenie sa na prve pismeno
	mov dx,cx			; odlozenie counteru
	mov cx,bx			; opakovanie pre dlzku podretazca
	repe cmpsb			; porovanavaj podretazec s retazcom
	je skok2			; ak su rovnake, skonci
	mov si,offset podr		; inak sa nastav na zaciatok podretazca
	add si,2
	pop di				; natiahni adresu retazca
	push di
	xor cx,cx
	mov cl,[es:di+1]		; skoc na miesto kde sme predtym
	add di,cx			; prestali
	sub di,dx
	add di,2
	mov cx,dx			; vrat hodnotu countera
	jmp skok4			; a dalej hladaj 1. pismeno podretazca
skok2:	mov ax,1			; ax<-1 - podretazec bol najdeny
hlkon:  pop bx
	ret
hladaj endp

podretazec proc				; ZISTOVANIE VYSKYTU PODRETAZCA
        push seg zadaj3                 ; "Zadaj hladany podretazec"
        pop ds
        mov dx,offset zadaj3
        call PisRet
        mov ah,0ah                      ; nacitanie retazca
        push seg podr
        pop ds
        mov dx, offset podr
        int 21h				; sluzba dosu-citaj retazec
	push seg nr			; odriadkovanie
	pop ds
	mov dx,offset nr
	call pisret
        push seg str1			; ulozenie str1 do ds:si
        pop es
        mov di, offset str1
        add di,10
	call hladaj			; procedura pre hladanie podretazca
	push ax
	cmp ax,0			; naslo podretazec?
	je try2				; nie, skus druhy retazec
	push seg info2a			; ano, vypis "nasiel som v prvom"
	pop ds
	mov dx,offset info2a
	call pisret
	push seg nr
	pop ds
	mov dx, offset nr
	call pisret
try2:	push seg str2			; ulozenie str2 do ds:si
	pop es
	mov di,offset str2
	call hladaj			; hladanie podretazca
	cmp ax,0			; naslo?
	jne pnav1			; ano, vypis info
	pop ax				; nie, zisti ci naslo v prvom
	cmp ax,0
	jne podkon			; ak nie, vyypis
	push seg err1			; "podretazec nenajdeny"
	pop ds
	mov dx,offset err1
	call pisret
	jmp podkon
pnav1:	pop ax				; vypis "nasiel som v druhom"
	push seg info2b			
	pop ds
	mov dx,offset info2b
	call pisret
podkon:	push seg nr			; odriadkovanie
	pop ds
	mov dx,offset nr
	call pisret
	ret
podretazec endp

start:					; ZACIATOK PROGRAMU
	call GetStr			; nacitanie retazcov
	call Posun			; posunutie prveho retazca o 10 byteov
	call Porovnanie			; porovnanie retazcov
	call podretazec			; hladanie podrtazca v retazcoch
	mov ax,4c00h			; ukoncenie programu
	int 21h
code	ends
end	start
; System:
; Dany program bol kompilovany v programovom prostredi Turbo Assembler v2.02,
; v systeme MS Dos 5.0. V tomto prostredi nevykazoval ziadne problemy, program
; fungoval spravne. Vzhladom na pouzite zakladne instrukcie procesora rady 
; 80x86, by mal program fungovat na lubovolnom PC kompatibilnom systeme.
; Obmedzenia programu:
; Maximalna dlzka zadavanych retazcov je obmedzena na 50 znakov. Rovnake 
; obmedzenie ma aj hladany retazec. Program nema ziadne ine obmedzenia.
; Moznosti vylepsenia:
; Zvacsenie obmedzenia dlzky zadavanych retazcov, volba porovnania/hladania
; podretazca/ukoncenia programu pomocou uzivatelskeho menu. Dalsimi moznymi
; vylepseniami su opatovne zadavanie retazcov, opakovane hladanie roznych
; podretazcov, vypis polohy podretazca, ak bol najdeny, atd..