;Zadanie c.1.
;Uloha: Napiste program, ktory nacita z klavesnice retazec znakov
;        (max.100 znakov) a podla  menu vykona  jednu z moznosti:
;       1) vypise retazec znakov na obrazovku
;       2) vypise poradove miesto uzivatelom zadaneho znaku 
;       3) najde znak s min hodnotou
;       4) vypise pocet cislic v retazci
;       5) male pismena konvertuje na velke
;       6) zarovna text zprava 
;       7) ukonci vykonavanie programu.
;       Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;
;
;Autor: Ladislav Klenovic
;rocnik: 2.
;sk.rok 2000/2001

zas segment stack 'stack'
  dw 64 dup (?)
zas ends

data     segment
Menu     db      0dh,0ah,'Vyber:',0dh,0ah
         db      '1 - Vypis retazca na obrazovku',0dh,0ah
         db      '2 - Najdi znak v retazci',0dh,0ah
         db	 '3 - Najdi znak s min hodnotou',0dh,0ah
         db      '4 - Zistenie poctu cislic v retazci',0dh,0ah
	 db 	 '5 - Konvertovanie malych pismen na velke',0dh,0ah
	 db 	 '6 - Zarovnanie textu z prava',0dh,0ah 	
         db      '7 - Koniec',0dh,0ah,'$'

Retazec  db      101                                 ;maximalny pocet znakov 
pocet    db      ?                                   ;pocet nacitanych znakov
R        db      103 dup (?)                         ;dane znaky (3 znaky na novy riadok a '$')
Rvelke   db      103 dup (?)                         ;pom pole znakov pouzivane pri bode '5'
NR       db      0dh,0ah                             ;novy riadok
Koniec   db      '$'                                 ;koniec vypisovania na obrazovku
Buffer   db      3 dup (?),0dh,0ah,'$'                 ;pre vypis cisiel
Vypis    db      0dh,0ah,'Zadany retazec je:$'
Cisl     db      0dh,0ah,'Pocet cislic v retazci je:$'
PorCis   db      0dh,0ah,'Prvy vyskyt znaku v retazci je na poradovom mieste:$'
Upper    db      0dh,0ah,'Konvertovany retazec ma tvar:$'
vypis_m  db	 0dh,0ah,'Znak s minimalnou hodnotou je:$'
Vyzva    db      'Zadaj retazec',0dh,0ah,'$'
Znak     db      0dh,0ah,'Zadaj hladany znak',0dh,0ah,'$'
Chyba    db      0dh,0ah,'V retazci sa dany znak nenachadza',0dh,0ah,'$'
Chyba2   db      0dh,0ah,'Co keby si zadal ciclo od 1 do 7?',0dh,0ah,'$'
data     ends

code     segment
start:   assume      ds:data,cs:code,ss:zas,es:data
         mov         ax,seg data        ;inicializacia DS registra
         mov         ds,ax
         mov         es,ax              ;pomocny

         mov         dx,offset Vyzva    ;vypise 'Zadaj retazec ...'
         mov         ah,09h             ;sluzba na vypis retazca
         int         21h

         mov         dx,offset Retazec  ;nacita dany retazec (max 100 znakov) a
         mov         ah,0Ah             ;do druheho bytu vrati pocet nacitanych
         int         21h                ;znakov

         mov         dx,offset NR       ;prida novy riadok
         mov         ah,09h
         int         21h

@menu:   mov         dx,offset Menu     ;vypise menu na obrazovku
         mov         ah,09h
         int         21h

qq:      mov         ah,01h             ;nacita znak do registra al
         int         21h

         cmp         al,'1'             ;Zisti, ci nacitany znak v registri al je 'A' alebo 'a'.
         jz          @vypis             ;ak sa rovna tak skoc na @vypis  
	 jnz	     @1

@vypis:  xor         cx,cx              ;prida do retazca 0dh,0ah,'$'
         xor         si,si              ;vynulovanie si,cx
         mov         cl,pocet           ;prirad do cl,pocet
         mov         si,cx              ;prirad do si,cl
         mov         [r+si],10          ;na r+si prida '0dh'
         inc         si                 ;inkrementuje si o byte
         mov         [r+si],13          ;na r+si prida '0ah'
         inc         si                 ;inkrementuje si
         mov         dl,koniec          ;do reg dl<-'$'
         mov         [r+si],dl          ;na r+si<-dl
                                                 
         mov         dx,offset Vypis    ;vypise 'zadany retazec je'
         mov         ah,09h
         int         21h

         mov         dx,offset R        ;vypise dany retazec
         mov         ah,09h
         int         21h
         jmp         @menu              ;vrati sa do menu

@1:      cmp         al,'2'             ;Zisti, ci nacitany znak v registri al je 'B' alebo 'b'
         jz          @znak
	 jnz	     @2

@znak:   mov         dx,offset Znak     ;vypise zadaj znak
         mov         ah,09h
         int         21h
         mov         ah,01h             ;nacita znak do reg al
         int         21h

         xor         si,si              ;zisti poradove cislo daneho znaku
         dec         si                 ;decrementuj si
         xor         cx,cx              ;vynulovanie cx
         mov         cl,pocet           ;cl<-pocet

@slucka: inc         si             ;cyklus pre prehladavanie retazca
         cmp         [R+si],al      ;porovna obsah kam ukazuje pointer [R+si] s reg al
         jnz         @loop          ;cyklus
         jmp         @skok          ;nepodmieneny skok
@loop:   loop        @slucka

         jmp         @Chyba         ;nepodmieneny skok na navestie @chyba

@skok:   mov         ax,si          ;ak sa znak nachadza vypise poradove cislo
         inc         ax             ;inkrementuje ax o 1
         mov         si,3           ;si<-3
@slucka2:dec         si             ;prevod poradoveho cisla z reg ax do bufferu
         mov         bx,10          ;bx <-10 co je zaklad sustavy
         xor         dx,dx          ;vynulovanie dx
         div         bx             ;delenie
         mov         di,dx          ;do di<-dx
	 add 	     dl,30h         ;pricitame dl<-'0'
         mov         [buffer+si],dl ;na buffer+si priradi obsah dl
         and         ax,ax          ;logicky sucin
         jnz         @slucka2        
    
         mov         dx,offset PorCis ;samotny vypis poradoveho cisla
         mov         ah,09h
         int         21h

         mov         dx,offset buffer
         mov         ah,09h
         int         21h

         jmp         @menu           ;navrat do menu

@Chyba:  mov         dx,offset Chyba
         mov         ah,09h
         int         21h
         jmp         @menu           ;navrat do menu

@2:      cmp         al,'3'             ;Zisti, ci nacitany znak v registri al je 'C' alebo 'c'
         jz          @minim
	 jnz	     @3

@minim:  mov         dx,offset vypis_m ;vypise 'znak s minimalnou hodnotou je'
         mov         ah,09h
         int         21h
        
	 xor         cx,cx   
	 xor 	     ax,ax	        
         mov 	     cl,pocet
         mov         bx,offset R
	 mov         dl,[bx]
         dec         cl    	          

@slucka3:		              	;prehladavanie retazca
         cmp         dl,[bx]
         jb	     @pminim
         mov         dl,[bx] 
@pminim: inc         bx
         loopne      @slucka3
         mov         ah,02h
         int         21h
         jmp         @menu

@3:      cmp         al,'4'             ;Zisti, ci nacitany znak v registri al je 'D' alebo 'd'
         jz          @cisla
	 jnz	     @4

@cisla:  xor         cx,cx             ;zisti pocet cislic v retazci
         mov         cl,pocet          ;nastavanie parametrov pre slucku
         xor         si,si
         dec         si
         xor         bx,bx
@slucka4:inc         si                ;samotna slucka ktora to zistuje
         cmp         [R+si],30h
         jb          @loop2
         cmp         [R+si],39h
         ja          @loop2
         inc         bx                ;pocet cislic ide do registra bx
@loop2:  loop        @slucka4
         mov         dx,offset Cisl    ;vypise 'Pocet cislic v retazci je:'
         mov         ah,09h
         int         21h

         mov         ax,bx
         mov         si,3
@slucka6:dec         si             ;prevod cisla z reg ax do bufferu
         mov         bx,10
         xor         dx,dx
         div         bx
         mov         di,dx
	 add	     dl,30h
         mov         [buffer+si],dl
         and         ax,ax
         jnz         @slucka6

         mov         dx,offset Buffer   ;vypise pocet cisiel v retazci
         mov         ah,09h
         int         21h

         jmp         @menu              ;spat do menu

@4:      cmp         al,'5'             ;Zisti, ci nacitany znak v registri al je '5'
         jz          @upcase
	 jnz	     @5
@upcase: 
	mov dx,offset R			;dx->retaz
	mov si,dx
	mov bx,offset Rvelke		;bx->upcs
	xor ax,ax
	xor cx,cx	
	mov cl,pocet			;pocet opakovani = dlzka retazca
@loop4:	
	mov al,[si]
	cmp al,60h
	jbe @dal			;ak al<=60h goto @dal
	cmp al,7Bh
	jnb @dal			;ak al>7bf goto @dal
	sub al,20h			;odcita 20h (konvert male na VELKE)
@dal:
	mov [bx],al	
	inc si				;zvacsime index retazca
	inc bx
	loopne @loop4
	mov byte ptr[bx],'$'
        mov dx,offset upper
        mov ah,09h
        int 21h
	mov dx,offset Rvelke
	mov ah,09h
	int 21h
	mov dx,offset NR
	mov ah,09h
	int 21h
        jmp @menu                       ;navrat do menu       

@5:      cmp         al,'6'             ;Zisti, ci nacitany znak v registri al je 'F' alebo 'f'
         jz          @zarov1
  	 jnz	     @6
       
@zarov1: 

        mov dx,offset NR		;vypis NR
	mov ah,09H			;vypis retazca	
	int 21H                         ;interupt

	xor cx,cx                       ;vynulovanie cx
	xor ax,ax                       ;vynulovanie ax
	mov al,80                       ;al<-80
	sub al,pocet                    ;al<-al-pocet
	mov cx,ax                       ;cx<-ax
@za1:
	mov dl,' '                      ;vypise znak ' ' 80-pocet krat
	mov ah,2                        ;vypis znaku
	int 21h                         
	loopne @za1

	xor cx,cx                       ;vynulovanie cx
	mov cl,pocet                    ;cl<-pocet
	mov bx,2                        ;bx<-2

@za2:
	mov dx,offset [Retazec+bx]      ;vypisu sa znaky az od 3 znaku
	mov ah,02H
	int 21H
	inc bx
	loopne @za2


  
         jmp         @menu           ;vrati sa do menu

@6:      cmp         al,'7'             ;Zisti, ci nacitany znak v registri al je 'Q' alebo 'q'
         jz          @koniec
	 mov         dx,offset Chyba2
         mov         ah,09h
         int         21h
         jmp         qq              ;skok na qq (zase vsetko od znova)

@koniec: mov         ax,4c00h        ;ukoncenie programu
         int         21h             

code     ends
         end         start

;ZHODNOTENIE
;-na volanie sluzieb dosu som pouzil interupt INT 21h
;-obmedzenia: ak zadame znak $ tak sa vypisu znaky len po tento znak
;-v programe je pouzita funkcia loopne( ukonci cyklus ked je splnena 
; podmienka napr. pocet opakovani sa uz rovna poctu znakov v retazci
; a priznakovy register;lepsie by bolo pouzit iba funkciu loop,ktora 
; implicitne pracuje registrom cx a netestuje ziadny priznakovy register   
;-program bol napisany pre jazyk asembler
; programe sa niektre casti opakuju,preto by bolo vyhodne vyuzit volanie 
; podprogramu