;Vypracoval:Lubos Martinkovic
;Kruzok:B11
;Uloha:Urobte program,ktory roby nasledovne operacie so zadanim retazcom:
;a) Vypise retazec na obrazovku,
;b) Vypise poradove cislo prvej medzeri,
;c) Vypise pocet vyskytu zadaneho znaku v retazci
;d) Najde znak s maximalnou hodnotou
;e) Zarovna cely retazec z lava
;f) Vypise obrateny retazec
;g) Ukoncenie programu

;*****************************RIESENIE************************************
;* Dany program ma nasledovne obmedznia na vstupny retazec:              *
;* 1.Maximalny pocet pismen je 100                                       *
;* 2.V retazci sa nesmie vyskytovat znak $                               * 
;*   (po tomto znaku za retazec usekne)                                  *
;*************************************************************************

ZAS     SEGMENT STACK

		DW      64 DUP(?)
ZAS     ENDS

DATA    SEGMENT
TEXT1    	 DB      'Vypis retazsca na obrazovku:   1)',10,13
		 DB      'Poradove cislo prvej medzeri:  2)',10,13
		 DB      'Zistenie poctu znaku v retazci:3)',10,13
		 DB      'Najdenie znaku s max hodnotou: 4)',10,13
		 DB      'Zarovnanie z lava:             5)',10,13
		 DB      'Vypis obrateneho retazca:      6)',10,13
		 DB      'KONIEC:                        k)$'
TEXT2    DB      'Zadaj retazec:$'
TEXT3	 DB	 'Pozicia prvej medzeri je:$'
TEXT4	 DB	 'Zadaj znak:$'
TEXT5    DB	 'Zadany znak za v retasci nachadza tolkoto krat:$'
TEXT6    DB	 'Znak s maximalnou hodnotou je:$'
TEXT7    DB      'Vstupny  retazec:$'
TEXT8    DB	 10,13,'Vystupny retazec:$'
VSTUP    DB      101
VYSTUP   DB      101 DUP(0)
VYSTUP2  DB      101 DUP(0)
DATA    ENDS
CODE    SEGMENT
		ASSUME  CS:CODE, DS:DATA,SS:ZAS

START:
NACIT:  MOV AX,SEG DATA
		MOV DS,AX               ;INICIALIZACI DS
		MOV DX,OFFSET TEXT2
		MOV	AX,3
		INT	10H		;VYMAZANIE OBRAZOVKY
		MOV AH,09H              ;VYPIS TEXT2
		INT 21H
		MOV DX,OFFSET VSTUP
		MOV AH,0AH              ;NACITNIE RETAZCA
		INT 21H
		ADD DX,2
		MOV SI,DX
		MOV BH,0
		MOV BL,BYTE PTR [SI-1]
		MOV BYTE PTR [BX+SI],'$'      ;UKONCENIE RETAZCA

MENU:   MOV DX,OFFSET TEXT1
		MOV	AX,3          	      ;VYMAZANIE OBRAZOVKY
		INT	10H
		MOV AH,09H                    ;VYPIS NA OBRAZOVKU
		INT 21H
		MOV SI,DX
		MOV AH,1                      ;NACITAVANIE ZNAKOV NA VYBER
		INT 21H                       ;Z MENU
		   CMP AL,'1'                 ;AK SA ZNAK ROVNA SKOCI N PRISLUSNE NAVESTIE
			   JE VYPIS
			  JMP TEST1
VYPIS:  MOV	AX,3                           ;VYMAZANIE OBRAZOVKY
		INT	10H
		MOV DX,OFFSET TEXT7
		MOV AH,09H
		INT 21H
		MOV DX,OFFSET VSTUP           ;NASTVENIE ADRESY
		ADD DX,2                      ;PRESKOCENIE ZAKONCONACICH ZNKOV
		MOV AH,09H                    ;VYPIS
		INT 21H
		MOV AH,1
		INT 21H			      ;CAKA NA SLACENIE KLAVESY
		JMP MENU                      ;NAVRAT DO MENU

TEST1:          CMP AL,'2'
		JE POZIC
			   JMP TEST2

POZIC:  MOV	AX,3                      ;VYMAZANIE OBRAZOVKY
		INT	10H
		MOV DX,OFFSET VSTUP
		ADD DX,2
		MOV SI,DX
		XOR AX,AX                     ;VYNULOVANIE AX
		XOR DX,DX                     ;VYNULOVANIE DX
		INC DX
		MOV CH,0
		MOV CL,[SI-1]		      ;POCET ZNAKOV RETAZCA	
POROV:  MOV AL,[SI]
		CMP AL,' '                    ;POROVNANIE
		JE  DOST                      ;AK TO JE MEDZERA TAK SKOCI
		INC SI                        ;DALCI ZNAK
		INC DX                        ;POZICIA
		LOOPNE  POROV
DOST:   	MOV AX,3		      ;VYMAZANIE OBRAZOVKY
		INT 10H
		MOV CX,DX
		MOV DX,OFFSET TEXT3	      ;VYPIS TEXT3		
		MOV AH,09H
		INT 21H
		JMP KOREKC                    ;SKOCI NA FUNKCIU KOREKCIE
					      ;VYPISOVANIA CISEL

TEST2:          CMP AL,'3'
		JE NAJDI
		   JMP TEST3

NAJDI:  MOV	AX,3                      ;VYMAZANIE OBRAZOVKY
		INT	10H
		MOV DX,OFFSET VSTUP
		ADD DX,2
		MOV SI,DX                     ;NASTAVENIE SI N KONIEC VSTUPU(ZACIATOK VYSTUPU)
		XOR CX,CX                     ;VYNULOVANIE CX
		MOV DX,OFFSET TEXT4           ;VOLANIE TEXTU
		MOV AH,09H                    ;VYPIS
		INT 21H
		MOV AH,08                      ;NACITANIE HLADANEHO ZNAKU
		INT 21H
		XOR DX,DX		      ;NULOVANIE REGISTROV
		MOV CH,0
		MOV BH,0
                MOV CL,[SI-1]                 
ZNOVU:  MOV BL,[SI]
		CMP AL,BL                     ;POROVNAVANIE
		JNE  PRESKOC
		INC DX                        ;POSET VYSKYTU
PRESKOC:        INC SI                        ;DALSI ZNAK RETAZCA
		LOOPNE ZNOVU
		MOV CX,DX
		MOV AX,3                      ;VYMAZANIE OBRAZOVKY
		INT 10H
		MOV DX,OFFSET TEXT5           ;VOLANIE TEXTU
		MOV AH,09H                    ;VIPIS
		INT 21H
		JMP KOREKC                    ;SKOK NA KOREKCIU VYPISOVANIA CISEL



TEST3:          CMP AL,'4'
		JE MAX
		   JMP TEST4

MAX:	MOV	AX,3                      ;VYMAZANIE OBRAZOVKY
        INT 10H
		MOV DX,OFFSET VSTUP
		ADD DX,2
		MOV SI,DX                     ;NASTAVENIE SI
		MOV BH,0		      ;NULOVANIE REG.
		MOV AH,0
		MOV CH,0                     ;VYNULOVNIE CH
		MOV CL,[SI-1]                ;POCET ZNAKOV

		MOV BL,[SI]                   ;DO AL SA DA PRVY(NULTY) ZNAK
OPAK2:	MOV AL,[SI+1]                 ;DO BL SA DA DRUHY(PRVY) ZNAK
		CMP AL,BL                     ;POROVNNIE AL S BL
		JBE VACSY                      ;AK JE AL VACSY SKOCI NA VACSY
		MOV BL,AL                     ;INAK SA BL(VACSY) ZAPISE DO CX
VACSY:  INC SI                        ;DALSY ZNAK
		LOOPNE OPAK2
		MOV AX,3                   ;MAZANIE OBRAZOVKY
		INT 10H
		MOV DX,OFFSET TEXT6          ;VOLANIE TEXTU
		MOV AH,09H                    ;VYPIS
		INT 21H
		XOR DX,DX
		MOV DL,BL
		MOV AH,02H                      ;VYPIS ZNAKU
		INT 21H
		MOV AH,1                      ;CAKA NA STLACENIE KLAVESY
		INT 21H
		JMP MENU                      ;NAVRAT DO MENU


TEST4:        CMP AL,'5'
				JE ZAROV
			   JMP TEST5

ZAROV: MOV AX,3				   ;VYMAZANIE OBRAZOVKY
		INT 10H
		MOV DX,OFFSET VSTUP		   ;VOLANIE ADRESY
		ADD DX,2
		MOV SI,DX			   ;NASTAVENIE SI NA ZACIATOK RET.
		MOV BX,OFFSET VYSTUP2		   ;VOLANIE VYSTUP2
		MOV CH,0
		MOV CL,[SI-1]                       ;POCET ZNAKOV
		MOV DX,BX
POSUN:	MOV AL,[SI]
		CMP AL,' '			   ;AK JE V AL MEDZERA ZOBERIE
		JE  POCIT			   ;NASLEDOVNY ZNAK
		JMP VON
POCIT:  INC SI
		DEC CX
		JMP POSUN
VON:	MOV AL,[SI]			   ;PREPISE VSTUP DO VYSTUPU BEZ
		MOV [BX],AL			   ;PRVYCH MEDZIER
		CMP AL,'$'			 ;PREPISUJE POKIAL NIE JE V AL $
		JE TDOST
		INC BX
		INC SI
		JMP  VON
TDOST:	MOV AX,3
		INT 10H                       ;VYMAZANIE OBRAZOVKY
		MOV DX,OFFSET TEXT7
		MOV AH,09H
		INT 21H				;VYPIS RETAZCA
		MOV DX,OFFSET VSTUP
		ADD DX,2
		MOV SI,DX
		MOV CH,0
		MOV CL,[SI-1]
		MOV AH,09H
		INT 21H
		MOV DX,OFFSET TEXT8
		MOV AH,09H
		INT 21H
		MOV DX,OFFSET VYSTUP2
		MOV AH,09H
		INT 21H
		MOV AH,08H                  ;CAKA NA STLACENIE KLAVESY
		INT 21H
		JMP MENU
	

TEST5:        CMP AL,'6'
		JE OBRAT
			   JMP TEST6

OBRAT:	MOV AX,3 			;VYMAZANIE OBRAZOVKY
		INT 10H
		MOV DX,OFFSET VSTUP         ;VOLANIE ADRESY
		ADD DX,2
		MOV SI,DX                   ;NASTVENIE SI
		MOV BX,OFFSET VYSTUP
		XOR CX,CX                   ;VYNULOVANIE CX
		MOV CL,[SI-1]
		ADD SI,CX                   ;NASTAVENIE NA POSLEDNY ZNAK
		MOV BX,SI
		DEC SI                      ;PRESKOCI UKONCOVACI ZNAK
		INC BX
		MOV DX,BX
NAV3:	MOV	AL,[SI]			;CYKLUS PRE SAMOTNU VYMENU
		MOV [BX],AL
		DEC SI
		INC BX
		LOOPNE	NAV3
		MOV AL,'$'		;RETAZEC SA UKONCI $
		MOV [BX],AL
		
		MOV AX,3
		INT 10H                       ;VYMAZANIE OBRAZOVKY
		MOV DX,OFFSET TEXT7
		MOV AH,09H
		INT 21H				;VYPIS RETAZCA
		MOV DX,OFFSET VSTUP
		ADD DX,2
		MOV SI,DX
		MOV CH,0
		MOV CL,[SI-1]
		MOV AH,09H
		INT 21H
		MOV DX,OFFSET TEXT8
		MOV AH,09H
		INT 21H
		MOV DX,OFFSET VYSTUP
		ADD SI,CX
		MOV DX,SI
		INC DX
		MOV AH,09H
		INT 21H
		MOV AH,08H                  ;CAKA NA STLACENIE KLAVESY
		INT 21H
		JMP MENU

TEST6:         CMP AL,'k'
		JE POM
			JMP MENU
POM :   JMP KONIEC

KOREKC:	CMP CX,100		       ;POROVNAVA CI JE POSET VYSKYTU STO
		JE STOX	      		;PRESKOCI NA STOX SA AK JE POCET CISLIC 100
		MOV AX,CX		;AK JE CISLO VACSIE AKO 9
		AAM	        ;PODELI AX 10 ADO AH DA VYSLEDOK,DO AL DA ZVYSOK
		XOR DX,DX			;VYNULUJE SA DX
                MOV DL,30H                            ;30H JE '0'
		ADD DL,AH
		PUSH AX					;ZALOHUJE AX
		MOV AH,02H
                INT 21H                                 ;VYPISE DESIATKY
                XOR DX,DX                             ;VYNULUJE SA DX
                MOV DL,30H                             ;30H JE '0'
                POP AX                               ;VYTIAHNE AX(KVOLI AL KDE JE ZVYSOK DELENIA
		ADD DL,AL
		MOV AH,02H
                INT 21H                     ;VYPISE JEDNOTKY
		MOV AH,1                    ;CAKA NA CTACENIE KLAVESY
		INT 21H
		JMP MENU                    ;NAVRAT DO MENU
STOX:	MOV DX,31H
		MOV AH,02H
		INT 21H			;VYPISE SA JEDNOTKA
		MOV DX,30H
		MOV AH,02H
		INT 21H			;VYPISE SA 0
		MOV DX,30H
		MOV AH,02H
		INT  21H		;VYPISE SA 0
		MOV AH,1                	;CAKA NA STLACENIE KLAVESNICE
		INT 21H
		JMP MENU                ;NAVRAT DO MENU



KONIEC: MOV AX,4C00H		;UKONCENIE PROGRAMU
		INT 21H
		MOV AH,4CH
		INT 21H
CODE    ENDS
		END   START

;*****************************Zhodnotenie****************************************
;Program je funkcny ak su splnene hore uvedene  podmienky.
;Na vipisovanie cisel som pouzil dekadicku korekciu csitavania AAM ,ktora
;podeli cislo v AX  10.Do AH da celociselny vysledok po deleni a do AL da
;zvisok.To mi umoznuje korektne vypisovanie cisel vascich ako 10.Ak si dam
;napr. do DH 30h(co je 0) pripocitam hodnotu v AH(desiatky) potom mam v DH
;korektnu hodnotu desietok daneho cisla.Tuto hodnotu necham vypisat a hned
;zanou vypisem po podobnej priprave jednotky.
;Pri realizacii som musel brat do uvahy ,ze vsetky  podmienene skoky su  len
;blizke a kratke.Preto sa v rograme vyskituje podnieneny skok ,ktory skase
;na navastie kde je skok nepodmieneny(daleky),a az ten skace na potrebne navastie.
;*********************************************************************************
