;Zadanie c.2
;Text zadania:
;Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
;(aspon 10) so znamienkom v desiatkovej ciselnej sustave, potom ich
;transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom kode
;a potom podla priania pouzivatela:
;a) vypocita sumu vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne a zapise usporiadanu postupnost
;cisel do noveho textoveho suboru,
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.
;
;Na pracu so subormi mozete pouzit napr. sluzby 3dH, 3eH, 3fH,40H.
;Vysledky operacii treba vypisovat v desiatkovej ciselnej sustave.
;Ak by pri  vypocte doslo k preteceniu, oznamte prekrocenie pripustneho
;ciselneho rozsahu.
;Autor: Lubos Martinkovic
;Termin odovzdania: 14.11.2000
;2.roc.,sk.rok 2000/2001
;
zas segment stack;zasobnik
	dw 1000 dup(?)
zas ends
DATA SEGMENT
vstups 	  	db 'vstup.txt',0        ; definicia suboru
nacitane 	db  100 dup(?)         ; tu sa bude ukladat citany subor
vystups   	db 'vystup.txt',0
pomoc		dw 100 dup(?)
pocet	    db 0                    ;pocet cisel
posun	    dw 2 dup(0a0dh)         ;2 entery pre zapis do vystupneho suboru
pomvyst 	db 1000 dup(?)
text	  	db 'bol nacitany subor$'
ztext1  	db 'Vzostupne usporiadane cisla:',0dh,0ah,'$'
text2  		db 'Zadana uloha nema zmysel$'
vtext1	    db 'Vyber prve cislo',0dh,0ah,'$';retazce pouzite pri vybere
vtext2	    db 'Vyber druhe cislo',0dh,0ah,'$';cisiel v procedure vybcis
dtext1	    db 'Podiel cisel $'
ntext1		db 'Sucin cisel $'
ntext2		db 'Vysledok nie je v rozsahu <-32767,32767>$'
dntext1		db ' sa rovna$ '
vschyba	    db 'Boli zadane cisla mimo rozsahu <-32767,32767>$'
atext   	db 'Suma vsetkych cisel je $'
atext1	    db 'Suma vsetkych cisel nie je v rozsahu <-32767,32767>$'
menu1		db 'Suma vsetkych cisel:  1)',10,13
			db 'Vypis cisel vzostupne:2)',10,13
			db 'Delenie:              3)',10,13
			db 'Nasobenie:            4)',10,13
			db 'KONIEC:               k)$'
DATA ENDS
CODE SEGMENT
ASSUME CS:code,ds:data
start:  mov ax,seg data
	mov ds,ax
	mov ah,3dh              ; otvor subor
	mov al,0                ; na citanie
	mov dx,offset vstups     ; je to subor vstup.inc
	int 21h
	mov dx,offset nacitane ; bude sa ukladat do pameti
	mov cx,1                ; po jednom znaku
	mov bx,ax               ; do bx daj handler otvoreneho suboru
citaj:	mov ah,3fh              ; citaj subor
	int 21h
	inc dx	                ; priprav adresu pre ulozenie dalsieho
								; znaku do pameti 'precitane'
	cmp ax,0                ; bol EOF?
	jne citaj		; ak nie, citaj dalsi znak zo suboru
	mov ax,3		;vymazanie obrazovky
	int 10h
	mov dx,offset text      ; kontrola precitaneho suboru
	mov ah,9
	int 21h
	mov ah,08h              ;caka na stlac. klavesy
	int 21h


prevod:                                 ;prevod nacitanych znakov na cisla
	mov dx,offset nacitane;
	mov si,dx
	mov cx,ax                              ;cx=pocet nacitanych bytov
	mov di,offset pomoc
cyk:	mov al,[si];                       al=nacitany znak
	inc si
	dec cx
	cmp al,'-'
	je navp;		al='-'
	cmp al,'0'
	jb navp1;	al<'0'
	cmp al,'9'
	ja navp1;	al>'9'
	jmp navp
navp1:	cmp cx,0;	test ci nebol citany posledny znak
	jne cyk
	jmp menu
navp:	mov bp,1
	cmp al,'-'
	jne navp2
	cmp cx,0
	jne navp3;'-' nie je posledny znak ?
	jmp menu
navp3:	mov bp,0ffffh;ak bp=0ffffh tak je cislo zaporne
	mov al,[si]
	inc si
	dec cx
	cmp al,'0'
	jb navp4;	al<'0'
	cmp al,'9'
	ja navp4;	al>'9'
	jmp navp2
navp4:	jmp menu
navp2:	and ax,0fh            ;al bude v bcd kode
	push ax
	mov ax,[di]
	mov dx,10
	imul dx                    ;	dx&ax=10*[di]
	jo navp5                   ; ak nastalo preplnenie
	mov [di],ax
	pop ax
	add [di],ax
	jo navp5                     ; ak nastalo preplnenie
	cmp cx,0
	je navp6; ak bol citany posledny znak
	mov al,[si];nacita dalsi znak
	inc si
	dec cx
	cmp al,'0'
	jb navp7
	cmp al,'9'
	ja navp7	;test ci je to cislica
	jmp navp2
navp5:	mov ah,3eh           ;nastalo preplnenie lebo velke vstupne cisla
	mov bx,offset vstups
	int 21h                  ;zatvorenie vstupneho suboru
	mov ah,3eh
	mov bx,offset vystups
	int 21h                  ;zatvorenie vystupneho suboru
	mov ax,3
	int 10h                  ;vymaze obrazovku
	mov dx,offset vschyba
	mov ah,09h
	int 21h                   ;oznam chyby
	mov ah,08h
	int 21h                   ;caka na klavesu
	mov ax,4c00h
	int 21h                   ;koniec s chybou
navp6:	inc byte ptr [pocet]  ;zvysi pocet cisel | bol citany posledny znak
	mov dx,bp
	mov ax,[di]
	imul dx
	mov [di],ax
	ret
navp7:	inc byte ptr [pocet]    ;zvysi pocet cisel
	mov dx,bp
	mov ax,[di]
	imul dx                     ;dx&ax=bp*[di] | bp urcuje znamienko
	mov [di],ax
	add di,2                    ;di nastavene na buduce binarne cislo
	jmp navp1



 menu: mov dx,offset menu1
		mov ax,3          	      ;vymazanie obrazovky
		int 10h
		mov ah,09h                    ;vypis na obrazovku
		int 21h
		mov si,dx
		mov ah,1                      ;nacitanie znakov na vyber
		int 21h                        ;z menu

		cmp al,'1'                 ;ak sa znak rovna skoci na prislusne
		je suma							   ;navestie
		jmp test1

suma:push ax
	mov ax,3
	int 10h;vymaze obrazovku
	mov ah,09h
	mov dx,offset atext
	int 21h;vypis uzivatelovi
	mov cx,word ptr [pocet]
	xor ch,ch                             ;	cx=pocet cisel
	mov bx,offset pomoc                   ;bx ukazuje cisla
	xor ax,ax
nava1:	add ax,[bx]
	jo nava2                              ;ak pretecenie
	add bx,2
	loopne nava1
	call vypisax                          ;zobrazi cislo v ax
	mov ah,08h
	int 21h;caka na klavesu
	pop ax
	jmp menu
nava2:	mov ax,3                          ;pri preteceni
	int 10h                               ;vymaze obrazovku
	mov ah,09h
	mov dx,offset atext1
	int 21h                               ;oznam o preplneni
	mov ah,08h
	int 21h                               ;caka na klavesu
	mov ax,4c00h
	int 21h                               ;koniec programu

vypisax proc                               	;ax=zobrazovane cislo
	push ax
	push bx
	push dx
	push cx
	push bp
	mov bp,0
	mov bx,ax
	and bx,8000h
	jz vypi1                    ;	ci nie je nastaveny znamienkovy bit
	mov bx,0ffffh
	imul bx                     ;	ax:=ax*(-1)
	push ax
	mov ah,2
	mov dl,'-'
	int 21h                     ;zobrazi znak minus
	pop ax
vypi1:	mov dx,0
	mov cx,10000
	div cx                       ;ax/10000 ->dx=zvysok | ax=podiel
	push dx
	cmp al,0
	jz vypi2                     ; skok aby sa nezobrazila lavostranna nula
	mov bp,0ffffh                ; oznacenie ze dalsie nuly nie su lavostranne
	mov dl,al
	or dl,30h;dl=ascii cisla
	mov ah,02h
	int 21h                       ;zobrazenie radu 10000
vypi2:	pop ax                    ;vyzdvihnutie zvysku
	mov dx,0
	mov cx,1000
	div cx                         ;zvysok/1000 ->dx=zvysok | ax=podiel
	push dx
	or bp,ax
	jz vypi3                      ;skok aby sa nezobrazila lavostranna nula
	mov bp,0ffffh                 ;oznacenie ze dalsie nuly nie su lavostranne
	mov dl,al
	or dl,30h                     ;dl=ascii cisla
	mov ah,02h
	int 21h                       ;zobrazenie radu 1000
vypi3:	pop ax                     ;vyzdvihnutie zvysku
	mov dx,0
	mov cx,100
	div cx                         ;zvysok/100 ->dx=zvysok | ax=podiel
	push dx
	or bp,ax
	jz vypi4                       ;skok aby sa nezobrazila lavostranna nula
	mov bp,0ffffh                  ;oznacenie ze dalsie nuly nie su lavostranne
	mov dl,al
	or dl,30h
	mov ah,2
	int 21h                      ;zobrazenie radu 100
vypi4:	pop ax                   ;ax<100
	aam                           ;ax deli 10 ->ah=podiel | al=zvysok
	push ax
	mov dl,ah
	xor dh,dh
	or bp,dx
	jz vypi5                     ;skok aby sa nezobrazila lavostranna nula
	or dl,30h
	mov ah,2
	int 21h                        ;zobrazi 10. rad zobrazovaneho cisla
vypi5:	pop ax
	mov dl,al
	or dl,30h                     ;dl=ascii cisla
	mov ah,2
	int 21h                     ;zobrazenie radu jednotiek zobrazovaneho cisla
	pop bp
	pop cx
	pop dx
	pop bx
	pop ax
	ret
vypisax endp

test1: cmp al,'2'
		je zorad
		jmp test2

zorad:
	push ax
	mov ax,3
	int 10h ;vymaz obrazovky
	mov dx,offset ztext1
	mov cx,30
	mov bx,offset vystups
	mov ah,40h
	int 21h           					;zapis komentaru do suboru
	mov ah,9
	mov dx,offset ztext1
	int 21h                				;zobrazenie zpravy
	mov di,offset pomoc
	mov dx,word ptr [pocet]
	xor dh,dh							;dx=pocet cisel
	dec dx								;dx=pocet cisel-1
	cmp dx,0
	jg znav						;ak su tam aspon dve cisla ma vyznam pokracovat
	mov ax,3
	int 10h                        ;vymaze obrazovku
	mov ah,9
 	mov dx,offset ztext1
	int 21h                        ;vypis o nezmyselnosti ulohy
	mov ah,08h
	int 21h;caka na klavesu
	ret
znav:	mov bp,0
	mov cx,dx                       ;cx=dx=pocet cisel-1
	mov bx,2
znav1:	mov ax,[di+bx-2]
	cmp ax,[di+bx]
	jng znav3                          ; skok ak ax<=[di+bx]
	xchg ax,[di+bx]
	mov [di+bx-2],ax
	inc bp
znav3:	add bx,2
	loopne znav1
	cmp bp,0
	jz znav2; skok ak su cisla usporiadane
	jmp znav
znav2:inc dx                        ;zacietok pom
	mov cx,dx                       ;cx=dx=pocet cisel
	mov bx,di                       ;bx ukazuje na cisla
	mov si,offset pomvyst            ;si ukazuje na buffer
znav4:	mov ax,[bx]
	push bx
	call vypisax                   ;zobrazenie cisla na obrazovku
	call tranax                   ;ulozenie cisla do transformatora
	mov ah,2
	mov dl,'	'
	int 21h                        ;zobrazenie medzery
	mov byte ptr [si],'	'          ;zapisanie medzery do bufferu
	inc si
	push cx
	mov ah,3
	mov bh,0
	int 10h                        ;zistenie pozicie kurzoru
	cmp dl,60
	jb znav5                       ;skok ak kurzor nie je pri konci riadku
	mov ah,2
	mov dl,0dh
	int 21h
	mov ah,2
	mov dl,0ah
	int 21h                         ;prechod na novy riadok na monitore
	mov word ptr [si],0a0dh
	add si,2                        ;prechod na novy riadok v buffery
znav5:	pop cx
	pop bx
	add bx,2
	loopne znav4
	mov dx,offset pomvyst
	sub si,dx
	mov cx,si
	mov ah,40h
	mov bx,offset vystups
	int 21h                          ;zapis do vystupneho suboru
	mov ah,8
	int 21h								;caka na klavesu
										;koniec pom
	mov cx,4
	mov dx,offset posun
	mov bx,offset vystups
	mov ah,40h
	int 21h                        ;zapis 2 enterov do vystupneho suboru
	pop ax
	jmp menu

tranax proc
	push ax
	push bx
	push dx
	push cx
	push bp
	mov bp,0
	mov bx,ax
	and bx,8000h
	jz trnav1                     ;	ci nie je nastaveny znamienkovy bit
	mov bx,0ffffh
	imul bx                       ;	ax:=ax*(-1)
	mov byte ptr [si],'-'         ;ulozenie '-' do bufferu
	inc si
trnav1:	mov dx,0
	mov cx,10000
	div cx                        ;ax/10000 ->dx=zvysok | ax=podiel
	push dx
	cmp al,0
	jz trnav2                      ; skok aby sa neulozila lavostranna nula
	mov bp,0ffffh                  ; oznacenie ze dalsie nuly nie su lavostranne
	or al,30h                      ;al=ascii cisla
	mov [si],al                    ;ulozenie cifry do 10000. radu do bufferu
	inc si
trnav2:	pop ax                     ;vyzdvihnutie zvysku
	mov dx,0
	mov cx,1000
	div cx                         ;zvysok/1000 ->dx=zvysok | ax=podiel
	push dx
	or bp,ax
	jz trnav3                       ;skok aby sa neulozila lavostranna nula
	mov bp,0ffffh                  ;oznacenie ze dalsie nuly nie su lavostranne
	or al,30h                      ;al=ascii cisla
	mov [si],al                    ;ulozenie cifry do 1000. radu do bufferu
	inc si
trnav3:	pop ax                     ;vyzdvihnutie zvysku
	mov dx,0
	mov cx,100
	div cx                        ;zvysok/100 ->dx=zvysok | ax=podiel
	push dx
	or bp,ax
	jz trnav4                     ;skok aby sa neulozila lavostranna nula
	mov bp,0ffffh                   ;oznacenie ze dalsie nuly nie su lavostranne
	or al,30h                    ;al=ascii cisla
	mov [si],al                  ;ulozenie cifry  100. radu do bufferu
	inc si
trnav4:	pop ax                    ;ax<100
	aam                           ;ax deli 10 ->ah=podiel | al=zvysok
	push ax
	mov dl,ah
	xor dh,dh
	or bp,dx
	jz trnav5                      ;skok aby sa neulozila lavostranna nula
	or dl,30h          				;prvod na ascii cisla
	mov [si],dl						;ulozenie cifry 10. radu do bufferu
	inc si
trnav5:	pop ax
	mov dl,al
	or dl,30h					;dl=ascii cisla
	mov [si],dl						;ulozenie cifry 1. radu do bufferu
	inc si
	pop bp
	pop cx
	pop dx
	pop bx
	pop ax
	ret
tranax endp

test2:cmp al,'3'
	   je delenie
	   jmp test3

delenie:                                 ;pouziva retazce dpror1,depror
	push ax
	call vyberc
	mov ax,3
	int 10h                                   ;vymaze obrazovku
	mov ah,9
	mov dx,offset dtext1
	int 21h                                    ;zobrazi spravu uzivatelovi
	mov ax,[si]
	mov cx,ax                                  ;cx=delenec
	call vypisax
	mov ah,2
	mov dl,' '
	int 21h                     				;zobrazi medzeru
	mov ax,[di]									;ax=delitel
	call vypisax									;zobrazenie delitela
	mov dx,offset dntext1
	mov ah,9
	int 21h											;zobrazi pokracovanie spravy
	mov ax,[di]										;ax=delitel
	xchg cx,ax
	cwd									;znamienkove rozsirenie delenca
	idiv cx
	call vypisax
	mov ah,8
	int 21h                                  ;caka na klavesu
	pop ax
	jmp menu



test3: cmp al,'4'
		je nasobenie
		jmp test4

nasobenie:                               ;pouziva retazce epror1,depror
	push ax
	call vyberc
	mov ax,3
	int 10h                            ;vymaze obrazovku
	mov ah,9
	mov dx,offset ntext1
	int 21h                            ;zobrazi spravu uzivatelovi
	mov ax,[si]
	mov cx,ax                           ;cx=cinitel v sucine
	call vypisax
	mov ah,2
	mov dl,' '
	int 21h                              ;zobrazi medzeru
	mov ax,[di]                          ;ax=cinitel
	call vypisax                           ;zobrazenie cinitela
	mov dx,offset dntext1
	mov ah,9
	int 21h                     ;zobrazi pokracovanie spravy
	mov ax,[di]                 ;ax=cinitel v sucine
	imul cx
	jno nnav1                   ;ci nenastalo pretecenie
	mov ax,3
	int 10h     				;vymaze obrazovku
	mov ah,9
	mov dx,offset ntext2
	int 21h                     ;zobrazi spravu o preteceni
	jmp nnav2
nnav1:	call vypisax
nnav2:	mov ah,8
	int 21h						;caka na klavesu
	pop ax
	jmp menu

vyberc proc
	mov ax,3
	int 10h						;vymaze obrazovku
	mov ah,9
	mov dx,offset vtext1
	int 21h						;vyzva uzivatelovy na vybratie prveho cisla
	mov cx,word ptr [pocet]
	xor ch,ch					;cx=pocet cisel
	mov bx,offset pomoc
vnav1:	mov ax,[bx]
	call vypisax
	push bx
	mov ah,2
	mov dl,'	'
	int 21h                    	;zobrazenie medzery
	push cx
	mov bh,0
	mov ah,3
	int 10h				  	    ;zistenie pozicie kurzoru
	cmp dl,60
	jb vnav2					;skok ak kurzor nie je pri konci riadku
	mov ah,2
	mov dl,0dh
	int 21h
	mov ah,2
	mov dl,0ah
	int 21h						;prechod na novy riadok
vnav2:	pop cx
	pop bx
	add bx,2
	loopne vnav1
	mov bh,0
	mov dx,100h
	mov ah,2
	int 10h					;nastavy kurzor na prve cislo
	mov si,offset pomoc
	mov cl,pocet				;cl=pocet cisel
	mov ch,1					;ch=index aktualneho cisla
vnav3:	mov ah,8
	int 21h						;nacitaj klavesu
	cmp al,'4'
	jne vlavo					;ci posun dolava
	cmp dl,0
	je vlavo                    ;ci sa da posunut dolava
	sub dl,8
	push si
	mov ah,2
	int 10h                     ;posunutie kurzoru dolava
	pop si
	sub si,2                   	;si bude ukazovat na predchadzajuce cislo
	dec ch                     	;dekrementuje index cisla
	jmp vnav3
vlavo:	cmp al,'6'              ;ci pusun doprava
	jne vnav5
	cmp ch,cl                   ;ci nie je na poslednom cisle
	je vnav5
	cmp dl,56                   ;ci kurzor nie je pri konci riadku
	je vnav5
	add dl,8
	push si
	mov ah,2
	int 10h                    	;posunutie kurzoru doprava
	pop si
	add si,2                    ;si bude ukazovat na nasledujuce cislo
	inc ch                      ;zvisuje index cisla
	jmp vnav3
vnav5:	cmp al,'8'
	jne vnav6					;ci sa ma ist o riadok vyssie
	cmp ch,9
	jb vnav6					;ak ch<9 tak nemoze ist na vyssi riadok /malo cisel pred ukazatelom/
	cmp dh,2
	jb vnav6					;ak dh<2 tak nad kurzorom nie je dostupny riadok
	dec dh
	push si
	mov ah,2
	int 10h						;posunutie kurzoru hore
	pop si
	sub si,16					;posunutie ukazatela na vybrane cislo
	sub ch,8					;znizi index cisla
	jmp vnav3
vnav6:	push ax
	cmp al,'2'
	jne vnav7					;ci sa ma prejst o riadok nizsie
	mov al,ch					;al=index cisla
	sub al,cl					;cl=pocet cisel
	cmp al,-8
	jnle vnav7					;skok ak sa nemoze ist o riadok nizsie
	cmp dh,24
	je vnav7					;skok ak je na poslednom riadku
	inc dh
	push si
	mov ah,2
	int 10h						;posunutie kurzoru dole
	pop si
	add si,16					;posunutie ukazatela o 8 cisel
	add ch,8					;zvisi index cisla o 8
	pop ax
	jmp vnav3
vnav7:	pop ax
	cmp al,0dh					;ci bol stlaceny enter
	je vnav8
	jmp vnav3
vnav8:	mov ax,3				;odtialto dole je vyber druheho cisla
	int 10h						;vymaze obrazovku
	mov ah,9
	mov dx,offset vtext2
	int 21h						;vyzva uzivatelovy na vybratie druheho cisla
	push si						;vybrate az na konci procedury| si ukazuje na
	mov cx,word ptr [pocet]		   ;prve vybrate cislo
	xor ch,ch						;cx=pocet cisel
	mov bx,offset pomoc
vnav12:	mov ax,[bx]
	call vypisax
	push bx
	mov ah,2
	mov dl,'	'
	int 21h							;zobrazenie medzery
	push cx
	mov bh,0
	mov ah,3
	int 10h							;zistenie pozicie kurzoru
	cmp dl,60
	jb vnav13						;skok ak kurzor nie je pri konci riadku
	mov ah,2
	mov dl,0dh
	int 21h
	mov ah,2
	mov dl,0ah
	int 21h							;prechod na novy riadok
vnav13:	pop cx
	pop bx
	add bx,2
	loopne vnav12
	mov bh,0
	mov dx,100h
	mov ah,2
	int 10h							;nastavy kurzor na prve cislo
	mov si,offset pomoc
	mov cl,pocet					;cl=pocet cisel
	mov ch,1						;ch=index aktualneho cisla
vnav14:	mov ah,8
	int 21h							;nacitaj klavesu
	cmp al,'4'
	jne vnav15						;ci posun dolava
	cmp dl,0
	je vnav15						;ci sa da posunut dolava
	sub dl,8
	push si
	mov ah,2
	int 10h							;posunutie kurzoru dolava
	pop si
	sub si,2						;si bude ukazovat na predchadzajuce cislo
	dec ch							;dekrementuje index cisla
	jmp vnav14
vnav15:	cmp al,'6'					;ci pusun doprava
	jne vnav16
	cmp ch,cl						;ci nie je na poslednom cisle
	je vnav16
	cmp dl,56						;ci kurzor nie je pri konci riadku
	je vnav16
	add dl,8
	push si
	mov ah,2
	int 10h							;posunutie kurzoru doprava
	pop si
	add si,2						;si bude ukazovat na nasledujuce cislo
	inc ch							;zvisuje index cisla
	jmp vnav14
vnav16:	cmp al,'8'
	jne vnav17						;ci sa ma ist o riadok vyssie
	cmp ch,9
	jb vnav17						;ak ch<9 tak nemoze ist na vyssi riadok /malo cisel pred ukazatelom/
	cmp dh,2
	jb vnav17						;ak dh<2 tak nad kurzorom nie je dostupny
	dec dh                             ;riadok
	push si
	mov ah,2
	int 10h							;posunutie kurzoru hore
	pop si
	sub si,16						;posunutie ukazatela na vybrane cislo
	sub ch,8						;znizi index cisla
	jmp vnav14
vnav17:	push ax
	cmp al,'2'
	jne vnav18						;ci sa ma prejst o riadok nizsie
	mov al,ch						;al=index cisla
	sub al,cl						;cl=pocet cisel
	cmp al,-8
	jnle vnav18						;skok ak sa nemoze ist o riadok nizsie
	cmp dh,24
	je vnav18						;skok ak je na poslednom riadku
	inc dh
	push si
	mov ah,2
	int 10h               			;posunutie kurzoru dole
	pop si
	add si,16						;posunutie ukazatela o 8 cisel
	add ch,8                        ;zvisi index cisla o 8
	pop ax
	jmp vnav14
vnav18:	pop ax
	cmp al,0dh						;ci bol stlaceny enter
	je vnav19
	jmp vnav14
vnav19:	mov di,si
	pop si
	ret
vyberc endp



test4:cmp al,'k'
		je koniec
		jmp menu

koniec: mov ah,3eh
		mov bx,offset vstups
		int 21h						;zatvorenie vstupneho suboru
		mov ah,3eh
		mov bx,offset vystups
		int 21h						;zatvorenie vystupneho suboru
		mov ax,4c00h  	   			;ukoncenie programu
		int 21h
		mov ah,4ch
		int 21h
code    ends
		end   start
;Program je plne funkcny. Program bol prelozeny programom tasm a zlinkovany
;tlink-om. Program cita cisla zo zadaneho suboru. Tieto cisla mozu byt
;oddelene lubovolnymi znakmi. Vsetky zobrazene a nacitane udaje musia byt
;v rozsahu <-32767,32767>, inak program oznami chybu. Program moze
;nacitat cisla len z prvych 1000 bytov vstupneho suboru. cisel moze
;byt najviac 100. Program pouziva DOS a BIOS prostrednictvom preruseni 10h
;a 21h. Mozne vylepsenie programu spociva v nahradeni bublinkoveho
;algoritmu triedenia shellovym.



