;***************************************************************
;                         Zadanie c.2.
;       Text zadania: Napiste program na prevod desiatkoveho
;        cisla so znamienkom do doplnkoveho kodu a vykonajte
;                         zadane operacie
;                      Autor:  Igor Masarovic  
;                  Termin odovzdania: 14.11.2000
;                     2.ro.,k.rok 2000/2001
;***************************************************************

 
.model large               ;definovanie modelu programu
.stack 100h                ;vytvorenie zasobnika o velkosti 100b

DATA SEGMENT  ;zaciatok datoveho segmentu,tu sa deklaruju premenne
color db ?    ;color -premenna,ktorej obsah nie je vopred znamy
null dw ?     ;to iste ako color
menu db ' M E N U '          ;vlastne retazce na zobrazenie menu
menu1 db '        Vypis sucet vsetkych cisiel        '
menu2 db ' Usporiadaj cisla vzostupne +zapis do txt  '
menu3 db '     Vydel dve cisla a vypis vysledok      '
menu4 db '    Vynasob dve cisla a vypis vysledok     '
menu5 db '              Koniec programu              '
prava db 'C I S L A:'        ;vlastne retazce na komentovanie
vyber1_text db 'Sucet vsetkych cisel je:'
vyber3_text db 'Podiel vybranych cisel je:'
vyber3_text2 db 'zvysok:'
vyber4_text db 'Sucin vybranych cisel je:'
poloha db  ?  ;poloha v menu,velkost 1b,obsah nie je vopred znamy
poloha2 db ?  ;to iste ako poloha1
cislo2 db ?   
cislo1 db ?
subor db  'cisla.txt',0  ;nazov suboru,kde su vstupne data(cisla)
vyber2_subor db 'vystup.txt',0  ;nazov suboru na ulozenie cisel
cisla_nac db 60 dup(?)    ;tu sa ukladaju nacitane cisla zo suboru
cisla_hot db 10 dup(?)    ;prekonvertovane cisla z nacitaneho suboru
cisla_usp db 10 dup(?)    ;usporiadane cisla
cisla_vloz db 60 dup(?)   ;usporiadane cisla na zapis do suboru
DATA ENDS       ;koniec segmentu dat



CODE SEGMENT           ;zaciatok vykonnej casti
ASSUME CS:code,ds:data  ;priradenie ds: segment dat, cs:kod


   vymaz_ret proc near       ;procedura na vymazanie retazca

    vym:
     mov dl,0+144                 ;nastavim farbu pozadia
     mov [si+0],dl            ;a vlozime ju do offsetu color
     mov dl,' '               ;znak, ktory sa bude zobrazovat
     call zobraz_char         ;a zavolame proceduru na zobr. znaku
     inc di                   ;posunieme poziciu na obrazovke
     inc di                   ;o jeden
   loop vym                   ;odcitame aporovname register cx s nulou
                              ;ak sa nerovnaju idem na navestie vym
     mov dl,15+144             ;teraz nastavim povodnu farbu
     mov [si+0],dl            ;do premennej color
   ret                        ;vratim cinnost hlavnemu programu

   vymaz_ret endp          ;koniec procedury na vymazanie retazca    

   zobraz_char proc near ;procedura na zobrazenie znaku na obrazovku

     mov es:[di],dl    ;vlozenie znaku do videoram dl-znak
     mov al,[si+0]     ;do al vlozime farbu znaku
     mov es:[di+1],al  ;a potom znova do videoram

     ret               ;vratime cinnost hlavnemu programu

   zobraz_char endp   ;koniec procedury na zobrazenie znaku
 
   zobraz_ret proc near  ;procedura na zobrazenie retazca

   pok:
     mov dl,ds:[bp]      ;z adresy ds:[bp] vyberieme znak       
     mov es:[di],dl      ;a vlozime ho do videoram
     mov al,[si+0]       ;nastavime farbu akou sa ma znak zobrazit
     mov es:[di+1],al    ;aj tu vlozime do videoram
     inc di              ;zvysime register di o jednotku
     inc di              ;a este o jednu jednotku
     inc bp              ;aj register bp zvysime o jednotku
     loop pok            ;pokial cx-1 je rozne od nuly tak cely cyklus
                         ;opakujeme
     ret                 ;vratime cinnost hlavnemu programu

   zobraz_ret endp       ;koniec procedury na zobrazenie retazca

  proc pozadie near      ;procedura na vytvorenie farebneho pozadia
     mov cx,4000         ;pocet znakov
     mov di,0            ;poloha prveho znaku
     mov dl,' '          ;typ znaku
   poz1:                 
     inc di              ;zvysime poziciu na obrazovke o jednu
     inc di
     call zobraz_char    ;zavolame proceduru na zobrazenie znaku
     loop poz1           ;toto opakujem pokial nie je v cx nula
     ret                 ;vratime cinnost hlavnemu programu

   pozadie endp          ;koniec procedury na vytvorenie pozadia
     
  proc okraje near       ;procedura na vytvorenie okrajov     
     mov dl,15+144       ;kod farby
     mov [si+0],dl       ;vlozime ho do registra faby
     mov di,0            ;pozicia na obrazovke
     mov dl,201          ;kod znaku
     call zobraz_char    ;vykreslenie znaku na obrazovku
     mov di,158          ;pozicia        
     mov dl,187          ;kod znaku
     call zobraz_char    ;vykreslenie znaku na obrazovku
     mov di,3840
     mov dl,200
     call zobraz_char
     mov di,3998
     mov dl,188
     call zobraz_char
     xor cx,cx           ;vynulujeme obsah registra cx
     mov di,160          ;poloha na obrazovke
    okraje1:             ;cyklus na vytvorenie zvislej ciary           
     mov dl,186          ;kod znaku
     call zobraz_char    ;zobrazenie znaku
     add di,160          ;zvyseni polohy na obrazovke
     inc cx              ;zvysime cx           
     cmp cx,23           ;porovname s 23,ak sa rovna vyskocime z cyklu
     jne okraje1
     xor cx,cx           ;znova vynulujeme cx
     mov di,318          ;pozicia na obrazovke
   okraje2:              ;dalsi cyklus na vytvorenie ciary 
     mov dl,186          ;kod znaku
     call zobraz_char
     add di,160
     inc cx
     cmp cx,23           ;zastavovacia podmienka cyklu
     jne okraje2
     xor cx,cx           ;vynulujeme cx
     mov di,2            ;poloha na obrazovke
   okraje3:              ;a dalsia ciara (vodorovna)
     mov dl,205          ;kod znaku
     call zobraz_char
     inc di              ;zvysenie polohy na obrazovke
     inc di
     inc cx
     cmp cx,78
     jne okraje3
     xor cx,cx
     mov di,3042
   okraje4:              ;cyklus na dalsiu ciaru              
     mov dl,205          ;ten isty znak ako predtym len ina pozicia
     call zobraz_char
     inc di
     inc di
     inc cx
     cmp cx,78
     jne okraje4
     xor cx,cx
     mov di,3842
   okraje5:              ;mame sest okrajov,takze aj 6 nezavislych
     mov dl,205          ;procedur
     call zobraz_char
     inc di
     inc di
     inc cx
     cmp cx,78
     jne okraje5
     mov di,3040         ;zobrazenie styroch znako,tych kde sa ciary
     mov dl,204          ;spajaju
     call zobraz_char
     mov di,3198
     mov dl,185
     call zobraz_char
     mov di,120
     mov dl,203
     call zobraz_char
     mov di,3160
     mov dl,202
     call zobraz_char
     mov di,280
     xor cx,cx
    okraje6:            ;a znova cyklus na vykreslenie ciary zo znakov 
     mov dl,186         
     call zobraz_char   
     add di,160
     inc cx
     cmp cx,18
     jne okraje6
    ret                      ;vratime cinnost hlavnemu programu
    
    okraje endp              ;koniec procedury na vytvorenie okrajov

  proc nacitaj near          ;procedura na nacitanie dat zo suboru
     mov ah,3dh              ; otvor subor
     mov al,0                ; na citanie 
     mov dx,offset subor     ; je to subor data.txt
     int 21h
     mov dx,offset cisla_nac ; bude sa ukladat do pameti
     mov cx,1                ; po jednom znaku
     mov bx,ax               ; do bx daj handler otvoreneho suboru
    citaj:	
     mov ah,3fh              ; citaj subor
     int 21h
     inc dx	                ; priprav adresu pre ulozenie dalsieho
                                ; znaku do pameti 'precitane'
     cmp ax,0                ; bol EOF?
     jne citaj               ;ak ano vyskoc z cyklu
     ret                     ;a vrat cinnost hlavnemu programu
   nacitaj endp              ;koniec procedury na nacitanie dat z txt 

  proc transf near     ;procedura na transformovanie ziskanych znakov
     xor bx,bx         ;na cisla
     xor ax,ax
     xor cx,cx         ;vymazeme potrebne registre
     mov di,offset cisla_hot   ;v di je adresa uz hotovych cisel
     mov bp,offset cisla_nac   ;a v bp adresa nacitanych znakov
    transf1:                   ;v subore su data cilsa ulozene na 5
     mov dl,ds:[bp]            ;miestach
     cmp dl,'-'                ;kedze cisla su 8-bitove tak 1 miesto 
     je transf2_1              ;je bud medzera alebo minus,ak
                               ;minus skocime na navestie 
    transf2:           
     inc bp            ;druha cifra je bud znamienko
     mov dl,ds:[bp]    ;a teda skocime na znamienkove navestie
     cmp dl,'-'
     je transf2_2
     cmp dl,' '        ;alebo medzera,a vtedy preskocim nasledujucu
     je transf3        ;instrukciu
     add bx,100        ;alebo je to jednotka a tak pridam do vysledneho
                       ;cisla 100
    transf3: 
     inc bp            ;dalsi znak moze byt bud minus,medzera alebo 
     mov dl,ds:[bp]    ;cislo
     cmp dl,'-'        ;podla toho o co sa jedna skocime na znamienko
     je transf2_3      
     cmp dl,' '        ;alebo neurobime nic
     je transf4
     sub dl,30h        ;alebo ak je to cislo na mieste desiatok
     mov al,dl         ;pricitame korekciu 30h
     mov dl,10         ;a vynasobime desiatimi
     mul dl            
     add bx,ax         ;tym dostaneme cislo na mieste desiatok         
                       ;a pricitame ho k vyslednemu cislu
    transf4:        
     inc bp            ;posledny znak moze byt uz iba cislo
     xor dx,dx       
     mov dl,ds:[bp]    ;tak ho nacitame
     sub dl,30h        ;vykoname korekciu
     add bx,dx         ;a pricitame,cim dostaneme hotove cislo
     inc bp            ;potom este porovname nasledujuci znak
     mov dl,ds:[bp]    ;s koncom nacitanych dat *
     cmp dl,'*'        ;ak sa zhoduju mame vsetky cisla prevedene
     je transf_hotovo  ;a skoncime
     inc bp          
     cmp cl,1          ;porovname,ci bolo cislo zaporne,ak ano
     je transf_minus   ;skocime na transf_minus
    transf5:
     mov ds:[di],bx    ;tu este vlozime vysledne cislo na adresu
     inc di            ;transformovanych ulozenych cisel
     xor bx,bx         ;vynulujeme register bx
     jmp transf1       ;a cely cyklus opakujeme s dalsimi znakmi
    transf2_1:         ;navestia na zistenie zaporneho cisla
     mov cl,1          ;ak je zaporne inicializujeme cl
     jmp transf2
    transf2_2:         ;to iste ako predosle naviestie
     mov cl,1
     jmp transf3
    transf2_3:      
     mov cl,1
     jmp transf4
    transf_minus:      ;ak sme zistili,ze cislo je zaporne
     neg bx            ;musime ho tak aj zobrazit cez funkciu neg
     xor cx,cx         ;vynulujeme register cx
     jmp transf5       ;a skocime na zapis cisla na adresu hotovych
    transf_hotovo:
     mov ds:[di],bx    ;ak sme nacitali posledne data ulozime posledne
                       ;cislo a transfer je hotovy
     ret               ;vratime cinnost hlavnemu programu
   transf endp         ;koniec procedury na ziskanie cisel zo vstupnych                        ;udajov

   proc vyber1 near    ;procedura realizujuca scitanie vsetkych cisel
     mov dl,15+144     ;kod farby
     mov [si+0],dl      ;ulozenie farby do registra farby
     mov bp,offset vyber1_text ;vypiseme text 
     mov di,3370
     mov cx,24
     call zobraz_ret   ;pomocou procedury zobraz_ret
     xor ax,ax         
     xor dx,dx         ;vynulujeme potrebne registre
     mov bp,offset cisla_hot ;do bp dame adresu cisel
     mov cx,10               ;a do registra cx ich pocet
    vybera:
     mov dl,ds:[bp]     ;zoberieme jedno cislo a pricitame do vysledku
     add al,dl          ;v al
     inc bp             ;posunieme ukazovatel na dalsie cislo
     loop vybera        ;a cely cyklus opakujeme az kym nie su scitane
                        ;vsetky cisla
     mov dl,10          ;kedze v mojom pripade je vysladne cislo mensie
     div dl             ;ako sto vydelime ho desiatimi a ziskame
     add ah,30h         ;obidve cifry
     add al,30h         ;k obidvom pricitame zaciatok cisel v ASCII
     mov dl,al          ;a postupne ich zobrazime
     mov di,3420
     call zobraz_char   ;najprv podiel (desiatky)
     mov dl,ah
     mov di,3422        ;a potom zvysok (jednotky)
     call zobraz_char
     jmp zaciatok       ;a skocime znova na zaciatok,do menu
     ret                ;vratime cinnost hlavnemu programu
   vyber1 endp          ;koniec procedury na sucet

   proc vyber2 near     ;procedura na zoradenie cisel
     mov cx,10          ;pocet cisel
     mov bp,offset cisla_hot ;najprv prekopirujeme cisla do
     mov di,offset cisla_usp ;pomocneho pola.pretoze ich budeme mazat
    vyber2_zac:
     mov dl,ds:[bp]     ;po jednom cisla kopirujeme cisla z cisla_hot
     mov ds:[di],dl     ;do cisla_usp
     inc di             ;zvysime ukazovatel v jednom
     inc bp             ;aj druhom poli a opakujeme
    loop vyber2_zac     ;kym nie su vsetky cisla prekopirovane
     xor cx,cx          ;vynulujeme register cx
     mov di,3370        ;poloha na obrazovke,ktoru budeme potrebovat   
     push di            ;neskor a preto ju vlozime do zasobnika
    vyber2_0:
     xor ax,ax          ;vynulujeme register ax
     mov bp,offset cisla_usp ;do bp dame adresu pola cisla_usp
     mov bl,ds:[bp]          ;vyberieme prvy prvok a porovname ho
     cmp bl,'+'              ;s mazacim znakom,ak sa rovnaju-skok
     je vyber2_plus2
    vyber2_a:              
     inc bp                  ;ak nie mame prve cislo
     inc ax                  ;zvysime ax (pocet cisel porovnanych)
     mov dl,ds:[bp]          ;a zoberieme druhe cislo
     cmp dl,'+'              ;pokial je tam mazaci znak (u mna +)
     je vyber2_b             ;nasleduje skok na vyber cisla
     cmp bl,dl               ;tu uz mame obidve cisla a porovname ich
     jg vyber2_vymen        ;ak je bl mensie nasleduje skok
    vyber2_b:
     cmp ax,9                ;tu porovnavame ci uz je posledne cislo
     jne vyber2_a            ;ak nie navrat a dalsie porovnavanie
     mov dl,'+'              ;teraz uz mame v bl najvacsi znak
     mov ds:[di],dl          ;preto na jeho poziciu dame 'nulovy' znak
     xor ah,ah               ;vynulujeme ah
     mov al,bl               ;do al dame cislo
     pop di                  ;teraz vyberieme zo zasobnika poziciu 
     cmp al,0                ;a porovname al z nulou             
     js vyber2_minus         ;ak je al zaporne cislo,dame znamienko
                             ;na navesti vyber2_minus
    vyber2_c:
     cmp al,100              ;pokial nie vypiseme cislo na obrazovku
                             ;zistime ci je vacsie ako sto ak ano-skok
     jg vyber2_up
    vyber2_vup:             ;ak nie jedna sa o cislo mensie ako sto              
     mov dl,10
     div dl                 ;preto ho vydelime desiatimi
     add ah,30h             ;a ziskame obidve cifry
     add al,30h             ;urobime korekciu pricitanim 30h
     inc di                 
     inc di                 ;posunieme kurzor o jednu poziciu
     mov dl,al              ;a vypiseme najprv desiatky
     call zobraz_char       
     mov dl,ah              ;potom znova zvysime poziciu kurzora
     inc di
     inc di
     call zobraz_char        ;a vypisem jednotky
     inc di                  ;potom koli estetike na dalsiu poziciu
     inc di                  ;vlozime ciarku na oddelenie cisel
     mov dl,','
     call zobraz_char       ;pomocou procedury zobraz_char
     push di                ;potom si ulozime poziciu do zasobnika
     cmp cx,9               ;porovname ci sme uz zobrazili vsetky cisla 
     je vyber2_hot         ;ak ano tak skoncime
     inc cx                ;ak nie zvysime pocet zobrazenych cisel
     jmp vyber2_0          ;a pokracujeme ziskanim dalsiho cisla na
                           ;zaciatok cyklu
    vyber2_vymen:          ;ak je dl vacsie ako doterajsie cislo
     mov bl,dl             ;tak ich tu vymenime
     mov di,bp            
     jmp vyber2_b         ;a pokracujeme v cykle hore
    vyber2_plus2:         ;pokial sme narazili na 'nulovy' znak         
     inc bp               ;zoberieme dalsie cislo za nim
     inc ax               ;zvysime pocet porovnanych cisel
     mov bl,ds:[bp]       
     cmp bl,'+'           ;a porovname cislo s 'nulovym' znakom
     je vyber2_plus2      ;pokial sa rovnaju skusime zobrat dalsie                           ;cislo
     jmp vyber2_a         ;a vratime sa do jadra cyklu
    vyber2_minus:        ;pokial je cislo zaporne
     neg al              ;tak ho upravime na kladne
     inc di              ;zvysime pozicu na obrazovke
     inc di        
     push ax             ;ulozime si cislo do zasobnika
     mov dl,'-'          ;a vypiseme na obrazovku minus
     call zobraz_char
     pop ax             ;vyberieme cislo zo zasobnika
     jmp vyber2_c       ;a pokracujeme v cykle hore
    vyber2_up:         ;pokial je cislo vacsie ako 100
     inc di            ;nemozeme ho hned delit
     inc di
     sub al,100    ;ale od neho odcitame 100
     mov dl,'1'    ;a na obrazovkuy vypiseme jednotku na miesto stovak
     push ax       ;ulozime si cislo
     call zobraz_char   ;zobrazime jednotku
     pop ax            ;vyberieme cislo a teraz ho v cykle hore 
                       ;vydelime desiatkou aby sme ziskali zvysne cifry
     jmp vyber2_vup
    vyber2_hot:             ;pokial sme s usporiadanim hotovy
     mov bp,offset cisla_vloz  ;treba cisla ulozit do suboru
     mov di,3370          ;pozicia na obrazovke a v bp adresa prazdneho 
                         ;pola urceneho k zapisu
     mov cx,50           ;maximalny pocet znakov
    vyber2_hot2:
     mov dl,es:[di]      ;teraz jednoducho vyberieme znaky z videoram
     mov ds:[bp],dl      ;a vlozime ich do pola na zapis
     inc di              ;pripravime dalsiu poziciu vo videoram
     inc di             
     inc bp              ;a v poli na zapis do suboru
     loop vyber2_hot2
    vyber2_uloz:         ;ked sme hotovi,nasleduje zapis do suboru
     mov ah,3ch          ;cislo sluzby
     mov dx,offset vyber2_subor ;nazov suboru
     int 21h          ;sluzba DOS-u na vytvorenie suboru
     mov bx,ax        ;do bx dame handler suboru,je potrebny na zapis  
     mov cx,50        ;pocet znakov na vlozenie do suboru
     mov dx,offset cisla_vloz ;kde sa znaky nachadzaju
     mov ah,40h               ;cislo sluzby
     int 21h         ;prerusenie DOS-u,zapis do suboru
    vyber2_koniec:   ;tym sme skoncili
     jmp zaciatok    ;skocime naspat do menu
     ret             ;a vratime cinnost hlavnemu programu
  
   vyber2 endp      ;koniec procedury na usporiadanie cisel

   proc vyber3 near          ;procedura realizujuca delenie
     call pohyb_prave_menu    ;zavolame proceduru na vyber cisel
     mov bp,offset vyber3_text ;zobrazime uvodny text
     mov cx,26               ;pocet znakov v retazci
     mov di,3370             ;pozicia na obrazovke           
     call zobraz_ret         ;zobrazenie cez proceduru zobraz_ret
     xor cx,cx
     xor ax,ax
     xor bx,bx           ;vymazeme potrebne registre
     mov bp,offset cislo1;a do bp vlozime adresu poz.nacitaneho 1.cisla
     mov cl,ds:[bp]      ;cislo vlozime do cl
     mov bp,offset cisla_hot ;do bp vlozime adresu pola cisel 
     cmp cl,0            ;pokial je to prv cislo preskocime cyklus     
     je vyber3_a         
    vyber3_b:           ;ak nie zistime si poziciu nacitaneho cisla
     inc bp             ;v poli cisel
     loop vyber3_b
    vyber3_a:           
     mov al,ds:[bp]     ;do al vlozime cislo,a porovname s nulou
     cmp al,0            
     js vyber3_minus2    ;pokial je zaporne je urcite zvysok zaporny
                         ;a tak zobrazime minus a upravime
    vyber3_f:            
     mov bp,offset cislo2 ;ak nie nacitame poziciu druheho cisla  
     mov cl,ds:[bp]       ;vlozime ju do cl
     mov bp,offset cisla_hot ;do bp vlozime adresu pola cisel
     cmp cl,0            ;opat poravname poziciu z cislo2,ak je nulova
                         ;preskocime cyklus
     je vyber3_c
    vyber3_d:            ;ak nie najdeme si jeho polohu v poli cisel
     inc bp
     loop vyber3_d
    vyber3_c:
     mov dl,ds:[bp]      ;cislo vlozime do dl
     idiv dl             ;a delime ax (teda al) s dl (so znamienkom)
     cmp al,0            ;porovname podiel s nulou
     js vyber3_minus     ;a pokial je zaporny skocime na navestie
     cmp al,0            ;porovname al s nulou
     je vyber3_g         ;ak je to nula preskocime nasl. riadok
     cmp bl,1            ;pretoze tu sa rozhoduje o znamienku
                         ;a nula je 'kladna'
     je daj_minus     ;pokial al je rozne od nuly skontrolujeme znam.
                      ;ak je zaporne tak ho zobrazime na navesti daj..
    vyber3_g:         
     mov bl,ah        ;ulozime si zvysok po deleni do bl
     xor ah,ah        ;vynulujeme register ah
     cmp al,100       ;porovname al so 100,ak je vacsi,tak skok
     jg del_2
     cmp al,10        ;potom ak nie porovname al s 10,ak je vacsi-skok
     jg del_1
     add al,30h       ;ak sme presli,tak je tam len jednotkove cislo
     mov dl,al        ;ktore po korekcii 30h,mozeme hned zobrazit
     mov di,3428      ;pozicia na obrazovke
     call zobraz_char ;procedura na zobrazenie znaku
    vyber3_zvysok: 
     mov bp,offset vyber3_text2 ;bp-adresa sprievodneho textu
     mov cx,7                  ;pocet znakov v retazci
     mov di,3440       ;pozicia prveho znaku na obrazovke    
     call zobraz_ret   ;vypisanie retazca
     xor ax,ax         ;vynulujeme register ax
     mov al,bl         ;a do al dame bl,cize zvysok po deleni
     cmp al,100        ;a znova to iste co predtym len so zvyskom
     jg del_2z
     cmp al,10
     jg del_1z
     add al,30h
     mov dl,al
     mov di,3460
     call zobraz_char
     jmp zaciatok      ;tym mame vysledok vypisany,mozeme skoncit
     ret               ;skok na zaciatok, a vratenie cinnosti hl.prog
    del_2:           ;pomocne navestie v dosledku skoku> ako 128bitov
     jmp del_3
    vyber3_minus:    ;pokial je podiel cislo zaporne
     neg al          ;tak z neho urobim kladne
     cmp bl,0        ;a ak je znamienko kladne,bude zaporne
     je daj_minus    ;a tak ho vypiseme na obrazovku na navesti daj...
     jmp vyber3_g    ;skok do hlavneho cyklu
    vyber3_minus2:   ;pokial je prve cislo vchadzajuce do delenia zap. 
     neg al          ;tak z neho urobim kladne
     mov bl,1        ;a nastavim znamienko minus na aktivne (reg bl)
     jmp vyber3_f    ;a skocim naspat so hlavneho cyklu
    daj_minus:
     push ax         ;vlozim hodnotu z ax do zasobnika
     mov dl,'-'      ;do dl dam znamienko minus a zobrazim
     mov di,3426     ;na poziciu di
     call zobraz_char ;zobrazenie znaku
     pop ax          ;vybranie hodnoty zo zasobnika do ax
     jmp vyber3_g    ;skok naspat do cyklu
    del_1:           
     mov dl,10       ;podiel je cislo mensie ako 100
     div dl          ;a preto mi staci vydelit ho desiatimi a
     add al,30h      ;dostanem po korekcii 30h cislo na miste desiatok
     add ah,30h      ;ako aj cuslo na mieste jednotiek
     mov dl,al       ;no a potom ich po jednom zobrazim
     mov di,3430      
     call zobraz_char ;tu zobrazim prostrednictvom zobraz_char desiatky
     mov dl,ah 
     mov di,3432
     call zobraz_char  ;a tu stovky
     jmp vyber3_zvysok ;skok naspat do hlavneho cyklu
    del_3:            ;podiel je cislo vacsie ako 100
     sub al,100       ;tak  od cisla odcitame 100
     push ax          ;ulozime hodnotu cisla do zasobnika
     mov dl,'1'       ;a zobrazime jednotku na mieste stoviek
     mov di,3428
     call zobraz_char
     pop ax           ;vlozime uz cislo mensie ako 100 zo zasobnika
                      ;do registra ax    
     jmp del_1        ;a skocime na predosly cyklus
    del_2z:           ;pomocne navestie koli podmienenemu skoku
                      ;vacsiemu ako 128bitov
     jmp del_3z
    del_1z:           ;to iste ako navestia del_1 a del_2
     mov dl,10        ;akurat ze tu pracujeme zo zvyskom
     div dl
     add al,30h
     add ah,30h
     mov dl,al
     mov di,3462
     call zobraz_char
     mov dl,ah 
     mov di,3464
     call zobraz_char
     jmp zaciatok
     ret
    del_3z:
     sub al,100
     push ax
     mov dl,'1'
     mov di,3460
     call zobraz_char
     pop ax
     jmp del_1z
   vyber3 endp       ;koniec procedury na podiel dvoch cisel

   proc vyber4 near  ;procedura na nasobenie dvoch cisel 
     call pohyb_prave_menu  ;procedura na vyber nasobiacich cisel
     mov bp,offset vyber4_text ;sprievodny text
     mov cx,25        ;pocet znako v retazci
     mov di,3370      ;pozicia na obrazovke
     call zobraz_ret  ;zobrazenie retazca
     xor cx,cx   
     xor ax,ax
     xor bx,bx         ;vynulovanie potrebnych registrov
     mov bp,offset cislo1 ;do bp vlozime adresu pozicie 1 vybraneho c.
     mov cl,ds:[bp]    ;tuto poziciu vlozime do cl
     mov bp,offset cisla_hot ;do bp vlozime adresu pola cisel
     cmp cl,0          ;porovname cl s nulou
     je vyber4_a       ;pokial je cl=0 preskocime nasledujuci cyklus
    vyber4_b:
     inc bp           ;ak nie tak sa nastavime v poli cisel na
     loop vyber4_b    ;poziciu danu v cislo1
    vyber4_a:
     mov al,ds:[bp]   ;do al,vlozime vybrane cislo
     cmp al,0         ;porovname ho s nulou
     js vyber4_minus2  ;ak je zaporne skocime na navestie vyber4...
    vyber4_f:          
     mov bp,offset cislo2 ;teraz zistime poziciu vybraneho 2.cisla
     mov cl,ds:[bp]    ;vlozime ju do cl
     mov bp,offset cisla_hot ;do bp vlozime adresu pola cisel
     cmp cl,0         ;znova porovname poziciu s nulou
     je vyber4_c      ;ak sa rovnaju preskocime nasl. cyklus
    vyber4_d:
     inc bp          ;ak nie ziskame poziciu v poli cisel
     loop vyber4_d
    vyber4_c:        
     mov dl,ds:[bp]   ;do dl vlozime druhe vyubrane cislo
     imul dl         ;vynasobime kladne cislo v ax(al) cislom so 
                     ;znamienkom v dl
     cmp ax,0        ;provname vysledok s nulou
     js vyber4_minus ; pokial je vysledok zaporny skocime na...
     cmp bl,1        ;porovname zmnamienkovy register s jednotkou
     je daj4_minus   ;a ak je cislo zaporne vypiseme na navesti.. -
    vyber4_g:
      cmp ax,10000    ;porovname sucin s 10000
      jg vyber4_4     ;ak je vacsi tak skok
      cmp ax,1000     ;potom s 1000
      jg vyber4_3
      cmp ax,100      ;so 100
      jg vyber4_2
      cmp ax,10       ;a s desiatkou
      jg vyber4_1
     vyber4_y:        ;pokial je mensi ako 10
       add al,30h     ;je to len jedno cislo a to mozeme hned zobrazit
       mov dl,al      ;vykoname korekciu
       mov di,3436    ;pozicia na obrazovke
       call zobraz_char ;vykraslenie znaku
     vyber4_z:         ;pomocne navestie pri podminenom skoku
      jmp vyber4_hot   ;nakolko je skok > ako 128bitov
     vyber4_minus2:    ;to iste ako predtym
      jmp vyber4_minus3
     daj4_minus:       ;to iste ako prve navestie
      jmp daj4_minus2  
    vyber4_4:          
      xor dx,dx        ;vynulujeme obsah registra dx
      mov bx,10000     ;do bx dame 10000
      div bx           ;a vydelime sucin
      push dx          ;zvysok po deleni vlozime do zasobnika
      add al,30h       ;ah je nulovy a al zobrazime,spravime korekciu
      mov dl,al
      mov di,3428      ;a na poziciu di
      call zobraz_char ;ho zobrazime pomocou procedury zobraz_char
      pop dx           ;zoberieme zvysok zo zasobnika
      mov ax,dx        ;a vlozime ho do ax
    vyber4_3:
      xor dx,dx        ;a pokracujeme v deleni teraz 1000
      mov bx,1000
      div bx       
      push dx          ;znova ulozime zvysok do zasobnika
      add al,30h       ;a podiel vypiseme
      mov dl,al
      mov di,3430
      call zobraz_char
      pop dx           ;vyberieme hodnotu zo zasobnika
      mov ax,dx        ;a vlozime zvysok do ax
    vyber4_2:
      xor dx,dx         ;dalsie delenie a to cislom 100
      mov bx,100
      div bx            
      push dx          ;zvysok dame do zasobnika
      add al,30h       ;a podiel po korekcii zobrazime
      mov dl,al
      mov di,3432
      call zobraz_char
      pop dx          ;vybranie zvysku zo zasobnika
      mov ax,dx       ;do ax vlozime zvysok
    vyber4_1:        
      xor dx,dx       ;vynulovanie registra dx        
      mov bl,10       ;a posledne delenie teraz desiatimi
      div bl          ;cim dostaneme aj posledne dve cifry sucinu
      add al,30h      ;najprv zobrazime podiel 
      mov dl,al     
      mov di,3434
      call zobraz_char
      mov al,ah     ;a skocime na koniec,kde sa zobrazia este jednotky
      jmp vyber4_y    
    vyber4_minus:     
     neg ax         ;ak je vysledne cislo zaporne upravime ho na kladne 
     cmp bl,0       ;porovname znamienkovy register
     je daj4_minus  ;ak je nulovy tak dame znamienko pred cislo
     jmp vyber4_g
    vyber4_minus3:  
     neg al         ;ak je prve cislo zaporne musime ho upravit na
                    ;kladne
     mov bl,1      ;a v znamienkovom registri nastavit jednotku 
     jmp vyber4_f
    daj4_minus2:   ;ak je vysledne cislo zaporne zobrazime pred nim
                   ;znamienko minus
     push ax       ;vlozime ax do zasobnika
     mov dl,'-'    ;do dl znamienko minus
     mov di,3426   ;a na pozicu di na obrazovke ho zobrazime
     call zobraz_char
     pop ax        ;vlozenie hodnoty zo zasobnika do registra ax
     jmp vyber4_g  ;skok do hlavneho cyklu
    vyber4_hot:  
    
     jmp zaciatok ;skok naspat do menu   
     ret          ;vratenie cinnosti hlavnemu programu
   vyber4 endp    ;koniec procedury na nasobenie dvoch cisel

   proc vyber5 near ;procedura na ukoncenie programu
     jmp koniec     ;skok na koniec programu
     ret         
   vyber5 endp      ;koniec procedury na ukoncenie programu
      
  
  proc vytvor_prave_menu near ;vytvorenie menu,kde sa vyberaju cisla
     mov bp,offset cisla_nac ;do bp vlozime adresu pola znakov zo
                             ;vstupneho suboru
     mov di,774              ;pozicia na obrazovke             
    vytvor1:
     mov dl,ds:[bp]        ;do dl vlozime znak z pola vstupu
     cmp dl,'.'            ;porovname ho z medziciselnym znakom
     je vytvor2            ;ak sa rovnaju skok na vytvor2
     cmp dl,'*'            ;porvname dl s koncom nacitanych dat
     je vytvor_hot         ;ak sa rovnaju koniec
     call zobraz_char      ;inac zobraz znak na obrazovku
     inc bp                ;adresa dalsieho znaku z vstupnych dat
     inc di             
     inc di                ;posun na obrazovke o jedno miesto
     jmp vytvor1           ;skok na nacitanie dalsieho znaku
    vytvor2:
     add di,152            ;pokial to bol medziciselny znak posun
                           ;'kurzor' na dalsi riadok 
     inc bp                ;adresa dalsieho znaku zo vstupnych dat
     jmp vytvor1
    vytvor_hot:           
     ret                ;vratenie cinnosti hlavnemu programu

   vytvor_prave_menu endp ;koniec procedury na vytvorenie...
       

  proc pohyb_prave_menu near ;zabezpecuje pohyb a vyber v menu cisel
     xor bx,bx              ;vynulovanie registra bx
    pravez:
     mov dl,8+130           ;kod farby
     mov [si+0],dl          ;vlozenie farby do [si+0]
     mov cx,6               ;pocet znakov                         
     mov di,772             ;poloha prveho cisla na obrazovke
     mov bp,offset poloha2  ;do bp adresa polohy svietiaceho ramceka
     mov ds:[bp],di         ;do polohy2 vloz polohu 1.
    prave0:
     mov al,[si+0]          ;cyklus,kde za zobrazi svietiaci ramcek
     mov es:[di+1],al       ;na zaciatku menu
     inc di                 ;zmena farby na potrebnych poziciach
     inc di
     loop prave0 
    prave1:
     mov ah,00h          ;cislo sluzby
     int 16h             ;preruseniue na vstup z klavesnice
     cmp al,'2'          ;pokial sme stlacili dvojku ideme dole...
     je prave_dole
     cmp al,'8'          ;ak osmicku ideme v menu hore (prave_hore)
     je prave_hore
     cmp al,13           ;ak sme stlacili enter
     je prave_vyber_cislo ;znamena to vyber daneho svietiaceho cisla 
     jmp prave1          ;ak sme nastlacili ani jedno cakame na 
                         ;stlacenie jedneho z nich
    prave_dole:          ;pohyb smerom dole
     xor di,di           ;vymazeme obsah di
     mov bp,offset poloha2 ;do bp vlozime adresu polohy ramceka
     mov di,ds:[bp]        ;do di,vlozime polohu ramceka
     cmp di,2212           ;porovname hodnotu s poslednym cislom
     je prave1             ;ak sa zhoduju nic sa neudeje,skok na
                           ;nacitanie z klavesnice
     mov dl,15+144       ;kod farby
     mov [si+0],dl       ;vlozenie farby na [si+0]
     mov cx,6            ;pocet miest
    prave2:
     mov al,[si+0]       ;zmena,tam kde bol ramcek,vymazeme ramcek
     mov es:[di+1],al    ;(prekreslime farbou pozadia)
     inc di
     inc di
     loop prave2
     add di,148
     mov cx,6
     mov dl,8+130       ;a na novu poziciu vlozime ramcek
     mov [si+0],dl      ;iba zmenou farby
    prave3:
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di 
    loop prave3
     sub di,12      ;od di odcitame 12 (2*6-pocet vysvietenych znakov)
     mov ds:[bp],di ;a do polohy2 vozime novu poziciu
     jmp prave1
    prave_hore:      ;presne rovnaky postup ako pri prave_dole
     xor di,di
     mov bp,offset poloha2
     mov di,ds:[bp]
     cmp di,772
     je prave1
     mov dl,15+144
     mov [si+0],dl
     mov cx,6
    prave4:         
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di
     loop prave4
     sub di,172
     mov cx,6
     mov dl,8+130
     mov [si+0],dl
    prave5:          ;akurat ramcek posunieme smerom hore
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di 
    loop prave5
     sub di,12
     mov ds:[bp],di
     jmp prave1
    prave_vyber_cislo: ;ak sme si cislo vybrali (stlac. enter)
     cmp bl,0          ;zistime ci sa jedna o prve cislo (ak bl=0)
     je prave_vyber    ;ak ano skok na prave_vyber
     cmp bl,1          ;alebo ci sa jedna o druhe cislo (ak bl=1)
     je prave_vyber2   ;ak ano skok na prave_vyber2
    prave_vyber:       ;navestie pri vybere prveho cisla     
     xor ax,ax          ;vynulovanie registra ax
     mov bp,offset poloha2 ;do bp adresa polohy2
     mov ax,ds:[bp]       ;do ax,hodnota z polohy2
     mov di,ax            ;do di (pozicia na obr.) vlozime hodnotu z ax 
     mov dl,15+144        ;kod farby
     mov [si+0],dl
     mov cx,6          ;pocet znakov
    prave_vyber_a:     ;navestie na vymazanie ramceka
     mov dl,[si+0]      
     mov es:[di+1],dl
     inc di
     inc di
     loop prave_vyber_a
     sub ax,772    ;odpocitanie od pozicie 772 (pozicia prvej polozky)
     mov dl,160    
     div dl        ;vydelenie pozicie cislom 160,cim ziskame poziciu
                   ;vybraneho cisla v poli cisla_hot
     mov bp,offset cislo1
     mov ds:[bp],al ;a tuto poziciu vlozime do cisla1
     mov bl,1      ;nastavime bl=1 (vyberame druhe cislo)
     jmp pravez    ;skok na zaciatok
    prave_vyber2:   ;navestie pri vybere druheho cisla
     xor ax,ax        ;vsetko rovnake ako pri prvom cisle
     mov bp,offset poloha2
     mov ax,ds:[bp]
     mov di,ax
     mov dl,15+144
     mov [si+0],dl
     mov cx,6
    prave_vyber2_a:
     mov dl,[si+0]
     mov es:[di+1],dl
     inc di
     inc di
     loop prave_vyber2_a
     sub ax,772
     mov dl,160
     div dl
     mov bp,offset cislo2 ;ibaze polohu cisla vlozime do cisla2
     mov ds:[bp],al
     
     ret                   ;vratenie cinnosti hlavnemu programu
  pohyb_prave_menu endp    ;koniec procedury na pohyb v menu cisel
    	

  proc vytvor_menu near ;procedura na vytvorenie hlavneho menu
     mov bp,offset menu ;do bp vlozime adresu retazca menu 
     mov cx,9           ;pocet znakov
     mov di,210         ;pozicia na obrazovke
     call zobraz_ret    ;zavolanie procedury na vypis
     mov dl,8+130       ;kod farby
     mov [si+0],dl         ;vlozenie farby do [si+0]
     mov bp,offset poloha  ;do bp adresa polohy ramceka
     mov dx,656            
     mov ds:[bp],dx       ;do polohy ramceka vloz polohu prvej polozky
     mov bp,offset menu1  ;do bp adresa retazca
     mov cx,43            ;pocet znakov (rovnaky pre vsetky polozky)
     mov di,656           ;pozicia na obrazovke
     call zobraz_ret
     mov dl,15+144        ;kod farby 
     mov [si+0],dl        ;vlozenie farby do [si+0]
     mov bp,offset menu2  ;do bp vlozenie adresy retazce
     mov cx,43            ;pocet znakov 
     mov di,976           ;poloha na obrazovke
     call zobraz_ret
     mov bp,offset menu3
     mov cx,43
     mov di,1296
     call zobraz_ret
     mov bp,offset menu4
     mov cx,43
     mov di,1616
     call zobraz_ret
     mov bp,offset menu5
     mov cx,43
     mov di,1936
     call zobraz_ret
     mov bp,offset prava
     mov cx,10
     mov di,290
     call zobraz_ret
     ret                 ;vratime cinnost hlavnemu programu
  vytvor_menu endp       ;koniec procedury na vytvorenie menu

  proc pohyb_menu near  ;procedura na pohyb v hlavnom menu
    pohyb1:
     mov ah,00h         ;cislo sluzby
     int 16h            ;prerusenie na vstup z klavesnice
     cmp al,'2'         ;porovname co bolo stlacene
     je dole
     cmp al,'8'
     je hore
     cmp al,13
     je pohyb_vyber    ;ak bola stlacena 2,8 alebo enter skocime na
                       ;prisluchajuce navestie,ak nie cakame na ich 
                       ;nacitanie
     jmp pohyb1
    dole:                ;navestie pri pohybe smerom dole
     xor di,di           ;v podstate je to presne to iste           
     mov bp,offset poloha ;ako pri pohyb_prave_menu
     mov di,ds:[bp]       ;akurat su ine pozicie retazcov
     cmp di,1936         ;a ina dlzka ramceka
     je pohyb1
     mov dl,15+144
     mov [si+0],dl
     mov cx,43
    pohyb2:
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di
     loop pohyb2
     add di,234
     mov cx,43
     mov dl,8+130
     mov [si+0],dl
    pohyb3:
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di 
    loop pohyb3
     sub di,86
     mov ds:[bp],di
     jmp pohyb1
    hore:
     xor di,di
     mov bp,offset poloha
     mov di,ds:[bp]
     cmp di,656
     je pohyb1
     mov dl,15+144
     mov [si+0],dl
     mov cx,43
    pohyb4:
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di
     loop pohyb4
     sub di,406
     mov cx,43
     mov dl,8+130
     mov [si+0],dl
    pohyb5:
     mov al,[si+0]
     mov es:[di+1],al
     inc di
     inc di 
    loop pohyb5
     sub di,86
     mov ds:[bp],di
     jmp pohyb1
    pohyb_vyber: ;vyber polozky (stlacenie ent.)
     mov di,3362 ;po vybrani vymazeme plochu kde sa vypisuju vysledky 
     mov cx,75   ;di-poloha zaciatku,cx-pocet pozicii 
     call vymaz_ret ;procedura na vymazanie znakov z obrazovky
     mov bp,offset poloha ;z polohy si zistime polohu ramceka pri
                          ;vybere
     mov di,ds:[bp]
     cmp di,656           ;a porvnavame s polohami retazcov v menu 
     je pohyb_vyber1   ;ak sa sa zhoduju skocime na tomu prisluchajuce
     cmp di,976        ;navestie
     je pohyb_vyber2
     cmp di,1296
     je pohyb_vyber3
     cmp di,1616
     je pohyb_vyber4
     cmp di,1936
     je pohyb_vyber5
    pohyb_vyber1:      
     call vyber1       ;a odtial zavolame prislusnu proceduru
     jmp pohyb_hotovo  ;a skocime na koniec procedury pohyb_menu
    pohyb_vyber2:
     call vyber2
     jmp pohyb_hotovo
    pohyb_vyber3:
     call vyber3
     jmp pohyb_hotovo
    pohyb_vyber4:
     call vyber4
     jmp pohyb_hotovo
    pohyb_vyber5:
     call vyber5
     jmp pohyb_hotovo
    pohyb_hotovo:      
     ret               ;navrat cinnosti hlavnemu programu
  pohyb_menu endp      ;koniec procedury na pohyb v hlavnom menu
     


start:
     mov ah,02h             ;prerusenie DOS-u na posun kurzora
     mov dh,25              ;kurzor dame 'za' obrazovku aby nezavadzal
     int 10h                ;vyvolame prerusenie
     mov ax,seg data        ;do ax vlozime segment dat
     mov ds,ax              ;a do ds potom vlozime ax
     mov ax,0b800h          
     mov es,ax              ;adresa na zapis do videoram
     xor di,di              ;vynulujeme di           
     mov si,offset color    ;do si vlozime adresu premennej color
     mov dl,15+144           ; do dl vlozime kod farby
     mov [si+0],dl   
     call nacitaj           ;nacitame udaje zo suboru
     call transf            ;pretransformujeme znaky zo suboru na cisla 
     call pozadie           ;vytvorime pozadie
     call okraje            ;vykreslime okraje
    zaciatok:
     call vytvor_menu       ;vytvorime hlavne menu
     call vytvor_prave_menu ;vytvorime menu cisel
     call pohyb_menu        ;vyber jednotlivych poloziek z menu
 koniec:                ;koniec celeho programu
     mov ax,4c00h        
     int 21h
     ends                 ;koniec kodoveho segmentu
     end start            ;definujeme odkial zacina program

;*********************************************************************
;Zhodnotenie: Program je funkcny pri pouziti mnou vytvoreneho vstupneho
;suboru.Program bol pisany vo Widows-e v Poznamkovom bloku,a spracovany
;programami TASM verzia 2.02 a zlinkovany programom TLINK verzia 3.01
;Cely program je rieseny priamym zapisom do videram,cize bez pouzitia
;sluzieb DOS-u na vypis znaku (retazca).Zda sa mi to omnoho jednoduchsie a prehladnejsie.Program je tvoreny vylucne procedurami
;ktore su volane z programu a navzajom.Sprehladnuje to cely program a
;ulahcuje hladanie chyb.
;Pri pouziti ineho suboru (modifikovaneho) by bolo treba osetrit vstup
;pri vysokych cislach mimo rozsah <-128,127>, takisto potom kontrolovat
;delenie nulou a pripadne zmenit mazaci znak (+) pri usporaduvani
;cisel.
;*********************************************************************