;Zadanie c.1.

;Text zadania: Napiste program, ktory nacita z klavesnice retazec znakov
; (max. 100 znakov) a podla ponukaneho menu vykona jednu z moznosti:
;  a) vypise retazec znakov na obrazovku
;  b) vypise pocet cislic v retazci
;  c) zisti, ci sa v retazci nachadza uzivatelom zadany znak a vypise o tom spravu
;  d) najde znak s min. hodnotou a vypise tento znak
;  e) male pismena konvertuje na velke
;  f) zarovna text sprava (vynecha prve medzery odkonca)
;  g) ukonci vykonavanie programu.
; Po vykonani zvolenej moznosti sa program vrati na vypis menu.

;Autor:  Martin Mokos B-11 

;Termin odovzdania: 24.10.2000

;2.roc.,k.rok 2000/2001


;tu sa nachadzaju vsetky textove vypisy vratane vypisu menu
DATA    SEGMENT		

	MAX_DLZKA       DB      101
	AKT_DLZKA       DB      ?
	RETAZEC         DB      102	DUP ('$')
	OBRATENY	DB	102	DUP ('$')
	MUSITE_TEXT	DB 13, 10, 'Musite zadat RETAZEC!!!',13, 10,'$'
	NAJMENSI_TEXT	DB 13, 10, 'Znak s minimalnou hodnotou: $'
	ZADAJ_TEXT      DB 'PROGRAM PRE PRACU S RETAZCOM	<<zadanie 1-B>> 	(c) Martin Mokos B-11', 13, 10
			DB 13, 10, 'Napiste retazec: ', 13, 10,'$'
	MENU_TEXT       DB 13, 10, '	VASA VOLBA:', 13, 10
			DB '(a) vypis povodneho  retazca', 13, 10
			DB '(b) pocet cislic v retazci', 13, 10
			DB '(c) najdenie pozadovaneho znaku', 13, 10
			DB '(d) najdenie znaku s min. hodnotou', 13, 10
			DB '(e) konverzia malych pismen na velke', 13, 10
			DB '(f) zarovnenie textu sprava', 13, 10, 13, 10
			DB '(g) koniec', 13, 10, 13, 10, '$'
	ZNAK_INDEX_TEXT DB 13, 10, 13, 10, 'Pozicie hladaneho znaku: $'
	NENASIEL_ZNAK_TEXT      DB 13, 10, 13, 10, 'Znak sa v retazci nenachadza.$'
	MEDZERA_TEXT    DB ' $'
	ODRIADKUJ       DB 13, 10, '$'
	POVODNY		DB 'Povodny retazec: ', 13, 10,'$'
	VYPIS		DB 'Konvertovany retazec: ', 13, 10,'$'
	ZADAJ_ZNAK_TEXT DB 13, 10, 'Hladame znak: $'
	POCET_CISEL_TEXT        DB 13, 10, 'Pocet cislic v retazci: $'
	ZAROVNANIE	DB 'Retazec zarovnany sprava: ', 13, 10,'$'
	CIARKA_TEXT	DB ', $'
	BYE		DB 'bye & thanx 4 using ;-))$'
DATA    ENDS

;definujeme si zasobnik
ZAS     SEGMENT         STACK 'STACK'	
	DW              100 DUP(?)	;pre 100 znakov
ZAS     ENDS

; makro pre vypis retazca na obrazovku
NAPIS   MACRO   retazec
	PUSH    DX			;uchovame si povodne...
	PUSH    AX			;...hodnoty registrov
	MOV     DX, OFFSET retazec	;zaciatok retazca
	MOV     AH, 09H			;sluzba pre vypis retazca
	INT     21H			;koncovy znak je '$'
	POP     AX			;obnovim registre AX...
	POP     DX			;...a DX
	ENDM

Code    SEGMENT
	ASSUME  CS:CODE, DS:DATA, SS:ZAS

;podprogram NAPIS_CISLO_DL vypise cislo ulozene v DL
;zvlada vypis az do cisla 99
NAPIS_CISLO_DL 	PROC	NEAR
	PUSH	AX		;odlozime obsah registra AX...
	PUSH	DX		;... a registra DX
	XOR	AH, AH		;vyuzijem len dolnu polovicu
	MOV	AL, DL		;budeme delit
	CMP	AL, 10		;je AL<10 ?
	JB	napis_continue2	;ak ano nulu pisat nemusime...
        MOV 	DL, 10		;inak vydelime
	DIV	DL		;AL=desiatky AH=jednotky
	PUSH    AX		;odlozime si vysledok..
	MOV	DL, AL		;
	ADD	dl, '0'		;(uprava na ASCII)
	MOV 	AH, 02H		;... lebo AH teraz menim
	INT 	21H		;pre sluzbu - vystup znaku
	POP	AX		;obnovim AX
	MOV	DL, AH		;a znovu tlacime

napis_continue2:
	ADD	DL, '0'		;znova uprava na ASCII
	MOV	AH, 02H		;vypise znak
	INT 	21H		;pre sluzbu - vystup znaku
	POP	DX		;obnovim obsah registrov pretoze...
	POP	AX		;... ich hlavny program potrebuje
	RET			;navrat do hl. programu

NAPIS_CISLO_DL	ENDP

;vypis oznamu pri prazdnom vstupe
aJustNapis:
	NAPIS	MUSITE_TEXT	;zdorazni a opakuje vyzvu
;-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

start:				;<--- ZACIATOK

	MOV	AX, SEG DATA	;inicializacia datoveho segmentu
	MOV	DS, AX
	MOV     AX, 0003H	;vymazem obrazovku
	INT     10H		;
	NAPIS   ZADAJ_TEXT	;info+vyzva pre vstup retazca
	MOV     DX, OFFSET MAX_DLZKA	;priprava na vstup
	MOV     AH, 0AH		;vstup s bufferom
	INT     21H		;nacitam ho
	CMP	[AKT_DLZKA], 0	;ak to bol prazdny retazec...
	JE	aJustNapis	;...nacitanie opakujem

;zobrazi ponuku funkcii
menu:
	NAPIS   MENU_TEXT	;vypise zoznam funkcii programu

;nacita uzivatelom zvolenu volbu 
volba:
	MOV     ah, 08h         ;nacitaj volbu
	INT     21h
				; spracovanie volby
	cmp     al, 'a'
	je      Menu_A
	cmp     al, 'b'
	je      Menu_B
	cmp     al, 'c'
	je      Menu_C
	cmp     al, 'd'		;nacitany znak je v AL
	je      Menu_D
	cmp 	al, 'e'
	je      Menu_E
	cmp 	al, 'f'
	je      Menu_F
	cmp 	al, 'g'
	je      Menu_G
	cmp	al, 'G'		;ak je zapnuty Caps Lock - aby sa dalo 
	je	Menu_G		;aspon vyskocit z programu
	JMP     volba           ;inak -> volba sa opakuje

;nasleduju nepodmiene skoky - pre velku dlzku programu,
;podmieneny skok by tak daleko nedoskocil...
	Menu_A:	JMP	prva
	Menu_B: JMP	druha
	Menu_C: JMP	tretia
	Menu_D: JMP 	stvrta
	Menu_E: JMP 	siesta
	Menu_F: JMP 	piata
	Menu_G: JMP 	koniec

;=1-1=1-1=1-1=1-1=1-1=1-1=
;sluzi na vypis povodneho retazca
prva:
	NAPIS	POVODNY		;sprava, ze vypisujeme povodny retazec
	NAPIS 	RETAZEC		;je tu pouzite makro na vypis retazca
	NAPIS	ODRIADKUJ	;nech kurzor neblika na konci retazca
	JMP 	cakaj		;aby si to uzivatel mohol pozriet

;=2-2=2-2=2-2=2-2=2-2=2-2=
;zisti pocet cislic v retazci
druha:
	XOR     CX,CX			;nulujem register CX...
	XOR     DX,DX			;...a register DX
	MOV	CL,[AKT_DLZKA]		;dlzka retazca je v pocitadle
	MOV 	BX,OFFSET RETAZEC	;zaciatok retazca v BX
druha_go:
	CMP	[BX],byte ptr '0'	;konverzia na 1 byte
	JB      druha2			;je to nizsie ako '0'?
	CMP	[BX],byte ptr '9'	;je to vyssie ako '9'?
	JA      druha2			
	INC     DL			;je to cislo => zvys pocitadlo
druha2:
	INC 	BL			;v kazdom pripade sa posun na dalsi znak
	LOOPNE  druha_go		;opakuj az kym CL==0
	NAPIS   POCET_CISEL_TEXT	;vypis
	call	NAPIS_CISLO_DL		;volame podprogram, kt vytlaci
	NAPIS	ODRIADKUJ		;cislo v DL, a odriadkujeme
	JMP	cakaj			;...a znovu do menu

;=3-3=3-3=3-3=3-3=3-3=3-3=
;najdenie pozadovaneho znaku
tretia:
	NAPIS	ZADAJ_ZNAK_TEXT		;co budeme hladat?
	MOV     ah, 01h         	;nacitaj znak - sluzba MS DOS
	INT     21h			;v AL je nacitany znak
	XOR     BX,BX			;pripravime si registre...
	XOR     DX,DX			;... tym, ze ich vynulujeme
	MOV	CL,[AKT_DLZKA]		;inicializujem pocitadlo
	MOV	BL,OFFSET RETAZEC	;BL=zaciatok retazca

tretia_go:
	CMP	AL,[BX]			;porovnavam so znakmi 
	JE      tretia_nasiel		;retazca

tretia_dalej:				;v kazdom pripad vykonam toto:
	INC     DL			;zvacsim index
	INC	BL			;zvacsim ukazovatel
	LOOPNE	tretia_go		;...az do konca retazca
	CMP	DH,0			;bol tam vobec znak?
	JNE     tretia_exit		;bol, to sme vypisali, koncime
	NAPIS   NENASIEL_ZNAK_TEXT	;nebol - informujem uzivatela

tretia_exit:
	NAPIS	ODRIADKUJ
	JMP	cakaj			;a navrat do menu

tretia_nasiel:
	CMP	DH,0			;nasli sme znak, je prvy?
	JNE     tretia_index		;ak nie je...
	NAPIS	ZNAK_INDEX_TEXT		;ak je prvy tlac info-text

tretia_index:
	call	NAPIS_CISLO_DL		;napis index znaku
	NAPIS   CIARKA_TEXT		;a oddel ho ciarkou+medzerou
	INC 	DH			;DH<>0 => uz bol vyskyt
	JMP	tretia_dalej		;pokracuje slucka

;=4-4=4-4=4-4=4-4=4-4=4-4=
;
stvrta:
	XOR     CX,CX			;nulujem register CX...
	XOR     DX,DX			;...a register DX
	MOV	CL,[AKT_DLZKA]		;dlzka retazca je v pocitadle
	MOV 	BX,OFFSET RETAZEC	;zaciatok retazca v BX
	MOV	DL, [BX]
	DEC	CL
	INC	BX

stvrta_go:
	CMP	[BX],DL			;konverzia na 1 byte
	JB      stvrta3			;je to nizsie ako '0'?

stvrta2:
	INC 	BL			;v kazdom pripade sa posun na 
	LOOPNE  stvrta_go		;dalsi znak, az kym CL==0
	NAPIS   NAJMENSI_TEXT		;vypis
	MOV	AH, 02H
	INT	21H
	MOV 	DX,OFFSET ODRIADKUJ	;cislo v DL, a odriadkujeme
	MOV	AH, 09H
	INT	21H
	JMP	cakaj			;...a znovu do menu

stvrta3:
	MOV	DL,[BX]
	JMP	stvrta2			;opakujeme slucku

;=5-5=5-5=5-5=5-5=5-5=5-5=
;zarovnanie textu sprava
piata:
	NAPIS	ZAROVNANIE		;vypise spravu
	XOR     CX, CX			;nulujem register CX
	MOV	CL, [AKT_DLZKA]		;dlzka retazca je v pocitadle
	MOV 	BX, OFFSET RETAZEC	;...a v BX prvy znak
	PUSH	CX			;uchovame si CX
	CMP	CL, 50H			;ak je dlzka retazca >80...
	JA	piata1			;...skocime na piata1
	MOV	DX, CX			;prepocitame pocet...
	XOR	CX, CX			;...medzier, ktore sa...
	MOV	CL, 4DH			;...od zaciatku vypisu 
	SUB	CX, DX

piata_go:
	MOV	DL, 00H			;tymto vypiseme potrebny pocet medzier
	MOV	AH, 02H			;funkcia MS DOS pre vypis znaku
	INT 	21H			;volanie sluzby MS DOS
	LOOPNE  piata_go		;dalsi znak, az kym CL==0
	POP	CX

piata_go2:
	MOV	DL, [BX]
	MOV	AH, 02H			;funkcia MS DOS pre vypis znaku
	INT 	21H			;volanie sluzby MS DOS
	INC	BL
	LOOPNE  piata_go2		;dalsi znak, az kym CL==0
	MOV 	DX,OFFSET ODRIADKUJ	;cislo v DL, a odriadkujeme
	MOV	AH, 09H
	INT	21H
	JMP	cakaj			;... a znovu

piata1:					;ak ma retazec >80 znakov
	MOV	CL, 50H			;a dame tam 80

piata1_go:				;takto pokracujeme
	MOV	DL, [BX]		;pricom vypisujeme znak po znaku
	MOV	AH, 02H			;funkcia MS DOS pre vypis retazca
	INT 	21H			;volanie sluzby MS DOS
	INC	BX			;po jednom znaku
	LOOPNE	piata1_go		;mi ich vypise vsetkych 80
	POP	CX
	SUB	CL, 50H
	MOV	DX, CX			;prepocitame pocet...
	XOR	CX, CX			;...medzier, ktore sa...
	MOV	CL, 4DH			;...od zaciatku vypisu 
	JMP	piata_go

;=6-6=6-6=6-6=6-6=6-6=6-6=
;konverzia malych pismen na velke
siesta:	MOV	DX,OFFSET VYPIS	;vypiseme spravu
	MOV	AH,09H		;funkcia MS DOS pre vypis retazca
	INT 	21H		;volanie sluzby MS DOS
	MOV 	BX, OFFSET RETAZEC
	MOV 	AL, AKT_DLZKA	;do AL dame dlzku retazca
	XOR 	AH, AH		;vyprazdnim AH
	MOV 	CX, BX		;
	ADD 	CX, AX

siesta_go:			;Cyklus na konvertovanie a vypis znakov
	CMP 	CX, BX		;porovnam si CX a BX
	JZ 	siesta2		;ak su rovnake, skocim na siesta2
	MOV 	AL, [BX]	;do AL si dam prvok na BX
	CMP 	AL, 60H		;ak jeho ASCII je "pod" malym 'a'...
	JBE 	siesta_go2	;...skocim na siesta_go2
	CMP 	AL, 7BH		;ak jeho ASCII nie je "pod" malym 'z'...
	JNB 	siesta_go2	;...skocim na siesta_go2
	SUB	AL, 20H		;inak male pismeno zvacsim na velke

siesta_go2:			;Vypis konvertovaneho znaku
	MOV 	DL, AL		;vypisujem znak
	MOV 	AH, 02H		;funkcia MS DOS pre vypis znaku
	INT 	21H		;volanie sluzby MS DOS
	INC 	BX		;skocim na nasledujuci znak...
	JMP 	siesta_go	;...a pracujem uz s nim

siesta2:			;koniec siesta_go a oriadkovanie
	NAPIS	odriadkuj	;skocim na dalsi riadok
	JMP 	cakaj		;Skok na zac. menu (po stlaceni klavesu)

;=x-x=x-x=x-x=x-x=x-x=x-x=
;pocka na vstup z klavesnice a nasledne zobrazi menu
cakaj:
	MOV     ah, 07h
	INT     021h            ;cakaj na stlacenie klavesu
	JMP	menu		;a vrat sa na vypis menu

;ukoncenie
koniec:
	MOV     AX, 0003H	;vymazem obrazovku
	INT     10H		;
	NAPIS 	BYE		;vypisem pozdrav
	MOV	AX, 04C00H	;korektne ukoncenie
	INT	21H
Code    ENDS
END     Start

;ZHODNOTENIE:
;program je funkcny
;pri vstupe by v retazci nemali byt znaky '$', pretoze znamenaju koniec retazca
;pouzival som programy ng a turbo debugger
