;Zadanie1.B
;Text zadania:
;Autor:Pavol Nemeth    
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001

;Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) a podla ponukaneho menu vykona  jednu z moznosti:
;a) vypise retazec znakov na obrazovku
;b) vypise pocet cislic v retazci
;c) zisti,ci sa v retazci nachadza pouzivatelom zadany znak a vypise o tom spravu
;d) najde znak s min. hodnotou a vypise tento znak
;e) mal pismeno konvertuje na velke
;f) zarovna text zprava ( vynecha prvy medzery odkonca)
;g) ukonci vykonavanie programu.

;Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;Nepouzivajte retazcov instrukcie!
;Zdrojovy program musi byt PODROBNE OKOMENTOVANY!


;---------------------------------------------------------------------
;---------------------------------------------------------------------
		zas     segment stack  ;definujem si zasobnik o velkosti
		dw      64 dup(?)      ;64 bajtov
		zas     ends
;---------------------------------------------------------------------
;---------------------------------------------------------------------
		data    segment
vstup           db      101 ;vstupny retazec o velkosti 100 znkov
pocet           db      0
		db      101 dup(?)
nr              db      10, 13, '$'
retazec         db      102 dup(?)
retazec2        db      102 dup(?)
retazec3        db      102 dup(?)
;---------------------------------------------------------------------
cislat          db      'Pocet cislic v retazci je : $';rozne vypisy ktore pouzivaju rozne procedurky
polohat         db      'Zadaj znak : $'
polohat1        db      13, 10, 'Zadany znak sa v retazci nenachadza $'
polohat2        db      13, 10, 'Poloha zadaneho znaku : $'
konvrtt         db      'Konvertovany retazec :', 13, 10, '$'
zarovt          db      'Retazec zarovnany zprava :', 13, 10, '$'
minimalt        db      'Znak s minimalnou hodnotou je : $'
zadajr          db      'Zadaj retazec : $'
menu            db      '1. Vypis zadaneho retazca.', 13, 10   ;vypis menu
		db      '2. Vypis poctu cislic v retazci.', 13, 10
		db      '3. Vypis polohy zadaneho znaku.', 13, 10
		db      '4. Male pismena konvertuje na velke.', 13, 10
		db      '5. Zarovna text zprava.', 13, 10
		db      '6. Vypise znak s minimalnou hodnotou.', 13, 10
		db      '7. Ukonci vykonavanie programu.', 13, 10, '$'
;---------------------------------------------------------------------
case            dw      vypret	;forma switch z vyssich jazykov(blizsie vysvetlene pri def. procedury volaj)	
		dw      cisla
		dw      poloha
		dw      konvrt
		dw      zarov
		dw      minimal
		dw      ukonc
		data    ends
;---------------------------------------------------------------------
;---------------------------------------------------------------------
		code    segment
		assume  ds:data, ss:zas, cs:code
;---------------------------------------------------------------------
ukonc           proc        ;procedura ,ktora ukonci cely program
		mov     ax, 4c00h;volam sluzbu dosu ,ktora ukonci program
		int     21h
		ret
ukonc           endp
;---------------------------------------------------------------------
cakaj           proc    ;procedura caka na stlacenie lubovolnej klavesy
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		mov     ah, 08h;volam sluzbu dosu,ktora nacita znak zo standardneho vstupu bez echa
		int     21h
		pop     dx cx bx ax;vyberam dane registre zo zasobnika
		ret
cakaj           endp
;---------------------------------------

cls             proc ;procedura co maze obrazovku
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		mov     ah, 00h ;pouzivam biosacke prerusenie int 10h - sluzby obrazovky
		mov     al, 003 ;sluzba 00h nastavuje mod obrazovky ulozeny v al(v tomto pripade text 80x25)
		int     10h
		pop     dx cx bx ax;vyberam dane registre zo zasobnika
		ret
cls             endp
;---------------------------------------------------------------------
vyptxt          proc    cpp  txt ;procedura na vypis lubovolnej textovej premennej
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		mov     ax, seg data;procedura ma jeden parameter(offsetovu adresu danej textovej premennej)
		mov     ds, ax;a pre ukladanie prarametrov do(a zo)zasobnika vyuziva volaciu konvenciu jazyka C++
		mov     dx, txt
		mov     ah, 09h;pouzivam dosovu sluzbu 09h na vypis retazca(zakonceneho '$')na adrese ds:dx
		int     21h
		pop     dx cx bx ax;vyberam dane registre zo zasobnika
		ret
vyptxt          endp
;---------------------------------------------------------------------
volaj           proc    ;procedura ktora vola dalsie procedury podla zadaneho znaku
		push    ax bx cx dx si;ukladam do zasobnika dane registre(pre istotu)
		call    cls
		call    vyptxt cpp, offset menu;vypis menu
		mov     ah, 08h;nacitam znak
		int     21h
		xor     ah, ah ;nulujem ah
		sub     al, 49d;ak bola stlacena cislica ziskam je hodnotu - 1
		cmp     al, 6d
		ja      volaj ;ak nebola stlacena cislica 1 - 7 ideme odznova
		xor     ah, ah
		sal     al, 1;vynasobim ziskanu hodnotu dvoma aby som sa mohol posuvat v 'strukture' case
		mov     si, ax
		call    [case + si];zavolam proceduru,ktorej je 'identifikator' je ulozeny na danom mieste 'struktury' case
		pop     si dx cx bx ax;vyberam dane registre zo zasobnika
		ret
volaj           endp

;---------------------------------------------------------------------
prevod          proc    cpp n  ;procedura vipise cislo ulozene v nejakom registri(funguje od 0 do 99)
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		mov     bl, 10d
		xor     cx, cx
		mov     cx, n
prevod1:        mov     ax, cx

		div     bl;v ax je delenec v bl delitel,delim desiatimi aby som zistil ci cislo mozem vytlacit
		cmp     al, 0;ak je celociselny podiel nula vytlacim cislo ktore je mensie ako 10
		jz      prevod2
		mov     dl, al    ;v ah je zvysok ,v je al podiel(ten je vzdy 0 - 9)
		add     dl, 48d   ;takto ziskam ascii hodnotu cisla,ktore vytlacim v dalsom kroku
		mov     ah, 02h                            ; vytlacim cislo v  najvyssom rade
		int     21h                                ; dl= asci hodn znaku ktoru sluzba 02h vytlaci na obrazovku
		mov     cl, ah                             ;v dalsom kroku uz delim zvysok
		jmp     prevod1
prevod2:        mov     dl, ah
		add     dl, 48d
		mov     ah, 02h
		int     21h
		pop     dx cx bx ax;vyberam dane registre zo zasobnika
		ret
prevod          endp
;--------------------------------------

vypret          proc    ;procedura vypise zadany retazec znak po znaku aby sa vytlacili aj pripadne zadane znaky $
		push    ax bx cx dx si;ukladam do zasobnika dane registre(pre istotu)
		call    cls
		mov     bx, offset retazec
		xor     cx, cx
		mov     cl, pocet
vypret1:        mov     dx, [bx]
		mov     ah, 02h
		int     21h
		inc     bx
		loopne  vypret1
							   ;call    vyptxt cpp, offset retazec  pri pouziti tejto fcie sa nezobrazia znaky $$$
		pop     si dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
vypret          endp
;---------------------------------------------------------------------
konvrt          proc    ;procedura konvertuje vsetky male pismena v retazci na velke
		push    ax bx cx dx si;ukladam do zasobnika dane registre(pre istotu)
		call    cls
		mov     si, offset retazec
		mov     bx , offset retazec2;konvertovany retazec
		xor     cx, cx
		mov     cl, pocet
konvrt1:        mov     al, [si]
		cmp     al, 61h                ;test na male pismeno
		jb      konvrt2
		cmp     al, 7ah
		ja      konvrt2   ;ak znak nie je male pismeno konverzia neprebehne
		sub     al, 32d
konvrt2:        mov     [bx], al
		inc     si
		inc     bx
		loopne  konvrt1

		mov     bx , offset retazec2
		call    vyptxt cpp, offset konvrtt;vypis spravy
		mov     cl, pocet
konvrt3:        mov     dx, [bx]       ;necham retazec vypisat po znaku aby sa zobrazil aj znak $(ak som ho zadal do retazca)
		mov     ah, 02h
		int     21h
		inc     bx
		loopne  konvrt3

		pop     si  dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
konvrt          endp
;---------------------------------------------------------------------
cisla           proc
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		call    cls ;vymazem obrazovku
		xor     cx, cx
		mov     dx, offset retazec
		mov     si, dx
		xor     bx, bx; vynulujem bx
		mov     cl, pocet;cyklus opakujem tolko krat kolko je znakov v retazci
cisla1:         cmp     byte ptr [si], '0';test ,ci je dany znak cislo
		jb      cisla2
		cmp     byte ptr [si], '9'
		ja      cisla2            ;ak dany znak nie je cislo opakujem cyklus bez inkrementacie bx
		inc     bx                ;ak ano,inkrementujem bx a opakujem cyklus
cisla2:         inc     si
		loopne  cisla1
cisla3:         call    vyptxt cpp, offset cislat
		call    prevod  cpp, bx ;necham vypisat cislo ulozene v bx(co je vlastne pocet cislic v retazci) na obrazovku
		pop     dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
cisla           endp
;--------------------------------------
poloha          proc;ak sa zadany znak v retazci nachadza ,procedura vypise jeho polohu,
		     ;ak nie,potom vypise spravu o tom ,ze sa v retazci znak nenachadza
		push    ax bx cx dx;ukladam do zasobnika dane registre(pre istotu)
		call    cls
		call    vyptxt cpp, offset polohat
		mov     ah, 01h
		int     21h
		xor     bx, bx
		mov     dx, offset retazec
		mov     si, dx
		xor     cx, cx
		mov     cl, pocet
poloha1:        inc     bx                                 ;cyklus prejde vzdy aspon jeden krat
		cmp     [si], al                           ;porovnavam pole so zadanym znakom
		je      poloha2
		inc     si
		loopne  poloha1                            ; ak sa znak nahodou v retazci nevyskytuje ,cyklus nepojde do nekonecna
poloha2:        cmp     cx, 0                              ;ak je v cx nula, cyklus presiel pocet krat a znak sa nenasiel
		ja      ok
nieje:          call    vyptxt c, offset polohat1;vypisem spravu ,ze sa znak v retazci nevyskytuje
		jmp     poloha3

ok:           	call    vyptxt c, offset polohat2
		call    prevod cpp, bx

poloha3:        pop     dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
poloha          endp

;--------------------------------------
zarov           proc  ;procedura zarovna retazec zprava takym sposobom,ze vynecha zprava vsetky medzery a cely text posunie doprava o pocet vynechanych medzier
		push    ax bx cx dx si;ukladam do zasobnika dane registre(pre istotu)
		call    cls ;mazem obrazovku
		mov     si, offset retazec
		xor     ax, ax
		mov     al, pocet

		add     si, ax
		dec     si                                 ;si ukazuje na posledny znak retazca


		xor     ax, ax
		xor     cx, cx
		mov     cl, pocet
		inc     cl                                 ;lebo pointer si neukaz na $(posledny) ale na znak pred nim
zarov1:         cmp     byte ptr[si], 32d;test na medzeru
		jne     zarov2                             ;pri prvom znaku zprava, ktory nie je medzera opustim cyklus
		inc     ax
		dec     si
		loopne  zarov1                             ;zabezpeci ze nebude nikdy neverending story

		   ;si ukazuje na prvy viditelny znak zprava
				   ;v ax je pocet medzier zprava

zarov2:         cmp     ax, 0    ;ak zprava nie su ziadne medzery rovno retazec vypisem
		je      zarov6
		xor     cx, cx
		mov     cl , pocet
		sub     cx, ax
		   ;v counteri je pocet znkov v retazci bez medzier zprava

		push    cx                                 ;ulozim tuto hodnotu do zasobnika

		mov     bx, offset retazec3

		mov     cx, ax;na lavu stranu retazca dam tolko medzier ,kolko bolo na pravej
zarov3:         mov     byte ptr[bx], 32d
		inc     bx
		loopne  zarov3



		mov     si, offset retazec
		mov     bx, offset retazec3
		add     bx, ax
		pop     cx ;necham retazec vypisat po znaku aby sa zobrazil aj znak $
zarov4:         mov     al, [si]; v tomto cykle skopirujem do zarovnaneho retazca zvysne znaky
		mov     [bx], al
		inc     bx
		inc     si
		loopne  zarov4

		mov     byte ptr[bx], '$'
		mov     bx, offset retazec3

		call    vyptxt cpp, offset zarovt
		xor     cx, cx
		mov     cl, pocet
zarov5:         mov     al, [bx]
		mov     dl, al
		mov     ah, 02h
		int     21h
		inc     bx
		loopne  zarov5
		jmp     zarov7

zarov6:         call    vyptxt cpp, offset zarovt;ak zprava nie su ziadne medzery rovno retazec vypisem

		mov     si, offset retazec
		xor     cx, cx
		mov     cl, pocet;vypisem retazec znak po znaku
opakuj:         mov     dx, [si]
		mov     ah, 02h
		int     21h
		inc     si
		loopne  opakuj


zarov7:         pop     si dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
zarov           endp
;--------------------------------------
minimal         proc;procedura najde v retazci znak s minimalnou hodnotou a vypise ho na obrazovku
		push    ax bx cx dx si;ukladam do zasobnika dane registre(pre istotu)
		call    cls
		mov     bx, offset retazec

		xor     ax, ax
		mov     al,[bx];zacnem porovnanim prveho znaku
		xor     cx, cx
		mov     cl , pocet


minimal1:       cmp     byte ptr[bx], al;postupne porovnavam znaky
		jb      minimal2 ;ak ma znak mensiu hodnotu ulozim ho do al
		inc     bx
		jmp     minimal3;ak nie,neulozim znak nikam a pokracujem v cykle

minimal2:       mov     al, [bx]
		inc     bx

minimal3:       loopne  minimal1


		call    vyptxt cpp, offset minimalt
		mov     dl, al
		mov     ah, 02h
		int     21h

		pop     si dx cx bx ax;vyberam dane registre zo zasobnika
		call    cakaj
		call    volaj
		ret
minimal         endp
;--------------------------------------
start:          call    cls
		call    vyptxt cpp, offset zadajr
		mov     ax, seg data
		mov     ds, ax
		mov     dx, offset vstup
		mov     ah , 0ah                           ;bufferovany vstup retazca
		int     21h
		mov     dx, offset vstup
		add     dx, 2
		mov     si, dx
		mov     bx, offset retazec
		xor     ax, ax
		xor     cx, cx
		mov     cl, pocet
cyklus1:        mov     al, [si]
		mov     [bx], al
		inc     si
		inc     bx
		loopne  cyklus1
		mov     byte ptr[bx], '$'
		mov     bx, offset retazec

		call    volaj
		call    ukonc
		code    ends
  end     start


;Program je funkcny ,pri zadavani vstupneho retazca sa moze zadat aj znak '$',ktory jednotlive procedury neignoruju.
;Je tomu tak preto ,lebo pouzivam bufferovany vstup retazca pomocou sluzby dosu 0ah,ktora zisti pocet jednotlivych znakov v retazci.
;Program mozno kedykolvek zhodit stlacenim ^C.Pri tvorbe progamu som pouzil Turbo Assembler Version 3.1 Copyright(c) 1998,
; 1992 Borland International ako aj Turbo Link Version 5.1 Copyright(c) 1992 Borland International.
;Co sa tyka technickeho vybavenia pouzival som  striedavo pocitace PENTIUM 100 a 386 DX, vzdy ten, pri ktorom v tom case nikto nerobil.
;Chovanie  programu  vzhladom  na pouzite sluzby DOS resp. BIOS , popis vlastnych pouzitych algoritmov, upozornenie na taktiky
;a finty, ktore som pri tvorbe progamu pouzil som uz stihol popisat priamo pri komentovani jednotlivych procedur.
;Program na zacitku nacita retazec pomocou bufferovaneho vstupu(sluzba 0ah).Potom vola proceduru volaj ,ktora vypise menu a vola
;dalsie procedury na zaklade slacenej klavesy.Na konci kazde takejto procedury volam opat proceduru volaj.(Okrem jednej - ukonc, ta ukoncuje program.)