ZAS	SEGMENT STACK 'stack'		;Deklaracia zasobnikoveho modulu o velkosti
	DW 64H DUP(?)		; 101 Bytov
ZAS	ENDS			;Koniec deklaracie

DATA	SEGMENT                 ;Deklaracia datovej oblasti
TEXT	DB 64H DUP('$')		;Vytvorenie stringu o velkosti 100 Bytov
Menu	db ''
	db 13,10,' (1)  Zadanie noveho retazca'
	db 13,10,' (2)  Vypis retazec '
	db 13,10,' (3)  Vypis pocet cislic '
	db 13,10,' (4)  Najdi znak'
	db 13,10,' (5)  Najdi znak s min. hodnotou'
	db 13,10,' (6)  Male pismena konverguj na velke'
	db 13,10,' (7)  Zarovnaj text zprava'
	db 13,10,' (8)  Odchod z programu'
	db 13,10,': $'
MEDZERE	db 80 DUP('$')
RIADOK1 db 81 DUP('$')
RIADOK2	db 21 DUP('$')
STL_KEY	db 13,10,13,10,'Stlac klavesu...$'
CISLOTEXT db 'Cislic v retazci je: ' 
CISLO   db 0,0,'$'
KONVERTUJEM db 13,10,'sa skonvertoval na:',13,10,'$'
PRAZDNYRETAZEC  db 'Retazec je prazdny!$';
UPOZORNENIE	db '  Ukonci ENTER-om ,alebo zanakom $'
TERAZNAPISTEXT	db '.',13,10,13,10,'Teraz napis retazec : $'
MINZNAKTEXT db 'Znak v retazci s najmensou hodnotou  je: ',39
MINZNAK	    db 0,39,'$'
NENASIELZNAK	db ' sa nenachadza v retazci!$'
NASIELZNAK	db ' sa nachadza v retazci!$' 
ZADAJZNAK 	db ' Napis znak, ktory ma byt vyhladany: $'
DATA	ENDS			;Koniec deklaracie


CODE	SEGMENT			;Zaciatok kodoveho segmentu
	ASSUME CS:CODE,DS:DATA,SS:ZAS		;direktiva
;
CLRSCR PROC		
	MOV AX, 03H		;Funk. 0- text. mod,
				;3  zmaze obrazovku
	INT 10h			;Vykonanie ziadosti BIOS-funkciou
	RET
ENDP
PRINT	PROC			;Funk. v DX ocakava OFFSET 'nametext'
	MOV AH, 09H		;ziadost o vystup textu na obrazovku
				;v dx je offset textu ,kt. sa vypise
	INT 21H			;vykonanie
	RET			;navrat
ENDP
CAKKLAV	PROC
	MOV DX, OFFSET STL_KEY	; v STL_KEY je retazec
				; 'Stlac klavesu ...'
	call PRINT		; Vypis ho.

	MOV AH, 7		; cakanie na stlacenie klavesy
	INT 21h			
	RET			; navrat
ENDP
DLTEXT PROC
	XOR CL,CL       	; v CL bude pocet znakov (vystup funkcie)
	MOV SI, OFFSET TEXT
SLUCKA_ZISTIP:
	MOV AL, [SI]		; Tu cita postupne znaky az po $
	CMP AL, '$'
	JZ  KONIEC_ZISTIP	; Ak znak je $ skoc ...
	INC SI			; SI=SI+1
	INC CL			; CL=CL+1
	JMP SLUCKA_ZISTIP	; Zopakuj slucku
KONIEC_ZISTIP:
	RET			; navrat
ENDP
PRAZRET PROC
	MOV SI, OFFSET TEXT
	XOR BL, BL		; BL-vysledok porovnania.
	MOV AL, [SI]		; Ak sa AL zac. $ ukonci podprogram 
	CMP AL, '$'		 
	JNZ  NEPRAZDNY		
        MOV BL, 1
	MOV DX, OFFSET PRAZDNYRETAZEC ;  vyp. PRAZDNYRETAZEC
	call PRINT
NEPRAZDNY:
	RET			; navrat
ENDP
VYPCISL PROC			;funk  BL cislo od 0-255
	XOR AH, AH		; AX (16 bit) osembitove cislo.
	MOV AL, BL		
    	MOV BH, 10		; Do BH  10
	DIV BH			; AL = AX / 10
				; AH = AX mod 10
	MOV SI, OFFSET CISLO	; SI  pointer CISLO
	ADD AL, 30H		; Cislo->ASSCI
	MOV [SI], AL		; vysl.do CISLO[1.pozicia]
	INC SI			; pointer na CISLO+1
	ADD AH, 30H		; Cislo -> ASSCI
	MOV [SI], AH		; vysl.do CISLO[2.pozicia]
	MOV DX, OFFSET CISLOTEXT; Vypise vetu s cislom ako TEXT
	call PRINT		; Vykonaj
	RET			; Prerusenie a navrat
ENDP
M1_NACTEXT PROC
	MOV DX, OFFSET UPOZORNENIE	; Vypise upozornenie 
	call PRINT
	MOV DL, '$'		; Vypise  $
	MOV AH, 2		;
	INT 21H			;
	MOV DX, OFFSET TERAZNAPISTEXT	
	call PRINT			
	MOV SI, OFFSET TEXT	; Nadstavi  SI
	XOR CL,CL		; Vynuluje POCITADLO
SLUCKA_M1:
	MOV AH, 7		; vstup z klavesnice
	INT 21H  		
	INC CL
	CMP CL, 100
	JAE KONIEC_M1
	CMP AL, 13		; Porov. Stlac ENTER 
	JZ  KONIEC_M1		; ak ano skoc na KONIEC_M1 
	CMP AL, '$'		; Porovna AL s 'koncom stringu'
	JZ  KONIEC_M1		; ak sa rovna, pojde na zaciatok slucky
        CMP AL, 20H		; Ak nebol stlac. ENTER, ale 
	JL  SLUCKA_M1		; nevyd. znak, potom  nac. klav
	MOV DL, AL		; Vyp. znaku 
	MOV AH, 2		;
	INT 21H			;
	MOV [SI],AL		; Presun z AL do adresy TEXTu (SI)
	INC SI			; Pos sa o jedno miesto v adrese TEXTu dalej
        JMP SLUCKA_M1               ;chod odznova
KONIEC_M1:			; Ak bol stlaceny ENTER
	MOV AL, '$'             ; Vloz do AL ukoncovaci znak '$'
	MOV [SI],  AL		; Presun znak v AL na koniec TEXTu.
        RET			
ENDP
M2_VYPTEXT	PROC		; vypise nas retazec v premennej text
        call PRAZRET		; skontroluje jeho dlzku
     	CMP BL, 1		; ak ano (true=1), potom skoc na
	JZ KONIEC_WR_TEXT	; KONIEC_WR_TEXT

	MOV DX, OFFSET TEXT	; v opacnom pripade vypis text
	call PRINT
KONIEC_WR_TEXT:	
	RET			
ENDP
M3_VYPCISL PROC
        call PRAZRET		; prazdny retazec? (BL)
     	CMP BL, 1		; 1 = TRUE a 0 = FALSE
	JZ KONIEC_M3		; ak je prazdny, na KONIEC_M3
        XOR CL, CL		
	MOV SI, OFFSET TEXT	; do SI nadstav pointer na TEXT
SLUCKA_M3:			; zaciatok cyklu s vyhladavanim cisiel
	MOV AL, [SI]		; Do AL presunie znak z TEXTu
	CMP AL, '$'		; porovnaj obsah AL s $ (koniec textu)
	JZ VYPIS_M3		; ak sa rovnaju, potom skoc na VYPIS_M3
	CMP AL, '0'		
	JL  VON_M3		
	CMP AL, '9'		
	JA  VON_M3		; a ak nie skoc na VON_M3
	INC CL			; a ak ano, inkrementuj CL
VON_M3:				; ak v AL nebolo cislo, alebo CL bolo inkr. 
	INC SI			; nadstav SI o znak dalej v TEXTe
	JMP SLUCKA_M3		
VYPIS_M3:		
	MOV BL, CL      	; Podprogram VYPCISL predpoklada vstup v BL
	call VYPCISL		; vypise cislo  (zo vstupu BL)
KONIEC_M3:
	RET			; Ukoncenie podprogramu
ENDP
M4_HLADZNAK PROC
        call PRAZRET		; Je prazdny retazec?
     	CMP BL, 1
	JZ KONIEC_M4		; Ak ano, skoc na KONIEC_M4

	MOV DX, OFFSET ZADAJZNAK; Vypise 
	call PRINT		; ze ma zadat nejaky znak.
	MOV AH, 01		; Citame znaku
	INT 21H			; Vykonanie
	MOV BL, AL		; V BL je nacitany znak
	MOV SI, OFFSET TEXT	; Nadstavy SI na pointer TEXT
SLUCKA_M4:
	MOV AL, [SI]		; Do AL  prvy (2., 3., atd) znak z TEXTu
	CMP AL, '$'		; AL porovna so znakom '$'
	JZ END0_M4		; Ak je rovny, END0_M4 
	CMP AL, BL		; AL porovna s BL 
	JZ  END1_M4		; Ak je rovny,  END1_M4 
	INC SI			; Posunie SI o jeden znak dalej
	JMP SLUCKA_M4		; Zopakuje postup od navestia SLUCKA_M4
END0_M4:			; Vypise , ze nenasiel hladany znak
	MOV DX, OFFSET NENASIELZNAK
        call PRINT
	JMP KONIEC_M4
END1_M4:			; Vypise , ze hladany znak nasiel
	MOV DX, OFFSET NASIELZNAK
	call PRINT
KONIEC_M4:
	RET			
ENDP
M5_HLADMZNAK PROC
        call PRAZRET		; Ak je prazdny retazec,
     	CMP BL, 1
	JZ KONIEC_M5		; Potom skoc na KONIEC_M5
	MOV SI, OFFSET TEXT
	MOV BL, [SI]		; Do BL ulozi prvy znak
	INC SI			; Text nizsie  od druheho znaku
SLUCKA_M5:
	MOV AL, [SI]		; Nacitanie Z textu
	CMP AL, '$'		; Ak je koniec retazcu,
	JZ  END1_M5		; skoc na END1_M5
	CMP BL, AL		; Porovnanie
        JLE PRESKOC_M5		; Ak znaky v BL <= AL, skoc na PRESKOC_M5
	MOV BL, AL		; inak daj do BL hodnotu v AL
PRESKOC_M5:
	INC SI			; SI=SI+1
	JMP SLUCKA_M5		; Zopakuj cyklus
END1_M5:			; Vypise vetu, zi 'min. znak je ...'
	MOV MINZNAK, BL
	MOV DX, OFFSET MINZNAKTEXT
	call PRINT
KONIEC_M5:
	RET			
ENDP
M6_MALNAVEL PROC		
        call PRAZRET		; Je prazdny retazec?
     	CMP BL, 1		; ak ano, ...
	JZ KONIEC_M6		; skoc na KONIEC_M6
	MOV DX, OFFSET TEXT	; Vypise este nezmeneny retazec
	call PRINT
	MOV SI, OFFSET TEXT	; Nadstavi pointer
SLUCKA_M6:
	MOV AL, [SI]		; Do AL presunie hodnotu v [SI]
	CMP AL, '$'		; Zisti, koniec riadku
	JZ VYPIS_M6		; 
	CMP AL, 'a'		; Zisti ci  v AL je male pismeno
	JL  VON_M6		;
	CMP AL, 'z'		;
	JA  VON_M6		; 
	SUB AL,20H		; Ak ano,AL=AL-20H
	MOV [SI], AL		; Zmenu zapise do [SI]
VON_M6: 
	INC SI			; Pointer nadstavi na znak dalej
	JMP SLUCKA_M6           
VYPIS_M6:	
	MOV DX, OFFSET KONVERTUJEM	; Dopise  za TEXT dalsie 
	call PRINT		; string v premennej KONVERTUJEM
	MOV DX, OFFSET TEXT	; A potom vypise zmeneny TEXT
	call PRINT		; Vykona
KONIEC_M6:
	RET			
ENDP
M7_ZARNAPRAVO	PROC
	call PRAZRET		; Vysledok je v BL
	CMP BL, 1
	JZ  KONIEC_M7
	MOV BL, 80		; Priprava vstupov pre podprogram 
        SUB BL, CL 		; 	-- || --
	call VYPISVELAMEDZER	; V BL je pocet medzer na vypisanie, ktore
				; vypise
	MOV DX, OFFSET TEXT	; Za medzerami vypise text
	call PRINT
	JMP KONIEC_M7
	
KONIEC_M7:
	RET
ENDP

VYPISVELAMEDZER PROC
STARTVYPISM:
	CMP BL, 0		; Ak BL=0, potom skonci
	JZ  KONIECVYPISM
	CMP BL, 79		; Ak BL>79 => BL=BL-80 => skoc na 
	JA VYPISMJENAD79
				; Ak je vsetko v poriadku, pokracuj
	MOV SI, OFFSET MEDZERE	; Nadstav pointer v SI
	XOR CL, CL		
	MOV AL, ' '		; Do AL presun medzeru
SLUCKAVYPISM:
	CMP CL, BL		; Ak je CL>=BL skoc na DOPLNZNAK$AVYPISHO
	JAE  DOPLNZNAK$AVYPISHO	; 
	MOV [SI], AL		; Ak CL<>BL, potom presun medzeru (AL) do [SI]
	INC SI			; SI = SI+1 (posun o jedno miesto dalej)
	INC CL      		; CL = CL+1
	JMP SLUCKAVYPISM	
DOPLNZNAK$AVYPISHO:
	MOV AL, '$'
	MOV [SI], AL
	MOV DX, OFFSET MEDZERE	; Vypise pocet medzier
	call PRINT
	JMP KONIECVYPISM
VYPISMJENAD79:
	SUB BL, 80		; BL = BL - 80
	JMP STARTVYPISM		
KONIECVYPISM:
	RET			
ENDP
;
START:	

	MOV AX, SEG DATA	;do DS vlozi segmentovu cast adresy DATA
	MOV DS, AX
;
	call CLRSCR		

	call M1_NACTEXT	; Spusti podprogram na nacitanie textu
PROGRAM:
	call CLRSCR		
	MOV DX, OFFSET Menu	; Vypise MENU
	call PRINT
VYBERMENU:
	MOV AH, 7		; Funkcia na nacitanie klavesy 
	INT 21h			; Vykonanie
	CMP AL, '1'		
	JZ MENU_1		
	CMP AL, '2'		
	JZ MENU_2		
	CMP AL, '3'		
	JZ MENU_3		
	CMP AL, '4'		
	JZ MENU_4		
	CMP AL, '5'		
	JZ MENU_5		
	CMP AL, '6'		
	JZ MENU_6		   
	CMP AL, '7'		
	JZ MENU_7		
        CMP AL, '8'             
        JZ MENU_8		
	JMP VYBERMENU		
MENU_1:
	call CLRSCR
	call M1_NACTEXT
	JMP PROGRAM
MENU_2:
	call CLRSCR
	call M2_VYPTEXT
	call CAKKLAV
	JMP PROGRAM
MENU_3:
	call CLRSCR
	call M3_VYPCISL
	call CAKKLAV
	JMP PROGRAM
MENU_4:
	call CLRSCR
	call M4_HLADZNAK
	call CAKKLAV
	JMP PROGRAM
MENU_5:
	call CLRSCR
	call M5_HLADMZNAK
	call CAKKLAV
	JMP PROGRAM
MENU_6:
	call CLRSCR
	call M6_MALNAVEL
	call CAKKLAV
	JMP PROGRAM
MENU_7: 
	call CLRSCR
	call M7_ZARNAPRAVO
	call CAKKLAV
	JMP PROGRAM
MENU_8: JMP KONIEC
	JMP PROGRAM
;
KONIEC:
	MOV AH, 4CH		;ukoncenie programu
	MOV AL, 00H		;vratime navratovu hodnotu 0
	INT 21H			
CODE	ENDS
	END START

