;Zadanie c.2
;Autor             : Stefan Novak, B/11 
;Text zadania      : Napiste program, ktory nacita zo suboru postupnosty cisle
;		     v desiatkovej sustave, potom ich konvertuje do dvojkovej v 
;		     doplnkovom kode.A potom vykona operacie.(min. 10 cisel)
;		     1. Vypise sumu.
;		     2. Zoradi cisla vzostupne a zapise ich do subora.
;		     3. Zoradi cisla zostupne a zapise ich do subora.
;		     4. Vynasobi dve cisla.
;		     5. Vydeli dve cisla.
;		     6. Ukonci program.		
;
;Termin odovzdania : 14.11.2000
;2.roc., sk.roku 2000/2001

zas     segment stack
        dw      64 dup(0)    
zas     ends

data    segment
text1   db 10,13,'Vypis sumu vsetkych cisel ..........................[1] $'
text2   db 10,13,'Usporiadaj cisla zostupne a zapis ich do suboru ....[2] $'
text3   db 10,13,'Vynasob dve cisla ..................................[3] $'
text4   db 10,13,'Vydel dve cisla ....................................[4] $'
text5   db 10,13,'Koniec .............................................[5] $'
text7   db 10,13,'Zadaj prve cislo a1 = (a1/a2 or a1*a2) $'
text8   db 10,13,'Zadaj druhe cislo a2 = (a1/a2 or a1*a2) $'
text9   db 10,13,'Vysledok je : $'
text10  db 10,13,'Zvysok pod deleni je : $'
text11  db 10,13,'Suma vsetkych cisel je : $'
text12  db 10,13,'Stlac klavesu. $'
texter1 db 10,13,'Chyba! Delenie nulou. $'
texter2 db 10,13,'Doslo k preteceniu alebo podteceniu. $'
texter3 db 10,13,'Subor nie je dobre zadany. $'

tempo   dw 0
tempz   dw 0

precit  db 200 dup(0)
cisla   db 200 dup(0)
dopkod  db 200 dup(0)
zosort  db 200 dup(0)
out1    db 200 dup(0)
cislo   db 100  
pocet   db 0
poce    db 0
poc     db 0
max     db 0 
zac     db 0
signum   db 0

filein  db 'data.in',0
fileout db 'data.out',0
data    ends 

code    segment
assume  cs:code, ds:data, ss:zas;
start:
        call crfile     ;vytvor subor
        call opfile     ;otvor subor
	call refile     ;nacitaj subor
        call deca       ;skontroluj ho a zapis do pamete
	call dopl       ;konvertovanie do doplnkovho kodu
	call menu       ;volaj menu

;------------------------------Procedury---------------------------------------;
;Vypis menu

menu    proc
	push ax
	xor ah, ah                           ;;
	mov al, 3                             ;;  vymazanie obrazovky.
	int 10h                              ;;
        pop ax
    	mov dx, offset text1	
    	mov ah, 09h
    	int 21h
    	mov dx, offset text2
    	mov ah, 09h
    	int 21h
    	mov dx, offset text3
    	mov ah, 09h
    	int 21h
	mov dx, offset text4
    	mov ah, 09h
    	int 21h
    	mov dx, offset text5
    	mov ah, 09h
    	int 21h
	

	mov ah, 08h               ;
	int 21h                   ;
	cmp al, '1'               ;
	jz  jedna                 ;
	cmp al, '2'               ;
	jz  dva                   ;
	cmp al, '3'               ;; Kontrola co ma vykonat
	jz  tri                   ;
	cmp al, '4'               ;
	jz  styri                 ;
	cmp al, '5'               ;
	jz  pat                   ;
	jmp menu
jedna:  call suma
dva:    call zostup
tri:    call nasob
styri:  call delenie
pat:    call koniec
        ret
menu    endp

suma    proc                      ;Procedura na vypocet sumy
        mov cl, pocet		  ;pocet cisel na spocitanie
	xor ax, ax
	xor dx, dx		
	mov bx, offset dopkod	  ;nastav sa na cisla v dopkode
zas2:	mov al, [bx]              ;
        inc bx	                  ;nacitanie cisla do ax
        mov ah, [bx]		  ;
        inc bx			  ;
        add dx, ax		  ; do dx ide suma
        jno s 			  ; kontrola pretecenia
	call pretecenie		
s:      loopne zas2		  ; kym sa nespocitaju vsetky
        push dx
	mov dx, offset text11     ;
	mov ah, 09h               ;
	int 21h                   ; priprava na vypis vysledku.
	pop dx                    ;
	push dx                   ;
        mov cx, dx                ;
	call vypcis		  ; vypis cisla (vysledku) ma obrazovku
	call stlac
        call menu		
	ret
suma    endp

zostup  proc
	mov cl, pocet		;pocet porovnani
	dec cl

dz3:    push cx			; v cx je ulozeny pocet porovnani
   	mov bx,offset zosort
dz1:
	push cx
	mov ax,[bx]		;ax je 1. cislo
	add bx,2
	mov dx,[bx]		;dx je 2. cislo
	push cx
	push bx
	jmp znamienko		;chod zistit znamienka ax a dx
	
zz:				;zz ak obidve - -
	pop bx
	pop cx
	cmp ax,dx		;zisti ktore je vacsie
	jae dz4			;ak netreba menit
	jb dz2			;vymen

kk:				;kk skace ak obidva cisla + +
	pop bx
	pop cx
	cmp ax,dx
	jae dz4
	jb  dz2
zk:				;navestie zk je ekvivalentne s dalej2
				;zk: prve- druhe+, automaticky vymen
dz2:	mov cx,ax		;vymena
	mov si,bx
	sub bx,2
	mov [bx],dx
	mov [si],cx
	add bx,2		;posun sa na dalsie cislo

kz:				;navestie kz je ekvivalentne s dalej4
				;kz:1.+,2.- automaticky nevymienaj
dz4:	pop cx			;bez vymeny dalej
	dec cx
	cmp cx,0
	jne dz1
	pop cx
	dec cx
	cmp cx,0
	jne dz3
	call wrfile             ; zapis do suboru
        call menu
znamienko:
	test ax,1000000000000000b	; ci je - or +
	jz axklad
	jnz axzap
q:	test dx,1000000000000000b	
	jz dxklad
	jnz dxzap
axklad:					;cl indikuje znamienko ax
	mov cl,0			;cl=0 ak ax>0
	jmp q
axzap:
	mov cl,1
	jmp q

dxklad:
	mov bl,0			;bl indikuje znamienko dx
	jmp qq				;bl=0 ak dx>0	
dxzap:
	mov bl,1
	jmp qq
qq:	
	mov ch,cl
	and ch,bl			;ch sucin cl,bl
	cmp ch,0 	
	je  qqq				;ak je sucin 0 mozu nastat 3 pripady
	cmp ch,1
	je w				;ax<0  dx<0
qqq:	cmp cl,bl
	je ww				;ax>0  dx>0
	ja www				;ax<0  dx>0
	jb wwww				;ax>0  dx<0
w:	jmp zz
ww:	jmp kk
www:	
	pop bx
	pop cx
	jmp zk
wwww:	
	pop bx
	pop cx
	jmp kz
	ret
zostup  endp



delenie proc
	xor di,di
	mov di,5		;di je pocet cisel za desatinou ciarkou
	mov dx,offset text7    ;;
    	mov ah,09h              ;
    	int 21h                 ;
	push dx                 ;
	push si                 ;
	mov dx, offset cislo    ;
	mov ah ,0Ah             ;
	int 21h                 ;
	mov dx, offset cislo    ;
	add dx, 2               ;
	mov si, dx              ;;; Nacitanie poradoveho cisla.
	mov al, [si]            ;
	sub al,30h              ;
	mov ah, al              ;
	inc si                  ; 
	mov al, [si]            ;
	sub al, 30h             ;
	aad                     ;
	dec al                  ;
	pop dx                  ;
	pop si                  ;
	push ax                ;;al = porad. cislo citatela

;------zisti znamienko prveho cisla
	mov bx,offset precit
	mov ah,6
	mul ah			
	add bx,ax		;bx+ax+1 = adresa znamienka vybraneho cisla
	mov cl,[bx]
	cmp cl,'+'
	je  pozit
	mov cl,1		;ak je 1.cislo zaporne cl=1
	jmp next1
pozit:  mov cl,0		;ak je kladne nech cl je 0
next1:
	mov [signum],cl		;uloz cl do sign.of.reminder(bude to aj znamienko zvysku)
;--------

	pop ax
	mov ah,2		;musime sa pohybovat po wordoch
	mul ah   
	mov bx,offset cisla
	add bx,ax		;nastav sa na adresu citatela
	mov ax,[bx]	
	push ax	                ;ax = citatel
	push ax	              	
    	mov dx,offset text8     ;;
    	mov ah,09h               ;
    	int 21h                  ;
	push dx                  ;
	push si                  ;
	mov dx, offset cislo     ;
	mov ah,0Ah               ;
	int 21h                  ;
	mov dx, offset cislo     ;
	add dx, 2                ;
	mov si, dx               ;;; Poradove cislo druheho
	mov al, [si]             ;
	sub al,30h               ;
	mov ah, al               ;
	inc si                   ;
	mov al, [si]             ;
	sub al, 30h              ;
	aad                      ;
	dec al                   ;
	pop dx                   ;
	pop si                   ;
	push ax                 ;; do al

;-------zisti znamienko druheho cisla
	mov bx,offset precit
	mov ah,6
	mul ah			
	add bx,ax		;bx+ax+1 = adresa znamienka vybraneho cisla
	mov ch,[bx]
	cmp ch,'+'
	je  pozit0
	mov ch,1
	jmp next10
pozit0:  mov ch,0
next10:
	xor cl,ch		;v cl znamienko vysledku - = 1
				;			 + = 0 
	xor ch,ch		;bp je 16 bitovy register
	mov bp,cx		;znamienko vysledku v bp
;--------

	pop ax
	mov ah,2		;al = porad. cislo menovatela
	mul ah                    
	mov bx,offset cisla
	add bx,ax
	mov cx,[bx]		;cx = menovatel
	cmp cx,0		;ak je menovatel 0 daj vediet
	jne pokracuj
	call delnul
pokracuj:
	pop ax
	push cx
	xor dx,dx
	push ax
	push bx
	push cx
	push dx
	push bp
	mov dx,offset text9	;vypis text vysledok je:
	mov ah,09h
	int 21h
	pop bp
;---- vypis znamienka pred vysledok delenia
	cmp bp,0
	je  next20
	mov ah,02h
	mov dl,'-'
	int 21h
;----
next20:
	pop dx
	pop cx
	pop bx
	pop ax
	xor bp,bp              ; bp = pocet deleni

eee:   			;SKUTOCNE DELENIE!! v ax citatel, v cx menovatel
	div cx                 ;ax = celociselny podiel s cx, do dx zvysok
	inc bp                 ;pocet deleni + 1  

        push ax
       	push bx
        push cx
        push dx
        mov cx,ax		;procedura vypisuje to ce je v cx
        call vypcis		;vypise vysledok delenia
	cmp bp,1		;ak je bp=1 tak daj desatinu ciarku
	jg next			;inac pokracuj...next
	call desciarka	
next:   pop dx
       	pop cx
       	pop bx
        pop ax
	
	
	cmp dx,3276	       ;dx = zvysok,  ci doide k preteceniu ak *10
	jng iii			;ak nie pokracuj v iii
go1:	cmp bp,1		;ak by bolo pretecenie vypis zvysok
	je go
	push ax
	push cx
	xor cx,cx
	mov cx,10
	mov ax,dx
	xor dx,dx
	div cx			;vydelim zvysok 10 bp krat
	mov dx,ax
	pop cx
	pop ax
	dec bp
	jmp go1
go:	call vypzlomku		;ak bp=1 vypis zvysok

iii:	push bx
	mov ax,dx
	mov bx,10
	mul bx			;vynasob zvysok 10
	pop bx
	xor dx,dx
	dec di			;bude zapisane desatinne cislo->dec di
	cmp di,0
	jne eee			;ak uz bolo zapisanych 5 des.cisel->menu
	call stlac
	call menu
	ret
delenie endp

nasob   proc                    ;proc nasobenia.
	mov dx,offset text7     ;;
    	mov ah,09h               ;
    	int 21h                  ;
	push dx                  ;
	push si                  ;
	mov dx, offset cislo     ;
	mov ah ,0Ah              ;; zistenie poradove cislo prveho
	int 21h                  ;
	mov dx, offset cislo     ;
	add dx, 2                ;
	mov si, dx               ;
	mov al, [si]             ;
	sub al,30h               ;
	mov ah, al               ;
	inc si                   ;
	mov al, [si]             ;
	sub al, 30h              ;
	aad                      ;
	dec al                   ;
	pop dx                   ;
	pop si                  ;;
	push ax                 ;al = porad. cislo citatela

;------zisti znamienko prveho cisla
	mov bx,offset precit
	mov ah,6
	mul ah			
	add bx,ax		;bx+ax+1 = adresa znamienka vybraneho cisla
	mov cl,[bx]
	cmp cl,'+'
	je  npozit
	mov cl,1		;ak je 1.cislo zaporne cl=1
	jmp nnext1
npozit:  mov cl,0		;ak je kladne nech cl je 0
nnext1:
	mov [signum],cl		;uloz cl do sign.of.reminder(bude to aj znamienko zvysku)
;--------

	pop ax
	mov ah,2		;musime sa pohybovat po wordoch
	mul ah   
	mov bx,offset cisla
	add bx,ax		;nastav sa na adresu citatela
	mov ax,[bx]	
	push ax	                ;ax = prvy clan
	push ax	              	
    	mov dx,offset text8     ;;
    	mov ah,09h               ;
    	int 21h                  ;
	push dx                  ;
	push si                  ;
	mov dx, offset cislo     ;
	mov ah,0Ah               ;
	int 21h                  ;
	mov dx, offset cislo     ;; zistenie druheho cisla.
	add dx, 2                ;
	mov si, dx               ;
	mov al, [si]             ;
	sub al,30h               ;
	mov ah, al               ;
	inc si                   ;
	mov al, [si]             ;
	sub al, 30h              ;
	aad                      ;
	dec al                   ;
	pop dx                   ;
	pop si                   ;
	push ax                 ;;

;-------zisti znamienko druheho cisla
	mov bx,offset precit
	mov ah,6
	mul ah			
	add bx,ax		;bx+ax+1 = adresa znamienka vybraneho cisla
	mov ch,[bx]
	cmp ch,'+'
	je  npozit0
	mov ch,1
	jmp nnext10
npozit0:  mov ch,0
nnext10:
	xor cl,ch		;v cl znamienko vysledku - = 1
				;			 + = 0 
	xor ch,ch		;bp je 16 bitovy register
	mov bp,cx		;znamienko vysledku v bp
;--------

	pop ax
	mov ah,2		;al = porad. cislo menovatela
	mul ah                    
	mov bx,offset cisla
	add bx,ax
	mov cx,[bx]		;cx = druhy clen
	pop ax
	push cx
	xor dx,dx
	push ax
	push bx
	push cx
	push dx
	push bp
	mov dx,offset text9	;vypis text vysledok je:
	mov ah,09h
	int 21h
	pop bp
;---- vypis znamienka pred vysledok delenia
	cmp bp,0
	je  nnext20
	mov ah,02h
	mov dl,'-'
	int 21h
;----
nnext20:
	pop dx
	pop cx
	pop bx
	pop ax
	mul cx                  ; NASOBENIE!
	jno nppp
	call pretecenie
nppp:
        push ax
       	push bx
        push cx
        push dx
        mov cx,ax		;procedura vypisuje to ce je v cx
        call vypcis		;vypise vysledok delenia
	call stlac
	call menu
	ret
nasob   endp

vypzlomku proc
	pop cx
	pop ax
	mov tempz,dx		;zapamataj si dx
	mov dx,offset text10
	mov ah,09h
	int 21h			;vypisuj text:zvysok je..
	cmp [signum],0
	je next40
	mov ah,02h
	mov dl,'-'
	int 21h			;vypis znamienko zvysku
next40: mov cx,tempz
	call vypcis		;vypis zvysok a chod do menu
	call menu
	ret
vypzlomku endp	

vypcis  proc
	push si
	mov si,1	;si=0 vypisuj aj 0
	mov dl,0
	mov bx,08000h
	cmp cx,bx
	jbe desattis	;ak je <= tak je kladne a vypisuj 10000-ky
	dec cx
	not cx
	mov dl,'-'
	mov ah,02h
	int 21h		;je zaporne a napis -
	mov dl,0
desattis:	
	cmp cx,9999	;celeho cisla(0<=cis<1000)
	jbe ddalej3	;ak je uz menej pokracuj na ddalej3
	sub cx,10000
	inc dl		;dl krat su tam 10000	
	jmp desattis
ddalej3:
	cmp si,0	;mam vypisovat aj 0?
	je  ttt		;ano
	cmp dl,0	
	je tisic	;ak sme neinkrementovali dl chod o rad nizsie
ttt:	add dl,30h
	mov ah,02h
	int 21h		;vypis dl
	mov si,0	;nastav si na 0 -> vypisuj uz aj 0
	mov dl,0	;vynuluj dl
tisic:	
	cmp cx,999
	jbe ddalej4
	sub cx,1000
	inc dl
	jmp tisic
ddalej4:        
	cmp si,0
	je  tttt
        cmp dl,0
	je stovky
tttt:	add dl,30h
	mov ah,02h
	int 21h
	mov si,0
	mov dl,0
stovky:	
	cmp cx,99
	jbe ddalej
	sub cx,100
	inc dl
	jmp stovky
ddalej:		
	cmp si,0
	je ttttt 
	cmp dl,0
	je desiatky
ttttt:	mov ah,02h
	add dl,30h
	int 21h
	mov si,0
	mov dl,0
desiatky:
	cmp cx,9
	jbe ddalej1
	sub cx,10
	inc dl
	jmp desiatky
ddalej1:	
	cmp si,0
	je tttttt 
	cmp dl,0
	je jednotky
tttttt:	mov ah,02h
	add dl,30h
	int 21h
	mov si,0
	mov dl,0
jednotky:
	cmp cx,0
	je ddalej2
	dec cx
	inc dl
	jmp jednotky
ddalej2:
	add dl,30h
	mov ah,02h
	int 21h
	pop si
	ret
vypcis  endp

wrfile  proc
	mov si,offset out1	; nastav ukazovatele na out1 (ascii)
	mov dx,offset zosort	; a na triedene (doplnkove)
	push dx			
	mov cl,pocet		
repeat: pop dx
	push si
	mov si,dx
	mov ax,[si]		; vezme cislo z triedene a da do ax
	add dx,2		; zvys ukazovatel na triedene
	pop si
	cmp ax,32767		; je to cislo kladne?
	jbe pozitivne0		; ak ano, skoc pred neho dat znamienko '+'
	push ax			; ak nie, tak daj pred neho znamienko '-'
	mov al,'-'
	mov [si],al
	pop ax
	not ax
	inc ax
	jmp negativne0
pozitivne0:
	push ax
	mov al,'+'
	mov [si],al		;priradenie '+' do si
	pop ax
negativne0:
	inc si			;zvys si(zapisali sme tam uz anamienko)
	push dx
	push cx
	mov bx,10000
	XOR cx,cx		; 10000 - najvyssi rad (bx)
	mov cx,10		; bude sa vzdy zmensovat delenim 10 (cx)
uprav:	XOR dx,dx
	div bx			; ax/bx - do ax da celociselny podiel a do dx zvysok
	add ax,30h		; uprav ax na ASCII
	push dx
	xor dx,dx
	push ax
	mov [si],al		; uloz aktualnu cislicu do pamate na miesto out1
	inc si
	mov ax,bx
	mov cx,10
	div cx			; bx/cx - zmensi rad
	mov bx,ax
	pop ax
	pop dx
	mov ax,dx		; presun zvysok po deleni do ax
	cmp bx,0
	ja uprav		; opakuj az po najnizsi rad
	pop cx
	dec cl
	cmp cl,0		; je to uz posledne cislo?
	jne repeat		; ak nie, tak chod na dalsie v poradi
	pop dx

	mov ax,seg data
	mov ds,ax
	mov dx,offset out1	; nastavenie na zapis do suboru
	mov al,6		;6*pocet potrebnych miest na zapis
	mov bl,pocet		       
	mul bl			;nasobenie 6
	mov cx,ax
	mov bx,[tempo]		;handler
	mov ah,40h
	int 21h			; zapis do suboru
	mov ah,3Eh
	int 21h			; uzavri subor zapisu
	ret
wrfile  endp

crfile  proc            	; vytvorit subor
        mov ax, seg data
        mov ds, ax
	mov ah, 3Ch
	mov al, 1
	mov dx, offset fileout
	mov cx, 0
        int 21h
	mov [tempo], ax         ; odlozenie handleru.
        ret
crfile  endp 

opfile  proc                    ; otvorenie suboru.
        mov ax, seg data
	mov ds, ax
	mov ah, 3Dh
	mov al, 0
	mov dx, offset filein
	int 21h
        ret
opfile  endp

refile  proc     			;precitanie suboru
        mov dx, offset precit           ; nacitanie do precit
	mov cx, 1
	mov bx, ax
citaj:  mov ah, 3Fh
	int 21h
	inc dx
	cmp ax, 0
	jne citaj
        mov ah, 3Eh
	mov bx, ax
	int 21h
        ret
refile  endp

deca    proc        			; zapis do dvokoveho kodu.
	mov bx, offset precit	
	mov [poc], 0
	mov [pocet], 0                  ; bude tam pocet cislic.
con:	mov al, [bx]			; controla ci je subor dobre zadany.
	inc [poc]
	cmp [poc], 1
	jne dalej
	cmp al, '$'
	jz  dalej3
	cmp al, '-'
	jz  dalej3
	cmp al, '+'
	jz  dalej3
	call error
dalej:  cmp al, '0'
	jnb dalej1
	call error
dalej1: cmp al, '9'
	jbe dalej2
	call error
dalej2: cmp [poc], 6
	jne dalej3
	inc [pocet]
	mov [poc], 0
dalej3:	inc bx
	cmp al, '$'
	jne con

	xor ah, ah
	xor ch, ch
	mov cl, pocet
	mov bx, offset precit
	mov si, offset cisla
dvojkod:push cx                   ;do 'cisla' sa daju cisla v dvoj. kode
	inc bx
	mov al, [bx]
	sub al, 30h               ;postupne nacitavat cisla a vynasobovanie dekadami a scitovanie
	mov cx, 10000
	imul cx
	jno pp
	call pretecenie
pp:	mov dx, ax
	push dx
	inc bx
	xor ah, ah
	mov al, [bx]
	sub al, 30h
	mov cx, 1000
	imul cx
	pop dx
	add dx, ax
	jno ppp
	call pretecenie
ppp:    push dx
	inc bx
	xor ah, ah
	mov al, [bx]
	sub al, 30h
	mov cx, 100
	imul cx
	pop dx
	add dx, ax
	jno pppp
	call pretecenie
pppp:   push dx
	inc bx
	xor ah, ah
	mov al, [bx]
	sub al, 30h
	mov cx, 10
	imul cx
	pop dx
	add dx, ax
	jno ppppp
	call pretecenie
ppppp:  push dx
	inc bx
	xor ah, ah
	mov al, [bx]
	sub al, 30h
	mov cx, 1
	imul cx
	pop dx
	add dx, ax
        jno pppppp
	call pretecenie
pppppp: inc bx
	mov [si], dx			;ked to zapise tak sa zapise v dvojkovom kode
	add si, 2
	pop cx
	loopne dvojkod	
	ret
deca	endp

dopl    proc				;danie do doplnkoveho kodu
        mov bx, offset precit
	mov si, offset cisla
	mov dx, offset dopkod
	mov di, offset zosort
	mov ch, 0
	mov cl, pocet
zas1:   mov al, [si]
	inc si
	mov ah, [si]
	push ax
	mov al, [bx]
	cmp al, '+'     		;zistenie ci je kladne alebo zaporne
	jne zaporne	
	jmp kladne
zaporne:pop ax
	not ax
	add ax, 1
	jmp zapdopl
kladne: pop ax	
	jmp zapdopl
zapdopl:push si
	mov si, dx
	mov [si], ax
	pop si
	mov [di], ax
	add di, 2
	add dx, 2
	inc si
	add bx, 6
	loopne zas1 
	ret
dopl	endp

desciarka proc			;napise desatinu ciarku
	mov ah,02h
	mov dl,'.'
	int 21h
	ret
desciarka endp

error   proc
	mov dx, offset texter3                
        mov ah, 9                             
	int 21h                             
	call koniec
	ret
error   endp

pretecenie proc
    	mov dx,offset texter2		
    	mov ah,09h			
    	int 21h					
    	call koniec			
	ret
pretecenie endp

delnul  proc
    	mov dx,offset texter1		
    	mov ah,09h			
    	int 21h					
    	call menu			
	ret
delnul  endp

stlac   proc
        mov dx, offset text12                 
	mov ah, 9                             
 	int 21h                               
        mov ah, 1                             
	int 21h                               
	jmp menu                            
	ret
stlac   endp

koniec  proc
   	mov ax,4c00h			
    	int 21h
	ret
koniec  endp
code    ends
        end start

; Program funguje tak ako bolo zadane. Vypracovany bol v editoroch managerov
; a C-cku. 
; Do suboru na nacitanie sa musia pisat cisla vzdy patmiestne so znamienkom (+00001)
; Ked sa vyberaju cisla na operaciu musia sa zadat vzdy dvojmiestne  (01)
	