;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;TURBO ASSEMBLER  VERSION 3.1
;
;TURBO LINK VERSION 5.1
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Roman Paterek
;B12
;zadanie 1
;20.8.2000

ZAS  SEGMENT STACK
     DB      200 DUP(?)         ;definovanie zasobnika
ZAS  ENDS  
DATA SEGMENT
TEXT_ZADAJ DB        'ZADAJ RETAZEC ZNAKOV: ','$'
TEXT0 DB        0ah, 0dh,0ah,0dh,'1.VYPIS RETAZEC ZNAKOV NA OBRAZOVKU',0ah,0dh,'$'
TEXT1 DB        '2.VYPIS KDE SA NACHADZA PRVA MEDZERA',0ah,0dh,'$'
TEXT2 DB	'3.NAJST ZADANY ZNAK A POCET VYSKYTOV V RETAZCI',0AH,0DH,'$'
TEXT3 DB 	'4.NAJST ZNAK S MAXIMALNOU HODNOTOU A VYPISE HO',0AH,0DH,'$'
TEXT4 DB 	'5.ZAROVNA TEXT ZLAVA',0AH,0DH,'$'					;definovanie textu,ktory vyuzivam v programe
TEXT5 DB	'6.VYPISE RETAZEC V OPACNOM PORADI',0AH,0DH,'$'
TEXT6 DB        '7.KONIEC',0ah,0dh,'$'
text7 db	0ah,0dh,'ZADAJ HLADANY ZNAK:$'
text8 db	0ah,0dh,'Pozicia prvej medzery: ','$'
text9 db        0ah,0dh,'Znak s maximalnou hodnotou je :$'
buf   db 100 dup(?)		; inicializacia bufera pre retazec
DATA ENDS								;definovanie datoveho segmentu
CODE SEGMENT     					;definovanie codoveho segmentu
     ASSUME CS:CODE,DS:DATA,SS:ZAS
Start:
     

     MOV AX,SEG DATA
     MOV DS,AX 				;vytlaci text 
     MOV DX,OFFSET TEXT_ZADAJ
     MOV AH,09H
     INT 21H
     
; nacitanie retazca max. 100 znakov
	xor bx,bx	; bx = pre indexaciu v retazci  
	xor cx,cx	; cx = sluzi na uchovanie kolko je znakov v retazci

citaj:				;zaciatok citania znakov z klavesnice
	cmp cx, 100	        ;ak prekroci pocet 100 tak prestane citat z klavesnice a skoci na menu
	je koniec_citania
	mov ah, 01h              ;01h sluzba pre vstup znaku 
	int 21h				;volanie dosovskeho prerusenia
	cmp al, 13	;testuje  stlacenie <enter>
	je koniec_citania
	mov buf[bx], al		;ulozenie znaku do pameti 
	inc bx                 ;incrementacia bx
	inc cx                 ;incrementacia cx  
	jmp citaj             ;skok na navestie citaj
koniec_citania:	
	 jmp menu
	     
menu:                          ;menu podla stlaceneho cisla sa vykona urcita uloha
     MOV DX,OFFSET text0
     MOV AH,09H
     INT 21H 

     MOV DX,OFFSET text1		;vytlacia sa texty na obrazovku
     MOV AH,09H
     INT 21H 

     MOV DX,OFFSET text2
     MOV AH,09H
     INT 21H 
     	    
     MOV DX,OFFSET text3
     MOV AH,09H
     INT 21H

     MOV DX,OFFSET text4
     MOV AH,09H
     INT 21H 

     MOV DX,OFFSET text5
     MOV AH,09H
     INT 21H    

     MOV DX,OFFSET text6
     MOV AH,09H
     INT 21H


     MOV AH,01h			; citanie znaku (volba ulohy)
     INT 21H

				
	cmp al,'1'		;ak je stlacena 1 tak sa vykona uloha1
	je uloha1
	cmp al,'2'
	je uloha2
	cmp al,'3'
	je temp1
	cmp al, '4'		
	je tmp4		;instrukcia jmp dovoluje skok maximalne +-128 bytes
			;kedze navestia su dalej tak musim pouzit pomocne navestia 
	cmp al, '5'	
         je tmp5
	cmp al, '6'
	je tmp6
	jmp koniec	
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; jednotlive ulohy

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha1:			; vypise retazec po znakoch
	xor bx, bx	;nulovanie registra bx
	mov ah, 02h     ;volanie sluzby pre vystup znaku na obrazovku
	mov dl, 10      ;ulozenie do registra dl new line
	int 21h	        ;volanie dosovskeho prerusenia
	mov ah,02h	;volanie sluzby pre vystup znaku na obrazovku	
        mov dl,13	;odenteruje new line
        int 21h      
vypis:
	cmp bx, cx         ;porovnava registre, v cx je ulozeny pocet znakov 
	je koniec_vypisu   
	mov ah, 02h        
	mov dl, buf[bx]          ;vypis znaku na obrazovku
	int 21h
	inc bx
	jmp vypis
	
koniec_vypisu:
	jmp menu


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha2:			; zisti poziciu prvej medzery v retazci

	mov ax, seg data 	; vypise hlasku
	mov ds, ax
	mov dx, offset text8
	mov ah, 09h
	int 21h

        xor bx,bx       ;nulovanie registra bx
         
hladaj:  cmp bx,cx		; v cx je pocet znakov
         je koniec_hladania
         cmp buf[bx],' '	;ak medzera sa nachadza v ratazci tak skoc na navestie nasiel 
         je nasiel  
         inc bx
         jmp hladaj 

koniec_hladania:
        jmp menu
nasiel:		       ;vypisanie prvej medzery na obrazovku
	cmp bx,10
         jl find3		; v bx mame poradove cislo 1 medzery
	
       mov ax,bx
       mov bl,0ah   ;vycislenie hodnoty, ktora je v ax pomocou instrukcie div
       div bl      ;pripocitanie posunutia v asci tabulke
       mov bh,ah 
       xor dx,dx
       mov dl,al
       add dx,48      
       mov ah,02h
       int 21h
       
       mov dl,bh
       add dx,49  
       mov ah,02h
       int 21h
       jmp menu  
find3:
   mov dx,bx
   add dx,49     ;ked je cislo mensie ako 10 tak sa tam iba pripocita posunutie, ktore je v asci
   mov ah,02h
   int 21h
   jmp menu
temp1:
    jmp uloha3
tmp4:       
     jmp uloha4          
tmp5:
     jmp uloha5    ;pomocne navestia,ktore umoznuju skok
tmp6:
     jmp uloha6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha3:		;hlada v retazci  zadany  znak a vypise pocet vyskytov
 		;pocet vyskytov ulozi do cx.
     mov ax,seg data
     mov ds,ax	           ;vypisanie hlasky na obrazovku
     mov dx,offset text7
     mov ah,09h
     int 21h
     mov ah,01h    ;nacitanie znaku z klavesnice
     int 21h 	   ;nacitany znak sa nachadza v al registri	
     xor bx,bx 
     mov dx,cx             ;nulovanie registrov
     xor cx,cx    
find:
      cmp bx,dx          ;porovnava vsetky prvky v retazci
        je koniec1  
      cmp  buf[bx],al     ;ak sa prvky rovnaju skoci na navestie find1     
      je find1            
       inc bx
      jmp find   
         
find1:
   inc bx                        ;v cx je pocet hladaneho znaku
   inc cx 			;ked nasiel zhodny prvok incrementuje cx
   jmp find     
koniec1:
    push dx   
    mov dx,cx
	cmp dl,10
         jl find4		; v bx mame poradove cislo 1 medzery
       mov bl,0ah
       mov ax,dx
       div bl      ;pripocitanie posunutia v asci tabulke
       mov bh,ah         ; to iste co v ulohe2
       mov dl,al
       add dx,48      
       mov ah,02h
       int 21h
       mov dl,bh
       add dx,48  
       mov ah,02h
       int 21h
       pop dx
       mov cx,dx
       jmp menu  
find4:
   add dx,48
   mov ah,02h     ;to iste co v ulohe2
   int 21h
   pop dx
   mov cx,dx
   jmp menu
    
    add dl,48        ;vypisanie poctu hladaneho znaku v retazci
    mov ah,02h
    int 21h
    pop dx              ;vybratie hodnoty dx zo zasobnika
    mov cx,dx
    jmp menu    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha4:         ;najde znak s maximalnou hodnotou a vypise ho
        xor bx,bx
        mov al,buf[bx]
max: cmp bx,cx 	 		;max vyhladava znak s maximalnou hodnotov                  
     je koniec2                ;ked prejde vsetky znaky tak skoci na navestie koniec2
     cmp al, buf[bx]           ;porovnava  ktora hodota znaku je vacsia
     jl max1	                 ;ak je al mensie ako buf[bx] tak skoci na navestie max1
     inc bx
     jmp max      

max1:
     mov al,buf[bx]                     ;ulozenie max. hodnoty do al
     inc bx
     jmp max
koniec2:
      push ax                 ;ulozenie obsahu registra ax do zasobnika
      mov ax,seg  data
      mov ds,ax
      mov dx,offset text9        ;vytlacenie textu na obrazovku
      mov ah,09h
      int 21h
      pop ax
      mov dl, al      ;vypisanie znaku s maximalnou hodnotov na obrazovku
      mov ah,02h
      int 21h
      jmp  menu    ;skok na menu
         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha5:                              ;zarovna text zlava
	xor bx, bx
	mov ah, 02h
	mov dl, 10
        int 21h	
	mov ah,02h
        mov dl,13                      ;new line a enter
        int 21h      
       
medzera:  cmp buf[bx],' '           ;porovnava az dovtedy dokym sa buf[bx] nerovna medzere
          je inc_bx               
	  jne vypis1
inc_bx:
        inc bx
        jmp medzera            
vypis1:					;vypis zarovnaneho textu
	cmp bx, cx             ;vypisuje dokym nepride na koniec retazca
	je koniec_vypisu1
         
	mov ah, 02h
	mov dl, buf[bx]
	int 21h
	inc bx
	jmp vypis1
	
koniec_vypisu1:
	jmp menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha6:        ;vypis retazca v opacnom poradi

	mov dl,0ah    ;new line
	mov ah,02h
	int 21h
         
        mov dl,0dh
        mov ah,02h
        int 21h 	
    
	push cx		;ulozenie cx do zasobnika
	mov di,cx      ;ulozenie cx do si
	xor bx,bx	;vynulovanie registra bx
obrat:  cmp bx,di       ;porovnava ci bx sa rovna di,ak sa rovnaju tak skonci a vrati sa na menu
        je koniec3 
        dec di	         ;decrementuje register di
	mov dl, buf[di]        ;vypis retazca v opacnom poradi
	mov ah, 02h
	int 21h
	jmp obrat      


koniec3:
        pop cx            ;vybratie cx zo zasobnika,v nom je ulozeny pocet bytes v retazci	
        jmp menu        ;vrati sa spat na navestie menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  

koniec:
     MOV AX,4C00H        ;volanie sluzby na ukoncenie programu
     INT 21H
CODE ENDS              ;koniec kodoveho segmentu
     END START

;ak sa stlaci znak  rozny od cislic 1 az sest tak sa ukonci program     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;