zas     segment   stack          ;zaciatok zasobnikoveho segmentu 
        dw        64 dup(?)      ;definicia 64-och slov 
zas     ends                     ;koniec zasobnikoveho segmentu
;---------------------------------------------------------------------------------------------------------------------
data    segment                  ;zaciatok datoveho segmentu  
POCET   db        100
POC1    db        0
VSTUP   db        '$'
        db        99 dup(?)       
MENU    db        'z-ZADAJ RETAZEC  v-VYPIS RETAZCA  k-KONIEC'
        db        0ah
        db        0dh
        db        'a-1.MEDZERA  b-ZAROVNAT  c-PREVRATIT  d-NAJVACSI ZNAK  e-VYSKYT ZNAKU$'
HLASKAZ db        'Zadaj retazec:$'
HLASKAV db        'Vypis retazca:$'
HLASKAD db        'Najvacsi znak je:$'
HLASKAE db        'Vyskyt akeho znaku:$'
data    ends                     ;koniec datoveho segmentu   
;---------------------------------------------------------------------------------------------------------------------
code    segment                  ;zaciatok kodoveho segmentu   
        assume    cs:code, ds:data, ss:zas
                                 ;oznamuje assembleru aktivne segmenty 

NACSTR  proc                     ;proc-nacita retazec 
        mov dl, offset POCET
        mov ah, 0ah
        int 21h
        mov bx, offset VSTUP
        mov cx, 0
        mov cl, POC1 
        add bx, cx
        mov byte ptr[bx], '$'
        ret
NACSTR  endp                     

MEDZ1   proc                     ;proc-najde 1.medzeru a vypise miesto na ktorom je
        mov cx, 0
        sub bx, 1 
zac3:   add cx, 1                ;cyklus-zastavi sa na prvej medzere
        add bx, 1  
        cmp byte ptr[bx], '$'
        jz  kon3
        cmp byte ptr[bx], ' '          
        jnz zac3
        mov ax, cx               ;vypis cisla z cx (umiestnenie medzery) 
        push ax
        mov dl, ah  
        add dl, 30h
        mov ah, 02h
        int 21h
        pop ax
        mov dl, al
        add dl, 30h
        mov ah, 02h 
        int 21h 
kon3:   ret
MEDZ1   endp

ZRMEDZ  proc                     ;proc-vymaze prve medzery retazca (zacin od adresy bx) 
        mov di, bx               ;bx do di (adr zaciatku retazca do di) 
        sub bx, 1                ;zmensi bx o 1
zac4:   add bx, 1                ;zvacsi bx o 1 (1.cyklus-bx sa nastavi na 1.znak retazca rozdielny od ' ')
        cmp byte ptr[bx], ' '    ;porovna znak na adr bx s ' '
        jz  zac4                 ;ak sa rovna skoci na zac4 (cykl 1)
pok4:   mov dl, [bx]             ;znak na adr bx do dl
        mov [di], dl             ;dl na adr di (kopiruje znaky z adresy bx na adresu di)   
        add di, 1                ;zvacsi di o 1 (posun v pameti o 1 Byte dopredu)
        add bx, 1                ;zvacsi bx o 1 (posun v pameti o 1 Byte dopredu)
        cmp dl, '$'              ;porovna dl (kopirovany znak) s $
        jnz pok4                 ;ak sa nerovna skoci na pok4 cykl 2) 
        ret 
ZRMEDZ  endp

PREVR   proc                     ;proc-prevrati retazec ktory zacina na adr bx
        mov di, bx               ;bx do di (adr zaciatku retazca do di)
        sub bx, 1                ;zmensi bx o 1
        mov ax, -1               ;do ax da -1
zac5:   add bx, 1                ;zvacsi bx o 1
        add ax, 1                ;zvacsi ax o 1
        cmp byte ptr[bx], '$'    ;porovna znak (Byte) na adr bx s $     
        jnz  zac5                ;ak sa rovna skoci na zac5 (cykl 1 - do bx adr konca retazca) 
        sub bx, 1                ;zmensi bx o 1 (adr 1.znaku pred $ v retazci)
        mov dl, 2                ;2 do dl
        div dl                   ;delenie na reg ax hodnotou v dl   
        xor cx, cx               ;vynulovanie cx
        mov cl, al               ;cele cislo po deleni al do cl (al=pocet znakov v retazci bez $ div 2) 
pok5:   mov dl, [bx]             ;znak na adr bx do dl
        mov al, [di]             ;znak na adr di do al
        mov [bx], al             ;al na adr bx
        mov [di], dl             ;dl na adr di (vymena znakov na i-teho znaku od zac a i-teho znaku od kon retazca)
        sub bx, 1                ;zmensi bx o 1 (posun v pameti o 1 Byte dozadu)
        add di, 1                ;zvacsi di o 1 (posun v pameti o 1 Byte dopredu)
        loop pok5                ;zmensi cx o 1 a porovna s 0 (cykl 2 - prevrati retazec)
        ret        
PREVR   endp

NAJVZN  proc                     ;proc-vypise najvacsi znak v retazci zacinajucom od adr bx
        mov dl, 0                ;0 do dl (dl - najvacsi najdeny znak)
zac6:   cmp byte ptr[bx], '$'    ;porovna znak na adr bx s $
        jz  kon6                 ;ak sa rovna skoci na kon6 (uz na konci retazca)
        cmp byte ptr[bx], dl     ;porovna znak na adr bx s dl
        jbe iter6                ;ak je mensi alebo rovny skoci na iter6
        mov dl, [bx]             ;znak na adr bx do dl (zapise do dl novy najvacsi znak) 
iter6:  add bx, 1                ;zvacsi bx o 1 (posun v pameti kde je retazec o 1 Byte dopredu 
        jmp zac6                 ;skoci na zac6 (cykl)
kon6:   mov ah, 02h              ;funkcia na vypis znaku (po skonceni cyklu)
        int 21h                  ;vykona sluzbu MS DOSu
        ret        
NAJVZN  endp

VYSKZN  proc                     ;proc-spyta sa aky znak a vypise pocet jeho vyskytov  
        mov cx, 0
        mov ah, 01h
        int 21h        
        sub bx, 1
zac7:   add bx, 1
        cmp byte ptr[bx], '$'
        jz  kon7
        cmp byte ptr[bx], al
        jnz zac7
        add cx, 1
        jmp zac7
kon7:   call NR                  ;vypise pocet jeho vyskytov  
        mov ax, cx
        aam
        push ax
        mov dl, ah
        add dl, 30h   
        mov ah, 02h   
        int 21h
        pop ax
        mov dl, al
        add dl, 30h
        mov ah, 02h
        int 21h  
        ret
VYSKZN  endp

NR      proc                    ;procedura na odriadkovanie
        mov dl, 0ah             ;do dl znak 0ah
        mov ah, 02h             ;funkcia na vypis znaku 
        int 21h                 ;vykona sluzbu MS DOSu
        mov dl, 0dh             ;do dl znak 0dh
        mov ah, 02h             ;funkcia na vypis znaku
        int 21h                 ;vykona sluzbu MS DOSu
        ret  
NR      endp
                                  
start:  
        mov ax, seg data        ;segmentova cast adresy data do ax  
        mov ds, ax              ;seg. cast adresy presun do ds
                
hlcykl: call NR                 ;hlavny cyklus - vypise menu nacita znak a podla neho vykona volanie procedury
        call NR
        mov dx, offset MENU     ;volanie proc na novy riadok, nastavenie offsetovej casti adresy do bx
        mov ah, 09h
        int 21h                 ;volanie MS DOSu na vypis retazca 
        call NR                 ;volanie proc na novy riadok
hlcykl1:mov ah, 08h             ;hlavny cyklus1 - nevypise menu (inak to iste ako hlavny cyklus) 
        int 21h                 ;funkcia na nacitanie znaku z klav bez vypisu, vykonanie sluzby MS DOSu
        xor si, si              ;vynulovanie si
        xor dx, dx              ;vynulovanie dx
        mov dl, al              ;al do dl
        mov si, dx              ;si do dx (v si nacitany znak)
  
pol1:   cmp si, 'k'             ;porovna znak v si s k 
        jnz pol2                ;ak sa nerovna skoci na pol2
        mov ah, 4ch             ;funkcia ukoncenie programu
        int 21h                 ;vykona sluzby MS DOSu                       
pol2:   cmp si, 'z'             ;porovna si so z  
        jnz pol3                ;ak sa nerovna skoci na dalsiu polozku (pol2 - kde vykonava zas to iste) 
        mov dx, offset HLASKAZ  ;inak offsetova cast HLASKAZ do dx 
        mov ah, 09h
        int 21h                 ;vypise retazec od adr HLASKAZ
        call NACSTR             ;volanie procedury na nacitanie retazca
        jmp hlcykl              ;po vykonani procedury skoci na hlcyklu (znovu vykona nacitanie znaku, porovnavanie a volanie procedur)
pol3:   cmp si, 'v'             ;to iste ako v pol2 (len sa porovnava s inym znakom a vola sa ina procedura) 
        jnz pol4
        mov dx, offset HLASKAV
        mov ah, 09h
        int 21h
        mov dx, offset VSTUP  
        mov ah, 09h
        int 21h
        jmp hlcykl
pol4:   cmp si, 'a'         
        jnz pol5
        mov bx, offset VSTUP
        call MEDZ1
        jmp hlcykl
pol5:   cmp si, 'b'
        jnz pol6
        mov bx, offset VSTUP
        call ZRMEDZ
        mov dx, offset HLASKAV
        mov ah, 09h
        int 21h
        mov dx, offset VSTUP
        mov ah, 09h
        int 21h
        jmp hlcykl
pol6:   cmp si, 'c'
        jnz pol7
        mov dx, offset HLASKAV
        mov ah, 09h
        int 21h
        mov bx, offset VSTUP
        call PREVR
        mov dx, offset VSTUP
        mov ah, 09h
        int 21h
        jmp hlcykl
pol7:   cmp si, 'd'
        jnz pol8
        mov dx, offset HLASKAD
        mov ah, 09h
        int 21h
        mov bx, offset VSTUP        
        call NAJVZN
        jmp hlcykl
pol8:   cmp si, 'e'
        jnz hlcyklp              ;ak sa dostane sem potom sa zadany zn nezhoduje so ziadnym zn v menu, skoci na hlcyklp
        mov dx, offset HLASKAE
        mov ah, 09h
        int 21h
        mov bx, offset VSTUP
        call VYSKZN
        jmp hlcykl               
hlcyklp:jmp hlcykl1              ;skoci na hlcykl1 (bez vypisu menu)

code    ends                     ;koniec kodoveho segmentu
        end start                ;program bude spusteny od navestia start 