Zadanie c.3
;S vyuzitm  retazcovych  instrukci  (vsade   kde  je  to  mozn) vytvorte program, ktory:
;a) nacta z  klvesnice dva  retazce do  dvoch rznych segmentov
;    (minimlne dlzky 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabk na vyssie adresy,
;c) porovn posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zist, ci s rovnako dlh a ci s rovnak
;d) zist, ci  sa  v  niektorom   z  retazcov  nachdza  zadany
;   podretazec.
Autor: T.Picha
Termin odovzdania: 5.12.2000 


NR     MACRO                    ;makro na novy riadok
        mov dl, 0ah             
        mov ah, 02h             ;funkcia na vypis znaku 
        int 21h                 ;vykona sluzbu MS DOSu
        mov dl, 0dh            
        mov ah, 02h             
        int 21h                 
       ENDM

VYP    MACRO  P1                ;makro na vypis hlasky P1
        assume ds: seg P1
        mov ax, seg P1
        mov ds, ax              ;segm.adr. P1 do ds
        mov dx, offset P1       ;offset.adr. P1 do dx
        mov ah, 09h             ;vypise retazec (ds:dx)
        int 21h
       ENDM

ZAS    SEGMENT STACK
          dw  64 dup(?)
ZAS    ENDS

DATA1  SEGMENT
MAX1      db  50                           ;max.poc.zn. 1.retazca
NAC1      db  0                            ;poc.nacit.zn 1.retazca
ZN1       db  50 dup(?)                    ;zn 1.retazca
hl1       db  'Zadaj 1.retazec:$'          ;hlasky na vypis
hl2       db  'Zadaj 2.retazec:$'
hl3       db  'Retazce maju rozdielnu dlzku$'
hl4       db  'Retazce su rozdielne$'
hl5       db  'Retazce su rovnake$'
hl6       db  'Zadaj podretazec na hladanie:$'
hl7       db  'Podretazec najdeny v retazci$'
hl8       db  'Podretazec sa nenachadza v retazci$'
DATA1  ENDS

DATA2  SEGMENT
MAX2      db  50                           ;max.poc.zn. 2.retazca
NAC2      db  0                            ;poc.nacit.zn 2.retazca
ZN2       db  50 dup(?)                    ;zn 2.retazca
MAX3      db  50                           ;max.poc.zn. 3.retazca
NAC3      db  0                            ;poc.nacit.zn 3.retazca
ZN3       db  50 dup(?)                    ;zn 3.retazca
DATA2  ENDS

CODE   SEGMENT
       assume cs:CODE, ss:ZAS, ds:DATA1, es:DATA2

NACSTR PROC FAR                            ;nacita retazec z klav. do (par1:par2)
       push bp
       mov bp, sp
       assume ds: seg [bp + 8]
       mov ds, [bp + 8]                    ;1.param - segment
       mov dx, [bp + 6]                    ;2.param - offset 
       mov ah, 0ah                         ;nacita retazec
       int 21h
       pop bp
       ret 4 
NACSTR ENDP

POSUN  PROC                                ;posunie retaz. Zn1 o 10 znakov hore
       assume ds:DATA1, es:DATA2                                           
       mov ax, seg DATA1                   ;posuvat bude retazec Zn1 v seg Data1
       mov ds, ax                          ;ako pomocny retazec pouzije Zn3 v seg Data2
       mov ax, seg DATA2
       mov es, ax
       mov si, offset ZN1                  ;si - posuvat v retazci Zn1
       mov di, offset ZN3                  ;di - posuvat v pom. retazci Zn3
       mov ax, 0
       mov al, nac1
       inc ax                              
       mov cx, ax                          ;do cx da pocet nacit.zn. do ret. Zn1
       push di                             ;ulozi ukazov. na zac. retaz. Zn1 a Zn3 do zas
       push si
       rep movsb                           ;prekopiruje zo Zn1 do Zn3
       pop di                              ;obnovi a vymeni zac. pozic. v retaz. Zn1 a Zn3
       pop si
       assume ds:DATA2, es:DATA1 
       mov cx, ax                          ;do cx dlzka prekop. retaz. v Zn3
       mov ax, ds                          ;vymeni ds a es, budem kopirovat opacne
       mov bx, es
       mov ds, bx
       mov es, ax
       push di                             ;ulozi pozic. zac. retazca Zn3 do zas.
       add di, 10                          ;posunie zo zac.pozic. o 10 zn. v Zn1
       rep movsb                           ;skopiruje naspat z Zn3 do Zn1 (od 10 pozicie) 
       pop di                              ;obnovi pozic.zac.retazca Zn3 zo zas
       mov cx, 10                          
       mov ax, 20h
       rep stosb                           ;bude mazat prvych 10 zn. od zac. Zn1
       ret 
POSUN  ENDP

PROC   POROV                               ;porovna retazce Zn1[10] a Zn2
       assume ds:DATA1, es:DATA2
       mov ax, seg DATA1
       mov ds, ax                          ;v ds seg. adr Zn1
       mov ax, seg DATA2
       mov es, ax                          ;v es seg. adr Zn2
       mov si, offset ZN1[10]              ;si - zac. od 10 zn retaz. Zn1
       mov di, offset ZN2                  ;di zac. Zn2
       mov cx, 0
       mov cl, nac1                        ;do cx poc. zn. v Zn1
       cmp cl, nac2                        ;porovan s poc. zn v Zn2
       je por       
       VYP hl3                             ;retazce su rozdielnej dlzky - vypise
       jmp kon
por:   repe cmpsb                          ;porovna Zn1[10] a Zn2
       je rovn
       VYP hl4                             ;retazce su rozdielne - vypise
       jmp kon
rovn:  VYP hl5                             ;retazce su rovnake - vypise
kon:   ret
ENDP   POROV

NAJDI  PROC FAR                            ;hlada podretazec(ds:si) v retazci(es:di)
       push bp                             ;retazec(par1:par2),par3-adr.s poc.zn.
       mov bp, sp
       assume ds:seg ZN3, es:seg [bp + 10] ;v dat.seg. bude podretazec
       mov ax, seg ZN3                     
       mov ds, ax                          
       mov si, offset ZN3                  ;si ukazuje na zac podretazca
       mov es, [bp + 10]                   ;v extra seg. retazec, ako prvy param. proc. 
       mov di, [bp + 8]                    ;di ukazuje na zac. retazca, 2.param.
       mov bx, [bp + 6]                    ;3.param dlzka retazca
       mov cx, 0
       mov cl, byte ptr[es:bx]             ;do cl poc. zn. v retazci
       mov bx, 0                           
       mov bl, cl                          ;do bl(na zac=3.param) uklada pocet este zostavajucich znakov
       mov ax, 0
       mov al, [si]                        ;do al prvy znak podretazca
najd1: repne scasb                         ;vyhladava 1.znak podretazca
       jne nie                             ;ak nenajde -> nenachadza sa, koniec
       dec di                              ;vrati sa o znak spat
       inc cl                              ;a zvacsi o 1 cl
       mov bl, cl                          ;zapamata cl - poc. zost. znakov
       cmp cl, NAC3                        ;porovna poc.zost.zn. s dlzkou podretazca
       jb nie                              ;ak menej -> nenachadza sa, koniec
       mov cl, NAC3                        ;do cl dlzku podretazca
       push si                             
       push di                             ;ulozi poziciu v retazci a podretazci
       repe cmpsb                          ;hladanie podretazca
       pop di                              ;obnovi poziciu v retazci a podretazci
       pop si
       je ano                              ;podretazec najdeny, koniec
       mov cl, bl                          ;obnovi cl - poc.zost.zn.
       inc di                              ;posunie sa v retazci o 1 znak 
       loop najd1                          ;opakuje cyklus, pricom zmensi poc.zost.zn.
ano:   VYP hl7                             ;nasiel
       jmp nkon
nie:   VYP hl8                             ;nenasiel
nkon:  pop bp
       ret 6
NAJDI  ENDP


START: 
       VYP hl1                             ;vypise hl1
       push seg MAX1
       push offset MAX1
       call NACSTR                         ;nacita 1.retazec
       NR                                  ;makro na odriadkovanie
       VYP hl2                             ;vypise hl2
       push seg MAX2
       push offset MAX2
       call NACSTR                         ;nacita 2.retazca
       NR                                  ;makro na odriadkovanie
       call POSUN                          ;posunie 1.retazec o 10 znakov hore
       call POROV                          ;porovna posunuty 1.retazec a 2. retazec
       NR                                  ;makro na odriadkovanie
       VYP hl6                             ;vypise hl2
       push seg MAX3
       push offset MAX3
       call NACSTR                         ;nacita 3.retazca
       NR                                  ;makro na odriadkovanie
       push seg ZN1
       push offset ZN1[10]
       push offset NAC1
       call NAJDI                          ;hlada 3.retazec v 1.retazci
       NR                                  ;makro na odriadkovanie
       push seg MAX2
       push offset ZN2
       push offset NAC2
       call NAJDI                          ;hlada 3.retazec v 2.retazci
       NR                                  ;makro na odriadkovanie

       mov ah, 4ch                         ;ukonci program
       int 21h    
CODE   ENDS
END START       

;program je funkcny, retazce mozu byt maximalne velkosti polovice segmentu,
;pri nacitavani retazca je pouzita dosovska sluzba 0ah a pri vypise textu dos.
;sluzba 09h