;Zadanie c.3
;
;S vyuzitim  retazcovych  instrukcii  (vsade   kde  je  to  mozne) vytvorte program, ktory:
;a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov
;    (minimalne dlzky 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;c) porovna posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zisti, ci su rovnako dlhe a ci su rovnake
;d) zisti,  ci  sa  v  niektorom   z  retazcov  nachadza  zadany
;   podretazec.
;
;Autor:  Juraj Proksa  
;Termin odovzdania: 5.12.2000
;2.roc.,sk.rok 2000/2001

zas	segment	stack
	db	100h	dup(?)
zas	ends

data1	SEGMENT
	dat1 DB 50 dup (0)
	buffer DB 43 DUP (?)
	hlaska1 DB 'Zadajte retazec (max 40 znakov)',13,10,'$'
	pocet1 DB ?
	pocet2 DB ?
	hlaska2 DB 'Retazce su rovnake.',13,10,'$'
	hlaska3 DB 'Retazce nie su rovnake.',13,10,'$'
	hlaska4 DB 'Zadajte hladany podretazec.',13,10,'$'
	hlaska5 DB 'Hladany podretazec nebol najdeny.',13,10,'$'
	hlaska6 DB 'Podretazec sa nachadza v aspon jednom retazci.',13,10,'$'
data1	ENDS

data2 	SEGMENT
	dat2 DB 50 dup (0)
data2	ENDS

code	SEGMENT

	assume ds:data1,cs:code, ss:zas

START:
	mov ax,seg DATA1
	mov ds,ax		;nastavenie ds na data1

	mov ax,0600h
	mov dx,8024
	mov cx,0		;nastavenie parametrov na vymazanie obrazovky
	mov bh,7
	int 10h			;vymaze obrazovku
	mov ah,2
	mov dx,0
	mov bh,0
	int 10H			;nastavi kurzor na 0 0		

;a-------------------------------------------------------------------------------
	mov ah,9		;vypis hlasky
	lea dx,hlaska1		;adresa hlasky
	int 21h

	mov buffer[0],40	;do bufferu sa nacita max 40 znakov
	mov ah,10		;nacitanie retazca
	lea dx,buffer
	int 21h

	mov ah,2
	mov dl,13
	int 21h			;enter
	mov ah,2
	mov dl,10		
	int 21h


	mov al,buffer[1]	;v buffer[1] pocet pismen
	mov pocet1,al		;

	mov ax,ds		;
	mov es,ax		;nastavenie es na ds
	cld			;smer dopredu
	lea si,buffer		;
	add si,2		;nastavenie adresy na prvy znak v buffer
	lea di,dat1		;nastavenie adresy 
	mov cl,pocet1		;pocet znakov
	xor ch,ch
rep	movsb			;presunutie znakov z bufferu do dat1


	mov ah,9		;vypis hlasky
	lea dx,hlaska1		;adresa hlasky
	int 21h

	mov buffer[0],40	;do bufferu sa nacita max 40 znakov
	mov ah,10		;nacitanie retazca
	lea dx,buffer
	int 21h

	mov ah,2
	mov dl,13
	int 21h			;enter
	mov ah,2
	mov dl,10		
	int 21h

	mov al,buffer[1]	;v buffer[1] pocet pismen
	mov pocet2,al		;

	mov ax,seg data2	;nastavenie es na druhy datovy segment
	mov es,ax		;

	cld			;smer dopredu
	lea si,buffer		;
	add si,2		;nastavenie adresy na prvy znak v buffer
	lea di,dat2		;nastavenie adresy 
	mov cl,pocet2		;pocet znakov
	xor ch,ch
rep	movsb			;presunutie znakov z bufferu do dat1
;ab------------------------------------------------------------------------------
	mov ax,ds		;
	mov es,ax		;nastavenie es na ds

	mov al,pocet1
	cbw			;pocet1 na word vysledok v ax
	dec ax			;pocet-1(lebo retazec zacina 0)
	lea si,dat1		;
	add si,ax		;nastavenie zdroju na koniec pismen
	lea di,dat1
	add di,ax		;nastavenie cielovej adresy na koniec
	add di,10		;+ posun o 10 slabik

	xor ch,ch
	mov cl,pocet1		;nastavenie poctu opakovni
	std			;smer dozadu
rep	movsb			;posunutie

;bc------------------------------------------------------------------------------

	mov al,pocet1		;dlzka prveho retazca
	cmp al,pocet2		;porovna dlzku prveho a druheho retazca
	jne NIE			;ak nie nemozu byt rovnake retazce

	mov ax,seg data2
	mov es,ax		;nastavenie es na druhy segment

	lea si,dat1		;
	add si,10		;pociatocna adresa prveho retazca 
	lea di,dat2		;pociatocna adresa druheho retazca 

	cld			;smer dopredu
	mov cl,pocet2		;pocet opakovani
repe	cmpsb 
	jne NIE			;ak sa najde prvy rozdielny
	
	mov ah,9		;vypis retazca
	lea dx,hlaska2		;'Retazce su rovnake.'
	int 21h	
	jmp KONIEC

NIE:	mov ah,9		;vypis retazca
	lea dx,hlaska3		;'Retazce nie su rovnake.'
	int 21h

KONIEC:
;cd------------------------------------------------------------------------------
	mov ah,9		;vypis hlasky
	lea dx,hlaska4		;adresa hlasky
	int 21h

	mov buffer[0],40	;do bufferu sa nacita max 40 znakov
	mov ah,10		;nacitanie retazca
	lea dx,buffer
	int 21h

	mov ah,2
	mov dl,13		
	int 21h			;enter
	mov ah,2
	mov dl,10		
	int 21h


	mov ax,ds		;
	mov es,ax		;nastavenie es na ds

	lea si,dat1		;
	add si,10		;nastavenie na prvy znak prveho retazca
	lea di,buffer
	add di,2		;nastavenie na prvy platny znak bufferu

	mov cl,pocet1	
	xor ch,ch
	
ZNUVU:	push cx			;
	push si			;odzalohovanie premennych
	push di			;
	
	mov cl,buffer[1]	;pocet opakovnia porovnavania
	cld			;smer porovnania
repe	cmpsb			;porovnanie
	je ANO			;ak bola zhoda vsetkych znakov

	pop di			;vybranie
	pop si			
	inc si			;posunutie na dalsi znak
	pop cx	
	loop ZNUVU

	mov ax,seg data2
	mov es,ax		;druhy retazec budev extra segmente

	mov cl,pocet2		;pocet znakov v retazci-pocet opakovani porovnania
	xor ch,ch

	lea si,buffer		
	add si,2		;nastavenie na prvy platny znak hladaneho ret.
	lea di,dat2		;prvy znak prehladavaneho retazca

ZNUVU2:	push cx
	push si
	push di
	
	mov cl,buffer[1]	;pocet znakov v hladanom retazci
	cld			;smer prehladavania
repe	cmpsb			;porovnanie
	je ANO

	pop di
	pop si
	inc di			;posunutie na dalsi retazec
	pop cx	
	loop ZNUVU2

	mov ah,9		;vypis hlasky
	lea dx,hlaska5		;adresa hlasky
	int 21h

	jmp KON
ANO:
	mov ah,9		;vypis hlasky
	lea dx,hlaska6		;adresa hlasky
	int 21h
KON:
;d------------------------------------------------------------------------------
	mov ax,4C00h		
	int 21h			;ukoncenie programu

code	ENDS
	END START

;Progran je funkcny. Program bol scompilovany programom Turbo Assembler v 2.2 a 
;zlinkovany Turbo Link v 3.01. Program funguje na pocitacoch s procesormi radu 
;80X86 a na operacnych systemoch kompatibilnych s MSDOS.
;Program pri nacitavani berie do uvahy len 40 znakov ostatne ignoruje. Rovnake 
;obmedzenie ma aj hladany retazec. Program nema ziadne ine obmedzenia.
