;Zadanie c.1.
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov)
;a podla ponkanho menu vykon  jednu z monost:
;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX 
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zlava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukonc vykonvanie programu.

;Autor: Martin Sasko  
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001


;----------------------------
ZAS	SEGMENT stack                ;zaciatok zasobnikoveho segmentu   
	dw  64 DUP (?)               ;definicia 64 slov
ZAS	ends	                     ;koniec zasobnikooveho segmentu
;----------------------------
DATA	SEGMENT                      ;zaciatok datoveho segmentu
text	db  101 DUP (?)
otazka	db 'zadaj max. 100 znakov: ',10,13,'$'
znak	db 'zadaj znak: $'
vyskyt	db 'pocet vyskytov: $'
najviac db 'najvacsiu hodnotu ma: $'
pomedz  db 'prva medzera sa nachadza na mieste cislo: $' 
pocet	dw ?
nic	db 'ziadna medzera$'
ponuka	db 10,13,'MENU PROGRAMU',10,13
        db 'v - vypise retazec na obrazovku',10,13
	db 'p - vypise poradove cislo miesta, kde sa nachadza prva medzera',10,13
	db 'z - hlada v retazci zadany znak a zisti kolkokrat sa opakuje',10,13
	db 'n - najde znak s max. hodnotou a vypise ho',10,13
	db 'r - zarovna text zlava (vynecha prve medzery)',10,13
	db 'o - vypise retazec v opacnom poradi',10,13
	db 'k - koniec programu',10,13,'$'
DATA	ends
;-----------------------------
Code 	SEGMENT
	ASSUME CS:CODE , DS:DATA , SS: ZAS

vypis_cisla PROC		;procedura na vypisanie cisla z DI (hexa)

	mov ah,2
	mov bx,DI
	shr bl,1
	shr bl,1
	shr bl,1		;extrakcia prvej cifri poctu
	shr bl,1
	cmp bl,9		;zisti ci je cifra z intervalu 0-9 alebo A-F
	ja pismeno		
	add bl,30h		;upravenie cifry do znaku 0-9
	jmp DALEJ
pismeno:add bl,37h		;upravenie cifry do znaku A-F		

dalej:	mov dl,bl
	int 21h			;vypis prvej cifry
	mov bx,DI
	shl bl,1
	shl bl,1
	shl bl,1
	shl bl,1		;extrakcia nizsej cifry 16-koveho cisla
	shr bl,1
	shr bl,1
	shr bl,1
	shr bl,1
	cmp bl,9		;zisti ci je cifra z intervalu 0-9 alebo A-F
	ja pismeno1
	add bl,30h		;upravenie cifry do znaku 0-9
	jmp dalej1
pismeno1:add bl,37h		;upravenie cifry do znaku A-F

dalej1:	mov dl,bl		
	int 21h			;vypis druhej cifry
	mov ah,08h
	int 21h			;cakanie na stacenie klavesy
	jmp menu

            RET
	    ENDP	




START:  mov ax,seg DATA         ;do ax vlozi segmentovu cast adresy
	mov ds,ax		;nastavenie ds na datovy segment
	mov ah,09h              ;funkcia na vypis retazca
	mov dx,offset otazka    ;vupis komentara
	int 21h			;vypis ziadosti na obrazovku
	xor DI,DI		;nulovanie pocitadla

nacitaj:mov ah,01h              ;nacita znak z klavesnice
	int 21h			;volanie sluzby MS-DOSU,prerusenie
	mov text[DI],al	 	;ulozi znak do pamate
	inc DI                  ;zvisovanie DI
	cmp al,13		;prorovnavanie s enterom
	jnz nacitaj		;skok na nacitaj		
	dec DI                  ;znizovanie DI
	mov text[DI],'$'	;vlozenie $ na koniec retazca
	mov pocet,DI            ;zisti pocet znakov v retazci


menu:
	mov ah,09h
	mov dx,offset ponuka
	int 21h
	mov ah,08h              ;nacitanie vyberu z menu   
	int 21h

	cmp al,'v'
	jz vypis
	cmp al,'p'
	jz hladaj
	cmp al,'z'
	jz hladdznak
	cmp al,'n'
	jz maxxznak
	cmp al,'r'		;skoky na vybrane casti 
	jz rrovno
	cmp al,'o'
	jz opakk
	cmp al,'k'
	jz koniec1

hladdznak: jmp hladznak
maxxznak: jmp maxznak
rrovno: jmp rovno		;vzdialene skoky
opakk: jmp opak
koniec1: jmp koniec
;-----------------------------	
vypis:	mov ah,09h
	mov dx,offset text	;vypis retazca
	int 21h
	mov ah,08h
	int 21h			;cakanie na stacenie klavesy
	jmp menu		;skok na menu
;------------------------------
hladaj:	xor DI,DI               ;vynulovanie pocitadla DI		

znovu:	cmp text[DI],' '        ;ak najde medzeru, skok 
	jz nalez
	cmp text[DI],'$'	;kontrola konca retazca
	jz nnalez		;ak sa znak rovna $, skok na vypis, ze nenasiel
	inc DI                  ;zvisovanie DI
	jmp znovu               ;nepodmienany skok na znovu

nalez:	inc DI                  ;zvisenie DI
	mov ah,09h
	mov dx,offset pomedz    ;vypis komentara
	int 21h 
	call vypis_cisla	;procedura na vypisanie cisla v DI

nnalez: mov ah,09h              ;ak nenasiel medzeru
	mov dx,offset nic	;vypis komentara 
	int 21h
	mov ah,08h
	int 21h			;cakanie na stacenie klavesy
	jmp menu                ;skok na menu
;----------------------------
hladznak:mov ah,09h
	mov dx,offset znak	;vypisanie komentara
	int 21h
	mov ah,01h
	int 21h			;nacitanie znaku
	xor DI,DI               ;vynulovanie DI
	dec DI                  ;znizenie DI, aby isiel od nuly
	xor cx,cx               ;vynulovanie cx 
znovu1:	inc DI                  ;zvisovanie DI
	cmp text[DI],'$'        ;kontrola konca retazca 
	jz stop			;ak je na konci vypise vysledok
	cmp al,text[DI]
	jnz znovu1		;ak nie je zadany znak potom so vrati
	inc cx		        ;zvisovanie cx
	jmp znovu1

stop:	mov ah,02h                ;nacita znak, aby sa nemuselo cakat na stlacenie klavesy
	mov dl,10               ;posunutie kurzora do dalsieho riadku
 	int 21h
	mov dl,13               ;posunutie kurzora na zaciatok riadku
	int 21h
	mov ah,09h
   	mov dx,offset vyskyt    ;vypis komentara 
	int 21h
	mov DI,cx               ;do DI ulozi pocet najdenych znakov
	call vypis_cisla	;procedura na vypisovanie cisla v DI
;----------------------------
maxznak:xor DI,DI               ;vynulovanie DI
	mov cl,text[DI]		;cl docasne maximum
	
znovu2:	inc DI
	cmp text[DI],'$'	;kontrola konca retazca
	jz stop1                ;ak sa znak rovna $, skok von z cyklu
	cmp text[DI],cl         ;kontrola znakov retazca
	ja viac		        ;ak je vacsie, skok na priradenie noveho maxima
	jmp znovu2              ;inak skok na zaciatok cyklu 
viac:	mov cl,text[DI]		;cl je nove maximum
	jmp znovu2

stop1:	mov ah,02h              ;nacita znak, aby sa nemuselo cakat na stlacenie klavesy
	mov ah,09h
	mov dx,offset najviac   ;vypis komentara
	int 21h
	mov ah,02h
	mov dl,cl
	int 21h			;vypis max. znaku
	mov ah,08h              ;cakanie na stacenie klavesy
	int 21h
	jmp menu		;skok na menu
;----------------------------
rovno:	xor DI,DI               ;vynulovanie DI 
	dec DI                  ;znizenie DI,aby islo od nuly
znovu3:	inc DI                  ;zvisenie DI
	cmp text[DI],' '	;ak sa rovna, skok naspat
	jz znovu3               ;zisti sa pocet medzier
	mov cx,DI		;cx pocet medzier na zaciatku
	sub pocet,cx            ;urobi rozdiel a vysledok da do pocet 
	xor bx,bx		;vynulovanie bx pocitadla
znovu4:	mov DI,bx               ;do DI da hodnotu 0
	add DI,cx               ;scitanie, vysledok da do DI  
	mov al,text[DI]         
	mov DI,bx               
	mov text[DI],al		;zarovnavanie z lava (posun textu o cx znakov)
	inc bx                  ;zvisenie bx
	mov DI,bx
	add DI,cx               ;scitanie DI a cx
	cmp text[DI],'$'        ;kontrola konca retazca
	jnz znovu4              ;ak je znak rozny ako $, skok naspat na znovu4
	mov DI,bx
	mov text[DI],'$'        ;pridanie $ do retazca
	mov ah,09h
	mov dx,offset text
	int 21h                 ;vypisanie retazca
	mov ah,08h              ;cakanie na stlacenie klavesy
	int 21h
	jmp menu                ;skok na menu
;-----------------------------
opak:	mov DI,pocet            ;presunie pocet do DI
	mov ah,02h              ;nacita znak, aby sa nemuselo cakat na stlacenie klavesnice
znovu5:	dec DI                  ;znizovanie DI
	mov dl,text[DI]		;vypis textu od zadu
	int 21h
	cmp DI,0                ;kontrola konca (zaciatku) retazca
	jnz znovu5              ;ak je DI rozny od nuly, skok naspat na znovu5
	mov ah,08h
	int 21h			;cakanie na stacenie klavesy
	jmp menu		;skok na menu
;---------------------------
koniec:	mov ax,4C00h		
	int 21h			;koniec programu
CODE	ends
	END START

;Program je funkcny. Bol skompilovany pomocou Turbo Assembler Version 2.02
;a zlinkovany pomocou  Turbo Link Version 3.01.
;Obmedzenia:1. ak sa do retazca zapise znak dolara $, vo vsetkych 
;moznostiach programu sa bude pracovat len so znakmi po znak dolara
;2. po vykonani jednej moznosti, sa naspat do menu dostaneme po stlaceni
;lubovolnej klavesy okrem sipky hore(hned sa spusti sluzba - hladaj znak) 
;3. ak sa v menu staci iny znak ako sa ponuka, spusti sa sluzba - hladaj znak
;Cisla su vypisovane v 16-kovej sustave 