;ZADANIE C.2
;Text zadania : Vytvorte program, ktroy nacita z textoveho suboru postupnost
;celych cisel so znamienkom v desiatkovej ciselnej sustave (aspon 10), potom ich transformuje
;na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom podla priania uzivatela:
;a) vypocita sumu vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel do noveho textoveho suboru
;c) vydeli dve dane cisla a vypise vysledok
;d) ukonci vykonavanie programu


;AUTOR: Martin Sasko
;Termin odovzdania: 14.11.2000
;2.roc.,sk.rok 2000/2001

;-------------------------------
ZAS	SEGMENT		STACK		;definujem stack
	DW		64 DUP(?)
ZAS	ENDS
;-------------------------------
DATA	SEGMENT	      			;definujem data
ponuka	db '-----------Ponuka---------------',13,10
	db 'v - vypisat sumu vsetkych cisel ',13,10
	db 'u - usporiadat cisla a zapisat do suboru ',13,10
	db 'n - nasobit dve cisla',13,10
	db 'd - vydelit dve cisla ',13,10
	db 'k - Koniec ',13,10,'$'
SUM	db 'Suma vsetkych cisel je: $'
OW	db 'Doslo k preteceniu! Nemozno vypocitat sumu cisel.$'
DEL1	db 'Napis poradove cislo prveho: $'
DEL2	db 'Napis poradove cislo druheho cisla: $'
ZV	db 'Zvysok $'


nr	db 13,10,'$'	;novy riadok
FILEIN	dw ?		;handle vstupneho suboru
FILEOUT	dw ?		;handle vystupneho suboru
FILE	db 'vstup.txt',0
FILE2	db 'vystup.txt',0
BUFFER	db ?		;buffer pre pracu so subormi
ZNAM	db 0H		;ak je cislo zaporne ZNAM=1, inac ZNAM=0
SORT	dw 100 DUP(?)	;sem ukladam usporiadane cisla
EOF	db ?		;ak je koniec subora,tak EOF=1, inac EOF=0
DATA	ENDS

;--------------------------------
CODE	SEGMENT
	ASSUME CS:CODE,SS:ZAS,DS:DATA


citcis	PROC			;nacita cislo z aktualnej adresy v subore, ktoreho handle je v bx 
	mov ZNAM,0
cc4:	mov ah,3Fh
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	xor cx,cx
	jnc cc5 			;ak nenastala chyba pri citani tak chod na cc1
cc5:	cmp ax,0
	je koniecc2
	cmp BUFFER,02Dh			;zisti, ci je BUFFER znamienko
	jne cc6	         		;ak nie skoci na cc6
	mov ZNAM,1			;ak ano ulozi do ZNAM jednotku, cize cislo bude zaporne
cc6:	cmp BUFFER,30h			;otestuje, ci je BUFFER>=0
	jb cc4				;ak nie skoci naspat na cc4
	cmp BUFFER,39h			;ak ano, otestuje, ci je BUFFER<=9
	jg cc4				;ak nie, tak nacitava zo suboru az ho najde
	xor ax,ax			;ak ano, vynuluje ax, v ax bude to nacitane cislo aj so znamienkom v doplnkovom kode
	push ax				;vlozi ax na zasobnik
cc1:	
	pop ax				;vytiahne ax zo zasobnika
	mov cx,10
	mul cx				;vynasobi ax*10
	mov cl,BUFFER
	sub cl,30h
	add al,cl			;a prida k al,dalsiu nacitanu cislicu
	jnc cc2
	inc ah				;ak nastalo pretecenie z al,incrementuje ah
cc2:
	push ax				;ulozi ax na zasobnik
	mov ah,3Fh
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	jnc cc3 			;ak nenastala chyba pri citani tak chod na @RW1, inak
cc3:	xor cx,cx
	cmp ax,0
	je koniec3
	cmp BUFFER,30h			;zisti, ci je BUFFER(nacitana cislica)>=0
	jb koniec1			;ak nie ukonci nacitanie cisla a skoci na koniec1, cislo je uz cele
	cmp BUFFER,39h			;zisti, ci je BUFFER<=9
	jg koniec1			;ak nie ukocni nacitanie cisla a skoci na koniec1
	jmp cc1 			;ak je BUFFER znova cislica, skoci na @RW1, kde ju dalej spracuje
koniec1:
	mov cx,1
koniec3:
	pop ax				;vytiahne zo zasobnika ax,kde sa nachadza nacitane cislo(zatial, len kladne)
	cmp ZNAM,1			;zisti, ci cislo ma byt zaporne
	jne koniecc2			;ak nie skoci na koniec2(koniec)
	neg ax				;ak ano zneguje ax,(not(ax)+1),z coho vznikne doplnkovy kod zaporneho cisla ax
koniecc2:
	ret
citcis	ENDP
;--------------------------------------
vypiscis PROC			;vypise cislo v doplnkovom tvare na obrazovku(v desiatkovej sustave)
	mov bh,ah			
	and bh,080h			
	cmp bh,080h			;zisti ci je prvy bit(znamienkovy) 1
	jne vc4 			;ak nie skoci na vc4, cislo je kladne
	push ax				;ak ano cislo je zaporne, ulozi cislo v ax na zasobnik
	mov ah,02h
	mov dl,2Dh
        int 21h                         ;vypise na obrazovku znak '-'
	pop ax				;vytiahne cislo zo zasobnika
	neg ax				;zneguje cislo na kladne cislo
vc4:	mov cx,9999			;cx<-9999(pretoze max.cislo ma 5 cislic)
vc2:	inc cx				;zvysovanie cx
	xor dx,dx			;vynulovanie dx
	div cx				;ax<-ax/cx
	push dx				;teraz sa v ax nachadza x-ta cislica a v dx zvysok, dx ulozime na zasobnik
	cmp al,0			;porovname cislicu s 0
	jne vc3 			;ak sa nerovna, skocime na vc3
	xor dx,dx			;inac vynulujeme dx
	mov ax,cx			;ax<-cx
	mov bx,10			
	div bx				;vydelime ax desiatimi
	mov cx,ax			;cx<-ax (posunieme sa o jednu cisilicu)
	pop ax				;vytiahneme cislicu zo zasobnika
	loop vc2			;pokial sme neotestavali aj poslednu cislicu(cx=1) tak skoci na vc2
	push ax				;vlozi ax na zasobnik
vc3:
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;napise cislicu na obrazovku
	xor dx,dx			;vynulovanie dx
	mov ax,cx		
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahneme cislo zo zasobnika
	dec cx				;znizovanie cx
vc1:	inc cx				;zvysovanie cx
	cmp cx,1			;otestujeme, ci uz nie je poslenda cislica(cx=1)
	je konvc  	 	        ;ak ano skoci na konvc
	cmp cx,0			;otestuje ci este je nejaka cislica
	je konvc2			;ak nie skoci na konvc2
	xor dx,dx			;vynulovanie dx
	div cx				;ax<-ax/cx
	push dx				;vlozi dx na zasobnik
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;vypise cislicu v al na obrazovku
	xor dx,dx			;vynulujem dx
	mov ax,cx
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahnem cislo zo zasobnika
	loop vc1			;ak su este nejake cislice skoci na vc1

konvc:	mov dl,al			
	add dl,30h
	mov ah,02h
	int 21h				;vypise poslednu cislicu
konvc2:
	ret
vypiscis	ENDP
;---------------------------------------
vypissub	PROC			;to iste ako vypiscis, ibaze nevypise cislo na obrazovku, ale do suboru, ktory ma handle v bx
	mov cx,bx
	mov bh,ah
	and bh,080h
	cmp bh,080h
	jne vs4
	push ax
	
	push cx
	mov ah,40h
	mov bx,cx
	mov cx,1
	mov BUFFER,2Dh
	mov dx,offset BUFFER
	int 21h
	pop cx
	pop ax
	neg ax
vs4:	mov bx,cx
	mov cx,9999
vs2:	inc cx
	xor dx,dx
	div cx
	push dx
	cmp al,0
	jne vs3
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop vs2
	push ax
vs3:
	push cx
	mov ah,40h
	mov cx,1
	add al,30h
	mov BUFFER,al
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	dec cx
vs1:	inc cx
	cmp cx,1
	je konvs
	cmp cx,0
	je konvs2
	xor dx,dx
	div cx
	push dx
	push cx
	mov ah,40h
	add al,30h
	mov BUFFER,al
	mov cx,1
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop vs1

konvs:	mov dl,al
	add dl,30h
	push cx
	mov ah,40h
	mov cx,1
	mov BUFFER,dl
	mov dx,offset BUFFER
	int 21h
	pop cx
konvs2:
	ret
vypissub	ENDP


;--------------------------------------
START:	mov ax,seg DATA
	mov ds,ax			;inicializacia datoveho segmentu DS
	mov ah,3dh
	mov al,0			;specifukuje subor ako read-only
	mov dx,offset FILE
	int 21h				;otvori subor s nazvom 'vstup.txt',ax je handle na tento subor			
	jnc @SUBOK			;zisti ci nenastala chyba pri otvarani subora
@SUBOK:
	mov FILEIN,ax			;ak nie vlozi do FILEIN handle vstupneho subora
menu:
	mov ah,09h
	mov dx,offset nr
	int 21h	
	mov ah,09h
	mov dx,offset ponuka
	int 21h				;vypise menu
	mov ah,08h
	int 21h				;nacita klavesu
	push ax
	mov ah,09h
	mov dx,offset nr
	int 21h				;skocim na novy riadok
	pop ax
	cmp al,'v'
	je suma				;ak je klavesa 'v' skoci na suma
	cmp al,'u'
	je uspo				;ak je klavesa 'u' skoci na uspo
	cmp al,'n'
	je nasobp			;ak je klavesa 'n' skoci na nasobp
	cmp al,'d'
	je deleniep			;ak je klavesa 'd' skoci na deleniep
	cmp al,'k'			
	je koniecp			;ak klavesa je 'k' skoci na koniecp

nasobp: jmp nasob
deleniep: jmp delenie			;vzdialene skoky
koniecp: jmp koniec

;-------------------------------------
suma:	
	xor bx,bx		;vynuluje bx, tu bude celkova suma
@11:	push bx
	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call citcis		;nacita cislo
	pop bx
	add bx,ax		;pripocitam cislo k bx
	cmp cx,0		;zisti ci je koniec suboru(cx=0)
	je @12			;ak ano skoci na @12
	jmp @11			;inac pokracuje na @11

@12:
	push bx
	mov ah,09h
	mov dx,offset SUM
	int 21h			;vypise retazec 'Vypocitana suma: '
	pop ax
	call vypiscis		;vypise sumu cisel
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	jmp menu

;---------------------------------------
uspo:
	mov ah,3ch
	mov al,0		;specifukuje subor ako normal
	mov dx,offset FILE2
	int 21h			;vytvori novy subor s menom 'vystup.txt',ax je handle na tento subor(FILEOUT)			
	mov FILEOUT,ax		;ulozi handle vystupneho subora do FIELOUT
	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call citcis		;nacita cislo do vstupneho suboru
	mov cx,0
	mov si,0
	mov SORT[si],ax		;ulozi ho do pola SORT na prve miesto
@22:	inc cx			;inkrementuje cx, v cx je pocet cisel v poli SORT
	mov bx,FILEIN
	push cx
	call citcis		;nacita cislo zo vstupneho suboru
	mov EOF,cl		
	pop cx
	push cx
	inc cx
	mov si,0
	mov di,0
@24:	cmp ax,SORT[si]		;prejde vsetkymi cislami v SORT, ci je nacitane cislo mensie ako co najmensie cislo v SORT
	jle @25			;ak ano skoci na @25
	jmp @26
@25:
	mov di,1
	mov bx,SORT[si]
	mov SORT[si],ax
	mov ax,bx
	add si,2
	loop @25		;vlozi cislo pred cislo v SORT[si], ktore je najmensie cislo, ktore je vacsie ako dane cislo
	inc cx			;inkrementuje cx
@26:
	add si,2
	loop @24
	sub si,2
	cmp di,1
	je @27
	mov SORT[si],ax		;ak je cislo vacsie ako vsetky cisla v SORT, ulozi ho na koniec
@27:
	pop cx
	cmp EOF,0		;zisti ci nebol koniec suboru
	je @23			;ak ano skoci na @23
	jmp @22			;ina na @22 
@23:	
	mov si,0
	inc cx
@28:	mov bx,FILEOUT
	mov ax,SORT[si]
	push cx
	mov bx,FILEOUT
	call vypissub
	pop cx
	push cx
	cmp cx,1
	je @29			;zapise cislo v poli SORT do vystupneho suboru
	mov ah,40h
	mov cx,1
	mov BUFFER,09h
	mov dx,offset BUFFER
	int 21h			;zapise tabulator do suboru(oddelenie cisel)
@29:	pop cx
	add si,2
	loop @28		;zapise vsetky cisla v SORT
	mov ah,3Eh
	mov bx,FILEOUT
	int 21h			;uzavre vystupny subor
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru 
	jmp menu

;-----------------------------------------------
nasob:
@40:    mov bx,FILEIN           ;bx<-handle vstupneho suboru
        call citcis           ;nacita cislo zo suboru
        push cx
        call vypiscis           ;zapise cislo na obrazovku
	mov ah,09h
        mov dx,offset nr	;skoci na novy riadok
        int 21h 
        pop cx
        cmp cx,0                ;otestuje ci nie je koniec suboru(ax=0)
        jne @40			;ak nie skoci na @40
	mov ah,09h
	mov dx,offset nr	;skoci na novy riadok
	int 21h                
        mov ah,09h
        mov dx,offset DEL1
        int 21h                 ;vypise text 'Napis poradie prveho cisla: '
        xor cx,cx
@42:    mov ah,01h
        int 21h                 ;nacita cislicu
        cmp al,13
        je @43                  ;ak bol stlaceny enter ukonci nacitavanie cisla a skoci na @43
        mov ah,0
        sub al,30h
        add cx,ax               ;prida nacita cislicu do ax
        jmp @42                 ;skok na @42
@43:
        push cx
        mov ah,42h
        mov bx,FILEIN
        xor cx,cx
        xor dx,dx
        xor al,al
        int 21h                 ;posunie sa na zaciatok suboru
        pop cx
@41:
        push cx
        call citcis     	;nacita cislo zo vstupne suboru
        pop cx
        loop @41                ;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
        push ax
        mov ah,42h
        mov bx,FILEIN
        xor cx,cx
        xor dx,dx
        xor al,al
        int 21h                 ;posunie sa na zaciatok vstupneho suboru
        xor cx,cx
        mov ah,09h
        mov dx,offset nr
        int 21h                 ;skoci na novy riadok
        mov ah,09h
        mov dx,offset DEL2
        int 21h                 ;vypise text 'Zadaj poradie druheho cisla: '
@45:    mov ah,01h
        int 21h
        cmp al,13
        je @44
        mov ah,0
        sub al,30h
        add cx,ax
        jmp @45
@44:
        push cx
        call citcis
        pop cx
        loop @44
        push ax
        mov ah,42h
        mov bx,FILEIN
        xor cx,cx
        xor dx,dx
        xor al,al
        int 21h                 ;posunie sa na zaciatok suboru
        mov ah,09h
        mov dx,offset nr
        int 21h                 ;potialto vsetko rovnake ako pri nacitani prveho cisla
        pop bx
        pop ax
        push ax
        push bx
        push bx                 ;povytahujem tie 2 cisla zo zasobnika
        call vypiscis           ;vypise 1. cislo
        mov ah,02h
        mov dl,'*'
        int 21h                 ;vypise '*'
        pop ax
        call vypiscis           ;vypise 2.cislo
        mov ah,02h
        mov dl,0CDh
        int 21h                 ;vypise '='
        pop bx
        pop ax
        xor dx,dx
        mul bx                 ;vynasobi 1.cislo 2., v ax bude celociselny vysledok
        call vypiscis           ;vypise vysledok
	jmp menu
;-----------------------------------------------
delenie:                        ;nacita poradia dvoch cisel a navzajom ich vydeli
@30:	mov bx,FILEIN		;bx<-handle vstupneho suboru
	call citcis		;nacita cislo zo suboru
	push cx			
	call vypiscis		;zapise cislo na obrazovku
	mov ah,09h
        mov dx,offset nr	;skoci na novy riadok
        int 21h 
	pop cx
	cmp cx,0		;otestuje ci nie je koniec suboru(ax=0)
	jne @30			;ak nie skoci na @30
	mov ah,09h
	mov dx,offset nr
	int 21h
	mov ah,09h
	mov dx,offset DEL1
	int 21h			;vypise text 'Napis poradie prveho cisla: '
	xor cx,cx
@32:	mov ah,01h
	int 21h			;nacita cislicu
	cmp al,13
	je @33			;ak bol stlaceny enter ukonci nacitavanie cisla a skoci na @33
	mov ah,0
	sub al,30h
	add cx,ax		;prida nacita cislicu do ax
	jmp @32			;skok na @32
@33:
	push cx
	mov ah,42h
	mov bx,FILEIN;
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	pop cx
@31:	
	push cx
	call citcis		;nacita cislo zo vstupne suboru
	pop cx
	loop @31		;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
	push ax
	mov ah,42h
	mov bx,FILEIN
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru
	xor cx,cx
	mov ah,09h
	mov dx,offset nr
	int 21h			;skoci na novy riadok
	mov ah,09h
	mov dx,offset DEL2
	int 21h			;vypise text 'Zadaj poradie druheho cisla: '
@35:	mov ah,01h		
	int 21h			
	cmp al,13		
	je @34			
	mov ah,0
	sub al,30h
	add cx,ax
	jmp @35
@34:	
	push cx
	call citcis
	pop cx
	loop @34
	push ax
	mov ah,42h
	mov bx,FILEIN
	int 21h
	xor cx,cx
	xor dx,dx
	xor al,al
	mov ah,09h
	mov dx,offset nr
	int 21h			;potialto vsetko rovnake ako pri nacitani prveho cisla
	pop bx
	pop ax
	push ax
	push bx
	push bx			;povytahujem tie 2 cisla zo zasobnika
	call vypiscis		;vypise 1. cislo
	mov ah,02h
	mov dl,2Fh
	int 21h			;vypise '/'
	pop ax
	call vypiscis		;vypise 2.cislo
	mov ah,02h
	mov dl,0CDh
	int 21h			;vypise '='
	pop bx
	pop ax
	xor dx,dx
	idiv bx			;vydeli 1.cislo 2., v ax bude celociselny vysledok a v dx bude zvysok
	push dx			
	call vypiscis		;vypise vysledok
	mov ah,09h
	mov dx,offset nr
	int 21h
	mov ah,09h
	mov dx,offset ZV
	int 21h			;vypise text 'zvysok'
	pop dx
	mov ax,dx
	call vypiscis		;a nakoniec vypise zvysok
	jmp menu
koniec:
	mov ah,3Eh
        mov bx,FILEIN
	int 21h
	mov ah,4ch
	int 21h

CODE 	ENDS
	END START

;Program je funkcny. Bol skompilovany pomocou Turbo Assembler Version 2.02
;a zlinkovany pomocou  Turbo Link Version 3.01.
;Obmedzenie:ak pri deleni je prve cislo zaporne, vypocita nezmysel
