; Zadanie c.2.

; Autor: Marek Skalak, B12

; Zadanie: Vytvorte  program,  ktory  nacita  z  textoveho suboru 
;	   postupnost celych cisel (aspon 10) so znamienkom  v desiatkovej 
;	   ciselnej sustave, potom ich transformuje na cisla v dvojkovej 
;	   ciselnej sustave v doplnkovom kde a potom podla priania pouzivatela:
;
;	   a) vypocita sumu  kaldnych a zapornych cisel a vypise ju
;          b) usporiada cisla vzostupne resp. zostupne a 
;             zapise usporiadanu postupnost cisel do noveho textoveho suboru,
;	   c) vydeli dve vybrane cisla a vypise vysledok
;	   d) vynasobi dve cisla a vypise vysledok
;	   e) ukonci vykonavanie programu.
;
; Termin odovzdania: 14.11.2000
; 2. rocnik, sk. rok 2000/2001

;-----------------------------------------------------------------------------
; Definuje segment zasobnika o velkosti 256B

zas     segment stack	'stack'
	dw      100h dup(?)
zas     ends

;-----------------------------------------------------------------------------
; Zaciatok datoveho segmentu, tu su definovane jednotlive datove
; struktury potrebovane v programe.

data    segment
infile	db	'zad2.in',0
hindle	dw	0
hondle	dw	0
handle	dw	0
oufile	db	'zad2.out',0
cis	db	'Nacitane cisla:',10,13,10,13,'$'
numbers	db	101 dup(0)
sorcis	db	'Cisla zotriedene vzostupne:',10,13,10,13,'$'
numbinv	db	101 dup(0)
nr	db	10,13,'$'
count	dw	0
conum	dw	0
conum2	dw	0
tmp	db	0
cislo	dw	0
tp	dw	0
tmp16	dw	0
hlaska	db	'Nepodarena akcia so suborom !!!',10,13,'$'
nums	dw	20 dup(0)
numes	dw	20 dup(0)
menu    db	10,13,10,13, 'Menu:',10,13
	db	'a) Suma kladnych cisel',10,13
	db	'b) Suma zapornych cisel',10,13
	db	'c) Usporiadat cisla vzostupne a ulozit ich do suboru',10,13
	db	'd) Vydelit dve vybrane cisla',10,13
	db	'e) Vynasobit dve vybrane cisla',10,13
	db	'f) Ukoncit program',10,13,10,13
	db	'Stlac pismeno pre vyber', 10,13,10,13,'$'
uvod	db	'Zadanie c.2, naprogramoval Marek Skalak.',10,13,10,13,'$'
pokrac	db	10,13,10,13,'Stlac nieco...',10,13,'$'
pret	db	10,13,10,13
	db	'Doslo k prekroceniu rozsahu <-30000, 30000> !!!',10,13,'$'
vysle	db	10,13,10,13,'Vysledok je : '
vys	db	6 dup(32) ,10,13,'$'
suma	dw	0
suma1	dw	0
suma2	dw	0
dizvs	db	10, 13,'Zvysok po deleni : $'
divzv	dw	0
divys	dw	0
delenec	dw	0
delitel	dw	1
dlcs	db	0
dlts	db	0
dele	db	10 dup(0)
deli	db	10 dup(0)
zadprv	db	10,13,10,13,'Vyber si prve cislo : $'
zaddru	db	10,13,'Vyber si druhe cislo : $'
con	dw	10
delnul	db	10,13,10,13,'Doslo k deleniu nulou !!!',10,13,'$'
addr	dw	0
iscif	db	0
isnnu	db	10,13,10,13,'Vybrane cislo nie je medzi nacitanymi !!!', '$'
pre	db	0
data    ends
;-----------------------------------------------------------------------------
code    segment                           ; zaciatok kodoveho segmentu
	assume  cs:code, ds:data, ss:zas  ; aktivovanie segmentov
;-----------------------------------------------------------------------------
opifile	proc				; procedura na otvorenie vstup. suboru
	clc				; vynulovanie Carry
	mov	dx, offset infile	; do dx presunie offset infile
	mov	ax, 3d00h		; do ax nastavi hodnoty pre otvorenie
	int	21h			; suboru na citanie, a zavola int 21h
	call	hlas			; zavola proceduru hlas
	mov	hindle, ax		; ak je vsetko O.K. do hindle vlozi 
	ret				; handle suboru, skocni proceduru
	endp				;
;-----------------------------------------------------------------------------
clifile	proc				; zavretie vstupneho suboru  
	mov	dx, offset infile	; do dx vlozi offset infile
	mov	bx, hindle		; do bx handle na vstupny subor
	mov	ah, 3eh			; nastavenie sluzby DOS pre zatvorenie
	int	21h		    	; suboru a zavolanie int 21h
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
opofile	proc				; procedura na otvorenie vystup. suboru
	clc				; vymazanie Carry
	mov	dx, offset oufile	; do dx vlozi offset oufile
	mov	ax, 3d01h		; do ax nastavi hodnoty pre otvorenie
	int	21h			; suboru na zapis, a zavola int 21h
	call	hlas			; zavola proceduru hlas
	mov	hondle, ax		; ak je vsetko O.K. do hondle vlozi
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
clofile	proc				; zavretie vystupneho suboru
	mov	dx, offset oufile	; do dx offset oufile
	mov	bx, hondle		; do bx handle vystup. suboru
	mov	ah, 3eh			; nastavenie sluzby DOSu 3eh
	int	21h			; zavolanie int 21h
	ret				; navrat
	endp			   	;
;-----------------------------------------------------------------------------
readin	proc				; nacitanie dat zo vstupneho suboru
	mov	ah, 3fh			; nastavenie sluzby DOSu 3fh
	mov	bx, hindle		; do bx handle vstup. suboru
	mov	dx, offset numbers	; do dx offset numbers
	mov	cx, 100			; do cx pocet nacitavanych bytov
	int	21h			; zavola int 21h
	call	hlas			; zavola hlas
	mov	count, ax		; ak je O.K. do count pocet nacitanych
	ret				; bytov, navrat
	endp				;
;-----------------------------------------------------------------------------
wriout	proc				; zapis do vystupneho suboru
	mov	ah, 40h			; nastavenie sluzby DOSu 40h
	mov	bx, hondle		; do bx handle vystup. suboru
	mov	dx, offset vys		; do dx offset vys
	mov	cx, 6			; do cx pocet bytov na zapis
	int	21h			; zavola int 21h
	call	hlas			; zavola hlas
	mov	ah, 40h			; nastavinie sluzby DOSu 40h
	mov	bx, hondle		; do bx handle vystup. suboru
	mov	dx, offset nr		; do dx offset nr
	mov	cx, 2			; do cx pocet bytov na zapis
	int	21h			; zavola int 21h
	call	hlas			; zavola hlas
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
hlas	proc				; vypis chybovej hlasky
	jnc	hlar			; ak je C=0 tak skoci na hlar a skonci
	mov	dx, offset hlaska	; inak do dx offset hlaska
	mov	ah, 09h			; pomocou sluzby DOSu 09h 
	int	21h			; ju vypise na obrazovku
	call	koniec			; a zavola koniec
hlar:	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
men	proc				; vypis menu na obrazovku
	mov	dx, offset cis		; vypis nacitanych cisel na obrazovku
	mov	ah, 09h			; pomoco sluzby 09h
	int	21h			; zavola int 21h
	call	numbs			; zavola proceduru numbs
	mov	dx, offset menu		; vypise menu na obrazovku
	mov	ah, 09h			; pomocou 09h
	int	21h			; zavola int 21h
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
press	proc				; stlacenie pismena z menu
	mov	ah, 8			; nacita znak z klavesnice bez echa
	int	21h			; zavola int 21h
	cmp	al, 'a'			; porovna al s 'a'
	jnz	a1pres			; ak nie ide na bpres
	call    sum			; ak ano zavola sum
a1pres:	cmp     al, 'b'			; porovna al s 'b'
	jnz	bpres			; ak nie ide na cpres
	call    sum1			; ak ano zavola sort
bpres:	cmp     al, 'c'			; porovna al s 'b'
	jnz	cpres			; ak nie ide na cpres
	call    sort			; ak ano zavola sort
cpres:	cmp     al, 'd'			; porovna al s 'c'
	jnz	dpres			; ak nie ide na dpres
	call    divide			; ak ano zavola 
dpres:	cmp     al, 'e'			; porovna al s 'd'
	jnz     epres			; ak nie ide na epres
	call    multi			; ak ano zavola multi
epres:	cmp	al, 'f'			; porovna al s 'e'
	jnz     enpres			; ak nie ide na enpres
	call	koniec			; ak ano zavola koniec
enpres: call	clrscr			; zavola clrscr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
sum	proc				; suma nacitanych cisel
	mov	suma, 0			; vynuluje sumu
	call	clrscr			; zavola clrscr
	call	clean			; zavola clean
	mov	dx, offset cis		; do dx da offset cis
	mov	ah, 09h			; vypise cis na obrazovku
	int	21h			; pomocou 09h a int 21h
	call	numbs			; zavola numbs
	mov	cx, conum		; do cx vlozi pocet cisel v cis
	xor	ax, ax			; vynuluje ax
	mov	bx, offset nums		; do bx vlozi offset nums
	clc				; vynuluje Carry
sumlo:  mov	ax, [bx]		; do ax da obsah [bx]
	cmp     ax, 10000000b
	jb	sump
        jmp	sumex 
sump:	add	suma,ax
sumex:	mov	ax,suma
;	add	suma, ax		; pripocita k sume ax
;	mov	ax, suma		; a ax vlozi do sumy
;	cmp	ax, -30000		; porovna ax s -30000
;	jl	sumpre			; ak je menej skoci na sumpre
;	cmp	ax, 30000		; porovna ax s 30000
;	jg	sumpre			; ak je viac skoci na sumpre
	inc	bx			; inkrementuje bx
	inc	bx			; inkrementuje bx
	loopne	sumlo			; ak cx nie je 0 skoci na sumlo
	jmp	sumen			; skoci na sumen
sumpre:	call	pretec			; zavola pretec
	call	pokr			; zavola pokr
	ret				; navrat
sumen:  mov	ax, suma		; do ax vlozi sumu
	call    revert			; zavola revert
	call	vysled			; zavola vysled
ensum:	call	pokr			; zavola pokr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
sum1	proc				; suma nacitanych cisel
	mov	suma, 0			; vynuluje sumu
	call	clrscr			; zavola clrscr
	call	clean			; zavola clean
	mov	dx, offset cis		; do dx da offset cis
	mov	ah, 09h			; vypise cis na obrazovku
	int	21h			; pomocou 09h a int 21h
	call	numbs			; zavola numbs
	mov	cx, conum		; do cx vlozi pocet cisel v cis
	xor	ax, ax			; vynuluje ax
	mov	bx, offset nums		; do bx vlozi offset nums
	clc				; vynuluje Carry
sumlo1:  mov	ax, [bx]		; do ax da obsah [bx]
	cmp     ax, 10000000b
	ja	sump1
        jmp	sumex1 
sump1:	add	suma,ax
sumex1:	mov	ax,suma
	inc	bx			; inkrementuje bx
	inc	bx			; inkrementuje bx
	loopne	sumlo1			; ak cx nie je 0 skoci na sumlo
	jmp	sumen1			; skoci na sumen
sumpre1:	call	pretec			; zavola pretec
	call	pokr			; zavola pokr
	ret				; navrat
sumen1:  mov	ax, suma		; do ax vlozi sumu
	call    revert			; zavola revert
	call	vysled			; zavola vysled
ensum1:	call	pokr			; zavola pokr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
sort	proc				; triedenie cisel
	call	clrscr			; zavola clrscr
	call	clean			; zavola clean
	mov	dx, offset nums		; do dx da offset nums
	mov	si, dx			; presunie dx do si
	mov	bx, offset numes	; do bx da offset numes
	mov	cx, conum		; do cx nastavi pocet cisel v nums
kosor:	mov	ax, [si]		; do ax vlozi obsah [si]
	mov	[bx], ax		; do [bx] vlozi ax
	inc	bx			; inkrementuje bx
	inc	bx			; inkrementuje bx
	inc	si			; inkrementuje si
	inc	si			; inkrementuje si
	loopne  kosor			; ak cx nie je 0 skoci na kosor
	mov	dx, offset numes	; do dx da offset numes
	mov	si, dx			; do si da dx
	mov	bx, offset numes	; do bx sa offset numes
	mov	cx, 0			; do cx nastavi 0
	mov	ax, conum		; do ax vlozi pocet cisel v numes
	mov	dx, 2			; do dx vlozi 2
	mul	dx			; vynasobi ax a dx
	mov	conum2, ax		; do conum2 vlozi vysledok
	mov	tp, 0			; do tp da 0
koba:   mov	bx, offset numes   	; do bx vlozi offset numes
	add	bx, cx			; pripocita k bx cx
	mov	ax, [bx]		; da do ax obsah [bx]
	mov	dx, [si]		; da do dx obsah [si]
	cmp	ax, dx			; porovna ax a dx
;	jl	kone			; ak ax<dx skoci na kone
	jnl	kone			; ak ax<dx skoci na kone
	mov	ax, [bx]		; inak do ax vlozi obsah [bx]
	mov	tmp16, ax		; do tmp16 vlozi ax
	mov	dx, [si]		; do dx vlozi obsah [si]
	mov     [bx], dx		; do [bx] vlozi dx
	mov	dx, tmp16		; do dx vlozi tmp16
	mov	[si], dx		; do [si] vlozi dx
	mov	tmp16, 0		; vynuluje tmp16
kone:	inc	cx			; inkrementuje cx
	inc	cx			; inkrementuje cx
	cmp	cx, conum2		; porovna conum2 s cx
	jnz	koba			; ak sa nerovnaju skoci na koba		
	xor	cx, cx			; vynuluje cx
	inc	tp			; inkrementuje tp
	inc	si			; inkrementuje si
	inc	si			; inkrementuje si
	mov	dx, tp			; da do dx tp
	cmp	dx, conum		; porovna dx a conum
	jnz	koba			; ak sa nerovnaju skoci na koba
kodal:  call	revsor			; zavola revsor
	call	pokr			; zavola pork
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
clean	proc				; cistenie poli v pamati
	mov	bx, offset dele		; do bx da offset dele
	mov	cx, con			; do cx da con
declea: mov	al, 0			; vynuluje al
	mov	[bx], al		; do [bx] vlozi al
	inc	bx			; inkrementuje bx
	loopne	declea			; ak cx nie je 0 skoci na declea
	mov	bx, offset deli		; do bx da offset dele
	mov	cx, con			; do cx da con
	mov	al, 0			; vynuluje al
diclea:	mov	[bx], al		; do [bx] vlozi al
	inc	bx			; inkrementuje bx
	loopne	diclea			; ak cx nie je 0 skoci na declea
	mov	cx, 6			; do cx vlozi 6
	mov	bx, offset vys		; do bx da offset dele
	mov	al, 32			; do al vlozi 32
vycl:	mov	[bx], al		; do [bx] vlozi al
	inc	bx			; inkrementuje bx
	loopne	vycl			; ak cx nie je 0 skoci na declea
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
input	proc				; nacitanie dvoch cisel z klavesnice
	call	clean			; zavola clean
	mov	delitel, 0		; vynuluje delitel
	mov	delenec, 0		; vynuluje delenec
	mov	bx, offset dele		; do bx vlozi offset dele
	add	bx, 5			; pripocita k bx 5
	mov	cx, con			; do cx vlozi con
	mov	dx, offset cis		; do dx vlozi offset cis
	mov	ah, 09h			; vypise na obrazovku cis
	int	21h			;
	push	cx			; do zasobika ulozi cx
	push	bx			; do zasobika ulozi bx
	call	numbs			; zavola numbs
	pop	bx			; zo zasobnika vyberie bx
	pop	cx			; zo zasobnika vyberie cx
	mov	dx, offset zadprv	; do dx vlozi offset zadprv
	mov	ah, 09h			; vypise na obrazovku zadprv
	int	21h			; 
prvlo:	mov	ah, 1			; nacita jeden znak z klavesnice
	int 	21h			; s echom
	cmp	al, 13			; porovna ci to nie je enter
	jz	inend			; ak ano skoci na inend
	cmp	al, 8			; porovna ci je to backspace
	jnz	daprv			; ak nie skoci na daprv
	inc	bx			; inkrementuje bx
daprv:	mov	[bx], al		; do [bx] vlozi al
	dec	bx			; dekrementuje bx
	loopne	prvlo			; ak cx nie je 0 skoci na prvlo
inend:  mov	cislo, 0		; vynuluje cislo
	mov	dx, offset dele		; do dx vlozi offset dele
	mov	si, dx			; do si vlozi dx
	mov	bx, offset delenec	; do bx vlozi offset delenec
	xor	ax, ax			; vynuluje ax
	xor	cx, cx			; vynuluje cx
	mov	cx, con			; do cx vlozi con
	mov	tp, 1			; do tp vlozi 1
	mov	tmp16, 10		; do tmp16 vlozi 10
decis:  mov	al, [si]		; do al vlozi obsah [si]
	cmp	al, 47			; porovna al s 47
	jbe	desne			; ak al<47 skoci na desne
	cmp	al, 58			; porovna al s 58
	jnb	desne			; ak al>58 skoci na desne
	sub	al, 48			; odcita od al 48
	mul	tp			; vynasobi ax s tp
	add	cislo, ax		; pripocita ax k cislu
	mov	ax, tp			; vlozi tp do ax
	mul	tmp16			; vynasobi tmp16
	mov	tp, ax			; vlozi ax do tp
	jmp	dexci			; skoci na dexci
desne:	cmp	al, 45			; porovna al s 45
	jnz	dexci			; ak sa nerovnaju skoci na dexci
	neg	cislo			; inak neguje cislo
	jmp	deen			; skoci na deen
desdo:	mov	ax, cislo		; vlozi do ax cislo
	mov	[bx], ax		; vlozi do [bx] ax
	inc	bx			; inkrementuje bx
	inc	bx			; inkrementuje bx
dexci:  xor	ax, ax			; vynuluje ax
	inc	si			; inkrementuje si
	loopne	decis			; ak cx nie je 0 skoci na decis
deen:	mov	ax, cislo		; vlozi cislo do ax
	mov	[bx], ax		; vlozi ax do [bx]
	call	isnum			; zavola isnum
;druhe:  mov	bx, offset deli		; do bx vlozi offset deli
  mov	bx, offset deli		; do bx vlozi offset deli
	add	bx, 5			; pripocita k bx 5
	mov	cx, con			; do cx vlozi con
	mov	dx, offset zaddru	; do dx da offset zaddru
	mov	ah, 09h			; vypise to na obrazovku
	int	21h			;
drulo:	mov	ah, 1			; caka na stacenie klavesy s echom
	int 	21h			;
	cmp	al, 13			; porovna ci to nie je ENTER
	jz      druhe			; ak ano skoci na druhe
	cmp	al, 8			; porovna ci to nie je BACKSPACE
	jnz	dadru			; ak nie skoci na dadru
	inc	bx			; inkrementuje bx
dadru:	mov	[bx], al		; do [bx] vlozi al
	dec	bx			; dekremnetuje bx
	loopne	drulo			; ak cx nie je 0 skoci na drulo
druhe:	mov	cislo, 0		; vynuluje cislo
	mov	dx, offset deli		; do dx da offset deli
	mov	si, dx			; do si da dx
	mov	bx, offset delitel	; do bx vlozi offset delitel
	xor	ax, ax			; vynuluje ax
	xor	cx, cx			; vynuluje cx
	mov	cx, con			; do cx vlozi con
	mov	tp, 1			; do tp vlozi 1
	mov	tmp16, 10		; do tmp16 vlozi 10
dicis:  mov	al, [si]		; do al vlozi obsah [si]
	cmp	al, 47			; porovna al s 47
	jbe	disne			; ak al < 47 skoci na disne
	cmp	al, 58			; porovna al s 58
	jnb	disne			; ak al > 58 skoci na disne
	sub	al, 48			; odpocita od al 48
	mul	tp			; vynasobi al a tp
	add	cislo, ax		; pripocita ax k cislu
	mov	ax, tp			; do ax vlozi tp
	mul	tmp16			; vynasobi ax a tmp16
	mov	tp, ax			; do tp vlozi ax
	jmp	dixci			; skoci na dixci
disne:	cmp	al, 45			; porovna al s 45
	jnz	dixci			; ak sa nerovna skoci na dixci
	neg	cislo			; neguje cislo
	jmp	diend			; skoci na diend
disdo:	mov	ax, cislo		; vlozi do ax cislo
	mov	[bx], ax		; vlozi do [bx] ax
	inc	bx			; inkrementuje bx
	inc	bx			; inkrementuje bx
dixci:  xor	ax, ax			; vynuluje ax
	inc	si			; inkrementuje si
	loopne	dicis			; ak cx nie je 0 skoci na dicis
diend:	mov	ax, cislo		; do ax vlozi cislo
	mov	[bx], ax		; do [bx] vlozi ax
	call	isnum			; zavola isnum
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
isnum	proc				; skotroluje ci je medzi nacitanymi
	mov	dx, offset nums		; do dx vlozi offset nums
	mov	si, dx			; do si vlozi dx
	mov	cx, conum		; do cx vlozi con
	xor	bx, bx			; vynuluje bx
	mov	ax, cislo		; do ax vlozi cislo
isn:	mov	dx, [si]		; do dx vlozi obsah [si]
	cmp	ax, dx			; porovna ax a dx
	jz	isne			; ak su rovnake skoci na isne
	inc	bx			; inkrementuje bx
	cmp	bx, conum		; porovna bx a conum
	jz	isno			; ak su rovnake skoci na isno
	inc	si			; inkrementuje si
	inc	si			; inkrementuje si
	loopne	isn			; ak cx nie je 0 skoci na isn
isne:	ret				; navrat
isno:	mov	dx, offset isnnu	; do dx vlozi offset isnnu
	mov	ah, 09h			; a issnu vypise na obrazovku 
	int	21h			; pomocou 09h a int 21h
	call	pokr			; zavola pokr
	call	input			; zavola input
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
divide	proc				; vydeli dva vybrane cisla
	call	clrscr			; zavola clrscr
	call	clean			; zavola clean
	call	input			; zavola input
	mov	divys, 0		; vynuluje divys
	mov	divzv, 0		; vynuluje divzv
	mov	dlcs, 0			; vynuluje dlcs	
	mov	dlts, 0			; vynuluje dits
	xor	dx, dx			; vynuluje dx
	mov	ax, delenec		; do ax vlozi delenec
	mov	bx, delitel		; do bx vlozi delitel
	cmp	bx, 0			; porovna bx s 0
	jnz	divdad			; ak sa nerovna skoci na divdad
	mov	dx, offset delnul	; vypise hlasku o deleni nulou
	mov	ah, 09h			; pomocou 09h a int 21h
	int	21h			;
	jmp	diven			; skoci na diven
divdad:	cmp	ax, 0			; porovna ax s 0
	jg	divdal			; ak je vacsie skoci na divdal
	neg	ax			; neguje ax
	mov	dlcs,1			; nastavi dlcs na 1
divdal:	cmp	bx, 0			; porovna bx s 0
	jg	divda			; ak je vacsie skoci na divda
	neg	bx			; neguje bx
	mov	dlts,1			; nastavi dlts na 1
divda:	idiv	bx			; deli ax bx-om
	mov     divys, ax		; do divys zapise vysledok z ax
	mov	divzv, dx		; do divzv zapise zvysok z dx
	cmp	dlcs,1			; porovna dlcs s 1
	jnz	divvy			; ak sa nerovna skoci na divvy
	neg	divys			; neguje divys
divvy:  cmp	dlts,1			; porovna dlts a 1
	jnz	dien			; ak sa nerovna skoci na dien
	neg	divys			; neguje divys
dien:	mov	ax, divys		; do ax vlozi divys
	call	revert			; zavola revert
	call	vysled			; zavola vysled
	cmp	dlcs, 1			; porovna dlcs a 1
	jnz	dizv			; ak sa nerovnaju skoci na dizv
	neg     divzv			; neguje divzv
dizv:	mov	ax, divzv		; do ax vlozi divzv
	call	revert			; zavola revert 
	call	dizvys			; zavola dizvys
diven:	call	pokr			; zavola pokr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
pokr	proc				; vypise hlasku a caka na klaves
	mov	dx, offset pokrac	; do dx vlozi offset pokrac
	mov	ah, 09h			; pomocou 09h a int 21h to zobrazi
	int	21h			; na obrazovke
	mov	ah,8			; pocka na stlacenie klavesy bez echa
	int	21h			;
	call	clrscr			; zavola clrscr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
pretec	proc				; vypise hlasku o presiahnuti rozsahu
	mov	dx, offset pret		; do dx vlozi offset pret
	mov	ah, 09h			; zobrazi to na obrazovke
	int	21h			; pomocou 09h a int 21h
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
multi	proc				; nasobenie dvoch vybranych cisel
	call	clrscr			; zavola clrscr
	mov	divys, 0		; vynuluje divys
	mov	dlcs, 0			; vynuluje dlcs
	mov	dlts, 0			; vynuluje dlts
	call	input			; zavola input
	xor	dx, dx			; vynuluje dx
	mov	ax, delenec		; do ax vlozi delenec
	mov	bx, delitel		; do bx vlozi delitel
	cmp	ax, 0			; porovna ax s 0
	jg	muldal			; ak je vacsi skoci na muldal
	neg	ax			; neguje ax
	mov	dlcs,1			; nastavi dlcs na 1
muldal:	cmp	bx, 0			; porovna bx a 0
	jg	mulda			; ak je vacsi skoci na mulda
	neg	bx			; neguje bx
	mov	dlts,1			; nastavi dlts na 1
mulda:	mul	bx			; vynasobi ax a bx
	mov     divys, ax		; do divys vlozi ax
	cmp	dlcs,1			; porovna dlcs a 1
	jnz	mulvy			; ak sa nerovna skoci na mulvy
	neg	divys			; neguje divys
mulvy:  cmp	dlts,1			; porovna dlts a 1
	jnz	muen			; ak sa nerovna skoci na muen
	neg	divys			; neguje divys
muen:	mov	ax, divys		; vlozi divys do ax
	push	ax			; do zasobnika vlozi ax
	call	check			; zavola check
	mov	al, pre			; do al vlozi pre
	cmp	al, 0			; porovna al a 0
	jz	muda			; ak sa rovnaju skoci na muda
	pop	ax			; vyberie zo zasobnika ax
	jmp	mupre			; skoci na mupre
muda:	pop	ax			; vyberie zo zasobnika ax
	call	revert			; zavola revert
	call	vysled			; zavola vysled
	jmp	mud			; skoci na mud
mupre:	call	pretec			; zavola pretec
	mov	pre, 0			; nastavi pre na 0
mud:	call	pokr			; zavola pokr
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
check	proc				; zistenie prekrocenia rozsahu
	xor	ax, ax			; vynuluje ax
	mov	al, dlcs		; do al vlozi dlcs
	add	al, dlts		; pripocita k al dlts
	cmp	al, 0			; porovna al a 0
	jz	kladne			; ak sa rovna skoci na kladne
	cmp	al, 2			; porovna al a 0
	jz	kladne			; ak sa rovna skoci na kladne
	xor	ax, ax			; vynuluje ax
	mov	ax, divys		; do ax vlozi divys
	cmp	ax,0			; porovna ax s 0
	jl	cend			; ak je mensie skoci na cend
	mov	pre, 1			; nastavi pre na 1
	ret				; navrat
kladne:	xor	ax, ax			; vynuluje ax
	mov	ax, divys		; do ax vlozi divys
	cmp	ax, 0			; porovna ax s 0
	jg	cend			; ak je vascie skoci na cend
	mov	pre, 1			; nastavi pre na 1
cend:	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
revert	proc				; konverzia z BIN do DEC
	push	ax			; do zasobnika vlozi ax
	call	clean			; zavola clean
	mov	iscif, 0 		; do iscif vlozi 0
	pop	ax			; vyberie zo zasobnika ax
	xor	bx, bx			; vynuluje bx
	mov	dx, offset vys		; do dx vlozi offset vys
	mov	si, dx			; do si vlozi dx
	cmp	ax, 0			; porovna ax s 0
	jge	redal			; ak je vacsie a rovne skoci na redal
	mov	cx, 45			; do cx vlozi 45
	mov	[si+bx], cx		; vlozi cx do [si+bx]
	neg	ax			; neguje ax
redal:	xor	bx, bx			; vynuluje bx
	xor	dx, dx			; vynuluje dx
	mov	cx, 10000		; vlozi do cx 10000
	div     cx			; podeli ax cx-om
	cmp	ax, 0			; porovna ax s 0
	jz	ne1			; ak sa rovna skoci na ne1
	inc	bx			; inkrementuje bx
	mov	[si+bx], al		; do [si+bx] vlozi al
	mov	cx, 48			; do cx vlozi 48
	add	[si+bx], cx		; k [si +bx] pripocita cx
	mov	iscif, 1		; nastavi iscif na 1
ne1:	mov	ax, dx			; do ax vlozi dx
	xor	dx, dx			; vynuluje dx
	mov	cx, 1000		; vlozi do cx 1000
	div     cx			; podeli ax cx-om
	cmp	ax, 0			; porvna al s 0
	jnz	ne2			; ak sa nerovna skoci na ne2
	cmp	iscif, 0		; porovna iscif s 0
	jz	ne3			; ak sa rovna skoci na ne3
ne2:	inc	bx			; inkrementuje bx
	mov	[si+bx], al		; do [si+bx] vlozi al
	mov	cx, 48			; do cx vlozi 48
	add	[si+bx], cx		; k [si+bx] pripocita cx
	mov	iscif, 1		; iscif nastavi na 1
ne3:	mov	ax, dx			; do ax vlozi dx
	xor	dx, dx			; vynuluje dx
	mov	cx, 100			; vlozi do cx 100
	div     cx			; podeli ax cx-om
	cmp	ax, 0			; porovna al s 0
	jnz	ne4			; ak sa nerovna skoci na ne4
	cmp	iscif, 0		; porovna iscif s 0
	jz 	ne5			; ak sa rovna skoci na ne5
ne4:	inc	bx			; inkrementuje bx
	mov	[si+bx], al		; do [si+bx] vlozi al
	mov	cx, 48			; do cx vlozi 48
	add	[si+bx], cx		; pripocita k [si+bx] cx
	mov	iscif, 1		; do iscif vlozi 1
ne5:	mov	ax, dx			; do ax vlozi dx
	xor	dx, dx			; vynuluje dx
	mov	cx, 10			; vlozi do cx 10
	div     cx			; podeli ax cx-om
	cmp	ax, 0			; porovna ax s 0
	jnz	ne6			; ak sa nerovna skoci na ne6
	cmp	iscif, 0		; porovna iscif s 0
	jz	ne7			; ak sa rovna skoci na ne7
ne6:	inc	bx			; inkrementuje bx
	mov	[si+bx], al		; do [si+bx] vlozi al
	mov	cx, 48			; do cx vlozi 48
	add	[si+bx], cx		; pripocita [si+bx] a cx
ne7:	inc	bx			; inkremnetuje bx
	mov	[si+bx], dl		; do [si+bx] vlozi dl
	mov	cx, 48			; do cx vlozi 48
	add	[si+bx], cx		; pripocita k [si+bx] cx
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
revsor	proc				; upravi zotriedene cisla pre vypis
	call	clean			; zavola clean
	mov	dx, offset numes	; do dx vlozi offset numes
	mov	si, dx			; do si vlozi dx
	mov	cx, conum		; do cx vlozi conum
	mov	dx, offset sorcis	; do dx vlozi offset sorcis
	mov	ah, 09h			; vypise sorcis na obrazovku pomocou
	int	21h			; 09h a int 21h
	call	opofile			; zavola opofile
reslo:	mov	ax, [si]		; do ax vlozi obsah [si]
	push	cx			; do zasobnika vlozi cx
	push	si			; do zasobnika vlozi si
	call	revert			; zavola revert
	push	bx			; do zasobnika vlozi bx
	push	si			; do zasobnika vlozi si
	call	wriout			; zavola wriout
	pop	si			; zo zasobnika vyberie si
	pop	bx			; zo zasobnika vyberie si
	inc	bx			; inkrementuje bx
	mov	dx, ','			; do dx vlozi ','
	mov	[si+bx], dx		; do [si+bx] vlozi dx
	inc	bx			; inkrementuje bx
	mov	dx, '$'			; do dx vlozi '$'
	mov	[si+bx], dx		; do [si+bx] vlozi dx
	pop	si			; zo zasobnika vyberie si
	mov	dx, offset vys		; do dx vlozi offset vys
	mov	ah, 09h			; vypise ho na obrazovku pomocou
	int	21h			; 09h a int 21h
	inc	si			; inkrementuje si
	inc	si			; inkrementuje si
	pop	cx			; zo zasobnika vyberie cx
	loopne	reslo			; ak cx nie je 0 skoci na reslo
	call	clofile			; zavolaclofile
	mov	dx, offset nr		; do dx vlozi offset nr
	mov	ah, 09h			; vypise ho na obrazovku pomocou
	int	21h			; 09h a int 21h
	call	clean			; zavola clean
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
numbs	proc				; vypis nacitanych cisel
	call	clean			; zavola clean
	mov	dx, offset nums		; do dx vlozi nums
	mov	si, dx			; do si vlozi dx
	mov	cx, conum		; do cx vlozi conum
neslo:	mov	ax, [si]		; do ax vlozi obsah [si]
	push	cx			; do zasobnika vlozi cx
	push	si			; do zasobnika vlozi si 
	call	revert			; zavola revert
	inc	bx			; inkrementuje bx
	mov	dx, ','			; do dx vlozi ','
	mov	[si+bx], dx		; do [si+bx] vlozi dx
	inc	bx			; inkrementuje bx
	mov	dx, '$'			; do dx vlozi '$'
	mov	[si+bx], dx		; do [si+bx] vlozi dx
	pop	si			; zo zasobnika vyberie si
	mov	dx, offset vys		; do dx vlozi offset vys
	mov	ah, 09h			; vypise ho na obrazovku pomocou
	int	21h			; 09h a int 21h
	inc	si			; inkrementuje si
	inc	si			; inkrementuje si
	pop	cx			; zo zasobnika vyberie cx
	loopne	neslo			; ak cx nie je 0 skoci na reslo
	call	clean			; zavola clean
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
vysled	proc				; vypis vysledku na obrazovku
	mov	dx, offset vysle	; do dx vlozi offset vysle
	mov	ah, 09h			; zobrazi ho na obrazovke
	int	21h			; pomocou 09h a int 21h
	call	clean			; zavola clean
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
dizvys	proc				; vypis zvysku na obrazovku
	mov	dx, offset dizvs	; do dx vlozi offset dizvys
	mov	ah, 09h			; zobrazi ho na obrazovke
	int	21h			; pomocou 09h a int 21h
	mov	dx, offset vys		; do dx vlozi offset vys
	mov	ah, 09h			; zobrazi ho 
	int	21h			;
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
clrscr	proc				; vymazanie obrazovky
	mov	ax, 3			; nastavi do ax 3
	int	10h			; zavola int 10h
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
koniec	proc				; koniec programu
	mov	ax, 4c00h		; nastavi do ax 4c00h
	int	21h			; zavola int 21h
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
inv	proc				; invertovanie v pamati
	mov	dx, offset numbers      ; do dx vlozi offset numbers
	mov	si, dx                  ; presunie dx do si
	mov	bx, offset numbinv      ; do bx vlozi offset numbinv
	xor	ax, ax                  ; vynuluje ax
	xor	cx, cx                  ; vynuluje cx
	mov	cx, count               ; do cl vlozi velkost
	mov	tmp, cl                 ; do tmp vlozi cl
	add	si, cx                  ; k si prirata cx
opinv:  mov	al, [si]                ; presuva posledny znak retazca
	mov	[bx], al                ; do prveho vo vypise
	inc	bx                      ; zvacsi bx o jednu
	dec	si                      ; zmensi si o jednu
	cmp	tmp, 0                  ; ak tmp=0 skoci na eninv
	jz	eninv                   ;
	dec	tmp                     ; inak zmensi tmp a skoci na opinv
	jmp	opinv                   ; skoci na opinv
eninv:	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
konv   	proc				; konverzia DEC na BIN
	call	inv			; zavola inv
	mov	dx, offset numbinv	; do dx vlozi offset numbinv
	inc	dx			; inkrementuje dx
	mov	si, dx                  ; presunie dx do si
	mov	bx, offset nums	        ; do bx vlozi offset nums
	xor	ax, ax                  ; vynuluje ax
	xor	cx, cx                  ; vynuluje cx
	mov	cx, count               ; do cl vlozi count
	mov	tp, 1			; do tp vlozi 1
	mov	tmp16, 10		; do tmp16 vlozi 10
opcis:  mov	al, [si]                ; vlozi do al byte z [si]
	cmp	al, 47                  ; porovna al so 47
	jbe	cisne                   ; ak je mensi skoci na cisne
	cmp	al, 58                  ; porovna al so 58
	jnb	cisne			; ak nie je mensi skoci na cisne
	sub	al, 48			; odpocita od al 48
	mul	tp			; vynasobi ax s tp
	add	cislo, ax		; pripocita ax k cislu
	mov	ax, tp			; vlozi tp do ax
	mul	tmp16			; vynasobi ax a tmp16
	mov	tp, ax			; vlozi do tp ax
	jmp	nexci			; skoci na nexci
cisne:	cmp	al, 45			; porovna al s 45
	jnz	cisko			; ak sa nerovna skoci na cisko
	neg	cislo			; neguje cislo
	cmp	cislo, 0		; porovna cislo s 0
	jl	nexci			; ak je mensie skoci na nexci
	call	pretec			; zavola pretec
	call	koniec			; zavola koniec
	ret				; navrat
cisko:	cmp	al, ','			; porovna al s ,
	jnz	nexci			; ak sa nerovna skoci na nexci
	cmp	cislo, 0		; porovna cislo s 0
	jnb	cisdo			; ak nie je mensie skoci na cisdo
	call	pretec			; zavola pretec
	call	koniec			; zavola koniec
	ret				; navrat
cisdo:	mov	ax, cislo		; do ax vlozi cislo
	mov	[bx], ax		; do [bx] vlozi ax
	inc	conum			; inkrementuje conum
	inc	bx			; inkrementuje bx
	inc	bx			; inkremnetuje bx
	mov	cislo, 0		; do cislo vlozi 0
	mov	tp, 1			; do tp vlozi 1
nexci:  xor	ax, ax			; vynuluje ax
	inc	si			; inkremnetuje si
	loopne	opcis			; ak cx nie je 0 skoci na opcis
	mov	ax, cislo		; do ax vlozi cislo
	inc	conum			; inkrementuje conum
	mov	[bx], ax		; do [bx] vlozi ax
	ret				; navrat
	endp				;
;-----------------------------------------------------------------------------
start:  mov	ax, seg data		; do ax vlozi segment adresy data
	mov	ds, ax			; do ds vlozi ax
	call	clrscr			; zavola clrscr
	mov	dx, offset uvod		; do dx vlozi offset uvodu
	mov	ah, 09h			; zobrazi ho na obrazovke
	int	21h			;
	call	opifile			; zavola opifile
	call	readin			; zavola readin
	call	clifile			; zavola clifile
	call	konv			; zavola konv
	jmp	me			; skoci na me
mn:	call	clrscr			; zavola clrscr
me:	call	men			; zavola men
	call	press			; zavola press
	jmp	me			; skoci na me
	call	koniec			; zavola koniec
code    ends                            ; koniec kodoveho segmentu
	end     start                   ; program sa zacina na start
;-----------------------------------------------------------------------------
; Program je funkcny. Bol spracovany pomocou Turbo Assambleru.
; Vstupny subo tvoria cisla zo znamienkom oddelene ciarkou.
; Vo vystupnom subore su cisla zotriedene podla velkost.
; Rozsah cisel je od -30000 do 30000.
; Program mohol byt aj kratsi ale vzhladom na cas ktory bol poskytnuty
; na vypracovanie nemoholo som rozmyslat nad vylepseniamy a fintami.
;-----------------------------------------------------------------------------
