;Zadanie c.1.
;Text zadania:
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov)
;a podla ponkanho menu vykon  jednu z monost:
;a) vype retazec znakov na obrazovku
;b) vype pocet cslic v retazci
;c) zist,ci sa v retazci nachdza pouvatelom zadany znak a vype o tom sprvu
;d) njde znak s min. hodnotou a vype tento znak
;e) mal psmen konvertuje na velk
;f) zarovn text zprava ( vynech prv medzery odkonca)
;g) ukonc vykonvanie programu.
;Po vykonan zvolenej monosti sa program vrti na vpis menu.
;Nepouvajte retazcov instrukcie!
;Zdrojovy program mus byt PODROBNE OKOMENTOVANY! 
;
;Autor:  Pavol Skocik  
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001

zas segment stack	;vytovorim zasobnik pre 64 slov
    dw 64 dup(?)
zas ends

dat segment	;datovy segment
vstup db 80     ;premenna vstup ma hodnotu 80
pocet db 0	;premenna pocet ma hodnotu 0
      db 80 dup(?)	;priestor pre vstupny retazec
nr    db 13	;novy riadok
      db 10
vystup db 83 dup(?)	;priestor pre vystupny retazec
txt_zad db 'Zadajte text : $';
txt_vyb db '1.Nezmeneny, 2.Cisla, 3.Na velke pismena, 4..MAX, 5.Znak 6. Zarovnat 7..koniec $';
txt_min db 13
	db 10
	db 'Znak s minimalnou hodnoutou:  $'
znak	db 1 dup(?)
txt_zn	db 13
	db 10
	db 'Aky znak sa ma vyhladat? $'
txt_znak db 13
	db 10
	db 'Je v retazci.'
	db 13
	db 10
	db '$'
txt_znak2 db 13
	db 10
	db 'Nie je v retazci. '
	db 13
	db 10
	db '$'
pocet2 	db 0
dat ends

code segment
     assume cs:code,ss:zas,ds:dat       ;kazdemu reg.je priradeny jeho segment


start:		;zaciatok programu
        mov ax,seg dat  ;do ax -> segmentova cast datoveho segmentu - INICIALIZACIA
        mov ds,ax       ;do dx sa presunie seg. cast dat.seg.
        mov dx,offset txt_zad	; do dx sa presunie rel. adresa txt_zad v dat.segmente
        mov ah,09h
        int 21h                 ;vypisanie textu na zadanie vstupu

        mov dx,offset vstup     ;do dx dame rel.adresu prem.vstup
        mov ah,0Ah      ;budeme volat DOS f-ciu 
        int 21h         ;do vstupu sa nacita z klavesnice

znova:
        ;mov ah,06h
	;int 10h
	mov dx,offset txt_vyb
        mov ah,09h
        int 21h                 ;vypisanie textu ze co ma uzivatel na vyber

opakuj:
        mov ah,1
        int 21h         ;vstup 1 znaku
        cmp al,'1'	;zistovanie co bolo stlacene
        jz nezmeneny
        cmp al,'2'
        jz cisla
        cmp al,'3'
        jz na_velke1
        cmp al,'4'
        jz min1
	cmp al,'5'
	jz znak_n1
        cmp al,'6'
        jz medzera1
	cmp al,'7'
	jz koniec1
        jmp opakuj

;*************************************************************************
nezmeneny:			;vypis nezmeneneho retazca
        mov dx,offset vstup	;do dx sa presunie rel. adresa prem vstup
        mov bx,offset vystup
        add dx,2	
        mov si,dx
        xor ch,ch       	;vynulovanie dolnej casti cx
        mov cl,pocet
   rep1:                ;tato slucka presunie vstupny retazec do priestoru pre vystupny
        mov al,[si]	;obsah bunky kam ukazuje si sa presunie do al	
        mov [bx],al                                                     	
        inc si		;inkrementacia si a bx
        inc bx
        loopne rep1;	;slucka sa opakuje kym
        jmp vypis ;	;nepodmieneny skok na navestie vypis	

na_velke1:			;pomocne navestia vytvorene kvoli velkej
	jmp na_velke		;dlzke programu
koniec1:
	jmp koniec
znak_n1:
	jmp znak_n
;***********************************************************************
vypis:
        mov byte ptr[bx],13	;do bunky kam ukazuje bx sa vlozi 13
        mov byte ptr[bx]+1,10   ;do nasledujucej sa vlozi 10
        mov byte ptr[bx]+2,'$'  ;do dalsej sa vlozi znak oznacujuci koniec retazca
	
	mov dx,offset nr        ;offset nr aby aj odriadkoval
        mov ah,09h
        int 21h
        jmp znova

medzera1:
	jmp medzera
;************************************************************
min1:	jmp min

cisla:	mov dx, offset vstup	;zistovanie poctu cisel v retazci
	add dx,2		;do dx rel.adr. vstup. retazca
	mov bx,offset vystup	;do bx rel.adr. vystupu
	mov si,dx
	mov pocet2,0		;vynulovanie prem. pocet2 ktora pocita vyskyty cislic
	xor ch,ch
	;mov bl,pocet2
	mov cl,pocet
rep2:	mov al,[si]	;slucka v ktorej sa kontroluje kazdy znak a zistuje
	cmp al,'0'	;sa ci je cislo alebo nie, ak je tak pocet2
	ja dalej_c      ;inkrementujeme
	cmp al,'9'
	jb dalej_c
	inc pocet2
dalej_c:
	inc si
	loopne rep2;
	mov dx,offset vystup
	xor ax,ax
	;mov ax,bx	
	;xor dx,dx
	;mov bx,10
	;div bx
	;mov dl,bl
	mov al,pocet2
	mov bl,10
	div bl		;delenie so zvyskom al-vysledok, ah-zvysok
	;add ax,3030h    ;z vysledku vytvorim ascii kody vysledku v ah a al
	;mov bx,offset vystup
	;mov [bx],al	;na prve miesto vo vyst. retazci vlozim prvu cislicu
	;mov byte ptr[bx]+1,ah	;na druhe miesto druhu cislicu
	;mov byte ptr[bx]+2,13	; a odriadkujem
	;mov byte ptr[bx]+3,10
	;mov byte ptr[bx]+4,'$'	;vlozim koncovy znak retazca
	;mov dx,offset nr	;vystupny retazec aj s odriadkovanim vypisem
	;mov ah,09h
	mov dl,al
	mov ah,02h
	int 21h
	mov dl,al
	mov ah,02h
	int 21h
	jmp znova 	;nepodmieneny skok na navestie znova (vypis menu)

;****************************************************
min:	mov dx,offset vstup	;vyhladanie znaku s max.hodnotou
	add dx,2		;
	mov bx,offset vystup
	mov si,dx               ;do si rel. adresu vstup
	xor ch,ch		
	xor ax,ax
	mov cl,pocet
	mov al,[si]            	;do al vlozime prvy znak
	mov [bx],al		;ten vezmem ako ten s max. hodnotou a zapisem na vystup
	sub pocet,1		;
	inc si
rep4:	cmp al,[si]             ;porovnam dalsi znak s uz vybratym ako maximalny
	ja dalej_min		;ak je mensi ako prvy tak sa nic nedeje a skocim na  dalej_min
	mov al,[si]		;ak je vacsi prepisem ho do al aj na vystup
	mov [bx],al
dalej_min:
	inc si			;inkrementacia si(aby ukazoval vzdy na dalsi znak)
	loopne rep4;		;koniec slucky
	mov dx,offset txt_min	;do dx rel.adr. retazca o vyhlaseni vysledku
	mov ah,09h		;jeho vypisanie
	int 21h
	mov byte ptr[bx]+1,13	;za najdeny znak vlozime odriadkovanie a koniec retazca
	mov byte ptr[bx]+2,10
	mov byte ptr[bx]+3,'$'
	mov dx,offset vystup	;vysup vypiseme
	mov ah,09h
	int 21h
	add pocet,1		;prem.pocet sme zmensili na zaciatku o 1, preto ju vratime do povodnej hodnoty
	jmp znova		;skok na navestie znova

;***********************************************************
znak_n:	mov dx,offset txt_zn	;vyhladanie zadaneho znaku
	mov ah,09h
	int 21h
	mov ah,1		;nacitanie hladaneho znaku
	int 21h
	mov bx,offset znak	;do bx rel.adr. prem. znak
	mov [bx],al		;nacitany znak sa ulozi do prem. znak
	mov dx,offset vstup	;do dx rel.adr. vstup
	add dx,2	
	mov si,dx
	xor ch,ch
	mov cl,pocet

rep5:	mov al,[si]		;do al po jednom znaky povodneho retazca
	cmp al,[bx]		;porovnaju sa
	jz sprava		;ak sa rovnaju znak sa v retazci vyskytuje
				;a vypise sa o tom sprava-prehladavanie skonci
dalej_z:inc si
	loopne rep5
	mov dx,offset txt_znak2	;vyhlasenie, ze znak nenasiel
	mov ah,09h
	int 21h
	jmp znova	;skok na navestie znova
	
sprava:	mov dx,offset txt_znak	;vypisanie spravy o najdeni znaku v retazci
	mov ah,09h
	int 21h
	jmp znova
;**************************************************
medzera:		;zarovnanie
	mov dx,offset vstup	;do dx rel.adr.vstup
	add dx,2
	mov si,dx
	mov bx,offset vystup
	xor ch,ch
	mov cl,pocet

rep6:	mov al,[si]	;do al vlozi prvy znak
	cmp al,' '	;ak je to medzera nezapise ju na vystup
	jnz prepis	;ak znak nieje medzera cely zvysok retazca prepise na vystup
	inc si
	loopne rep6
prepis:	mov al,[si]	;prepis vysledku na vystup
	mov [bx],al
	inc si
	inc bx
	loopne prepis
	jmp vypis
;********************************************************
na_velke:		;konverzia malych pismen na velke
        mov dx,offset vstup	
        add dx,2
        mov bx,offset vystup
        mov si,dx
        xor ch,ch
        mov cl,pocet
   rep3:		;porovnavanie pismen
        mov al,[si]	;skumany znak sa vlozi do al
        cmp al,60h      ;porovnanie znaku a
        jbe dalej_v	;ak je mensi nic sa nestane
        cmp al,'z'	;porovnanie so z 
        jnb dalej_v	;ak nieje mensi ako z nic sa nestane
        sub al,20h	;ak je v rozpati a-z, odpocita sa od jeho hodnoty 20h a je z neho velke pismeno
   dalej_v:
        mov [bx],al	;vysledok sa zapise na vystup
        inc si
        inc bx
        loopne rep3;

        jmp vypis


koniec:
        mov ax,4c00h    ;funkcia na navrat do DOSu
        int 21h                                                           
code ends
     end start




;zhodnotenie:
;Program bol skompilovany Turbo assemblerom verzia 2.02
;a zlinkovany pomocou Turbo LInk Verzia 3.01
;niesu pouzite ziadne obmedzenia vstupov
;po vypisani vyzvy na zadanie retazca sa ukoncuje enterom
;potom sa vypise menu kde sa stlaci len jedna z moznosti a funkcia sa zacne vykonavat
;po vykonani sa sama vrati do menu
;
;
