;ZADANIE c.3
;S vyuzitim  retazcovych  instrukcii  (vsade   kde  je  to  mozne) vytvorte 
;program, ktory:
;a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov
;    (minimalne dlzky 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;c) porovna posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zisti ci su rovnako dlhe a ci su rovnake
;d) zisti,  ci  sa  v  niektorom   z  retazcov  nachadza  zadany
;   podretazec.
;
;Autor:  Andrej Slamka   os.cislo 99619
;Termin odovzdania: 4.12.2000
;2.roc.,sk.rok 2000/2001

zas	segment	stack
	dw	64 dup()
zas	ends	

data	segment
max1	db	20
poc1	db	0
ret1	db	30 dup(?)
messg0	db	'Stlac lubovolnu klavesu ...$'
messg1	db	10,10,13,' Zadaj prvy retazec : $'
messg2	db	10,10,13,' Zadaj druhy retazec : $'
messg3	db	10,10,13,' Zadaj hladany podratazec : $'
messg4	db	10,10,13,' Retazce su rovnako dlhe.$'
messg5	db	10,10,13,' Retazce nie su rovnako dlhe.$'
messg6	db	10,10,13,' Retazce sa zhoduju.$'
messg7	db	10,10,13,' Retazce sa nezhoduju.$'
messg8	db	10,10,13,' Zadaj hladany podretazec : $'
messg9	db	10,10,13,' Podretazec sa nenachada v prvom retazci.$'
messg10	db	10,10,13,' Podretazec sa nachada v prvom retazci.$'
messg11	db	10,10,13,' Podretazec sa nenachada v druhom retazci.$'
messg12	db	10,10,13,' Podretazec sa nachada v druhom retazci.$'
poloz	db	10,10,13,'    Hlavne menu :'
	db	10,10,13,' a) Nacitaj prvy retazec'
	db	10,13,' b) Nacitaj druhy retazec'
	db	10,13,' c) Porovnaj retazce'
	db	10,13,' d) Hladaj podretazec'
	db	10,13,' e) Koniec'
	db	10,10,13,'    Tvoj vyber : $'
data	ends

data2	segment
max2	db	20
poc2	db	0
ret2	db	20 dup(?)
max3	db	20
poc3	db	0
podret	db	20 dup(?)
data2	ends

code	segment
	assume DS:data, ES: data2, CS:code, SS:zas;
;-------------------- zmaze obrazovku ------------------------
zmaz	proc
	mov ax, 03h
	int 10h              ;zmaz obrazovku
	ret
zmaz	endp
;------------------- vypise text na adrese dx ----------------
messg	proc
	push ax
	mov ah, 09h
	int 21h
	pop ax
	ret
messg	endp
;------------------- caka na klavesu  ----------------------
key	proc
	push ax			;odlozime registre ax. bx, dx
	push bx
	push dx
	mov ah, 02h		;sluzba na nastavenie kurzoru
	mov bh, 0		;nastavime videostranku
	mov dh, 24		;nastavime riadok	
	mov dl, 25		;a stlpec
	int 10h			;zavolame prerusenie
	lea dx, messg0		;do dx oadresa messg0
	call messg
	mov ah,08h
	int 21h			;caka na klavesu bez echa
	pop dx
	pop bx
	pop ax			;obnovime registre
	ret
key	endp
;---------------------- zaciatok programu ----------------------
start:	mov ax, seg data
	mov ds, ax		;do ds ulozi segmentovu adresu data
	mov ax, seg data2
	mov es, ax		;do es ulozi segmentovu adesu data2
;----------------hlavne menu----------------------------------------
menu:	call zmaz
	lea dx, poloz
	call messg		;zobrazi menu
	mov ah, 01h
	int 21h			;nacita znak
	cmp al, 'a'		
	jz citaj_prvy		;podla vyberu skoci na urcite navestie
	cmp al, 'b'
	jz citaj_druhy
	cmp al, 'c'
	jz porovnaj
	cmp al, 'd'
	jz hladaj
	cmp al, 'e'
	jz koniec
	jmp menu

citaj_prvy:	call cit_prvy		;podla navestia zavola proceduru
		jmp menu		;a vrati sa spat do menu
citaj_druhy:	call cit_druhy
		jmp menu
porovnaj:	call porov
		jmp menu
hladaj:		call hlad
		jmp menu
;---------------koniec progamu--------------------------------------
koniec:
	mov ah, 4ch
	int 21h
;---------------------nacita prvy retazec--------------------------
cit_prvy	proc
	lea dx, messg1
	call messg		;vypise text messg1
	lea dx, max1
	mov ah, 0ah
	int 21h			;nacita prvy retazec
	lea dx, ret1
	mov si, dx
	xor cx, cx
	mov cl, poc1
	add si, cx		;nastavime si na koniec
	dec si			;retazca 1
	mov di, si
	add di, 10
	push es
	push ds
	pop es			;ulozime do es adresu ds
	std
	xor cx, cx
	mov cl, poc1
	rep movsb
	pop es
	ret
cit_prvy	endp
;---------------------nacita druhy retazec--------------------------
cit_druhy	proc
	lea dx, messg2
	call messg		;vypise text messg2
	push ds			;odlozime ds
	push es			;odlozime es
	pop ds			;nastavime ds na es
	lea dx, max2		
	mov ah, 0ah
	int 21h			;nacita druhy retazec
	pop ds			;obnovy adresu ds
	ret
cit_druhy	endp
;--------------------- porovnanie retazcov ------------------------
porov	proc
	cld
	mov al, poc1		;ulozi dlzku 1.retazca do al
	cmp al, poc2 		;porovna ju s dlzkou druheho retazca
	je rovnako_dlhe
	lea dx, messg5
	call messg		;a vypise prislusnu sparvu
	lea dx, messg7
	jmp end_p	
rovnako_dlhe:
	lea dx, messg4
	call messg		;a vypise prislusnu sparvu
	lea si, ret1		;do si ulozi adresu ret1
	add si, 10
	lea di, ret2		;do di ulozi adresu ret2
	xor cx, cx		;vynuluje cx
	mov cl, poc1		;do cx ulozi pocet
	repe cmpsb		;porovna retazce
	je zhodne		;podla
	lea dx, messg7		;vysledku vypise spravu
	jmp end_p		;pocka na klavesu a vrati
zhodne:	lea dx, messg6		;sa spat
end_p:	call messg		;do
	call key		;menu
	ret
porov	endp
;----------------------vyhlada podretazec---------------------
hlad	proc
	cld
	lea dx, messg8	
	call messg		;vypise text messg8
	push ds
	push es
	pop ds
	mov ah, 0ah
	lea dx, max3
	int 21h			;nacita hladany podretazec
	pop ds
	xor bx, bx		;vynuluje bx a cx
	xor cx, cx
	mov bl, poc1		;do bl ulozi dlzku ret1
	sub bl, poc3		;zmensi bl o poc3 a zvacsi o 1
	inc bl
	lea di, podret		;do di da adresu podret
	lea si, ret1		;do si adresu ret1
	add si, 10
spat:	cmp bl, 1		;porovna bl s 1
	jb nefound1		;ak je na konci tak nic nenasiel
	mov cl, poc3		;do cl ulozi dlzku podretazca
	repe cmps ret1, podret	;porovna retazce
	je found1		;ak su zhodne podretazec sa tam nachadza
	dec di			;ak nie su vrati spat di
	dec bl			;zmensi bl o jedna
	jmp spat		;a vrati sa spat
nefound1:			;podla vysledku hladania
	lea dx, messg9		;vypise prislusnu spravu
	jmp end_p2	
found1:	lea dx, messg10
end_p2:	call messg
	xor bx, bx		;vynuluje bx a cx
	xor cx, cx
	mov bl, poc1		;do bl ulozi dlzku ret1
	sub bl, poc3		;zmensi bl o poc3 a zvacsi o 1
	inc bl
	lea di, podret		;do di da adresu podret
	lea si, ret2		;do si adresu ret2
spat2:	cmp bl, 1		;porovna bl s 1
	jb nefound2		;ak je na konci tak nic nenasiel
	mov cl, poc3		;do cl ulozi dlzku podretazca
	repe cmps ret2, podret	;porovna retazce
	je found2		;ak su zhodne podretazec sa tam nachadza
	dec di			;ak nie su vrati spat di
	dec bl			;zmensi bl o jedna
	jmp spat2		;a vrati sa spat2
nefound2:			;podla vysledku hladania
	lea dx, messg11		;vypise prislusnu spravu
	jmp end_p3	
found2:	lea dx, messg12
end_p3:	call messg
	call key
	ret
hlad	endp
;----------------------koniec code segmentu-------------------
	ends
	END	start

;Zhodnotenie:
;Program dokaze nacitat vsetky retazce maximalne dlzky 20 znakov.
;Inak by program nemal mat zidne obmedzenia.