;ZADANIE c.2
;
;Vytvorte  program,  ktory  nacita  z  textoveho suboru postupnost
;celych cisel (aspon 10)so znamienkom  v desiatkovej ciselnej sustave,
;potom ich transformuje na cisla v dvojkovej ciselnej sustave v 
;doplnkovom kode a potom podla priania pouzivatela
;a) spocita kladne (alebo zaporne)cisla a sumu vypise
;b) usporiada cisla zostupne a zapise usporiadanu postupnost cisel
;   do noveho textoveho suboru,
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi posledne dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.
;
;Autor:  Andrej Slamka   os.cislo 99619
;Termin odovzdania: 14.11.2000
;2.roc.,sk.rok 2000/2001


zas	segment		stack
	dw		64 dup(?)
zas	ends

data	segment
cisla	db		20 dup(0)
znak	db		0
poc	db		0
znam	db		0	;0 - plus  1 - minus
sumap	db		0
sumam	db		0
subor1	db		'data.txt', 0
subor2	db		'data2.txt', 0
subaddr	dw		0
sub2adr	dw		0
messg0	db		10,10,13,'   Pretecenie !$'
messg1	db		10,13,' Subor bol nacitany.$'
messg2	db		'Stlac lubovolnu klavesu ...$'
messg3	db		10,10,13,' Nacitane cisla su : $'
messg4  db		10,10,13,' Suma kladnych cisel je : $'
messg5  db		10,10,13,' Suma zapornych cisel je : $'
messg6  db		10,10,13,' Sucin cisel je : $'
messg7  db		10,10,13,' Zadaj index prveho cisla : $'
messg8  db		10,10,13,' Zadaj index druheho cisla : $'
messg9	db		10,10,13,' Cele cislo po deleni : $'
messg10 db		10,10,13,' Zvysok po deleni : $'
messg11 db		10,10,13,' Cisla usporidane a ulozene do suboru data2.txt.$'
messg12	db		10,13,' Subor data.txt nenajdeny.$'
messg13	db		10,10,13,' Zly index !$'
messg14 db		10,10,13,' Delenie nulou !$'

poloz	db		10,13,'     Hlavne menu :'
	db		10,10,13,' a) Vypis cisla'
	db		10,13,' b) Scitaj kladne reps. zaporne cisla'
	db		10,13,' c) Usporiadaj cisla a uloz do noveho suboru'
	db		10,13,' d) Vydel dve vybrane cisla'
	db		10,13,' e) Vynasob posledne dve cisla'
	db		10,13,' f) Koniec programu'
	db		10,10,13,'      Tvoja volba : $'
data	ends

code	segment
	assume  DS:data,CS:code,SS:zas
;------------------------------ nejake uzitocne procedury -------------------
pretecenie	proc
	mov ah, 09h
	mov dx, offset messg0
	int 21h
	ret
pretecenie 	endp
;------------------------------ vypise cislo v al ---------------------------
vypis_cislo	proc		;vypise cislo v al v doplnkovom kode
	push bx
	push cx			;odlozime reguistre bx, cx
	mov ah, 0
	sub al, 1
	not al			;prvededieme cislo spat do 2-kodu
	test al, 10000000b	
	jns kladne_p            ;zisitime ci je kladne alebo zaporne
	mov bl, al		;ak je zaporne, odloz al bo vl
	mov ah, 02h
	mov dl, '-'
	int 21h			;vypis znamienko -
	mov ah, 0
	mov al, bl		;vrat do al bl
	xor al, 128             ;odstran znamienkovy bit
kladne_p:	
	mov bl, 10		;do bl uloz 10
	xor cx, cx		;vynuluj cx
	cmp al, 0		;zisti, ci al je 0
	jz vypis_nulu_p		;ak je nula, vypise priamo nulu bez delenia
del_p:	cmp al, 0		;ak sme uz al podeli 10, tolko kratm ze je 0
	jz vypis_p		;tak to ciselko teraz vypiseme
	div bl			;podelime ax bl
        push ax			;odlozime ax, cize zvysok po deleni do zasobnika
	inc cx			;zvacsime pocet cifier o jednu
	mov ah, 0		;vynulujeme ah
	jmp del_p		;a vratime sa spat na delenie
vypis_p:			;tu zaciname vypisovat zvysky
	pop ax			;precitame posledny zvysok zo zasobnika
	add ah,48		;zmenime cislo na znak
	mov dl, ah
	mov ah, 02h
	int 21h			;a vypiseme ten znak
	loop vypis_p		;v cx bolo pocet cifier, takze cx zmensujeme o 1
	jmp koniec_p		;pokial nie je rovne nule, a potom skoncime vypisovanie
vypis_nulu_p:			;tu vypisujeme al, pokial to bola iba nula
	mov dl, '0'		;do dl dame znak '0'
	mov ah, 02h	
	int 21h			;a vypiseme ho
koniec_p:			;koniec vypisovania
	pop cx			;obnovime registre cx a bx
	pop bx
	ret			;a vyskocime z procedury
vypis_cislo	endp
;----------------------nacita cislo do al-----------------------------------
citaj_cislo	proc            ;iba kladne cisla
	push bx			;odlozime cx, bx do zasobnika
	push cx
	xor ax, ax		;vynulujeme ax, bx
	xor bx, bx
	mov znak, 0		;do znaku vlozime 0, tam bude nase nacitane cislo
citaj_p:
	mov ah, 08h
	int 21h			;nacitame znak bez echa
	cmp al, 13              ;zistujeme, co bolo stlacene
	jz koniec_p2		;ak to bol enter, tak skocime na koniec nacitavania
	cmp al, '0'
	jb citaj_p
	cmp al, '9'             ;ak nacitany znak nebola jedna z cifier 0 - 9
	ja citaj_p		;tak nacitava dalsi znak
	mov cl, al              ;do cl odlozime al
	sub cl, 48		;premenime znak na cislo
	mov ah, 02h
	mov dl, al
	int 21h			;vypiseme stlaceny znak
	mov ah, 0		;vynuluje ah, pred nasobenim
	mov al, znak		;do al vlozime poslednu hodnotu nacitavaneho cisla
	mov bl, 10		;ideme nasobit 10, tak do bl ulozine 10
	mul bl			;vynasobime ax s bl=10
	add al, cl		;pripocitame do al nacitane cislo
	mov znak, al		;odlozime znaku nase nacitane cislo
	jmp citaj_p		;a vratime sa spat na nacitavanie dalsieho cisla
koniec_p2:
	pop cx			;obnovime cx a bx
	pop bx
	mov ah, 0
	mov al, znak		;ulozime do al nase nacitane cislo
	ret
citaj_cislo	endp
;---------------------caka na klavesu----------------------------------------
klavesa	proc
	push ax			;odlozime registre ax. bx, dx
	push bx
	push dx
	mov ah, 02h		;sluzba na nastavenie kurzoru
	mov bh, 0		;nastavime videostranku
	mov dh, 24		;nastavime riadok	
	mov dl, 25		;a stlpec
	int 10h			;zavolame prerusenie
	mov dx, offset messg2	;do dx oadresa messg2
	mov ah, 09h		;do ah 09h
	int 21h                 ;vypiseme text messg2
	mov ah,08h
	int 21h			;caka na klavesu bez echa
	pop dx
	pop bx
	pop ax			;obnovime registre
	ret
klavesa	endp
;---------------------zmaze obrazovku---------------------------------------
zmaz	proc
	mov ax,03h
	int 10h
	ret
zmaz	endp
;------------------------------ zaciatok programu ---------------------------
start:	mov ax, seg data
	mov ds, ax
	call zmaz
	mov ah, 3dh		;otvorenie suboru
	mov dx, offset subor1
	int 21h
	mov subaddr, ax		;odlozime si handle vstupneho suboru
	cmp ax, 02h		;ak subor existuje tak program pokracuje	
	jnz existuje
	mov ah, 09h
	mov dx, offset messg12
	int 21h			;inak vypise chybu a program skonci
	call klavesa
	jmp koniec		;skok na koniec pri chybe
existuje:
	mov bx, subaddr 	;dame do bx handle zdrojoveho suboru
	mov cx, 1                	;citaj po jednom byte
	mov si, offset cisla		;vynulujeme si
citaj:	mov ah, 3fh
	mov dx, offset znak	;do znaku vzdy ulozi precitany znak
	mov bx, subaddr
	int 21h
	cmp ax, 0		;ak uz nic neprecital, tak
	jz koniec_suboru	;skonci citanie
	cmp znak, ' '		;zistujeme, co sme nacitali
	jz dalsie_cislo		;ak je to medzera tak ideme na dalsie cislo
	cmp znak, '-'		;ak je to minus
	jne kladne		;tak nasavime
	mov znam, 1             ;znam na 1
	jmp citaj               ;ak to nebola cifra, tak citaj dalsi znak
kladne:
	mov ax, [si]		;ulozime do ax obsah [si]=nase prave nacitavane cislo
	cmp znak, '0'
	jb dalej
	cmp znak, '9'
	ja dalej		;zistime, ci znak je cifra
	mov bh, 0		;ak je
	mov bl, 10              ;tak vynasobime
	mul bl                  ;ax 10
	mov bl, znak
	sub bl, 48              ;do bl pripravime nacitanu cifru
	add al, bl		;a pripocitame ju do al
dalej:	
	mov [si], al		;odlozime al do [si]
	jmp citaj
dalsie_cislo:
	mov al, [si]
	test al, 128		;zisti, ci doslo k prepisaniu znamienkoveho bitu
	jns ok
	mov ah, 09h		;ak ano
	mov dx, offset messg0	;tak vypise chybu
	int 21h
	call klavesa		;pocka na klavesu
   	jmp koniec		;a skonci
ok:	cmp znam, 0             ;ak je cislo kladne tak nic s nim nerob
	jz zaporne
	mov al, [si]		;ak je cislo zaporne tak do 
	or al, 128		;najvysieho bitu ulozime 1
	mov [si], al		;a odlozime al, do [si]
zaporne:
	mov al, [si]		;vlozime do al [si] nase precitane cislo
	not al			;negujeme al 
	add al, 1		;a pripocitame 1 = doplnkovy kod
	mov [si],al		;odlozime al spat do [si]
	inc si			;posun o byte dalej, na dalsie cislo
	mov znam, 0             ;nastavime znamienko spat na nulu
	jmp citaj		;a citame dalsie cislo
koniec_suboru:
	cmp znam, 0           	;ak je cislo kladne tak nic s nim nerob
	jz zaporne2
	mov al, [si]		;ak je cislo zaporne tak do 
	or al, 128		;najvysieho bitu ulozime 1
	mov [si], al		;a odlozime al, do [si]
zaporne2:
	mov al, [si]		;vlozime do al [si] nase precitane cislo
	not al			;negujeme al 
	add al, 1		;a pripocitame 1 = doplnkovy kod
	mov [si],al		;odlozime al spat do [si]
	mov ax, offset cisla    ;do ax odlozime adresu cisel
	inc si			;si ukazuje na posledne cislo
	sub si, ax		;adcitame konecnu a zaciatocnu adresu
	mov ax, si		;aby sme zistili kolko cisel sme precitali
	mov poc, al		;a to ulozime do poc
	mov dx, offset messg1
	mov ah, 09h
	int 21h			;vypise informaciu o nacitani suboru
	call klavesa
;-------------------------------uvodne menu---------------------------------
menu:	call zmaz		;zmaze obrazovku
	mov dx, offset poloz	
	mov ah, 09h
	int 21h                 ;vypise menu
	mov ah, 01h
	int 21h			;nacita jeden znak
	cmp al, 97              ;podla toho, co nacital
	jz .vypis_cisla         ;skoci na urictu ulohu
	cmp al, 98
	jz .suma_cisel
	cmp al, 99
	jz .usporiadaj
	cmp al, 100
	jz .del_vybrane
	cmp al, 101
	jz .nasob_posledne
	cmp al, 102
	je .koniec
	jmp menu		;ak nevyhovuje nic tak cita dalsi znak
;--------------predlzenie skokov--------------------------------------------
.vypis_cisla: jmp vypis_cisla
.suma_cisel: jmp suma_cisel
.usporiadaj: jmp usporiadaj
.del_vybrane: jmp del_vybrane
.nasob_posledne: jmp nasob_posledne
.koniec: jmp koniec
;-------------------vypise nacitane cisla------------------------------------
vypis_cisla:
	mov dx, offset messg3
	mov ah, 09h
	int 21h         	;vypise text messg3
	mov si, offset cisla	;nastavi si na adresu cisla
	mov cl, poc		;do cl ulozi pocet cisel
	cmp cl, 0		;zisti, ci pocet cisel nie je nula
	jz menu			;ak je skoci spat do menu
dalsie:
	mov al, [si]		;do al vlozime cislo z [si]
	call vypis_cislo	;vypiseme ho
	mov ah, 02h
	mov dl, ' '
	int 21h			;vypiseme medzeru
	inc si			;posunieme sa na dalsie cislo
	loop dalsie		;ak sme nevypisali vsetky cisla, tak pis dalsie
	call klavesa		;caka na klavesu
	jmp menu		;ide spat do menu
;-------------------------vypise sumu cisel------------------------------
suma_cisel:
	mov sumap, 0		;vynulujeme sumy
	mov sumam, 0
	mov si, offset cisla	;s nastavy na adresu cisla
	mov cl, poc		;do cl ulozime pocet
	cmp cl, 0		;zisti, ci pocet cisel nie je nula
	jz menu			;ak je skoci spat do menu
spat1:  mov al, [si]		;do al vlozime cislo z [si]
	sub al, 1
	not al
	test al, 10000000b	;zistime ci je kladne
	js zaporne1		;ak nie je, skocime na zaporne1
	mov bl, sumap		;do bl ulozime sumu kladnych cisiel
	add bl, al		;pripocitame do bl al
	test bl, 128
	jns ok2
	mov ah, 09h
	mov dx, offset messg0
	int 21h	
	call klavesa
	jmp menu
ok2:	mov sumap, bl		;a vlozime bl spat do sumap
	jmp kladne1		;skocime na klane1
zaporne1:
	mov al, [si]		;pripocitame
	sub al, 1
	not al
	xor al, 10000000b	;zrusime znamienkovy bit
	mov bl, sumam		;do sumy
	add bl, al		;zapornych cisel al
	test bl, 128
	jns ok3
	mov ah, 09h
	mov dx, offset messg0
	int 21h	
	call klavesa
	jmp menu
ok3:	mov sumam, bl
kladne1:
	inc si			;posunieme sa na dalsie cislo
	loop spat1		;ak sme nescitali vsetky cisla(cl<>0) tak chod na spat1
	mov ah, 09h
	mov dx, offset messg4
	int 21h			;vypise text messg4
	mov al, sumap		;do al ulozime sumu kladnych cisel
	not al
	add al, 1
 	call vypis_cislo	;a vypiseme sumu
	mov ah, 09h
	mov dx, offset messg5
	int 21h              	;vypise text messg5
	mov al, sumam		;do al vlozime sumu zapornych cisel
	xor al, 10000000b	;vyrobime znamienkovy bit
	not al
	add al, 1
	call vypis_cislo	;a vypiseme ju
	call klavesa		;caka na klavesu
	jmp menu		;vrat sa spat do menu
;------------------usporiadaj a zapis do suboru-----------------------
usporiadaj:                     ;triedenie prebublavanim
	mov si, offset cisla	;do si ulozi adresu cisla
	xor ax, ax
	xor bx, bx		;vynuluje bx a ax
	mov cl, poc		;nastavi cl na poc-1
	dec cl
	mov bl, 1		;nastavi bl na 1
spat4:  cmp cl, 1
	jb utriedene
spat3:	cmp bl, cl		;porovna bl a cl
	ja dalej4		;ak je bl vacsie ako cl tak skoci na dalej4
	mov al, [si]		;zisti, ci al je kladne
	mov dl, [si+1]
	test al, 128
	jns testuj
	test dl, 128
	jns testuj
	cmp al, dl
	jb dalej3		;tak ich porovna <
	xchg al, dl         ;ak je aspon jedno zaporne, tak
	mov [si], al		;ich porvna >
	mov [si+1], dl
	jmp dalej3		;a vymeni ich ak al < [si+1]
testuj:	cmp al, 0
	jnz nic5
	or al, 128
nic5:	cmp dl, 0
	jnz nic6
	or dl, 128
nic6:	cmp al, dl
	ja dalej3      		;porovna [si]=al a [si+1]
	xchg al, dl		;a vymeni ich ak al > [si+1]
	cmp al, 128
	jnz nic7
	xor al, 128
nic7:	cmp dl, 128
	jnz nic8
	xor dl, 128
nic8:	mov [si], al
	mov [si+1], dl
dalej3:	inc bl			;zvacisi bl o 1
	inc si			;posun sa na dalsie cislo
	jmp spat3	
dalej4:	dec cl			;zmensi cl o 1
	mov si, offset cisla    ;nastav si na zaciatok cisla
	mov bl, 1		;nastav bl na 1
	jmp spat4
.zapisane: jmp zapisane		;len na predlzenie skoku
utriedene:
	mov ah, 3ch             ;vytvorime
	mov dx, offset subor2	;vystupny subor
	xor cx, cx
	int 21h			;data2.txt
	mov al, 1		;nastavime al na 1=zapis
	mov ah, 3dh
	mov dx, offset subor2
	int 21h			;otvorime subor data2.txt
	mov sub2adr, ax		;do sub2adr ulozime handle suboru2
	mov si, offset cisla	;nastav si na cisla
	xor cx, cx		;vynuluj cx, pocet zapisanych cisel
pis:	cmp cl, poc		;porovna cl s poc, ci su zapisane vsetky cisla
	push cx			;odlozime cx do zasobmika
	jae .zapisane
	mov ah, 0		
	mov al, [si]            ;do al vlozime cislo z [si]
	sub al, 1
	not al			;prevedieme ho do dvojkovej sustavy
	test al, 10000000b	;zistime,ci je zaporne
	jns kladne0
	push ax                 ;ak je tak odlozime ax
	mov znak, '-'
	mov cx, 1
	mov bx, sub2adr
	mov dx, offset znak
	mov ah, 40h
	int 21h			;zapiseme znak '-' do suboru
	pop ax			;obnocime ax
	mov ah, 0
	xor al, 128             ;zrusime znamienkovy bit
kladne0:	
	mov bl, 10              ;nastavime bl na 10, budeme delit 10
	xor cx, cx		;vynuluje cx
	cmp al, 0		;ak je al
	jz vypis_nulu		;tak hned vypise nulu
del:	cmp al, 0		;ak je uz al tak vypiseme zvysky	
	jz vypis
	div bl			;vydeli al s bl
        push ax                 ;odlozi zvysok do zasobnika
	inc cx			;zvacsi pocet cifier o 1
	mov ah, 0
	jmp del			;vrati sa spat na del
vypis:	
	pop ax			;vytiahne poslednu cifru zo zasobnika
	push cx			;odliz cx do zasobnika
;	mov al, 0
	add ah, 48		;zvysok premeni na cifru
	mov znak, ah		;vlozi ju do znaku
	mov ah, 40h
	mov cx, 1
	mov dx, offset znak
	mov bx, sub2adr
	int 21h			;a zapise znak do suboru2
	pop cx			;obnovi cx, pocet zapisanych cifier
	loop vypis		;ak nie su vypisane vsetky cifry, tak skoc na vypis
	mov znak, ' '		;vlozi znaku ' '=medzeru
	mov dx, offset znak
	mov cx, 1
	mov bx, sub2adr
	mov ah, 40h             ;a zapise ju do suboru2
	int 21h			;aby boli medzi cislami medzery
	pop cx			;obnovy cx, pocet zapisanych cisiel
	mov ch, 0
	inc cl			;zvacsi cl
	inc si			;zvacsi si = posun na dalsie cislo
	jmp pis			;skoci spat na nulu
vypis_nulu:
	mov znak, '0'
	mov dx, offset znak
	mov cx, 1
	mov bx, sub2adr
	mov ah, 40h
	int 21h			;zapise do suboru2 0
	mov znak, ' '
	mov dx, offset znak
	mov cx, 1
	mov bx, sub2adr
	mov ah, 40h
	int 21h                 ;zapise do suboru2 ' '
	pop cx			;obnovi pocet zapisanych cisiel
	mov ch, 0
	inc cl			;zvacsi cl
	inc si			;zvacsi si = posun na dalsie cislo
	jmp pis			;skoci spat na nulu
zapisane:	
	mov ah, 09h
	mov dx, offset messg11
	int 21h			;vypise text messg11
	mov ah, 3eh
	mov bx, sub2adr
	int 21h			;zatvori subor2
	call klavesa		;caka na klavesu
	jmp menu		;skoci spat do menu
;------------------vydeli dve vybrane cisla---------------------------
del_vybrane:
	mov ah, 09h
	mov dx,	offset messg7
	int 21h			;vypise text messg7
	call citaj_cislo	;nacita cislo do al
	cmp al, poc
	ja nesedi               ;pokial
	cmp al, 0               ;al nie je v 
	ja sedi			;intervale <1,poc> tak 
nesedi:	mov ah, 09h
	mov dx,	offset messg13
	int 21h			;vypise o tom spravu
	call klavesa		;caka na klavesu
	jmp menu		;skoci spat do menu
sedi:	mov si, offset cisla	;do si ulozi adresu cisla
	add si, ax		;nastavi si na vybrane cislo
	mov ah, 09h
	mov dx,	offset messg8
	int 21h
	call citaj_cislo	;nacita index druheho cisla
	cmp al, poc
	ja nesedi2		;to iste ako predtym ci 
	cmp al, 0		;nacitane cislo je v interval <1,poc>
	ja sedi2
nesedi2:mov ah, 09h
	mov dx,	offset messg13
	int 21h
	call klavesa
	jmp menu
sedi2:	mov di, ax		;di nastavime na druhe vybrane cislo
	mov znam, 0		;nastavi znamienko ma 0
	mov al, [si-1]		;do al ulozi nase vybrane cislo
	sub al, 1
	not al			;prevedie ho spat do dvoj. kodu
	test al, 10000000b      ;zisti znamienko
	jns nic			;ak je zaporne
	xor al, 128		;odstranime znamienkovy bit
nic:
	mov bl, [di-1]		;do bl vlozi druhe vybrane cislo
	sub bl, 1
	not bl			;prevedie cislo do dvoj. kodu
	test bl, 10000000b      ;zisti znamienko
	jns nic2                ;ak je zaporne
	xor bl, 10000000b	;odstranime znamienkovy bit
nic2:
	mov ah, 0		;vynuluje ah, bh
	mov bh, 0
	cmp bl, 0
	jnz no_zero
	mov ah, 09h
	mov dx, offset messg14
	int 21h
	call klavesa
	jmp menu
no_zero:
	cmp al, 0
	jnz no_zero2
	xor ax, ax
	xor bx, bx
	jmp wau
no_zero2:	
	div bl			;vydeli cislo v ah cislo v bl
	mov bh, ah		;do bh vlozi zvysok po deleni
wau:	push ax
	mov ah, 09h
	mov dx,	offset messg9
	int 21h			;vypise text messg9
	pop ax
	not al			;prevedie cele cislo po deleni
	add al, 1		;do doplnkove kodu
	call vypis_cislo	;a vypise ho
	mov ah, 09h
	mov dx,	offset messg10
	int 21h			;vypise text messg10
	mov al, bh		;do al da bl=zvysok po deleni
	not al			;prevedie
	add al, 1		;do dolnkove kodu
	call vypis_cislo	;vypise zvysok
	call klavesa		;caka na klavesu
	jmp menu		;skoci spat do menu
;------------------vynasobi posledne dve cisla---------------------------
nasob_posledne:
	mov ah, 09h
	mov dx, offset messg6
	int 21h			;vypise text messg6
	mov si, offset cisla	;do si ulozi adresu cisla
	xor ax, ax		;vynuluje ax
	mov al, poc		;do al vlozi pocet cisel
	add si, ax		;nastavi si na koniec cisla
	mov al, [si-2]		;do al vlozi predposledne cislo
	mov bl, [si-1]		;do bl vlozi posledne cislo
	sub al, 1		;prevedie
	sub bl, 1		;al aj bl
	not al                  ;do dvojkoveho
	not bl			;kodu
	mov znam, 0             ;nastavi znamienko na nulu
	test al, 10000000b	;zisti, ci al je zaporne
	jns nic3
	mov znam, 1		;ak je tak nastavi znamienko na 1
	xor al, 128
nic3:	test bl, 10000000b	;zisti, ci bl je zaporne
	jns nic4		
	cmp znam, 1             ;ak je tak zisti, ci aj al bolo zaporne
	xor  bl, 128
	jz nic4          	;ak ano, tak znam zmeni na 0
	mov znam, 0		;ak nie tak so znamniekom nic nespravi
nic4:	mul bl			;vynasobi al s bl
	test al, 128		;zisti, ci doslo k prepisaniu znamienkoveho bitu
	jns ok1
	mov ah, 09h		;ak ano
	mov dx, offset messg0	;tak vypise chybu
	int 21h
	call klavesa		;pocka na klavesu
   	jmp menu		;a skoni do menu
ok1:	cmp znam, 1
	jnz vypis1              ;ak je znamienko 1
	or al, 128		;tak vyrobime 1 na znamienkovom bite
vypis1:
	not al			;prevediem cislo
	add al, 1		;do doplnkoveho kodu
	call vypis_cislo	;a vypiseme ho
	call klavesa		;caka naklavesu
	jmp menu		;skoci spat do menu
;----------------koniec programu----------------------------
koniec:	mov ah, 3eh
	mov bx, subaddr
	int 21h			;zatvori vstupny subor data.txt
	mov ah, 4ch		;ukonci program
	int 21h
code	ends
	END	start

; Hodnotenie programu:
;
; Program nacita cele cisla zo suboru a potom ich v doplnkovom kode ulozi do pamate.
; Maximalny pocet cisel je 20.
; Interval cisel s ktorymi program pracuje je <-127,127>
; Pri preteceni program vypise chybu.