;ZADANIE c.2
;Vytvorte  program,  ktory  nacta  z  textovho sboru postupnost celych csel
;(aspon 10)so znamienkom  v desiatkovej cselnej sstave, potom ich transformuje
;na csla v dvojkovej cselnej sstave v doplnkovom kde a potom podla priania
;pouzvatela
;a)spocta kladn (alebo zporn)csla a sumu vypse
;b)usporiada csla zostupne a zapse usporiadan postupnost csel do novho textovho sboru,
;c)vydel dve vybran csla a vypse vysledok
;d)vynsob posledn dve csla a vypse vysledok
;e)ukonc vykonvanie programu.
;Autor: Michal Slamka
;Termin odovzdania:14.11.2000
;2.roc.,sk.roc.2000/2001
;-----------------------------------------------------------------------
jumps
multerrs
;-----------------------------------------------------------------------
zas     segment stack 'stack'             ;zaciatok zasobnikoveho segmentu
        dw      64 dup(?)                 ;definicia 64-och slov 
zas     ends                              ;koniec zasobnikoveho segmentu 
;-----------------------------------------------------------------------
data    segment                           ;zaciatok datoveho segmentu
menu    db      '1: Spocitaj kladne cisla',13,10          ;definicia vypisu menu
        db      '2: Spocitaj zaporne cisla',13,10
        db      '3: Usporiadaj cisla zostupne a zapis ich do noveho suboru',13,10
        db      '4: Vydel vybrane cisla',13,10
        db      '5: Vynasob posledne dve cisla',13,10
        db      '6: Koniec programu',13,10
        db      'STLAC ZVOLENE CISLO:',13,10,'$'
stlac   db      'Nestlacil si vhodny znak!$'
text1   db      'Cisla ulozene v subore "cisla.txt" su:$'
veta1   db      'Sucet kladnych cisel je:$'     ;definicia dalsich vypisov
veta2   db      'Sucet zapornych cisel je:$'
veta31  db      'Cisla usporiadane zostupne:',13,10,'$'
veta32  db      'Tato postupnost bola ulozena do suboru "uspor.txt"!',13,10,'$'
veta4   db      'Vyber si dve cisla:',13,10,'$'
subor   db      'cisla.txt',0                          ;definicia suboru
uklsub  db      'uspor.txt',0
read    db      100 dup(?)         ; tu sa bude ukladat citany subor
nr      db      13,10,'$'                                       ;definicia noveho riadku
naccis  dw      100 dup(0)
data    ends                                            ;koniec datoveho segmentu
;--------------------------------------------------------------------------
code    segment                                         ;zaciatok kodoveho segmentu
        assume  ds:data, ss:zas, cs: code               ;aktivne segmenty
start:  mov     ax, seg data                            ;do AX vloz seg. cast adresy
        mov     ds, ax                                  ;seg. cast adresy presun do DS
        mov     dx, offset text1
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h
        mov     ah,3dh              ; otvor subor
        mov     al,0                ; na citanie
        mov     dx,offset subor     ; je to subor data.inc
        int     21h


        mov     dx,offset read      ; bude sa ukladat do pameti
        mov     cx,1                ; po jednom znaku
        mov     bx,ax               ; do bx daj handler otvoreneho suboru
citaj:  mov     ah,3fh              ; citaj subor
        int     21h
        inc     dx                  ; priprav adresu pre ulozenie dalsieho
                                    ; znaku do pameti 'precitane'
        cmp     ax,0                ; bol EOF?
        jne     citaj               ; ak nie, citaj dalsi znak zo suboru
        mov     byte ptr dx, '$'
        mov     dx, offset read
        mov     ah, 9
        int     21h

ponuka: mov     dx, offset menu
        mov     ah, 09h
        int     21h

        mov     ah, 01h
        int     21h

        cmp     al, '1'
        je      uloha1
        cmp     al, '2'
        je      uloha2
        cmp     al, '3'
        je      uloha3
        cmp     al, '4'
        je      uloha4
        cmp     al, '5'
        je      uloha5
        cmp     al, '6'
        je      koniec
        
        mov     dx, offset stlac
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h

        jmp     ponuka

koniec: mov     ax,4c00h
        int     21h

uloha1: mov     dx, offset nr
        mov     ah, 09h
        int     21h
        mov     dx, offset veta1
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h
        jmp     ponuka

uloha2: mov     dx, offset nr
        mov     ah, 09h
        int     21h
        mov     dx, offset veta2
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h
        jmp     ponuka

uloha3: mov     dx, offset nr
        mov     ah, 09h
        int     21h
        mov     dx, offset veta31
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h
        mov     dx, offset veta32
        mov     ah, 09h
        int     21h
        mov     dx, offset nr
        mov     ah, 09h
        int     21h
        jmp     ponuka

uloha4: mov     dx, offset nr
        mov     ah, 09h
        int     21h
        jmp     ponuka

uloha5: mov     dx, offset nr
        mov     ah, 09h
        int     21h
        jmp     ponuka

ends
end     start
