;Norbert Toth B13, Info 21
;Zadanie 2
;
;Program nacita retazec vypise menu:
;1. vypocita sumu  vsetkych cisel a vypise ju.
;2. Usporiada cisla vzostupne a zapise usporiadanu postupnost cisel do noveho       textoveho suboru.
;3. Usporiada cisla zostupne a zapise usporiadanu postupnost cisel do noveho        textoveho suboru.
;4. Vydeli dve vybran cisla a vypise vysledok.
;5. Vynasobi dve cisla a vypise vysledok.
;6. Koniec.
;a realizuje ho.
; (c)2000
;-----------------------------------------------------------

ZAS	SEGMENT STACK		;Definicia zasobnika
	DW	64 DUP(?)
ZAS	ENDS			;Koniec definicie zasobnika

;---------------------------------------------------------------

DATA	SEGMENT			;Definicia datoveho segmentu
SUBOR	DB	"INPUT.TXT",0	;Vstupny subor 
OUTPUTV	DB	"OUTPUTV.TXT",0	;Vystupny subor 
OUTPUTZ	DB	'OUTPUTZ.TXT',0	;Vystupny subor 
MIN	DB	'-'
POCETZN	DB	0		;Skutocny pocet cislic
POCET	DB	0
CISLA	DW	100 DUP(?)	;Dane cisla
USPOR	DW	100 DUP(?)	;Usporiadane cisla
USP	DB	0
CISLO	DW	0		;aktualne cislo
CIS	DW	0
ZNAM	DB	0
SUMA	DW	0
HAND	DW	0
POM	DB	0 
MEDZ	DB	' '
NOVYR	DB	0DH		;Prechod na novy riadok
	DB	0AH
RETKON	DB	'$'		;Koniec retazca.
MENU	DB	'1. Vypocita sumu  vsetkych cisel a vypise ju.',0DH, 0AH      ;Vypis menu a hlaseni
	DB	'2. Usporiada cisla vzostupne a zapise usporiadanu postupnost cisel do noveho       textoveho suboru.',0DH, 0AH
	DB	'3. Usporiada cisla zostupne a zapise usporiadanu postupnost cisel do noveho        textoveho suboru.',0DH, 0AH
	DB	'4. Vydeli dve vybrane cisla a vypise vysledok.',0DH, 0AH
	DB	'5. Vynasobi dve cisla a vypise vysledok.',0DH, 0AH
	DB	'6. Koniec.',0DH, 0AH
	DB	'Volba.$'
NEEXIST	DB	'Subor neexistuje!$'
NECIT	DB	'Neviem citat subor!$'
NEOTV	DB	'Neda sa otvorit.$' 
NEPIS	DB	'Neda sa zapisovat.$'
ZAPIS	DB	'Zapis vykonany.$'
POKEC	DB	'Stlac lub. klavesu  ...$'
SUCET	DB	'Sucet cisel je :$'
PRETEC	DB	'Doslo k preteceniu.$'
ZADAJ	DB	'Zadaj prve cislo:$'
ZADAJ2	DB	'Zadaj druhe cislo:$'
VYSLED	DB	'Vysledok je: $'
ZVYSOK	DB	'Zvysok: $'
DELN	DB	'Nastalo delenie nulou!$'
  
DATA	ENDS			;Koniec dat. segmentu

;------------------------------------------------------------------

CODE	SEGMENT			;Zaciatok kodoveho segmentu
	ASSUME	CS:CODE, DS:DATA, SS:ZAS

;------------------------------------------------------------------

START:	MOV AX,	SEG DATA	;Vlastny zaciatok programu
	MOV DS, AX
	MOV AH, 3DH
	MOV AL, 2
	MOV DX, OFFSET SUBOR
	INT 21H			;otvorenie suboru
	JNC DALEJ		;porovnanie CF
	MOV DX,	OFFSET NEEXIST	;ak neexistuje
	MOV AH, 09H
	INT 21H			;vypise sa text
	JMP MEN6		;a ukonci sa program
DALEJ:	MOV HAND, AX		;ak existuje,program pokracuje
NACITANIE:
	MOV DX,	OFFSET CISLO
	MOV BX, HAND 
	MOV AH, 3FH
	MOV CX, 1
	INT 21H			;nacitanie znaku
	JNC DALEJ2		;porovnanie CF
	MOV DX,	OFFSET NECIT	;ak nevie citat
	MOV AH, 09H
	INT 21H			;vypise sa text
	JMP MEN6		;a ukonci sa program
DALEJ2:	MOV BX ,DX
	CMP AX, 0		;test konca suboru
	JZ KONIECNAC
	CMP [BX], ' '		;ak je to medzera
	JZ KONIECNACCIS		;zapise sa cislo
	CMP [BX], '-'
	JZ ZAPORNE		;je to zaporne cislo
	PUSH DX			;prevod cisla
	SUB [BX], 30H
	MOV AX, CIS
	MOV DX, 10
	MUL DX
	ADD AX, [BX]
	MOV CIS, AX 
	POP DX
	JMP NACITANIE

ZAPORNE:
	MOV ZNAM, 01H		;znamenie zaporneho cisla
	JMP NACITANIE

KONIECNACCIS:
	MOV BX, OFFSET CISLA	;uchova pocet znakov
	XOR AX, AX
	MOV AL, POCET
	MOV DX, 2
	MUL DX
	ADD BL, AL		;posun na koniec CISLA
	MOV AX, CIS
	CMP ZNAM, 1		
	JE ZAPOR		;ak je zaporne
SPAT:	MOV [BX], AX
	MOV CIS, 0
	MOV ZNAM, 0
	ADD POCET, 1		;zvacsi sa pocet
	JMP NACITANIE

ZAPOR:	NEG AX			;neguje sa
	JMP SPAT

KONIECNAC:
	MOV AH, 3EH
	MOV DX, OFFSET SUBOR
	INT 21H			;zatvorenie suboru

;------------------------------------------------------------------

CYKLUS:	MOV AX,03H		;zmazanie obrazovky
	INT 10H
	MOV DX,	OFFSET NOVYR	;Vypis menu, oriadkovanie
	MOV AH, 09H
	INT 21H
	MOV DX,	OFFSET MENU	;Vypis textu.
	MOV AH, 09H
	INT 21H
	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H
	MOV AH, 01H		;Nacitanie volby
	INT 21H
	MOV CL, AL
	MOV DX,	OFFSET NOVYR
	MOV AH, 09H
	INT 21H			;Oriadkovanie
	CMP CL, 31H		;Skok na prislusnu polozku
	JZ M1
	CMP CL, 32H
	JZ M2
	CMP CL, 33H
	JZ M3
	CMP CL, 34H
	JZ M4
	CMP CL, 35H
	JZ M5
	CMP CL, 36H
	JZ M6
	JMP CYKLUS


M1:	JMP MEN1		;Skok na prislusnu polozku
M2:	JMP MEN2
M3:	JMP MEN3
M4:	JMP MEN4
M5:	JMP MEN5
M6:	JMP MEN6

;---------------------------------------------------------------

MEN1:	MOV DX,	OFFSET SUCET	;Realizacia Menu1
	MOV AH, 09H		;Vypis textu.
	INT 21H
	MOV SUMA, 0		;inicializacia prem.
	MOV BX, OFFSET CISLA
	XOR CX, CX
	MOV CL, POCET
	
CYKLUS1:
	MOV DX, [BX]
	CMP SUMA, 32767
	JA MINUSS		;ak je suma zaporna
	CMP DX, 32767
	JA MINUSD		;ak je suma zaporna
	ADD SUMA, DX		;inak iba pricita
	
	JO PR

BACK:	INC BX
	INC BX
	LOOPNE	CYKLUS1		;skok pre dalsie cislo

	MOV AX, SUMA
	CALL VYPIS		;vypis sumy

	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H
	JMP POCKAJ		;Skok na zaciatok

MINUSS:	NEG SUMA		;neguje sa
	CMP DX, 32767
	JA MINUSSD		;ak je DX zaporne
	CMP SUMA, DX
	JA MINS
	SUB DX, SUMA		;urobi sa rozdiel

	JO PR

	MOV SUMA, DX
	JMP BACK

MINUSSD:
	NEG DX			;ak su obidve zaporne
	ADD SUMA, DX

	JO PR

	NEG SUMA
	JMP BACK

MINS:	SUB SUMA, DX		;ak suma>DX

	JO PR

	NEG SUMA
	JMP BACK

MINUSD:	NEG DX			;neguje sa DX 
	CMP SUMA, DX
	JA MIND
	SUB DX, SUMA		;ak je DX zaporne a suma<DX

	JO PR

	MOV SUMA, DX
	NEG SUMA
	JMP BACK

MIND:	SUB SUMA, DX		;ak je DX zaporne a suma>DX

	JO PR

	JMP BACK

PR:	JMP PRET

;---------------------------------------------------------------

MEN2:	CMP USP, 1		;ak nie je usporiadane pole
	JNE USPORI		;usporiada sa

X:	MOV AH, 3CH
	MOV AL, 2
	MOV CX, 0
	MOV DX, OFFSET OUTPUTV
	INT 21H			;vytvorenie suboru
	JNC DALEJ4		;porovnanie CF
	MOV DX,	OFFSET NEOTV	;ak neexistuje
	MOV AH, 09H
	INT 21H			;vypise sa text
	JMP MEN6		;a ukonci sa program
DALEJ4:	MOV HAND, AX		;ak existuje,program pokracuje
	MOV BX, OFFSET USPOR
	XOR CX, CX
	MOV CL, POCET

DALEJ5:	MOV AX, [BX]
	CALL VYPISS		;vypis cisla
	INC BX
	INC BX
	PUSH CX
	PUSH BX
	MOV BX, HAND
	MOV CX,1
	MOV AH, 40H
	MOV DX, OFFSET MEDZ	;vypis medzery
	INT 21H
	POP BX
	POP CX
	LOOPNE DALEJ5		;ak vie pisat ,program pokracuje

	MOV DX,	OFFSET ZAPIS	;ak vie pisat
	MOV AH, 09H
	INT 21H			;vypise sa text

	MOV DX,	OFFSET NOVYR
	MOV AH, 09H
	INT 21H			;oriadkuje sa
	
	MOV AH, 3EH
	MOV DX, OFFSET OUTPUTV
	INT 21H			;zatvorenie suboru

	JMP POCKAJ

USPORI:	CALL USPORIADAJ
	JMP X

;---------------------------------------------------------------

MEN3:	CMP USP, 1
	JNE USPORI2

XX:	MOV AH, 3CH
	MOV AL, 2
	MOV CX, 0
	MOV DX, OFFSET OUTPUTZ
	INT 21H			;otvorenie suboru
	JNC DALEJ6		;porovnanie CF
	MOV DX,	OFFSET NEOTV	;ak neexistuje
	MOV AH, 09H
	INT 21H			;vypise sa text
	JMP MEN6		;a ukonci sa program
DALEJ6:	MOV HAND, AX		;ak existuje,program pokracuje
	MOV BX, OFFSET USPOR	
	XOR CX, CX
	MOV CL, POCET
	MOV AX, 2
	MUL CX
	ADD BX, AX
	SUB BX, 2		;BX sa nastavi na koniec uspor. pola

DALEJ7:	MOV AX, [BX]
	CALL VYPISS		;vupis cisla
	DEC BX
	DEC BX
	PUSH CX
	PUSH BX
	MOV BX, HAND
	MOV CX,1
	MOV AH, 40H
	MOV DX, OFFSET MEDZ	;vypis medzery
	INT 21H
	POP BX
	POP CX
	LOOPNE DALEJ7		;program pokracuje

	MOV DX,	OFFSET ZAPIS	;ak vie pisat
	MOV AH, 09H
	INT 21H			;vypise sa text

	MOV DX,	OFFSET NOVYR
	MOV AH, 09H
	INT 21H			;oriadkuje sa
	
	MOV AH, 3EH
	MOV DX, OFFSET OUTPUTZ
	INT 21H			;zatvorenie suboru
	JMP POCKAJ

USPORI2:
	CALL USPORIADAJ
	JMP XX
;---------------------------------------------------------------

MEN4:	XOR CX, CX
	ADD CL, POCET
	MOV BX, OFFSET CISLA	
NAV1:	MOV AX, [BX]
	CALL VYPIS
	ADD BX, 2
	MOV DL, ' '
	MOV AH, 02H
	INT 21H
	LOOPNE NAV1

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H
         
 	MOV DX, OFFSET ZADAJ
	MOV AH, 09H
	INT 21H

	MOV AH, 01H		;nacitanie 1. cisla (1. cifra)
	INT 21H

	MOV AH, 20
	SUB AL, 30H
	MUL AH
	MOV POM, AL

	MOV AH, 01H		;nacitanie 1. cisla(2. cifra)
	INT 21H

	MOV AH, 02H
	SUB AL, 31H
	MUL AH
	ADD AL, POM
	MOV BX, OFFSET CISLA
	ADD BX, AX

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H


 	MOV DX, OFFSET ZADAJ2
	MOV AH, 09H
	INT 21H

	MOV DX, [BX]

	MOV AH, 01H		;nacitanie 2. cisla(1. cifra)
	INT 21H
	MOV AH, 20
	SUB AL, 30H
	MUL AH
	MOV POM, AL

	MOV AH, 01H		;nacitanie 2. cisla(2. cifra)
	INT 21H

	MOV AH, 02H
	SUB AL, 31H
	MUL AH
	ADD AL, POM

	MOV BX, OFFSET CISLA
	ADD BX, AX

	MOV AX, DX
	XOR DX, DX

	CMP AX, 32767
	JA MINU 		;ak je suma zaporna

SPA:	MOV CX, [BX]

	CMP CX, 0
	JE DELNUL	

	IDIV CX

	PUSH DX
	PUSH AX

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H

	MOV DX,	OFFSET VYSLED	;Vypis textu.
	MOV AH, 09H
	INT 21H

	POP AX
	CALL VYPIS

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H

	MOV DX,	OFFSET ZVYSOK	;Vypis textu.
	MOV AH, 09H
	INT 21H

	POP AX
	CALL VYPIS

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H

	JMP POCKAJ

MINU:	MOV DL, 255
	MOV DH, 255
	JMP SPA

DELNUL:	
 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H

	MOV DX,	OFFSET DELN	;Vypis textu.
	MOV AH, 09H
	INT 21H

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H

	JMP POCKAJ

;----------------------------------------------------------------------

MEN5:	XOR CX, CX
	ADD CL, POCET
	MOV BX, OFFSET CISLA	
NAV2:	MOV AX, [BX]
	CALL VYPIS
	ADD BX, 2
	MOV DL, ' '
	MOV AH, 02H
	INT 21H
	LOOPNE NAV2

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H
         
 	MOV DX, OFFSET ZADAJ
	MOV AH, 09H
	INT 21H

	MOV AH, 01H		;nacitanie 1. cisla (1. cifra)
	INT 21H

	MOV AH, 20
	SUB AL, 30H
	MUL AH
	MOV POM, AL

	MOV AH, 01H		;nacitanie 1. cisla(2. cifra)
	INT 21H

	MOV AH, 02H
	SUB AL, 31H
	MUL AH
	ADD AL, POM
	MOV BX, OFFSET CISLA
	ADD BX, AX

 	MOV DX, OFFSET NOVYR
	MOV AH, 09H
	INT 21H


 	MOV DX, OFFSET ZADAJ2
	MOV AH, 09H
	INT 21H

	MOV DX, [BX]

	MOV AH, 01H		;nacitanie 2. cisla(1. cifra)
	INT 21H
	MOV AH, 20
	SUB AL, 30H
	MUL AH
	MOV POM, AL

	MOV AH, 01H		;nacitanie 2. cisla(2. cifra)
	INT 21H

	MOV AH, 02H
	SUB AL, 31H
	MUL AH
	ADD AL, POM

	MOV BX, OFFSET CISLA
	ADD BX, AX

	MOV AX, DX
	XOR DX, DX
	MOV CX, [BX]

	IMUL CX
	
	CMP DX, 0
	JNE PRET
	CMP DX, 65535
	JNE PRET 

	PUSH DX
	PUSH AX

	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H

	MOV DX,	OFFSET VYSLED	;Vypis textu.
	MOV AH, 09H
	INT 21H

	POP AX
	POP DX
	CALL VYPIS

	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H

	JMP POCKAJ			;Skok na zac. cyklu
	
;---------------------------------------------------------------

MEN6:	MOV AX, 4C00H		;Koniec a navrat do DOSu
	INT 21H

;---------------------------------------------------------------

POCKAJ:	MOV DX, OFFSET POKEC	;Vypise sa 'Stlac lub. klavesu...'	
	MOV AH, 09H
	INT 21H
	MOV AH, 01H		;pocka sa na lub. klav.
	INT 21H
	JMP CYKLUS
;---------------------------------------------------------------
PRET:	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H
	MOV DX,	OFFSET PRETEC	;Vypis textu
	MOV AH, 09H
	INT 21H
	MOV DX,	OFFSET NOVYR	;Oriadkovanie
	MOV AH, 09H
	INT 21H
	JMP POCKAJ

;----------------------------------------------------------------

VYPIS:	PUSH BX			;ulozia sa registre
	PUSH CX
	PUSH DX
	XOR CX, CX
	CMP AX, 32767		;porovnanie 
	JA ZN1			;ak je zaporne
ZN2:	CMP AX, 10
	JB ZNE
	MOV BX, 10
	XOR DX, DX
	DIV BX			;prevod do 10 sustavy
	ADD CX, 1
	PUSH DX			;ulozenie do zasobniku	
	JMP ZN2
ZNE:	PUSH AX			;ulozenie posled. znaku
	ADD CX, 1
	MOV AH, 02H
ZN3:	POP DX
	ADD DL, 30H		;prevod na ASCCI kod
	INT 21H			;vypis
	LOOPNE ZN3	

	POP DX			;vybratie registrov
	POP CX
	POP BX
	RET			;navrat


ZN1:	PUSH AX
	MOV AH, 02H
	MOV DL, '-'
	INT 21H			;vypis -
	POP AX
	NEG AX			;negacia
	JMP ZN2
	    

;----------------------------------------------------------------
USPORIADAJ: 			;usporiadanie pola
	XOR CX, CX		;inicializacia prem
	MOV CL, POCET
	MOV AX, 2
	MUL CX
	MOV CX, AX
	MOV AX, 2
CYKL:				;opakovanie je dane hodnotou cx
	MOV BX, OFFSET CISLA
	ADD BX, CX
	MOV DL, BYTE PTR [BX]		;kopiruje retazec cisla do retazca uspor
	MOV BX, OFFSET USPOR
	ADD BX, CX
	MOV BYTE PTR [BX], DL
	LOOPNE CYKL

	MOV BX, OFFSET CISLA
	ADD BX, CX
	MOV DL, BYTE PTR [BX]		;kopiruje posledny clen retazeca cisla do retazca uspor
	MOV BX, OFFSET USPOR
	ADD BX, CX
	MOV BYTE PTR [BX], DL

	XOR DX, DX
	MOV DL, POCET
	MOV CISLO, DX
OPAKUJ:	XOR DX, DX		;vonkajsi cyklus
	XOR CX, CX
	MOV CL, POCET
	SUB CX, 1
	MOV BX, OFFSET USPOR

OPAKUJ2:			;vnutorny cyklus
	CMP [BX], 32768
	JB KL
	CMP [BX+2], 32767
	JA ROV         
	ADD BX, 2
	LOOPNE OPAKUJ2
	SUB CISLO,1
	CMP CISLO, 0
	JNE OPAKUJ
	RET
	
KL:	CMP [BX+2], 32768	;ak je 2. kladne	
	JB ROV 
	PUSH DX
	MOV AX, [BX]		;ak nie vymenia sa
	MOV DX, [BX+2]
	MOV [BX], DX
	MOV [BX+2], AX
	POP DX
	ADD BX, 2
	LOOPNE OPAKUJ2
	SUB CISLO,1
	CMP CISLO, 0
	JNE OPAKUJ
	RET

ROV:	MOV DX, [BX+2]		;ak su rovnake 
	CMP [BX], DX		;porovnaju sa
	JA VYM			
	ADD BX, 2
	LOOPNE OPAKUJ2
	SUB CISLO,1
	CMP CISLO, 0
	JNE OPAKUJ
	RET

VYM:	PUSH DX			;vymena cisel
	MOV AX, [BX]
	MOV DX, [BX+2]
	MOV [BX], DX
	MOV [BX+2], AX
	POP DX
	ADD BX, 2
	LOOPNE OPAKUJ2
	SUB CISLO, 1
	CMP CISLO, 0
	JNE OP
	RET

OP:	JMP OPAKUJ

;-------------------------------------------------------------------
	
VYPISS:	PUSH BX			;ulozia sa registre
	PUSH CX
	PUSH DX
	XOR CX, CX
	CMP DX, 32767
	JA ZNS1			;ak je zaporne
ZNS2:	CMP AX, 10
	JB ZNSE
	MOV BX, 10
	XOR DX, DX
	DIV BX			;prevod do 10 sustavy
	ADD CX, 1
	PUSH DX			;ulozenie do zasobniku	
	JMP ZNS2

ZNSE:	PUSH AX			;ulozenie posled. znaku
	ADD CX, 1
	MOV POCETZN, CL
	MOV BX, HAND
	MOV DX, OFFSET CISLO
	MOV CX,1
ZNS3:	MOV AH, 40H
	POP CISLO
	ADD CISLO, 30H		;prevod na ASCCI kod
	INT 21H			;vypis
	DEC POCETZN
	CMP POCETZN, 0
	JNE ZNS3

	POP DX
	POP CX
	POP BX
	RET


ZNS1:	PUSH AX
	MOV AH, 40H
	MOV BX, HAND
	MOV DX, OFFSET MIN
	MOV CX, 1
	INT 21H			;vypis -
	POP AX
	NEG AX			;neracia AX
	XOR CX, CX
	JMP ZNS2
	
;----------------------------------------------------------------


CODE	ENDS
	END	START
;----------------------------------------------------------------------



;Program funguje spravne, ale ma niekolko obmedzeni:
;- najviac 99 cisel rozsahu -32 768 do 32767
;- na konci vstup suboru musi byt medzera
;- nasobenie vypisuje v rozsahu -32 768 do 32767
;- nema osetrenie suctu
;- pri nacitani poradia musia byt 2 cislice 
;
;
;Pouziva nasledujuce sluzby Dosu (prerusenie 21h)
;- 01h - nacitanie znaku
;- 02h - vypis znaku
;- 09h - vypis retazca
;
;Pouziva nasledujuce sluzby Biosu
;prerusenie 10h
; sluzba 03h - zmazanie obrazovky 
;
;-----------------------------------------------------------------------
