
;Zadanie c.1.
;Text zadania: 
;ZADANIE c.1
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) a podla ponkanho menu vykon  jednu z monost:
;A
;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX 
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zlava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukonc vykonvanie programu.

;Autor:  Michal Janciga  
;Termin odovzdania: 26.10.2000
;2.roc.,k.rok 2000/2001




ZAS SEGMENT STACK
    dw  256 dup(?)
ZAS ENDS
;---------------------------------------------------------
; Datovy segment

DATA SEGMENT
VSTUP  db 100
POCET  db 0
       db 100 dup(?)
NR     db 13
       db 10
VYSTUP db 103 dup(?)
ZADAJ  db 'Zadaj retazec:$'
MENUTEXT  db 13,10,'Vyber si funkciu:',13,10;
	  db '1.) vypis nezmeneny retazec',13,10;
	  db '2.) hladaj medzeru',13,10;
	  db '3.) hladaj znak s maximalnou hodnotou',13,10;
	  db '4.) vykonaj reverziu retazca',13,10;
	  db '5.) hladaj znak',13,10;
          db '6.) zarovnaj text zlava',13,10;
          db '7.) koniec programu',13,10;
          db 13,10,13,10,'Tvoja volba: $',13,10;
BEK    db 8
desiatky db 0
jednotky db 0
NR2    db 13
       db 10
       db '$'
MEDZERA db 13,10,'Prva medzera sa nachadza na pozicii cislo $'
HLADAJ db  13,10,'ktory znak chces hladat ? $',13,10;
NIEJE  db 13,10,'takyto znak sa v retazci nenachadza$',13,10
JETU    db 13,10,'pocet vyskytov hladaneho znaku $',13,10
RETAZEC  db 'Dlzka retazca je $'
MAXTEXT  db 13,10,'Znak ktory ma maximalnu hodnotu je $'
DATA ENDS
;---------------------------------------------------------------
; Kodovy segment

CODE SEGMENT
	assume CS:CODE, SS:ZAS, DS:DATA

START: mov AX,seg DATA
       mov DS,AX

       mov DX,offset ZADAJ          ; vypis zaciatocneho textu
       mov AH,09h
       INT 21h

       mov DX,offset VSTUP          ; nacitanie retazca
       mov AH,0Ah
       INT 21h

       mov BX,offset VYSTUP

MENU:  mov DX,offset MENUTEXT       ; vypis menu
       mov AH,09h
       INT 21h

       mov AH,01
       INT 21h          ; do AL da ASCII kod stlacenej klavesy

       mov DX,offset VSTUP
       add DX,2
       mov SI,DX
       xor CX,CX
       mov CL,POCET

      ; cmp AL,'6'
       ;je ZAROVNAJ
       cmp AL,'5'
       je VYSKYT
       cmp AL,'4'
       je REVERZ
       cmp AL,'3'
       je MAXHOD
       cmp AL,'2'
       je HLMEDZERU

NEZMENENY:                      ; vypise nezmeneny retazec
       xor AX,AX                ; vynuluje register AX
ZNOVA1: mov AL,[SI]             ; z registra SI nacita prvy prvy znak a
	mov [BX],AL             ; presunie ho do AL, a z AL do BX
	inc SI                  ; posunie ukazovatel na dalsi znak
	inc BX                  ; SI-v zdroji, BX v ciely
	loopne ZNOVA1           ; vrati sa na ZNOVA1 pokial neprejde
jmp VYTLAC                      ; cely retazec

HLMEDZERU:                      ;hlada v retazci prvu medzeru
       xor AX,AX                ;vynuluje AX


ZNOVA2: mov AL,[SI]            ;SI ukazuje na prvy znak,presun ho do AL
	cmp AL,20h             ;je to medzera ?
	jne DALEJ2             ;ak nie, skoc na DALEJ2
                               ;ak je pokracuj
	mov DX, offset MEDZERA ;do DX daj offsetovu cast adresy MEDZERA
        mov AH,09h             ;vypis retazec na obrazovku
        int 21h                ;prerusenie pre vypis

        xor DL,DL              ;vynuluj DL
        mov AL,BL              ;udaj z BL presun do AL
        sub AL,37h             ;pocita znaky v retazci
        cmp AL,39h

        mov DL,AL              ;hodnotu z AL daj do DL
        mov AH,02h             ;vytlac znak (por. cislo) na obrazovku
        int 21h                ;prerusenie pre vypis

;PREVOD:


        jmp RESTART           ;skoc na RESTART
DALEJ2: mov [BX],AL           ;znak uloz do BX (vystup)
	inc SI                ;posun ukazovatel na dalsi znak
	inc BX                ;to iste

	loopne ZNOVA2         ;kym neprejde celym retazcom
jmp RESTART

MAXHOD:                   ;hlada znak s maximalnou hodnotou
        xor AX,AX         ;vynuluje AX, a DX
        xor DX,DX         ;
        mov DX,00h        ;do DX da najmensiu hodnotu znaku v ascii tab.
ZNOVA3: mov AL,[SI]       ;SI ukazuje na prvy znak retazca
	cmp AL,DL         ;porovna znak ret. s hodnotou v DL
	jnb DALEJ3_1      ;ak je AL > DL skoci na navestie DALEJ3_1
        jmp DALEJ3        ;ak nie skoci na DALEJ3
DALEJ3_1:
        mov DL,AL         ;v DL bude priebezne max hodnota
        jmp DALEJ3        ;skoc na DALEJ3



DALEJ3: mov [BX],AL       ;znak z Al daj do BX
	inc SI            ;inkrementuj SI
	inc BX            ;            BX
	loopne ZNOVA3     ;slucka kym neprejde celym retazcom,hod v CX

jmp VYTLAC3               ;tu sa nachadza vystup na obrazovku

REVERZ:                   ;vykona rever retazca
	xor AX,AX         ;vynuluje AX
	add SI,CX         ;v SI je pocet prvkov retazca
	sub SI,1          ; SI ukazuje na posledny znak retazca (nie $)
ZNOVA4: mov AL,[SI]       ;znak na ktory ukazuje SI daj do AL
	mov [BX],AL       ;a z AL na BX- vystup
	dec SI            ; dekrementuj SI
	inc BX            ; inkrementuj BX
	loopne ZNOVA4     ;pokial neprejde celym retazcom
jmp VYTLAC                ;vystup na obrazovku

VYSKYT:
        xor AX,AX
        xor DX,DX
        ;xor BX,BX
        ;mov BX,CX
        ;xor CX,CX
        mov DX,offset HLADAJ
        mov AH,09h
        int 21h
        mov AH,01h
        int 21h
        xor DX,DX
        mov DL,AL
        xor AX,AX
ZNOVA5: mov AL,[SI]
        cmp AL,DL
        je  DALEJ5_1
        jmp DALEJ5

DALEJ5_1:

         inc CX
         jmp DALEJ5
DALEJ5: mov [BX],AL
	inc SI
	inc BX
	loopne ZNOVA5
jmp VYTLAC5

VYTLAC5:
        xor DX,DX           ;vynuluje register DX
        mov DX,offset JETU  ;do DX da offsetovu adresu textu JETU
        mov AH,09h          ;vytlaci text na obrazovku
        int 21h             ;prerusenie pre vypis
        xor DX,DX           ;vynuluje register DX
        mov DX,CX           ;pocet vyskytov v CX da do DX
        mov AH,02h          ;vypise znak na obrazovku
        int 21h             ;prerusenie pre vypis
        jmp RESTART5        ;skoc ma RESTART5

       cmp AL,'6'
       je ZAROVNAJ
ZAROVNAJ:                      ; zarovna text zlava
        xor AX,AX              ; vynuluje register AX
        xor DX,DX              ; vynuluje register DX
ZNOVA6: mov AL,[SI]            ; znak na ktory ukazuje SI dam do AL
	cmp AL,' '             ; AL porovnam s medzerou
	jne DALEJ6_1           ; ak nie je medzera skoc na DALEJ6_1
        inc SI                 ; ak je SI bude ukazovat na dalsi znak
       	jmp ZNOVA6             ; skoci na ZNOVA6

DALEJ6_1:

        ;mov AL,08h
        mov DL,AL              ; znak z AL da do DL
        mov AH,02h             ; vypise ho na obrazovku
        int 21h                ; prerusenie pre vypis
       ;mov DL,AL
       ; jmp DALEJ6
        ;mov [BX],AL
	;inc SI
	;inc BX
	loopne ZNOVA6          ; pokial neprejde celym retazcom
jmp RESTART5                   ; skoc na RESTART5


;VYTLAC6:                        ;vystup pre zarovnanie zlava
;        XOR DX,DX               ;vynuluje DX
 ;       mov DX,offset BEK       ;do DX daj segmentovu adresu BEK
  ;      mov AH,09h              ;vytlac BEK na obrazovku
   ;     int 21h                 ;prerusenie na vypis
   ;     XOR DX,DX               ;vynuluje DX

;        mov DL,AL               ;hodnotu z AL da do DL
 ;       mov AH,09h              ;vytlaci retazec na obrazovku
  ;      int 21h                 ;prerusenie na vypis
   ;     jmp RESTART5            ;skoc na navestie RESTART5

                                ;vystup pre hladanie max. hodnoty znaku
VYTLAC3:xor CX,CX               ;vynuluj CX
        mov CX,DX               ;hodnotu z DX daj do CX
        mov DX,offset MAXTEXT   ;do DX da offsetovu adresu MAXTEXT-u
        mov AH,09h              ;vytlac retazec na obrazovku
        int 21h                 ;prerusenie na vypis
        xor DX,DX               ;vynuluj DX
        mov DX,CX               ;hodnotu z CX (max znak) daj do DX
        mov AH,02h              ;vytlac znak na obrazovku
        int 21h                 ;prerusenie na vypis
        jmp RESTART5            ;skoc na RESTART5

VYTLAC: mov byte ptr [BX],13    ;vystup na obrazovku
	mov byte ptr [BX]+1,10
	mov byte ptr [BX]+2,'$'
	mov DX,offset NR
	mov AH,09h
	INT 21h


RESTART5:         ;nastavi kurzor na novy riadok
mov DX,offset NR2 ;do DX da offsetovu cast adresy NR2
mov AH,09h        ;vytlac na obrazovku
INT 21h           ;prerusenie pre vypis

RESTART:
mov AH,08
INT 21h          ; do AL da ASCII kod stlacenej klavesy ale neechuje ho

cmp AL,'7'       ; ak bolo stlacene '7' => koniec
je KONIEC

mov DX,offset NR2 ;ak bolo stlacene nieco ine
mov AH,09h        ;posunie kurzor na novy riadok
INT 21h           ;a skoci na zaciatok programu - na navestie START
jmp START         ;


KONIEC: mov AX,4C00h  ;prerusenie pre ukoncenie programu v DOS-e
	INT 21h
CODE ENDS            ;koniec kodoveho segmentu
     END START       ;koniec navestia START


; Zhodnotenie
; v programe nefunguju 2 funkcie
; zarovnanie , a hladanie znaku
; 

