; MARIAN KALMAR
; zadanie 2
; kruzok A 03

        DOSSEG
        .MODEL SMALL
        .STACK       200H
        .DATA

;Definovanie datoveho segmentu: vsetky hlasky a miesto v pamati pre retazce

QUERY   DB    13,10,'Zadaj vstupny subor: $'

VSTUP   DB    13                ;miesto v pamati, kde sa
POCET   DB    0                 ;nacita meno suboru, z ktoreho
FILE    DB    13 DUP (?)        ;sa nacitavaju cisla
OUT1    DB    'vzostup.out',0   ;vystup pre vzostupne usporiadanie
;OUT2    DB    'zostup.out',0    ;vystup pre zostupne usporiadanie
NR      DB    13,10,'$'         
                                ; vypis menu
MENU    DB      13,10
        DB      13,10,'0. Vypis cisiel'
        DB      13,10,'1. Suma cisiel  (s vypisom na obrayovku)'
        DB      13,10,'2. Usporiadanie cisiel vzostupne a ich zapis do suboru'
;        DB      13,10,'3. Usporiadanie cisiel zostupne a ich zapis do suboru'
        DB      13,10,'4. Delenie 2 cisiel (+ vypisat vysledku)'
        DB      13,10,'5. Nasobenie 2 cisiel (+ vypis vysledku)'
        DB      13,10,'6. Koniec',13,10, '$'

OF      DB      13,10,'Chyba, pretecenie ! - Zadaj cisla znovu',13,10,'$'
SUM     DB      13,10,'Suma: $'
ZERDIV  DB      13,10,'delilo sa nulou - Zadaj cisla znovu.$'
NOFILE  DB      13,10,'Zadany subor neexistuje.',13,10,'$'
CISLA   DB      13,10,'Zadaj indexy cisiel, ktore sa maju $'
VIAC    DB      13,10,'Zadane cislo je vacsie ako je pocet nacitanych cisel.$'
WARNING DB      13,10,'Sucin je prilis velky - zadaj ine cisla$'
DELIT   DB      'Vydelit: $'
NASOBIT DB      'Vynasobit: $'
VYSLED  DB      13,10,'Vysledok: $'
ZOSTAT  DB      13,10,'Zvysok: $'

VSTUPX  DB      10              ;nacitanie stringu,
        DB      0               ;obsahujuceho 2 cisla, ktore sa
NMBRS   DB      10 DUP (0)      ;maju vydelit alebo vynasobit

CISLAX  DB      2 DUP (?)       ;miesto pre nacitane 2-och cisiel v binarnom tvare
POCET1  DB      200             ;pocet bytov, ktore sa maju nacitat zo vstupneho subora
NUMBERS DB      200 DUP (0)     ;tu sa nacita obsah suboru
BINARY  DW      100 DUP (0)     ;sem sa nacitaju cisla zapisu v binarnom doplnkovom kode
FINAL   DW      100 DUP (0)     ;tu sa urobi kopia nacitanych cisel, aby sa s nimi mohlo pracovat

OUTWR   DB      200 DUP (0)     ;sem sa zapise string, ktory obsahuje vystupne cisla - ma sa zapisat do vystupneho subora

PROD    DB      4 DUP (?)       ;Sem sa zapise vysledok nasobenia
COUNT   DB      0               ;pocet nacitanych cisel - realny pocet
CURRENT DW      0               ;tuto sa uschovava poradove cislo momentalneho cisla - pouziva sa v niektorych funkciach
SIGNS   DW      0               ;tu sa uchova kolko znakov bolo nacitanych, aby sa tolko rovnako potom mohlo aj vypisat do subora
HIN     DW      0               ;toto su handle cisla
HOUT1   DW      0               ;troch pouzivanych
HOUT2   DW      0               ;suborov

;Kod programu

        .CODE

;Procedura, ktora precita kolko znakov bolo nacitanych

COUNTER PROC    NEAR
        MOV SI,OFFSET NUMBERS	; do SI nacita OFFSET NUMBERS
        XOR CX,CX		; nulovanie CX

GETTER: MOV AX,[SI]		
        CMP AX,0                ; ak je koniec, skok na GOODX
        JE GOODX

        INC SI
        INC CX
        JMP GETTER

GOODX:  MOV BX,OFFSET SIGNS	; ulozenie poctu znakov do SIGNS
        MOV [BX],CX
        RET
        ENDP

;Procedura, ktora urobi kopiu cisel v BINARY do FINAL

COPY    PROC    NEAR
        MOV SI,OFFSET BINARY
        MOV DI,OFFSET FINAL
        MOV CX,100
ZING1:  MOV word ptr [DI],00H	; vynulovanie FINAL
        INC DI
        LOOP ZING1
        MOV DI,OFFSET FINAL
        XOR CX,CX
        MOV CL,COUNT		; do CL sa nacita pocet cisel

AGAIN:  MOV AX,[SI]		; kopirovanie BINARY -> FINAL
        MOV [DI],AX
        ADD SI,2
        ADD DI,2
        LOOP AGAIN

        RET
        ENDP

;Procedura, ktora vypise cislo, ktore sa nachadza v BX, na obrazovku

WRTNMBR PROC    NEAR
	PUSH AX		; zachovanie registrov AX, BX, CX, DX
	PUSH BX
	PUSH CX
	PUSH DX
        MOV AX,BX       ; cislo, ktore sa ma vypisat bolo v BX
        XOR DX,DX
        XOR CX,CX
        MOV BX,10
        CMP AX,8000H	
        JB DVIS         ; AX < 8000h => je kladne (2**15, ak je > tak je znamienkovy bit = 1)
        PUSH AX
        MOV AH,02H	; AX je zaporne
        MOV DL,2DH	; vypise sa znak -
        INT 21H
        POP AX          ;obnovenie Push-nutej hodnoty AX
        NEG AX		; znegujem AX na kladne cislo
        MOV DX,00H

DVIS:   DIV BX          ;tento segment programu z kazdej cislice 
        PUSH DX		;urobi ascii znak a da ho do stack-u
        MOV DX,00H
        INC CX
        CMP AX,0
        JNZ DVIS
        MOV AH,02H	; vypis jedneho znaku

POPER:  POP DX          ;tento segment programu kazdu cislicu vyberie 
        ADD DL,30H	;zo stacku a vypise na obrazovku
        INT 21H
        LOOP POPER
	POP DX          ; obnovenie povodnych hodnot registrov
	POP CX		; AX, BX, CX, DX
	POP BX
	POP AX
        RET             ;navrat 
        ENDP

;Procedura, ktora pretransformuje cisla v pamati FINAL na ASCII kody

TRANSF  PROC    NEAR
        MOV SI,OFFSET FINAL
        MOV DI,OFFSET OUTWR
NEXT:   MOV AX,[SI]
        XOR CX,CX
        XOR BX,BX
        XOR DX,DX
        MOV BX,10
        CMP AX,8000H		; je cislo kladne?
        JB DIVIS		; ano -> skok na DIVIS
        MOV byte ptr [DI], '-'	; nie -> do stringu sa vlozi znak -
        INC DI
        NEG AX			; a cislo sa zneguje na kladne

DIVIS:  DIV BX          ;tento segment programu z kazdej cislice 
        PUSH DX		;urobi ascii znak a da ho do stack-u
        INC CX
        MOV DX,00H
        CMP AX,0
        JNZ DIVIS

POPPER: POP DX          ;tento segment programu kazdu cislicu vyberie 
        ADD DL,30H	;zo stacku a da do pamati OUTWR
        MOV [DI],DL
        INC DI
        LOOP POPPER

        ADD SI,2
        INC DI
        MOV BX,OFFSET CURRENT
        MOV CL,[BX]
        INC CL
        MOV [BX],CL
        CMP CL,COUNT		; proces opakujeme az kym nie su vypisane
        JNE NEXT		; vsetky cisla

        MOV SI,OFFSET CURRENT
        MOV word ptr [SI],00H
        RET
        ENDP

;Tato procedura vypise nacitane cisla na obrazovku

MENU0   PROC    NEAR
        MOV AH,09H         	; odriadkovanie
        MOV DX,OFFSET NR
        INT 21H
        MOV AH,40H              ; vypis cisiel 
        MOV BX,01		; standardny handle obrazovky
        MOV CX,SIGNS		; SIGNS = pocet nacitanych znakov zo vstupu
        MOV DX,OFFSET NUMBERS
        INT 21H
        RET
        ENDP

;Tato procedura vypocita sumu vsetkych nacitanych cisel

MENU1   PROC    NEAR
        XOR AX,AX
        XOR CX,CX
        MOV CL,COUNT		; v CL je pocet cisel
        MOV BX,OFFSET BINARY

EVAL:   ADD AX,[BX]
        JO OVER1	; ak nastalo pretecenie, skoc

        ADD BX,2	
        LOOP EVAL       ;dekrementuj, porovnaj s 0 a ak =! 0 skoc
        MOV BX,AX

	PUSH AX
	
        MOV DX,OFFSET SUM	; vypis stringu SUM
        MOV AH,09H
        INT 21H

	POP AX
	MOV BX, AX		; vypis sumy
        CALL WRTNMBR		; vypise cislo v BX
        JMP XXX

OVER1:  MOV AH,09H
        MOV DX,OFFSET OF	; vypis ERRORU pretecenie
        INT 21H

XXX:    RET
        ENDP

;Tato procedura usporiada cisla vzostupne a zapise ich do subora

MENU2   PROC    NEAR
        CALL COPY
        MOV CX,200
        MOV SI,OFFSET OUTWR
ZING2:  MOV byte ptr [SI],00H		; vynulovanie OUTWR
        INC SI
        LOOP ZING2
AGAIN1: XOR DI,DI			
        XOR CX,CX
        XOR BX,BX
        MOV CL,COUNT
        SUB CL,1
        MOV SI,OFFSET FINAL

MORE:   MOV AX,[SI]                     ; zoradenie od najvacsieho cisla
        ADD SI,2			; po najmensie
        CMP AX,[SI]
        JLE COOL1
        MOV DX,AX
        MOV AX,[SI]
        MOV [SI],DX
        MOV [SI-2],AX
        INC DI             ;v DI sa urcuje ci bola urobena aspon jedna zmena
COOL1:  INC BL             ;v BX sa nachadza pocet porovnavani
        CMP BL,CL
        JNE MORE

        CMP DI,0
        JNE AGAIN1

        CALL TRANSF

        MOV AH,3CH
        MOV CX,00H
        MOV DX,OFFSET OUT1
        INT 21H

        MOV SI,OFFSET HOUT1
        MOV [SI],AX

        MOV BX,AX
        MOV AH,40H
        MOV CX,SIGNS
        MOV DX,OFFSET OUTWR
        INT 21H

        MOV AH,3EH
        MOV BX,HOUT1
        INT 21H

        RET
        ENDP

;Tato procedura usporiada cisla zostupne a zapise ich do subora

;MENU3   PROC    NEAR
;        CALL COPY
;        MOV CX,200
;        MOV SI,OFFSET OUTWR
;ZING3:  MOV byte ptr [SI],00H
;        INC SI
;        LOOP ZING3
;AGAIN2: XOR DI,DI
;        XOR CX,CX
;        XOR BX,BX
;        MOV CL,COUNT
;        SUB CL,1
;        MOV SI,OFFSET FINAL

;MOREX:  MOV AX,[SI]
;        ADD SI,2
;        CMP AX,[SI]
;        JGE COOL2
;        MOV DX,AX
;        MOV AX,[SI]
;        MOV [SI],DX
;        MOV [SI-2],AX
;        INC DI             ;v DI sa urcuje ci bola urobena aspon jedna zmena
;COOL2:  INC BL             ;v BX sa nachadza pocet porovnavani
;        CMP BL,CL
;        JNE MOREX
;
;        CMP DI,0
;        JNE AGAIN2
;
;        CALL TRANSF
;
;        MOV AH,3CH
;        MOV CX,00H
;        MOV DX,OFFSET OUT2
;        INT 21H

;        MOV SI,OFFSET HOUT2
;        MOV [SI],AX

;        MOV BX,AX
;        MOV AH,40H
;        MOV CX,SIGNS
;        MOV DX,OFFSET OUTWR
;        INT 21H
;
;        MOV AH,3EH
;        MOV BX,HOUT2
;        INT 21H

;        RET
;        ENDP

;Tato procedura vydeli 2 cisla a vypise vysledok a zostatok na obrazovku

MENU4   PROC    NEAR
        MOV AH,09H
        MOV DX,OFFSET CISLA
        INT 21H

        MOV AH,09H
        MOV DX,OFFSET DELIT
        INT 21H

        MOV AH,0AH
        MOV DX,OFFSET VSTUPX
        INT 21H

        MOV SI,OFFSET NMBRS
        MOV DI,OFFSET CISLAX
        XOR DX,DX
        PUSH DX
        XOR CX,CX
        XOR AX,AX
        XOR BX,BX
        MOV BP,10

READX:  MOV AX,BX
        MUL BP
        MOV BX,AX
        XOR AX,AX
        MOV AL,[SI]
        CMP AX,20H
        JE OKX
        CMP AX,13
        JE OKX
        SUB AX,30H
        ADD BX,AX
        POP DX
        PUSH BX
        INC SI
        JMP READX

OKX:    POP AX
        MOV [DI],AL
        INC SI
        INC DI
        INC CX
        CMP CX,2
        JE NACIT
        XOR DX,DX
        XOR AX,AX
        XOR BX,BX
        PUSH BX         ;Aby sa nenarusili hodnoty CS:IP v stacku 
        JMP READX	;(ked budem robit RET)

NACIT:  MOV BP,2
        XOR BX,BX
        XOR CX,CX
        MOV SI,OFFSET CISLAX
YYY:    MOV DI,OFFSET BINARY
        XOR AX,AX
        MOV AL,[SI]
        SUB AL,1
        PUSH CX
        MOV CL,COUNT
        CMP AL,CL
        JB MENEJ
        MOV AH,09H
        MOV DX,OFFSET VIAC
        INT 21H
        JMP COOLZ
MENEJ:  POP CX
        MUL BP
        ADD DI,AX
        MOV AX,[DI]
        INC SI
        INC CX
        CMP CX,2
        JE YES
        MOV BX,AX
        JMP YYY

YES:    CMP AX,0
        JE DIVZERO
        XOR DI,DI
        MOV CX,AX
        MOV AX,BX
        MOV BX,CX
        CMP AX,7FFFH
        JA NGTV
COOLXY: IDIV BX
        MOV BX,AX               ;v BX a CX si ulozim vysledok
        MOV CX,DX               ;a zostatok po deleni
        JMP OKXY

NGTV:   MOV DX,0FFFFH
        JMP COOLXY

OKXY:   MOV AH,09H
        MOV DX,OFFSET VYSLED
        INT 21H

DONT:   PUSH CX
        CALL WRTNMBR

        MOV AH,09H
        MOV DX,OFFSET ZOSTAT
        INT 21H

        POP BX

        CALL WRTNMBR
        JMP COOLZ

DIVZERO:
        MOV AH,09H
        MOV DX,OFFSET ZERDIV		; delenie nulou
        INT 21H

COOLZ:  RET
        ENDP

;Tato procedura vynasobi 2 cisla a vypise vysledok na obrazovku

MENU5   PROC    NEAR
        MOV AH,09H
        MOV DX,OFFSET CISLA
        INT 21H

        MOV AH,09H
        MOV DX,OFFSET NASOBIT
        INT 21H

        MOV AH,0AH
        MOV DX,OFFSET VSTUPX
        INT 21H

        MOV SI,OFFSET NMBRS
        MOV DI,OFFSET CISLAX
        XOR DX,DX
        PUSH DX
        XOR CX,CX
        XOR AX,AX
        XOR BX,BX
        MOV BP,10

READY:  MOV AX,BX		
        MUL BP                 	; AX = AX * BP
        MOV BX,AX
        XOR AX,AX
        MOV AL,[SI]
        CMP AX,20H		; ak je v AX  medzera, skoc
        JE OKZY
        CMP AX,13		; ak je v AX  enter, skoc
        JE OKZY
        SUB AX,30H		
        ADD BX,AX
        POP DX
        PUSH BX
        INC SI
        JMP READY

OKZY:   POP AX
        MOV [DI],AL
        INC SI
        INC DI
        INC CX
        CMP CX,2
        JE NACITY
        XOR DX,DX
        XOR AX,AX
        XOR BX,BX
        PUSH BX         ;Aby sa nenarusili hodnoty CS:IP v stacku (ked budem robit RET)
        JMP READY

NACITY: MOV BP,2
        XOR BX,BX
        XOR CX,CX
        MOV SI,OFFSET CISLAX
YYYY:   MOV DI,OFFSET BINARY
        XOR AX,AX
        MOV AL,[SI]
        SUB AL,1
        PUSH CX
        MOV CL,COUNT
        CMP AL,CL
        JB MENEJY
        MOV AH,09H
        MOV DX,OFFSET VIAC
        INT 21H
        JMP COOLYY
MENEJY: POP CX
        MUL BP
        ADD DI,AX
        MOV AX,[DI]
        INC SI
        INC CX
        CMP CX,2
        JE YESY
        MOV BX,AX
        JMP YYYY

YESY:   XOR DI,DI
        XOR DX,DX
        IMUL BX
        JNO NOPROB
        INC DI

NOPROB: MOV BX,AX

        CMP DX,0
        JE NOWARNX
        CMP DX,0FFFFH
        JE NOWARNX

WARNX:  MOV AH,09H
        MOV DX,OFFSET WARNING		; prilis velky sucin
        INT 21H
        JMP COOLYY

NOWARNX:
        CMP DI,1
        JE WARNX
        MOV AH,09H
        MOV DX,OFFSET VYSLED
        INT 21H

        CALL WRTNMBR

COOLYY: RET
        ENDP


;-------------------------------------------------------------------------

START:  MOV AX,@DATA
        MOV DS,AX
        MOV DX,OFFSET QUERY
        MOV AH,09H
        INT 21H

        MOV DX,OFFSET VSTUP     ;tato cast nacita meno subora
        MOV AH,0AH
        INT 21H
        MOV BX,OFFSET FILE
        XOR CX,CX
        MOV CL,POCET
        ADD BX,CX
        MOV byte ptr [BX],00H

        MOV DX,OFFSET NR
        MOV AH,09H
        INT 21H

        MOV DX,OFFSET FILE      ;otvori vstupny subor
        MOV AX,3D20H
        INT 21H
        JNC OKOPEN
        PUSH AX
        MOV AH,09H
        MOV DX,OFFSET NOFILE
        INT 21H
        POP AX
        JMP EXIT

OKOPEN: MOV SI,OFFSET HIN
        MOV [SI],AX

        XOR CX,CX
        MOV BX,AX               ;toto nacita cisla zo suboru na offset numbers
        MOV AH,3FH
        MOV CL,POCET1
        MOV DX,OFFSET NUMBERS
        INT 21H

        MOV DI,OFFSET NUMBERS
        ADD DI,AX
        MOV byte ptr [DI],00H

;mam nacitane vsetky cisla na offsetu numbers

        MOV SI,OFFSET NUMBERS
        XOR CX,CX
        XOR BX,BX
        MOV BP,10
        XOR AX,AX
        XOR DI,DI
        PUSH CX

READNMBR:
        MOV AX,BX
        MUL BP
        MOV BX,AX
        XOR AX,AX
        MOV AL,[SI]
        CMP AL,20H		; ak bol nacitany znak medzery
        JE CELE
        CMP AL,00H		; ak bol nacitany znak EOF
        JE KONIEC
        CMP AL,2DH		; ak bol nacitany znak -
        JE NEGATIVE
	;
	CMP AL, '9'		; ak je znak mimo rozsahu cislic 0 - 9
	JA KONIEC
	CMP AL, '0'
	JB KONIEC
	;
        SUB AL,30H		; v AL bude cislo v desiatkovej sustave
        ADD BX,AX
        CMP BX,8000H		
        JA OVER
        JE TST
OK1:    CMP DX,0000H
        JE OK
OVER:   MOV AH,09H
        MOV DX,OFFSET OF        ; pretecenie
        INT 21H
        JMP EXIT
TST:    CMP DI,1
        JE OK1
        JNE OVER

OK:     POP DX
        PUSH BX
        INC SI
        JMP READNMBR		; cislo nacitane, ulozene, citam dalsie

NEGATIVE:
        XOR DI,DI
        INC DI
        INC SI
        JMP READNMBR

CELE:
        MOV BX,OFFSET BINARY	; v stacku su cislice cisla
        ADD BX,CX
        POP DX
        CMP DI,1                ; ak je DI = 1 cislo je zaporne
        JNE POZ			
        NEG DX
POZ:
        MOV [BX],DX
        PUSH DX
        XOR DI,DI
        XOR BX,BX
        XOR AX,AX
SPACE:  INC SI
        CMP byte ptr [SI],20H
        JE SPACE
        ADD CX,2
        JMP READNMBR

KONIEC:
	SUB CX, 2	; zistenie skutocneho poctu cisel
        MOV AX,CX
        XOR CX,CX
        MOV CL,2
        DIV CL
        INC AL
        MOV BX,OFFSET COUNT	; pocet cisel bude ulozeny v COUNT
        MOV [BX],AL

        MOV AH,3EH
        MOV BX,OFFSET HIN
        INT 21H
        CALL COUNTER

MENUX:  MOV DX,OFFSET MENU      ;tato cast vypise menu
        MOV AH,09H
        INT 21H


;nasledovna cast kodu testuje volbu z menu

VNES:   MOV AH,08H
        INT 21H

        CMP AL,20H
        JE MENUX
        CMP AL,'0'
        JE MN0
        JB VNES
        CMP AL,'1'
        JE MN1
        CMP AL,'2'
        JE MN2
       ; CMP AL,'3'
       ; JE MN3
        CMP AL,'4'
        JE MN4
        CMP AL,'5'
        JE MN5
        CMP AL,'6'
        JE EXIT
        JA VNES

;nasledovna cast v zavislosti od volby, vola prislusne procedury

MN0:
        CALL MENU0
        JMP VNES

MN1:
        CALL MENU1
        JMP VNES

MN2:
        CALL MENU2
        JMP VNES

;MN3:
;        CALL MENU3
;        JMP VNES

MN4:
        CALL MENU0
        CALL MENU4
        JMP VNES

MN5:
        CALL MENU0
        CALL MENU5
        JMP VNES


EXIT:   MOV AX,4C00H    ;koniec
        INT 21H
        END START
