;*** ZADANIE 1 ****  
ZAS     SEGMENT STACK
        DW      100 DUP(?)
ZAS     ENDS

;*******************************************************************

DATA    SEGMENT
POCET   DB 100 DUP(?)
RETAZ   DB 101 DUP('$')
NR     db 13
       db 10
MENU_TEXT DB    13,10,10,'*** Vyber si z nasledujucich moznosti ***'
        DB      13,10,'1.Vypise retazec na obrazovku',13,10
        DB      '2.Vypise pocet cislic v retazci',13,10
        DB      '3.Zisti znak zadany uzivatelom',13,10
        DB      '4.Vypise znak s min.hodnotou',13,10
        DB      '5.Konvertuje male pismena na velke',13,10
        DB      '6.Zarovna text zprava',13,10
        DB      '7.Ukonci program',13,10,'$'
NENASIEL  DB    'Nenasiel som medzeru!!!','$',13,10      
POC_CIS DB      'Pocet cislic v retazci je:','$'
ZADAJ_ZNAK  DB  'Zadaj znak:','$'
NENACHADZA  DB  10,13,'Zadany znak sa v retazci nenachadza !','$'
VYSKYT  DB      10,13,'Miesta vyskytu znaku: ','$'
DATA    ENDS

;*******************************************************************

CODE    SEGMENT
        ASSUME CS:CODE,DS:DATA,SS:ZAS

;*******************************************************************

;Podprogram vypisu cisla na obrazovku
;vstup cisla v ax
VYP_CIS PROC    NEAR 

        PUSH    BX                      ;odlozenie pouzivanych registrov
        PUSH    DX

        MOV     BL,100
        DIV     BL                      ;AL - stovky, AH - zvysok
        PUSH    AX                      ;odlozenie vysledku
        CMP     AL,0                    ;ak AL = 0, stovky sa nevypisu
        JE      VYP2

        MOV     DL,AL
        ADD     DL,30h                  ;konverzia stoviek na znak
        MOV     AH,2
        INT     21H                     ;vypis stoviek
VYP2:   POP     AX                      ;vratenie vysledku
        MOV     AL,AH
        MOV     AH,0

        CMP     AL,10                   ;ak je poradie mensie nez 10
        JNL     VYP3                    ;vypisu sa len jednotky
        MOV     AH,AL
        JMP     VYP4

vyp3:   MOV     BL,10                   ;zistovanie desiatok
        DIV     BL
        PUSH    AX                      ;al - desiatky, ah - jednotky 
        MOV     DL,AL
        ADD     DL,30H
        MOV     AH,2
        INT     21H                     ;vypis desiatok

        POP     AX
vyp4:   MOV     DL,AH                  ;zvysok su jednotky
        ADD     DL,30H
        MOV     AH,2
        INT     21H                     ;vypis jednotiek

        POP     DX                      ;vratenie odlozenych registrov
        POP     BX

        RET

        ENDP    VYP_CIS

;*******************************************************************

START:
;*******************************************************************

        MOV AX,SEG DATA
        MOV DS,AX
        MOV CL,0
        MOV BX,OFFSET RETAZ              ;nastavenie sa na zaciatok retazca
        MOV DI,[BX]

ULOZ:   MOV AH,8                         ;caka na stlacenie klavesy
        INT 21H
        CMP AL,0                         ;ak sa jedna o rozsireny kod
        JNE ULOZ1                        ;ignorujeme ho
        INT 21H                          ;vybratie rozsireneho kodu
        JMP ULOZ                         ;navrat na zadavanie

ULOZ1:  CMP AL,13                        ;je to Enter?                              
        JE  MENU                         ;ak ano ,koniec zadavania
        MOV [BX],AL                      ;ulozenie znaku
        INC BX                           ;posun na dalsie miesto v retazci
        MOV DL,AL
        MOV AH,2
        INT 21H                          ;vypis znaku na obrazovku
        INC CL                           ;zvysenie poctu znakov
        CMP CL,100                       ;ak je pocet =100
        JE  MENU                         ;skok do menu
        JMP ULOZ                         ;skok na uloz

MENU:
        MOV AH,9
        MOV DX,OFFSET MENU_TEXT          ;vypise menu na obrazovku
        INT 21H


KLAV:   MOV AH,8                         ;caka na stlacenu klavesu
        INT 21H

        CMP AL,0                         ;ak je rozsireny kod,precita sa
        JNE KLAV1                        ;ale sa nespracuje
        INT 21H
        JMP KLAV
                                         ;zistenie volby,co sa bude vykonavat
KLAV1:  CMP AL,'1'
        JE VYPIS

        CMP AL,'2'
        JE POM

        CMP AL,'3'
        JE ZISTI_ZNAK
        
        CMP AL,'5'
        JE KONVERT
        
KLAV3:  CMP AL,'7'
        JE POM1
        


VYPIS:  MOV DX,OFFSET RETAZ               ;vypis retazca na obrazovku
        MOV AH,9
        INT 21H
        JMP MENU

;*******************************************************************

;VYSKYT ZADANEHO ZNAKU

;*******************************************************************

ZISTI_ZNAK:
D:      MOV     DX,OFFSET ZADAJ_ZNAK         ;vypis retazca "Zadaj znak :"
        MOV     AH,9
        INT     21H
        MOV     AH,1                    ;zadanie znaku
        INT     21H
        MOV     CH,AL                   ;odlozenie zadaneho znaku

        MOV     BX,0                    ;pozicia znaku v retazci
        MOV     CL,0                    ;pocet vypisanych cisel
        MOV     SI,OFFSET RETAZ         ;nastavenie na zaciatok retazca

D1:     CMP     byte ptr ds:[SI+BX],'$' ;kontrola konca retazca
        JE      D_K
        CMP     CH,byte ptr [SI+BX]     ;porovnanie zadaneho a nacitaneho znaku
        JE      D0
        INC     BX                      ;nastavenie na dalsi znak
        JMP     D1

D0:     INC     BX                      ;nastavenie na dalsi znak
        INC     CL                      ;zvysenie poctu vypisov
        CMP     CL,1                    ;ak je to prvy vypis,
        JNE     D2                      ;vypise sa retazec:
        MOV     DX,OFFSET VYSKYT        ;"Miesta vyskytu znaku :"
        MOV     AH,9
        INT     21H
D2:     MOV     AX,BX                   ;vypis cisla
        CALL    VYP_CIS
        MOV     DL,' '                  ;vypis medzery kvoli oddeleniu cisel
        MOV     AH,2
        INT     21H
        JMP     D1                      ;opakovanie

D_K:    CMP     CL,0                    ;Ak sa znak v retazci nenachadza,
        JE      D3                      ;vypise sa o tom oznam
        JMP     MENU

D3:     MOV     DX,OFFSET NENACHADZA    ;"Znak sa v retazci nenachadza"
        MOV     AH,9
        INT     21H
        JMP     MENU                    ;navrat do menu

POM: JMP CISLICE
;*******************************************************************

KONVERT:
        
        ADD DX,2
        MOV SI,DI
        MOV BX,OFFSET RETAZ
        XOR AX,AX

OPAK:
        MOV AL,[BX]
        CMP AL,60H
        JBE DALEJ
        CMP AL,7BH
        JNB DALEJ
        SUB AL,20H
        

DALEJ:  MOV [BX],AL
        INC BX
        INC SI
        LOOPNE OPAK

VYPISK: MOV DX,OFFSET RETAZ               ;vypis retazca na obrazovku
        MOV AH,9
        INT 21H
        jmp menu


POM1: JMP KONIEC
;*******************************************************************

;SPOCITANIE CISLIC

;*******************************************************************

CISLICE:
        MOV     BX,OFFSET RETAZ         ;zaciatok retazca
        MOV     CL,0                    ;vynulovanie poctu cislic
C0:     CMP     byte ptr [bx],'$'       ;kontrola konca retazca
        JE      KONIEC0
        CMP     byte ptr [bx],'9'       ;kontrola, ci je znak cislom
        JG      C1                      ;ak je znak > 9, chod dalej
        CMP     byte ptr [bx],'0'
        JL      C1                    ;to iste, ak znak < 0
        INC     CL

C1:     INC     BX                      ;posun na dalsi znak
        JMP     C0

KONIEC0:
        MOV     DX,OFFSET POC_CIS       ;"Pocet cislic v retazci:"
        MOV     AH,9
        INT     21H
        MOV     AL,CL
        MOV     AH,0
        CAll    VYP_CIS                 ;vypis poctu na obrazovku

        JMP     MENU                    ;navrat do menu 

;*******************************************************************

KONIEC: MOV AX,4C00H                    ;ukoncenie programu
        INT 21H

CODE    ENDS                            ;ukoncenie segmentu
        END START
