;kompilacia: tasm /l /zi /c nazov.asm
;linkovanie: tlink /l /i /v nazov.obj

;ZADANIE c.2
;Vytvorte  program,  ktory  nacta  z  textovho sboru postupnost celych
;csel so znamienkom  v desiatkovej cselnej sstave (aspon 10), potom
;ich transformuje na csla v dvojkovej cselnej sstave v doplnkovom kde
;a potom podla priania uzvatela
;a) vypocta sumu  kladnych(zapornych) csel a vypise ju
;b) usporiada csla zostupne a zapse usporiadan postupnost csel
;   do novho textovho sboru,
;c) vydel dve vybran csla a vypise vysledok
;c) vynasobi dve posledne csla a vypise vysledok
;d) ukonc vykonvanie programu.
;Vysledky operci treba vypisovat v desiatkovej cselnej sstave.
;Ak by pri  vypocte sumy v pripade a)  doslo k preteceniu, oznamte prekrocenie
;ciselneho rozsahu
;Zdrojovy program mus byt PODROBNE OKOMENTOVANY!
;***********************************
;Zadanie c.1.
;Text zadania: Napiste program....
;Autor:           Zoltan Kostolny
;Termin odovzdania: 8.tyzden
;2.roc.,sk.rok 2000/2001
;***********************************

;***********************************************************************
;Zasobnik

zasob segment stack
	dw 100 dup(?)
zasob ends

;************************************************************************
;Definicie premennych

data    segment

udaje   db 255 dup(?)
cisla   dw 50 dup(0)    ;vyalokovanie 50 miest pre cisla
menu1	db 10,13,"1 - vypis sumy cisiel",10,13
	db "2 - usporiadanie zadanych cisel",10,13
	db "3 - vydelenie dvoch zadanych cisel",13,10
        db "4 - vynasobi dve cisla",13,10
        db "5 - ukonci program",13,10,10,'$'
vstup   db "zipi.txt",0
vystup	db "vystup.txt",0
ch_sub	db "Chyba pri otvarani suboru !",13,10,'$'
ch_cit	db "Chyba pri citani zo suboru !",13,10,'$'
ch_udaj	db "Chyba udajov !",13,10,'$'
sucet	db "Sucet cisel : ",'$'
pretec	db "Doslo k preteceniu !",13,10,'$'
poc_b   dw ?    ;pocet nacitanych bytov
poc_c	db 0	;pocet cisel
cislo1  db 0
cislo2  db 0
cislo	dw 0	;pomocne cislo pre konverziu
minus	db 0	;priznak znamienka
vymena	db 0	;priznak vymeny


data    ends

;************************************************************************
;Program

code    segment
assume  cs:code, ds:data, ss:zasob

;*************************************************************************
;Podprogram vypisu cisla na obrazovku
;vstup cisla v ax
;v bx je rukovet zariadenie (0 = standardny vystup, cize obrazovka)

vyp_cis	proc	near	

	push	dx			;odlozenie pouzivanych registrov
	push	cx
	push	di
	push	bx

	mov	cx,0			;pocet vypisovanych znakov
	mov	di,offset udaje		;znaky na vypis

	cmp	ax,0
	jge	vyp1			;ak je cislo zaporne
	mov	byte ptr [di],'-'	;vypise sa minus
	inc	di			;posun na dalsie miesto
	inc	cx			;zvysenie poctu znakov na vypisanie
	neg	ax			;zmena cisla na kladne

vyp1:	mov	bl,100
	div	bl			;AL - stovky, AH - zvysok
	cmp	al,0			;ak AL = 0, stovky sa nevypisu
	je	vyp2

	mov	dl,al
	add	dl,30h			;konverzia stoviek na znak
	mov	[di],dl			;vypise sa znak
	inc	di			;posun na dalsie miesto
	inc	cx			;zvysenie poctu znakov na vypisanie

vyp2:	mov	al,ah
	mov	ah,0

	cmp	al,10			;ak je poradie mensie nez 10
	jnl	vyp3			;vypisu sa len jednotky
	mov	ah,al
	jmp	vyp4

vyp3:	mov	bl,10			;zistovanie desiatok
	div	bl			;al - desiatky, ah - jednotky	
	mov	dl,al
	add	dl,30h
	
	mov	[di],dl			;vypise sa znak
	inc	di			;posun na dalsie miesto
	inc	cx			;zvysenie poctu znakov na vypisanie

vyp4:	mov	dl,ah			;zvysok su jednotky
	add	dl,30h

	mov	[di],dl			;vypise sa znak
	inc	di			;posun na dalsie miesto
	inc	cx			;zvysenie poctu znakov na vypisanie

	mov	byte ptr [di],' '	;medzera je kvoli vypisu do suboru
					;aby boli cisla od seba oddelene
	inc	cx

	pop	bx
	mov	dx,offset udaje		;vypis na obrazovku (alebo do subora)
	mov	ah,40h
	int	21h

	pop	di
	pop	cx
	pop	dx			;vratenie odlozenych registrov

	ret

	endp	vyp_cis

;****************************************************************************
;Podprogram pre zistenie, ci je znak cislo
;vstup znaku v bl
;ak znak nie je cislo, nastavi sa CARRY

jecislo	proc	near

	cmp	bl,'9'
	jle	jecis1
	stc			;nastavi CARRY
	jmp	je_kon
jecis1:	cmp	bl,'0'
	jge	jecis2
	stc
	jmp	je_kon
jecis2:	clc			;vynuluje CARRY
je_kon:	ret

	endp	jecislo

;****************************************************************************
;Hlavny program

;NACITANIE CISEL ZO SUBORA

start:  mov 	ax,seg data
        mov 	ds,ax
	mov	ax,3d00h		;otvorenie suboru pre citanie
	mov	dx,offset vstup
        int     21h
	jnc	st1			;ak je vsetko OK, chod dalej
	mov	dx,offset ch_sub
	mov	ah,9
	int	21h			;vypis chyboveho hlasenia
	jmp	koniec

st1:	mov	bx,ax			;rukovet suboru
	mov	dx,offset udaje		;pamet pre nacitane udaje
        mov     ah,3fh                  ;citanie zo suboru
        mov     cx,300                  ;pocet bytov na nacitanie
	int	21h
	jnc	st2			;vsetko OK - chod dalej
	mov	ah,9
	mov	dx,offset ch_cit
	int	21h			;chyba pri citani zo suboru
	jmp	koniec

st2:    mov     poc_b,ax                ;odlozenie poctu precitanych bytov
	mov	ah,3eh			;zatvorenie subora
	int	21h			;chyby pri zatvarani ignorujeme

;TRANSFORMACIA DO DVOJKOVEJ SUSTAVY

	mov	si,offset udaje		;nastavenie na zaciatok udajov
	mov	di,offset cisla		;pamet cisel
        mov     cx,1                    ;pocet spracovanych bytov
	mov	poc_c,0			;pocet transf. cisel
medz:	cmp	byte ptr [si],' '	;je aktualny znak medzera ?
	jne	konv1			;ak nie, chod dalej
	inc	si			;inac opakuj
	inc	cx
        cmp     cx,poc_b                ;ak su spracovane vsetky byty,
	je	konv_k			;koniec konverzie
	jmp	medz

;si ukazuje na zaciatok cisla

konv1:	mov	minus,0			;kladne cislo
	mov	bl,[si]
	call	jecislo			;je prvy znak cislo?
	jnc	konv2
	cmp	bl,'-'
	jne	konv3
	inc	si
	inc	cx
	mov	minus,1			;zaporne cislo
	jmp	konv2

konv3:	mov	dx,offset ch_udaj	;chyba udajov
	mov	ah,9
	int	21h
	jmp	koniec

konv2:	mov	bl,[si]
	call	jecislo
	jc	konv3
	
	mov	al,[si]
	sub	al,30h			;prevod znaku na cislo
	mov	ah,0
	mov	bh,0
	mov	dl,10

konv4:	inc	si
	inc	cx
	cmp	byte ptr [si],' '	;ak je dalsi znak medzera, koniec konverzie
	je	konv_k
        cmp     cx,poc_b                ;ak su spracovane vsetky byty,
	jge	menu			;koniec konverzie
	mov	bl,[si]
	call	jecislo
	jc	konv3
	imul	dl			;vynasobi al*10
	sub	bl,30h			;prevod znaku na cislo
	add	ax,bx			;pripocita bl
        cmp     ax,127                ;kontrola rozsahu cisla
	jg	konv3
	jmp	konv4			;pokracuj s dalsim znakom

konv_k: cmp	minus,1			;je to zaporne cislo?
	je	znam
ul_cis:	mov	[di],al			;ulozenie transformovaneho cisla
	inc	di
	inc	poc_c			;zvysenie poctu cisel
        cmp     cx,poc_b
	jge	menu			;ak sme presli vsetky nacitane byty
					;ideme na menu
	jmp	medz			;inac ideme na dalsie cislo

znam:	neg	al			;dvojkovy doplnok
	jmp	ul_cis			;ulozenie cisla a pokracovanie


;cisla su v poli CISLA a ich pocet je v POC_C
         mov  dx,offset udaje
         mov ah,9
         int 21h
;MENU

menu:   mov	ah,9
	mov	dx,offset menu1
	int	21h			;vypis menu na obrazovku

klav:	mov	ah,8
	int	21h			;cakanie na klavesu

	cmp	al,0			;ak je rozsireny kod, precita sa
	jne	klav1			;ale nespracuje
	int	21h
	jmp	klav

klav1:	cmp	al,'1'			;zistenie, co sa ma spravit
        je      scit_zac
	cmp	al,'2'
        je      usp
klav3:  cmp     al,'3'
	jne	klav2
	jmp	koniec
klav2:	jmp	klav

;SCITANIE CISEL

scit_zac:   mov     si,offset cisla         ;nastavenie na zaciatok cisel
	mov	cl,poc_c		;pocet cisel
	mov	ch,0
	mov	bx,0			;sucet
	mov	ah,0
scit1:  mov     al,byte ptr [si]        ;cislo
	cbw				;prevod na word
	add	bx,ax			;postupne pripocitavanie
	inc	si
        loop    scit1                    ;opakuj cx-krat

	mov	ax,bx
        cmp     ax,127                  ;kontrola pretecenia
        jg      scit2
        jmp     scit3
        cmp     ax,-128
        jl      scit2
        jmp     scit3

scit2:    mov     dx,offset pretec        ;"Doslo k preteceniu"
	mov	ah,9
	int	21h
	jmp	menu

scit3:    push    ax

	mov	dx,offset sucet		;"Sucet cisel :"
	mov	ah,9
	int	21h

	pop	ax
	mov	bx,0			;vypis na obrazovku (standardny vystup)
	call	vyp_cis			;Vypis cisla na obr.
	jmp	menu

;USPORIADANIE PODLA VELKOSTI (bublesort)

usp:    mov     vymena,0                ;nulovanie priznaku vymeny
	mov	si,offset cisla		;nastavenie na zaciatok cisel
	mov	cl,poc_c		;pocet cisel
	mov	ch,0
	dec	cx			;porovnani je o jedno menej ako cisel
usp0:   mov     al,byte ptr [si]
	cmp	al,byte ptr [si+1]	;porovnanie dvoch po sebe iducich cisel
        jge     usp1     
	mov	ah,byte ptr [si+1]	;ak je prve vecsie, tak sa vymenia
	mov	byte ptr [si],ah
	mov	byte ptr [si+1],al
	mov	vymena,1
usp1:   inc     si                      ;nastavenie na dalsie cislo
        loop    usp0                    ;opakuj pre vsetky cisla
	cmp	vymena,0
        jne     usp                     ;opakuj, kym dochadza k vymene

;zapis do suboru

	mov	ah,3ch			;otvorenie vystupneho suboru
	mov	dx,offset vystup
	mov	cx,0
	int	21h
        jnc     usp2
	mov	dx,offset ch_sub	;Chyba pri praci so suborom
	mov	ah,9
	int	21h
	jmp	koniec

usp2:   mov     bx,ax                   ;rukovet suboru
	mov	cl,poc_c		;pocet cisle
	mov	ah,0
	mov	si,offset cisla		;nastavenie na zaciatok cisel
usp3:   mov     al,[si]                 ;nacitanie cisla
	inc	si			;nastavenie na dalsie cislo
	cbw				;zmena na word
	call	vyp_cis			;vypis cisla
        loop    usp3                    ;opakuj pre vsetky cisla
	jmp	menu

        

;UKONCENIE PROGRAMU

koniec:	mov	ax,4c00h
	int	21h			;ukoncenie programu

code	ends				;skonci program

	end start

;nejde nasobenie dvoch poslednych 
;nejde delenie dvoch vybranych cisel
;8-bitovy rezim
