;Zadanie c. 2
;Napiste program, ktor nacta zo sboru cisla a podla priania uzivatela
;1-Vypocita sumu
;2-Usporiada vzostupne a zapise do suboru
;3-Vydeli 2 cisla a vypise vysledok
;4-Vynasobi 2 cisla a vypise vysledok
;5-Ukonci program
;
;Autor: Milan Melicherck, B-11
;14.11.2000
;

        assume  cs:code, ds: data, ss: stac
minus 	equ	'-'
zero    equ     '0'
one	equ     '1'
two	equ     '2'
three 	equ     '3'
four 	equ     '4'
five	equ     '5'
spc	equ     ' '

stac    segment stack
        dw      64 dup(?)
stac    ends

data    segment
decimal dw     000ah
buffer  db     70 dup(0)
pocetch dw     0
pocetno dw     0
nums    dw     10 dup(0)
handle  dw     0
no      db     6 dup(0),0ah,0dh,0ah,0dh,'$'
fin     db     'input.txt',0
fout    db     'output.txt',0
seol    db     0ah,0dh,'$'
sferr   db     'Chyba pri praci so suborom!',0ah,0dh,'$'
smenu   db     0ah,0dh,'1-Vypocitaj sumu vsetkych cisel',0ah,0dh
        db     '2-Usporiadaj cisla',0ah,0dh
        db     '3-Vydel 2 cisla',0ah,0dh
        db     '4-Vynasob 2 cisla',0ah,0dh
        db     '5-Koniec',0ah,0dh,0ah,0dh
        db     'Vyber: $'
s1out   db     'Suma vsetkych cisel: $'
sower   db     'Pri vypocte doslo k preteceniu!!!',0ah,0dh,0ah,0dh,'$'
sinno1  db     'Zadaj poradove cislo 1. cisla (0-9): $'
sinno2  db     'Zadaj poradove cislo 2. cisla (0-9): $'
s0div   db     'Delenie nulou!!!',0ah,0dh,'$'
no1     db     ?
no2     db     ?
s3out   db     'Podiel: $'
s4out   db     'Sucin: $'
data    ends

code    segment
eol     proc                            ;procedura na prechod na novy riadok
        push    ax
        push    dx
        mov     ah,09
        mov     dx,offset seol
        int     21h
        pop     dx
        pop     ax
        ret
eol     endp

ferror  proc                            ;procedura vypisujuca oznam o chybe
        mov     ah,09h                  ;pri praci so subormi
        mov     dx,offset sferr
        int     21h
        cmp     handle,0
        jne     nofile
        call    fclose
nofile: jmp     f5m
	ret
ferror  endp

fopen   proc                    ;proc. otvarajuca subor (pozaduje v DX offset
        mov     ah,3dh          ;na meno suboru (ASCIIZ)
        int     21h
        jnc     fopnok
        call    ferror
fopnok: mov     handle,ax
	ret
fopen   endp

fclose  proc                    ;procedura zatvarajuca subor (handle suboru
        mov  ah,3eh             ;je v premennej handle)
        mov  bx,handle
        int  21h
        mov  handle,0
	ret
fclose  endp

itoa    proc                         
        xor     dx,dx                   ;proc konvertujuca cislo v ax
        mov     si,5                    ;na retazec v 'no'
        xor     bp,bp
        cmp     ax,0
        jge     ipos                    ;ak je zaporne, poznac do bp
        not     bp                      ;a vymaz znamienko
        neg     ax
ipos:   xor     dx,dx                   ;postupnym delenim 10 zisti cifry
        div     decimal                 ;vydel - v ax podiel, dx - zvysok
        add     dx,zero                 ;premen cislo na ASCII
        mov     no[si],dl               ;uloz dalsiu cifru
        dec     si
        cmp     ax,0                    ;pokial uz ), tak skoci
        jne     ipos
        cmp     bp,0                    ;ak bolo zaporne, dopln minus
        je      ipos2
        mov     no[si],minus
        dec     si
ipos2:  cmp     si,0                    ;dopln medzery na pozicie pred ciframi
        jl      iend
        mov     no[si],spc
        dec     si
        jmp     ipos2
iend:   ret
itoa    endp

wrino   proc                            ;vypis retazec 'no'
        push    ax
        push    bx
        push    dx
        xor     ax,ax
        mov     bx,offset no
wrdch:  mov     al,[bx]                 ;najdi 1 cifru
        cmp     al,spc
        jne     wnospc
        inc     bx
        jmp     wrdch
wnospc: mov     ah,09                   ;vypis cislo
        mov     dx,bx
        int     21h
        pop     dx
        pop     bx
        pop     ax
        ret
wrino   endp

findmin proc                           
        shl     cx,1                    ;proc najde minimalne cislo od indexu
        push    dx                      ;cx az po koniec
        mov     dx,pocetno
        shl     dx,1
        mov     bp,cx
        mov     ax,nums[bp]             ;nacitaj 1. cislo
        inc     bp
        inc     bp
nxtno:  mov     bx,nums[bp]             ;nacitaj porovnavane cislo
        cmp     ax,0                    ;podla znamienok cisle porovna cisla
        jl      f21l                    ;ak je porovnavane mensie, tak ho zober
        cmp     bx,0                    ;za najmensie
        jl      f22l
        cmp     ax,bx
        jna     f2less
        mov     ax,bx
        mov     cx,bp
        jmp     f2less
f22l:   mov     cx,bp
        mov     ax,nums[bp]
        jmp     f2less
f21l:   cmp     bx,0
        jl      f212l
        jmp     f2less
f212l:  cmp     ax,bx
        jna     f2less
        mov     cx,bp
        mov     ax,bx
f2less: inc     bp
        inc     bp
        cmp     bp,dx
        jb      nxtno
        shr     cx,1
        pop     dx
        ret
findmin endp

start:  mov     ax,seg data
        mov     ds,ax
        mov     dx,offset fin           ;otvorenie vstupneho suboru
        mov     al,00h
        call    fopen
        mov     ah,3fh                  ;nacitanie 70 znakov (min. 10 cisel 
        mov     bx,handle               ;oddelenych medzerou)
        mov     cx,70
        mov     dx,offset buffer
        int     21h
        mov     pocetch,ax              ;skutocny pocet znakov
        call    fclose                  ;zavri subor
        mov     si,offset buffer        ;dekodovanie (atoi) - vsetkych 10 cisel
        mov     di,nums
        xor     bx,bx
        xor     ax,ax
        xor     bp,bp
        mov     cx,pocetch
dnxt:   mov     bl,[si]                 ;nacitaj znak
        cmp     bl,0                    ;ak 0, uz vsetky dekodovane
        je      dfin
        cmp     bl,spc                  ;ak medzera, nove cislo
        je      dspc
        cmp     bl,minus                ;ak '-', cislo je zaporne
        jne     dnomin
        not     bp
        inc     si
        jmp     dnxt
dnomin: sub     bl,zero                 ;premen ASCII znak na cislo
        mul     decimal                 ;uz nacitane cifry posun o 1 rad vyssie
        add     ax,bx                   ;pricitaj prave nacitanu
        inc     si                      
        loop    dnxt                    ;dalsi znak
dfin:   cmp     bp,0                    ;ak bolo zaporne
        je      fadmin
        neg     ax                      ;vyrob zaporne cislo
fadmin: mov     nums[di],ax             ;uloz posledne cislo
        jmp     dend
dspc:   cmp     bp,0                    ;ak nove cislo
        je      dadmin
        neg     ax                      ;ak bolo zaporne
dadmin: mov     nums[di],ax             ;uloz
        xor     ax,ax
        inc     di
        inc     di
        inc     si
        xor     bp,bp
        inc     pocetno
        cmp     pocetno,10              ;ak bolo 10 cisel, skonci s nacitavanim
        jae     dend
        jmp     dnxt                    ;inak nacitaj dalsie
dend:   inc     pocetno
menu:   mov     ah,09h                  ;vypis menu
        mov     dx,offset smenu
        int     21h
reamnu: mov     ax,0c08h                ;nacitaj cislo pozadovanej f-cie
        int     21h
        cmp     al,one                  ;zisti, ktora f-cia
        je      f1
        cmp     al,two
        je      f2
        cmp     al,three
        je      f3
        cmp     al,four
        je      f4
        cmp     al,five
        je      f5
        jmp     reamnu                  ;ak ani jedna z f-cii, ignoruj klavesu
f1:     mov     ah,02                   ;vypis cisla f-cie a vzdialeny
        mov     dl,al                   ;skok na jej telo
        int     21h
        call    eol
        jmp     f1m
f2:     mov     ah,02
        mov     dl,al
        int     21h
        call    eol
        jmp     f2m
f3:     mov     ah,02
        mov     dl,al
        int     21h
        call    eol
        jmp     f3m
f4:     mov     ah,02
        mov     dl,al
        int     21h
        call    eol
        jmp     f4m
f5:     mov     ah,02
        mov     dl,al
        int     21h
        call    eol
        jmp     f5m

f1m:    xor     ax,ax
        mov     cx,pocetno              ;od posledneho cisla po 1. scitaj
f1suma: mov     si,cx
        dec     si
        shl     si,1
        mov     bx,nums[si]             ;nacitaj cislo
f12pos: add     ax,bx                   ;pricitaj k doterajsej sume
        jo      f1ower                  ;ak owerflow, vypis chybu a skonci f-ciu
        loop    f1suma                  ;inac opakuj 
        call    itoa                    ;premen cislo na retazec
        mov     ah,09h
        mov     dx,offset s1out
        int     21h
        call    wrino                   ;vypis cislo
        jmp     menu                    ;vypis menu
f1ower: mov     ah,09h                  ;vypis chybu
        mov     dx,offset sower
        int     21h
        jmp     menu                    ;ukonci f-ciu

f2m:    mov     cx,0                    ;od 1. cisla
f2iter: mov     dx,cx
        push    cx
        call    findmin                 ;najdi najmensie
        mov     si,cx
        shl     si,1
        mov     di,dx
        shl     di,1
        mov     ax,nums[si]             ;vymen s najmensim
        mov     bx,nums[di]
        mov     nums[si],bx
        mov     nums[di],ax
        pop     cx
        inc     cx
        inc     cx
        cmp     cx,pocetno              ;ak uz bolo 10
        dec     cx
        jb      f2iter
        mov     al,01h                  ;otvor vystupny subor
        mov     dx,offset fout
        call    fopen
        mov     cx,pocetno
        shl     cx,1
        mov     bp,0
f2wrnx: mov     ax,nums[bp]             ;nacitaj cislo
        push    cx
        push    bp
        call    itoa                    ;vyrob z neho retazec
        mov     ah,40h                  ;zapis ho
        mov     bx,handle
        mov     cx,6
        mov     dx,offset no
        int     21h
        mov     ah,40h                  ;zapis eol
        mov     cx,2
        mov     dx,offset seol
        int     21h
        pop     bp
        inc     bp
        inc     bp
        pop     cx
        cmp     bp,cx                   ;uz vsetky zapisane?
        jl      f2wrnx
        call    fclose                  ;ak ano, zavri subor
        jmp     menu                    ;a vypis menu

f3m:    mov     ah,09h                  
        mov     dx,offset sinno1
        int     21h
        mov     ax,0c01h                ;nacitaj index 1. cisla
        int     21h
        sub     al,zero
        mov     no1,al
        call    eol
        mov     ah,09h
        mov     dx,offset sinno2        ;nacitaj index 2.cisla
        int     21h
        mov     ax,0c01h
        int     21h
        sub     al,zero
        mov     no2,al
        call    eol
        xor     bp,bp
        xor     cx,cx
        mov     cl,no2
        mov     si,cx
        shl     si,1
        mov     bx,nums[si]             ;nacitaj delitela
        cmp     bx,0
        je      no0div                  ;ak delitel rovny nule, oznam chybu
        jg      f32pos
        not     bp
        neg     bx
f32pos: mov     cl,no1
        mov     si,cx
        shl     si,1
        mov     ax,nums[si]             ;nacitaj delenec
        cmp     ax,0                    ;podla znamienok vydel a prirad
        jge     f31pos                  ;spravne znamienko vysledku
        not     bp
        neg     ax
f31pos: xor     dx,dx
        idiv    bx
        cmp     bp,0
        je      f3opos
        neg     ax
f3opos: call    itoa                    ;premen podiel na retazec
        mov     ah,09
        mov     dx,offset s3out
        int     21h
        call    eol
        call    wrino                   ;a vypis ho
        jmp     menu                    ;skok na menu
no0div: mov     ah,09
        mov     dx,offset s0div         ;vypis chybu "delenie nulou"
        int     21h
        jmp     menu                    ;koniec f-cie

f4m:    mov     ah,09                   ;nacitaj index 1. cisla
        mov     dx,offset sinno1
        int     21h
        mov     ax,0c01h
        int     21h
        call    eol
        sub     al,zero
        mov     no1,al
        mov     ah,09                   ;nacitaj index 2. cisla
        mov     dx,offset sinno2
        int     21h
        mov     ax,0c01h
        int     21h
        call    eol
        sub     al,zero
        mov     no2,al
        xor     cx,cx
        mov     cl,no2
        mov     si,cx
        shl     si,1
        mov     bx,nums[si]             ;nacitaj 2. cislo
        xor     cx,cx
        mov     cl,no1
        mov     si,cx
        shl     si,1
        mov     ax,nums[si]             ;nacitaj 1. cislo
        imul    bx                      ;vynasob
        jno     f4nowr                  ;ak pretecenie, vypis chybu
        mov     ah,09
        mov     dx,offset sower
        int     21h
        jmp     menu                    ;koniec f-cie
f4nowr: call    itoa                    ;ak nebolo pretecenie, premen cislo
        mov     ah,09                   ;na retazec
        mov     dx,offset s4out
        int     21h
        call    eol
        call    wrino                   ;a vypis ho
        jmp     menu                    ;koniec f-cie

f5m:    cmp     handle,0                ;ak nebol zatvoreny subor
        je      fclosd                  
        call    fclose                  ;zatvor
fclosd: mov     ah,4ch                  ;ukonci program
        int     21h

code	ends
	end	start





;program vyzaduje ms-dos
;vyzaduje vstupny subor (cisla oddelene 1 medzerou), existujuci vystupny subor
;program nacita 10 cisel (presne), mohlo by sa rozsirit na lubovolny pocet >= 10
;pripadne vo f-cii 3,4 spravit vypis zadanych cisel