;zadanie c 1.
;napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov)
;a podla ponukaneho menu vykona jednu z moznosti
; - vypise retazec znakov na obrazovku
; - vypise poradove cislo miesta kde sa nachadza prva medzera
; - hlada v retazcizadany znak a pocet jeho vyskytov ulozi do  cx
; - najde znak z maximalnou hodnotou a vypise tento znak
; - zarovna text zlava (vynecha prve medzery)
; - vypise retazec v opacnom poradi
; - ukonci vykonavanie programu
;autor	Tomas Palenik	99535
;
;termin odvzdania do piateho tyzdna semestra
;datum vyhotovenia este pred piatym tyzdnom semestra
;2.roc.sk.rok 2000/2001
;
.model small
zas	segment		stack
	db	100H dup(?)
zas	ends
data	segment
vstup	db	100
pocet	db	0
	db	103 dup(?)
nr	db	0Ah
	db	0Dh
	db	'$'
menu0	db	'Ocakavam vstupny retazec: $'
menu1	db	'V - vypis retazec$'
menu2	db	'S - najdi prvu medzeru$'
menu3	db	'F - najdi zadany znak$'
menu4	db	'M - najdi max znak$'
menu5	db	'Z - zarovnaj zlava$'
menu6	db	'R - reverzne vypis$'
menu7	db	'K - koniec$' 		
menu8   db      'neni tam$'
menu9  	db	'zadaj znak : $'
menu10  db	'100$'
menu11	db	'zadaj znak:$'
pre1	db	0
pre10	db	0
data	ends

code	segment
	assume ds:data,ss:zas,cs:code
; vykova odriadkovanie na obraze tj vypise
; sekvenciu CR LF
odriadkuj	proc	near
	mov	dl,	13      ; vypis znaku 0Dh na obraz
	mov	ah,	2       ; sluzbou cislo 2
	int	21h         	
	mov	dl,	10 	; vypis znaku 0Ah na obraz
	mov	ah,	2
	int 	21h
	mov	ah,	09h     ;
	ret
odriadkuj	endp
; vypise menu na obraz tj,vypise jednotlive polozky
; menu pod seba
vyp_menu	proc	near	
	mov	ax,	seg data     	;presunie do segmnetoveho reg ds
	mov	ds,	ax		;adresu data segmentu
	mov	dx,	offset menu1    ;do dx ide relativna adresa jednot
	mov	ah,	09h		;livich premennych menu
	int	21h                     ;a nasledne je vypisovana sluzbou
	call	odriadkuj		;na vypis retazca na obrazovku
	mov	dx,	offset menu2    ;na odriadkovanie je volana procedura
	int	21h			;odriadkuj
	call	odriadkuj
	mov	dx,	offset menu3
	int	21h
	call	odriadkuj
	mov	dx,	offset menu4
	int 	21h
	call	odriadkuj
	mov	dx,	offset menu5
	int	21h
	call	odriadkuj
	mov	dx,	offset menu6
	int 	21h 
	call	odriadkuj
	mov	dx,	offset menu7
	int 	21h
	call	odriadkuj
	ret
vyp_menu	endp
; vypise retazec v povodnom poradi znakov pomocou cyklickeho vypisu znakov 
vyp_ret		proc	near
	mov	dx,	offset pocet  	;nastavenie pred zaciatok retazca
	mov	bx,	dx              ;
	xor	cx,	cx
	mov	cl,	[bx]            ;inicializacia pocitadla
cyk:
	inc	bx
	mov 	dl,	[bx]
	mov	ah,	02h            ;vystup jedneho znaku na obraz
	int	21h
	loopne	cyk	               ;cyklus z vyuzitim pocitadla cx
	ret
vyp_ret		endp
; vypise retazec v obratenom poradi pomocou cyklickeho vypisu znakov
vyp_rev		proc	near
	mov	dx,	offset pocet  ;zistenie dlzky retazca
	mov	bx,	dx
	xor	cx,	cx
	mov	cl,	[bx]          ;inicializacia pocitadla
	add	bx,	cx            ;nastavenie na koniec
	inc	bx
kak:	
	dec	bx
	mov	dl,	[bx]
	mov	ah,	02h             ;vypis jedneho znaku na obraz
	int	21h
	loopne  kak                 	;cyklus z vyuzitim pocitadla cx
	ret
vyp_rev		endp	
; najde v retazci znak z maximalnou ascii hodnotou a vypise ho na obraz
maxim		proc	near
	xor	dx,	dx              ;vynulovanie vysledku dx
	mov	bx,	offset pocet
	xor	cx,	cx              ;vynulovanie pocitadla
	mov	cl,	[bx]            ;inicializacia pocitadla
kyk:
	inc	bx
	cmp	dl,	[bx]            ;porovna ciastkovy vysledok z ak
	jae	kek			;tualnym znakom retazca,ak je akt.
	mov	dl,	[bx]		;znak vacsi tak ho ulozi ako novy
kek:					;ciastocny vysledok a pokracuje
	loop 	kyk
	                                ;na konci je vysledok v dx
	mov	ah,	2		;a suzbou na vystup znaku sa vypise
	int	21h
	ret	
maxim		endp
; najde poradove cislo miesta kde sa nachadza prva medzera
medzera		proc	near
	mov	bx,	offset pocet    ;nastavenie na zaciatok
	xor	cx,	cx
	mov	cl,	[bx]            ;inicializacia pocitadla
kmk:
	inc	bx
	mov	al,	[bx]
	
	cmp	al,	20h             ;porovnavanie akt.znaku z medzerou
	je	von                     ;ak nasiel medzeru konci cyklus
	loop	kmk                     ;inac hlada az do konca
	mov	dx,	offset menu8    ;ak nenasiel vypise hlasku
	mov 	ah,	09h
	int	21h
von:	mov	dx,	offset pocet    ;poradove cislo medzery
	sub	bx,	dx              ;sa bude nachadzat v reg bx
        
        cmp	bx,	100
	je	sto
	mov 	ax,	bx         	;poradove cislo do reg ax
	aam                             ;kde sa rozdeli na 2 cifry
	xor	dx,	dx
	xor 	bx,	bx
	mov	dl,	ah      	;ktore sa vypisu
	mov	bl,	al              ;ako znaky pomocou sluzby os
	add	dl,	30h             ;je treba pripocitat 30h
	mov     ah,	2		;koli ascii kodovaniu
	int	21h
	mov	dl,	bl
	add	dl,	30h
	mov	ah,	2
	int	21h
	jmp	kme
sto:    mov	dx,	offset menu10
	mov	ah,	09h
	int	21h
	
kme:
	ret
medzera		endp
;najde pocet vyskytov zadaneho znaku v retazci
zadany		proc	near
	mov	dx,	offset menu11
	mov	ah,	09h
	int	21h
	call odriadkuj

	mov	bx,	offset pocet    ;nastavenie na zaciatok
	xor	cx,	cx
	xor	dx,	cx
	mov	ah,	01h
	int 	21h
	xor 	dx,	dx
	mov	dl,	al
	mov	cl,	[bx]            ;inicializacia pocitadla
k3mk:
	inc	bx
	mov	al,	[bx]
	
	cmp	al,	dl             ;porovnavanie akt.znaku zo zadanym
	jne	v3on
        inc	dh 
v3on :
	loop	k3mk                     ;hlada az do konca

        xor	cx,	cx
	xor	bx,	bx
	mov	bl,	dh	

        cmp	bx,	100
	je	s3to
	mov 	ax,	bx         	;vysledna poloha je v ax
	;add	ax,	1
	;mov	cx,	ax	        ;skopiruje sa do cx
	aam
	xor	dx,	dx
	xor 	bx,	bx
	mov	dl,	ah
	mov	bl,	al
	add	dl,	30h
	mov     ah,	2
	int	21h
	mov	dl,	bl
	add	dl,	30h
	mov	ah,	2
	int	21h
	jmp	k3me
s3to:    mov	dx,	offset menu10
	mov	ah,	09h
	int	21h
	
k3me:

	ret
zadany		endp
;zarovna v cykle dopredu
zarovnaj	proc	near
;
	mov    	bx,	offset pocet 
	xor	cx,	cx
	mov	cl,	[bx]
	
kzk:
	inc 	bx
	xor	ax,	ax
	mov	al,	[bx]	
	sub	al,	' '
	jnz	v1zn
	loop	kzk
v1zn:
	mov 	dx,	bx
	mov	bx,	offset pocet
	mov	byte ptr[bx],	cl
kyo:	inc	bx
	xchg	dx,	bx
	mov	al,	[bx]
	xchg	dx,	bx
	mov  	byte ptr[bx],	al
	inc	dx
	loopne	kyo
konk:	
	ret
zarovnaj	endp
;nacita znak z klavesnice a podla jeho hodnoty vola prislusnu polozku menu
nacitaj_znak	proc	near
	mov	ah,	01h    	;nacitanie znaku z klav sluzbou na to urcenou
	int	21h
	cmp	al,	66h     ;porovnavanie znaku a skoky na prislusne
	je	proc3		;volania procedur
	cmp	al,	6Bh
	je	proc7
	cmp	al,	6Dh
	je	proc4
	cmp	al,	72h
	je	proc6
	cmp	al,	73h
	je	proc2
	cmp	al,	76h
	je	proc1
	cmp	al,	7Ah
	je	proc5
	call odriadkuj       	
	ret
proc1:	call odriadkuj          ; vypise retazec normalne
	call vyp_ret
	call odriadkuj
	ret
proc2:	call odriadkuj
	call medzera		; vypise poradove cislo prvej medzery
	call odriadkuj
	ret
proc3:	call odriadkuj
	call zadany         	;najde pocet vyskitov zadaneho znaku
	call odriadkuj
	ret
proc4:	call odriadkuj
	call maxim              ; najde maximalny znak
	call odriadkuj
	ret
proc5:	call odriadkuj
	call zarovnaj		;zarovna
	call odriadkuj
	ret
proc6:	call odriadkuj
	call vyp_rev            ; vypise retazec obratene
	call odriadkuj
	ret
proc7:	call odriadkuj          ; nastavi koniec pre hlavnu cast programu
	mov	ah,	4Ch	; ktora potom skonci
	ret	
nacitaj_znak	endp

start:
	mov 	ax,	seg data      	;nastavenie datoveho segm do reg ds
	mov 	ds,	ax
	mov	dx,	offset menu0    ;vypis vyzvy na vstup retazca
	mov	ah,	09h
	int	21h
	mov	dx,	offset vstup    ;vstup retazca z kl
	mov	ah,	0Ah
	int	21h

	call odriadkuj                  ;cyklicky vypisuje
cyklus:	
	call 	vyp_menu                ;vypisuje menu
	call	nacitaj_znak            ;nacita riadiaci znak a vola prislusny
	cmp	ah,	4Ch		;kod pri znaku K skonci cyklus
	je	koniec                  ;a cely program
	jmp	cyklus
koniec:
	mov	ah,	4CH	
	int 	21h
code	ends
	end start
;program je funkcny vsetky casti programu funguju podla  zadania
;zatial neboli pozorovane chybne reakcie programu na vstupy ani pad programu
;program bol vypracovany pomocou prekladaca turbo asembler 5.0
;je mozne ze pri zadani niektorych exotickych znakov ako klav skratky ci klav Fn
;mozeme dostt neocakavany vystup, inac program korektne obhospodaruje sluzby os
;mozne vylepsenie - niektore casti kodu by sa dali napisat optimalnejsie
;co sa tyka taktik a fint pouzitych , autor ziadne specialne nepouzil ale program
;funguje 
