;ZADANIE c.1 A
;Text zadania:
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) 
;a podla ponkanho menu vykon  jednu z monost:

;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX 
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zlava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukonc vykonvanie programu.

;Autor: Teodor Petrk,B12
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001

;Zaciatok programu

.model small			;zadefinujem model program, ktory vyhradi miesto v pameti
.stack 100h  			;zasobnik od adresy 100h

popx equ pop dx cx bx ax        ;definujem makro popx, pushx
pushx equ push ax bx cx dx      ;ulozenie a nacitanie stavu procesora

.data

vyzva1  	db "     Zadaj retazec : $"
autor		db "                   Teodor Petrik, B12, zadanie c.1 A$"
znak    	db 3 dup (2,?)
zprava2 	db "     Retazec : $"
sprava  	db "     Pocet vyskytov zadaneho znaku : $"
Cisla   	db "0123456789"
sprava2 	db "     Zadaj znak ktory chces najst :$"
sprava3 	db "Zarovnany text :$"
nomedzera 	db "Medzera sa v retazci nenachadza!$"
yesmedzera 	db "Medzera je na mieste : $"
maximalnyznak 	db "Znak s maximalnou hodnotou : $"
neni    	db "Znak sa v retzci nenachadza$"     
pozi    	db "Znak sa nachadza na pozicii : $"
buffer  	db 4 dup(?),"$"
menux		db "                              M E N U		  ",10,13,"$"
menu1		db 10,13,"                   a) Nacitat retazec$"
menu2		db 10,13,"                   b) Vypisat retazec$"
menu3		db 10,13,"                   c) Vypise poradove cislo prvej medzery$"
menu4 		db 10,13,"                   d) Pocet vyskytov zadaneho znaku ulozi do CX$"
menu5		db 10,13,"                   e) Najde a vypise znak s maximalnou hodnotou$"
menu6   	db 10,13,"                   f) Zarovna text zlava$"
menu7  		db 10,13,"                   g) Vypis v obratenom poradi$"
menu8   	db 10,13,"                   k) KONIEC$"
riadok		db 10,13,"$"
retaz   	db 103 dup (103,?),'$'	;zadefinujeme retazec s maximalnou dlzkou 100

.code

;********************Procedura na vymazanie obrazovky
clrscr proc near
    	pushx		;ulozi registre do stack
    	mov ax,0B800h	;adresa videopamete
    	mov es,ax
    	mov di,0
    	mov cx,25*80	;do cx ulozi rozmery textoveho obrazu
    	mov ah,07h	;nastavi cierne pozadie, bledosede pismo
    	mov al,' '    	;znak ktorym chcem zaplnit obrazovku
nav:stosw
    	loop nav
    	mov dx,0605h
    	call setcur 
    	popx
    	ret 
endp clrscr

;********************Procedura na nastavenie pozicie kurzora
setcur proc near
    	pushx
    	mov ah,02
    	mov bx,0   
    	int 10h
    	popx
    	ret
endp

;********************Procedura na vypis menu
menu proc near
	pushx			;procedura sluzi na vypis menu
    	mov ah,09
    	mov dx,offset menux	;nadpis
    	int 21h
    	mov dx,offset menu1	;volnba a)
    	int 21h
    	mov dx,offset menu2	;volba	b)
    	int 21h
    	mov dx,offset menu3	;volba 	c)
    	int 21h
    	mov dx,offset menu4	;volba 	d)
    	int 21h
    	mov dx,offset menu5	;volba	e)
    	int 21h
    	mov dx,offset menu6	;volba	f)
    	int 21h
    	mov dx,offset menu7	;volba	g)
    	int 21h
    	mov dx,offset riadok	;vypise volny riadok
    	int 21h
    	mov dx,offset menu8	;volba	k)
    	int 21h
        mov dx,offset riadok	;vypise volny riadok
        int 21h
        mov dx,offset riadok	;vypise volny riadok
        int 21h
        mov dx,offset riadok	;vypise volny riadok
        int 21h
        mov dx,offset autor     ;o autorovi
        int 21h
    	popx
    	ret  
endp menu

;********************Procedura na nacitanie retazca
nacitaj proc near	
    	pushx
    	call clrscr		;zmaze obrazovku zavolanim funkcie clrscr
    	mov dx,offset vyzva1	;vypise vyzvu
    	mov ah,9		
    	int 21h
    	mov dx,061ah		;nastavi kurzor na poziciu 6. riadok a 1. stlpec
    	call setcur		;volanie funkcie setcur	
	mov ah,0ah		;nacita zadavany retazec
    	mov dx,offset retaz
    	int 21h
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov bx,offset retaz
    	add bx,2		;posunuie sa o 2 bity v ktorych su informacie o retazci
    	add bx,cx		;poripocita dlzku retazca
    	mov al,'$'		;ukonci retazec znako '$'
    	mov [ds:bx],al		;ulozi retazec do pamete
    	popx
    	ret
endp nacitaj

;********************Procedura na vypis retazca
vypis proc near
    	pushx
    	call clrscr		;zmaze obrazovku volnim funkcie clrscr
    	mov ah,09
    	mov dx,offset zprava2	;vypis na obrazovku
    	int 21h
    	mov dx,offset retaz	;dx je zaciatok retazca
    	add dx,2		;posunie sa o 2 bity (informacie o retazci)
    	int 21h			;prerusenie sposoby vypis retazca
    	mov ah,0		;caka na stlacenie klavesy
    	int 16h
    	popx
    	ret
endp vypis
 


;********************Procedura na vypis retazca v obratenom poradi
vypisnaopak proc near
    	pushx
    	call clrscr		;volanie funkcie clrscr na zmazanie obrazovky
    	mov ah,09		;vypis
    	mov dx,offset zprava2
    	int 21h
    	mov dx,0618h		;nastavenie kurzoru na 6.riadok a 18.stlpec
    	call setcur		;volanie funkcie setcur
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov bx,offset retaz
    	add bx,cx		;poripocita dlzku retazca
    	inc bx			;inkrementuje bx
    	mov ah,02		;bude sa vypisovat znak
cyklus2:  			;cyklus ktory vypise zadany retazec naopak
	mov dl,[ds:bx]
    	int 21h			;vypise znak
    	dec bx			;dekrementuje bx
	loop cyklus2
    	mov ah,0		;stlac klaves
    	int 16h
    	popx
    	ret
endp vypisnaopak

;********************Procedura na vypis cisla
vypcisl proc near
    	pushx
   	mov bx,10     		;do bx sa ulozi zaklad
    	mov di,4
cyklusm:
	dec di
    	mov dx,0
    	div bx              	;dx ax /bx
    	mov si,dx           	;do si zbytok
    	mov dl,[cisla+si]   	;do dl pismeno
    	mov [buffer+di],dl  	;a zapis. do buff.
    	cmp ax,0		;je cela cast nula?
    	jnz cyklusm
    	mov dx,offset buffer
    	add dx,di
    	mov ah,09h
    	int 21h  
    	popx
    	ret
endp vypcisl

;********************Procedura na zistenie poctu znaku v retazci
pocetvyskytov proc near
    	pushx
    	call clrscr		;volanie procedury na zmazanie obrazovky
    	mov ah,09h		;vypis
    	mov dx,offset sprava2
    	int 21h
    	mov dx,062ah		;nastavnie kurzora na poziciu
    	call setcur		;zavolanie funkcie setcur
    	mov ah,0ah		;nacitanie znaku, ale ako retazca
    	mov dx,offset znak
    	int 21h
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov bx,2		;do bx sa ulozi 2
    	mov si,0		;do si sa ulozi 0 co je pocet vyskytov
        mov al,[znak+2]    	;do al sa ulozi zaciatocny znak
loopx:
	mov dl,[retaz+bx]	;v kazdom kroku cyklu sa do dl ulozi nasledujuci znak
    	cmp dl,al		;porovna dl a al
    	jnz increment		;pokial sa nerovnaju potom skoci na na navestie increment
    	inc si			
increment: inc bx		;pokial sa rovnaju inkrementuje sa si aj bx
    	loop loopx		;pokial sa nerovnaju inkrementuje sa iba bx
    	call clrscr		;volanie funkcie clrscr na zmazanie obrazovky
    	push ax			;ulozi ax do zasobnika
    	mov dx,offset sprava	;vypis
    	mov ah,09h
    	int 21h
    	pop ax			;vyberie ax zo zasobnika
    	mov ax,si		;ulozi do ax pocet vyskytov
  	mov cx,si		;ulozi do cx pocet vyskytov podla zadania
    	mov dx,0630h		;nastavi poziciu kurzora
    	call setcur		;zavola fujnkciu setcur
    	call vypcisl		;zavola funkciu na vypis cisla
    	mov ah,0		;stlac klaves
    	int 16h
    	popx
    	ret
endp pocetvyskytov

;********************Procedura na hladanie medzery
medzera proc near
	pushx
    	call clrscr		;zalova clrscr
   	mov dx,0908h		;nastavi kurzor
    	call setcur		;zavola setcur
    	mov ch,0		
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov si,2		;do si sa ulozi 2
    	mov al,' '		;do al sa ulozi medzera  
cyklus1:			;cyklus na hladanie medzery
	mov dl,[retaz+si]	;do dl kazdy krokom cyklu nasledujuci znak
    	cmp dl,al		;porovna dl a al
    	jz vypisy		;ked sa rovnaju skoci na vypisy
    	inc si			;inak sa inkrementuje si
    	loop cyklus1
vypisy: 
	cmp cx,0		;porovna cx s 0
    	jz nieje		;ak sa rovnaju skoci na navestie nieje teda medera nieje
    	dec si			;inak sa dekrementuje si
    	mov ah,09h		;vypis v pripade, ze medzera sa v retazci nachadza
    	mov dx,offset yesmedzera
    	int 21h
    	mov ax,si		;do ax ulozi si
    	call vypcisl		;zavola proceduru na vypis cisla
    	jmp key			;skoci na navestie key
nieje:
	mov ah,09h		;vypis ked je retazec bez medzery
    	mov dx,offset nomedzera
    	int 21h        
key: 
	mov ah,0		;pocka na stlacenie klavesu
    	int 16h
    	popx
    	ret
endp medzera

;********************Procedura na zarovnanie
zarovnanie proc near
	pushx
    	call clrscr		;volanie clrscr
    	mov dx,0906h		;nastavenie kurzora
    	call setcur		;volanie setcur
        mov ah,09h		;vypis
        mov dx,offset sprava3
        int 21h
    	mov dx,0917h		;nastavenie kurzora
    	call setcur		;volanie setcur
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov si,2		;do si 2
    	mov al,' '    		;do al medzera, ktora sa bude hladat
cyklus9:			;cyklus, vypisuje znaky az po 1.medzeru 
	mov dl,[retaz+si]	;do dl nasledujici znak
      	cmp dl,' '		;porovna dl s medzerou
      	jz incre		;ak sa rovnaju skoci na incre
      	mov ah,02h		;ak nie potom este vypise znak
      	int 21h 
    	inc si			;a inkrementuje si
    	loop cyklus9
incre:inc si			;inkrementuje si
	cmp cx,0		;zisti ci bola medzera        
    	jz keyx			;ak nie potom skoci na keyx
loop10:				;cyklus na vypis retazca za medzerou
     	mov dl,[retaz+si] 	;do dl nasledujuci znak
     	cmp dl,'$'		;pokial je dl znak pre koniec retazca skoci na keyx
     	jz keyx
     	mov ah,02h		;inak znak vypise
     	int 21h
     	inc si			;inkrementuje si
	loop loop10        
keyx: 
	mov ah,0		;stlac klaves
    	int 16h
    	popx
    	ret
endp zarovnanie

;********************Procedura na najdenie a vypis znaku s max.hodnotou
maxznak proc near
	pushx
    	call clrscr		;volanie clrscr
   	mov dx,0908h		;nastavenie kurzora
    	call setcur		;volnie setcur
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov si,2		;do si sa ulozi 2
        mov di,2		;do di sa ulozi 2
    	mov bl,[retaz+2]	;do bl sa ulozi prvy znak   
xcyklus1:			;cyklus na najdenie znaku s max. hodnotou
	mov dl,[retaz+si]	;do dl nasledujuci znak
    	cmp dl,bl		;porovna dl a bl
    	jl max			;ked je dl mensie ako bl skoci na navestie max
        mov bl,dl		;inak sa este do bl ulozi dl
max:inc si			;inkrementacia si
    	loop xcyklus1
	mov ah,09h		;vypis
	mov dx,offset maximalnyznak
	int 21h
	mov dl,bl		;do dl sa ulozi bl aby sa mohol znak vypisat
	mov ah,02h
	int 21h  
	mov ah,0		;stlac klaves
    	int 16h
    	popx
    	ret
endp maxznak


;***************************************************************
start:  
	mov ax,@data		;datova oblast, register ds
        mov ds,ax	

				;blok instrukcii na prve nacitanie retazca
    	call clrscr		;zmaze obrazovku zavolanim funkcie clrscr
    	mov dx,offset vyzva1	;vypise vyzvu
    	mov ah,9		
    	int 21h
    	mov dx,061ah		;nastavi kurzor na poziciu 6. riadok a 1. stlpec
    	call setcur		;volanie funkcie setcur	
	mov ah,0ah		;nacita zadavany retazec
    	mov dx,offset retaz
    	int 21h
    	mov ch,0
    	mov cl,[retaz+1]	;do cl sa ulozi dlzka retazca
    	mov bx,offset retaz
    	add bx,2		;posunuie sa o 2 bity v ktorych su informacie o retazci
    	add bx,cx		;poripocita dlzku retazca
    	mov al,'$'		;ukonci retazec znako '$'
    	mov [ds:bx],al		;ulozi retazec do pamete

opak:	
	call clrscr		;volanie funkcie na zmazanie obrazovky
	call menu		;volanie funkcie menu 
case:   
	mov ah,0		;stlac klaves
        int 16h				
				;porovnava al so stlacenym znakom a podla toho vola navestia
        cmp al,'a' 		
        jz ponuka1
        cmp al,'b'
        jz ponuka2
        cmp al,'c'
        jz ponuka3
        cmp al,'d'
        jz ponuka4
        cmp al,'e'
        jz ponuka5
        cmp al,'f'
        jz ponuka6
        cmp al,'g'
        jz ponuka7
        cmp al,'k'
        jz ponuka8
        jmp case		;pokial nebol stlaceny klaves z hore uvedenych opakujesa case
				;nasleduju navestia pre jednotlive vybery z ponuky
ponuka1:      
	call nacitaj
        jmp opak
ponuka2:      
	call vypis
        jmp opak
ponuka3:      
	call medzera
	jmp opak
ponuka4:      
	call pocetvyskytov
	jmp opak
ponuka5:      
	call maxznak
	jmp opak
ponuka6:      
	call zarovnanie;vypisnaopak
        jmp opak
ponuka7:      
	call vypisnaopak;kolkoznak
	jmp opak
ponuka8:      
	jmp konec  
konec:	
	mov ax,4c00h    ;ukonci program
        int 21h
end start

;Zaverecne zhodnotenie:
;Program je plne funkcny
;Technicke vybavenie: pocitac 486 DX2/66
;Programove vybavenie: 	Turbo Assembler ver. 2.02
			Turbo Link      ver. 3.01
;Obmedzenia programu:
;program ma nacitavanie retazca v menu, preto ma na zaciatku v retazci ulozene meno autora

;v programe su tieto obmedzenia:
;pri nezadani znaku pri volbe a) vypisuje program rozne znaky

;v programe su pouzite tieto procedury
;clrscr - procedura na vymazanie obrazovky
;setcur - procedura na nastavenie kurzora
;menu   - procedura na vypis menu pomocou instrukcie 09h prerusenia int 21h
;nacitaj - procedura na nacitavanie retazca, instrukcia 0ah, prerusenie int 21h
;vypis   - procedeura na vypis retazca, 09h, int 21h
;vypisnaopak - procedura na vypis retazca naopak, znaky pomocou 02h, int 21h
;vypcisl - procedura na vypis cisla 
;pocetvyskytov - procedura na zistenie poctu vyskytov zadaneho znaku v retazci
;medzera - procedura na vyhladanie prvej medzery
;zarovnanie - procedura na zarovnanie textu podla prvej medzery
;maxznak - procedura na vyhladanie a vypisanie znaku s maximalnou hodnotou


