;ZADANIE c.2 A
;Text zadania: 
;Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
;(aspon 10) so znamienkom v desiatkovej ciselnej sustave, potom ich transformuje
;na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom podla priania
;pouzivatela ponukne menu

;a) vypocita sumu vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel do noveho
;   textoveho suboru
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu 

;Autor: TEODOR PETRIK, B12
;Termin odvzdania:14.11.2000
;2.roc.,sk.rok 2000/2001

;zaciatok programu
;tasm 3.2,tlink5.2

;popis procedur
;clrscr        	maze obrazovku
;setcur        	nastavuje kurzor
;menu      	vypis textu menu
;vypcisl       	vypise cislo v ax		
;nacitaj 	otvori subor potom nacita retazec a subor zavrie
;error1		vypise chybove hlasenie pri aritmetickej chybe
;vyppol		vypise pole cisel
;strtonum	prevedie konvertovanie cisel z retasca na cisla
;vyplcisl	vypise cislo
;sucet		spocita cisla a vypise sumu, pri preteceni hlasi chybu
;vusppo		vzostupne usporiada cisla
;vzostup	vzostupne usporiadanie pole zapise do suboru
;nacitajc	nacita cislo z klavesnice
;nasobenie	vynasobi dve lubovolne cisla
;delenie	vydeli dve lubovolne cisla


.286		; na istrukcie pusha popa
.model small  	; dvojsegmentovy model
.stack 100h   	; zasobnik velky 100h

.data	      ; datova cast
cisla   db "0123456789"
buffer  db 5 dup(?),"$"
nadpis	db "                               MENU		  ",10,13,"$" ; cisla 10,13 kvoli zariadkovaniu
moz1	db 10,13,"                a) Vypocita a vypise sumu vsetkych cisel$"
moz2	db 10,13,"                b) Usporiadaj vzostupne a zapise do noveho suboru$"
;moz3	db 10,13,"                c) Usporiadaj zostupne a zapis$"
moz4 	db 10,13,"                c) Vydeli dve cisla a vypise vysledok$"
moz5	db 10,13,"                d) Vynasobi dve cisla a vypise vysledok$"
moz6    db 10,13,"                k) Koniec$"
vet 	db 10,13," Nacitane cisla su : $"
vet1    db 10,13," Suma cisel je : $"
vet2    db 10,13," Aritmeticka chyba $"
vet3    db 10,13," Cisla boli vzostupne zapisane do suboru vzostupne.txt $"
vet4    db 10,13," Zapisane do subora zostup.txt $"
vet5	db 10,13," Zadaj indexi cisel pre delenie (od jedna): $"
vet6	db 10,13," Zadaj indexi cisel pre nasobenie (od jedna): $"
vet7    db 10,13," Vysledok (cele cislo) : $"
vet8    db 10,13," Zvysok delenia : $"
prr	db 10,13,"$"
subor   db "cisla.txt",0
subor2  db "vzostupne.txt",0
subor3  db "zostup.txt",0
retaz   db ' ',100h dup("$")
medzera db ' $'
pole    db 30h dup(?)
cislo   db 3,4 dup(' ')
kam	db ?
ktorys  dw ?
vysl    db ?
stabx   dw ?
pocet   dw ?
vstup   dw ?
vystup1 dw ?
vystup2 dw ?
desat   db 10
mjedna  db -1
autor	db 10,13,"                   Teodor Petrik, B12, zadanie c.2 A$"



.code			; codova cast

;****************************************************************************
;procedura na nacitanie zo suboru

nacitaj proc
    pusha
    mov dx,offset subor		;blok instrukcii na otvaranie suboru
    mov ax,3d00h
    int 21h
    mov vstup,ax

    mov ah,3fh			;blok na nacitanie zo suboru
    mov bx,vstup
    mov dx,offset retaz
    inc dx           		;inkrementacia kvoli prvej medzere
    mov cx,100h
    int 21h
    mov bx,ax
    mov [retaz+bx],' '		;pridanie medzier

    mov ah,3eh			;blok na uzavretie suboru
    mov bx,vstup
    int 21h

    popa
    ret
nacitaj endp

;****************************************************************************
;procedura na vypis chyboveho hlasenia

error1 proc
  	pusha
  	mov ah,9
  	mov dx,offset vet2
  	int 21h
  	popa
  	ret
error1 endp

;****************************************************************************
;procedura na vypis pola cisel

vyppol proc
    	pusha
    	mov dx,offset medzera
    	mov di,0

fo8:
	cmp di,pocet		
    	jz ef8			;ak sa di a pocet rovnaju skoci na ef8
    	mov al,[pole+di]
    	cbw			;uprava znamienka
    	call vypcisl		;vypis cisla v ax
    	mov cx,1
    	mov ah,kam		;v kam sa nachadza 09 v pripade vypisu na obrazovku
				;alebo 40h v pripade vypisu do suboru
    	mov bx,ktorys
    	int 21h
    
    	inc di
    	jmp fo8
ef8:       
    	popa
    	ret
vyppol endp 

;****************************************************************************

prevednac proc
    	pusha
			; DS:[BX] -> zaciatok, po medzeru
loo:
	inc bx
    	mov al,ds:[bx]
    	cmp al,' '
    	jz k5
    	cmp al,0dh
    	jz k5
    	jmp loo
k5:
    	mov stabx,bx
    	dec bx
    
    	mov cx,1
    	mov dx,0
lo1:
	mov al,ds:[bx]
    	cmp al,'-'
    	jz min
    	cmp al,' '
    	jz ko
    	sub al,30h   ;v al cifra
    	mul cl       ;ax=al*cl
    	add dl,al    ;dl=vyledok 
    	mov al,cl	 
    	mul desat	 ;ax=al*10
    	mov cl,al	 
    	dec bx
    	jmp lo1
min:
	mov al,dl
    	imul mjedna
    	mov vysl,al
    	jmp ko1
ko :
	mov vysl,dl
ko1:
	popa
    	ret
prevednac endp

;****************************************************************************
;procedura na konvertovanie znakov na cisla

strtonum proc
    	pusha			
    	mov bx,offset retaz	;vypis retaz
    	mov di,0
n1 :
	inc bx			;inkrementacia bx
    	mov al,ds:[bx]    	
    	cmp al,'$'		;porovna sa al so znakom $ ci nieje koniec
    	jz ko2			;ak sa rovnaju potom skoci na navestie ko2
    	cmp al,' '		;porovnanie al so znakom medzery ci nenasleduje cislo
    	jz n1			;ak sa rovnaju potom skoci na n1
    	call prevednac 		
    	mov al,vysl		;do al vysledok
    	mov [pole+di],al	;do pola al
    	inc di			;inkrementovanie di
    	mov bx,stabx		
    	jmp n1			;skok na zaciatok
ko2:
	mov pocet,di		;do pocet di - pocet cisel
    	popa
    	ret
strtonum endp

;****************************************************************************
;procedura na mazanie obrazovky

clrscr proc			
    	pusha			; zasunie registre 
    	mov ax,0B800h		; do ax adresa videopamate
    	mov es,ax		; do es ax
    	mov di,0		
    	mov cx,25*80		; do cx riadky*stlpce (25*80)
    	mov ah,07h		; horny bajt 07=cierne pozadie, bledosedy text
    	mov al,' '		; al = medzera tym
nav:
	stosw			; mov es:[di],ax add di,2
    	loop nav

    	mov dx,0605h		; dh = riadok = 06, dl = stlpec = 05
    	call setcur 		
    	popa			; obnova registrov
    	ret 			; navrat
clrscr endp 

;****************************************************************************
;procedura na nastavenie kurzoru

setcur proc
    	pusha
    	mov ah,02   	; cislo sluzby biouseu na nastavenie kurzoru
    	mov bx,0	; cislo videostranky 
    	int 10h		; prerusenie biosu
    	popa
    	ret
setcur endp

;****************************************************************************
;procedura na vypis menu

menu proc
    	pusha
    	mov ah,09		; ah=9 sluzba na vypis
    	mov dx,offset nadpis   	; do dx ofsett premennej nadpis tj DS:[dx] ukazuje na zaciatok premennej nadpis	
    	int 21h
    	mov dx,offset moz1     
    	int 21h
    	mov dx,offset moz2
    	int 21h
;    	mov dx,offset moz3
;    	int 21h
    	mov dx,offset moz4
    	int 21h
    	mov dx,offset moz5
    	int 21h
    	mov dx,offset prr
    	int 21h
    	mov dx,offset moz6
    	int 21h
    	mov dx,offset prr
    	int 21h
    	mov dx,offset prr
    	int 21h
    	mov dx,offset prr
    	int 21h
    	mov dx,offset autor
    	int 21h
    	popa
    	ret  
menu endp

;****************************************************************************
;procedura na vypis cisla

vypcisl proc		
    	pusha
    	mov bx,10       ;zaklad
    	mov cx,ax       ; neskor koli znamienku
    	cmp ax,0	;ak je vacsie ako 0 vypis
    	jg va1		;ak nieje potom prevedenie na doplnkovy kod
    	not ax
    	inc ax
va1:
	mov di,5
lll:
	dec di		; di ukazuje do buffera
    	mov dx,0
    	idiv bx             ;dx = ax mod bx
    	mov si,dx           ;do si zbytok
    	mov dl,[cisla+si]   ;do dl pismeno (si vyberie z retazca cisel podla svojej hodnoty)
    	mov [buffer+di],dl  ;a zapis. do buff. (odzadu)
    	cmp ax,0		;je cela cast nula?
    	jnz lll

    	cmp cx,0
    	jge vat
    	dec di 
    	mov [buffer+di],'-'
vat:
	mov dx,offset buffer  
    	add dx,di		; korekcia koli neplneniu buffera odpredu
    	mov ah,kam
    	mov bx,ktorys
    	mov cx,5
    	sub cx,di
    	int 21h		;vypis buffer
    
    	popa
    	ret
vypcisl endp


;****************************************************************************
;procedura na zistenie suctu

sucet proc 
	pusha
    	call clrscr
    	mov dx,offset vet
    	mov ah,9
    	int 21h
    	mov kam,09h
    	call vyppol
    	mov ah,9
    	mov dx,offset vet1
    	int 21h

    	mov cx,pocet
    	mov bx,0
    	mov si,0
lo2:	mov al,byte ptr[pole+si]
    	cbw
    	add bx,ax
    	jo er1
    	inc si
    	loop lo2

    	mov ax,bx
    	mov kam,09h
    	call vypcisl
    	jmp da3

er1:	call error1

da3:	mov ah,0
    	int 16h

    	popa
    	ret 
sucet endp

;****************************************************************************
;procedura na usporiadanie pola

vusppo proc

    	pusha
	poc dw ?
    	mov ax,pocet
    	mov poc,ax
    	dec poc
    	mov cx,0
fo1:
	cmp cx,poc
    	jz ef1
    	mov di,cx
    	mov al,[pole+di]
    	mov bx,cx
    	inc bx
fo2:   
	cmp bx,pocet
       	jz ef2
       
       	cmp byte ptr [pole+bx],al
       	jg nic
       	mov di,bx
       	mov al,[pole+bx]
nic:   
       	inc bx
       	jmp fo2
ef2:   
    	mov si,cx
    	mov ah,[pole+si]
    	mov [pole+di],ah
    	mov [pole+si],al
    
    	inc cx
    	jmp fo1
ef1:
    	popa
    	ret
vusppo endp

;****************************************************************************
;procedura na vzostupne usporiadanie

vzostup proc
    	pusha
    	call vusppo        ; usporiadaj pole

    mov ah,3ch
    mov dx,offset subor2
    mov cx,0
    int 21h 
    mov vystup1,ax
    mov ktorys,ax


    mov kam,40h
    
    call vyppol

    call clrscr
    mov ah,9 
    mov dx,offset vet3
    int 21h

    mov ah,00
    int 16h
    
    popa
    ret
vzostup endp

;****************************************************************************
zusppo proc
    pusha
poc1 dw ?
    mov ax,pocet
    mov poc1,ax
    dec poc1

    mov cx,0
fo5:cmp cx,poc1
    jz ef5
    mov di,cx
    mov al,[pole+di]
    mov bx,cx
    inc bx
fo6:   cmp bx,pocet
       jz ef6
       
       cmp byte ptr [pole+bx],al
       jl nic1
       mov di,bx
       mov al,[pole+bx]
  nic1:   
       inc bx
       jmp fo6
ef6:   
    mov si,cx
    mov ah,[pole+si]
    mov [pole+di],ah
    mov [pole+si],al
    
    inc cx
    jmp fo5
ef5:
    popa
    ret
zusppo endp

;****************************************************************************
zostup proc
    pusha
    call zusppo        ; usporiadaj pole

    mov ah,3ch
    mov dx,offset subor3
    mov cx,0
    int 21h 
    mov vystup2,ax
    mov ktorys,ax

    mov kam,40h

    call vyppol
       
    call clrscr
    mov ah,9 
    mov dx,offset vet4
    int 21h

    mov ah,00
    int 16h
    
    popa
    ret
zostup endp

;****************************************************************************
nacitajc proc
    pusha
    mov ah,0ah
    mov dx,offset cislo
    int 21h
    mov bx,offset cislo
    inc bx
    mov byte ptr ds:[bx],' '
    inc bx
    call prevednac	;zavolaj proceduru na prevod na cislo
    popa
    ret
nacitajc endp

;****************************************************************************
;procedura na vydelenie dvoch lubovolnych cisel

delenie proc 
    	pusha
    	call clrscr
    	mov kam,09h
    	call vyppol
    	mov dx,offset vet5
    	mov ah,9
    	int 21h

    	call nacitajc	;nacitaj index cisla
    	mov al,vysl	;v al je cislo
    	cbw		;al do ax
    	dec ax		;dekrementacia kvoli indexovaniu od nuly
    	mov si,ax	;do si ukazovatel na citatela

    	mov dx,0734h
    	call setcur
    
    	call nacitajc
    	mov al,vysl
    	cbw
    	dec ax
    	mov di,ax

    	mov al,[pole+si]
    	cbw
    	mov bl,[pole+di]

    	idiv bl

    	mov bx,ax
    	mov ah,9
    	mov dx,offset vet7
    	int 21h
    	mov al,bl
    	cbw
    	call vypcisl

    	mov ah,9
    	mov dx,offset vet8
    	int 21h
    	mov al,bh
    	cbw
    	call vypcisl

    	mov ah,0
    	int 16h

    	popa
    	ret
delenie endp    

;****************************************************************************
;procedura na nasobenie dvoch lubovolnych cisel

nasobenie proc 
    	pusha
    	call clrscr
    	mov kam,09h
    	call vyppol
    	mov dx,offset vet6
    	mov ah,9
    	int 21h

    	call nacitajc
    	mov al,vysl
    	cbw
    	dec ax
    	mov si,ax

    	mov dx,0734h
    	call setcur
    
    	call nacitajc
    	mov al,vysl
    	cbw
    	dec ax
    	mov di,ax

    	mov al,[pole+si]
    	mov bl,[pole+di]

    	imul bl

    	mov bx,ax
    	mov ah,9
    	mov dx,offset vet7
    	int 21h
    	mov ax,bx
    	call vypcisl

    	mov ah,0
    	int 16h

    	popa
    	ret
nasobenie endp    


;****************************************************************************
;****************************************************************************
;****************************************************************************

start:  mov ax,@data
        mov ds,ax		; ds data

opak:
	call clrscr
	call menu
	call nacitaj
        call strtonum
 
case:   
	mov ah,0
        int 16h

        cmp al,'a' 	; moznosti
        jz volba1
        cmp al,'b'
        jz volba2
;        cmp al,'c'
;        jz volba3
        cmp al,'c'
        jz volba4
        cmp al,'d'
        jz volba5
        cmp al,'k'
        jz volba6

        jmp case

volba1:     
	call sucet
        jmp opak
volba2:     
	call vzostup
	jmp opak
;volba3:     
;	call zostup
;	jmp opak
volba4:     
	call delenie
        jmp opak
volba5:      
	call nasobenie
	jmp opak
volba6:      
	jmp koniec  
 
koniec:	
	mov ax,4c00h    ;koniec programu
        int 21h
end start

;Zaverecne zhodnotenie:
;Program je plne funkcny
;Technicke vybavenie: pocitac 486 DX2/66
;Programove vybavenie: 	Turbo Assembler ver. 2.02
			Turbo Link      ver. 3.01
;program nacitava velkosti osem bitov

