; Program na demonstraciu prace z retazcami v asm
; Parogram nepouziva ziadnu premennu na ukladanie retazca,vyuziva
; volnu cast v PSP - Program segment prefix (informacna cast DOSu o beziacom
; procese) od 80h (kde je ulozeny pocet znakov na command line pri spustany
; programu).
; Tips to optimize code:
;         obcas som pouzil namiesto loop xxxxx  dec cl/cx jnz xxxxx
;         niektore casty by sa dali lepsie zalgoritmizovat
;
; BTW: po skompilovani je treba sustit code.com - zakryptuje samotne telo programu
;      tj. kryptuje vsetko za koncom dekryptora, keby sa code.com nespustil po kompilacii
;      program by nefungoval korektne - pravdepodobne by nesiel vobec ;)

.286
.model tiny                              ; je to COM subor tj.  CS=DS
.code                                    ;
HORE  equ cld                            ; lepsie pochopitelne v programe ako cld
DOLE  equ std
STR_I equ 80h                            ; zaciatok retazca - commandline - kedze pouzivam funkciu 0Ah sem nastavim prepokladnu dlzku retazca - 100
STR1  equ 82h                            ; tu zacina samotny retazec - na tomto offsete

startupcode

        mov bx,STR_I
        mov byte ptr [bx],100             ; nastavy dlzku retazca

        mov dx,offset copy_rights         ; print copyrights
        call write_str
        mov dx,offset info                ; input message
        call write_str
        mov ah,0Ah
        mov dx,STR_I                      ; read str
        int 21h
        xor ax,ax
        mov al,cs:[81h]
        mov strln,ax                      ; nastavyme premennu strln na dlzku retazca

        call next_line

        mov bx,strln
        mov byte ptr [bx+STR1],'$'        ; set end of str

        mov dx,STR1
        call write_str

        call poradove_cislo_space           ; a
        call prve_velke_pismeno             ; b
        call prve_dve_velke                 ; c
        call prve_dve_num                   ; d
        call tri_male_pis                   ; e
        call poc_nac_znaku                  ; f
        call space_in                       ; g
        call del_space                      ; h
        call pocet_malych                   ; i
        call pocet_cislic                   ; j


        mov dx,offset press
        call write_str
        xor ax,ax                           ; wait for key
        int 16h

        mov dx,offset part_two
        call write_str


        call backward                      ; backward ;-)
        call first_5_back                  ; a
        call num_back                      ; b
        call small_back                    ; c
        call big_back                      ; d
        call backward_without_spaces       ; e
        call backward_with_hvizdy          ; f
	call small2big 		           ; g
	call big2small			   ; h
	call kazde_druhe_back              ; i
        call backward_with_brackets        ; j


        int 20h                            ; koniec

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

poradove_cislo_space proc                  ; co k tomu dodat ??
        mov dx,offset msg1_a
        call write_str
        mov si,STR1                        ; si nastavy na zaciatok retazca
@@next: lodsb
        cmp al,20h                         ; je medzera ?? konci - vypis pozicu
        je  @@kon
        cmp al,'$'                         ; je koniec ?? tak konci
        jne @@next
        mov si,STR1
@@kon:  mov ax,si
        sub ax,STR1
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

prve_velke_pismeno proc
        mov dx,offset msg1_bc
        call write_str
        mov si,STR1
@@cykl: lodsb
        cmp al,'$'
        je  @@no_big
        cmp al,'A'
        jnae @@cykl
        cmp al,'Z'
        jnbe @@cykl
        sub si,STR1
        mov ax,si
        call writeint
        ret
@@no_big:
        xor ax,ax
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

prve_dve_velke proc
        mov dx,offset msg1_bc
        call write_str
        mov si,STR1
@@cykl1c: lodsb
        cmp al,'$'
        je  @@no_big1c
        cmp al,'A'
        jnae @@cykl1c
        cmp al,'Z'
        jnbe @@cykl1c
        mov ax,si
        sub ax,STR1
        push si
        call writeint
        pop si

@@cykl2c: lodsb
        cmp al,'$'
        je  @@no_big1c
        cmp al,'A'
        jnae @@cykl2c
        cmp al,'Z'
        jnbe @@cykl2c
        mov ax,si
        sub ax,STR1
        push ax
        mov dx,offset msg1_c1
        call write_str
        pop ax
        call writeint
        ret

@@no_big1c:
        xor ax,ax
        call writeint
        mov dx,offset msg1_c1
        call write_str
        xor ax,ax
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

prve_dve_num proc
        mov dx,offset msg1_d
        call write_str
        mov si,STR1
@@cykl1d: lodsb
        cmp al,'$'
        je  @@no_big1d
        cmp al,'0'
        jnae @@cykl1d
        cmp al,'9'
        jnbe @@cykl1d
        mov ax,si
        sub ax,STR1
        push si
        call writeint
        pop si
@@cykl2d: lodsb
        cmp al,'$'
        je  @@no_big1d
        cmp al,'0'
        jnae @@cykl2d
        cmp al,'9'
        jnbe @@cykl2d
        mov ax,si
        sub ax,STR1
        push ax
        mov dx,offset msg1_d1
        call write_str
        pop ax
        call writeint
        ret
@@no_big1d:
        xor ax,ax
        call writeint
        ret
        endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

tri_male_pis proc
        mov dx,offset msg1_e
        call write_str
        mov si,STR1
@@cykl1e: lodsb
        cmp al,'$'
        je  @@no_big1e
        cmp al,'a'
        jnae @@cykl1e
        cmp al,'z'
        jnbe @@cykl1e
        mov ax,si
        sub ax,STR1
        push si
        call writeint
        pop si

@@cykl2e: lodsb
        cmp al,'$'
        je  @@no_big1e
        cmp al,'a'
        jnae @@cykl2e
        cmp al,'z'
        jnbe @@cykl2e
        mov ax,si
        sub ax,STR1
        push si
        push ax
        mov dx,offset msg1_e1
        call write_str
        pop ax
        call writeint
        pop si

@@cykl3e: lodsb
        cmp al,'$'
        je  @@no_big1e
        cmp al,'a'
        jnae @@cykl3e
        cmp al,'z'
        jnbe @@cykl3e
        mov ax,si
        sub ax,STR1
        push ax
        mov dx,offset msg1_e2
        call write_str
        pop ax
        call writeint
        ret
@@no_big1e:
        xor ax,ax
        call writeint
        ret
        endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

poc_nac_znaku proc
        mov dx,offset  msg1_f
        call write_str
        mov ah,1
        int 21h
        mov ah,al
        xor bx,bx
        mov si,STR1
@@cykl1f: lodsb
        cmp al,ah
        jne  @@next1f
        inc bx
@@next1f:
        cmp al,'$'
        jne @@cykl1f
        mov dx,offset msg1_f1
        call write_str
        mov ax,bx
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

space_in proc
        mov dx,offset msg1_g
        call write_str
        mov si,STR1
        xor bx,bx
        xor cx,cx
@@cykl1g:
        lodsb
        cmp bx,3
        jne @@next1g
        xor bx,bx
;       mov dh,al
;       mov al,' '
;       mov ah,2
;       mov dl,al
;       int 21h
        inc cx
;       mov al,dh
@@next1g:
        inc bx
;       mov ah,2
;       mov dl,al
;       int 21h
        cmp al,'$'
        jne @@cykl1g
        mov ax,cx
        call writeint
        call next_line

        mov si,STR1
        xor bx,bx
@@cykl1g_:
        lodsb
        cmp bx,3
        jne @@next1g_
        xor bx,bx
        mov dh,al
        mov al,' '
        mov ah,2
        mov dl,al
        int 21h
        mov al,dh
@@next1g_:
        cmp al,'$'
        je @@exit1g
        inc bx
        mov ah,2
        mov dl,al
        int 21h
        jmp short @@cykl1g_
@@exit1g:

        ret
        endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

del_space proc
        mov dx,offset msg1_h
        call write_str
        mov si,STR1
        xor cx,cx
@@cykl1h:
        lodsb
        cmp al,' '
        jne @@next1h
        inc cx
        lodsb
@@next1h:
        cmp al,'$'
        jne @@cykl1h
        mov ax,cx
        call writeint
        call next_line


        mov si,STR1
        xor cx,cx
@@cykl1h_:
        lodsb
        cmp al,' '
        jne @@next1h_
        inc cx
        lodsb
@@next1h_:
        cmp al,'$'
        je @@exit1h
        mov ah,2
        mov dl,al
        int 21h
        jmp short @@cykl1h_
@@exit1h:
        ret
        endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

pocet_malych proc
        mov dx,offset msg1_i
        call write_str
        mov si,STR1
        xor cx,cx
@@cykl1i:
        lodsb
        cmp al,'$'
        je  @@str_ende1i
        cmp al,'a'
        jnae @@cykl1i
        cmp al,'z'
        jnbe @@cykl1i
        inc cx
        jmp short @@cykl1i
@@str_ende1i:
        mov ax,cx
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

pocet_cislic proc
        mov dx,offset msg1_j
        call write_str
        mov si,STR1
        xor cx,cx
@@cykl1j:
        lodsb
        cmp al,'$'
        je  @@str_ende1j
        cmp al,'0'
        jnae @@cykl1j
        cmp al,'9'
        jnbe @@cykl1j
        inc cx
        jmp short @@cykl1j
@@str_ende1j:
        mov ax,cx
        call writeint
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

backward proc
        mov si,STR1
        mov cx,strln
        add si,cx
        dec si
@@backward:
        DOLE
        lodsb
        mov ah,2
        mov dl,al
        int 21h
        dec cl
        jne @@backward
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
first_5_back proc
        mov dx,offset msg2_a
        call write_str
        mov si,STR1
        add si,4
        mov cx,5
        mov ah,2
        DOLE
cykl2a: lodsb
        mov dl,al
        int 21h
        loop cykl2a
        HORE
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

num_back proc
        mov dx,offset msg2_b
        call write_str
        mov si,STR1
        add si,strln
        mov ah,2
        DOLE
cykl2_b:lodsb
        cmp si,STR1
        je  no_num2b
        cmp al,'0'
        jb  cykl2_b
        cmp al,'9'
        ja  cykl2_b
        mov dl,al
        int 21h
cykl2_b_1:
        lodsb
        cmp al,'0'
        jb kon2_b
        cmp al,'9'
        ja kon2_b
        mov dl,al
        int 21h
        cmp si,STR1
        jne cykl2_b_1
kon2_b: ret
no_num2b:
        mov dx,offset msg2_b1
        call write_str
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

small_back proc
        mov dx,offset msg2_c
        call write_str
        mov si,STR1
        add si,strln
        mov ah,2
        xor cx,cx
        DOLE
cykl2_c:lodsb
        cmp si,STR1-2
        je  kon2c
        cmp al,'a'
        jb cykl2_c
        cmp al,'z'
        ja cykl2_c
        mov dl,al
        int 21h
        mov cx,1
        jmp cykl2_c
kon2c:  cmp cx,1
        je  kon2_c
        mov dx,offset msg2_c1
        call write_str
kon2_c: ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

big_back proc
        mov dx,offset msg2_d
        call write_str
        mov si,STR1
        add si,strln
        mov ah,2
        xor cx,cx
        DOLE
cykl2_d:lodsb
        cmp si,STR1-2
        je  kon2d
        cmp al,'A'
        jb cykl2_d
        cmp al,'Z'
        ja cykl2_d
        mov dl,al
        int 21h
        mov cx,1
        jmp cykl2_d
kon2d:  cmp cx,1
        je  kon2_d
        mov dx,offset msg2_d1
        call write_str
kon2_d: ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

backward_without_spaces proc
        mov dx,offset msg2_e
        call write_str
        mov si,STR1
        mov cx,strln
        add si,cx
        dec si
        mov ah,2
        DOLE
cykl2_e:
        lodsb
        cmp al,' '
        je next2_e
        mov dl,al
        int 21h
next2_e:
        dec cl
        jne cykl2_e
        ret
        endp


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

backward_with_hvizdy proc
        mov dx,offset msg2_f
        call write_str
        mov si,STR1
        mov cx,strln
        add si,cx
        dec si
        mov ah,2
        DOLE
cykl2_f:
        lodsb
        mov dl,al
        int 21h
        mov dl,'*'
        int 21h
        dec cl
        jne cykl2_f
        ret
        endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

small2big proc
	mov dx,offset msg2_g
	call write_str
	mov si,STR1
	HORE
cykl2_g:lodsb
	cmp al,'$'
	je  kon2_g
	cmp al,'a'
	jb  print2_g
	cmp al,'z'
	ja  print2_g
	sub al,20h              ; set 6 bit - small to big
print2_g:
	mov dl,al
	mov ah,2
	int 21h
	jmp cykl2_g
kon2_g: ret
	endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

big2small proc
	mov dx,offset msg2_h
	call write_str
	mov si,STR1
	HORE
cykl2_h:lodsb
	cmp al,'$'
	je  kon2_h
	cmp al,'A'
	jb  print2_h
	cmp al,'Z'
	ja  print2_h
	add al,20h              ; set 6 bit - small to big
print2_h:
	mov dl,al
	mov ah,2
	int 21h
	jmp cykl2_h
kon2_h: ret
	endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

kazde_druhe_back proc
	mov dx,offset msg2_i
	call write_str
        mov si,STR1
        mov cx,strln
        add si,cx
        dec si
	xor bx,bx
        DOLE
cykl2_i:
        lodsb
	inc bx
	cmp bx,2
	jne next2_i
	xor bx,bx
        mov ah,2
        mov dl,al
        int 21h
next2_i:
	dec cl
        jnz cykl2_i
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

backward_with_brackets proc
        mov dx,offset msg2_j
        call write_str
        mov ah,2
        mov dl,'('
        int 21h
        call backward
        mov ah,2
        mov dl,')'
        int 21h
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
writeint proc
          push ax
          mov bx,10
          xor cx,cx
wn0:      xor dx,dx
          div bx
          push dx
          inc cx
          test ax,ax
          jnz wn0
wn2:      pop dx
          or dl,'0'
          cmp dl,'9'
          jbe wn3
          add dl,7
wn3:      pusha
          mov ah,2
          int 21h
          popa
          loop wn2
          pop ax
          ret
          endp
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
write_str proc
        mov ah,9
        int 21h
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
next_line proc
        mov ah,2
        mov dl,0Dh
        int 21h
        mov dl,0Ah
        int 21h
        ret
        endp

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
; DATA
;
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.data
 copy_rights db '',13,10,'$'
 info db 'Zadaj retazec (max 100 znakov):$'
 strln dw 0
 msg1_a db 13,10,'Pozicia prvej medzery je:$'
 msg1_bc db 13,10,'Pozicia prveho velkeho pismena:$'
 msg1_c1 db ' a druheho je:$'
 msg1_d db 13,10,'Pozicia prvej cislice je:$'
 msg1_d1 db ' a druhej je:$'
 msg1_e db 13,10,'Pozicia prveho maleho pismena je:$'
 msg1_e1 db ' druheho je:$'
 msg1_e2 db ' a tretieho je:$'
 msg1_f db 13,10,'Zadaj znak:$'
 msg1_f1 db 13,10,'Pocet vyskytov znaku:$'
 msg1_g db 13,10,'Pocet pridanych medzier:$'
 msg1_h db 13,10,'Pocet zmazanych medzier je:$'
 msg1_i db 13,10,'Pocet malych pismen:$'
 msg1_j db 13,10,'Pocet cislic:$'

 press db 13,10,'Press any key...',13,10,'$'
 part_two db 'Druha cast',13,10,'$'

 msg2_a db 13,10,'Prvych 5 znakov odzadu:$'
 msg2_b db 13,10,'Cisla odzadu:$'
 msg2_b1 db 'niesu ziadne cisla$'
 msg2_c db 13,10,'Male pismena odzadu:$'
 msg2_c1 db 'niesu ziadne male pismena$'
 msg2_d db 13,10,'Velke pismena odzadu:$'
 msg2_d1 db 'niesu velke pismena$'
 msg2_e db 13,10,'Retazec odzadu bez medzier:$'
 msg2_f db 13,10,'Za kazdy znak vlozena hviezdika:$'
 msg2_g db 13,10,'Vsetky male pismena na velke:$'
 msg2_h db 13,10,'Vsetky velke pismena na male:$'
 msg2_i db 13,10,'Kazdy druhy znak retazca odzadu:$'
 msg2_j db 13,10,'Retazec odzadu uzaverty v ():$'
total_end:
end

