;Text zadania:
; S vyuzitim retazcovych instrukcii (vsade kde je to mozne vytvorte
; program, ktory :
;   1) nacita z klavesnice dva retazce do dvoch roznych segmentov
;      (minimalne 20 Byte),
;   2) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;   3) porovna posunuty retazec s retazcom v druhom segmente ,t.j.
;      zisti, ci su rovnako dlhe a ci su rovnake
;   4) zisti, ci sa v niektorom z retazcov nachadza zadany podretazec.
; vytvoril: Jan Ciganek
; 2. rocnik, Informatika,B7/15, skolsky rok 2000/2001

.286

            ASSUME    CS:CODE, DS:DATA, SS:ZAS

DATA	    SEGMENT
TEXT100     DB        13,10,' $'
TEXT00      DB        'Zadajte prvy retazec: $'
TEXT01      DB        13,10,'Zadajte druhy retazec: $'

TEXT02      DB        13,10,13,10,'Retazce nie su rovnako dlhe => su rozne !!!$'
TEXT03      DB 	      13,10,13,10,'Zadane retazce su rozne$'
TEXT04      DB        13,10,13,10,'Zadane retazce su rovnake !!!$'
TEXT05      DB        13,10,13,10,'Zadajte podretazec: $'
TEXT11      DB        'nachadza !!!$';
TEXT12      DB        13,10,13,10,'Nezadali ste ziadny podretazec !!!$'
TEXT22      DB        13,10,13,10,13,10,'zaver:',13,10,'Podretazec sa v prvom retazci $'
TEXT32      DB        13,10,'Podretazec sa v druhom retazci $'
TEXT10      DB        'nenachadza !!!$';

PRRR	    DB        10,13,' $'       ; pri mazani obrazovky
POCC	    DB        26	       ; pomocne premenne
POMOC	    DB        30,32 DUP(?)
TEX1  	    DB        30,42 DUP(?)     ; 32+10 - bude sa to o 10 posuvat
DATA	    ENDS

DATA2	    SEGMENT
TEX2	    DB        30,32 DUP(?)
DATA2	    ENDS

ZAS	    SEGMENT   STACK
	    DW	      128 DUP (?)
ZAS	    ENDS

CODE	    SEGMENT
START:	    MOV       AX, SEG DATA
	    MOV       DS, AX		
	    CALL      ZMAZ       ; procedura na zmazanie obrazovky

	    MOV       AH, 09H
	    LEA       DX, TEXT00
	    INT       21H 	 ; vypise aby ste zadali 1. retazec
	    MOV       AH, 0AH
	    LEA       DX, TEX1	 ; nacitanie 1. retazca
	    INT       21H

	    MOV       AH, 09H
	    LEA       DX, TEXT01
	    INT       21H 	 ; vypise aby ste zadali 2. retazec

	    PUSH      DS  	 ; da segment do zasobnika

	    MOV       AX, SEG DATA2
	    MOV       DS, AX	 ; datovy segment DATA2

	    LEA       DX, TEX2   ; nacitanie 2. retazca
	    MOV       AH, 0AH
	    INT       21H 		

	    POP       DS	 ; vratime spat segment

; POSUN O 10 ZNAKOV 
	    XOR       AX, AX     ; XOR samo so sebou => vynulovanie
	    MOV       AL, [TEX1+1] ; zistime velkost 1. retazca (adresa TEXT1 je len to maximum (takze este +1))
	    ADD       AL, 2	 ; priratm 2 lebo enter, aj pocet
	    MOV       CX, AX	 ; zapamatam si velkost, aby som vedel kolko krat to mam opakovat CX pouzije REP
	    ADD       AX, (OFFSET TEX1) ; najdem koniec retazca (ADRESA+POCET)
	    MOV       SI, AX	 ; SI ukazuje odkial to chcem (na koniec) .. SI na konci textu
	    ADD       AX, 10	 ; budem posuvat o 10
	    MOV       DI, AX	 ; DI ukazuje tam, kam to chcem (na koniec)
	    MOV       AX, DS	 ; posuvam v tom istom segmente
	    MOV       ES, AX	 ; ES = DS
	    STD			 ; odzadu, aby sa to neprepisovalo
	    REP       MOVSB	 ; opakuje to CX krat, CX krat to posunie

;  POROVNANIE DVOCH RETAZCOV 
	    CLD			 ; naspat odpredu
	    MOV       AX, SEG DATA2
	    MOV       ES, AX	 ; do ES dam segment DATA2
	    MOV       SI, (OFFSET TEX1)+11 ; SI ukazuje na TEXT1
	    MOV       DI, (OFFSET TEX2)+1  ; DI ukazuje na TEXT2
	    CMPSB		 ; porovna velkost retazcov ... dlzku
	    JE        SKOC01     ; iba prvy znak retazcov, co je POCET)
	    MOV       AH, 09H    ; vypise text ze retazce nie su rovnako
	    MOV       DX, OFFSET TEXT02 ; dlhe, preto nie su rovnake
	    INT       21H
	    JMP       PODRETAZEC ; ak nie su rovnako dlhe skoci na PODRETAZEC
SKOC01:     XOR       CX, CX     ; sem skoci, ak su retazce ronako dlhe
	    MOV       CL, [TEX1+11] ; velkost retazca do CX (kolko kret to budem opakovat)
	    REPE      CMPSB      ; je jedno ktoreho retazca, lebo su rovnake
	    JE        ROVNAKE    ; ak su rovnake tie retazce skoc na ROVNAKE
	    MOV       AH, 09H    ; vypise, ze retazce su rozne
	    LEA       DX, TEXT03
	    INT       21H
	    JMP       PODRETAZEC ; skoci na PODRETAZEC
ROVNAKE:    MOV       AH, 09H    ; vypise, ze su retazce rovnake
	    LEA       DX, TEXT04
	    INT       21H

;NACITANIE PODRETAZCA 
PODRETAZEC: LEA       DX, TEXT05 ; vypise text, aby ste zadali podretazec
	    INT       21H

	    MOV       DX, OFFSET POMOC
	    MOV       AH, 0AH
	    INT       21H 	 ; nacitanie podretazca

	    MOV       AL, [POMOC+1]
	    CMP       AL, 0H     ; porovnanie, ak ste nezadaly ziadny podretazec
	    JNZ       ZACNI      ; ak ste nieco zadali skoci na ZACNI

	    MOV       AH, 09H	 ; vzpise, ze ste nezadali ziadny podretazec
	    LEA       DX, TEXT12
	    INT       21H
	    JMP       CAKA	 ; skoci na CAKA, kde pocka na enter a skonci

; PODRETAZCA V RETAZCOCH 
ZACNI:	    MOV       AH, 09H
	    LEA       DX, TEXT22
	    INT       21H 	 ; vypise ze ci sa to v prvom retazci ...

	    MOV       AX, SEG DATA
	    MOV       ES, AX	 ; segment prveho retazca
	    MOV       DI, (OFFSET TEX1)+11 ; adresa (posunutia) 1.retazca

	    CALL      HLADAJ_POD ; procedura, ktora hlada, ci sa podretazec nachadza v retazci

	    MOV       AH, 09H
	    LEA       DX, TEXT32
	    INT       21H 	 ; vypise ze ci sa to v druhom retazci ...

	    MOV       AX, SEG DATA2
	    MOV       ES, AX	 ; segment druheho retazca
	    MOV       DI, (OFFSET TEX2)+1 ; adresa 2. retazca (normalna)

	    CALL      HLADAJ_POD ; procedura, ktora hlada, ci sa podretazec nachadza v retazci

; CAKANIE NA ENTER 
CAKA:	    MOV       AH, 7H     ; caka na stlacene klavesy
	    INT       21H
	    CMP       AL, 13     ; a ak zadate enter
	    JZ        KONIEC     ; skoci na KONIEC
	    JMP       CAKA       ; ak nestlacite enter opat skoci na CAKA

;UKONCENIE PROGRAMU 
KONIEC:     MOV       AH, 4CH    ; ukoncenie programu
	    INT       21H



;HLADANIE PODRETAZCA V RETAZCI 
HLADAJ_POD  PROC                 ; v ES je segment, kde mame retazec a v DI je jeho adresa
	    MOV       AL, ES:[DI] ; dlzku retazca nacitame zo segmentu ES a adresy DI
	    INC       DI         ; teraz ukazuje DI na prvy znak (naozajstny)
	    CBW
	    MOV       CX, AX     ; v CX je pocet opakovani
	    MOV       SI, (OFFSET POMOC)+2 ; adresa podretazca
	    LODSB	         ; v AL je prvy znak podretazca AL <- DS:[SI]

OPAKUJ:     REPNE     SCASB      ; opakuje CX krat a hlada prvy znak (DI sa posuva automaticky)
	    JNE       NIE_JE     ; ak tam nie je ani len prvy znak, alebo nie je v tom zvysku
	    PUSH      AX         ; odlozime nase premenne
	    PUSH      CX
	    PUSH      DI

	    XOR       CX, CX
	    MOV       CL, [POMOC+1] ; do CL dlzku hladaneho podretazca
	    DEC       CL	 ; decrementuje CL, lebo o ten prvy znak uz nechceme
	    MOV       SI, (OFFSET POMOC)+3 ; tu je start (druhy znak)

	    REPE      CMPSB	 ; overime, ci sa zhoduje retazce ES: DI a DS:SI
	    JNE       NEXT	 ; ak nie skus najst dalsi rovnaky znak, skoc na NEXT
	    ADD       SP, 6	 ; zmaze veci ... PUSH (SP je pointer v zasobniku)

	    MOV       AH, 09H
	    LEA       DX, TEXT11
	    INT       21H 	 ; napise, ze sa to tam 'nachadza'
	    JMP       KON_PROC

NEXT:	    POP       DI	 ; ak sme nic nenasli pokracujeme v hladani prveho znaku
	    POP       CX
	    POP       AX
	    JMP       OPAKUJ     ; skoci na OPAKUJ

NIE_JE:     MOV       AH, 09H
	    LEA       DX, TEXT10
	    INT 21H 		; napise, ze sa to tam 'nenachadza'
KON_PROC:   RET                 ; return
	    ENDP                ; a koniec procedury

; ZMAZANIE OBRAZOVKY 
ZMAZ        PROC                 ; zmaze obrazovku
	    MOV       AX, 03H
	    INT       10H
	    RET
ENDP

CODE	    ENDS
	    END       START


;kruzok B7/15, skolsky rok 2000/2001, II - rocnik , Informatika          
;zadanie cislo 3                                                          
;poznamky: program pracuje podla zadania                                  
; - v programe je obmedzena dlzka retazcov 30 znakov                     
; - nesmie sa zadavat znak $                                              
;zoznam pouzitych procedur:                                              
; - HLADAJ     - hladanie podretazca v retazcoch                          
; - ZMAZ       - zmazanie obrazovky                                       
