.model small                                      ;deklaracia maleho modulu
zas	segment		stack                     ;zaciatok zasobnikoveho segmentu
	db	100H dup(?)                       ;definovanie 100 znakov
zas	ends                                      ;koniec zasobnikoveho segmentu
data	segment                                   ;zaciatok datoveho segmentu
mstr    db      104 dup (101);                    ;premenna pre nacitanie retazca
vstup	db	100
pocet	db	0
	db	103 dup(?)
nr	db	0Ah
	db	0Dh
	db	'$'
menu0	db	'Ocakavam vstupny retazec: $'
menu1	db	'V - vypis retazec$'
menu2   db      'S - vypis pocet cislic$'
menu3   db      'F - najdi zadany znak$'
menu4   db      'M - najdi min znak$'
menu5   db      'Z - male konvertuj na velke$'
menu6   db      'R - zarovnaj zprava$'
menu7   db      'K - koniec$'
oznam_c1 db     'Zadajte, ktory mam vyhladat$'
oznam_c2 db     'Znak " " sa v retazci nachadza na pozicii $'
oznam_c3 db     'Znak " " sa v retazci nenachadza. $'
oznam_c4 db     'Konvertovany retazec : ',0DH,0AH,'$'
oznam_b db      'Pocet cislic v retazci: $'
cislica db      '00000$'               ;formular pre cislicu
clear   dw 25dup (0d0ah)               ;retazec na odriadkovanie  
        db '$'
data    ends                                      ;koniec datoveho segmentu

code    segment                                   ;zaciatok kodoveho segmentu
        assume ds:data,ss:zas,cs:code             ;oznam aktivnych segmentov
riadkuj         proc	near
	mov	dl,	13               ;vypis znaku 0dh na obrazovku
	mov	ah,	2                ;sluzbou cislo 2
	int	21h
	mov	dl,	10               ;vypis znaku 0ah na obrazovku
	mov	ah,	2
	int 	21h
	mov	ah,	09h
	ret
riadkuj         endp

vypis_menu      proc	near	        
	mov	ax,	seg data         ;presunie do segmentoveho registra ds adresu datoveho segmentu
	mov	ds,	ax
	mov	dx,	offset menu1     ;do dx idu relativne adresy jednotlivych premennych menu
	mov	ah,	09h              ;a nasledne je vypisovana sluzbou na vypis retazca na 
	int	21h
	call	riadkuj                  ;obrazovku
	mov	dx,	offset menu2     ;na riadkovanie sluzi procedura riadkuj
	int	21h
	call	riadkuj
	mov	dx,	offset menu3
	int	21h
	call	riadkuj
	mov	dx,	offset menu4
	int 	21h
	call	riadkuj
	mov	dx,	offset menu5
	int	21h
	call	riadkuj
	mov	dx,	offset menu6
	int 	21h 
	call	riadkuj
	mov	dx,	offset menu7
	int 	21h
	call	riadkuj
	ret
vypis_menu      endp

vypis_ret       proc	near         ; vypise retazec v povodnom poradi znakov pomocou cyklickeho vypisu znakov 
	mov	dx,	offset pocet ;nastavenie pred zaciatok retazca
	mov	bx,	dx
	xor	cx,	cx
	mov	cl,	[bx]         ;inicializacia pocitadla
lak:
	inc	bx
	mov 	dl,	[bx]
	mov	ah,	02h          ;vystup jedneho znaku na obraz
	int	21h
	loopne	lak	             ;cyklus z vyuzitim pocitadla cx
	ret
vypis_ret       endp

minimum         proc	near    ; najde v retazci znak z minimalnou ascii hodnotou a vypise ho na obraz
	mov	dx,	300
	mov	bx,	offset pocet
	xor	cx,	cx               ;vynulovanie pocitadla
	mov	cl,	[bx]             ;inicializacia pocitadla
lbk:
	inc	bx
	cmp	dl,	[bx]             ;porovna ciastkovy vysledok z aktualnym
	jb	lck                      ;znakom retazca,ak je akt.
	mov	dl,	[bx]             ;znak mensi tak ho ulozi ako novy
lck:	                                 ;ciastocny vysledok a pokracuje
	loopne 	lbk
	mov	ah,	2                ;na konci je vysledok v dx
	int	21h                      ;a sluzbou na vystup znaku sa vypise
	ret
minimum         endp
	
nacitaj_znak	proc	near  ;nacita znak z klavesnice a podla jeho hodnoty vola prislusnu polozku menu
	mov	ah,	01h   ;nacitanie znaku z klav sluzbou na to urcenou
	int	21h
	cmp	al,	66h   ;porovnavanie znaku a skoky na prislusne 
	je	proc3         ;volania procedur
	cmp	al,	6Bh
	je	proc7
	cmp	al,	6Dh
	je	proc4
	cmp	al,	72h
	je	proc6
	cmp	al,	73h
	je	proc2
	cmp	al,	76h
	je	proc1
	cmp	al,	7Ah
	je	proc5
	call riadkuj
	ret




	

proc1:	call riadkuj       ;vypise sa retazec
	call vypis_ret
	call riadkuj
	ret
proc2:	call riadkuj         ;zisti pocet cislic v retazci
        call pocet_cislic
        call riadkuj
	ret
proc3:	call riadkuj         ;vyhlada zadany znak
        call vyhladanie
        call riadkuj
	ret
proc4:	call riadkuj         ;najde znak s minimalnou hodnotou
	call minimum
	call riadkuj
	ret
proc5:	call riadkuj         ;prekonvertuje male pismena na velke
        call konverzia 
	call riadkuj
        ret
proc6:	call riadkuj         ;zarovna retazec zprava
        
	ret
proc7:	call riadkuj         ;ukonci sa program
	mov	ah,	4Ch
	ret	
nacitaj_znak	endp

pocet_cislic proc near          ;prehlada cely retazec a scita pocet cislic v nom
        push ax
        xor cx,cx
        mov dx,offset mstr      ;do dx ide relativna adresa procedury mstr
        inc dx
        mov di,dx
        mov cl,byte ptr ds:[di]
        xor dx,dx
  cyklus_b:
        INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AL,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AL,30H		; TU ZACINAJU CISLICE V ASCII TABULKE
	JB  NIC_B		; NIC Z TOHO
	CMP AL,39H		; TU KONCIA CISLICE
	JNBE NIC_B		; NIC Z TOHO
	INC DX			; PRESIEL SITOM -> JE TO CISLICA
  NIC_B:
        LOOP CYKLUS_B		; CYKLUS, KYM CX JE VECSIE AKO 0
  
	CALL CLRSCR
	PUSH DX
	MOV DX,OFFSET OZNAM_B	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	POP DX
	CALL ZOBRAZ_CISLO	; ZOBRAZI CISLO
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
POCET_CISLIC ENDP
	


VYHLADANIE PROC NEAR	
	PUSH AX
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_C1
	MOV AH,09H		; VYPIS VYZVY NA ZADANIE ZNAKU
	INT 21H
	MOV AH,01H		; VSTUP ZNAKU S ECHOM NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	MOV DI, OFFSET OZNAM_C2
	MOV DS:[DI+6 ],AL	; DOPLNENIE ZNAKU DO SPRAVY	 
	MOV DI, OFFSET OZNAM_C3
	MOV DS:[DI+6 ],AL	; DOPLNENIE ZNAKU DO SPRAVY	 
	CALL CLRSCR
	
	XOR CX,CX		; NULOVANIE CX
	MOV DX,OFFSET MSTR	; NASTAVIM SA NA ZACIATOK MSTR
	INC DX			; PRESKOCIM BYTE "MAX"
	MOV DI,DX		; VLOZIM ZACIATOK DO DI
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
	XOR DX,DX		; DO DX BUDEM DAVAT POCET NAJDENYCH ZADANYCH ZNAKOV
  CYKLUS_C:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	INC DX			; ZAPAMETAM SI POZICIU
	MOV AH,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AH,AL		; V AH JE ZNAK Z RETAZCA, V AL JE ZADANY ZNAK
				; POROVNAM ICH
	JE  ANO_C		; NASIEL SOM
	LOOP CYKLUS_C		; CYKLUS, KYM CX JE VECSIE AKO 0
	CALL CLRSCR
	MOV DX, OFFSET OZNAM_C3
	MOV AH,09H
	INT 21H
	JMP KONIEC_C
  ANO_C:
	PUSH DX
	MOV DX,OFFSET OZNAM_C2	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	POP DX
	CALL ZOBRAZ_CISLO	; ZOBRAZI CISLO
KONIEC_C:
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
VYHLADANIE ENDP 

CLRSCR PROC NEAR		; ZMAZANIE OBRAZOVKY  
	PUSH AX
	PUSH BX
	PUSH DX
	MOV DX,OFFSET CLEAR	; ADRESA PREMENNEJ DO DX
	MOV AH,09H		; FUNKCIA VYPIS NA OBRAZOVKU
	INT 21H
	MOV BH,00H		; NASTAVENIE KURZORA NA [1,1]
	MOV AH,02H
	MOV DH,00H
	MOV DL,00H
	INT 10H
	POP DX
	POP BX
	POP AX
	RET
CLRSCR ENDP
  
ZOBRAZ_CISLO PROC NEAR		; ZOBRAZI CISLO - OCAKAVA HO V DX
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	MOV DI,OFFSET CISLICA 
	MOV AX,DX		; DO AX IDE CISLO
	XOR DX,DX
	MOV CX,10000		; DELIM PRVU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO DX
	ADD AX,30H
	MOV BYTE PTR DS:[DI],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,1000		; DELIM DRUHU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+1],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,100		; DELIM TRETIU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+2],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,10		; DELIM STVRTU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+3],AL
	ADD DX,30H
	MOV BYTE PTR DS:[DI+4],DL ; ZVYSOK JE POSLEDNA CISLICA (JEDNOTKY)
	MOV DX, OFFSET CISLICA
	MOV AH,09H
	INT 21H			; VYPIS CISLIC	
	POP DX
	POP CX
	POP BX
	POP AX
	RET
ZOBRAZ_CISLO ENDP
	

KONVERZIA PROC NEAR
	PUSH AX
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_C4	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	XOR CX,CX
	MOV DX,OFFSET MSTR
	INC DX
	MOV DI,DX
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
  CYKLUS_E:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AL,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AL,61H		; TU ZACINAJU MALE PISMENA V ASCII TABULKE
	JB  NIC_E		; NIC Z TOHO
	CMP AL,7AH		; TU KONCIA MALE PISMENA
	JNBE NIC_E		; NIC Z TOHO
	MOV AH,00H		; PRESIEL SITOM -> JE TO MALE PISMENO
	SUB AX,20H		; ZKONVERTUJEM HO NA VELKE
  NIC_E:MOV DL,AL		; DO DL IDE (KONVERTOVANY) ZNAK
  	MOV AH,02H
	INT 21H			; ZOBRAZI ZNAK Z DL	
  	LOOP CYKLUS_E		; CYKLUS, KYM CX JE VECSIE AKO 0
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	
	POP AX
	RET
KONVERZIA ENDP
start:
	mov 	ax,	seg data        ;nastavenie datoveho segm do reg ds
	mov 	ds,	ax
	mov	dx,	offset menu0    ;vypis vyzvy na vstup retazca
	mov	ah,	09h
	int	21h
	mov	dx,	offset vstup    ;vstup retazca z kl
	mov	ah,	0Ah
	int	21h
        call riadkuj                    ;cyklicky vypisuje
cyklus:	
	call 	vypis_menu              ;vypisuje menu
	call	nacitaj_znak            ;nacita riadiaci znak a vola prislusny
	cmp	ah,	4Ch             ;kod pri znaku K skonci cyklus
	je	koniec                  ;a cely program
	jmp	cyklus
koniec:
	mov	ah,	4CH	
	int 	21h                          ;navrat do ms-dos
code	ends                                 ;koniec kodoveho segmentu
	end start                            ;koniec suboru




