;ZADANIE CISLO 2.      
;Program,ktory nacita zo vstupneho suboru
;postupnost cisel (aspon 10) a potom:

; a)scita ich (ak pretecie oznami)
; b)usporiada vzostupne a zapise vysledok do vystupneho subora
; c)vydeli dve vybrane cisla
; d)vynasobi dve vybrane cisla
; e)ukonci sa

;Vypracoval: DALIMIR ORFANUS
;Kruzok: B 12
;Termin odovzdania: 14. XI. 2000
;2.rocnik; sk. rok. 2000/2001

;======================================                                                             
                zas     segment stack                      ; definicia stakoveho segmentu
                dw      64 dup(?)                                                        
                zas     ends                                                             

;======================================                                                  

                data    segment                                                          

buff            db      1024 dup(?)                        ; buff na subor               
subor           db      'input.txt', 0                     ; meno subora v ASCIIZ        
subor2          db      'output.txt', 0                    ; meno subora na output v ASCIIZ
handle          dw      ?                                  ; handle na subor             
text            db      10 dup(?)                          ; na text                     
nl              db      0dh, 0ah, '$'                                                    
text1           db      0dh, 0ah, 'Suma vsetkych cisel.........A', 0dh, 0ah              
                db      'Usporiadat vzostupne a vypisat do subora......B', 0dh, 0ah      
                db      'Vydeli dve vybrane cisla..............C', 0dh, 0ah              
                db      'Vynasobi dve cisla...............D', 0dh, 0ah                   
                db      'Koniec programu.........Q', 0dh, 0ah                                       
                db      'Vyber: ', '$'                                                              
text2           db      'Chyba pri nacitani suboru!!!', 0dh, 0ah, '$'                    
text3           db      '.: ', '$'                                                       
text4           db      0dh, 0ah, 'PRETECENIE!!!!', 0dh, 0ah, '$'                        
text5           db      0dh, 0ah, 'Zadaj 1. cislo: ', '$'                                
text6           db      0dh, 0ah, 'Zadaj 2. cislo: ', '$'                                
text7           db      0dh, 0ah, 'Zvysok: ', '$'                                        
nasobky         dw      1h                                                               
                dw      0ah                                                              
                dw      64h                                                              
                dw      3e8h                                                             
                dw      2710h                                                            
cisla           dw      10 dup(?)                          ; nacitane cisla v doplnkovom kode
cisla2          dw      10 dup(?)                                                        
pom             db      -100                               ; pomocna testovacia premenna 
kolko           db      ?                                                                
                data    ends                                                             

;======================================                                                             

                code    segment                                                          
                assume  cs:code, ds:data, ss:zas                                         
start:                  
                mov     dx, seg subor                                                    
                mov     ds, dx                                                           
;-- Otvorenie subora                                                                     

                mov     ah, 3dh                            ;otvorime si subor "input.txt"
                mov     al, 00010010b                                                    
                mov     dx, offset subor                                                 
                int     21h                                                              
                jc      CHYBA                              ; ak nastala nejaka chyba
                mov     handle, ax                         ;odlozime si cislo subora

;-- Nacitanie do zasobnika                                                               

                mov     ah, 3fh                            ;nacitame si obsah suboru do buffera
                mov     bx, handle                                                                  
                mov     cx, 1024                                                                    
                mov     dx, offset buff                                                  
                int     21h                                                              
                jc      CHYBA                              ;ak nahodou chyba

;-- Zatvorenie subora                                                                    

                mov     ah, 3eh
                mov     bx, handle                          
                int     21h                    
                jc      CHYBA                  
;--------------------                          
                call    NACITAJ                            ; nacita do pola prekonvertovane ASCII z bufera

MENU:                   
                mov     ah, 09h                            ;NL
                mov     dx, offset nl          
                int     21h       

                mov     dx, offset cisla                   ;Vypise zoznam nacitanych cisel
                mov     cl, kolko                                      
                call    VYPIS                                          

                mov     ah, 09h                            ; Namaluje menu
                mov     dx, offset text1       
                int     21h                    

                mov     ah, 01h                            ;caka na stisnutie klavesy
                int     21h                               

;-- ROZKOK --
                cmp     al, 'a'                           
                jne     DALEJ_M_1                
                jmp     SUMA                   
DALEJ_M_1:              
                cmp     al, 'b'
                jne     DALEJ_M_2
                jmp     USPORIADAJ
DALEJ_M_2:              
                cmp     al, 'c'                                                                     
                jne     DALEJ_M_3
                jmp     VYDEL
DALEJ_M_3:              
                cmp     al, 'd'
                jne     DALEJ_M_4
                jmp     VYNASOB
DALEJ_M_4:              
                cmp     al, 'q'
                jne     MENU
                jmp     KONIEC


                mov     dx, offset cisla
                mov     cl, kolko 
                call    VYPIS     

                jmp     KONIEC    

;-- Subor sa nenasiel, chyba citania, chyba zatvorenia                                              
CHYBA:                  
                mov     ah, 09h         
                mov     dx, offset text2
                int     21h             
;-- terminate signal
KONIEC:                 
                mov     ax, 4c00h                
                int     21h                      
;=======================================================
SUMA:                                                      ;suma   fsetkich cisel
                mov     ah, 09h                            ;NL
                mov     dx, offset nl
                int     21h          

                xor     cx, cx                   
                xor     bx, bx                             ;do CX kolko, v BX bude vysledok
                mov     cl, kolko                              
                mov     si, offset cisla                                                            
                clc                                        ;pre istotu
CYKLY_SUMA_1:           
                LODSW                                      ;nacitame si ciselko do AX
                add     bx, ax                             ;a scitame
                jo      PRETECENIE_SUMA                    ; ked pretecie vyskoc z cyklu
                LOOP    CYKLY_SUMA_1                      

                mov     ax, bx                             ;Vypis vysledok
                call    PIS1                              
                jmp     MENU                               ;skoc do MAIN-u

PRETECENIE_SUMA:        
                mov     ah, 09h                            ;ak sucet pretiekol, potom to oznam
                mov     dx, offset text4                           
                int     21h                                        
                jmp     MENU                               ;a az potom si skoc do MAIN-u
;==========================================               
USPORIADAJ:             
                mov     dx, ds                             ; do pola CISLA2 si skopirujem pole CISLA
                mov     es, dx                                                                      
                mov     di, offset cisla2                                
                mov     si, offset cisla                                 
                xor     cx, cx                                           
                mov     cl, kolko                                        
                REPZ    MOVSW                                            

;cez minimum                                                             
                mov     si, offset cisla2                  ; nastav si veci pred cyklami
                mov     ch, 1                                            
CYKLY_USP_I:            
                mov     ax, [si]                           ; v ax bude "relativne minimum
                mov     cl, ch                             ; CL je riadiaca premenna vn. cyklu a CH von.
                mov     di, si                             ; do DI:=SI+2 (aby ukazoval o 1 "okienko dalej"
                add     di, 2
CYKLY_USP_J:            
                inc     cl                                 ; inc riadiacu premennu
                cmp     ax, [di]                           ; porovnaj, kam ukazuje SI s tym co je na [DI]
                jl      POKRACUJ_USP                       ; ak nie je mensie, tak preskocim vymenu
                mov     bx, [di]                           ; vymena [DI]<->[SI]               
                mov     [si], bx                     
                mov     [di], ax                     
                mov     ax, bx                       
POKRACUJ_USP:           
                add     di, 2                              ;posun dalej DI
                cmp     cl, kolko                          ; uz som na konci pola?                             
                jne     CYKLY_USP_J                        ;ak nie, potom opakuj cyklus cez J

                add     si, 2                              ; posun SI
                inc     ch                                 ; ci je CH<n-1
                cmp     ch, kolko        
                jne     CYKLY_USP_I                        ;ak este nie, potom opakuj cyklus cez I
; teraz to vypise                                                         
                mov     ah, 09h                            ; urobi novy riadok
                mov     dx, offset nl                
                int     21h                          
                mov     dx, offset cisla2                  ;priprava parametrov na vypis pola CISLA2
                xor     cx, cx
                mov     cl, kolko
                call    VYPIS                              ; samotny vypis
;teraz vypis do subora 
                mov     dx, offset cisla2
                xor     cx, cx
                mov     cl, kolko
                call    VYPIS_DO_SUB
                jmp     MENU                               ; navrat do MAIN-u      
;==================================================            
VYDEL:                  
                xor     cx, cx                             ; mv CX, 0
                mov     ah, 09h        
                mov     dx, offset text5                   ; oznam aby zadal 1. pr. cislo cisla
                int     21h

                mov     ah, 01h
                int     21h    
                sub     al, '1'                            ; v al poradove cislo 1.
                mov     cl, al

                mov     ah, 09h                            ; to iste ako pre 1. cislo
                mov     dx, offset text6                  
                int     21h                               

                mov     ah, 01h                           
                int     21h                               
                sub     al, '1'                           
                mov     dl, al                            

                mov     si, offset cisla 
                inc     cl                                
CYKLY_DEL_1:            
                LODSW    
                LOOP    CYKLY_DEL_1                        ;do BX si dam 1. prvok

                mov     bx, ax
                mov     cl, dl           
                inc     cl               
                mov     si, offset cisla 
CYKLY_DEL_2:            
                LODSW    
                LOOP    CYKLY_DEL_2                        ; v BX delenec v AX delitel => vymena
                xchg    ax, bx 
                cwd                                        ;AX->DXAX
                idiv    bx                                 ;del so znamienkom 
                push    dx                                 ;odloz si zvysok
                push    ax                                 ;odloz si celociselne delenie

                mov     ah, 09h                            ;NL
                mov     dx, offset nl                   
                int     21h                             

                pop     ax                                 ; do obnov AX
                call    PIS1                               ; vypis cisla                

                mov     ah, 09h                            ; vypis: "Zvysok"
                mov     dx, offset text7                
                int     21h                          

                pop     ax                                 ;do AX obnovi to, co bolo predtym v DX
                call    PIS1                               ; a samozrejme, ze vypise

                jmp     MENU                               ; spat do MAIN-u

VYNASOB:                
                xor     cx, cx
                mov     ah, 09h
                mov     dx, offset text5                   ; oznam aby zadal por. cislo 1. clena
                int     21h                                                                     

                mov     ah, 01h                                                                 
                int     21h                                                                     
                sub     al, '1'                            ; v al poradove cislo 1.
                mov     cl, al 

                mov     ah, 09h                            ;to iste ale pre 2. cislo
                mov     dx, offset text6                 
                int     21h                              

                mov     ah, 01h                          
                int     21h                              
                sub     al, '1'                          
                mov     dl, al                             ;teraz je v CL por.cis. na 1. a v DL na 2.

                mov     si, offset cisla                                 
                inc     cl
CYKLY_NASOB_1:                                             ;do     AX si nacitame 1.
                LODSW    
                LOOP    CYKLY_NASOB_1                                    

                mov     bx, ax                             ;ale este si ho odlozime do BX
                mov     cl, dl                                           
                inc     cl                                               
                mov     si, offset cisla                                 
CYKLY_NASOB_2:                                             ;teraz  si nacitame do AX 2. cislo
                LODSW    
                LOOP    CYKLY_NASOB_2                      ;a teraz si to peken prenasobime
                imul    bx
                jo      PRETECENIE_NASOB                   ;ak by doslo k preteceniu zo 16b->32b
                push    ax                                 ;v AX je vysledok, ktory si teraz odlozim
;DX ignorujem          
                mov     ah, 09h                            ;NL
                mov     dx, offset nl                               
                int     21h                                         

                pop     ax                                 ;obnovym AX
                call    PIS1                               ;a vypisem vysledok
                jmp     MENU                               ;spat do MAIN-u
PRETECENIE_NASOB:        
                mov     ah, 09h                            ;ak som nahodou trosku pretiekol, potom oznam
                mov     dx, offset text4                                     
                int     21h                 
                jmp     MENU                               ;a po vypisani oznamu sa vratim spat do MAIN-u


;=======================================================                   
PIS1            PROC                                       ;vypisuje iba 1 cislo; ktore je v AX
;------------------------------------------------------- 
                mov     di, offset text                  
                call    BIN2ASCII                                          
                mov     ah, 09h                                            
                mov     dx, offset text                                    
                int     21h                                                
                ret      
                ENDP     
;=======================================================                   
VYPIS           PROC     
;-------------------------------------------------------                   
; v CL kolko vypisat                                                       
; v DX offset na pole wordov, kde su cisla                                 
                mov     si, dx                                             
                mov     dh, cl                             ; dame si aj do DH pocet cisel

CYKLY_VYPIS:            
                mov     dl, dh                             ; do DL pocet, odcitaj CL
                sub     dl, cl                             ; + '1' - aby islo od 1 a nie od 0
                add     dl, '1'                          
                mov     ah, 02h                            ; zobraz to cislo
                int     21h                              
                mov     ah, 09h                            ; zobraz '.: '
                mov     dx, offset text3                       
                int     21h                                    

                LODSW    

                mov     di, offset text                    ; konvertuj a uloz do text
                call    BIN2ASCII                                 

                mov     ah, 09h                            ; zobraz text
                mov     dx, offset text                  
                int     21h                              
                mov     ah, 09h                            ; urob novy riadok
                mov     dx, offset nl                    
                int     21h                              
                LOOP    CYKLY_VYPIS                      
                ret      
                ENDP     
;======================================================= 
NACITAJ         PROC                                       ; prevedie do pola wordov
;------------------------------------------------------- 
                mov     si, offset buff                  
                mov     bp, offset cisla                 
                xor     cx, cx                           

CYKLY_N:                
                xor     dx, dx                             ; predpoklad, ze je >0
                mov     es, dx                           
                mov     al, [si]                         
                cmp     al, ' '                            ; ak je medzera, potom posun dalej
                je      SKOK_1N                           
                cmp     al, '-'                            ; ak nie je minus, potom skac
                jne     SKOK_2N                           
                mov     dx, 1                              ; poznacit si, ze je minus
                mov     es, dx                            
                inc     si                                 ; a posunieme sa dalej
SKOK_2N:                
                mov     di, si                            
                inc     cx                                
SKOK_2aN:                                                  ;najdem si offset na zac. a koniec cisla
                inc     si                                
                mov     al, [si]                          
                cmp     al, ' '                           
                jne     SKOK_2aN                           ;Hladam koniec cisla

                dec     si                               
                push    si                               
                push    bp                               
                XCHG    si, di   
                call    ASCII2BIN                          ;a konecne si mozem zavolat proceduru, ktora
                pop     bp                                 ;mi prevedie do doplnkoveho kodu
                mov     si, bp                             
                mov     [si], ax                           ;to cislo si odlozim do pola
                pop     si                               
                add     bp, 2                              ;posuniem sa dalej v poli cisel

SKOK_1N:                
                inc     si                                 ;test ci nie je koniec nacitavanych cisel
                mov     al, [si]                                   
                cmp     al, '$'                                    
                je      KONIEC_N                                   
                cmp     cx, 10                             ;test ci som uz nenacital 10 cisel
                jne     CYKLY_N                                 
KONIEC_N:               
                mov     kolko, cl                          ; zapamatame si pocet precitanych cisel
                ret      
                ENDP     
;=======================================================        
ASCII2BIN       PROC                                       ; ASCII prevedie do 16 bit. doplnkoveho kodu
;-------------------------------------------------------        
; v SI zacitok znakov, v DI koniec znakov                       
; v ES znamienko (0 nie je, 1 je)                               
; !!!!!POZOR pouziva AX !!!!!!!!!!!!                            
; v AX vysledok                                                 
                push    bx                                      
                push    cx                                      
                push    dx                                      

                mov     ax, si                             ; do CX=DI-SI
                mov     cx, di                                  
                sub     cx, ax                                  
                inc     cx                                      
                xor     bx, bx                             ; BX=0
                mov     si, offset nasobky                      
CYKLY_A2B:              
                xor     ah, ah                                  
                mov     al, [di]                                
                dec     di                                      
                sub     al, '0'                                 
                mov     dx, [si]                                
                add     si, 2                                   
                mul     dx                                      
                add     bx, ax                             ; lebo vysledok nasobenoa je v DX, AX
                LOOP    CYKLY_A2B                               

                mov     ax, bx                             ; tvorba doplnkoveho kodu
                mov     bx, es                                  
                cmp     bx, 0                                   
                je      SKOC                               
                neg     ax                                 
SKOC:                   
                pop     dx                                 
                pop     cx                                 
                pop     bx                                 

                ret      
                ENDP     
;========================================================  
BIN2ASCII       PROC                                       ; prevedie cislo v AX na string
;--------------------------------------------------------  
; v AX cislo, v DI ukazovatel na retazec                   
                push    ax                                 
                push    bx                                 
                push    cx                                 
                push    dx                                 
                clc      
                mov     cx, 1                              ; ze este nic nepisal do retazca
                cmp     ax, 0                              ;je to dobre, aby nevypisoval nuly az potom cisla
                jge     SKOC1                              
                mov     bl, '-'                            ;ze je to minus
                mov     [di], bl               
                inc     di                     
                neg     ax                     

SKOC1:                  
                mov     bx, ax                             ; v BX je cislo a v AX je pocet odcitani
                xor     ax, ax                                                                     
SKOC_10000:             
                cmp     bx, 10000                                                                  
                jl      SKOC_next1                         ; ak je mensie ako 10000 tak chod na 1000
                xor     cx, cx                             ; ze prvy znak v stringu nebude 0       
                inc     ax                                                                         
                aaa      
                sub     bx, 10000                              
                jmp     SKOC_10000                             
SKOC_next1:             
                cmp     cx, 1                              ;test, ci tam mozem napisat 0 alebo nic
                je      SKOC_1000                                    
                add     al, '0'                                      
                mov     [di], al                                     
                inc     di
                xor     ax, ax
SKOC_1000:                                                 ;to     vsetko sa uz iba opakuje
                cmp     bx, 1000                                     
                jl      SKOC_next2                                   
                xor     cx, cx                                       
                inc     ax                                           
                aaa      
                sub     bx, 1000                                     
                jmp     SKOC_1000                                    
SKOC_next2:             
                cmp     cx, 1         
                je      SKOC_100      
                add     al, '0'       
                mov     [di], al      
                inc     di            
                xor     ax, ax        
SKOC_100:               
                cmp     bx, 100       
                jl      SKOC_next3                         
                xor     cx, cx        
                inc     ax            
                aaa      
                sub     bx, 100       
                jmp     SKOC_100      
SKOC_next3:             
                cmp     cx, 1         
                je      SKOC_10       
                add     al, '0'       
                mov     [di], al      
                inc     di            
                xor     ax, ax        
SKOC_10:                
                cmp     bx, 10        
                jl      SKOC_next4                         ; ak je mensie ako 10000 tak chod na 1000
                xor     cx, cx        
                inc     ax            
                aaa      
                sub     bx, 10        
                jmp     SKOC_10       
SKOC_next4:             
                cmp     cx, 1         
                je      SKOC_1        
                add     al, '0'       
                mov     [di], al      
                inc     di            
                xor     ax, ax        
SKOC_1:                 
                cmp     bx, 1         
                jl      SKOC_next5                         ; ak je mensie ako 10000 tak chod na 1000
                inc     ax            
                aaa      
                sub     bx, 1         
                jmp     SKOC_1        
SKOC_next5:             
                add     al, '0'       
                mov     [di], al      
                inc     di            

                mov     al, '$'                            ;zakoncime retazec
                mov     [di], al                 
                pop     dx                                 ;a obnovime si registre
                pop     cx                        
                pop     bx                        
                pop     ax                        
                ret      
                ENDP     
;========================================================
VYPIS_DO_SUB    PROC     
;--------------------------------------------------------
; v DX offset na pole wordov                      
; v cl pocet                                      

; otvorenie subora na zapis                       
                push    dx                        
                push    cx                        

                mov     ah, 3ch                   
                mov     dx, offset subor2         
                xor     cx, cx                    
                int     21h                       
;                jc je pruser                     
                mov     handle, ax                

;                                                 
                pop     cx                        
                pop     dx                        
                mov     si, dx                    

CYKLY_VYPIS_DO_SUB:      
                push    cx                        

                LODSW    

                mov     di, offset text                    ; konvertuj a uloz do text
                call    BIN2ASCII                                 

                mov     dx, offset text                    ;tato procedura zisti dlzku retazca
                call    ZISTI_POCET                        ;a vysledok necha v CX

                mov     ah, 40h                            ; uloz text
                mov     bx, handle                         ;CX bol uz nastavenury predchadazjucou procedurov
;                mov     cx, 6                    
                mov     dx, offset text           
                int     21h                        

                mov     ah, 40h                            ; urob novy riadok
                mov     bx, handle                 
                mov     cx, 2                              ;0dh a 0ah su 2 bajty
                mov     dx, offset nl                
                int     21h                        

                pop     cx                        
                LOOP    CYKLY_VYPIS_DO_SUB        

                mov     ah, 3eh                            ; zatvorenie subora
                mov     bx, handle                 
                int     21h                       

                ret      
                ENDP     
;========================================================
ZISTI_POCET     PROC                                       ; zisti dlzku retazca 
;--------------------------------------------------------
; v DX offset na retazec                          
; v CX vracia dlzku                               
                push    dx                                 ; odloz DX (offset)
                mov     dx, ds                             ; ES:=DS
                mov     es, dx                       
                pop     dx                                 ;obnov DX obsahom stareho DX (offsetu)
                mov     di, dx                             ;DI:=DX

                xor     ax, ax                                   
                mov     al, '$'                                  
                mov     cx, 8                                    
                REPNE   SCASB                     

                sub     di, dx                             ;DI ukazuje na $ a DX na zac
                mov     cx, di                             ;preto rozdiel je dlzka retazca a este -1
                dec     cx                        
                ret      
                ENDP     
;========================================================        
                ends     
                end     start                                               

; ZHODNOTENIE:                                                              

; 1.a) OBMEDZENIA NA VST. SUBOR                                             
;  - Ocakava len cisla v ASCII, "-" a minus.                                
;  - cisla su z rozsahu -32768 do 32767                                     
;  - medzi cislami sa prepoklada medzera(e)                                 
;  - za znakom "-"sa ocakava samotne cislo                                  
;  - na ukoncenie sa musi vlozit postupnost " $"                            
;  - za nou moze nasledovat lubovolny text               
;  - postupnost cisel musi byt ulozena v prvych 1024 bajtoch (len tolko nacitava)

; 1.b) PROGRAMOVE OBMEDZENIA                                                
;  - pracuje s cislami z rozsahu -32768 do 32767                            
;  - akekolvek prekrocenia rozsahu ohlasi: "PRETECENIE!!!"                  
;  - maly problem v cykle pri vypise: niekedy zle indexuje (len pri vypise, nie za behu)

; 1.c) OBMEDZENIA NA VYSTUPNY SUBOR                                         
;  - okrem implicitneho mena "output.txt" nie su ziadne                     

; 2. ZAUJIMAVE RIESENIA                                                     
;  - velmi som sa s programom "nepiplal", ale predsa si na nieco            
;    spominam:                                                              
;    pri prevode ASCII2BIN som si jednotlive nasobky 10 ulozil do pola      
;    z ktoreho sa podla cyklu odcitavaju jednotlive nasobky ako obsahy indexov
;    pola, tym padom som dlzku procedury oproti "tvrdo" napisanym odcitavaniam po
;    (jeden cyklys na 10, druhy na 100 atd) "subtilne" skratil.             
;    obdobny postup som mohol aplikovat aj pri spatnom prevode, ale         
;    som uz nemal chut sa tak hrat.                                         
;  - ak to vobec je:                                                        
;    vo vstupnom subore sa postupnost cislic ukoncuje symbolom $            
;    a program viac netestuje, co je zatym dalej, takze tam moze byt hocico.

; 3. ZAVER                                               
;  - Ulohe som sa mohol aj viac venovat, ako som sa venoval, dovody boli
;    vsak objektivne (5 zapoctoviek v predoslom tyzdni). 
;  - Ak by som mohol ulohu este modifikovat, prerobil by som BIN2ASCII
;    na efektivnejsi tvar, taky aky je pouzity v ASCII2BIN
;  - "Zrusil" by som tak silne obmedzenia na vst. subor  
;  - Opravil by som chybu v indexovani pri vypise        
;  SUMA: Poupravil by som program na viac "User friendly"

;  Zivotny cyklus bol uplne standartny.
;  Prostredie: WIN98SE