;ZADANIE c.1
;Nap?te program, ktor na?ta z klvesnice re?azec znakov (max.100 znakov) a ;pod?a ponkanho menu vykon  jednu z mo?nost:
;A
;a) vyp?e re?azec znakov na obrazovku
;b) vyp?e poradov ?slo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo? do CX 
;d) njde znak s max. hodnotou a vyp?e tento znak
;e) zarovn text z?ava (vynech prv medzery)
;f) vyp?e retazec v obrtenom porad,
;g) ukon? vykonvanie programu.
; 
;Autor:  Stefan Jancar  
;Termin odovzdania: 26.10.2000
;2.ro?.,?k.rok 2000/2001
;
;----------------- Inicializaci stack segmentu -----------------------
;
zas segment stack
    dw 16 dup(?)
zas ends
;
;----------------------------------------------------------------------
;

;
;----------------- Inicializacia dat ---------------------------------
;
data segment
sprava1 db 'Zadaj retazec: $'
sprava2 db 'Pozicia,kde sa nachadza prva medzera:',13,10,'$'
sprava3 db 13,10,'V retazci nenachadza medzera! $'
sprava4 db 'Zadaj znak:$'
sprava5 db 13,10,'V retazci som nasiel zadany znak. $'
sprava6 db 13,10,'V retazci sa nenachadza tento znak!$'
sprava7 db 'Znak s max. hodnotou: $'
sprava9 db 'Zarovnany retazec: $'
sprava10 db 'Retazec netreba zarovnat! $'
menu    db 'Menu',13,10,13,10
        db 'a) vypis retazec',13,10
        db 'b) prva medzera',13,10
        db 'c) hladaj znak',13,10
        db 'd) znak s max. hodnotou',13,10
        db 'e) zarovnaj text zlava',13,10
        db 'f) obrat retazec',13,10
        db 'g) koniec',13,10,13,10
        db 'Vyber si!',13,10,'$'
vstup   db 100
pocet   db 0
retazec db 103 dup(?)
cislo   db ?
data ends

;
;-----------------------------------------------------------------------
;

;
;------------------ Definicia maker ------------------------
;
; Makro vypis  - vypise text
; Makro cls    - zmaze obrazovku
; Makro pause  - caka az kym uzivatel stlaci klaves
;


vypis macro text         ; makro na vypis textu
      lea dx,text
      mov ah,9
      int 21h
      endm

cls macro                ;makro na zmazanie obrazovky
    mov ax,3
    int 10h
    endm

pause macro              ;makro na cakanie kym uzivatel stlaci tlacidlo
    mov ax,0
    int 16h
    endm
;
;-----------------------------------------------------------------------
;

code segment
     assume ds:data,ss:zas,cs:code

start:
       mov ax,seg data
       mov ds,ax
       mov ax,0b800h                   ; nastavime videosegment
       mov es,ax
       xor di,di

       cls
       vypis sprava1                   ;vypise:"Zadaj retazec"

       mov ah,0ah                      ;nacitame retazec
       mov dx,offset vstup
       int 21h
       mov bx, offset retazec
       push bx
       add bl, pocet
       mov byte ptr [bx], '$'

step:
       cls
       vypis menu                       ;vypis menu
       mov ah,8
       int 21h
       cmp al,'a'                       ;najdeme ktory klaves bol stlaceny
       je boda
       cmp al,'b'
       je bodb
       cmp al,'c'
       je bodc
       cmp al,'d'
       je bodd
       cmp al,'e'
       je bode
       cmp al,'f'
       je bodf
       cmp al,'g'
       mov ax,4c00h
       int 21h

boda:
     jmp output
bodb:
     jmp medzera
bodc:
     jmp find
bodd:
     jmp hladat
bode:
     jmp zarovnaj
bodf:
     jmp obrat


output:                                  ;zobrazenie textu
       cls
       mov cl,pocet
       pop bx
       mov si,bx
pis:
       mov al,[si]
       mov es:[di],al
       add di,2
       inc si
       loop pis
       pause
       push bx
       jmp step

medzera:                                 ;najde prvu medzeru
        cls
        pop bx
        mov cl,pocet
        mov si,bx
        push bx
        mov bl,' '
        xor dx,dx
opakuj: mov al,[si]
        cmp al,bl
        inc dx
        je vysledok
        loop opakuj
        cmp dx,1
        je nenasiel
vysledok:
         xor cx,cx
         mov ax,dx
         mov di,offset cislo
         mov bx,10
         xor dx,dx
 sem:    
         div bx
         mov [di],dl
         inc cx
         or ax,ax
         jnz sem
         mov si,di
         dec si
         xor di,di
         vypis sprava2
         jmp pisem
nenasiel:vypis sprava3
         jmp koniec
pisem:   mov al,[si]
         add al,48
         mov es:[di],al
         add di,2
         dec si
         loop pisem
         mov word ptr es:[di],'$'
koniec:  pause
         jmp step

find:                                       ;vyhlada zadany znak
      cls
      vypis sprava4
      mov ah,01
      int 21h
      pop bx
      mov cl,pocet
      mov si,bx
      push bx
cyklus:
       mov dl,[si]
       cmp al,dl
       je nasiel
       inc si
       loop cyklus
       vypis sprava6
       jmp spat
nasiel:
       vypis sprava5
spat:
       pause
      jmp step

obrat:                                     ;obratenie retazca
        cls
        pop bx
        mov dx,bx
        mov cl,pocet
        add dl,cl
        dec dl
        mov si,dx
pis1:
        mov al,[si]
        mov es:[di],al
        add di,2
        dec si
        cmp si,0
        je pridaj
        loop pis1
pridaj: mov word ptr es:[di],'$'
        pause
        push bx
        jmp step

hladat:                                    ;hlada maximum
        mov ah, 09h
        mov dx, offset sprava7
        int 21h
        mov bl, 1
        mov dl, retazec
hladaj2:
        cmp bl, pocet
        jb vacsi
        mov ah, 02h
        int 21h                    ;vypise najdeny znak
        pause
        jmp step                   ;spat do menu
vacsi:
        cmp retazec[bx], dl        ;je to mensie alebo rovne
        jae dalej3                 ;ak je tak preskoc ulozenie
        mov al, retazec[bx]        ;ulozi do al znak s max.hodnotou
dalej3:
        inc bx                     ;posune sa o znak dalej
        jmp hladaj2                ;skoci na pocit

zarovnaj:                          ;zarovnanie retazca
         cls
         xor di,di
         pop bx
         mov si,bx
         push bx
         xor bx,bx
         mov bl,' '
 este:   mov al,[si]
         inc cx
         inc si
         cmp al,bl
         je este
         cmp cx,1
         je nerovnat
         inc cx
         vypis sprava9
         pop bx
         mov si,bx
         add si,cx
         push bx
 pisat:  mov al,[si]
         mov es:[di],al
         add di,2
         inc si
         loop pisat
         mov word ptr es:[di],'$'
         jmp koncim
nerovnat:vypis sprava10
koncim:  pause
         jmp step

code ends
       end start

;---------------------------------------------------------------------------
; Zhodnotenie:
; Program ma problemy s vyhladavanim znaku s max. hodnotou,zarovnanim.
; Bral som do uvahy aj to ze uzivatel chce zadat aj specialne znaky ako
; $ co by sluzba 21h nevypisala.
; Preto som vypis realizoval priamym zapisom do videopamati.
; Zaciatok videopamate je na adrese B800:0000
; Dalsi problem je vo vypise cislic.
; Program som robil na programe TASM 3.0
; --------------------------------------------------------------------------
