;Zadanie c.1.
;Text zadania: Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) a 
;podla ponukaneho menu vykona  jednu z moznosti:

;a) vypise retazec znakov na obrazovku
;b) vypise poradove cislo miesta, kde sa nachadza prva medzera,
;c) hlada v retazci zadany znak a pocet jeho vyskytov ulozi do CX 
;d) najde znak s max. hodnotou a vypise tento znak
;e) zarovna text zlava (vynecha prve medzery)
;f) vypise retazec v obratenom poradi,
;g) ukonci vykonavanie programu.

;Autor:  Lubos Juricek  
;Termin odovzdania: 26.10.2000
;2.roc.,   sk.rok 2000/2001 ,   C3


zas segment stack            ;definicia zasobn. segmentu
        dw      64 dup(?)    ; dlzky 64 slov
zas ends

data segment                 ;definicia udaj. segmentu
        uloz    db 100 dup(0)                                           ;adresa kam sa bude ukladat text
        text1   db 0ah,0dh,'Medzera sa v retazci nenasla $'             ;definuje retazec text1
        text2   db 0ah,0dh,'Prva medzera sa nasla na mieste cislo   :     $'
        znak    db 0ah,0dh,'Zadaj znak a vratim pocet vyskytov v registri cx :$'
        text3   db 0ah,0dh,'Pocet vyskytov daneho znaku v retazci je:     $'
        zadaj db 0ah,0dh,'Napis retazec dlzky maximalne 100 znakov :',0ah,0dh,'$'
        menu db  0ah,0dh,0ah,0dh,'0 : nacitanie retazca',0ah,0dh
             db  '1 : vypis retazca znakov na obrazovku',0ah,0dh
             db  '2 : vypis poradoveho cisla miesta,kde je prva medzera',0ah,0dh
             db  '3 : hladanie zadaneho znaku a pocet vyskytov ulozi do registra cx',0ah,0dh
             db  '4 : hladanie znaku s maximalnou hodnotou a vypis znaku',0ah,0dh
             db  '5 : zarovnanie textu zlava',0ah,0dh
             db  '6 : vypis retazca v obratenom poradi',0ah,0dh
             db  '7 : ukoncenie programu',0ah,0dh,'$'
       nadpis   db '                      Praca s retazcom',0ah,0dh,'Program nacita retazec a podla vypisaneho menu vykonava dane operacie',0ah,0dh,0ah,0dh,'$'

data ends

code segment                           ;def. kodoveho segmentu
        assume cs:code,ds:data,ss:zas  ;direktiva pre procesor
                                       ;hovori, ktore reg. bude poc. pouzivat pre pracu so segmentami
start:  mov ax,seg data
        mov ds,ax                      ;do ds dame segment. cast adresy dat. segmentu

        mov ah,09h
        mov dx,offset nadpis   ; vypis popisu programu
        int 21h



A:      mov ah,09h
        mov dx,offset menu   ; vypis menu
        int 21h
                             ;vyber z menu
pom7:   mov     ah, 06H      ;nacitanie bez echa
        mov     dl, 0FFH     ;nastavi ZF do 0 ak nie je v buffri znak
        int     21H
        jz      pom7

        cmp al,'0'             ;vyber z moznosti sme museli urobit pomocnymi
        jne pom0               ;navestiami pretoze inac sme mali daleke skoky
        jmp A0
pom0:   cmp al,'1'
        jne pom1               ;         |
        jmp A1                 ;         |
pom1:   cmp al,'2'             ;         |
        jne pom2               ;         V
        jmp A2
pom2:   cmp al,'3'
        jne pom3
        jmp A3
pom3:   cmp al,'4'
        jne pom4
        jmp A4
pom4:   cmp al,'5'
        jne pom5
        jmp A5
pom5:   cmp al,'6'
        jne pom6
        jmp A6
pom6:   cmp al,'7'
        jne pom7
        jmp A7
                                ;nacitanie retazca
A0:     xor cl,cl               ;nulovanie cl-pocitadlo - osetruje medzu 100 nacit. znakov 
        mov bx,offset uloz      ;bx-offset.adresu pola, kam sa budu ukladat nacitane znaky 

        mov ah,09h
        mov dx,offset zadaj     ; poziadavka na zadanie retazca
        int 21h

opakuj: mov ah,01h              ;vstup jedneho znaku
        int 21h
        mov [bx],al             ;ulozenie znaku do pola uloz
        inc bx
        inc cl                  ;aby ulozilo na nasl.byte v uloz
        cmp cl,100              ;kontrola pretecenie pola uloz
        jge A
        cmp al,13               ;kontrola enteru
        jnz opakuj
        jmp A

A1:
        xor cl,cl               ;pocitadlo     
        mov bx,offset uloz
                                ;vypise enter aby sa neprekryvali vypisy
        mov ah,02h
        mov dl,0ah
        int 21h
        mov ah,02h
        mov dl,13
        int 21h                 ;enter

nav1:   mov ah,02h              ;vypis pola po znakoch
        mov dl,[bx]             ;bx ukazuje vzdy na nasled. prvok pola
        int 21h
        inc bx                  ;nastavuje na nasl. adresu
        inc cl
        cmp dl,13               ;kontrola enteru v poli
        je pomA
        jmp nav1

pomA :  jmp A

A2:                                 ;vypis poradoveho cisla 1. medzery
                mov ah,02h          ;vypise enter
                mov dl,0ah
                int 21h
                mov ah,02h
                mov dl,13
                int 21h
                
		mov bx,offset uloz   ;bx nastavi na adresu uloz
                dec bx               ;tu decrementuje lebo v cyle musime zacinat o 1.znaku
                xor cl,cl            ;cl bude ukazovat na prvy  znak
skok:           inc cl               ;cl rata por.cislo medzery
                inc bx
                cmp byte ptr[bx],13  ;porovnava s enterom
                je preskoc2
                cmp byte ptr[bx],32  ;porovna znak s medzerou
                jne skok
                jmp preskoc3
preskoc2:       mov dx,offset text1
                mov ah,09h           ; vypis ze medzera sa v retazci nenasla!!!!!!
                int 21h
                jmp A
preskoc3:                                           
                mov al,cl     ;al je vstupna hodnota podrogramu  
		call view     ;volame podprogram zacinajuci navestim view, ktory nam vypise obsah registra al 
                jmp A
		
A3:                                    ;hlada zadany znak
                xor al,al              ;nuluje al 
                
                mov bx,offset uloz     
                
                dec bx                 ;bx ukazuje na uloz-1
                               
                mov dx,offset znak     ;vypis 'Zadaj znak...'
                mov ah,09h
                int 21h
                
 		mov ah,01h             ;nacita zadny znak z klavesnice
                int 21h
                xor dl,dl

znaky:          inc bx                 ;v cykle uz bx ukazuje na uloz
                
                cmp byte ptr[bx],13    ;kontrola enteru
                je zapis               ;skoci na zapis ked je na konci retazca
                cmp byte ptr[bx],al    ;porovnava obsah uloz so zadanym znakom
                jne znaky              ;nasl.3 riadky : ak sa znak v uloz nezhoduje, tak sa dl nezvysi a naopak,ale vzdy skoci na znaky
                inc dl                 ;odtial sa dostane iba pri predch. dvoch podmienkach
                jmp znaky

zapis:          xor dh,dh              ;ulozime do cx
                mov cx,dx
		mov ax,cx
		call skok2
                jmp A

A4:                                    ;najde znak s max.ASCII hodnotou 
                mov ah,02h          ;enter
                mov dl,0ah
                int 21h
                mov ah,02h
                mov dl,13
                int 21h             ;enter
                
                mov bx,offset uloz      ;nastavime bx na uloz
                mov dl,00h              ;do dl dame min.hodnotu. 
max:                            
                cmp byte ptr[bx],13             ;sledujeme enter
                je nap1
                
		cmp byte ptr[bx],dl     ;kazdy prvok porovnavame z dl 
                ja zmen                 ;ak ja > tak zmenime  v zmen dl
                inc bx
                jmp max
zmen:           mov dl,byte ptr[bx]     ;v dl bude max. znak z dosial precitanych
                inc bx                  ;nastavime na dalsi znak
                jmp max                 ;a opakujeme
nap1:           mov ah,02h       ;vypis znaku na obrazovku
                int 21h
                jmp A
                                  ;zarovnamie zlava
A5:             
                mov bx,offset uloz
zarovnanie:     cmp byte ptr[bx],20h        ;porovnava obsah bx s medzerou
                je vynechanie          ;skoci a vynecha
                jmp A1p    ;ak uz narazilo na znak skoci na vypis noveho retazca
vynechanie:     inc bx      ;nastavi adresu na dalsi prvok 
                jmp zarovnanie

A1p:                        ;vypis zarovn. retazca
                            ;vypise enter aby sa neprekryvali vypisy
        mov ah,02h
        mov dl,0ah
        int 21h
        mov ah,02h
        mov dl,13
        int 21h              ;enter

nav1p:  mov ah,02h           ;vypis pola po znakoch
        mov dl,[bx]
        int 21h
        inc bx               ;nastavi na dalsi znak
        
        cmp dl,13      ;kontrola enteru pocitadlom
        je vysp
        jmp nav1p

vysp:   jmp A
                                                                                                                                      
                              ;obratene poradie
A6:             mov bx,offset uloz    ;bx nastav. na uloz
                xor cx,cx  

sem:            cmp byte ptr[bx],13   ;porovnava z enterom pretoze chceme pocet znakov v retazci
                je dalej
                inc cx                ;cx vrati pocet znakov
                inc bx                ;nastav na dalsi znak -> nakoniec bx nastavene ne koniec uloz
                jmp sem

dalej:          mov ah,02h      ;enter
                mov dl,0ah
                int 21h
                mov ah,02h
                mov dl,13
                int 21h         ;enter
             
opak2:          mov ah,02h                ;vypisuje naopak
                mov dl,byte ptr[bx]
                int 21h
                dec bx                 ;nastavuje na predchadzaj. znak
                dec cx
                cmp cx,0               ;kontrola ci sme na zaciatku
                jge opak2              ;ak nie opakuj
                jmp A

view:   mov     dx, offset text2        ;vstup je al 
        mov     bx, offset text2 + 45   ;budeme zapisovat odzadu
        xor     ah, ah

        mov     cl, 0AH
to:     div     cl         ;deli al/cl a zvysok da do ah ,vysledok da do al
        add     ah, '0'    ;pricita ASCII nuly
        mov     [bx], ah   ;vypisuje od konca retazca, kam ukazuje bx
        xor     ah, ah
        dec	bx          ;nastavi bx na predch. miesto
        cmp     al, 0       ;ak je delitel mensi ako 10 tak vysledok denia je 0 a cyklus konci
        jne     to
        mov     ah, 09H     
        int     21h
        ret

skok2 : mov     dx, offset text3       ;funkcia analogicka s predch. podprogramom
        mov     bx, offset text3 + 45
        xor 	ah,ah

        mov	cl, 0AH
tam:    div	cl
        add     ah, '0'
        mov     [bx], ah
        xor     ah, ah
        dec     bx
        cmp     al, 0
        jne     tam
        mov     ah, 09H
        int     21h
        ret


A7:             mov ah,4ch             ;koniec programu
                int 21h

code ends
        end start


;Zhodnotenie:

; Program je funkcny,bol vypracovany v dosovskom editore v. 2.0.026, prelozeny programom 
;Turbo Assembler v. 2.02, zlinkovany programom Turbo Link v. 3.01 a ladeny programom
;Turbo Debugger 3.1.
; Obmedzenie programu je v tom,ze ak zadavame vstupny retazec mozeme ho prepisovat 
;iba tak, ze prepiseme vsetky nasledujuce znaky a navyse do max. mozneho poctu nacitanych znakov
;sa zaratavaju aj uz vymazane znaky. 
; Vylepsenia vidim v spomenutom nedostatku, ktory by sa mohol odstranit sluzbou DOSu 0Ah, 
;ktora cita retazec znakov. Algoritmy su popisane v komentaroch. 
; Pri skokoch mi vzhladom na dlzku programu vypisovali pri preklade daleke skoky, tak som musel
;pouzit pomocne navetia a skakat s jmp.

