;Napiste program, ktory nacita z klavesnice retazec znakov (max.
;100 znakov) a podla ponukaneho menu vykona jednu z moznosti:
;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX 
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zlava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukonc vykonvanie programu.

;Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;Nepouzivajte retazcove instrukcie!
;Zdrojovy program musi byt PODROBNE OKOMENTOVANY!
;
;Autor: Dusan Kasac (INFA 2)
;Spracovane ulohy: a,b,c,d,e,f,g
;Termin odovzdania: 26.10.2000
;2.roc, sk.rok 2000/2001

model small
data segment
	text1 db 'Menu:',0
	text2 db 10,13,10,13,'1. Vypis retazca',0
	text3 db 10,13,'2. Najdi prvu medzeru',0
	text4 db 10,13,'3. Zisti vyskyt zadaneho znaku',0
	text5 db 10,13,'4. Zarovnaj text zlava',0
        text6 db 10,13,'5. Vypis retaca v opacnom poradi',0
        text20 db 10,13,'6. Najvacsi znak',0
	text7 db 10,13,'7. Koniec',0
	text8 db 10,13,10,13,'Tvoja volba (1-7)? ',0
	text9 db 'Zadaj retazec: ',0
        text10 db 10,13,10,13,'Stlac nieco ...',0
        text11 db 10,13,10,13,'Retazec: ',0
        text12 db 10,13,10,13,'Prva medzera je na pozicii: ',0
        text13 db 10,13,10,13,'V zadanom retazci nie je medzera!',0
        text14 db 10,13,10,13,'Zadany retazec neobsahuje tento znak!',0
        text15 db 10,13,10,13,'Retazec zarovnany zlava: ',0
        text16 db 10,13,10,13,'Retazec v opacnom poradi: ',0
        text17 db 10,13,10,13,'Hladany znak: ',0
	text18 db 10,13,'Pozicie najdenych znakov: ',0
	text19 db 10,13,'Pocet najdenych znakov: ',0
	text21 db 10,13,10,13,'Najvacsi najdeny znak: ',0
	text22 db ' ',0
	retazec db 101 dup(0)

	stack 64
data ends
code segment
	assume cs:code,ds:data,ss:data

start:	mov ax,seg data
	mov ds,ax		;priradilo DS ukazatel na DATA segment
        xor cx,cx		;vynuluje CX
 	call zmazobr		;maze obrazovku
	call nacitajret		;nacita retazec
menu:   call zmazobr		
	call vypismenu		;vypise menu
	call citajznak		;nactava 1 znak zo Standard Input
	cmp al,'1'
	jz vypisanie		;ak stlac. "1" potom Vypisanie
	cmp al,'2'
	jz najstmedzeru		;ak "2" potom Najstmedzeru
	cmp al,'3'
	jz vysk		        ;ak "3" potom zistit vyskyt znaku
	cmp al,'4'		;ak "4" potom zarovnaj
	jz zarovnaj
	cmp al,'5'		;ak "5" vypis opacne
	jz opac
	cmp al,'6'		;ak"6" znamena najdi najvacsi
        jz najv
	cmp al,'7'		;ak"7" znamena koniec programu
        jz koni
	jmp menu		;inak opakuj nacitanie znaku
vysk:	jmp zistivyskyt
opac:	jmp vypisopacne
koni:	jmp koniec
najv:   jmp najvacsi
vypisanie:
	mov dx,offset text11	;daj ukazatel na text11
        call vypisret		;vypis dany retazec, na kt. ukazuje DX
	mov dx,offset retazec
	call vypisret		;vypis retazca
	mov dx,offset text10
	call vypisret		;vypis "Stlac nieco ..."
	jmp menu

najstmedzeru:
        mov al,1		;inicializuj pocitadlo pozicie na hodnotu 1
	mov bx,offset retazec	;BX ukazuje na pole retazec
zac1:	cmp byte ptr [bx],' '	;porovnaj prvok pola retazec s ' '
	jz kon1			;ak sa = skoc na kon1
	cmp byte ptr [bx],0	;ak nie porovnaj prvok s koncom retazca '0'
        jz kon2			;ak koniec retazca skoc na kon2
	inc bx			;BX+1
        inc al			;AL+1
        jmp zac1 		;skoc na zac1 ak je to iny znak
kon1:	push ax			;AX do zasobniku
	mov dx,offset text12
	call vypisret		;vypisanie "Prva medzera je na poz.:"
	pop ax			;vyber AX (proc vypisret moifikuje AX)
        xor bx,bx		;nuluje BX
	mov bl,al
	call vypiscislo		;vypise pocet mezier
	mov dx,offset text10
    	call vypisret		;vypise "Stlac nieco ..."
	jmp menu
kon2:	mov dx,offset text13
	call vypisret		;"Nie je ziadna medzera"
	mov dx,offset text10
        call vypisret		;"Stlac nieco...."
	jmp menu

zarovnaj:
	mov dx,offset text15	;daj ukazatel na text11
        call vypisret		;vypis dany retazec, na kt. ukazuje DX
	mov dx,offset retazec
        mov di,dx
znova:
	mov al,[di]
        cmp al,32               ;porovnanie, ci je to medzera
	jnz vyp1
	inc di                  ;ak je to medzera, tak posun na dalsi znak
	jmp znova	        ;testuj dalej
vyp1:
	mov dx,di
	call vypisret		;vypis retazca
	mov dx,offset text10
	call vypisret		;vypis "Stlac nieco ..."
	jmp menu

	mov dx,offset text10
	call vypisret		;"Stlac nieco ..."
	jmp menu

zistivyskyt:
	mov dx,offset text17
	call vypisret		;"Zadaj znak"
	xor cx,cx
	call citajznak		;nacita znak
	mov bx,offset retazec
	mov ah,2		;AH=2 (vypis znaku; AH uz nemodifikujem)
	dec bx			;zniz BX kvoli prvemu prechodu cyklom
znovu:  inc bx			;BX+1
        inc ch			;CH+1 (prvy precod CH=1)
	cmp byte ptr [bx],0	;porovnaj prvok retazca s '0' (koncom)
	jz mimo			;ak je koniec retazca skoc na mimo
	cmp [bx],al		;porovnaj prvok so zadanym znakom
	jnz znovu		;ak to nie je on daj dalsi znak
	cmp cl,0		;ak to je on, je to prvy najdeny znak?
        jnz dalej		;ak nie je skoc na dalej
	push bx			; inak dloz BX,CX,AX
	push cx			;kvoli zmene v proc vypisret
        push ax
	mov dx,offset text18
	call vypisret		;vypis "Pozicie zadanych znakov:
        pop ax			;vyber AX,CX,BX
	pop cx
	pop bx
dalej:	inc cl			;zvys pocitadlo najdenych znakov
	push bx			;uloz registre
	push cx
        push ax
        xor bx,bx		;nuluj BX
	mov bl,ch		;uloz tam momentalnu poziciu
	call vypiscislo		;vypis ju na obrazovku
	mov dl,' '		;a za tym jednu medzeru
	int 21h
	pop ax			;vyber registre
	pop cx
	pop bx
	jmp znovu		;dalsi znak
mimo:   push cx			;odloz CX (pocitadlo)
	mov dx,offset text19
	call vypisret		;vypis "Pocet najdenych znakov"
        pop cx			;vyber CX
	xor bx,bx
	mov bl,cl		;daj pocet najdenych znakov do BL
	call vypiscislo		;vypis BL
	mov dx,offset text10
	call vypisret		;"Stlac nieco"
	jmp menu

vypisopacne:
	mov bx,offset retazec	;ukazatel na retazec
	xor cx,cx		;vynuluj pocitadlo
pocet:	cmp byte ptr [bx],0	;porovnaj s koncom retazca
        jz mampoc		;ak ano skoc na mampoc
	inc cl			;CL+1
	inc bx			;BX+1
	jmp pocet		;skoc na pocet
mampoc: push cx
	mov dx,offset text16
	call vypisret		;vypis "Retazec v opacnom poradi:"
	pop cx			;v CX mam pocet znakov
        mov ah,2		;AH je vypis znaku - uz nemodifikujem
	mov bx,offset retazec
	dec cx			;CX-1
	add bx,cx		;BX=BX+CX - koniec retazca
zacvyp:	mov dl,[bx]		;postupne znaky od konca davam do DL
	int 21h			;a vypisujem ich
        dec bx			;dalsi (predchadzajuci znak)
	cmp bx,offset retazec
	jge zacvyp		;ak je BX>=zaciatku retazca : cykluj
	mov dx,offset text10
	call vypisret		;inak vypis "Stlac nieco .."
	jmp menu
najvacsi:
	mov dx,offset text21
	call vypisret		;vypis "Najvacsi najdeny znak : "
	mov bx,offset retazec	;BX ukazuje na pole retazec
	mov al,0
opk1:	cmp byte ptr [bx],al	;porovnaj prvok pola retazec s momentalne najvacsim znakom
	jl obskc1			
        mov al,byte ptr [bx]
obskc1:
	inc bx
        cmp byte ptr [bx],0     ;je to koniec retazca ?
	jnz opk1
	mov dx,offset text22
	mov bx,dx
	mov byte ptr [bx],al
	call vypisret
	mov dx,offset text10
	call vypisret		;vypis "Stlac nieco .."
	jmp menu
koniec:	mov ah,4ch		;koniec programu
	int 21h

zmazobr proc
	mov ah,6		;nastavenie registrov
	mov ch,0
	mov cl,0
	mov dh,25
	mov dl,80
	mov al,0
	mov bh,07h		;mo obrazovky (0-pozadie; 7-text) farba
	int 10h			;zmazanie obrazovky
	mov ah,2		;nastavenie kurzoru
	mov dh,0
	mov dl,0
	mov bh,0
	int 10h			;kurzor na (0,0)
	ret
	endp

citajznak proc
zac0:	xor cl,cl		;nuluj CL
zac:	mov ah,8		;AH=8
	int 21h			;cita znak s klavesnice [bez vypisu]
	cmp al,0		;ak to nie je riadiaci znak
	jnz kon			;tak skoc na kon
	mov cl,1		;inak nastav CL=1
        jmp zac			;a vycitaj druhu honotu riad. znaku
kon:    cmp ch,1		;CH=1 moze byt stlaceny aj riadici znak
	jz von1			;je to kvoli "Stlac nieco ..."
	cmp cl,1		;inak riad. znaky ignoruje (CH=0)
	jz zac0			;po vycitani riad. znaku (2x) je stale CL=0
        mov ch,dl		;skace na nacitanie dalsieho znaku CL=0
	mov dl,al
	mov ah,2
	int 21h			;vypis nacitaneo znaku ak treba (CH=0)
	mov dl,ch
von1:	xor ch,ch		;vynuluje CH
	ret
	endp

vypismenu proc			;no comment
	mov dx,offset text1
	call vypisret
	mov dx,offset text2
	call vypisret
	mov dx,offset text3
	call vypisret
	mov dx,offset text4
	call vypisret
	mov dx,offset text5
	call vypisret
	mov dx,offset text6
	call vypisret
	mov dx,offset text20
        call vypisret
	mov dx,offset text7
	call vypisret
	mov dx,offset text8
        call vypisret
        ret
	endp

nacitajret proc
	mov dx,offset text9
        call vypisret		;"Zadaj retazec: "
	mov bx,offset retazec
	mov dx,bx
	add dx,100		;maximalne dosiahnutelna honota konca
citaj:	call citajznak		;citaznak
	cmp al,13		;ak ENTER tak
	jz mamret		;skoc na mamret
	cmp al,8		;ak nie je BCKSPACE
        jnz cit 		;skoc na cit: inak todalej osetri
	cmp bx,offset retazec	;ak som na zaciatku retazca
        jz citaj1		;skoc na citaj1
        push dx
	dec bx			;BCKSP znizi ukazatel
	mov byte ptr [bx],0	;dam tam znacku konca retazca
	mov ah,2
	mov dl,' '		;vypise medzeru (vymaze znak na obraz.)
	int 21h
	mov dl,8		;posun kurzoru spat o 1 znak
	int 21h
	pop dx
        jmp citaj		;cita dalej
citaj1:	mov ah,2
	mov dl,' '		;zaciatok retazca
	int 21h			;vrat kurzor ojednu poziciu dalej
	jmp citaj
cit:	mov [bx],al		;ak normalny znak tak ho da do pola
	inc bx			;zvysi poziciu v poli
	cmp bx,dx		;porovna s maximom 100 znakov
	jz mamret		;ak ano tak skonci
	jmp citaj		;inak cita dalsi znak
mamret:	ret
	endp

vypisret proc
	mov ah,2		;ukazatel je v DX
        mov cx,dx
	mov bx,dx
vypis:	mov dl,[bx]		;BX kvoli indexacii pola
	cmp dl,0		;ak je to koniec retazca
        jz konvyp		;tak skonci
	int 21h			;inak vypis znak
	inc bx
	jmp vypis
konvyp:	mov bx,offset text10	;ak vypisujem hlasku "Stlac nieco ..."
	cmp cx,bx
        jnz von			;ak nie tak skonci
	mov ch,1		;ak ano tak cakaj na stacenie niecoho
	call citajznak
von:	ret
	endp

vypiscislo proc
	xor cx,cx		;cislo je v BX
	mov ah,2
s100:	cmp bx,100		;spocita pocet 100
	jb s10
	sub bx,100
	inc cl
	jmp s100
s10:	cmp cl,0
	jz s11
	add cl,30h		;prida 30h k poctu 100-viek
	mov dl,cl
	int 21h			;vypise pocet 100-viek
s11:	cmp bx,10
	jb s1
	sub bx,10		;spocita 10-tky
	inc ch
	jmp s11
s1:     cmp ch,0
	jz s001
	add ch,30h		;prida 30h
	mov dl,ch
        int 21h			;vypise 10-tky
	jmp s01
s001:	cmp cl,0		;ak nie su 1-tky skoc na s01
	jz s01
	add ch,30h
	mov dl,ch		;inak vypis pocet1-tiek
	int 21h
s01:	add bl,30h		
	mov dl,bl
	int 21h
	ret
	endp

code ends
end start
;Zhodnotenie:
;Program je plne funkcny a pri konecnom testovani sa nevyskytla ziadna chyba.
;Testoval som na pocitaci Pentium II 300MHz,64MB RAM.
;Z BIOS preruseni bolo pouzite iba 10h na zmazanie obrazovky.
;Program reaguje na akekolvek vstupne hodnoty okrem riadiacich znakov (F1 - F12,kurzor.sipky,
;Insert,Home,Delete,PgDn ...). Program pri dosiahnuti max. dlzky retazca 100 znakov automaticky
;pokracuje vypisom menu (a spracuvava dany 100 znakovy retazec).

