;ZADANIE C.2
;Text zadania : Vytvorte program, ktroy nacita z textoveho suboru postupnost
;		celych cisel (aspon10) so znamienkom v desiatkovej ciselnej sustave,
;		potom ich transformuje na cisla v dvojkovej ciselnej sustave
;		v doplnkovom kode a potom podla priania uzivatela:
;		a) vypocita sumu vsetkych cisel a vypise ju
;		b) usporiada cisla zostupne a zapise usporiadanu postupnost cisel
;		   do noveho textoveho suboru
;		c) vydeli dve vybrane cisla a vypise vysledok
;		d) vynasobi posledne dve cisla a vypise vysledok
;		e) ukonci vykonavanie programu
;MENO a PRIEZVISKO: Ladislav Klenovic
;KRUZOK:B10
;Termin odovzdania: 14.11.2000 
;2.roc.,sk.rok 2000/2001

ZAS	SEGMENT		STACK	'STACK'	;definujem stack
	DW		64 DUP(?)
ZAS	ENDS

DATA	SEGMENT				;definujem data
MENU	DB		'1) Scitaj cisla ',0Dh,0Ah
	DB		'2) Usporiadaj cisla zostupne a zapis do suboru (vystup.txt)',0Dh,0Ah
	DB		'3) Vydel cisla ',0Dh,0Ah
	DB		'4) Nasob cisla ',0Dh,0Ah
	DB		'5) Koniec ',0Dh,0Ah,'$'
SUMA	DB		'Suma vsetkych cisel je: $'
OW	DB		'Pretecenie! Suma cisel nemozna.$'
PR1	DB		'Napis poradove cislo prveho cisla: $'
PR2	DB		'Napis poradove cislo druheho cisla: $'
ZV	DB		' zvysok $'
FETEXT	STRUC
	DB		30 DUP(?)
FETEXT	ENDS
FE	FETEXT		<'Function number invalid!$'>
	FETEXT		<'File not found!$'>
	FETEXT		<'Path not found!$'>
	FETEXT		<'No handle available!$'>
	FETEXT		<'Access denied!$'>
	FETEXT		<'Invalid handle!$'>
	FETEXT		5 DUP(<>)
	FETEXT		<'Open mode invalid!$'>
NL	DB		0Dh,0Ah,'$'	;novy riadok
VSTUP	DW		?		;handle vstupneho suboru
VYSTUP	DW		?		;handle vystupneho suboru
MENOV	DB		'vstup.txt',0
MENOVY	DB		'vystup.txt',0
BUFFER	DB		?		;buffer pre pracu so subormi
SIGN	DB		?		;ak je cislo zaporne SIGN=1, inac SIGN=0
USP	DW		100 DUP(?)	;sem ukladam usporiadane cisla
EOF	DB		?		;ak je koniec subora,tak EOF=1, inac EOF=0
POCET	DW		?		;pocet cisel v subore	
DATA	ENDS


CODE	SEGMENT
	ASSUME CS:CODE,SS:ZAS,DS:DATA
FILEERROR	PROC			;procedura vypise text chyby ktora sa udiala pri praci so suborom a ktora sa nachadza v registri ax
	push ax				;v ax sa nachadza cislo chyby, ulozime ho na zasobnik
	mov ah,09h
	mov dx,offset NL
	int 21h				;skocim na novy riadok
	pop ax				;vytiahnem zo zasobnika cislo chyby
	mov bl,SIZE FETEXT		;tu adresujem text chyby, dlzka textu chyby->bl
	dec ax				;dekrementujem ax, pretoze indexovanie sa zacina od 0, ale prva chyba je 1
	mul bl				;vynasobim ax*bl,(bl dlzka textu chyby)
	add ax,offset FE		;k ax pripocitam relativnu adresu FE, cize zaciatok textov chyb
	mov dx,ax			;dx<-ax
	mov ah,09h
	int 21h				;vypisem text na obrazovku
	mov ah,4ch
	int 21h				;ukonci program
FILEERROR	ENDP

NAC_SLOVO	PROC			;nacita cislo z aktualnej adresy v subore, ktoreho handle je v bx 
	mov SIGN,0			;znam<-0(kladne cislo)	
@NS4:	mov ah,3Fh			
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	xor cx,cx
	jnc @NS5			;ak nenastala chyba pri citani tak chod na @NS1, inak
	call FILEERROR			;zavolaj proceduru vypisovania chyb
@NS5:	cmp ax,0			;ci sme dosiahli koniec suboru
	je @ENDNS2
	cmp BUFFER,02Dh			;zisti, ci je BUFFER znamienko
	jne @NS6			;ak nie skoci na @NS6
	mov SIGN,1			;ak ano ulozi do ZNAM jednotku, cize cislo bude zaporne
@NS6:	cmp BUFFER,30h			;otestuje, ci je BUFFER>=0
	jb @NS4				;ak nie skoci naspat na @NS4
	cmp BUFFER,39h			;ak ano, otestuje, ci je BUFFER<=9
        ja @NS4				;ak nie, tak nacitava zo suboru az ho najde
	xor ax,ax			;ak ano, vynuluje ax, v ax bude to nacitane cislo aj so znamienkom v doplnkovom kode
	push ax				;vlozi ax na zasobnik
@NS1:	
	pop ax				;vytiahne ax zo zasobnika
	mov cx,10
	mul cx				;vynasobi ax*10
	mov cl,BUFFER
	sub cl,30h
	add al,cl			;a prida k al,dalsiu nacitanu cislicu
	jnc @NS2
	inc ah				;ak nastalo pretecenie z al,incrementuje ah
@NS2:
	push ax				;ulozi ax na zasobnik
	mov ah,3Fh
	mov cx,1			;udava pocet bytov, ktore ma nacitat(1)
	mov dx,offset BUFFER		;kam ma udaj zapisat(do BUFFER)
	int 21h				;nacita
	jnc @NS3			;ak nenastala chyba pri citani tak chod na @RW1, inak
	call FILEERROR			;zavolaj proceduru vypisovania chyb
@NS3:	xor cx,cx
	cmp ax,0
	je @ENDNS3
	cmp BUFFER,30h			;zisti, ci je BUFFER(nacitana cislica)>=0
	jb @ENDNS1			;ak nie ukonci nacitanie cisla a skoci na @ENDNS1, cislo je uz cele
	cmp BUFFER,39h			;zisti, ci je BUFFER<=9
	jg @ENDNS1			;ak nie ukocni nacitanie cisla a skoci na @ENDNS1

	jmp @NS1			;ak je BUFFER znova cislica, skoci na @NS1, kde ju dalej spracuje
@ENDNS1:
	mov cx,1
@ENDNS3:
	pop ax				;vytiahne zo zasobnika ax,kde sa nachadza nacitane cislo(zatial, len kladne)
	cmp SIGN,1			;zisti, ci cislo ma byt zaporne
	jne @ENDNS2			;ak nie skoci na @ENNS2(koniec)
	neg ax				;ak ano zneguje ax,(not(ax)+1),z coho vznikne doplnkovy kod zaporneho cisla ax
@ENDNS2:
	ret
NAC_SLOVO	ENDP

VYPIS		PROC			;vypise cislo v doplnkovom tvare na obrazovku(v desiatkovej sustave)
	mov bh,ah			
	and bh,080h			
	cmp bh,080h			;zisti ci je prvy bit(znamienkovy) 1
	jne @V4				;ak nie skoci na @V4, cislo je kladne
	push ax				;ak ano cislo je kladne, ulozi cislo v ax na zasobnik
	mov ah,02h
	mov dl,2Dh
	int 21h				;vypise na obrazovku znak '-'
	pop ax				;vytiahne cislo zo zasobnika
	neg ax				;zneguje cislo na kladne cislo
@V4:	mov cx,9999			;cx<-9999(pretoze max.cislo ma 5 cislic)
@V2:	inc cx				;cx<-cx+1
	xor dx,dx			;dx<-0
	div cx				;ax<-ax/cx
	push dx				;teraz sa v ax nachadza x-ta cislica a v dx zvysok, dx ulozime na zasobnik
	cmp al,0			;porovname cislicu s 0
	jne @V3				;ak sa nerovna, skocime na @V3
	xor dx,dx			;inac vynulujeme dx
	mov ax,cx			;ax<-cx
	mov bx,10			
	div bx				;vydelime ax desiatimi
	mov cx,ax			;cx<-ax (posunieme sa o jednu cisilicu)
	pop ax				;vytiahneme cislicu zo zasobnika
	loop @V2			;pokial sme neotestovali aj poslednu cislicu(cx=1) tak skoci na @V2
	push ax				;vlozi ax na zasobnik
@V3:
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;napise cislicu na obrazovku
	xor dx,dx			;dx<-0
	mov ax,cx		
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahneme cislo zo zasobnika
	dec cx				;cx<-cx-1
@V1:	inc cx				;cx<-cx+1
	cmp cx,1			;otestujeme, ci uz nie je poslenda cislica(cx=1)
	je @ENDV			;ak ano skoci na @ENDV
	cmp cx,0			;otestuje ci este je nejaka cislica
	je @ENDV2			;ak nie skoci na @ENDV2
	xor dx,dx			;dx<-0
	div cx				;ax<-ax/cx
	push dx				;vlozi dx na zasobnik
	mov ah,02h
	add al,30h
	mov dl,al
	int 21h				;vypise cislicu v al na obrazovku
	xor dx,dx			;dx<-0
	mov ax,cx
	mov bx,10
	div bx
	mov cx,ax			;cx<-cx/10
	pop ax				;vytiahnem cislo zo zasobnika
	loop @V1			;ak su este nejake cislice skoci na @V1

@ENDV:	mov dl,al			
	add dl,30h
	mov ah,02h
	int 21h				;vypise poslednu cislicu
@ENDV2:
	ret
VYPIS		ENDP

ZAPIS		PROC			;to iste ako VYPIS, ibaze nevypise cislo na obrazovku, ale do suboru, ktory ma handle v bx
	mov cx,bx
	mov bh,ah
	and bh,080h
	cmp bh,080h			;ci je jednotka v najvyssom rade
	jne @Z4				;ak nie tak @Z4(zaporne cislo)
	push ax				;ulozime cislo z ax do zasobnika
		
	push cx				;cx->zasobnika
	mov ah,40h			;otvorime subor pre zapis
	mov bx,cx			;v bx handler suboru
	mov cx,1			;pocet nacitanych bajtov
	mov BUFFER,2Dh			;znamienko
	mov dx,offset BUFFER		;dx<-offset BUFFER
	int 21h
	pop cx				;cx<-zasobnik(cize to co bolo posledne vlozene)
	pop ax				;ax<-zasobnik(bude to samotne cislo
	neg ax				;znegujeme ho na kladne
@Z4:	mov bx,cx
	mov cx,9999
@Z2:	inc cx
	xor dx,dx
	div cx
	push dx
	cmp al,0
	jne @Z3
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop @Z2
	push ax
@Z3:
	push cx
	mov ah,40h
	mov cx,1
	add al,30h
	mov BUFFER,al
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	dec cx
@Z1:	inc cx
	cmp cx,1
	je @ENDZ
	cmp cx,0
	je @ENDZ2
	xor dx,dx
	div cx
	push dx
	push cx
	mov ah,40h
	add al,30h
	mov BUFFER,al
	mov cx,1
	mov dx,offset BUFFER
	int 21h
	pop cx
	xor dx,dx
	mov ax,cx
	push bx
	mov bx,10
	div bx
	pop bx
	mov cx,ax
	pop ax
	loop @Z1

@ENDZ:	mov dl,al
	add dl,30h
	push cx
	mov ah,40h
	mov cx,1
	mov BUFFER,dl
	mov dx,offset BUFFER
	int 21h
	pop cx
@ENDZ2:
	ret
ZAPIS		ENDP

PROC3		PROC		;nacita poradia dvoch cisel a navzajom ich vydeli
@40:	mov bx,VSTUP		;bx<-handle vstupneho suboru
	call NAC_SLOVO		;nacita cislo zo suboru
	push cx			
	call VYPIS		;zapise cislo na obrazovku
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	cmp cx,0		;otestuje ci nie je koniec suboru(ax=0)
	jne @40			;ak nie skoci na @40
	mov ah,09h
	mov dx,offset PR1
	int 21h			;vypise text 'Napis poradie prveho cisla: '
	xor cx,cx

@42:	mov ah,01h
	int 21h			;nacita cislicu
	cmp al,13

	je @43			;ak bol stlaceny enter ukonci nacitavanie cisla a skoci na @43

	push ax			;magic engine
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax		;prida nacita cislicu do cx

	jmp @42			;skok na @42

@43:
	push cx
	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	pop cx
@41:	
	push cx
	call NAC_SLOVO		;nacita cislo zo vstupneho suboru
	pop cx
	loop @41		;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
	push ax
	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru
	xor cx,cx
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	mov ah,09h
	mov dx,offset PR2
	int 21h			;vypise text 'Zadaj poradie druheho cisla: '

@45:	mov ah,01h		
	int 21h			
	cmp al,13		
	je @44			

	push ax			
	mov ax,10
	mul cx
	mov cx,ax
	pop ax

	mov ah,0
	sub al,30h
	add cx,ax
	jmp @45
@44:
	push cx
	call NAC_SLOVO
	pop cx
	loop @44
	push ax
	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	mov ah,09h
	mov dx,offset NL
	int 21h			;potialto vsetko rovnake ako pri nacitani prveho cisla
	pop bx
	pop ax
	push ax
	push bx
	push bx			;povytahujem tie 2 cisla zo zasobnika
	call VYPIS		;vypise 1. cislo
	mov ah,02h
	mov dl,2Fh
	int 21h			;vypise '/'
	pop ax
	call VYPIS		;vypise 2.cislo
	mov ah,02h
	mov dl,0CDh
	int 21h			;vypise '='
	pop bx
	pop ax

	mov sign,0
	cmp ax,0
	jge @49	
	neg ax
	mov sign,1	

@49:	xor dx,dx
	idiv bx			;vydeli 1.cislo 2., v ax bude celociselny vysledok a v dx bude zvysok

        cmp sign,0
	je @50
	neg ax

@50:	push dx			
	call VYPIS		;vypise vysledok
	mov ah,09h
	mov dx,offset ZV
	int 21h			;vypise text 'zvysok'
	pop dx
	mov ax,dx
	call VYPIS		;a nakoniec vypise zvysok
	ret
PROC3		ENDP

PROC4		PROC		;nacita poradia dvoch cisel a navzajom ich vynasobi
	mov pocet,0
@30:	mov bx,VSTUP		;bx<-handle vstupneho suboru
	call NAC_SLOVO		;nacita cislo zo suboru
        inc pocet		;inkrementacia prem. pocet
	push cx			
	call VYPIS		;zapise cislo na obrazovku
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	cmp cx,0		;otestuje ci nie je koniec suboru(ax=0)
	jne @30			;ak nie skoci na @30
	xor cx,cx
	mov cx,pocet		;cx<-pocet

	push cx			;ulozime do zasobnika
	mov ah,42h		;posunutie ukazatela zaznamu
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	pop cx
@31:	
	push cx
	call NAC_SLOVO		;nacita cislo zo vstupneho suboru
	pop cx
	loop @31		;bude nacitavat cisla za vstupneho suboru az kym nenacita cislo so zadanym poradim
	push ax
	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru
	xor cx,cx
	dec pocet
	mov cx,pocet
@34:	
	push cx
	call NAC_SLOVO
	pop cx
	loop @34
	push ax
	mov ah,42h
	mov bx,VSTUP		;handler vstupneho suboru
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	mov ah,09h
	mov dx,offset NL
	int 21h			;potialto vsetko rovnake ako pri nacitani prveho cisla
	pop bx
	pop ax
	push ax
	push bx
	push bx			;povytahujem tie 2 cisla zo zasobnika
	call VYPIS		;vypise 1. cislo
	mov ah,02h
	mov dl,2Ah
	int 21h			;vypise '*'
	pop ax
	call VYPIS		;vypise 2.cislo
	mov ah,02h
	mov dl,0CDh
	int 21h			;vypise '='
	pop bx
	pop ax
	xor dx,dx
	imul bx			;vynasobi 1.cislo 2., v ax bude celociselny vysledok 
	call VYPIS		;vypise vysledok
	mov ah,09h
	ret
PROC4		ENDP

PROC1		PROC
	xor bx,bx		;vynuluje bx, tu bude celkova suma
@11:	push bx
	mov bx,VSTUP		;bx<-handle vstupneho suboru
	call NAC_SLOVO		;nacita cislo
	pop bx
	add bx,ax		;pripocitam cislo k bx
	jo @13			;ak nastalo pretecenie ukonci scitavanie a skoci na @13
	push bx
	push cx
	call VYPIS		;vypise nacitane cislo
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
	pop cx
	pop bx
	cmp cx,0		;zisti ci je koniec suboru(cx=0)
	je @12			;ak ano skoci na @12
	jmp @11			;inac pokracuje na @11

@12:
	push bx
	mov ah,09h
	mov dx,offset SUMA
	int 21h			;vypise retazec 'Vypocitana suma: '
	pop ax
	call VYPIS		;vypise sumu cisel
	jmp @14
@13:	mov ah,09h
	mov dx,offset OW
	int 21h			;vypise chybu pretecenia
	mov ah,09h
	mov dx,offset NL
	int 21h			;skoci na novy riadok
@14:	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok suboru
	ret			;ukonci proceduru
PROC1		ENDP

PROC2		PROC
        mov ah,3ch
	mov al,0		;specifukuje subor ako normal
	mov dx,offset MENOVY
	int 21h			;vytvori novy subor s menom 'vystup.txt',ax je handle na tento subor(VYSTUP)			
	jnc @21			;zisti ci nenastala chyba pri spracovani subora
	call FILEERROR		;ak ano vyvola proceduru FILEERROR
@21:	mov VYSTUP,ax		;ulozi handle vystupneho subora do VYSTUP
	mov bx,VSTUP		;bx<-handle vstupneho suboru
	call NAC_SLOVO		;nacita cislo do vstupneho suboru
	mov cx,0
	mov si,0
	mov USP[si],ax		;ulozi ho do pola USP na prve miesto
@22:	inc cx			;inkrementuje cx, v cx je pocet cisel v poli SORT
	mov bx,VSTUP
	push cx
	call NAC_SLOVO		;nacita cislo zo vstupneho suboru
	mov EOF,cl		
	pop cx
	push cx
	inc cx
	mov si,0
	mov di,0
@24:	cmp ax,USP[si]		;prejde vsetkymi cislami v USP, ci je nacitane cislo mensie ako co najmensie cislo v USP
	jge @25			;ak ano skoci na @25
	jmp @26
@25:
	mov di,1
	mov bx,USP[si]
	mov USP[si],ax
	mov ax,bx
	add si,2
	loop @25		;vlozi cislo pred cislo v USP[si], ktore je najmensie cislo, ktore je vacsie ako dane cislo
	inc cx			;inkrementuje cx
@26:
	add si,2
	loop @24
	sub si,2
	cmp di,1
	je @27
	mov USP[si],ax		;ak je cislo vacsie ako vsetky cisla v USP, ulozi ho na koniec
@27:
	pop cx
	cmp EOF,0		;zisti ci nebol koniec suboru
	je @23			;ak ano skoci na @23
	jmp @22			;inac na @22 
@23:	
	mov si,0
	inc cx
@28:	mov bx,VYSTUP
	mov ax,USP[si]
	push cx
	mov bx,VYSTUP
	call ZAPIS
	pop cx
	push cx
	cmp cx,1
	je @29			;zapise cislo v poli USP do vystupneho suboru
	mov ah,40h
	mov cx,1
	mov BUFFER,09h
	mov dx,offset BUFFER
	int 21h			;zapise tabulator do suboru(oddelenie cisel)
@29:	pop cx
	add si,2
	loop @28		;zapise vsetky cisla v USP
	mov ah,3Eh
	mov bx,VYSTUP
	int 21h			;uzavre vystupny subor
	mov ah,42h
	mov bx,VSTUP
	xor cx,cx
	xor dx,dx
	xor al,al
	int 21h			;posunie sa na zaciatok vstupneho suboru 
	
	mov cx,12
	mov si,0
@POKUS:	mov ax,USP[si]
	push cx
;	call VYPIS
	mov ah,09h
	mov dx,offset NL
	int 21h			;skocim na novy riadok
	pop cx
	add si,2
	loop @POKUS		;vypise vsetky cisla v poli USP na obrazovku
	ret
PROC2		ENDP

START:	mov ax,seg DATA
	mov ds,ax			;inicializacia datoveho segmentu DS
	mov ah,3dh
	mov al,0			;specifukuje subor ako read-only
	mov dx,offset MENOV
	int 21h				;otvori subor s nazvom 'vstup.txt',ax je handle na tento subor			
	jnc @SUBOK			;zisti ci nenastala chyba pri otvarani subora
	call FILEERROR			;ak ano zavola proceduru FILEERROR
@SUBOK:
	mov VSTUP,ax			;ak nie vlozi do VSTUP handle vstupneho subora
@MENU:
	mov ah,09h
	mov dx,offset NL
	int 21h	
	mov ah,09h
	mov dx,offset MENU
	int 21h				;vypise menu
	mov ah,01h
	int 21h				;nacita klavesu
	push ax
	mov ah,09h
	mov dx,offset NL
	int 21h				;skocim na novy riadok
	pop ax
	cmp al,31h
	je @1				;ak je klavesa '1' skoci na @1
	cmp al,32h
	je @2				;ak je klavesa '2' skoci na @2
	cmp al,33h
	je @3				;ak je klavesa '3' skoci na @3
	cmp al,34h			
	je @4				;ak je klavesa '4' skoci na @4
	cmp al,35h			
	jne @MENU			;ak klavesa nie je '5' skoci nazad do @MENU
	mov ah,3Eh			
	mov bx,VSTUP			;inac
	int 21h				;uzavre vstupny subor
	mov ah,4ch
	int 21h				;a ukonci program
@1:	
	call PROC1
	jmp @MENU
@2:     
	call PROC2
	jmp @MENU
@3:
	call PROC3
	jmp @MENU
@4:
	call PROC4
	jmp @MENU
CODE 	ENDS
	END START
