;ZADANIE C.2

;TEXT ZADANIA:  VYTVORTE PROGRAM, KTORY NACITA Z TEXTOVEHO SUBORU POSTUPNOST
;CELYCH CISEL (ASPON 10) SO ZNAMIENKOM V DESIATKOVEJ CISELNEJ SUSTAVE, POTOM
;ICH TRANSFORMUJE NA CISLA V DVOJKOVEJ CISELNEJ SUSTAVE V DOPLNKOVOM KODE A
;POTOM PODLA PRIANIA:
;      A) VYPOCITA SUMU VSETKYCH CISEL A VYPISE JU
;      B) USPORIADA CISLA VZOSTUPNE ZAPISE USPORIADANU
;         POSTUPNOST CISEL DO NOVEHO TEXTOVEHO SUBORU
;      C) VYDELI DVE VYBRANE CISLA A VYPISE VYSLEDOK
;      D) VYNASOBI DVE CISLA A VYPISE VYSLEDOK
;      E) UKONCI VYKONAVANIE PROGRAMU.

;VYSLEDKY OPERACII TREBA VYPISOVAT V DESIATKOVEJ CISELNEJ SUSTAVE.
;AK BY PRI VYPOCTE DOSLO K PRETECENIU, OZNAMTE PREKROCENIE PRIPUSTNEHO
;CISELNEHO ROZSAHU.

;AUTOR:  MARTIN KOMINAK
;TERMIN ODOVZDANIA: 16.11.2000
;2. ROCNIK, SK.ROK 2000/2001


LOCALS

.MODEL SMALL            ;PAMATOVY MODEL PROGRAMU

ZASOBNIK SEGMENT STACK  ;ZASOBNIK A JEHO INICIALIZACIA
         STACK 1024
ZASOBNIK ENDS

DATA SEGMENT            ;DATOVY SEGMENT
MENU    DB "1) ZADAJ VSTUPNY SUBOR",10,13
        DB "2) VYPOCITAJ SUMU",10,13
        DB "3) USPORIADAJ VZOSTUPNE",10,13
        DB "4) VYDEL DVE VYBRANE CISLA",10,13
        DB "5) VYNASOB DVE VYBRANE CISLA",10,13
        DB "6) KONIEC",'$'
DAJMENO DB "ZADAJ MENO SUBORU: $"
SUBORN  DB 13,0                             ;BUFFER NA NAZOV VSTUPN. SUBORU
SUBOR   DB 13 DUP(?)                        ;NAZOV VSTUPNEHO SUBORU
HANDLER DW 0                                ;HANDLER OTVORENEHO SUBORU
NEEXIST DB "SUBOR NEEXISTUJE!$"
ZRUSOUT DB "ZAPIS POSTUPNOSTI ZRUSENY!$"
OPENERR DB "CHYBA PRI VYTVARANI SUBORU!$"
N       DW 0                                ;POCET BYTEOV NACIT DO BUFFERU
BUFF    DB 800 DUP(?)                       ;VSTUPNY BUFFER
CISLA   DW 100 DUP(0)                       ;BUFFER NA KONVERTOVANE CISLA
POCET   DW 0                                ;POCET NACIT CISEL
INDEX   DW 0                                ;INDEX DO POLA CISEL
SUMA    DW 0                                ;SUMA CISEL
SUMAOUT DB "SUMA CISEL: "
SUMAASC DB 6 DUP(' '), '$'                  ;ASCII SUMY CISEL
CON     DB 6 DUP(' '), 13, 10, '$'          ;DOCASNE ASCII CISLO
OVERFLOWOUT DB "BOL PREKROCENY MOZNY ROZSAH!$"
DAJC    DB "ZADAJ "
NC      DB "1. CISLO: $"
NASOUT DB "SUCIN: "
NASASC DB 6 DUP(' '), '$'                   ;ASCII SUCINU CISEL
ASCC   DB 7, 0, 7 DUP(?), 0
DELOUT DB "PODIEL: "
DELASC DB 6 DUP(' '), '$'                   ;ASCII PODIELU CISEL
BADFILE DB "SUBOR OBSAHUJE CISLA MIMO POVOLENU HODNOTU ! $"
FILEOK DB 00H
NOFILE DB " ZADAJTE NAJPRV NAZOV SUBORU ! $"
DATA ENDS



CODE SEGMENT                    ;KODOVY SEGMENT
     ASSUME SS:ZASOBNIK, DS:DATA, CS:CODE



CLS PROC NEAR
        MOV AX, 0600H           ;VYMAZ OKNO
        MOV BH, 7                       ;ATRIBUT, KT. SA MAZE
        XOR CX,CX                       ;LAVY HORNY ROH 0,0
        MOV DX,4F4FH                     ;PRAVY DOLNY ROH 79,79
        INT 10H

        MOV AH, 02H               ;POSUN KURZOR NA 0,0
        XOR BH, BH                      ;C. VIDEO STRANKY
        MOV DX, 0000H                    ;POSUN NA 0,0
        INT 10H

        RET
CLS ENDP

MENUPROC PROC NEAR
        CALL CLS                ;VYMAZE OKNO

        MOV DX,OFFSET MENU
	MOV AH,09H
	INT 21H			; VYPISEM MENU

        RET
MENUPROC ENDP


ZADAJ_SUBOR PROC NEAR           ;ZADANIE NAZVU SUBORU
        CALL CLS         	;VYMAZ DIALOG

        MOV AH,09H                ;VYPIS: ZADAJ VSTUPNY SUBOR:
        MOV DX, OFFSET DAJMENO
        INT 21H

        MOV AH, 0AH             ;BUFFERED INPUT - VSTUP NAZVU SUBORU
        MOV DX, OFFSET SUBORN           ;DO RETAZCA SUBORN
        INT 21H
        CMP BYTE PTR [SUBORN+1], 0      ;AK NEBOLO NIC NACITANE
        JBE @@ERR                           ;VYSKOC Z PROCEDURY
        MOV BX, OFFSET SUBOR            ;INAK SA PRESUN NA KONIEC RETAZCA
        MOV AL, [SUBORN+1]
        CBW
        ADD BX, AX
        MOV BYTE PTR [BX], 0                ;A UKONCI HO NULOU
        XOR AX, AX                      ;VRAT NULU V AX
        RET
@@ERR:  MOV AX, 1                       ;VRAT 1 V AX
        RET
ZADAJ_SUBOR ENDP

OTVOR_SUBOR PROC NEAR
        MOV AH, 3DH                     ;OTVOR SUBOR
        MOV AL, 2                       ;NA CITANIE AJ ZAPIS
        MOV DX, OFFSET SUBOR            ;OFFSET NAZVU SUBORU
        INT 21H
        JNC @@OK                        ;AK NENASTALA CHYBA PRESKOC NA OK

        CALL CLS                 	;VYMAZ DIALOG
        MOV AH,09H                        ;VYPIS: SUBOR NEEXISTUJE!
        MOV DX, OFFSET NEEXIST        
        INT 21H
	MOV AH,08H		        ; CAKA NA STLACENIE KLAVESY
	INT 21H
        MOV AX, 1                       ;VRAT 1 V AX
        RET

@@OK:   MOV HANDLER, AX               ;ULOZ HANDLER SUBORU
        CALL CLS                 	;VYMAZ DIALOG
        XOR AX, AX                      ;VRAT 0 V AX
        RET
OTVOR_SUBOR ENDP

VYTVOR_SUBOR PROC NEAR
        MOV AH, 3CH                     ;VYTVOR SUBOR
        XOR CX, CX                      ;SUBOR BEZ ATRIBUTU
        MOV DX, OFFSET SUBOR            ;OFFSET NAZVU SUBORU
        INT 21H
        JNC @@OK                        ;SKOC KED NENASTALA CHYBA

        CALL CLS
        MOV AH,9                        ;VYPIS: CHYBA PRI OTVARANI SUBORU!
        MOV DX, OFFSET OPENERR
        INT 21H
	MOV AH,08H			; CAKA NA STLACENIE KLAVESY
	INT 21H
        MOV AX, 1                       ;VRAT 1 V AX
        RET

@@OK:   MOV HANDLER, AX               ;ULOZ HANDLER
        CALL CLS                 ;VYMAZ DIALOG
        XOR AX, AX                      ;VRAT 0 V AX
        RET
VYTVOR_SUBOR ENDP

ZATVOR_SUBOR PROC NEAR
        MOV AH, 3EH                     ;ZATVOR SUBOR
        MOV BX, HANDLER               ;HANDLER SUBORU
        INT 21H
        RET
ZATVOR_SUBOR ENDP

NACITAJ PROC NEAR               ;NACITA SUBORU DO BUFFERU BUFF
        MOV AH, 3FH             ;FUNKCIA CITANIA
        MOV BX, HANDLER       ;HANDLER OTVORENEHO SUBORU
        MOV CX, 650             ;MAX. POCET PRECIT. ZNAKOV
        MOV DX, OFFSET BUFF     ;OFFSET BUFFERU
        INT 21H
        JC @@ERR                ;AK NENASTALA CHYBA PRI CITANI
        MOV WORD PTR N, AX        ;ULOZ POCET PRECITANYCH BYTEOV
@@ERR:
        RET                     ;INAK VYSKOC
NACITAJ ENDP


VYPIS1 PROC NEAR               ;VYPISE OBSAH SUBORU NA OBRAZOVKU
       CALL CLS           	;VYMAZANIE VYSTUPNEHO OKNA
       MOV DX,OFFSET BUFF
       MOV AX,N
       MOV DI,DX
       ADD DI,AX
       MOV BYTE PTR DS:[DI],'$'	; NA KONIEC RETAZCA ZADA '$'
       MOV AH,09H
       INT 21H			; VYPISE OBSAH SUBORU
       MOV AH,08H
       INT 21H	 		; CAKAM NA KLAVESU

      RET
VYPIS1 ENDP

VYPIS2 PROC NEAR               ;VYPISE OBSAH POLA CISEL NA OBRAZOVKU
      CALL CLS           ;VYMAZANIE VYSTUPNEHO OKNA

      MOV SI, OFFSET CISLA     ;OFFSET POLA CISEL
      MOV CX, POCET          ;POCET CISEL V POLI
@@LOOP:
      PUSH CX
      MOV DI, OFFSET CON + 5   ;NASTAVENIE OFFSETU NA BUFFER DO PAMATE
      MOV AX, [SI]             ;CISLO Z POLA ADRESOVANE SI
      CALL ITOA                ;KONVERZIA CISLA NA ASCII
      ADD SI, 2                ;UPRAVENIE INDEXU DO POLA CISEL
      ADD DX, 100H             ;PRESUN SURADNIC KURZORA PRE NASLEDUJUCI CYKLUS
      PUSH DX                  ;A ICH UCHOVANIE
      MOV AH, 09H                ;VYPIS CISLA NA OBRAZOVKU
      MOV DX, OFFSET CON
      INT 21H
      POP DX
      POP CX
      LOOPNZ @@LOOP            ;OPAKOVANIE CYKLU CX-KRAT
      MOV AH,08H
      INT 21H			; CAKAM NA KLAVESU
      RET
VYPIS2 ENDP

ATOI PROC NEAR                  ;KONVERZIA ASCII NA INTEGER
                                ;IN: DI=OFFSET CISLA V DS
@@FINDBEG:                      ;NAJDENIE ZACIATKU CISLA V BUFF
      CMP BYTE PTR [DI], '0'    ;POROVNAVANIE, CI JE V INTERVALE CISEL
      JB @@NEXT
      CMP BYTE PTR [DI], '9'
      JA @@NEXT                 ;NIE JE -> ZVYS INDEX A OPAKUJ POSTUP
      JMP @@GOTCHA              ;INAK SKONTROLUJ ZNAMIENKO
@@NEXT:
      INC DI
      JMP @@FINDBEG
@@GOTCHA:                               ;SKONTROLUJ ZNAMIENKO
      MOV AX, 1                 ;ZNAMIENKO
      CMP BYTE PTR [DI-1], '-'  ;AK JE PRED CISLOM -
      JNE @@BEZZN
      NEG AX                    ;ZNAMIENKO SA ROVNA -1
@@BEZZN:
      PUSH AX                   ;ULOZ ZNAMIENKO
      XOR AX, AX                ;AX = VYSTUPNE CISLO
@@OPAK:
      MOV BL, [DI]              ;ZOBER ZNAK
      SUB BL, '0'               ;PREKONVERTUJ Z ASCII NA SHORT
      XOR BH, BH
      ADD AX, BX                ;PRIPOCITAJ
      INC DI                    ;POSUN INDEX
      CMP BYTE PTR [DI], '0'    ;SKONTROLUJ, CI NASLEDUJUCI BYTE JE CISLO
      JB @@KONIEC
      CMP BYTE PTR [DI], '9'
      JA @@KONIEC               ;AK NIE -> UKONC PROCES
      MOV BX, 10                ;INAK VYNASOB VYSLEDOK 10
      IMUL BX
      CMP AX, 8000H             ;SKONTROLUJ, CI NENASTALO PRETECENIE
      JAE @@KONIEC              ;AK NIE
      JMP @@OPAK                ;       -> OPAKUJ PROCES
@@KONIEC:
      CMP AX, 8000H             ;SKONTROLUJ, CI NENASTALO PRETECENIE
            POP BX              ;VYTIAHNI ZO ZASOBNIKA ZNAMIENKO
      JAE @@OVERFLOW
      IMUL BX                   ;NASOB VYSLEDOK
      RET                       ;VRAT VYSLEDOK V AX
@@OVERFLOW:                     ;OSETRENIE PRETECENIA
      CALL CLS           ;VYMAZ DIALOG
      MOV AH, 09H               ;VYTLAC SPRAVU O PREKROCENI ROZSAHU
      MOV DX, OFFSET OVERFLOWOUT
      INT 21H
      MOV AH,08H		; CAKAM NA KLAVESU
      INT 21H
      STC                       ;NASTAV CARRY
      RET
ATOI ENDP

ITOA PROC NEAR                  ; KONVERZIA INTEGER NA ASCII
      PUSH DX                   ; AX = CISLO
      PUSH DI                   ; DI = OFFSET KONCA RETAZCA
      MOV DL, ' '
      TEST AX, 8000H            ; TESTUJ, CI JE CISLO ZAPORNE
      JZ @@POKRAC               ; AK NIE -> POKRACUJ
      MOV DL, '-'               ; ZMEN ZNAMIENKO NA -
      NEG AX                    ; NEGUJ CISLO NA KLADNE
@@POKRAC:
      PUSH DX                   ; ULOZ ZNAMIENKO NA ZASOBNIK
      MOV BX, 10                ; DELITEL
@@DEL:CWD                       ; AX -> DX:AX
      DIV BX                    ; DELENIE 10
      ADD DL, '0'               ; KONVERZIA NA ASCII
      MOV BYTE PTR DS:[DI], DL  ; ULOZENIE DO BUFFERA POSTUPNE ODZADU
      DEC DI                    ; ZNIZENIE INDEXU
      CMP AX, 0                 ; AK ZA AX ESTE NEROVNA NULE
      JNE @@DEL                     ;DEL DALEJ
      POP DX                    ; INAK OSETRI ZNAMIENKO
      MOV BYTE PTR [DI], DL     ; VYTLAC HO DO BUFF PRED CISLO
      DEC DI                    ; ZNIZ INDEX
      POP BX                    ; ZVYSOK DOPLN MEDZERAMI
      SUB BX, 6                         ; VYPOCET POCTU MEDZIER
      MOV CX, DI                        ; =>(KONIEC BUFF-6)-AKT. INDEX
      SUB CX, BX
@@DOPLN:                                ; CYKLUS DOPLNANIA
      JCXZ @@KONIEC
      MOV BYTE PTR [DI], ' '
      DEC DI
      LOOP @@DOPLN
@@KONIEC:
      POP DX                    ; OBNOVENIE REG. DX S KONVERTOVANYM CISLOM
      RET
ITOA ENDP

GET_FIRST PROC NEAR             ;NACITAJ A PREKONVERTUJ PRVE CISLO Z BUFFERU
      MOV DI, OFFSET BUFF                ;NASTAV OFFSET NA ZACIATOK
      CALL ATOI                          ;VYBER CISLO DO AX
      JNC @@GOODNUMBER
      STC
      MOV AX,01H		; AK JE CARRY 1, TAK DOSLO K CHYBE -> PREKROCENY
      				;    ROZSAH
      RET
@@GOODNUMBER:
      MOV INDEX, DI                    ;ULOZ UPRAVENY INDEX DO BUFFERU
      RET
GET_FIRST ENDP

GET_NEXT PROC NEAR              ;NACITAJ A PREKONVERTUJ NASLEDUJUCE CISLO
      MOV AX, N                        ;ZISTI, CI UZ NIE JE KONIEC BUFFERU
      ADD AX, OFFSET BUFF
      CMP DI, AX
      JAE @@EOF             ;    |------  AK JE NASTAV CARRY A VYSKOC
      MOV DI, INDEX       ;    |        INAK NACITAJ INDEX
      CALL ATOI             ;    |              VYBER DALSIE CISLO DO AX
      JNC @@GOODNUMBER
      MOV AX,01H
      STC
      RET
@@GOODNUMBER:
      MOV INDEX, DI       ;    |              ULOZ UPRAVENY INDEX DO BUFFERU
      CLC                   ;    |              VYMAZ CARRY (PRE ISTOTU)
      RET                   ;    |
@@EOF:XOR AX,AX
      STC                   ; <--|
      RET
GET_NEXT ENDP

SUMUP PROC NEAR                 ;VYPOCET SUMY CISEL VO VSTUPNOM SUBORE
      CMP BYTE PTR HANDLER, 0 ;SKONTROLUJ, CI JE OTVORENY SUBOR
      JE @@ERR

      MOV SUMA, 0    ;VYNULUJ SUMU

      CALL GET_FIRST            ;NACITAJ PRVE CISLO
@@LOOP:
      ADD SUMA, AX   		;PRIPOCITAJ DO SUMY
      JO @@OVERFLOW             ;KONTROLA PRETECENIA
      CALL GET_NEXT             ;NACITAJ DALSIE CISLO
      JC @@PRINTOUT             ;AK NIE JE ESTE KONIEC BUFFERA
      JMP @@LOOP                    ;OPAKUJ
@@PRINTOUT:
      MOV DI, OFFSET SUMAASC + 5    ;NASTAV OFFSET KONCA BUFFERU
      MOV AX, SUMA       ;NACITAJ SUMU DO AX
      CALL ITOA                     ;KONVERTUJ INTEGER NA ASCII

      CALL CLS               	;VYMAZ DIALOG
      MOV AH, 09H                   ;VYPIS SPRAVY O SUME CISEL
      MOV DX, OFFSET SUMAOUT
      INT 21H
      MOV AH,08H
      INT 21H

@@ERR:
      RET
@@OVERFLOW:                          ;OSETRENIE PRETECENIA
      CALL CLS
      MOV AH, 09H
      MOV DX, OFFSET OVERFLOWOUT	; VYPISE HLASKU O PRETECENI
      INT 21H
      MOV AH,08H
      INT 21H
      RET
SUMUP ENDP

USP_VZOSTUPNE PROC NEAR         ;BUBBLE-SORT
        MOV POCET, 0         ;NACITA CISLA Z BUFFERU DO POLA
        CALL GET_FIRST                  ;ZACNE PRVYM
        MOV SI, OFFSET CISLA
        MOV [SI], AX                            ;ULOZ CISLO DO POLA
@@LOOP: ADD SI, 2                       ;A OSTATNE NACITA V CYKLE
        INC POCET
        CALL GET_NEXT
        JC @@TRIED                              ;KONTROLA KONCA BUFFERU
        MOV [SI], AX                            ;ULOZ CISLO DO POLA
        JMP @@LOOP
@@TRIED:                            ;TRIEDENIE
        MOV CX, POCET    ;CX = POCET CISEL
        DEC CX
        MOV BX, 8000H               ;BX SA PRIPOCITA PRED POROVNAVANIM KU
                                    ;KAZDEMU CISLU -> KONVERZIA DOPLNKOVEHO
                                    ;KODU NA KOD S POSUNUTOU NULOU
@@OUTER:XOR DI, DI                  ;VONKAJSI CYKLUS
@@INNER:                                ;VNUTORNY CYKLUS
        MOV AX, [CISLA + 2 + DI]            ;NACITAJ DVE CISLA VEDLA SEBA
        MOV DX, [CISLA + DI]
        PUSH AX                             ;UCHOVAJ ICH V ZASOBNIKU
        PUSH DX
        ADD AX,BX                           ;KONV. DO KODU S POSUNUTOU NULOU
        ADD DX, BX
        CMP AX, DX                          ;POROVNAJ CISLA ICH V TOMTO KODE
        POP DX                              ;OBNOV ICH ZO ZASOBNIKA
        POP AX
        JAE @@NEMEN                         ;AK ICH TREBA VYMENIT
        MOV [CISLA + 2 + DI], DX                ;TAK ICH VYMEN
        MOV [CISLA + DI], AX
@@NEMEN:
        ADD DI, 2                           ;INAK UPRAV INDEX
        MOV AX, CX                          ;POROVNAJ INDEX VNUTORNEHO
        SHL AX, 1                           ;CYKLU S VONKAJSIM
        CMP DI, AX
        JNE @@INNER                         ;PODLA TOHO OPAKUJ VNUT.
        LOOP @@OUTER                        ;VONKAJSI SA RIADI CEZ REG. CX

        CALL VYPIS2             ;VYPIS USPORIADANE CISLA NA OBRAZOVKU
        CALL SAVE               ;ULOZ POSTUPNOST DO VYSTUPNEHO SUBORU
        RET
USP_VZOSTUPNE ENDP

USP_ZOSTUPNE PROC NEAR          ;BUBBLE-SORT
        MOV WORD PTR POCET, 0         ;NACITA CISLA Z BUFFERU DO POLA
        CALL GET_FIRST                  ;ZACNE PRVYM
        MOV SI, OFFSET CISLA
        MOV [SI], AX                            ;ULOZ CISLO DO POLA
@@LOOP: ADD SI, 2                       ;A OSTATNE NACITA V CYKLE
        INC POCET
        CALL GET_NEXT
        JC @@TRIED                              ;KONTROLA KONCA BUFFERU
        MOV [SI], AX                            ;ULOZ CISLO DO POLA
        JMP @@LOOP
@@TRIED:                            ;TRIEDENIE
        MOV CX, POCET    ;CX = POCET CISEL
        DEC CX
        MOV BX, 8000H               ;BX SA PRIPOCITA PRED POROVNAVANIM KU
                                    ;KAZDEMU CISLU -> KONVERZIA DOPLNKOVEHO
                                    ;KODU NA KOD S POSUNUTOU NULOU
@@OUTER:XOR DI, DI                  ;VONKAJSI CYKLUS
@@INNER:                                ;VNUTORNY CYKLUS
        MOV AX, [CISLA + 2 + DI]            ;NACITAJ DVE CISLA VEDLA SEBA
        MOV DX, [CISLA + DI]
        PUSH AX                             ;UCHOVAJ ICH V ZASOBNIKU
        PUSH DX
        ADD AX, BX                          ;KONV. DO KODU S POSUNUTOU NULO
        ADD DX, BX
        CMP AX, DX                          ;POROVNAJ CISLA ICH V TOMTO KOD
        POP DX                              ;OBNOV ICH ZO ZASOBNIKA
        POP AX
        JBE @@NEMEN                         ;AK ICH TREBA VYMENIT
        MOV [CISLA + 2 + DI], DX                ;TAK ICH VYMEN
        MOV [CISLA + DI], AX
@@NEMEN:ADD DI, 2                           ;INAK UPRAV INDEX
        MOV AX, CX                          ;POROVNAJ INDEX VNUTORNEHO
        SHL AX, 1                           ;CYKLU S VONKAJSIM
        CMP DI, AX
        JNE @@INNER                         ;PODLA TOHO OPAKUJ VNUT.
        LOOP @@OUTER                        ;VONKAJSI SA RIADI CEZ REG. CX

        CALL VYPIS2             ;VYPIS USPORIADANE CISLA NA OBRAZOVKU
        CALL SAVE               ;ULOZ POSTUPNOST DO VYSTUPNEHO SUBORU
        RET
USP_ZOSTUPNE ENDP

ZADAJ_CISLO PROC NEAR    ;VSTUP CISLA ZO STANDARDNEHO VSTUPU
        PUSH AX                 ;IDENTIFIKACIA CISLA
        CALL CLS         ;VYMAZ DIALOG

        POP AX
        MOV NC, AL            ;VLOZ ID DO RETAZCA, KTORY SA VYPISE
        MOV AH,9                ;VYPIS: ZADAJ X. CISLO:
        MOV DX, OFFSET DAJC
        INT 21H

        MOV AH, 0AH             ;BUFFERED INPUT
        MOV DX, OFFSET ASCC           ;ASCII BUFFER NA CISLO
        INT 21H

        MOV DI, OFFSET ASCC+2   ;KONVERTUJ NA INTEGER
        CALL ATOI

        RET                     ;VRAT NACITANE CISLO V AX
                                ;AK NASTALA CHYBA, BUDE NASTAVENE AJ CARRY
ZADAJ_CISLO ENDP

NASOBENIE PROC NEAR
        MOV AL, '1'             ;NASTAV ID
        CALL ZADAJ_CISLO        ;NACITAJ CISLO ZO STANDARDNEHO VSTUPU
        JC @@ERR                ;AK NASTALA CHYBA VYSKOC
        PUSH AX
        MOV AL, '2'             ;NASTAV ID
        CALL ZADAJ_CISLO        ;NACITAJ CISLO ZO STANDARDNEHO VSTUPU
                POP DX
        JC @@ERR                ;AK NASTALA CHYBA VYSKOC
        IMUL DX                 ;VYNASOB CISLA
        JO @@OVERFLOW           ;OSETRENIE PRETECENIA

        MOV DI, OFFSET NASASC + 5 ;KONVERZIA SUCINU DO ASCII
        CALL ITOA
        CALL CLS           ;VYPIS SPRAVY
        MOV AH, 09H
        MOV DX, OFFSET NASOUT
        INT 21H
	MOV AH,08H
	INT 21H
        RET
@@OVERFLOW:                     ;OSETRENIE PRETECENIA
        CALL CLS
        MOV AH, 09H
        MOV DX, OFFSET OVERFLOWOUT	; VYPISE HLASKU O PRETECENI
        INT 21H
	MOV AH,08H
	INT 21H
@@ERR:  RET
NASOBENIE ENDP

DELENIE PROC NEAR
        MOV AL, '1'             ;NASTAV ID
        CALL ZADAJ_CISLO        ;NACITAJ CISLO ZO STANDARDNEHO VSTUPU
        JC @@ERR                ;AK NASTALA CHYBA VYSKOC
        PUSH AX
        MOV AL, '2'             ;NASTAV ID
        CALL ZADAJ_CISLO        ;NACITAJ CISLO ZO STANDARDNEHO VSTUPU
                MOV BX, AX
                POP AX
        JC @@ERR                ;AK NASTALA CHYBA VYSKOC
        CWD                     ;KONVERZIA AX -> DX:AX
        IDIV BX                 ;PODEL CISLA

        MOV DI, OFFSET DELASC + 5     ;KONVERZIA PODIELU DO ASCII
        CALL ITOA
        CALL CLS               ;VYPIS SPRAVY
        MOV AH, 09H
        MOV DX, OFFSET DELOUT
        INT 21H
	MOV AH,08H
	INT 21H
@@ERR:  RET
DELENIE ENDP

SAVE PROC NEAR          ;KONVERZIA A ULOZENIE POLA CISEL DO SUBORU
      CALL ZATVOR_SUBOR            ;ZATVOR OTVORENY VSTUPNY SUBOR
      CALL ZADAJ_SUBOR             ;ZADAJ MENO VYSTUPNEHO
           CMP AX, 0
           JNE @@ZRUS              ;AK JE MENO DOBRE ZADANE
      CALL VYTVOR_SUBOR                ;VYTVOR NOVY SUBOR
           CMP AX, 0
           JNE @@KONIEC            ;AK JE SUBOR VYTVORENY A OTVORENY:

      MOV SI, OFFSET CISLA      ;NASTAV SA NA ZACIATOK POLA
      MOV CX, POCET           ;A POCITADLO NA POCET PRVKOV
@@LOOP:
      PUSH CX                   ;ULOZ ITERACNU PREMENNU
      MOV DI, OFFSET CON + 5    ;NASTAV DOCASNY BUFFER NA KONVERZIU
      MOV AX, [SI]              ;NASTAV KONVERTOVANE CISLO
      CALL ITOA                 ;KONVERTUJ NA ASCII
      ADD SI, 2                 ;UPRAV INDEX DO POLA

      MOV AH, 40H               ;ZAPIS DO SUBORU
      MOV BX, HANDLER         ;ZAPIS DO OTVORENEHO SUBORU URCENEHO HANDLEROM
      MOV CX, 8                 ;POCET BYTOV URCENYCH NA ZAPIS
      MOV DX, OFFSET CON        ;OFFSET BUFFERU
      INT 21H                   ;VOLANIE SLUZBY

      POP CX                    ;VYBER ITER. INDEX
      LOOPNZ @@LOOP             ;OPAKUJ PRE VSETKY OSTATNE CISLA
      RET
@@ZRUS:                         ;VYPIS SPRAVY O ZRUSENI ZAPISU DO SUBORU
      CALL CLS                ;AKO DOSLEDOK NESPRAVNE ZADANEHO SUBORU
      MOV AH, 09H
      MOV DX, OFFSET ZRUSOUT
      INT 21H
      MOV AH,08H
      INT 21H
@@KONIEC:
      RET
SAVE ENDP
;****************************************************************************

START:
        MOV AX, SEG DATA        ;NASTAV DATA SEGMENT
        MOV DS, AX

N1:     CALL MENUPROC               ;VYPISE MENU

        MOV AH, 07H              ;NACITA ZNAK ZO VSTUPU DO AL
        INT 21H
        CMP AL, '1'             ;POROVNAVA HO A VOLA JEDNOTLIVE FUNKCIE
        JNE N2                  ;ZADAJ VSTUPNY SUBOR
            CALL ZADAJ_SUBOR
            CMP AX, 0
            JNE ERR1
            CALL OTVOR_SUBOR	; OTVORI SUBOR
            CMP AX, 0
            JNE ERR4
            CALL NACITAJ	; NACITA HO DO BUFFRA
	    CALL GET_FIRST
	    JC OK_NO
CYKLUS:	    
	    CALL GET_NEXT	; ZKONTROLUJE CISLICE
	    JC OK_NO
	    JMP CYKLUS
VSETKO_OK:	    
            CALL VYPIS1          ; VSETKO JE OK
	    MOV FILEOK,01H
            JMP N1
OK_NO:	    CMP AX,00H
	    JE VSETKO_OK
	    MOV DX,OFFSET BADFILE   ; BOLO NASTAVENE CARRY A ZAROVEN
	    			;    JE V AX 01H -> CHYBA V SUBORE	
	    MOV AH,09H
	    INT 21H
	    MOV AH,08H
	    INT 21H
	    MOV FILEOK,00H           ; V SUBORE BOLA CHYBA
     ERR1:  CALL CLS
     ERR4:  JMP N1
N2:     CMP AL, '2'             ;VYPOCITAJ SUMU
        JNE N3
		CMP FILEOK,00H	   ; AK NEBOL ZADANY VSTUPNY SUBOR
		JNE OK1		   ; TAK VYPISE HLASKU
		CALL CLS
		MOV DX,OFFSET NOFILE
		MOV AH,09H
		INT 21H
		MOV AH,08H
		INT 21H
		JMP N1
OK1:            CALL SUMUP
            JMP N1
N3:     CMP AL, '3'             ;USPORIADAJ VZOSTUPNE
        JNE N5
		CMP FILEOK,00H
		JNE OK2
		CALL CLS
		MOV DX,OFFSET NOFILE
		MOV AH,09H
		INT 21H
		MOV AH,08H
		INT 21H
		JMP N1
OK2:            CALL USP_VZOSTUPNE
            JMP N1
N5:     CMP AL, '4'             ;VYDEL DVE VYBRANE CISLA
        JNE N6
            CALL DELENIE
            JMP N1
N6:     CMP AL, '5'             ;VYNASOB DVE VYBRANE CISLA
        JNE N7
            CALL NASOBENIE
            JMP N1
N7:     CMP AL, '6'             ;KONIEC
	JE KONIEC
        JMP N1                  ;AK NEBOLA STLACENA 7, SKOC NA ZACIATOK

KONIEC: MOV AH, 4CH             ;UKONC PROGRAM
        INT 21H
CODE ENDS
     END START

;ZHODNOTENIE:

;PROGRAM PRACUJE PODLA ZADANYCH KRITERII A JE PLNE FUNKCNY. BOL VYPRACOVANY
;V PROSTREDI DOSU. ROZSAH PLATNYCH CISEL JE <-32767, 32767> - TEDA POUZIVAM
;16-BITOVU ARITMETIKU. TENTO ROZSAH PLATI PRE DATA VSTUPUJUCE DO PROGRAMU AKO
;AJ Z NEHO VYSTUPUJUCE.

;OBMEDZENIA:
;PROGRAM JE OKREM INTERVALU PLATNYCH CISEL OBMEDZENY AJ NA VSTUPE:
;        - VSTUPNY SUBOR MOZE DOSAHOVAT VELKOST MAX. 800 BYTEOV
;        - VSTUPNY SUBOR MOZE OBSAHOVAT MAX. 100 CISEL, CO POKRYVA 800 BYTEOV
;        - PRI VSTUPE VIAC AKO 24 CISEL SA OBJAVIA NA OBRAZOVKE
;          CHYBY VYPISU - VYPIS UTECIE
;OSTATNE PROCEDURY AKO TRIEDENIE A SUMA PRACUJU KOREKTNE, CO SA DA POTVRDIT
;VYSTUPOM DO SUBORU.