;Zadanie c.2b
;
;Text Zadania:
;Vytvorte  program,  ktory  nacta  z  textovho sboru postupnost celych 
;csel (aspon 10)so znamienkom  v desiatkovej cselnej sstave, potom 
;ich transformuje na csla v dvojkovej cselnej sstave v doplnkovom kde a 
;potom podla priania pouzvatela
;a)	spocta kladn (alebo zporn)csla a sumu vypse
;b)	usporiada csla zostupne a zapse usporiadan postupnost csel
;       do novho textovho sboru,
;c)	vydel dve vybran csla a vypse vysledok
;d)	vynsob posledn dve csla a vypse vysledok
;e)	ukonc vykonvanie programu.
;
;Autor: Norbert Kornyi
;Termin odovzdania: 16.11.2k
;2.roc.,sk.rok 2000/2001

stck SEGMENT 
dw 20 dup (?)
stck ENDS


data SEGMENT
menutxt		db 'Vyberte si z MENU :',13,10
		db 'a) Scitanie vsetkych kladnych cisel',13,10
		db 'b) usporiadanie cisel zostupne a zapis do suboru',13,10
		db 'c) vydelenie dvoch vybranych cisel podla indexu',13,10
		db 'd) vynasobenie dvoch poslednych cisel a vypis vysledku',13,10
		db 'e) koniec programu',13,10,'$'

text_a1		db 'Suma vsetkych kladnych cisel je : '
text_a12	db 5 dup (' '),'$'
text_a2		db 'Suma kladnych cisel je prilis velka...','$'
text_b		db 'Cisla boli ulozene do suboru cisla.out','$'
subor		db 'cisla.txt',0
suborout	db 'cisla.out',0
buffer		db 8*30 dup (?)
buffer2		db 8*30 dup ('      ',13,10)
bufferlen	dw ?
cisla		dw 30 dup (0)
sign		db 0
cislacnt	dw 0
text_c1		db 'Zadajte indexy cisel na vydelenie oddelene ENTERom :',13,10,'$'
text_c12	db '      /       :'
text_c2		db 'Podiel vybranych cisel je :'
podiel		db 7 dup (' '),13,10
		db 'Zvysok :'
zvysok		db 7 dup (' '),13,10,'$'
text_c3		db 'Podiel je zle cislo...',13,10,'$'

index		db 6,8 dup (0)
text_d		db 'Sucin poslednych dvoch cisel je  :'
sucin		db 7 dup (' '),13,10,'$'				; pocet zkonvertovanych wordov
text_d2		db 'Sucin je prilis velke cislo !',13,10,'$'
txtcrlf		db 13,10,10,10,'$'

menuadr		dw offset uloha_a
		dw offset uloha_b
		dw offset uloha_c
		dw offset uloha_d
		dw offset uloha_e
data ENDS


code SEGMENT
ASSUME CS:code,DS:data,SS:stck
Start:
		mov ax,SEG data
		mov ds,ax
		mov es,ax
		mov ax,SEG stck
		mov ss,ax			; Definicia segmentov

		mov ax,3d00h
		mov dx,offset subor
		int 21h				; Otvorenie suboru

		mov bx,ax
		mov ah,3fh
		mov dx,offset buffer
		mov cx,0ffffh
		int 21h				; Nacitanie obsahu suboru

		mov bx,ax
		mov si,offset buffer
		mov di,offset cisla
		mov byte ptr [si+bx],0	; zapis 0 na koniec buffera

nextcislo:	call ascii2bin          	; Ak je cislo mimo, neratame ho
		cmp byte ptr [sign],0ffh
		je cislomimo
		inc word ptr [cislacnt]         ; Zvacsime pocet nacitanych cisel
		stosw				; Ulozime BIN hodnotu cisla
cislomimo:	cmp byte ptr [si],0		; Ak sme este neskoncili, tak dalsie cislo
		jnz nextcislo

endofbuffer:
menu:		mov ax,03h
		int 10h				; Mazanie obr.

		mov dx,offset menutxt
		mov ah,09h
		int 21h				; Vypis moznosti menu

		mov ah,01h
		int 21h
		sub al,'a'
		js menu
		cmp al,5-1
		ja menu				; Je polozka mimo rozsahu ?

		xor ah,ah
		shl ax,1
		mov si,offset menuadr
		add si,ax

		mov ah,09h
		mov dx,offset txtcrlf
		int 21h				; Zariadkovanie

		call [si]			; Volanie ziskanej adresy polozky menu

		xor ax,ax			; Cakanie na stlac. klav.
		int 16h

		jmp menu			; Opakujeme menu

;;;;;;;;;;;;;;
;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;
;Vstup:		DS:SI adresa cisla ukoncena 13 alebo 0
;Vystup:	zkonvertovane cislo v AX
ascii2bin:	
		mov bx,10			; sustava
		xor cx,cx			; cislo
		xor ax,ax			; tmp
		mov byte ptr [sign],0
nextchar:	lodsb
		cmp al,13
		je endascii2bin
		or al,al
		je endascii2bin			; ak je CR alebo NULL koncime.
		cmp al,'	'
		je nextchar
		cmp al,' '
		je nextchar			; TAB a SPACE je oddelovaci znak

		cmp al,'-'			; minus ?
		jne nominus
		mov byte ptr [sign],1		; Ak ano nastav znamienko
		jmp nextchar
nominus:	
		xchg ax,cx			; potrebujeme bin. cislo v ax
		cmp byte ptr [sign],1		; Je cislo zaporne ?
		je multiple			; Ak ano, tak nech nasobi
		cmp ax,32767			; Ak je kladne a sucasne > 32767 tak je mimo rozsahu
		jna multiple
		mov byte ptr [sign],0ffh	; Inak chyba !
multiple:	mul bx				; najprv "posunieme" cislo dolava v 10 sustave
		xchg ax,cx
		sub al,'0'			; vyrobime z ascii bin
		add cx,ax
		jmp nextchar

endascii2bin:	cmp byte ptr [sign],1
		jne retascii2bin
		neg cx
retascii2bin:	mov ax,cx
		inc si
		ret
;;;;;;;;;;;;;;
; Vstup: 	AX=cislo
;        	[DS:sign] znamienko
;	 	ES:DI adresa na zkonvertovane cislo (odzadu)
; Vystup: 	zkonvertovane AX na ascii hodnotu na ES:DI (odzadu)
bin2ascii:	mov bx,10
		std

nextdigit:	xor dx,dx
		div bx		
		xchg dx,ax
		add al,'0'
		stosb
		xchg dx,ax
		or ax,ax		; Mame este co delit ?
		jnz nextdigit

		cmp byte ptr [sign],1	; Ak mame znamienko, tak zapiseme aj to.
		jne endbin2ascii
		mov byte ptr [di],'-'
endbin2ascii:
		cld
		ret
;;;;;;;;;;;;;;
;;;;;;;;;;;;;;
;Vystp: Suma kladnych cisel
;
uloha_a:	mov si,offset cisla
		mov cx,word ptr [cislacnt]
		xor dx,dx
loopa:		lodsw
		cmp ax,32767
		ja dontcount			; Ak nie je kladne, nepocita sa
		add dx,ax
		jo overflow			; Pokial je cislo prilis velke, ohlasi chybu
dontcount:	loop loopa
		jmp nooverflow
overflow:	mov ah,09
		mov dx,offset text_a2
		int 21h
                ret

nooverflow:	mov ax,dx			; Inak ho zkonvertuje na ASCII
		mov di,offset text_a12+4
		call bin2ascii

		mov ah,09h			; a vypise ho
                mov dx,offset text_a1
		int 21h
		ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha_b:	
		mov cx,word ptr [cislacnt]
		dec cx				; Cyklus a=1 to n-1
		mov si,offset cisla
		xor dx,dx
loopb2:		lodsw				; nacitame cislo
		mov bx,ax
		mov di,si
		sub di,2
		inc dx
		push cx
		push si

		mov cx,word ptr [cislacnt]
		sub cx,dx			; Podcyklus b=a+1 to n

loopb1:		lodsw
		mov byte ptr [sign],0

		cmp ax,32767			; kontrola znamienok
		jna nezapax
zapax:		xor byte ptr [sign],1
nezapax:	cmp bx,32767
		jna nezapbx
zapbx:		xor byte ptr [sign],1
nezapbx:	cmp byte ptr [sign],1		; Porovnanie zavisi od polarity cisel
		je rozneznam
		cmp bx,ax
		jnb noswap
		jmp swap			; Ak sme nasli vacsie cislo, tak swap
rozneznam:
		cmp ax,bx
		jnb noswap

swap:		mov word ptr [si-2],bx		; Zamena v pamati
		mov word ptr [di],ax
		xchg bx,ax			; Uz porovnavame zmenenu hodnotu
noswap:		loop loopb1

		pop si				; obnova premennych pre nadcyklus
		pop cx
		loop loopb2

		mov di,offset buffer2+5
		mov si,offset cisla
		mov cx,word ptr [cislacnt]	; Nasleduje konverzia vsetkych cisel na ASCII

loopb3:		push di                  
		lodsw

		mov byte ptr [sign],0
		cmp ax,32767			; je zaporne ?
		jna doloop3
		mov byte ptr [sign],1		; ak ano, tak nastav znamienko
		neg ax				; a do AX=|AX|

doloop3:	call bin2ascii
		pop di
		add di,8			; Kazde cislo ma rezervovane v bufferi 8 bytov
		loop loopb3

;		mov byte ptr [di],'$'

		mov ah,3ch
		mov dx,offset suborout
		xor cx,cx
		int 21h				; Zalozenie suboru

		mov bx,ax
		mov ah,40h
		mov dx,offset buffer2
		mov cx,word ptr cislacnt	; Zapiseme POCET_CISEL*8
		shl cx,1
		shl cx,1
		shl cx,1			; 8 je velkost jedneho cisla
		int 21h

		mov ah,09h
		mov dx,offset text_b
		int 21h				; vypis textu

		ret
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha_c:	mov ah,09h
		mov dx,offset text_c1
		int 21h

		mov ah,0ah				; Nacita cislo ako retazec
		mov dx,offset index
		int 21h

		mov si,offset index+2			; Zkonvertuje ho
		call ascii2bin
		mov bx,ax				; 
		shl bx,1
		mov ax,word ptr [offset cisla+bx]	; Do AX ide delenec
		push ax

		mov ah,0ah				; opat nacita cislo
		mov dx,offset index
		int 21h

		mov si,offset index+2
		call ascii2bin
		mov bx,ax
		shl bx,1
		mov bx,word ptr [offset cisla+bx]	
		pop ax                                  ; Do BX delenec

		mov byte ptr [sign],0			; Zistime vysledne znam.
		cmp ax,32767				; podielu
		jna kladne_c
		neg ax					; a prip. upravime
		xor byte ptr [sign],1			; delenec a delitel
kladne_c:	cmp bx,32767				; na ich abs. hodnoty
		jna kladne_c2
		neg bx
		xor byte ptr [sign],1
kladne_c2:
		xor dx,dx
		or bx,bx				; delenie 0
		jz chyba_c

		div bx
		jnc vypis_d				; ak je delenie OK, tak vypis

chyba_c:	mov ah,09h
		mov dx,offset text_c3
		int 21h
		ret

vypis_d:	push dx					; Zmena na ASCII
		mov di,offset podiel+5
		call bin2ascii
		pop ax
		mov di,offset zvysok+5
		call bin2ascii

		mov ah,09h
		mov dx,offset text_c2
		int 21h					; Vypis

		ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha_d:	mov byte ptr [sign],0
		mov bx,word ptr [cislacnt]	; do BX pocet nacitanych cisel
		sub bx,2
		shl bx,1			; bx*2, pretoze su to wordy
		mov si,offset cisla
		add si,bx			; SI ukazuje na prepredposledne cislo

		lodsw				; Znamienkova korekcia
		cmp ax,32767
		jna kladne
		neg ax
		xor byte ptr [sign],1
kladne:
		mov bx,ax
		lodsw
		cmp ax,32767
		jna kladne2
		neg ax
		xor byte ptr [sign],1
kladne2:
		mul bx				; Nasobime 2 cisla
		jnc ok_d
		mov dx,offset text_d2
ok_d:		mov di,offset sucin+5
		call bin2ascii			; konverzia sucinu na ASCII

		mov ah,09h
		mov dx,offset text_d
		int 21h				; Vypis
		ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uloha_e:	mov ax,4c00h
		int 21h				; Ukoncenie programu.


code ENDS
		end Start

Program je plne funkcny. Na jeho vyvoj bol pouzity TASM, ako technicky manual
som pouzival SYSMAN. Program bol doladovany v TD.
Ako vstup programu sluzi subor 'cisla.txt' kde su v jednotlivych riadkoch cisla
v rozsahu -32768;32767. Pokial je tento rozsah prekroceny, je cislo ignorovane.

Vylepsenia:
- Menu je strukturovane podla adries funkcii
- Na triedenie cisel som pouzil bubble sort so sluckou (a=1 to n-1 (b=a+1 to n))
- shl ax,1 - nasobenie 2^n mozno vyriesit posunom o 1 bit vlavo n krat.
  vyhody su: mensi kod a vacsia rychlost.
- xor byte ptr [sign],1 Preklopi hodnotu znamienka 0=+  a  1=-
- xchg ax,bx - v skutocnosti je to rychlejse ako mov ax,bx a zabera to 1 byte
