;Zadanie c.1.
;Text zadania:

;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) a ;podla ponkanho menu vykon  jednu z monost:
;a) vype retazec znakov na obrazovku
;b) vype pocet cslic v retazci
;c) zist,ci sa v retazci nachdza pouvatelom zadany znak a vype o tom ;sprvu
;d) njde znak s min. hodnotou a vype tento znak
;e) mal psmen konvertuje na velk
;f) zarovn text zprava ( vynech prv medzery odkonca)
;g) ukonc vykonvanie programu.

;Autor:  Daniel Kothaj  
;Termin odovzdania: 26.10.2000 
;2.roc.,k.rok 2000/2001

stck	SEGMENT STACK
		dw 20 dup(?)
stck	ENDS

data	SEGMENT
menutxt:
		db 'Zadajte volbu:',13,10
		db 'a) vypisat retazec na obrazovku',13,10
		db 'b) vypisat pocet cislic v retazci',13,10
		db 'c) zistit vyskyt znaku v retazci',13,10
		db 'd) najst znak s minimalnou hodnotou',13,10
		db 'e) konverzia malych pismen na velke',13,10
		db 'f) zarovnat text zprava',13,10
		db 'g) ukoncit program',13,10
		db 0

menupol:	dw offset uloha_a
		dw offset uloha_b
		dw offset uloha_c
		dw offset uloha_d
		dw offset uloha_e
		dw offset uloha_f
		dw offset uloha_g
 
buffer:		db 100,0
		db 100 dup(?),0

text1		db 'Zadajte prosim retazec : ',0
text2		db 13,10,10,10,'...stlac lubovolnu klavesu...',0
text_a		db 13,10,10,'Zadany retazec:',13,10,0
text_b		db 13,10,10,'Pocet cislic v retazci: '
cislo_b		db 4 dup(?)
text_c1		db 13,10,10,10,'ZadAj znak, ktory sa ma vyskytovat: ',0
text_c2		db 13,10,'Pocet vyskytov znaku "'
text_c22	db ?
		db '" v retazci je : '
cislo_c		db 4 dup(?),0
text_d		db 13,10,10,10,'Znak s minimalnou hodnotou v retazci je : "'
text_d2		db (?),'"',0
text_e		db 13,10,10,10,'Male pismena boli zkonvertovane na velke. Novy retazec :',13,10,0
text_f		db 13,10,10,10,'Text zarovnany zprava :',13,10,0

data	ENDS

code	SEGMENT
ASSUME CS:code,DS:data,SS:stck
Start:
		mov ax, SEG data
		mov ds,ax

		mov ax,3
		int 10h				; Vymazanie obrazovky
		mov si,offset text1		; Vypisanie uvodneho textu
		call vypis

		mov ah,0ah
		mov dx,offset buffer
		int 21h				; Nacitame retazec na adresu buffer

menu:		mov ax,03h			; Mazanie obrazovky
		int 10h

		mov si,offset menutxt
		call vypis			; Vypis moznosti do menu

		mov ah,01h
		int 21h				; Nacitame znak, ktory oznacuje polozku

		sub al,'a'			; 'a'=61h v ASCII
		js menu				; ak je pod 60h, tak nevyhovuje
		cmp al,7-1			; sedem poloziek, ratame od 0
		ja menu				; ak znak oznacuje polozku vyssiu ako ponukame, nevyhovuje

		xor ah,ah
		mov si,ax
		shl si,1		; nasobime al dvomi (velkost word)
		add si,offset menupol	; do SI dostaneme adresu adresy "podprocedury" v tabulke

		mov ax,[si]		; do ax adresu "podprocedury"
		call ax			; zavolame precitanu adresu

		mov si,offset text2
		call vypis
		xor ax,ax
		int 16h			; Caka na stlacenie klavesy

		jmp menu		; Ak sa vrati z proc., ponukne menu

;  Konverzia cisla na retazec  
; vstup:	BL=ciselna sustava
;		AX=cislo na konverziu
;		SI=adresa pre retazec
;vystup:	retazec na adrese DS:SI ukonceny 0
digit:		div bl				; delime AX/BL
		add ah,30h			; 30h je '0'
		mov [si],al
                mov [si+1],ah


;               mov byte ptr [si],0             ; Retazec ukoncime 0
		ret
;  Vypis  
;vstup: 	v ds:si adresa retazca ukonceneho 0;
vypis:		mov ah,02h
vypisloop:	mov dl,[si]
		or dl,dl			; nahrada cmp dl,0 - setri 1Byte
		jz endvypis

		int 21h
		inc si
		jmp vypisloop
endvypis:	ret		
;  A  
;Vypise retazec znakov na obrazovku
uloha_a:	

		mov si,offset text_a
		call vypis

		
		mov si,offset buffer+2
			
		call vypis
		ret
;  B  
; Vypise pocet cislic
uloha_b:	mov si,offset buffer+2
		xor ax,ax

nextchar:	mov bl,[si]			; Nacitame znak z retazca
		inc si				; ukazatel+1 aby ukazoval na dalsi znak
		cmp bl,13			; je to Enter?
		je endofstr			; ak ano tak je koniec retazca

		cmp bl,'0'			; je znak v bl <'0'?
		jb nextchar			; ak ano tak to neni cislo
		cmp bl,'9'			; je znak v bl >'9'?
		ja nextchar			; ak ano, neni to cislo
		inc ax				; ak sa dostaneme sem, je to cislo => pocet do AX
		jmp nextchar			; kontrolujeme dalsi znak

endofstr:	mov si,offset cislo_b		; koverzia cisla na retazec
		mov bl,10			; desiatkova sustava

		call digit

		mov si,offset text_b
		call vypis
		
end_b:		ret
;  C  
uloha_c:	mov si,offset text_c1
		call vypis
		mov ah,01h
		int 21h				; Nacitanie znaku

		xor cx,cx
		mov si,offset buffer+2
searchnext:	mov ah,[si]			; Nacitame do AH znak z retazca
		inc si				; neskor kontrolujeme dalsi znak
		cmp ah,13
		je endsearch

		cmp ah,al			; je znak totozny s nami hladanym znakom ?
		jne searchnext
		inc cx
		jmp searchnext

endsearch:	mov byte ptr [text_c22],al	; Ulozime hladany znak
		mov ax,cx			; Do AX pocet jeho vyskytov v retazci
		mov bl,10			; des. sustava
		mov si,offset cislo_c
		call digit

		mov si,offset text_c2
		call vypis

		ret
;  D  
uloha_d:	mov si,offset buffer+2
		mov ah,255			; do AH max. moznu hodnotu

cmpnext:	mov al,byte ptr [si]
		inc si
		cmp al,13
		je endcmp                       ; Jelenovi pivo nelej

		cmp al,ah			; Je nacitany znak mensi ako posledny nacitany ?
		jnb cmpnext
		mov ah,al			; Ulozime najmensi znak pre porovnanie
		jmp cmpnext

endcmp:		mov byte ptr [text_d2],ah
		mov si,offset text_d
		call vypis

		ret
;  E  
uloha_e:	mov si,offset buffer+2

nextconvert:	mov al,byte ptr [si]
		inc si
		cmp al,13
		je endconvert

		cmp al,'a'			; Je znak mensi ako 'a'?
		jb nextconvert
		cmp al,'z'			; Je vacsi ako 'z' ?
		ja nextconvert			; Ak ano tak hladame dalsi

		sub al,32
		mov byte ptr [si-1],al
		jmp nextconvert

endconvert:	mov si,offset text_e
		call vypis
		call uloha_a			; Vypis retazca
		ret		
;  F  
uloha_f:	mov si,offset text_f
		call vypis	           	; no comment

		mov bl,byte ptr [buffer+1]
		xor bh,bh
		mov byte ptr [buffer+2+1+bx],0 ; to kvoli procedure

		mov al,byte ptr [buffer+1]
		xor ah,ah
		mov si,offset buffer+2
		mov bl,80			; v bl je pocet znakov v riadku
		div bl

		xchg ah,al		
		push ax
		or ah,ah			; je (pocet znakov mod 80)=0 ?
		jz oneline			; Budeme vypisovat len jeden riadok
		mov cx,80
		mov ah,02h
loopalign:	mov dl,[si]
		int 21h				; Vypise znak
		inc si				; Zvacsi ukazatel
		loop loopalign

oneline:	pop ax
		xor ah,ah
		mov cx,80
		sub cx,ax
		mov ah,02h
		mov dl,' '
loopmedzera:	int 21h
		loop loopmedzera


		call vypis
		ret

;  G  
uloha_g:
		mov ax,4c00h
		int 21h



code	ENDS
		end Start	



;Zhodnotenie:
;Program je funkcny .Bol vypracovanany v prostredi dos za pouzitia
;TASM,TLINK,(nutn programov a tech.vybavenie), ;chovanie  programu vzhladom  na vstupn  daje (  s obmedzenia?), chovanie  ;programu  vzhladom  na pouit sluby DOS resp. BIOS , opis   monch   ;vylepen   -   programov resp.technicke, popis vlastnch pouitch ;algoritmov, upozornenie na taktiky a finty, ktor pouil tvorca programu

