 ;   PROGRAM NA PRACU S RETAZCOM  
 ;   ZADANIE CISLO : 1
 ;   AUTOR : Martin Kozeluha, KRUZOK : A-03
 ;   TERMIN ODOVZDANIA : 5.tyzden semestra
 ;   2.rocnik, skolsky rok 2000/2001
 ;   MOZNOSTI PROGRAMU :        
 ;   1 - vypise retazec znakov na obrazovku
 ;   2 - vypise pocet cislic v retazci
 ;   3 - najde zadany znak a vypise o tom spravu
 ;   4 - najde znak s minimalnou hodnotou a vypise ho
 ;   5 - male pismena skonvertuje na velke
 ;   6 - zarovna text z prava
 ;   7 - ukonci cinnost
 ;=================================================================================


ZAS SEGMENT STACK			; ZASOBNIKOVY SEGMENT
	DB 100H DUP (?)
ZAS ENDS
 ;-------------------------------------------------------------------------------------------------------------------------------------------------------------------
DATA SEGMENT				; DATOVY SEGMENT 
	MSTR 	DB 100 DUP (?);	; PREMENNA PRE NACITANIE RETAZCA
	VYPIS 	DW 5 DUP (0D0AH);
		DB 'PROSIM ZADAJTE RETAZEC V DLZKE MAX. 100 ZNAKOV : ',0DH,0AH,'$'
	MENU 	DW 9 DUP (0D0AH)
		DB '                      [A] VYPIS RETAZCA',0DH,0AH
		DB '                      [B] POCET CISLIC V RETAZCI',0DH,0AH
		DB '                      [C] VYHLADANIE ZNAKU',0DH,0AH
		DB '                      [D] VYHLADANIE ZNAKU S MINIMALNOU HODNOTOU',0DH,0AH
		DB '                      [E] KONVERZIA MALYCH PISMEN NA VELKE',0DH,0AH
		DB '                      [F] VYPIS ZAROVNANY SPRAVA',0DH,0AH
		DB '                      [G] KONIEC PROGRAMU'
		DW 10 DUP(0D0AH),'$'
	OZNAM_A DB 'ZADANY RETAZEC : ',0DH,0AH,'$'	
	OZNAM_B DB 'POCET CISLIC V RETAZCI : $'
	OZNAM_C1 DB 'ZADAJTE ZNAK, KTORY MAM VYHLADAT : $'
	OZNAM_C2 DB 'ZNAK " " SA V RETAZCI NACHADZA $'
	OZNAM_C3 DB ' KRAT. $'
	OZNAM_D DB 'ZNAK S MINIMALNOU HODNOTOU :  " " $'
	OZNAM_E DB 'KONVERTOVANY RETAZEC : ',0DH,0AH,'$'
	OZNAM_F DB 'RETAZEC ZAROVNANY DOPRAVA : ',0DH,0AH,'$' 
	CAKAJ   DB 'CAKAM NA STLACENIE KLAVESY ... $'
	CLEAR   DW 25 DUP (0D0AH)
		DB '$'
	CISLICA DB '00000$'       	; FORMULAR PRE CISLICU
	
DATA ENDS
 ;-------------------------------------------------------------------------------------------------------------------------------------------------------------------
CODE SEGMENT
	ASSUME CS:CODE, DS:DATA, SS:ZAS
	
START:
	MOV AX,SEG DATA
	MOV DS,AX		; NASTAVENIE SEGMENTOVEJ ADRESY PREMENNYCH
	CALL CLRSCR
	MOV DX,OFFSET VYPIS	; ADRESA PREMENNEJ DO DX
	MOV AH,09H		; FUNKCIA VYPIS NA OBRAZOVKU
	INT 21H
	MOV DX,OFFSET MSTR	; ADRESA MSTR DO DX
	MOV AH,0AH		; FUNKCIA NA NACITANIE RETAZCA
	INT 21H

	MOV DX,OFFSET MSTR	; ADRESA MSTR DO DX
	INC DX			; O JEDEN BYTE DALEJ SA NACHADZA POCET ZNAKOV
	XOR CX,CX		; NULOVANIE CX
	MOV DI,DX
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV
	MOV AX,DX		; DO AX IDE ADRESA MSTR
	ADD AX,CX		; PRIPOCITAM POCET ZNAKOV
	INC AX			; PRESKOCIM  BYTE : "LEN" 
	MOV DI,AX
	XOR AX,AX
	MOV AL,'$'
	MOV BYTE PTR DS:[DI],AL	; PRIDAM NA KONIEC RETAZCA UKONCOVACI ZNAK '$' 
	
	
MENU_START:			; MENU AJ S VYPISOM NA OBRAZOVKU
	CALL CLRSCR		; SKACE SA TU Z PODPROG., KTORE PISALI NA OBR.	
	MOV DX,OFFSET MENU	; ADRESA PREMENNEJ MENU DO DX
	MOV AH,09H		; FUNKCIA VYPIS NA OBRAZOVKU
	INT 21H

MENU_CYKLUS:
	XOR AX,AX
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	CMP AL,'A'
	JE A 
	CMP AL,'a'
	JE A 
	CMP AL,'B'
	JE B 
	CMP AL,'b'
	JE B 
	CMP AL,'C'
	JE C 
	CMP AL,'c'
	JE C 
	CMP AL,'D'
	JE D 
	CMP AL,'d'
	JE D 
	CMP AL,'E'
	JE E 
	CMP AL,'e'
	JE E
	CMP AL,'F'
	JE F 
	CMP AL,'f'
	JE F
	CMP AL,'G'		; 'g' ALEBO 'G' => KONIEC
	JE KONIEC 
	CMP AL,'g'
	JE KONIEC 

	JMP MENU_CYKLUS


A: 	CALL VYPIS_RETAZCA
	JMP MENU_START
B:	CALL POCET_CISLIC
	JMP MENU_START
C:	CALL VYHLADANIE
	JMP MENU_START
D:	CALL MINIMAL
	JMP MENU_START
E:	CALL KONVERZIA
	JMP MENU_START
F:	CALL ZAROVNANIE
	JMP MENU_START

	
	
	
KONIEC:	
	MOV AX,4C00H		; UKONCENIE PROGRAMU
	INT 21H
	
	
VYPIS_RETAZCA PROC NEAR			; VOLBA 'A' Z MENU
	PUSH AX
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_A	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	MOV DX,OFFSET MSTR	; OFFSETOVA ADRESA MSTR DO DX
	INC DX			; PRESKOCIM UVODNE DVA BYTE
	INC DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
;   JMP MENU_START		; NAVRAT DO CYKLU MENU
VYPIS_RETAZCA ENDP	



POCET_CISLIC PROC NEAR
	PUSH AX
	XOR CX,CX
	MOV DX,OFFSET MSTR
	INC DX
	MOV DI,DX
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
	XOR DX,DX		; DO DX BUDEM DAVAT POCET CISLIC
  CYKLUS_B:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AL,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AL,30H		; TU ZACINAJU CISLICE V ASCII TABULKE
	JB  NIC_B		; NIC Z TOHO
	CMP AL,39H		; TU KONCIA CISLICE
	JNBE NIC_B		; NIC Z TOHO
	INC DX			; PRESIEL SITOM -> JE TO CISLICA
  NIC_B:LOOP CYKLUS_B		; CYKLUS, KYM CX JE VECSIE AKO 0
	CALL CLRSCR
	PUSH DX
	MOV DX,OFFSET OZNAM_B	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	POP DX
	CALL ZOBRAZ_CISLO	; ZOBRAZI CISLO
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
POCET_CISLIC ENDP
	


VYHLADANIE PROC NEAR	
	PUSH AX
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_C1
	MOV AH,09H		; VYPIS VYZVY NA ZADANIE ZNAKU
	INT 21H
	MOV AH,01H		; VSTUP ZNAKU S ECHOM NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	MOV DI, OFFSET OZNAM_C2
	MOV DS:[DI+6 ],AL	; DOPLNENIE ZNAKU DO SPRAVY	 
	
	XOR CX,CX		; NULOVANIE CX
	MOV DX,OFFSET MSTR	; NASTAVIM SA NA ZACIATOK MSTR
	INC DX			; PRESKOCIM BYTE "MAX"
	MOV DI,DX		; VLOZIM ZACIATOK DO DI
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
	XOR DX,DX		; DO DX BUDEM DAVAT POCET NAJDENYCH ZADANYCH ZNAKOV
  CYKLUS_C:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AH,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AH,AL		; V AH JE ZNAK Z RETAZCA, V AL JE ZADANY ZNAK
				; POROVNAM ICH
	JNE  NIC_C		; NIC Z TOHO
	INC DX			; PRESIEL SITOM -> JE TO ZADANY ZNAK
  NIC_C:LOOP CYKLUS_C		; CYKLUS, KYM CX JE VECSIE AKO 0
	CALL CLRSCR
	PUSH DX
	MOV DX,OFFSET OZNAM_C2	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	POP DX
	CALL ZOBRAZ_CISLO	; ZOBRAZI CISLO
	MOV DX,OFFSET OZNAM_C3	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
;   JMP MENU_START		; NAVRAT DO CYKLU MENU
VYHLADANIE ENDP   
	
MINIMAL	PROC NEAR
	PUSH AX
	XOR CX,CX
	MOV DX,OFFSET MSTR
	INC DX
	MOV DI,DX
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
	MOV AH,0FFH		; MAX MOZNA HODNOTA DO AH
  CYKLUS_D:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AL,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AL,AH		; V AH JE NAJMENSI ZNAK, POROVNAM HO S AL
	JNB  NIC_D		; NIC Z TOHO (NIE JE MENSI)
	MOV AH,AL		; JE MENSI => DAM HO DO AH
  NIC_D:LOOP CYKLUS_D		; CYKLUS, KYM CX JE VECSIE AKO 0
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_D	; OFFSETOVA ADRESA STR DO DX
	MOV DI,DX
	MOV BYTE PTR DS:[DI+31],AH ; DOPLNIM ZNAK DO SPRAVY PRE UZIVATELA
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
;   JMP MENU_START		; NAVRAT DO CYKLU MENU
MINIMAL ENDP
	

KONVERZIA PROC NEAR
	PUSH AX
	CALL CLRSCR
	MOV DX,OFFSET OZNAM_E	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	XOR CX,CX
	MOV DX,OFFSET MSTR
	INC DX
	MOV DI,DX
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
  CYKLUS_E:			; CYKLUS, V KTOROM PREJDEM CELYM RETAZCOM
  	INC DI			; POSUNIEM SA NA PRVY ZNAK
	MOV AL,BYTE PTR DS:[DI]	; DO AL IDE ZNAK
	CMP AL,61H		; TU ZACINAJU MALE PISMENA V ASCII TABULKE
	JB  NIC_E		; NIC Z TOHO
	CMP AL,7AH		; TU KONCIA MALE PISMENA
	JNBE NIC_E		; NIC Z TOHO
	MOV AH,00H		; PRESIEL SITOM -> JE TO MALE PISMENO
	SUB AX,20H		; ZKONVERTUJEM HO NA VELKE
  NIC_E:MOV DL,AL		; DO DL IDE (KONVERTOVANY) ZNAK
  	MOV AH,02H
	INT 21H			; ZOBRAZI ZNAK Z DL	
  	LOOP CYKLUS_E		; CYKLUS, KYM CX JE VECSIE AKO 0
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	
	POP AX
	RET
KONVERZIA ENDP	
	
	
ZAROVNANIE PROC NEAR
	PUSH AX
	CALL CLRSCR		; ZMAZANIE OBRAZOVKY
	MOV DX,OFFSET OZNAM_F	; OFFSETOVA ADRESA STR DO DX
	MOV AH,09H		; SLUZBA NA VYPIS RETAZCA
	INT 21H
	XOR CX,CX		; NULUJ CX
	MOV DX,OFFSET MSTR	; DO DX IDE OFFSETOVA ADRESA MSTR
	INC DX			; PRESKOCIM POLICKO MAX
	MOV DI,DX		; ADRESU POLICKA LEN DAM DO DI
	MOV CL,BYTE PTR DS:[DI]	; DO CX IDE POCET ZNAKOV V RETAZCI
	CMP CX,80		; POROVNAM CI SA ZMESTI NA 1 RIADOK
	JBE RIADOK1		; AK ANO, SKOC TAM
	PUSH CX			; ODLOZIM SI POCET ZNAKOV
	MOV BX,80
  MEDZERY:			; CYKLUS, V KTOROM HLADAM MEDZERY NA KONCI		
	MOV AL, BYTE PTR DS:[DI+BX]	; POSLEDNY ZNAK RETAZCA
	CMP AL,20H		; ASCII KOD MEDZERY
	JNE VYPIS_R1		; AK TO NEBOLA MEDZERA, TAK POKRACUJEM DALEJ 
	DEC BX			; POSUNIEM SA O 1 ZNAK DOLAVA
	MOV AH,02H		; VYSTUP ZNAKU NA OBRAZOVKU(POSUNIEM POZICIU
	MOV DL,20H		;    TYM, ZE VYPISEM MEDZERU)
	INT 21H			; VYPIS ZNAKU
	JMP MEDZERY		; POKRACUJ V HLADANI MEDZIER NA KONCI RETAZCA
  VYPIS_R1:			; VYPISE PRVY RIADOK
  	MOV CX,BX		; POCET ZNAKOV (BEZ KONCOVYCH MEDZIER) DO CX
	MOV BX,01H		; NASTAVIM SA NA PRVY ZNAK
  CYKLUS_F1:	
  	MOV AH,02H
	MOV DL,BYTE PTR DS:[DI+BX]
	INT 21H			; VYPISEM ZNAK
	INC BX
	LOOP CYKLUS_F1		; A V CYKLE CELY RETAZEC
  	POP CX			; NACITAM SI ODLOZENY POCET ZNAKOV V RETAZCI
	SUB CX,80		; ODPOCITAM UZ VYRIESENYCH 80 ZNAKOV
	ADD DI,80		; A POSUNIEM UKAZOVATEL DI
  RIADOK1:
        MOV BX,CX		; DO BX VLOZIM POCET ZNAKOV
	MOV AX,80
	SUB AX,CX		; ODPOCITAM OD 80 POCET ZNAKOV
	MOV CX,AX		; A POCET VLOZIM DO CX
  VYPIS_MEDZIER:		; V CYKLE DOPLNIM ZLAVA MEDZERY 
  				;  ( ABY SOM ZAROVNAL MSTR DOPRAVA)
  	MOV AH,02H		; SLUZBA VYPIS ZNAKU
	MOV DL,20H		; ASCII KOD MEDZERY
	INT 21H			; VYPIS MEDZERY
  	LOOP VYPIS_MEDZIER	
  MEDZERY2:			; CYKLUS, V KTOROM ZNOVA HLADAM MEDZERY 		
	MOV AL, BYTE PTR DS:[DI+BX]	; POSLEDNY ZNAK RETAZCA
	CMP AL,20H		; ASCII KOD MEDZERY
	JNE VYPIS_R2		; AK TO NEBOLA MEDZERA, TAK POKRACUJEM DALEJ 
	DEC BX			; POSUNIEM SA O 1 ZNAK DOLAVA
	MOV AH,02H		; VYSTUP ZNAKU NA OBRAZOVKU(POSUNIEM POZICIU
	MOV DL,20H		;    TYM, ZE VYPISEM MEDZERU)
	INT 21H			; VYPIS ZNAKU
	JMP MEDZERY2		; POKRACUJ V HLADANI MEDZIER NA KONCI RETAZCA
  VYPIS_R2:			; VYPISE PRVY RIADOK
  	MOV CX,BX		; POCET ZNAKOV (BEZ KONCOVYCH MEDZIER) DO CX
	MOV BX,01H		; NASTAVIM SA NA PRVY ZNAK
  CYKLUS_F2:	
  	MOV AH,02H
	MOV DL,BYTE PTR DS:[DI+BX]
	INT 21H			; VYPISEM ZNAK
	INC BX
	LOOP CYKLUS_F2		; A V CYKLE CELY RETAZEC
	MOV AH,08H		; VSTUP ZNAKU BEZ ECHA NA OBRAZOVKU
	INT 21H			; ZAVOLANIE SLUZBY, ZNAK IDE DO AL
	POP AX
	RET
ZAROVNANIE ENDP
	
	
CLRSCR PROC NEAR		; ZMAZANIE OBRAZOVKY  
	PUSH AX
	PUSH BX
	PUSH DX
	MOV DX,OFFSET CLEAR	; ADRESA PREMENNEJ DO DX
	MOV AH,09H		; FUNKCIA VYPIS NA OBRAZOVKU
	INT 21H
	MOV BH,00H		; NASTAVENIE KURZORA NA [1,1]
	MOV AH,02H
	MOV DH,00H
	MOV DL,00H
	INT 10H
	POP DX
	POP BX
	POP AX
	RET
CLRSCR ENDP

ZOBRAZ_CISLO PROC NEAR		; ZOBRAZI CISLO - OCAKAVA HO V DX
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	MOV DI,OFFSET CISLICA 
	MOV AX,DX		; DO AX IDE CISLO
	XOR DX,DX
	MOV CX,10000		; DELIM PRVU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO DX
	ADD AX,30H
	MOV BYTE PTR DS:[DI],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,1000		; DELIM DRUHU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+1],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,100		; DELIM TRETIU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+2],AL
	MOV AX,DX
	XOR DX,DX
	MOV CX,10		; DELIM STVRTU CISLICU
	DIV CX			; CISLICA IDE DO AX, ZVYSOK DO BX
	ADD AX,30H
	MOV BYTE PTR DS:[DI+3],AL
	ADD DX,30H
	MOV BYTE PTR DS:[DI+4],DL ; ZVYSOK JE POSLEDNA CISLICA (JEDNOTKY)
	MOV DX, OFFSET CISLICA
	MOV AH,09H
	INT 21H			; VYPIS CISLIC	
	POP DX
	POP CX
	POP BX
	POP AX
	RET
ZOBRAZ_CISLO ENDP

	
CODE ENDS
	END START
	
;=================================================================================
; ZHODNOTENIE:
; Program je plne funkcny -  bol vypracovany v podmienkach podobnych ako poskytuje Centralna 
;pocitacova ucebna na Fakulte informatiky a elektrotechniky STU, cim sa vylucila mozna nefunkcnost 
;programu sposobena rozlicnostou softveroveho vybavenia.Chyba: Program nevypisuje znaky nasledujuce za znakom'$',
;pretoze pre ukoncovanie retazca je pouzity rovnaky znak(cize '$').	
;Program je vypracovany za pomoci procedur a vyuzitia podmienenych aj nepodmienenych skokov.

	
	
	
	
	
	
	