;Zadanie cislo 2
;Text zadania:Vytvorte program,ktory z textoveho suboru nacita postupnost 
;celych cisel so znamienkom v desiatkovej ciselnej sustave,potom ich pretransformuje
;na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom podla priania 
;uzivatela -
;a, spocita kladne a zaporne cisla a sumu vypise 
;b, usporiada cisla zostupne a zapise sumu do textoveho suboru
;c, vydeli dve vybrane cisla
;d, vynasobi posledne dve cisla 
;e, ukonci vykonavanie programu
;AUTOR: Kozeluha Martin
;TERMIN ODOVZDANIA: 8.tyzden semestra
;2.rocnik,skolsky rok 2000/2001

;PROGRAM:
	

ZAS	SEGMENT	STACK			 ;definovanie zasobnikoveho segmentu
	db	200h DUP(?)
ZAS	ENDS

DATA	SEGMENT	
 


Menu            dw      5 DUP(0A0DH)  	   ;vypisanie Menu
		db      '                    ͻ',10,13
		db	'                     A - USPORIADAT CISLA ZOSTUPNE      ',10,13
		db      '                    ͹',10,13
		db	'                     B - VYDELIT DVE VYBRANE CISLA      ',10,13
		db      '                    ͹',10,13
		db	'                     C - VYNASOBIT DVE POSLEDNE CISLA   ',10,13
		db      '                    ͹',10,13 
		db	'                     D - VYPOCITAT SUMU KLADNYCH CISEL  ',10,13
		db      '                    ͹',10,13
		db	'                     E - VYPOCITAT SUMU ZAPORNYCH CISEL ',10,13
		db 	'                    ͹',10,13
		db	'                     Q - KONIEC                         ',10,13	     
		db      '                    ͼ',10,13,'$'

Meno_suboru_in    db      'Zadaj meno vstupneho suboru: $'
Meno_suboru_out   db      'Zadaj meno vystupneho suboru: $'

Chyba_otvarania	  db	13,10,'SUBOR SA NEPODARILO OTVORIT !',13,10,'$'
Chyba_zatvarania  db	13,10,'SUBOR SA NEPODARILO UZAVRIET !',13,10,'$'

Pretecenie	   db	13,10,'DOSLO K PRETECENIU !!!',13,10,'$'
Kolke_cislo 	   db	'. -  $'				 ;poradie cisla
Bez_cisla	   db	'NEBOLO NACITANE NIJAKE CISLO !$'
Odriadkuj	   db	13,10,'$'				  ;odriadkovanie
Pocet_cisel	   db	0				   ;sem uklada pocet cisel
Cisla		   dw	100 DUP(0)			   ;sem uklada nacitane cisla
Subor_in           db	15 DUP(0)			   ;na meno vstupneho suboru
Vstup   	   dw	0				   ;subor na citanie
Subor_out	   db	15 DUP(0)			   ;na meno vystupneho suboru
Vystup  	   dw	1				   ;subor na zapis
Cislo		   db	10 DUP(0)			   ;
Uvod_delenia	   db	10,13,10,13,'    Delenie  ',10,13,'$'
Delenie1	   db	'  ZADAJ PORADIE 1. CISLA: $'
Delenie2	   db	'  ZADAJ PORADIE 2. CISLA: $'
Vysledok_delenia   db	'  VYSLEDOK JE: $'
Zvysok_delenia     db	'     ZVYSOK JE: $'
Delenie_nulou	   db	10,13,'   DELENIE NULOU !!!$',10,13

Uvod_nasobenia	   db	10,13,10,13,'    Nasobenie  ',10,13,'$'
Vysledok_nasobenia db	'  VYSLEDOK JE: $'
Suma_kladnych1	   db	'  SUMA KLADNYCH CISEL JE: $'  
Suma_zapornych1	   db	'  SUMA ZAPORNYCH CISEL JE: $'
Medzera	           db	' '
Minus		   db	'-'
TmpChar		   db	0


DATA	ENDS
;-----------------------------------------------------------------
CODE	SEGMENT
	ASSUME	CS:CODE,DS:DATA,SS:ZAS

START:	
	mov	dx,SEG DATA	;do dx <- segment DATA	- nastavenie premennych
	mov	ds,dx		;nastav ds na DATA
	mov	es,dx
	call	Nacitaj_vstupy	;Nacitanie vstupnych udajov - volanie procedury
CYKLUS:	call    Zmaz		;volanie procedury na zmazanie obrazovky
	mov     dx,offset Menu  ;zavolaj menu
	mov     ah,09h		;vypise ho na obrazovku
	int     21h 
	
	mov	ah,08h		;funkcia pre vstup znaku bez echa - zadanie moznosti z menu
	int	21h		
	
	cmp	al,'A'		;porovnanie znaku s A
	je	A		;ak sa zhoduje skoc na A
	cmp     al,'a'
	je      A
	cmp	al,'B'
	je	B
	cmp     al,'b'
	je      B
	cmp	al,'C'
	je	C
	cmp     al,'c'
	je      C
	cmp	al,'D'
	je	D
	cmp     al,'d'
	je      D
	cmp	al,'E'
	je	E
	cmp     al,'e'
	je      E
	cmp	al,'Q'
	je	Koniec		;skoc na koniec
	cmp     al,'q'
	je      Koniec
	jmp	CYKLUS		;znova nacitaj klavesu - opakuj tento cyklus

A:	call	Usporiadaj	;volanie jednotlivtch procedur
	call	Vypis_cisla	
	call	Vypis_subor	
	jmp     CYKLUS	;|
B:	call	Delenie		
	jmp	CYKLUS	;|
C:	call	Nasobenie	
	jmp	CYKLUS	;|
D:	call	Suma_kladnych	
	jmp	CYKLUS	;/
E:	call	Suma_zapornych	
	jmp	CYKLUS	;/
Koniec:	mov	ah,4ch		;funkcia pre ukoncenie programu - koniec hlavneho programu
	int	21h            
	


	
;*************************** PROCEDURY ******************************

;--------------------------------------------------------------------
Vypis_cisla proc near		;procedura vypise cisla ulozene v pamati na obrazovku
				
				
	call	Zmaz
	xor	di,di		 ;vynulovanie retazcov
	xor	cx,cx
	mov	cl,Pocet_cisel	 ;cl nastavi na premennu Pocet_cisel
Dalej:
	mov	ax,di
	inc	ax		 ;posuva sa na dalsie cislo v pamati
	call	Vypis_cislo	 ;procedura na vypisanie cisla
	lea	dx,Kolke_cislo	 ;do dx presunie adresu premennej Kolke_cislo
	call	Vypis_text	 ;procedura na vypisanie oznamov{vypise potrebny oznam definovany v datovom segmente}
	mov	bx,di
	shl	bx,1		 ;aritmeticky posun vlavo,pri beznej indexacii iba cez bx
	mov	ax,Cisla[bx]	 ;by vypisal vsetko a len po jednom znaku
	inc	di
	call	Vypis_cislo	 ;procedura na vypisanie 'bx-teho'cisla
	lea	dx,Odriadkuj
	call	Vypis_text
	loop	Dalej
	ret

Vypis_cisla	endp
;--------------------------------------------------------------------
Delenie	proc near			;Vydeli dve cisla
	lea	dx,Odriadkuj
	call	Vypis_text
	call	Vypis_text
	call	Vypis_cisla
	lea	dx,Odriadkuj
	call	Vypis_text
	lea	dx,Uvod_delenia         ;prikaz lea ma podobnu funkciu ako prikz mov
	call	Vypis_text
	lea	dx,Delenie1
	call	Vypis_text
D1:			                ;nacitavanie poradoveho cisla delenca
	call	Nacitaj_cislo1		;nacitanie cisla z retazca
	cmp	bx,0
	jle	D1			;ak je mensie ako 0,tak ho nacita
	mov	al,Pocet_cisel
	xor	ah,ah
	cmp	bx,ax
	jg	D1			;ak je vacsie ako 0,tak ho nacitalo az teraz

	mov	cx,bx
	lea	dx,Odriadkuj
	call	Vypis_text

	lea	dx,Delenie2
	call	Vypis_text
D2:			                ;nacitavanie poradoveho cisla delitela
	call	Nacitaj_cislo1
	cmp	bx,0
	jle	D2			;ak je mensie ako 0
	mov	al,Pocet_cisel
	xor	ah,ah
	cmp	bx,ax
	jg	D2			;ak je vacsie ako 0
	lea	dx,Odriadkuj
	call	Vypis_text
	shl	cx,1			;logicke posuny vlavo
	shl	bx,1

	mov	ax,Cisla[bx-2]		;preskocime prve dva bajty
	mov	dx,ax
	push	dx
	mov	bx,cx
	mov	ax,Cisla[bx-2]
	lea	dx,Odriadkuj
	call	Vypis_text
	pop	dx
	mov	cx,dx
	xor	dx,dx
	cmp	cx,0
	je	DelenieNulou
	cwd				;rozsiri dvojnasobne register aby nepretekalo pri deleni so znanienkom
	idiv	cx			;delenie so znamienkom
	mov	cx,dx
	lea	dx,Vysledok_delenia
	call	Vypis_text
	call	Vypis_cislo
	lea	dx,Zvysok_delenia
	call	Vypis_text
	mov	ax,cx
	call	Vypis_cislo
	lea	dx,Odriadkuj
	call	Vypis_text
	call	cakaj
	ret

DelenieNulou:
	lea	dx,Delenie_nulou	   ;ohlasenie,ze doslo k deleniu nulou
	call	Vypis_text
	call	cakaj
	ret
Delenie	endp
;--------------------------------------------------------------------
Nasobenie proc near			;Vynasobi dve cisla
	lea	dx,Odriadkuj
	call	Vypis_text
	call	Vypis_text
	call	Vypis_cisla
	lea	dx,Odriadkuj
	call	Vypis_text
	lea	dx,Uvod_nasobenia
	call	Vypis_text
	xor	ch,ch
	xor	bh,bh
	mov	cl,Pocet_cisel
	mov	bl,Pocet_cisel
	sub	cx,1			    ;odcita 1
	shl	cx,1			    ;logicky posun vlavo
	shl	bx,1

	mov	ax,Cisla[bx-2]              ;preskocime dva bajty
	mov	dx,ax
	push	dx
	mov	bx,cx
	mov	ax,Cisla[bx-2]
	lea	dx,Odriadkuj
	call	Vypis_text
	pop	dx
	mov	cx,dx
	xor	dx,dx
	imul	cx			;nasobenie so znamienkom
	jo	Pretecenie1		;osetrenie pretecenia, jump if overflow
	
	mov	cx,dx
	lea	dx,Vysledok_nasobenia
	call	Vypis_text
	call	Vypis_cislo
	lea	dx,Odriadkuj
	call	Vypis_text
	call	cakaj
	ret

Pretecenie1:
	lea	dx,Pretecenie
	call	Vypis_text
	call	cakaj
	ret
Nasobenie endp
;--------------------------------------------------------------------
Nacitaj_cislo1 proc near		;Nacitanie cisla
				        ;Vystup	BX = nacitane cislo
	push	ax
	push	cx
	push	dx
	xor	bx,bx
Prve:
	mov	ah,08h			;vstup z klavesnice - nacita poradie prveho cisla
	int	21h
	cmp	al,13			;ci nebol stlaceny Enter
	je	NiejeEnter
	cmp	al,'0'			;porovnava s 0 
	jl	Prve			;ak je mensie
	cmp	al,'9'			;porovnava s 9
	jg	Prve			;ak je vacsie
	mov	dl,al
	xor	dh,dh
	call	Zobraz_znak		;zobrazi znak
	push	ax
	mov	cl,10
	mov	ax,bx
	mul	cl			;nasobenie bez znamienka
	mov	bx,ax
	pop	ax
	sub	ax,'0'
	xor	ah,ah
	add	bx,ax
	jmp	Prve
NiejeEnter:
	mov	dl,al
	xor	dh,dh
	call	Zobraz_znak
	mov	dl,10
	xor	dh,dh
	call	Zobraz_znak
NiejeEnd:
	pop	dx
	pop	cx
	pop	ax
	ret
	
Nacitaj_cislo1 endp
;--------------------------------------------------------------------
Vypis_subor proc near		;Zapis pola cisel do suboru
				;VSTUP = pocet_cisel
				
	call	Zmaz
	call	Vypis_cisla
	lea	dx,Meno_suboru_out	;do dx vloz adresu vystupneho suboru
	call	Vypis_text
	lea	dx,Subor_out
	mov	cx,15		;Max. pocet znakov (pre meno suboru)
	mov	al,0		;ukoncovaci znak pre ASCIIZ
	call	Nacitaj_retazec		;Nacitanie mena vyst. sub.
	mov	ah,3ch			;otvorenie suboru
	mov	cx,1			;pre zapis
	int	21h
	jc	Chyba1
	mov	Vystup,ax
	
	xor	di,di
	xor	cx,cx
	mov	cl,Pocet_cisel
Dalej2:
	push	cx
	mov	bx,di
	shl	bx,1			;logicky posun do lava
	mov	ax,Cisla[bx]
	inc	di
	mov	bx,Vystup
	call	Zapis_cislo
	mov	ah,40h			;zapis do suboru
	mov	bx,Vystup
	mov	cx,1
	lea	dx,Medzera
	int	21h
	pop	cx
	loop	Dalej2
	mov	bx,Vystup
	call	Zatvor_subor
	ret
Chyba1:
	ret
Vypis_subor endp
;--------------------------------------------------------------------
Suma_kladnych proc near			;Vypocet sumy cisel
				        ;VSTUP	Pocet_cisel
	call    Vypis_cisla			
	xor	di,di
	xor	dx,dx
	xor	cx,cx
	mov	cl,Pocet_cisel
Suma1:
	mov	bx,di
	shl	bx,1
	mov	ax,Cisla[bx]
	cmp	ax,0
	jl	NieKladne
	add	dx,ax                 ;tu pripocita
NieKladne:
	jo	Suma1_pretecenie
	inc	di
	loop	Suma1
	push	dx
	lea	dx,Odriadkuj
	call	Vypis_text
	lea	dx,Suma_kladnych1
	call	Vypis_text
	pop	dx
	mov	ax,dx
	call	Vypis_cislo
	call    cakaj
	ret
Suma1_pretecenie:
	lea	dx,Pretecenie
	call	Vypis_text
	call	cakaj
	ret
Suma_kladnych endp
;--------------------------------------------------------------------
Suma_zapornych proc near			;Vypocet sumy cisel
				                ;VSTUP	Pocet_cisel
	call    Vypis_cisla		
	xor	di,di
	xor	dx,dx
	xor	cx,cx
	mov	cl,Pocet_cisel
Suma2:
	mov	bx,di
	shl	bx,1
	mov	ax,Cisla[bx]
	cmp	ax,0
	jg	NieZaporne
	add	dx,ax				;spocita
NieZaporne:
	jo	Suma2_pretecenie
	inc	di
	loop	Suma2
	push	dx
	lea	dx,Odriadkuj
	call	Vypis_text
	lea	dx,Suma_zapornych1
	call	Vypis_text
	pop	dx
	mov	ax,dx
	call	Vypis_cislo
	call	cakaj
	ret
Suma2_pretecenie:
	lea	dx,Pretecenie
	call	Vypis_text
	call	cakaj
	ret
Suma_zapornych endp
;--------------------------------------------------------------------
Usporiadaj proc near		;Triedenie cisel zostupne 
				;VSTUP	Pocet_cisel
				
	xor	dh,dh
	mov	dl,Pocet_cisel
	dec	dx
	cld			;nulovanie priznaku smeru
f3l1:	mov	cx,dx		 
	lea	si,Cisla
	lodsw                   ;zapis retazca
	mov	bx,ax		
f3l2:	lodsw			;zapis retazca	
	cmp	bx,ax		
	jge	f3n
	mov	di,si		
	sub	di,4		
	stosw			;ulozenie retazca
	mov	ax,bx		
	stosw	                ;ulozenie retazca		
f3n:	mov	bx,ax		
	loop	f3l2		
	dec	dx		
	jnz	f3l1
	ret				;navrat z podprogramu
Usporiadaj endp			
;--------------------------------------------------------------------
Nacitaj_vstupy	proc near		;podprogam na nacitanie udajov zo vstupneho suboru
	call	Zmaz
                lea	dx,Meno_suboru_in	;do dx vloz adresu vstupneho suboru
	call	Vypis_text
	lea	dx,Subor_in
	mov	cx,15		;Max. pocet znakov (pre meno suboru)
	mov	al,0		;ukoncovaci znak pre ASCIIZ
	call	Nacitaj_retazec		;Nacitanie mena vst. sub.
	call	Zmaz
	lea	dx,Subor_in
	mov	al,0h			
	call	Otvor_subor
	mov	Vstup,bx
	xor	di,di
	mov	cx,100
Opakuj1:
	mov	bx,Vstup
	call	Nacitaj_cislo
	jc	Koniec_opakovania
	mov	bx,di
	shl	bx,1
	mov	Cisla[bx],ax
	inc	di
	loop	Opakuj1
Koniec_opakovania:
	mov	bx,Vstup
	call	Zatvor_subor
	mov	ax,di
	mov	Pocet_cisel,al
	cmp	di,0
	call	Zmaz
	je	Nic_nenacitane
	ret
Nic_nenacitane:
	lea	dx,Bez_cisla
	call	Vypis_text
	call	cakaj
	ret
Nacitaj_vstupy	endp
;--------------------------------------------------------------------
Nacitaj_cislo proc near			;Nacitanie cisla z text. sub.
				
	push	cx
	push	dx
	push	di
	xor	ax,ax
	mov	Cislo[1],' '
	xor	di,di
	push	ax
	mov	ah,3Fh		;citanie zo suboru
	lea	dx,Cislo
	mov	cx,1
	int	21h		;Nacitanie 1 byte zo vstup. sub.
	jc	Chyba3  	;chyba pri nacitavani -> skoc na chyba3
	cmp	ax,di
	jne	Dalej4	;Ak nie su rovne
	pop	ax
	pop	di
	pop	dx
	pop	cx
	stc                                   ;nastavenie priznaku prenosu
	ret
Chyba3:
	pop	ax
	jmp     CYKLUS	
Dalej4:
	cmp	Cislo[0],'0'
	jl	Pokracuj
	cmp	Cislo[0],'9'
	jg	Pokracuj
	inc	di
	pop	ax
	xor	dx,dx
	mov	cx,10
	imul	cx
	jno	Nieje_pretecenie
Je_pretecenie:
	lea	dx,Pretecenie
	call	Vypis_text
	call	cakaj
Nieje_pretecenie:
	mov	cl,Cislo[0]
	sub	cl,'0'
	xor	ch,ch
	cmp	di,1
	jne	Prva_nieje_nula
	cmp	cl,0
	jne	Prva_nieje_nula
Prva_nieje_nula:	
	add	ax,cx
	jno	Nieje_pretecenie2
	lea	dx,Pretecenie
	call	Vypis_text
	call	cakaj
Nieje_pretecenie2:
	push	ax
Dalej5:	
	mov	ah,3Fh
	lea	dx,Cislo
	mov	cx,1
	int	21h		;Nacitanie 1 byte zo vstup. sub.
	jc	Chyba3  	;chyba pri nacitavani-> skoc na chyba3 
	cmp	ax,0
	jne	Dalej5
	pop	ax
	cmp	di,0
	je	Nic     	;Ak nacitanych 0 bytov
	push	ax
	jmp	Koniec_citania
Dalej6:
	jmp	Dalej4
Nic:
	pop	di
	pop	dx
	pop	cx
	stc
	ret
Pokracuj:
	mov	al,Cislo[0]
	cmp	al,10
	je	Koniec_citania
	cmp	di,0
	jne	Koniec_citania
	cmp	Cislo[0],'-'            ;porovnvanie so znamienkom minus
	jne	Dalej5
	mov	Cislo[1],'-'
	jmp	dalej5
	
Koniec_citania:
	pop	ax
	cmp	di,0
	je	Nic
	cmp	Cislo[1],'-'
	jne	Koniec_citania1
	neg	ax      		;minus znamienko
Koniec_citania1:
	pop	di
	pop	dx
	pop	cx
	clc
	ret
Nacitaj_cislo endp
;--------------------------------------------------------------------
Vypis_cislo proc near			;Vypise na obrazovku cislo
					;VSTUP	AX = cislo
	push	ax
	push	bx
	push	cx
	push	dx
	mov	dx,1			;zistovanie znamienka cisla
	ror	dx,1			;rotacia vpravo
	and	dx,ax
	rol	dx,1			;rotacia vlavo
	cmp	dx,1
	jne	Nieje
	xor	dx,dx
	mov	bx,ax
	mov	dl,'-'
	call	Zobraz_znak
	mov	ax,bx
	neg	ax
Nieje:
	cmp	ax,10
	jl	DoDesat
	cmp	ax,100
	jl	DoSto	
	cmp	ax,1000
	jl	DoTisic
	cmp	ax,10000
	jl	DoDesTis
	mov	bx,10000
	xor	dx,dx
	div	bx
	push	dx
	add	ax,'0'
	mov	dl,al
	call	Zobraz_znak
	pop	dx
	mov	ax,dx
DoDesTis:
	mov	bx,1000
	xor	dx,dx
	div	bx
	push	dx
	add	ax,'0'
	mov	dl,al
	call	Zobraz_znak
	pop	dx
	mov	ax,dx
DoTisic:
	mov	bx,100
	xor	dx,dx
	div	bx
	push	dx
	add	ax,'0'
	mov	dl,al
	call	Zobraz_znak
	pop	dx
	mov	ax,dx
DoSto:
	mov	bx,10
	xor	dx,dx
	div	bx
	push	dx
	add	ax,'0'
	mov	dl,al
	call	Zobraz_znak
	pop	dx
	mov	ax,dx
DoDesat:
	add	ax,'0'
	mov	dl,al
	call	Zobraz_znak
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
Vypis_cislo endp
;--------------------------------------------------------------------
Zapis_cislo proc near			;Vypise do suboru cislo
					;VSTUP	AX = cislo
					
	push	ax
	push	cx
	push	dx
	mov	dx,1
	ror	dx,1
	and	dx,ax
	rol	dx,1
	cmp	dx,1
	jne     Nieje1
	xor	dx,dx
	mov	cx,ax
	lea	dx,Minus
	call	FPrintChar
	mov	ax,cx
	neg	ax
Nieje1:
	cmp	ax,10
	jl	FDoDesat
	cmp	ax,100
	jl	FDoSto	
	cmp	ax,1000
	jl	FDoTisic
	cmp	ax,10000
	jl	FDoDesTis
	mov	cx,10000
	xor	dx,dx
	div	cx
	push	dx
	add	ax,'0'
	mov	TmpChar,al
	lea	dx,TmpChar
	call	FPrintChar
	pop	dx
	mov	ax,dx
FDoDesTis:
	mov	cx,1000
	xor	dx,dx
	div	cx
	push	dx
	add	ax,'0'
	mov	TmpChar,al
	lea	dx,TmpChar
	call	FPrintChar
	pop	dx
	mov	ax,dx
FDoTisic:
	mov	cx,100
	xor	dx,dx
	div	cx
	push	dx
	add	ax,'0'
	mov	TmpChar,al
	lea	dx,TmpChar
	call	FPrintChar
	pop	dx
	mov	ax,dx
FDoSto:
	mov	cx,10
	xor	dx,dx
	div	cx
	push	dx
	add	ax,'0'
	mov	TmpChar,al
	lea	dx,TmpChar
	call	FPrintChar
	pop	dx
	mov	ax,dx
FDoDesat:
	add	ax,'0'
	mov	TmpChar,al
	lea	dx,TmpChar
	call	FPrintChar
	pop	dx
	pop	cx
	pop	ax
	ret
Zapis_cislo endp
;--------------------------------------------------------------------
Nacitaj_retazec proc near			;funkcia pre nacitanie retazca
				;Vstup	CX = max pocet znakov
				;	DS:DX = adresa vystupu
				;	AL = ukoncovaci znak
	push	bx
	push	di
	push	ax
	
	mov	bx,dx
	xor	di,di
Opakuj_nacitavanie1:
	mov	ah,01h		;getchar s echom 
	int	21h
	cmp	al,13		;test enteru
	je	Konci_nacitavanie1
	mov	[bx][di],al
	inc	di
	loop	Opakuj_nacitavanie1	;nacitavanie max cx znakov
Konci_nacitavanie1:
	pop	ax
	mov	[bx][di],al	;ulozenie ukoncovacieho znaku do retazca
	pop	di
	pop	bx
	ret
Nacitaj_retazec endp
;--------------------------------------------------------------------
Otvor_subor proc near			;otvorenie suboru
				;Vstup	DS:DX = nazov suboru
				;	AL = open mode	00 read
				;			01 write
				;			02 r/w
				
	push	ax
	mov	ah,3dh		;dos funkcia pre otvorenie suboru
	int	21h
	jnc	Koniec_otvarania
	lea	dx,Chyba_otvarania
	call	Vypis_text
	mov	ah,4ch		;DOS funkcia pre ukoncenie programu
	int	21h            ;DOS volanie
	ret
Koniec_otvarania:
	mov	bx,ax		;ulozenie handle do bx
	pop	ax
	ret
Otvor_subor endp
;--------------------------------------------------------------------
Zatvor_subor proc near			;Zatvorenie suboru
				
	
	mov	ah,3eh
	int	21h
	jnc	Koniec_zatvarania
	lea	dx,Chyba_zatvarania
	call	Vypis_text
	mov	ah,4ch		;funkcia pre ukoncenie programu
	int	21h            
	ret
Koniec_zatvarania:
	
	ret
Zatvor_subor endp
;--------------------------------------------------------------------
Zmaz proc near				;podprogram Zmaz
	push	ax			
	push	bx			; ulozenie registrov do zaobnika
	push	cx			
	push	dx				
	mov	cx,0h			;nastavenie vstupnych hodnot pre volanie funkcie	
	mov	dh,25			
	mov	dl,80			
	mov	al,0			
	mov	bh,07			
	mov	ah,06h			;sluzba 06 - posuv obrazovky nahor, vymazanie
	int 	10h			;volanie video sluzby
	mov	bh,0			;nastavenie kurzora na poziciu 0,0 (lavy horny roh)
	mov	dx,0			
	mov	ah,02h			;sluzba 02{zobrazenie znaku
	int	10h			
	pop	dx			
	pop	cx			
	pop	bx			; obnovenie registrov zo zasobnika
	pop	ax			
	ret
Zmaz endp				;Koniec podprogramu
;--------------------------------------------------------------------
Vypis_text proc near			;Podprogram na vypis textu, dx adresa textu 
	push	ax			;ulozenie ax do zasodnika
	mov	ah,09h			;vypis textu je 9 funkcia dosu
	int	21h			;volanie funkcie dosu
	pop	ax			;obnovenie ax zo zasobnika
	ret				;navrat z podprogramu
Vypis_text endp           		;koniec podprogramu
;--------------------------------------------------------------------
FPrintChar proc near			;vstup	DL = character
					
	push	ax
	push	cx
	mov	ah,40h
	mov	cx,1
	int	21h
	pop	cx
	pop	ax
	ret
FPrintChar endp
;--------------------------------------------------------------------
Zobraz_znak proc near			;vstup	DL = character
	push	ax
	mov	ah,02h
	int	21h
	pop	ax
	ret
Zobraz_znak endp
;--------------------------------------------------------------------
cakaj	PROC				;Cakanie na stlacenie klavesy
	push	ax
	mov	ah,07h
	int	21h
	pop	ax
	ret
cakaj	ENDP
;--------------------------------------------------------------------


CODE	ENDS				;koniec segmentu CODE
	END	START			;koniec Programu a nastavenie zaciatku na START


;Zhodnotenie: program je plne funkcny,alebo sa mi nepodarilo zistit v nom 
;nejake nedostatky,ktore by urobili tento program chybnym(je zostaveny 
;podla zadania B).Program nacita zo vstupneho suboru cisla,ostatne znaky 
;ignoruje.Pri zadavani cisel na delenie sa zadavaju poradove cisla oboch
;cisel,ak sa take cislo v subore nenachadza je ignorovane.Program by mal 
;byt kompaktibilny s prostredim ako Dosovskym,tak aj Windows.
