; PETER KVACKAJ,kruzok B 10
; ZADANIE c.2
; TEXT ZADANIA: 
;   Vytvorte program,ktory nacita z textoveho suboru postupnost
;   celych cisel so znamienkom v desiatkovej sustve (aspon 10),
;   potom ich transformujte na cisla v desiatkovej sustave
;   v doplnkovom kode a potom podla priania uzivatela :
;   1. vypocita sumu vsetkych cisel zo suboru a vypise ju
;   2. usporiada cisla vzostupne a zapise usporiadanu postupnost
;      do noveho textoveho suboru
;   3. vydeli dve vybrane cisla a vypise vysledok
;   4. vynasobi dve cisla a vypise vysledok
;   5. usporiada cisla zostupne a posyupnost zapise do noveho suboru.
;   6. ukonci vykonavanie porogramu
;
; Na pracu so subormi mozete pouzit napr. sluzby 3dH, 3eH,3fH,40H. Vysledky
; operacii treba vypisovat v desiatkovej ciselnej sustave. Ak by pri vypocte
; sumy v pripade 1. doslo k preteceniu, oznamte prekrocenie ciselneho rozsahu.
;

; Termin odovzdania: 14.11.2000

;
;
;
;
;

;definovanie zasobnika
ZAS	SEGMENT STACK      'STACK';direktiva pre assembler-zaciatok
				  ;zasobnikoveho segmentu
	DW      64 DUP(?)         ;definicia 64-slov
ZAS     ENDS                      ;koniec zasobnikoveho segmentu
;---------------------------------------------------------------------------

DAT	SEGMENT
 divide	     DB 3		  ;max. pocet znakov,kt.sa moze nacitat
 pocet	     DB 0		  ;skutoc.pocet znakov vstupneho retazca
 operand     DB	3 DUP(?)	  ;vymedzenie priestoru pre:
                                  ;-vstupny operand
				  ;-pri nacitavani poradoveho cisla polozky
				  ;-v 3. bode(delenec a delitel)
 numbers     DW	20 dup(0)         ;miesto v pameti pre 20 cisel
 patbytov    DB	5 dup(0)          ;cislo,max 5-miest,v ascii
 handler1    DW	0                 ;handler vstupneho suboru
 handler2    DW	0                 ;handler vystupneho suboru
 znak        DB 0		  ;na nacitavanie znakov zo suboru
 figure	     DB 0                 ;pocet nacitanych cisel
 znamienko   DB 0                 ;znamienko
	     DB '$'

zacni	 DB   13,10,'Vstupny subor musi existovat.Z neho nacita'
	 DB   13,10,'maximalne 20 cisel,ktore sa prevedu do doplnkoveho kodu.',13,10
	 DB   13,10,'Nesmie sa prekrocit interval <-32768,32767> aj pre sumu.',13,10,'$'
;
 menu    DB   13,10,13,10,13,10,'1.Vypisanie sumy z cisel v subore.'
	 DB   13,10,'2.Usporiadaj  vzostupne a zapis do suboru.'
	 DB   13,10,'3.Nasobenie dvoch cisel a vypis na obrazovku.'
         DB   13,10,'4.Vydelenie dvoch cisel a vypis na obrazovku.'
	 DB   13,10,'5.Usporiadaj zostupne a zapis do suboru.'
	 DB   13,10,'6. Koniec.',13,10
	 DB   13,10,'Potvrd vyber :$'
;
 pathin  DB   "vstup.txt",0
 pathout DB   "vystup.txt",0
 hlaska1 DB   13,10,'Vstupny subor sa neda otvorit.',13,10,'$'
 hlaska2 DB   13,10,'Vystupny subor sa neda otvorit.',13,10,'$'
 hlaska3 DB   13,10,'Vstupny subor sa neda zatvorit.',13,10,'$'
 hlaska4 DB   13,10,'Vystupny subor sa neda zatvorit.',13,10,'$'
 hlaska5 DB   13,10,'Cislo vo vstupnom subore je mimo interval.',13,10,'$'
 hlaska6 DB   13,10,'Suma nespada do intervalu.',13,10,'$'
 hlaska7 DB   13,10,'Chyba pri citani.',13,10,'$'
 hlaska8 DB   13,10,'Chyba pri zapise.',13,10,'$'
 urci1   DB   13,10,'Vyber si deleneca:$'
 urci2   DB   13,10,'Vyber si delitela:$'
 urci3   DB   13,10,'Vyber si prve cislo:$'
 urci4   DB   13,10,'Vyber si druhe cislo:$'
 podiel  DB   13,10,'Vysledok: $'
 zvysok  DB   13,10,'Zvysok:$'
 kon	 DB	  13,10,'KONIEC',13,10,'$'
 nula    DB	  13,10,'Nastalo delenie nulou.',13,10,'$'
 NL 	 DB    13		       ;novy riadok
	 DB   10,'$'
 order	 DB	  '. $'
DAT ENDS                               ;koniec zasobnikoveho segmentu
;---------------------------------------------------------------------------
CODE 	SEGMENT                        ;zaciatok kodoveho segmentu
	ASSUME	CS:CODE,SS:ZAS,DS:DAT  ;direktiva-oznamuje assemblru
				       ;aktivne segmenty
;---------------------------------------------------------------------------
START:	mov 	ax,SEG DAT             ;nacitanie segmentovej adresy do AX
	mov	ds,ax		       ;cez AX presun do registra DS
	mov     dx,offset zacni	       ;do DX posunutie zacni(retazec v
				       ;datovom segmente
	mov     ah,09H		       ;funkcia vypis retazca (zacni)
	int	21H                    ;volanie sluzby MS DOSu
;---------------------------------------------------------------------------
;otvorenie suboru vstup.txt
	mov 	ah,3dH                 ;otvorenie suboru zadaneho
	mov	dx,offset PATHIN       ;retazcom pathin cez sluzbu 3dH
	mov	al,0
	int	21H
	jnc     handle
	mov     dx,offset HLASKA1      ;vypis chybovej spravy
				       ;ak sa nepodarilo subor vstup.txt
	mov     ah,09H		       ;otvorit(priznak cf bol nastaveny
	int	21H                    ;na 1

	jmp	KONIEC
handle:	mov	HANDLER1,ax            ;do ax ulozi handler suboru
;----------------------------------------------------------------------------
	xor	dx,dx                  ;vynulovanie dx,cislo-realna hodnota
	push 	dx 		       ;dx->stack pre neskorsi cyklus
	xor 	si,si                  ;vynulovanie si:posun v numbers(index)
	xor 	bp,bp                  ;vynulovanie bp:1-bola cislica
                                       ;               2-koniec suboru
                                       ;               0-neni cislo ani minus
dalsi:  cmp	al,'-'                              
	jz	BEZ                    ;ak sa rovna '-' tak na bez
	xor	di,di                  ;navestie dalsie cislo,vynulovanie di
bez:	cmp	bp,1
	jb	DALZNAK		       ;skok na dalsi znak
	pop	dx
	mov	bx,offset NUMBERS
	mov 	[bx+si],dx             ;ulozenie cisla v dx do pam.miesta
	xor	dx,dx                  ;pripravime dx na nove cislo
	push 	dx                     ;dx sa nastavi na nulu a -> zasobnik
	inc	FIGURE                 ;inkr. poctu nacitanych cisel
	add	si,2                   ;inkrement. poctu  cisel
	cmp   	si,40                  ;(jedno cislo zabera 2 Byty)
	jae     CLOSEF                 ;ak cisel 20 zatvor subor
	cmp   	bp,2                   ;ak citanie na konci suboru
	jz      CLOSEF                 ;zatvor
	xor	bp,bp		       ;vynulovanie,nastavi sa na1 pri dalsom
				       ;cisle (nie iba cislici)
DALZNAK:mov 	ah,3fH		       ;citanie 1 znaku zo suboru cez sl. 3fH
	mov	bx,HANDLER1
	mov	dx,offset ZNAK         ;do ZNAK sa bude nacitavat
	mov	cx,1		       ;nacita 1 byte
	int	21H
	jnc     OK1                    ;->OK1 ak nedoslo pri citani k chybe
	mov     dx,offset HLASKA7      ;vypis chybovej spravy
				       ;(priznak cf bol nastaveny na 1)
	mov     ah,09H
	int	21H
	jmp	KONIEC                 ;->ukoncenie programu
OK1:    cmp	ax,0                   ;citanie na konci suboru?
	jnz	OK5                    ;nie - pokracuj
	cmp	bp,0                   ;ano -je posledne cislo ulozene?
	jz	CLOSEF                 ;ak ano zatvor subor
	mov	bp,2                   ;ak nie uloz a potom zatvor
	jmp 	dalsi
OK5:	mov	al,ZNAK                ;nacitany znak do registra(pre rychl.)
	cmp	al,'-'		       ;test na minusku(zap.cislo)
	jnz	NEXT1
	mov	di,1                   ;testy na cislicu
	jmp	dalsi
NEXT1:  cmp	al,'0'
	jb      dalsi
	cmp	al,'9'
	ja	dalsi                  ;jump above
	mov	bp,1                   ;bola cislica,nastav bp
	pop     dx                     ;dx<-stack
	sub 	al,30H                 ;prevod ascii cislice na cislo
	cbw                            ;zkonvertovanie al na word
	cmp	di,1                   ;je nastavene znamienko?
	jnz	NEXT2                  ;ak nie je preskoc
	neg	ax                     ;inak vytvor doplnok
NEXT2:  cmp	dx,0                   ;podmienka,kt.osetri jednocif.cislo
	jz	PUT                    ;preskoci sa spracovanie vyssich radov
	cmp	dx,3276                ;ak dx!=0 treba dx zvacsit 10krat
	jg	RANGE                  ;to nepojde ak je mimo tento rozsah
	cmp	dx,-3276
	jl	RANGE
	mov	bx,dx                  ;do bx povodnu hodnotu dx
	mov	cx,9
CICLE1: add	dx,bx                  ;10krat pripocita bx k dx(nasobi 10)
	loop	CICLE1
PUT:	add	dx,ax                  ;pripocita nacitane cislo
	jo	RANGE                    ;ak mimo rozsah->out
	push	dx                     ;ulozi dx do stacku
	jmp	DALZNAK
;--------------------------------------------------------------------------
CLOSEF: mov	bx,offset HANDLER1    ;parametre pre proceduru
	mov     dx,offset HLASKA3 ;ktora zatvori subor
	call	CloseFile
	jmp    	OFFER
;---------------------------------------------------------------------------
RANGE:  mov     dx,offset HLASKA5   ;  ;vypis chybovej spravy
				       ;(priznak cf bol nastaveny na 1)
	mov     ah,09H
	int	21H
	mov	bx,offset HANDLER1    ;parametre pre proceduru
	mov     dx,offset HLASKA3 ;ktora zatvori subor
	call	CloseFile
	jmp	KONIEC
;---------------------------------------------------------------------------
OFFER:	mov     dx,offset MENU         ;vypis menu
	mov     ah,09H
	int	21H
	mov	ah,1                   ;nacitanie znaku z klavesnice
				       ;pomocou sluzby systemu 01h
				       ;vstup(znak) sa ulozi do AL
	int	21H
;---------------------------------------------------------------------------
NAV1:	cmp	al,'1'		       ;bolo stlacene '1' ?
	jnz	NAV2	               ;skoc na navestie1
	call    VypocetSumy 
	jmp	OFFER
NAV2:	cmp	al,'2'
	jnz	NAV3
	call    UsporiadajVzostupne
	jmp	OFFER
NAV3:   cmp     al,'3'
        jnz     NAV4
        call    VypocetNasobenia
        jmp     OFFER
NAV4: 	cmp	al,'4'
        jnz     NAV5
	call    VypocetDelenia
	jmp	OFFER                  ;skok spat na ponuku
NAV5: 	cmp	al,'5'
	jnz 	KONIEC
	call    UsporiadajZostupne
	jmp	OFFER                  ;skok spat na ponuku

                                    ;ukonci program ak zvolim znak(polozku) mimo 1, 2, 3
KONIEC:	mov     dx,offset KON       ;vypis retazca z dat.seg. na obr
	mov     ah,09H
	int	21H
	mov 	ax,4C00H               ;funkcia ukoncenie programu
	int	21H
;-------------------------------------------------------------------------
;procedura pre zatvorenie suboru.V bx musi byt handler,v dx offset chyb.spr.
CloseFile 	proc
	mov	ah,3eH
	int	21H
	jnc     OK2                    ;->OK2 ak nedoslo pri citani k chybe
;	mov     ah,09H                 ;vypis chybovej spravy
;	int	21H                    ;(priznak cf bol nastaveny na 1)
;	jmp	KONIEC                 ;ukonci program
OK2:    ret
CloseFile endp
;---------------------------------------------------------------------------
;procedura, ktora zkonvertuje doplnkove dvojkove cislo(16bitove)ulozene v di
;do ascii a ulozi do pamete do PATBYTOV
;si - index na jednotlive casti retazca PATBYTOV
;v cykle sa postupne odcitavaju 10000,1000..1,zistuje sa ich nasobnost->dl a
;zapisuje do PATBYTOV.Cyklus prebehne 5 krat a do PATBYTOV zapise i uvodne nuly
;ak bolo cislo napr.124->00124
;
ConvertIntToASCII proc
	push	ax
	push    bx
	push    cx
	push    si
	mov	bx,offset PATBYTOV
	xor	si,si
	mov	bp,10                  ;obsahom bp sa bude delit ax
				       ;aby sa prebehli 10000-ky,1000..1-ky
	cmp	di,0                   ;zistenie ci je cislo v di zap.cislo
	jnl	NEXT3                  ;jump not lower
	sub	di,1                   ;ak je, prevedie na priamy kod
	not	di                     ;odpocita 1 a zinvertuje
	mov	ZNAMIENKO,'-'
NEXT3:  xor	cx,cx
	mov	cl,5                   ;5,lebo cisla mozu mat max 5 cifier
	mov	ax,10000               ;zacne sa z odpocitavanim 10000-ok
	xor	dl,dl
SUBTR:	cmp	di,ax                  ;porovna cis.kt. treba previest s ax
	jb	CYCLE2                 ;ak je cislo mensie skok
	inc 	dl                     ;inkrementuj dl,bude tam cifra des.
	sub	di,ax                  ;di=di-ax
	jmp	SUBTR                  ;pokracuj z odpocitavanim
CYCLE2: add 	dl,30H                 ;cislo v dl na ascii cislicu
	mov	[bx+si],dl             ;zapis do PATBYTOV
	inc	si                     ;inkrementuje index do PATBYTOV
	xor	dx,dx                  ;ab sa mohlo delit ax<-dx&ax/bp
				       ;+vynulovanie pre dalsi rad
	div	bp                     ;vysledok = ax/bp(10) zap do ax
	loop	SUBTR                  ;zvysok nas nezaujima
	pop     si
	pop     cx
	pop     bx
	pop     ax
	ret
ConvertIntToASCII endp
;---------------------------------------------------------------------------
;procedura ,kt. vypise cislo v ascii v PATBYTOV(v pameti).
;jednotlive znaky nacitava z pamete do dl.Ak je bp!=0 vypise sa na obraz.
;procedura je volana po procedure ConvertIntToASCII
;
PrintToScreen proc
	push	ax
	push	bx
	push	cx
	push	si
	cmp	ZNAMIENKO,'-'	       ;ak procedura ConvertIntToASCII
				       ;nastavi znamienko, tak vypis
	jnz	KLADNE
	mov	ah,09H
	mov	dx,offset ZNAMIENKO
	int	21H
KLADNE:	mov 	bx,offset PATBYTOV
	xor	si,si
	xor	bp,bp
	xor	cx,cx		       ;vynulovanie predtym nez ho pouzijem
				       ;ako pocitadlo
	xor	cl,cl
	mov	cl,5                   ;5 lebo cislo moze mat max 5 cifier
REPEAT: mov	dl,[bx+si]             ;do dl ulozi si-ity byte z PATBYTOV
	cmp	dl,30H                 ;porovna cislo s ascii nulou;
	jz      NEXT4                  ;ak je nula skok,nulu netreba zapisat
	inc	bp                     ;ak nie bp uz nebude nulovy
NEXT4:  cmp	cx,1                   ;ak posledny znak tak zapis
				       ;aj ak je to ascii nula
	jz	ZAPIS2
	cmp	bp,0                   ;ak je bp nulovy skok na dal cyklus
	jz	CYCLE3                 ;ak je bp <>0,vypis aj nulu
ZAPIS2:	mov	ah,2                   ;inak vypis obsah dl
	int 	21H
CYCLE3: inc	si
	loop	REPEAT                 ;opakuj 5 krat
	mov	ZNAMIENKO,0		       ;nastavi znamienko na 0
	pop	si
	pop	cx
	pop	bx
	pop	ax
	ret
PrintToScreen endp
;---------------------------------------------------------------------------
;procedura ,kt. vypise cislo v ascii v PATBYTOV(v pameti) do suboru vystup.txt.
;(Ak je bp!=0 vypise do suboru.)
;procedura bude nasledovat po procedure ConvertIntToASCII
;
PrintToFile proc
	mov	dl,ZNAMIENKO
	cmp	dl,'-'	               ;ak procedura ConvertIntToASCII
				       ;nastavi znamienko, tak vypis
	jnz	POSIT
	mov	dx,offset ZNAMIENKO         ;adresa bufferu odkial sa sa bude
				       ;nacitavat znamienko
	mov	ah,40H
	mov	bx,HANDLER2          ;handler vystupneho suboru
	mov	cx,1		       ;zapise 1 byte
	int	21H
	jnc     POSIT                  ;ak nedoslo pri zapise k chybe
	mov     dx,offset HLASKA8     ;vypis chybovej spravy

POSIT:	mov 	bx,offset PATBYTOV
	xor	si,si
	xor	bp,bp
	xor	cx,cx
	mov	cl,5                   ;v cykle sa prejde 5 bytov PATBYTOV
OPAKUJ: mov	dl,[bx+si]             ;ascii cislo do pomocneho dl
	cmp     dl,30H                 ;porovna cislo s ascii nulou
	jz      NEXT6                  ;ak je nula skok
	inc	bp                     ;ak nie bp uz nebude nulovy
NEXT6:  cmp	cx,1                   ;ak posledny znak tak zapis
				       ;aj ak je to ascii nula
	jz	ZAPIS
	cmp	bp,0                   ;ak je bp nulovy skok na dal cyklus
	jz	CYCLE5
ZAPIS:	push 	bx
	push	cx
	add     bx,si                  ;v bx bazovo index. adr. bytu v PATBYTOV
	mov	dx,bx                  ;adresa bufferu odkial sa sa bude
				       ;nacitavat
	mov	ah,40H
	mov	bx,HANDLER2          ;handler vystupneho suboru
	mov	cx,1		       ;zapise 1 byte
	int	21H
	jnc     OK3                    ;->OK3 ak nedoslo pri zapise k chybe
	mov     dx,offset HLASKA8     ;vypis chybovej spravy
				       ;(priznak cf bol nastaveny na 1)
	mov     ah,09H
	int	21H
	jmp	KONIEC                 ;->ukoncenie programu
OK3:	pop	cx
	pop	bx
CYCLE5: inc	si		       ;si ukazuje na dalsie ascii cislo
	loop	OPAKUJ
	mov	ah,40H
	mov 	dx,offset NL           ;odriadkovanie
	mov	bx,HANDLER2          ;handler vystupneho suboru
	mov	cx,2		       ;zapise 2 byte
	int	21H
	jnc     OK4                    ;->OK4 ak nedoslo pri zapise k chybe
	mov     dx,offset HLASKA8     ;vypis chybovej spravy
				       ;(priznak cf bol nastaveny na 1)
	mov     ah,09H
	int	21H
	jmp	KONIEC                 ;->ukoncenie programu
OK4:	mov	ZNAMIENKO,0		       ;nastavi znamienko na 0
	ret
PrintToFile endp
;---------------------------------------------------------------------------
;procedura,kt. prevedie dvojmiestne(max 99) ascii cislo do dvojkoveho
;cislice ascii cisla du v dh,dl
;do al vrati dvojkove cislo
;
ShortConvertToInt proc
	mov 	al,OPERAND             ;do al obsah 1. nacitnu cifru porad.
				       ;cisla
				       ;=mov al,[bx] lebo v bx je offset
				       ;operandu nastavenej v procedure
				       ;ShortConvertToInt
	sub	al,30H                 ;prevod ascii na dvojk.cislo
	cmp	POCET,1                ;ak pocet vst.znakov iba 1 tak ukonci
	jz	FINISH
	xor	cx,cx                  ;inak vynasobi(pripocitavanim)
	mov	cl,9                   ;obsah al 10 krat(dl pripocita 9krat)
	mov	dl,al
MUL10:	add     al,dl
	loop	MUL10
	mov	dl,[bx+1]
	sub	dl,30H
	add	al,dl                  ;a pripocita cislo z dl
FINISH: ret
ShortConvertToInt endp
;---------------------------------------------------------------------------
;procedura, ktora zisti index cisla v poli NUMBERS zo zadaneho poradoveho
;cisla,ulozi do ax dane cislo(proceduru vyuziva 3. polozka menu)
;v dx musi mat offset URCI1 or URCI2
;

FindOperand 	proc
index:  push    dx                     ;ulozenie itemu dx do stacku
	mov     ah,09H                 ;v dx je offset vypisu URCI1 or URCI2
				       ;ktory sa vypise
	int	21H
	mov	ah,0aH                 ;nacitanie porad.cisla cez sluzbu 0aH
	mov	dx,offset DIVIDE       ;do POCET->skut.pocet nacit.znakov
	int 	21H                    ;do OPERAND dane znaky
	mov 	bx,offset OPERAND
	mov	dh,[bx]                ;1.nacitany znaku do dh
	cmp	dh,'1'                 ;testy na to ci je to cislica
	jb	cyklus6
	cmp	dh,'9'
	ja	cyklus6
	cmp     POCET,2                ;ak nacital iba 1 znak
	jb      NEXT7                  ;tak skok
	mov	dh,[bx+1]              ;inak do dh dalsi nacitany znak
	cmp	dh,'0'                 ;a testy na cislicu(druha uz moze
				       ;byt nulova)
	jb	cyklus6                 ;ak nevyhovuje volba sa opakuje
	cmp	dh,'9'
	ja	cyklus6
NEXT7:  pop	dx
	jmp     najdi
cyklus6:pop     dx                     ;obnovenie dx
	jmp	index                  ;opakuj pokial nebude spravna volba
najdi:  push	dx		       ;ulozenie pre pripad dalsiho skoku
				       ;spat(zvolene cislo>figure)
	call    ShortConvertToInt      ;z dh a dl prevedie do dvojk.cis.do al
	pop	dx
	cmp	al,FIGURE              ;ak al(zadana volba porad.cis)je
	ja      index                  ;vacsia ako pocet cisel tk nova volba
	cbw                            ;zkonvert.al do wordu
	dec	ax                     ;v ax je FIGURE-1
	add	ax,ax		       ;ax je index cisla v poli NUMBERS
	mov	si,ax                  ;zapis daneho
	mov	bx,offset NUMBERS      ;cisla do
	mov     ax,[bx+si]             ;ax
	ret
FindOperand endp
;---------------------------------------------------------------------------
;procedura na vypocet sumy:
;di bude obsahovat sumu v dvojkovo doplnk.kode
;bx bude ukazovat na na nacitane cisla do pamete(na zac. mnoziny)
;si offset(index) na jednotlive cisla
VypocetSumy proc
	xor     cx,cx
	mov	cl,FIGURE              ;do pocitadla pocet cisel
	xor	si,si
	xor	di,di
	mov 	bx,offset NUMBERS
SUMA:	add	di,[bx+si]             ;pripocitaj do di cislo
	jo	OUTSUM                 ;ak owerflow/jump owerflow
        jmp     DALEJ1 
OUTSUM: mov     ah,09H
	mov	dx,offset HLASKA6
	INT	21H
DALEJ1:	add	si,2
	loop	SUMA
	mov     dx,offset NL           ;odriadkovanie
	mov     ah,09H
	int	21H
	call	ConvertIntToASCII      ;dvojkove->ascii
	call	PrintToScreen          ;ascii z pameti na obrazovku
	mov     dx,offset NL           ;odriadkovanie
	mov     ah,09H
	int	21H
        ret
VypocetSumy endp

;-------------------------------------------------------------------------------
;procedura na vzostupne usporiadanie
;v ax bude index posledneho cisla z NUMBERS,sluzi na ukoncenie cyklu
;v di bude index cisla z NUMBERS ,kt.sa porovnava zo zvyskom cisel.
;si bude obsahovat indexy zvysku z kt.sa bude vyberat najv.cislo na miesto di
;bp bude pomocny register pri usporiadavani

UsporiadajVzostupne proc
	mov	bx,offset NUMBERS
	xor	cx,cx
	mov	cl,FIGURE              ;do cx pocet cisel
	mov	ax,cx                  ;do ax pocet cisel
	add     ax,ax                  ;v ax je pocet cisel*2(2 B na cislo)
				       ;a tiez index za posledne cislo
				       ;sluzi ako ukoncovaci apod.cyklu
	dec     cl                     ;na usporiadanie staci FIGURE-1 cyklov
	mov	di,-2                  ;aby pri prvej inkr. ukaz. na 1. cislo
MAJOR:	add	di,2                   ;di ukazuje na dalsie cislo
	mov	si,di
MINOR:	mov	dx,[bx+di]             ;do dx cislo ktore,ktore sa bude
				       ;porovnavat zo zvyskom
	add	si,2                   ;indexovanie zvysku pola cisel
	cmp     si,ax                  ;porovnanie ci uz je koniec pola
	jz	CYCLE4                 ;ak ano tak novy cyklus s reduk.zvysk.
	cmp	dx,[bx+si]             ;porovnaj
	jng     NEXT5                  ;ak dx mensie skok
	mov	bp,[bx+si]             ;inak prehod cisla
	mov	[bx+di],bp
	mov	[bx+si],dx
NEXT5:  jmp	MINOR                  ;dalsi maly cyklus cez akt.zvysok pola
CYCLE4:	loop	MAJOR
;---------------vypis do suboru vystup.txt------
;-----otvorenie suboru
	mov 	ah,3dH                 ;otvorenie suboru zadaneho
	mov	dx,offset PATHOUT      ;retazcom pathin cez sluzbu 3dH
	mov	al,1
	int	21H
	jnc     HAND
	mov     dx,offset HLASKA2 ;vypis chybovej spravy
				       ;ak sa nepodarilo subor vstup.txt
	mov     ah,09H		       ;otvorit(priznak cf bol nastaveny
	int	21H                    ;na 1
        mov     dx,offset KON       ;vypis retazca z dat.seg. na obr
	mov     ah,09H
	int	21H
	mov 	ax,4C00H               ;funkcia ukoncenie programu
	int	21H

HAND:	mov	HANDLER2,ax          ;do ax ulozi handler suboru
	xor	si,si
	xor	cx,cx
	mov	cl,FIGURE
	mov	bx,offset NUMBERS
WRITE:  push	cx                     ;odpocitavanie->stack lebo procedury
				       ;vyuzivaju cx
	push	si                     ;lebo proc.printtofile  ho zmeni
	push	bx		       ;podobne
	mov	di,[bx+si]             ;do di jednotlive cisla
	call    ConvertIntToASCII
	call	PrintToFile            ;vypis cisla do suboru
	pop	si                     ;obnovenie indexu do NUMBERS
	add	si,2                   ;si<-index dalsieho cisla
	pop	bx                     ;obnovenie offsetu NUMBERS
	pop	cx                     ;nacitanie cx
	loop    WRITE
;---------uzavratie suboru vystup.txt
	mov	bx,offset HANDLER2   ;parametre pre proceduru
	mov     dx,offset HLASKA4 ;ktora zatvori subor
	call    CloseFile
        ret
UsporiadajVzostupne endp


;-------------------------------------------------------------------------
;vydeli dve vybrane cisla a vypise vysledok

VypocetDelenia proc
	mov	bx,offset NUMBERS
	xor	si,si                  ;index na cislo v poli NUMBERS
;---------vypise vsetky cisla na obrazovku, aj s poradovym cislom
	xor	cx,cx
	xor     ax,ax                  ;jednoduche pocitadlo pre vypis
				       ;poradia cisel na obr.
	mov	cl,FIGURE              ;do cx pocet cisel
SHOW:	mov	di,ax
	inc	di                     ;v di poradove cislo cisla v poli
	push	ax
	mov     ah,09H                 ;vypis medzery medzi por.cis.acislom
	mov	dx,offset NL
	int	21H
	call 	ConvertIntToASCII      ;prevedie obsah di
	call    PrintToScreen          ;a vypise ho
	mov     ah,09H                 ;vypis medzery medzi por.cis.acislom
	mov	dx,offset ORDER
	int	21H
	pop	ax
	mov	di,[bx+si]             ;do di konkretne cislo
	call 	ConvertIntToASCII      ;jeho prevod
	call    PrintToScreen          ;a vypis
	inc     ax
	add	si,2                   ;do si index dalsieho cisla
	loop	SHOW                   ;opakuj FIGURE-krat
;---------vyber dvoch poloziek
	mov	dx,offset URCI1        ;pre proceduru
	call	FindOperand            ;nacita delenec do ax
	push	ax                     ;odlozenie ax(delenca) do stacku
	mov	dx,offset URCI2
	call	FindOperand            ;nacita delitel do ax
	mov     cx,ax                  ;delitel do cx
	cmp	cx,0		       ;je delitel nulovy?
	jnz	nulok                  ;nie-je to vporiadku,skok na nulok
        mov	ah,09H                 ;pri pokuse o dekenie nulou vypis
	mov	dx,offset NULA
	int	21H
NULOK:	pop	ax                     ;obnovenie ax
	cwd                            ;zkonvert. ax do doublewordu(+ dx)
	idiv	cx                     ;znamienkove delenie
				       ;v ax je podiel
				       ;v dx je zvysok
	push	dx		       ;ulozenie zvysku	
	mov	di,ax                  ;pre proced. presun podiel do di
	call	ConvertIntToASCII      ;prevod
	mov     ah,09H                 ;a
	mov	dx,offset PODIEL       ;vypis podielu
	int	21H
	call	PrintToScreen
	pop	dx
	mov	di,dx                  ;pre proced. presun zvysku do di
	call	ConvertIntToASCII      ;prevod do ASCII
	mov     ah,09H                 ;a
	mov	dx,offset ZVYSOK       ;vypis zvysku
	int	21H
	call	PrintToScreen
	ret
VypocetDelenia endp

;-------------------------------------------------------------------------------

VypocetNasobenia proc
	mov	bx,offset NUMBERS
	xor	si,si                  ;index na cislo v poli NUMBERS
;---------vypise vsetky cisla na obrazovku, aj s poradovym cislom
	xor	cx,cx
	xor     ax,ax                  ;jednoduche pocitadlo pre vypis
				       ;poradia cisel na obr.
	mov	cl,FIGURE              ;do cx pocet cisel
SHOW1:	mov	di,ax
	inc	di                     ;v di poradove cislo cisla v poli
	push	ax
	mov     ah,09H                 ;vypis medzery medzi por.cis.acislom
	mov	dx,offset NL
	int	21H
	call 	ConvertIntToASCII      ;prevedie obsah di
	call    PrintToScreen          ;a vypise ho
	mov     ah,09H                 ;vypis medzery medzi por.cis.acislom
	mov	dx,offset ORDER
	int	21H
	pop	ax
	mov	di,[bx+si]             ;do di konkretne cislo
	call 	ConvertIntToASCII      ;jeho prevod
	call    PrintToScreen          ;a vypis
	inc     ax
	add	si,2                   ;do si index dalsieho cisla
	loop	SHOW1                  ;opakuj FIGURE-krat
;--------- vyber dvoch poloziek ------------------------------------------------
	mov	dx,offset URCI3        ;pre proceduru
	call	FindOperand            ;nacita prve cislo do ax
	push	ax                     ;odlozenie ax(prve) do stacku
	mov	dx,offset URCI4
	call	FindOperand            ;nacita druhe cislo do ax
	mov     cx,ax                  ;delitel do cx
	pop	ax                     ;obnovenie ax
	cwd                            ;zkonvert. ax do doublewordu(+ dx)
	imul	cx                     ;znamienkove nasobenie
				       ;v ax je vrch
				       ;v dx je spodok cisla,pretecenie
	mov	di,ax                  ;pre proced. presun podiel do di
	call	ConvertIntToASCII      ;prevod
	mov     ah,09H                 ;a
	mov	dx,offset PODIEL       ;vypis vysledku nasobenia
	int	21H
	call	PrintToScreen          ;
	ret
VypocetNasobenia endp

;-------------------------------------------------------------------------------

UsporiadajZostupne proc

	mov	bx,offset NUMBERS
	xor	cx,cx
	mov	cl,FIGURE              ;do cx pocet cisel
	mov	ax,cx                  ;do ax pocet cisel
	add     ax,ax                  ;v ax je pocet cisel*2(2 B na cislo)
				       ;a tiez index za posledne cislo
				       ;sluzi ako ukoncovaci apod.cyklu
	dec     cl                     ;na usporiadanie staci FIGURE-1 cyklov
	mov	di,-2                  ;aby pri prvej inkr. ukaz. na 1. cislo
MAJOR1:	add	di,2                   ;di ukazuje na dalsie cislo
	mov	si,di
MINOR1:	mov	dx,[bx+di]             ;do dx cislo ktore,ktore sa bude
				       ;porovnavat zo zvyskom
	add	si,2                   ;indexovanie zvysku pola cisel
	cmp     si,ax                  ;porovnanie ci uz je koniec pola
	jz	CYCLE41                ;ak ano tak novy cyklus s reduk.zvysk.
	cmp	dx,[bx+si]             ;porovnaj
	jg      NEXT51                 ;jump if greater - ak dx mensie skok
	mov	bp,[bx+si]             ;inak prehod cisla
	mov	[bx+di],bp
	mov	[bx+si],dx
NEXT51: jmp	MINOR1                 ;dalsi maly cyklus cez akt.zvysok pola
CYCLE41:loop	MAJOR1
;---------------vypis do suboru vystup.txt------
;-----otvorenie suboru
	mov 	ah,3dH                 ;otvorenie suboru zadaneho
	mov	dx,offset PATHOUT      ;retazcom pathin cez sluzbu 3dH
	mov	al,1
	int	21H
	jnc     HAND1
	mov     dx,offset HLASKA2 ;vypis chybovej spravy
				       ;ak sa nepodarilo subor vstup.txt
	mov     ah,09H		       ;otvorit(priznak cf bol nastaveny
	int	21H                    ;na 1
        mov     dx,offset KON       ;vypis retazca z dat.seg. na obr
	mov     ah,09H
	int	21H
	mov 	ax,4C00H               ;funkcia ukoncenie programu
	int	21H

HAND1:	mov	HANDLER2,ax          ;do ax ulozi handler suboru
	xor	si,si
	xor	cx,cx
	mov	cl,FIGURE
	mov	bx,offset NUMBERS
WRITE1:  push	cx                     ;odpocitavanie->stack lebo procedury
				       ;vyuzivaju cx
	push	si                     ;lebo proc.printtofile  ho zmeni
	push	bx		       ;podobne
	mov	di,[bx+si]             ;do di jednotlive cisla
	call    ConvertIntToASCII
	call	PrintToFile            ;vypis cisla do suboru
	pop	si                     ;obnovenie indexu do NUMBERS
	add	si,2                   ;si<-index dalsieho cisla
	pop	bx                     ;obnovenie offsetu NUMBERS
	pop	cx                     ;nacitanie cx
	loop    WRITE1
;---------uzavratie suboru vystup.txt
	mov	bx,offset HANDLER2   ;parametre pre proceduru
	mov     dx,offset HLASKA4 ;ktora zatvori subor
	call    CloseFile
        ret
UsporiadajZostupne endp




CODE	ENDS                           ;koniec kodoveho segmentu
	END	START                  ;koniec suboru - pre assembler

ZHODNOTENIE: Program bol kompilovany v programe TASM 2.02 a prilinkovany
             v prog. TLINK 3.01. Subory vstup.in a vystup.out musia existovat
	     inak je program predcasne ukonceny. Maximalny pocet cisel
  	     ktore mozu byt nacitane moze byt 20 (ostatne sa ignoruju) 
	     v rozsahu od -32768 po 32767. Vo vstupe sa ignoruju ine znaky
	     ako cisla (so znamienkom a bez). Viacnasobne pouzitie 
	     minus sa berie stlale ako minus (nie je to unarne minus). Medzi
	     znamienkom a cislom nesmie byt ziaden znak, inak sa znamienko
             minus ignoruje. Ak sa v subore najde cislo, ktore je mimo
	     nas interval tak sa program ukonci ( a vypise chybovu hlasku).
	     Ak dojde k preteceniu v sumacii tak to program zahlasi.
