;ZADANIE :1/a
;Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) 
;a podla ponukaneho menu vykona jednu z moznosti:
;      a) vypise retazec znakov (max.100 znakov) na obrazovku
;      b) vypise poradove cislo miesta, kde sa nachadza prva medzera,
;      c) hlada v retazci pouzivatelom zadany znak,vypise pcet najdenych
;         kusov a vypise vsetky miesta jeho vyskytu, ak nenajde, vypise, 
;         ze sa v retazci dany znak nenachadza
;      d) najde znak s maximalnou hodnotou a vypise tento znak
;      e) zarovna text zlava
;      f) vypise retazec v obratenom poradi
;      g) ukonci program 
;
;Dodatok :
;Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;
;Spracoval: Jozef LIPOVSKY /INF B 11/
;Spracovane ulohy: a,b,c,d,e,f,g
;Termin odovzdania: 23.10.2000
;2.roc, sk.rok 2000/2001




data segment                              ;zadefinovanie datoveho segmentu   
	 text1 db 'Menu:',0                     
	 text2 db 10,13,10,13,'1. Vypis retazca',0
	 text3 db 10,13,'2. Najdi prvu medzeru',0
	 text4 db 10,13,'3. Zisti vyskyt zadaneho znaku',0
         text5 db 10,13,'4. Zisti znak s max. hodnotou',0
         text6 db 10,13,'5. Zarovnaj text zlava',0
         text7 db 10,13,'6. Vypis retaca v obratenom poradi',0
	 text8 db 10,13,'7. Koniec programu !',0
	 text9 db 10,13,10,13,'Tvoja volba (1-6)? ',0
	text10 db 'Zadaj retazec znakov: ',0
        text11 db 10,13,10,13,'Stlac lubovolnu klavesu ...',0
        text12 db 10,13,10,13,'Zadany retazec: ',0
        text13 db 10,13,10,13,'Prva medzera je na pozicii: ',0
        text14 db 10,13,10,13,'V zadanom retazci sa nenachadza medzera!',0
        text15 db 10,13,10,13,'Retazec v obratenom poradi: ',0
        text16 db 10,13,10,13,'Hladany znak v retazci: ',0
	text17 db 10,13,'Pozicie najdenych znakov: ',0
	text18 db 10,13,'Pocet najdenych znakov: ',0
        text19 db 10,13,10,13,'Znak s maximalnou hodnotou v zadanom retazci:',0
	text20 db 10,13,10,13,'Zarovnany text do lava: ',0         
retazec db 101 dup(0)                    
                                                
	                                
data ends                                 ;koniec datoveho segmentu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
code segment
	assume cs:code,ds:data,ss:data

start:	mov ax,seg data
	mov ds,ax		;priradilo DS ukazatel na DATA segment
        xor cx,cx		;vynuluje CX
 	call zmazobr		;maze obrazovku
	call nacitajret		;nacita retazec
menu:   call zmazobr		;maze obrazovku
	call vypismenu		;vypise menu
	call citajznak		;nactava 1 znak 
	cmp al,'1'              ;podmienka, caka nastlacenie "1"      
	jz vypisanie		;ak stlaci "1" potom: Vypisanie
	cmp al,'2'
	jz najstmedzeru		;ak "2" potom Najstmedzeru
	cmp al,'3'		;ak "3" potom zisti vyskyt znaku
	jz vysk
        cmp al,'4'              ;ak "4" potom najde znak s max. hodnotou 
        jz maxhod 
        cmp al,'5'              ;ak "5" potom zarovna text do lava  
        jz zaro            
	cmp al,'6'		;ak "6" vypis obrat
	jz obra
	cmp al,'7'		;"7" znamena koniec programu
        jz koni
	jmp menu		;inak opakuj nacitanie znaku
vysk:	jmp zistivyskyt
maxhod: jmp maximum
zaro:   jmp zarovnaj
obra:	jmp vypisobratene
koni:	jmp koniec

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vypisanie:
	mov dx,offset text12	;daj ukazatel na text12
        call vypisret		;vypis dany retazec, na kt. ukazuje DX
	mov dx,offset retazec
	call vypisret		;vola funkciu vypis retazca
	mov dx,offset text11    ;daj ukazovatel na rext 11
	call vypisret		;vypis "Stlac lubovolnu klavesnicu ..."
	jmp menu                ;skok do menu 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
najstmedzeru:
        mov al,1		;inicializuj pocitadlo pozicie na hodnotu 1
	mov bx,offset retazec	;BX ukazuje na pole retazec
zac1:	cmp byte ptr [bx],' '	;porovnaj prvok pola retazec s ' '
	jz kon1			;ak sa = skoc na kon1
	cmp byte ptr [bx],0	;ak nie porovnaj prvok s koncom retazca '0'
        jz kon2			;ak koniec retazca skoc na kon2
	inc bx			;BX+1
        inc al			;AL+1
        jmp zac1 		;skoc na zac1 ak je to iny znak
kon1:	push ax			;AX do zasobniku
	mov dx,offset text13
	call vypisret		;vypisanie "Prva medzera je na poz.:"
	pop ax			;vyber AX (proc vypisret modifikuje AX)
        xor bx,bx		;nuluje BX
	mov bl,al
	call vypiscislo		;vypise pocet mezier
	mov dx,offset text11
    	call vypisret		;vypise "Stlac lubovolnu klavesnicu ..."
	jmp menu                ;navrat do menu
kon2:	mov dx,offset text14
	call vypisret		;"V zadanom retazci nieje medzera !
	
	mov dx,offset text11
        call vypisret		;"Stlac lubovolnu klavesnicu...."
	jmp menu                ;navrat do menu 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

zistivyskyt:
	mov dx,offset text16
	call vypisret		;Vypise: "Hladany znak:"
	xor cx,cx               ;nuluje cx  
	call citajznak		;nacita znak
	mov bx,offset retazec
	mov ah,2		;AH=2 (vypis znaku; AH uz nemodifikujem)
	dec bx			;zniz BX kvoli prvemu prechodu cyklom
znovu:  inc bx			;BX+1
        inc ch			;CH+1 (prvy precod CH=1)
	cmp byte ptr [bx],0	;porovnaj prvok retazca s '0' (koncom)
	jz mimo			;ak je koniec retazca skoc na mimo
	cmp [bx],al		;porovnaj prvok so zadanym znakom
	jnz znovu		;ak to nie je on daj dalsi znak
	cmp cl,0		;ak to je on, je to prvy najdeny znak?
        jnz dalej		;ak nie je skoc na dalej
	push bx			; inak dloz BX,CX,AX
	push cx			;kvoli zmene v proc vypisret
        push ax
	mov dx,offset text17
	call vypisret		;vypis "Pozicie zadanych znakov:
        pop ax			;vyber AX,CX,BX
	pop cx
	pop bx
dalej:	inc cl			;zvys pocitadlo najdenych znakov
	push bx			;uloz registre
	push cx
        push ax
        xor bx,bx		;nuluj BX
	mov bl,ch		;uloz tam momentalnu poziciu
	call vypiscislo		;vypis ju na obrazovku
	mov dl,' '		;a za tym jednu medzeru
	int 21h
	pop ax			;vyber registre
	pop cx
	pop bx
	jmp znovu		;dalsi znak
mimo:   push cx			;odloz CX (pocitadlo)
	mov dx,offset text18
	call vypisret		;vypis "Pocet najdenych znakov"
        pop cx			;vyber CX
	xor bx,bx
	mov bl,cl		;daj pocet najdenych znakov do BL
	call vypiscislo		;vypis BL
	mov dx,offset text11
	call vypisret		;"Stlac lubovolnu klavesnicu ... "
	jmp menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

maximum:
	mov dx,offset text19    ; daj ukazovatel na text 19 
        call vypisret           ; vypis dany retazec, na ktory ukazuje dx
	mov bx,offset retazec
	mov dl,[bx]             ; do registra dl dam prvy znak

opet_m:                            
	inc bx                  ;inkkrementujem bx+1
	mov al,[bx]             ;do al registra nacitam to co je v bx      
	cmp dl,al               ;porovnavam registre
	ja dalej_max            ;podmieneny skok, ak je vacsie
	mov dl,al               ;inak dam do dl al

dalej_max:
	cmp al,0                ;porovnam al s 0, t.j. s koncom retazca 
	jnz opet_m              ;ak nieje koniec retazca pokracujem v opet_m
	
	mov ah,2                ;zobrazim najvacsi najdeny znak  
	int 21h

	mov dx,offset text11    ;vypisem:" Stlac lubovolnu klavesu . . ."
	call vypisret           ;vypis textu
;	call citajznak          ;cakam na stlacenie klavesy
	jmp menu                ;navrat do menu 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

zarovnaj:
	mov dx,offset text20       ;ukazovatel textu 20 na register 20     
	call vypisret              ;vypis:"Zarovnany text do lava:"
	mov cx,offset retazec      ;ukazovatel na retazec   
	mov bx,cx		   ;pocitadlo medzier	
	mov ax,0                   ;doplnenie retazca

zn_z:                                  
	mov dl,[bx]                ;vloz do registra dl znak z registra bx   
	cmp dl,' '                 ;porovnanie znaku v dl s ' 't.j. medzerou
	jnz uloz                   ;podmienka ak tam nieje medzera, skoc na uloz
	inc bx                     ;inkrementacia bx+1  
	jmp zn_z                   ;skok na zaciatok porovnavania, t.j. zn_z
uloz:
	xchg bx,cx                 ;xchg =xchange t.j. vymena registrov 
uloz1:
	push bx                    ;odlozim si znak z registra bx
	mov bx,cx		   ;nacitam do bx, ktore je volne cx
	mov dl,[bx]                ;a teraz dam bx kde je vlastne cx do dl  
	pop bx                     ;a teraz obnovim opat povodny bx
	
	cmp dl,0                   ;porovnam dl s nulou, ci ja na konci 
	jz uloz2                   ;skok, je tam nula-skok na uloz2 
	mov [bx],dl                ;nieje a preto zapis na nove miesto
	inc bx                     ;inkrementujem bx+1   
	inc cx                     ;a zaroven aj cx+1 
	jmp uloz1                  ; a opakujem . . .        
uloz2:
	mov [bx],al                ;sem som skocil s uloz1 ak su tam uz len nuly
	inc bx                     ;bx=bx+1
	cmp [bx],al                ;porovnanie  
	jnz uloz2                  ;skok naspat na zaciatok uloz2

	mov dx, offset retazec      
	call vypisret              ;vypis retazca 
	
	mov dx,offset text11        
	call vypisret              ;vypis:"Stlac lubovolnu klavesu..."
;	call citajznak             ;caka na klavesu
	jmp menu                   ;skok na menu

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vypisobratene:
	mov bx,offset retazec	;ukazatel na retazec
	xor cx,cx		;vynuluj pocitadlo
pocet:	cmp byte ptr [bx],0	;porovnaj s koncom retazca
        jz mampoc		;ak ano skoc na mampoc
	inc cl			;CL+1
	inc bx			;BX+1
	jmp pocet		;skoc na pocet
mampoc: push cx
	mov dx,offset text15
	call vypisret		;vypis "Retazec v obratenom poradi:"
	pop cx			;v CX mam pocet znakov
        mov ah,2		;AH je vypis znaku - uz nemodifikujem
	mov bx,offset retazec
	dec cx			;CX-1
	add bx,cx		;BX=BX+CX - koniec retazca
zacvyp:	mov dl,[bx]		;postupne znaky od konca davam do DL
	int 21h			;a vypisujem ich
        dec bx			;dalsi (predchadzajuci znak)
	cmp bx,offset retazec
	jge zacvyp		;ak je BX>=zaciatku retazca : cykluj
	mov dx,offset text11
	call vypisret		;inak vypis "Stlac lubovolnu klavesu .."
	jmp menu                ;navrat do menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
koniec:	mov ah,4ch		;koniec programu
	int 21h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
zmazobr proc
	mov ah,6		;nastavenie registrov
	mov ch,0
	mov cl,0
	mov dh,25
	mov dl,80
	mov al,0
	mov bh,07h		;mo obrazovky (0-pozadie; 7-text) farba
	int 10h			;zmazanie obrazovky
	mov ah,2		;nastavenie kurzoru
	mov dh,0
	mov dl,0
	mov bh,0
	int 10h			;kurzor na (0,0)
	ret
	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
citajznak proc

zac0:	xor cl,cl		;nuluj CL
zac:	mov ah,8		;AH=8
	int 21h			;cita znak s klavesnice [bez vypisu]
	cmp al,0		;ak to nie je riadiaci znak
	jnz kon			;tak skoc na kon
	mov cl,1		;inak nastav CL=1
        jmp zac			;a vycitaj druhu honotu riad. znaku
kon:    cmp ch,1		;CH=1 moze byt stlaceny aj riadici znak
	jz von1			;je to kvoli "Stlac lubovolnu klavesu ..."
	cmp cl,1		;inak riad. znaky ignoruje (CH=0)
	jz zac0			;po vycitani riad. znaku (2x) je stale CL=0
        mov ch,dl		;skace na nacitanie dalsieho znaku CL=0
	mov dl,al
	mov ah,2
	int 21h			;vypis nacitaneho znaku ak treba (CH=0)
	mov dl,ch
von1:	xor ch,ch		;vynuluje CH
	ret
	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vypismenu proc			;procedura na vypisanie menu
	
        mov dx,offset text1
	call vypisret
	mov dx,offset text2
	call vypisret
	mov dx,offset text3
	call vypisret
	mov dx,offset text4
	call vypisret
	mov dx,offset text5
	call vypisret
	mov dx,offset text6
	call vypisret
	mov dx,offset text7
	call vypisret
	mov dx,offset text8
        call vypisret
        mov dx,offset text9
	call vypisret
        ret
	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
nacitajret proc
	
	mov dx,offset text10
        call vypisret		;"Zadaj retazec znakov: "
	mov bx,offset retazec
	mov dx,bx
	add dx,100		;maximalne dosiahnutelna honota konca
citaj:	call citajznak		;citaznak
	cmp al,13		;ak ENTER tak
	jz mamret		;skoc na mamret
	cmp al,8		;ak nie je BCKSPACE
        jnz cit 		;skoc na cit: inak todalej osetri
	cmp bx,offset retazec	;ak som na zaciatku retazca
        jz citaj1		;skoc na citaj1
        push dx
	dec bx			;BCKSP znizi ukazatel
	mov byte ptr [bx],0	;dam tam znacku konca retazca
	mov ah,2
	mov dl,' '		;vypise medzeru (vymaze znak na obraz.)
	int 21h
	mov dl,8		;posun kurzoru spat o 1 znak
	int 21h
	pop dx
        jmp citaj		;cita dalej
citaj1:	mov ah,2
	mov dl,' '		;zaciatok retazca
	int 21h			;vrat kurzor ojednu poziciu dalej
	jmp citaj
cit:	mov [bx],al		;ak normalny znak tak ho da do pola
	inc bx			;zvysi poziciu v poli
	cmp bx,dx		;porovna s maximom 100 znakov
	jz mamret		;ak ano tak skonci
	jmp citaj		;inak cita dalsi znak
mamret:	ret
	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vypisret proc

	mov ah,2		;ukazatel je v DX
        mov cx,dx
	mov bx,dx
vypis:	mov dl,[bx]		;BX kvoli indexacii pola
	cmp dl,0		;ak je to koniec retazca
        jz konvyp		;tak skonci
	int 21h			;inak vypis znak
	inc bx
	jmp vypis
konvyp:	mov bx,offset text11	;ak vypisujem hlasku "Stlac lubovolnu klavesu ..."
	cmp cx,bx
        jnz von			;ak nie tak skonci
	mov ch,1		;ak ano tak cakaj na stacenie niecoho
	call citajznak
von:	ret
	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vypiscislo proc

	xor cx,cx		;cislo je v BX
	mov ah,2
s100:	cmp bx,100		;spocita pocet 100
	jb s10
	sub bx,100
	inc cl
	jmp s100
s10:	cmp cl,0
	jz s11
	add cl,30h		;prida 30h k poctu 100-viek
	mov dl,cl
	int 21h			;vypise pocet 100-viek
s11:	cmp bx,10
	jb s1
	sub bx,10		;spocita 10-tky
	inc ch
	jmp s11
s1:     cmp ch,0
	jz s001
	add ch,30h		;prida 30h
	mov dl,ch
        int 21h			;vypise 10-tky
	jmp s01
s001:	cmp cl,0		;ak nie su 1-tky skoc na s01
	jz s01
	add ch,30h
	mov dl,ch		;inak vypis pocet1-tiek
	int 21h
s01:	add bl,30h		
	mov dl,bl
	int 21h
	ret
	endp

code ends
end start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Dodatocny komentar;
;bohuzial pre nedostatok casu som neodhalil chybu, 
;vdaka ktorej mi nefungyje uplne dokonale zarovnavanie do lava, 
;ale tento problem je riesitelni a preto dufam, ze to zohladnite.
;                                                         Dakujem

