; Michal Litavsky
; INF B-11

ZAS     SEGMENT STACK
        DW      64 DUP(?)
ZAS     ENDS
            
DATA    SEGMENT
VSTUP   DB      100
POCET   DB      0
TEXT    DB      100 DUP(?)
MENU    DB      0AH, 0DH
        DB      'A - vypis retazca', 0AH, 0DH
        DB      'B - poradove cislo 1. medzery', 0AH, 0DH
        DB      'C - hladaj zadany znak', 0AH, 0DH
        DB      'D - vypis znaku s max. hodnotou', 0AH, 0DH
        DB      'E - zarovnaj text zlava', 0AH, 0DH
        DB      'F - invertuj retazec', 0AH, 0DH
        DB      'G - EXIT'
        DB      10,13,10,13,10,13,10,13,10,13,10,13,10,13
        DB      10,13,10,13,10,13,10,13,10,13,10,13,'$'
REG     DB      10, 13, 10, 13,  'Vysledok >>    ', 10, 13, '$'
NR      DB      10, 13, 10, 13
VYSTUP  DB      103 DUP(?)
DATA    ENDS

CODE    SEGMENT
        ASSUME  DS:DATA, SS:ZAS, CS:CODE

START:  MOV     AX, SEG DATA
        MOV     DS, AX

        ;nacitanie retazca
        MOV     DX, OFFSET VSTUP
        MOV     AH, 0AH
        INT     21H

ZAC:    MOV     DX, OFFSET TEXT
        MOV     SI, DX
        MOV     BX, OFFSET VYSTUP
        XOR     AX, AX
        XOR     CX, CX
        MOV     CL, POCET

        ;vypis menu
        MOV     DX, OFFSET MENU
        MOV     AH, 09H
        INT     21H

        ;vyber z menu
POR:    MOV     AH, 06H
        MOV     DL, 0FFH
        INT     21H
        JZ      POR

        CMP     AL, 'a'
        JNE      P2
        ;vypis retazca
A:      MOV     AL, [SI]
        MOV     [BX], AL
        INC     SI
        INC     BX
        LOOPNE  A
        CALL    ZOBRAZ
        JMP     ZAC

P2:     CMP     AL, 'A'
        JE      A
        CMP     AL, 'b'
        JNE     P3
        ;poradove cislo 1. medzery
B:      MOV     AL, [SI]
        CMP     AL, ' '
        JE      B1
        INC     SI
        LOOPNE  B
B1:     MOV     AX, SI
        SUB     AL, 2           ;v AL poradove cislo medzery
        CALL    VIEW
        JMP     ZAC

P3:     CMP     AL, 'B'
        JE      B
        CMP     AL, 'c'
        JNE     P4
        ;pocet vyskytov daneho znaku do CX
C:      MOV     AH, 01H
        INT     21H
        XOR     DX, DX
C1:     MOV     AH, [SI]
        INC     SI
        CMP     AL, AH
        JNE     C2
        ADD     DL, 1
C2:     LOOPNE  C1
        MOV     CX, DX          ;v CX pocet vyskytov znaku
        MOV     AX, CX
        CALL    VIEW
        JMP     ZAC

P4:     CMP     AL, 'C'
        JE      C
        CMP     AL, 'd'
        JNE     P5
        ;vypis znaku s max. hodnotou
D:      XOR     AH, AH
D1:     MOV     AL, [SI]
        CMP     AL, AH
        JNG     D2
        MOV     AH, AL
D2:     INC     SI
        DEC     CL
        CMP     CL, 0
        JE      D3
        JMP     D1
D3:     MOV     AL, AH
        MOV     [BX], AL
        INC     BX
        CALL    ZOBRAZ
        JMP     ZAC

P5:     CMP     AL, 'D'
        JE      D
        CMP     AL, 'e'
        JNE     P6
        ;zarovnanie textu zlava
E:      MOV     AL, [SI]
        CMP     AH, 0FFH
        JE      E1
        CMP     AL, ' '
        JNE     E1
        INC     SI
        MOV     AL, [SI]
        CMP     AL, ' '
        JE      E2
        MOV     AH, 0FFH
E2:     DEC     CL
        JMP     E
E1:     MOV     AH, 0FFH
        MOV     [BX], AL
        INC     SI
        INC     BX
        LOOPNE  E
        CALL    ZOBRAZ
        JMP     ZAC

P6:     CMP     AL, 'E'
        JE      E
        CMP     AL, 'f'
        JNE     P7
        ;inverovanie retazca
F:      ADD     SI, CX
        SUB     SI, 1
F1:     MOV     AL, [SI]
        MOV     [BX], AL
        DEC     SI
        INC     BX
        LOOPNE  F1
        CALL    ZOBRAZ
        JMP     ZAC

P7:     CMP     AL, 'F'
        JE      F
        CMP     AL, 'g'
        JNE     P8
        ;ukoncenie programu
EXIT:   MOV     AH, 4CH
        INT     21H

P8:     CMP     AL, 'G'
        JE      EXIT
        JMP     POR

ZOBRAZ: MOV     BYTE PTR[BX], 0AH
        MOV     BYTE PTR[BX+1], 0DH
        MOV     BYTE PTR[BX+2], '$'
        MOV     DX, OFFSET NR
        MOV     AH, 09H
        INT     21H
        RET

        ;vypis ciselnej hodnoty z registra na obrazovku
VIEW:   MOV     DX, OFFSET REG
        MOV     BX, OFFSET REG + 17
        XOR     AH, AH

        MOV     CL, 0AH
TO:     DIV     CL
        ADD     AH, '0'
        MOV     [BX], AH
        XOR     AH, AH
        DEC     BX
        CMP     AL, 0
        JNE     TO
        MOV     AH, 09H
        INT     21h
	RET

        ;MOV     AX, 0C08H
        ;INT     21H
          
CODE    ENDS
        END     START
