; Michal Litavsky
; INF B-11

ZAS     SEGMENT STACK
        DW      64 DUP(?)
ZAS     ENDS
            
DATA    SEGMENT
NR1	DB	10, 13,'Obsah suboru:', 10, 13
VSTUP   DB      50 DUP(?)		;sem sa nacita subor
	DB      '$'
CLRSCR  DB      10,13,'$'
TEXT1	DB	'Subor sa precital$'
TEXT2 	DB	'Subor sa neotvoril!$'
TEXT3	DB	10,13,'Stlac lubovolnu klavesu...',10,13,'$'
TEXT4	DB	10,13,'Zadaj poradove cislo  prveho: $'
TEXT5	DB	10,13,'Zadaj poradove cislo druheho: $'
POCET   DW      0
SUBOR   DB      'vstup.txt',0
SUBOR2  DB      'vystup.txt',0
MENU    DB      0AH, 0DH
        DB      '1 - suma vsetkych cisel', 0AH, 0DH
        DB      '2 - usporiadaj vzostupne a zapis do suboru', 0AH, 0DH
        DB      '3 - vydel dve cisla', 0AH, 0DH
        DB      '4 - vynasob dve cisla', 0AH, 0DH
        DB      '5 - EXIT',10,13,'$'
REG     DB      10, 13, 10, 13,  'Vysledok >>        $'
REG2    DB      10,13,'Zvysok   >>        $'
CISLA   DW      20 DUP(?)
POM     DW      20 DUP(?)
INDEX	DW	2 DUP(?)
INDEX2  DW      0
INDEX3  DW      0
INDEX4  DW      0
INDEX5  DW      0
NR2     DB      10, 13, 10, 13
VYSTUP  DW      20 DUP(?)
VYSTUP2 DB      50 DUP(?)
        DB      '$'
DATA    ENDS

CODE    SEGMENT
        ASSUME  DS:DATA, SS:ZAS, CS:CODE

START:  MOV     AX, SEG DATA
        MOV     DS, AX


	MOV     DX, OFFSET SUBOR        ;nacitanie suboru
        MOV     AL, 0                   ;read only
        MOV     AH, 3DH                 
        INT     21H
	CMP	AX, 2			;nasiel sa subor?
	JNE	DALEJ			;ak ano, pokracuj
	MOV	DX, OFFSET TEXT2
	MOV	AH, 9
	INT	21H
	JMP	KONIEC			;ak nie, skonci	


DALEJ:  MOV     BX, AX                  ;nastavenie handleru
        MOV     CX, 1                   ;po jednom znaku
        MOV     DX, OFFSET VSTUP        ;sem sa nacitaju udaje
CITAJ:  MOV     AH, 3FH                 ;sluzba cita zo suboru
        INT     21H
	INC	DX
        CMP     AX, 0                   ;test EOF
        JNE     CITAJ

        MOV     DX, OFFSET TEXT1        ;kontrola precitaneho suboru
        MOV     AH, 9
        INT     21H

	;zadavanie cisel
TAM:    MOV     BX, OFFSET INDEX4       ;vloz index
        MOV     AX, [BX]
        XOR     CX, CX                  ;nuluj CX
        MOV     BX, OFFSET VSTUP        ;citaj po znakoch zo VSTUP
        ADD     BX, AX                  ;prislusny znak
SEM:    MOV     AL, [BX]                ;vloz jeho ASCII do AL
        CMP     AL, ' '                 ;ak je to medzera skoc
        JE      KON
        CMP     AL, '$'                 ;koniec nacitavania
        JE      SKONCI
        SUB     AL, '0'                 ;korekcia o ASCII
        XOR     AH, AH                  ;nuluj AH
        PUSH    AX                      ;vloz AX do zasobnika
        INC     CX                      ;inkrementuj CX
        INC     BX                      ;inkrementuj BX
        JMP     SEM                     ;citaj dalsi znak

KON:    MOV     BX, OFFSET POCET        ;kolko ma cislic cislo
        MOV     AX, [BX]                
        INC     AX                      ;pripocitaj medzeru
        MOV     [BX], AX
        MOV     BX, OFFSET INDEX4       
        MOV     AX, [BX]
        ADD     AX, CX
        INC     AX
        MOV     [BX], AX                ;uloz sem adresu dalsej cislice

        POP     DX                      ;prva cislica do DX
        CMP     CX, 1                   ;ak bola iba jedna skoc
        JE      KON2
        POP     AX                      ;druha cislica
        MOV     DH, 10
        MUL     DH                      ;vynasob ju desiatimi
        ADD     DL, AL                  ;k DL to pripocitaj
        CMP     CX, 2                   ;ak boli iba dve skoc
        JE      KON2                    
        POP     AX                      ;dalsia cislica
        MOV     DH, 100                 
        MUL     DH                      ;vynasob ju stomi
        ADD     DL, AL                  ;k DL to pripocitaj

KON2:   MOV     BX, OFFSET INDEX5
        MOV     AX, [BX]
        MOV     BX, OFFSET CISLA
        ADD     BX, AX
        MOV     [BX], DL                ;ulozenie hodnoty do CISLA
        MOV     BX, OFFSET INDEX5
        MOV     AX, [BX]
        ADD     AX, 2
        MOV     [BX], AX
        JMP     TAM


        ;pomocne pole
SKONCI: MOV     CX, POCET
        XOR     DX, DX

POM1:   MOV     BX, OFFSET CISLA        ;ukaz na zaciatok pola
        ADD     BX, DX                  ;posun sa na dalsi prvok
        MOV     AX, [BX]                ;do AX prvok pola
        MOV     BX, OFFSET POM          ;ukaz na zaciatok pola
        ADD     BX, DX                  ;posun na dalsi prvok
        MOV     [BX], AX                ;zapis do pola
        ADD     DX, 2                   ;dalsi prvok pola
        LOOPNE  POM1
        CALL    USPOR                   ;zavola podprogram


	;vypis nacitaneho suboru
ZAC:	MOV	DX, OFFSET NR1
        MOV	AH, 09H
	INT	21H

        ;vypis menu
        MOV     DX, OFFSET MENU
        MOV     AH, 09H
        INT     21H

        ;Caka na vyber z menu
MNU:    MOV     AH, 06H                 ;sluzba nacita jeden znak 
        MOV     DL, 0FFH                ;z klavesnice, ked je v DL
        INT     21H                     ;hodnota 0FFH, sluzba cita
        JZ      MNU                     ;bez echa
	;vyberie z menu	
	CMP	AL, '1'
	JE	P1
	CMP	AL, '2'
	JE	P2
	CMP	AL, '3'
	JE	P3
	CMP	AL, '4'
	JE	P4
	CMP	AL, '5'
	JE	P5
	JMP	MNU

	;pomocne navestia
P1:     JMP     SUMA
P2:     JMP     USP
P3:     JMP     DEL
P4:	JMP	NASOB
P5:	JMP	KONIEC

        ;spocita vsetky cisla
SUMA:   XOR     AX, AX                  ;nuluj register AX
        XOR     DX, DX                  ;nuluj register DX
        MOV     CX, POCET               ;daj do CX premennu POCET
        
        MOV     BX, OFFSET CISLA        ;ukaz na hodnotu v CISLA
S:      MOV     DX, [BX]                ;daj ju do DX
        ADD     AX, DX                  ;rataj sumu cisel
        ADD     BX, 2                   ;ukaz na dalsiu hodnotu
        LOOPNE  S
        CALL    VIEW                    ;vytlac AX na obrazovku
        CALL    PAUZA                   ;cakaj na klavesu
        JMP     ZAC                     ;vypis menu


        ;vypis usporiadania a zapis do suboru
USP:    MOV     DX, OFFSET SUBOR2       ;nacitanie suboru
        MOV     AL, 1                   ;write only
        MOV     AH, 3DH                 ;otvor subor
        INT     21H
	CMP	AX, 2			;nasiel sa subor?
        JNE     DALEJ1                  ;ak ano, pokracuj
	MOV	DX, OFFSET TEXT2
	MOV	AH, 9
	INT	21H
	JMP	KONIEC			;ak nie, skonci	


DALEJ1: MOV     BX, AX                  ;nastavenie handleru
        MOV     CX, 50                  ;zapis 50 byte
        MOV     DX, OFFSET VYSTUP2      ;sem sa nacitaju udaje
        MOV     AH, 40H                 ;sluzba zapisuje do suboru
        INT     21H

        MOV     DX, OFFSET VYSTUP2
        MOV     AH, 09H
        INT     21h
    
        CALL    PAUZA
        JMP     ZAC                     ;vypis menu


        ;vydeli dve cisla
DEL:    MOV     DX, OFFSET TEXT4        ;vypis pomocneho textu
	MOV	AH, 9
	INT	21H
	MOV 	AH, 1
        INT	21H
	MOV	BX, OFFSET INDEX	;sem sa ulozia indexy
	CMP	AL, '0'			;kontrola
        JB      DEL                     ;ak je pod znova
	CMP	AL, '9'
        JA      DEL                     ;ak je nad znova
	SUB	AL, 48			;korekcia
        MOV     AH, 2
        MUL     AH                      ;index na word
	MOV	[BX], AL		;ulozenie 1. indexu
D1:     MOV     DX, OFFSET TEXT5        ;vypis pomocneho textu
	MOV	AH, 9
	INT	21H
	MOV 	AH, 1
        INT	21H
	CMP	AL, '0'			;kontrola
        JB      D1                      ;ak je pod znova
	CMP	AL, '9'
        JA      D1                      ;ak je nad znova
	SUB	AL, 48			;korekcia
        MOV     AH, 2
        MUL     AH                      ;index na word
	MOV	[BX+2], AL		;ulozenie 2. indexu
	
        MOV     BX, OFFSET INDEX        ;ukaz na prvy index
        MOV     DX, [BX]                ;daj ho do DX
        MOV     BX, OFFSET CISLA        ;ukaz na prvu hodnotu
        ADD     BX, DX                  ;ukaz na hodnotu na 1. indexe
        MOV     AX, [BX]                ;daj ju do AX

        MOV     BX, OFFSET INDEX+2      ;ukaz na druhy index
        MOV     DX, [BX]                ;daj ho do DX
        MOV     BX, OFFSET CISLA        ;ukaz na prvu hodnotu
        ADD     BX, DX                  ;ukaz na hodnotu na 2. indexe
        MOV     CL, [BX]                ;daj ju do CL
        XOR     CH, CH

        CMP     AX, CX                  ;porovnaj AX s CX
        JNB     D2                      ;ak AX>=CX, tak del
        MOV     AL, CL                  ;inak len vypis zvysok
        JMP     D3

D2:     DIV     CL                      ;vydel AX/CL=AL
        PUSH    AX                      ;zvysok do zasobnika
        XOR     AH, AH                  ;nulovanie registra AH
        CALL    VIEW                    ;vytlac AX na obrazovku

        POP     AX                      ;zvysok do AX
        MOV     AL, AH
D3:     XOR     AH, AH
        CALL    VIEW2                   ;vytlac zvysok v AX
        CALL    PAUZA                   ;cakaj na klavesu
        JMP     ZAC                     ;vypis menu



	;vynasobi dve cisla a vypise vysledok
NASOB:  MOV     DX, OFFSET TEXT4        ;vypis pomocneho textu
	MOV	AH, 9
	INT	21H
        MOV     AH, 1                   ;caka na 1. index
        INT	21H
	MOV	BX, OFFSET INDEX	;sem sa ulozia indexy
	CMP	AL, '0'			;kontrola
	JB	NASOB			;ak je pod znova
	CMP	AL, '9'
	JA	NASOB			;ak je nad znova
	SUB	AL, 48			;korekcia
        MOV     AH, 2
        MUL     AH                      ;index na word
	MOV	[BX], AL		;ulozenie 1. indexu
N1:     MOV     DX, OFFSET TEXT5        ;vypis pomocneho textu
	MOV	AH, 9
	INT	21H
        MOV     AH, 1                   ;caka na 2. index
        INT	21H
	CMP	AL, '0'			;kontrola
	JB	N1			;ak je pod znova
	CMP	AL, '9'
	JA	N1			;ak je nad znova
	SUB	AL, 48			;korekcia
        MOV     AH, 2
        MUL     AH                      ;index na word
	MOV	[BX+2], AL		;ulozenie 2. indexu
	
        MOV     BX, OFFSET INDEX        ;ukaz na prvy index
        MOV     DX, [BX]                ;daj ho do DX
        MOV     BX, OFFSET CISLA        ;ukaz na prvu hodnotu
        ADD     BX, DX                  ;ukaz na hodnotu na 1. indexe
        MOV     AL, [BX]                ;daj ju do AL

        MOV     BX, OFFSET INDEX+2      ;ukaz na druhy index
        MOV     DX, [BX]                ;daj ho do DX
        MOV     BX, OFFSET CISLA        ;ukaz na prvu hodnotu
        ADD     BX, DX                  ;ukaz na hodnotu na 2. indexe
        MOV     AH, [BX]                ;daj ju do AH
        MUL     AH                      ;vynasob AL*AH=AX
        CALL    VIEW                    ;vytlac AX na obrazovku
        CALL    PAUZA                   ;cakaj na klavesu
        JMP     ZAC                     ;vypis menu

        ;ukoncenie programu
KONIEC: MOV     AH, 4CH
        INT     21H


ZOBRAZ: ;MOV     BYTE PTR[BX], 0AH
        ;MOV     BYTE PTR[BX+2], 0DH
        ;MOV     BYTE PTR[BX+4], '$'
        MOV     DX, OFFSET NR2
        MOV     AH, 09H
        INT     21H
        RET

	;cakanie na lubovolny klaves
PAUZA:  MOV     DX, OFFSET TEXT3        ;vypis pomocneho textu
	MOV	AH, 9
	INT	21H
PAUZ:   MOV     AH, 06H                 ;caka na klaves
        MOV     DL, 0FFH
        INT     21H
        JZ      PAUZ

        MOV     CX, 40                  ;vycistenie obrazovky
        MOV     DX, OFFSET CLRSCR
PAUZ2:  MOV     AH, 9
        INT     21H
        LOOPNE  PAUZ2
	RET	

        ;vypis ciselnej hodnoty z registra na obrazovku
VIEW:   MOV     DX, OFFSET REG
        MOV     BX, OFFSET REG + 22

        MOV     CL, 10                  ;bude sa delit 10
TO:     DIV     CL
        ADD     AH, '0'                 ;korekcia o ASCII
        MOV     [BX], AH                ;daj do retazca
        XOR     AH, AH                  ;nuluj AH
        DEC     BX                      ;dekrementuj BX
        CMP     AL, 0                   ;porovnaj AL s nulou
        JNE     TO                      ;ak AL=0 pokracuj
        MOV     AH, 09H
        INT     21h

        MOV     CX, 7                   ;kolkokrat prebehne cyklus
T1:     MOV     BX, OFFSET REG + 15     ;ukaz na prvy byte za >>
        ADD     BX, CX                  ;ukaz na BX-1
        MOV     BYTE PTR[BX], ' '       ;daj tam medzeru
        LOOPNE  T1                      
	RET

        ;vypis ciselnej hodnoty z registra na obrazovku
VIEW2:  MOV     DX, OFFSET REG2
        MOV     BX, OFFSET REG2 + 20
               
        MOV     CL, 10                  ;bude sa delit 10
TO2:    DIV     CL
        ADD     AH, '0'                 ;korekcia o ASCII
        MOV     [BX], AH                ;daj do retazca
        XOR     AH, AH                  ;nuluj AH
        DEC     BX                      ;dekrementuj BX
        CMP     AL, 0                   ;porovnaj AL s nulou
        JNE     TO2                     ;ak AL=0 pokracuj
        MOV     AH, 09H
        INT     21h

        MOV     CX, 7                   ;kolkokrat prebehne cyklus
T2:     MOV     BX, OFFSET REG2 + 13    ;ukaz na prvy byte za >>
        ADD     BX, CX                  ;ukaz na BX-1
        MOV     BYTE PTR[BX], ' '       ;daj tam medzeru
        LOOPNE  T2
	RET

        ;usporiada cisla vzostupne a ulozi ich do suboru
USPOR:  XOR     AX, AX                  ;nuluj register AX
        XOR     DX, DX                  ;nuluj register DX
        MOV     CX, POCET               ;daj do CX premennu POCET

        MOV     BX, OFFSET POM          ;ukaz na prvu hodnotu
        MOV     DX, [BX]
U1:     MOV     AX, [BX]                ;daj ju do AX
        CMP     AX, DX                  ;porovnaj ju s DX
        JA      U2                      ;ak je vacsia pokracuj

        MOV     DX, AX                  ;daj do DX minimum
        CMP     CX, POCET
        JE      U3
        ADD     SP, 2                   ;zrus zasobnik
U3:     PUSH    CX                      ;daj index do zasobnika
U2:     ADD     BX, 2                   ;ukaz na dalsiu hodnotu
        LOOPNE  U1

        MOV     BX, OFFSET INDEX2       ;ukaz na hodnotu v INDEX2
        MOV     AX, [BX]                ;daj ju do AX

        MOV     BX, OFFSET VYSTUP       ;ukaz na VYSTUP
        ADD     BX, AX                  ;ukaz na spravnu hodnotu
        MOV     [BX], DX                ;uloz minimum
        MOV     BX, OFFSET INDEX2       ;ukaz na hodnotu v INDEX2
        MOV     AX, [BX]                ;daj ju do AX
        ADD     AX, 2                   ;prirataj k nej 2
        MOV     [BX], AX                ;uloz na INDEX2

        POP     CX                      ;vyber index zo zasobnika
        MOV     AX, POCET               ;daj do AX premennu POCET
        SUB     AX, CX                  ;skutocny index

        MOV     BX, OFFSET POM          ;ukaz na hodnotu na POM
        MOV     AH, 2                   ;do AH daj 2
        MUL     AH                      ;vynasob dvomi
        XOR     AH, AH                  ;nuluj AH register
        ADD     BX, AX                  ;ukaz na minimalny index
        MOV     BYTE PTR[BX], 127       ;vloz tam 127
        MOV     BX, OFFSET INDEX2       ;ukaz na hodnotu v INDEX2
        MOV     AX, [BX]                ;daj ju do AX
        MOV     CL, 2                   ;do CL 2
        DIV     CL                      ;vydel AX dvomi
        XOR     AH, AH                  ;nuluj AH register
        CMP     AX, POCET               ;porovnaj AX s POCET
        JNE     USPOR                   ;ak sa nerovnaju, znova


USPOR1: MOV     CX, POCET

USP1:   MOV     BX, OFFSET INDEX3       ;ukaz na index
        MOV     AX, [BX]                ;daj ho do AX
        MOV     BX, OFFSET VYSTUP       ;ukaz na hodnotu
        ADD     BX, AX                  ;ukaz na nase cislo
        MOV     DL, [BX]                ;nase cislo do DL

        MOV     BX, OFFSET INDEX3       ;ukaz na index
        MOV     AX, [BX]                ;jeho hodnotu do AX
        MOV     DH, 2                   
        DIV     DH                      ;vydel ju dvoma
        XOR     AH, AH
        ADD     AX, 1                   ;pripocitaj k nej 1
        MOV     DH, 4
        MUL     DH                      ;vynasob styrmi

        MOV     BX, OFFSET VYSTUP2
        ADD     BX, AX                  ;ukaz na prisluchajucu adresu

        MOV     AL, DL                  ;do AL nase cislo
        XOR     AH, AH

        MOV     DL, 10                  ;bude sa delit 10
US:     DIV     DL
        ADD     AH, '0'                 ;korekcia o ASCII
        MOV     [BX], AH                ;daj do retazca
        XOR     AH, AH                  ;nuluj AH
        DEC     BX                      ;dekrementuj BX
        CMP     AL, 0                   ;porovnaj AL s nulou
        JNE     US                      ;ak AL=0 pokracuj

        MOV     BX, OFFSET INDEX3
        MOV     AX, [BX]
        ADD     AX, 2                   ;inkrementacia indexu
        MOV     [BX], AX                ;zapis indexu
        LOOPNE  USP1
        RET

        ;MOV     AX, 0C08H
        ;INT     21H
          
CODE    ENDS
        END     START
