;Zadanie c.1.
;Text zadania:
;Napte program, ktor nata z klvesnice reazec znakov (max.100 znakov)
;a poda ponkanho menu vykon  jednu z monost:
;a) vype reazec znakov na obrazovku
;b) vype poradov slo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukon vykonvanie programu.

;Autor:  Juraj Malcho, B-11
;Termin odovzdania: 24.10.2000
;2.ro., k.rok 2000/2001

.MODEL SMALL
.STACK 100
.DATA
	INFO	DB	'Napis text (maximalne 100 znakov):',0AH,0DH,24H
	MENUS	DB	'V...Vypis retazca znakov',0DH,0AH
		DB	'S...Hladanie medzery v stringu',0DH,0AH
		DB	'H...Hladanie znaku v retazci',0DH,0AH
		DB	'M...Hladanie znaku s maximalnou hodnotou ASCII',0DH,0AH
		DB	'L...Zarovnanie textu zlava',0DH,0AH
		DB	'I...Obratene poradie',0DH,0AH
		DB	'K...Koniec',0DH,0AH,24H
	VSTUP	DB	100
	POCET	DB	0
	DATAST	DB	100 DUP(20H)
	NR	DB	0AH
		DB	0DH
	VYSTUP	DB	103 DUP(?)
	NOSPC	DB	'V stringu nie je medzera...$'
        ZADAJZNAK DB	'Zadaj znak: $'
        MEDZERA	DB	'Prva medzera je na mieste $'
        HLZNAK1	DB	0AH,0DH,'Hladany znak sa vyskytuje $'
        HLZNAK2	DB	'-krat.$',0AH,0DH
        MAXHOD	DB	'Znak s maximalnou ASCII hodnotou je $'

.CODE
;******************************************************************************

START:
;	*** VYPIS VYZVY NA VSTUP ***
	CALL	CLS			; VYMAZANIE OBRAZOVKY
	MOV	AX, SEG INFO
	MOV	DS, AX
        MOV	ES, AX                  ; NASTAVENIE DS A ES
	MOV 	DX, OFFSET INFO         ; NASTAVENIE DX NA STRING INFO
	MOV	AH, 09H			; VYPIS STRINGU
	INT	21H			; VOLANIE SLUZBY
;	*** CAKANIE NA VSTUPNY RETAZEC ***
	MOV	DX, OFFSET VSTUP	; NASTAVENIE DS:DX=DATA:VSTUP
	MOV	AH, 0AH			; CAKANIE NA STRING
	INT	21H			; VOLANIE SLUZBY

MENU:
; 	*** VYPIS HLAVNEHO MENU ***
	CALL	CLS			; VYMAZANIE OBRAZOVKY
	MOV	DX, OFFSET MENUS	; NASTAVENIE OFFSETU DO DX
	MOV	AH, 09H			; VYPIS MENU
	INT	21H			; VOLANIE OBSLUHY
CITAJZNAK:
;	*** VSTUP VOLBY & HANDLING ***
	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 'V'			; POROVNAVANIE VSTUPOV
	JE	@VYPIS                  ; A SKOK NA PRISLUSNU OBSLUHU
	CMP	AL, 'S'                 ; ...
	JE	@SPACE                  ; ...
	CMP	AL, 'H'                 ; ...
	JE	@HLADANIE               ; ...
	CMP	AL, 'M'                 ; ...
	JE	@MAXVALUE               ; ...
	CMP	AL, 'L'                 ; ...
	JE	@JUSTLEFT               ; ...
	CMP	AL, 'I'                 ; ...
	JE	@INVERT                 ; ...
	CMP	AL, 'K'                 ; ...
	JE	@KONIEC                 ; ...
	JMP	CITAJZNAK	; AK ANI JEDNO NEVYHOVUJE, NAVRAT NA CITAJZNAK
        			; A CITANIE DALSEJ KLAVESY
@VYPIS:                    	; PODLA STLACENEJ KLAVESY
	CALL	VYPIS           ; VOLANIE PRISLUSNEJ PROCEDURY -
        JMP	MENU		; - JE TO KVOLI OBIDENIU OBMEDZENIA
				; DLZKY SKOKU +127, -128
@SPACE:
	CALL	SPACE
        JMP	MENU

@HLADANIE:
	CALL	HLADANIE
        JMP	MENU

@MAXVALUE:
     	CALL	MAXVALUE
        JMP	MENU

@JUSTLEFT:
	CALL	JUSTLEFT
        JMP	MENU

@INVERT:
	CALL	INVERT
        JMP	MENU

@KONIEC:
;	*** KONIEC PROGRAMU ***
	MOV	AH, 4CH		; UKONCI S LUBOVOLNYM EXIT CODE
        INT	21H		; VOLANIE OBSLUHY
;******************************************************************************

;**************************** IMPLEMENTACIE PROCEDUR **************************

;****** MAZANIE OBRAZOVKY *****************************************************
PROC	CLS
	;*** MAZANIE
       	MOV	AX, 0600H	; SLUZBA 6-SCROLL OBRAZOVKY;
        MOV	CH, 0		; LAVY HORNY OKRAJ - RIADKY
        MOV	CL, 0           ; LAVY HRONY OKRAJ - STLPCE
        MOV	DH, 24		; PRAVY DOLNY OKRAJ - RIADKY
        MOV	DL, 80          ; PRAVY DOLNY OKRAJ - STLPCE
	MOV	BH, 7           ; NASTAVENIE ATRIBUTU-CIERNE POZADIE+BIELE PISMO
        INT	10H		; VOLANIE SLUZBY BIOSU
        ;*** NASTAVENIE KURZORA NA [0,0]
        MOV	AH, 02          ; SLUZBA 2-NASTAVENIE POZICIE KURZORA
        MOV	DX, 0000H	; [0,0]
        MOV     BH, 0		; VIDEOSTRANKA 0 - IMPLICITNA
        INT	10H		; VOLANIE SLUZBY BIOSU
	RET
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA VYPISE NA OBRAZOVKU ZADANY RETAZEC *******************
PROC 	VYPIS
	MOV	SI, OFFSET DATAST	; SI <- UKAZATEL NA ZACIATOK DAT
	XOR	CH, CH
	MOV	CL, [POCET]             ; CX=POCET ZNAKOV NACITANEHO STRINGU
        MOV	AH, 2			; SLUZBA 2 - VYPIS ZNAKU
@LOOPV:
        MOV	DL, byte ptr [SI] 	; NASTAVENIE NA AKTUALNY ZNAK
        INT	21H			; VOLANIE SLUZBY
   	INC	SI			; POSUN INDEXU VSTUPU
   	LOOP	@LOOPV			; CEZ VSETKY ZNAKY...
   @V1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@V1			; OPAKUJ AZ PO <ENTER>
        RET                             ; NAVRAT
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA ZISTI PORADOVE CISLO PRVEJ MEDZERY *******************
PROC 	SPACE
	MOV	BX, OFFSET DATAST	; NASTAVENIE BX NA ZACIATOK STRINGU
        XOR	CH, CH
	MOV	CL, [POCET]		; CX=POCET ZNAKOV
	XOR	AX, AX                  ; NULOVANIE POCITADLA
  @SPR:					; PREHLADANIE STRINGU
        INC	AX                      ; INKREMENTUJ POCITADLO - POZICIA
        AAA                             ; RATAJ PRIAMO V UNPACKED BCD
	CMP	byte ptr [BX], 20H	; JE MEDZERA?
	JZ	@SVYSTUP		; AK ANO => VYSTUP
	INC	BX			; INAK INKREMENTUJ BX => DALSI ZNAK
	LOOPNZ	@SPR	  		; OPAKUJ AZ PO CX=NULA

@SVYSTUP:				; VYSTUP PODPROGRAMU
	CMP	CX, 0			; AK SA NENASLA MEDZERA =>
	JZ	@NOSPACE		; PRISLUSNY VYSTUP - @NOSPACE

        PUSH	AX                      ; ULOZ AX
        MOV	AH,9                    ; VYPIS UVODNEJ HLASKY
        MOV	DX, OFFSET MEDZERA      ; "MEDZERA JE ..."
        INT	21H
        POP 	AX                      ; VYTIAHNI AX ZO STACKU
        MOV	DH, AL                  ; PRICHYSTANIE PRE VYSTUP 2. CISLICE
        CMP	AH, 0			; AK JE PRVA CISLICA NULOVA
        JZ	@L1			; VYPIS LEN DRUHU
        MOV	DL, AH                  ; PRVA CISLICA NA VYSTUP
        ADD	DL, 30H                 ; KONVERZIA NA ASCII
        MOV	AH, 2			; VYPIS ZNAKU
        INT	21H
   @L1: MOV	DL, DH                  ; VYPIS DRUHEJ CISLICE - PARAMETER
        ADD	DL, 30H			; KONVERZIA NA ASCII
        MOV	AH, 2			; VYPIS ZNAKU
        INT	21H
   @S1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@S1			; OPAKUJ AZ PO <ENTER>
   	RET				; NAVRAT Z PROCEDURY

@NOSPACE:				; AK SA NENASLA MEDZERA
	MOV	DX, OFFSET NOSPC	; DO DX OFFSET NA "NENAJDENA MEDZERA..."
	MOV	AH,9H			; DISPLAY STRING
	INT	21H			; VOLANIE OBLUHY
   @S2:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@S2			; OPAKUJ AZ PO <ENTER>
	RET				; NAVRAT
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA VYHLADAVA V STRINGU DANY ZNAK ************************
PROC 	HLADANIE
        MOV	DX, OFFSET ZADAJZNAK	; DX=OFFSET NA STRING ZADAJZNAK
        MOV	AH,9                    ; VYPIS STRINGU
        INT	21H
	MOV	AH,01H			; CITANIE ZNAKU, KTORY SA BUDE HLADAT
        INT	21H                     ; V AL JE HLADANY ZNAK
        MOV	DL, AL			; HLADANY ZNAK DO DL
        MOV	BX, OFFSET DATAST	; DO BX OFFSET NA STRING
        XOR	CH, CH
        MOV	CL, [POCET] 		; CX=POCET ZNAKOV
        XOR	AX, AX			; AX=0 - POCITADLO ZNAKOV

@HPREHL:
	CMP     byte ptr [BX], DL	; ZNAK V STRINGU = HLADANY ZNAK?
        JNZ	@INYZNAK		; AK NIE JE => @INYZNAK
        INC	AX                      ; O JEDEN NAJDENY ZNAK VIAC
        AAA				; RATAJ ROVNO V UNPACKED BCD
@INYZNAK:
	INC	BX                      ; POSUN SA V STRINGU O 1
        LOOPNZ	@HPREHL 		; A ZNOVA SA VRAT NA @HPREHL
;	*** SPRACOVANIE VYSLEDKU ***
        PUSH	AX                      ; UCHOVANIE SI POCTU (BCD)
        MOV	AH,9                    ; VYPIS TEXTU
        MOV	DX, OFFSET HLZNAK1      ; NA VYSTUPE - "HLADANY ZNAK..."
        INT	21H
        POP 	AX                      ; VYBERIEM HODNOTU AX NA SPRACOVANIE
        PUSH	AX			; ALE ESTE JU BUDEM POTREBOVAT
        MOV	DH, AL                  ; PRICHYSTANIE PRE VYSTUP 2. CISLICE
        CMP	AH, 0			; AK JE PRVA CISLICA NULOVA
        JZ	@L2			; VYPIS LEN DRUHU
        MOV	DL, AH                  ; PRVA CISLICA NA VYSTUP
        ADD	DL, 30H                 ; KONVERZIA NA ASCII
        MOV	AH, 2			; VYPIS ZNAKU
        INT	21H
   @L2: MOV	DL, DH                  ; VYPIS DRUHEJ CISLICE - PARAMETER
        ADD	DL, 30H			; KONVERZIA NA ASCII
        MOV	AH, 2			; VYPIS 2. CIFRY
        INT	21H
	MOV	DX, OFFSET HLZNAK2	; ZVYSOK TEXTU...
        MOV	AH, 9			; VYPIS STRINGU
        INT	21H

;	*** ZAPIS BCD CISLA DO CX ***
        POP	AX                      ; VYBERIEM AX
        AAD             		; AX=10*AH+AL
	MOV	CX, AX                  ; ULOZ DO CX
   @H1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@H1			; OPAKUJ AZ PO <ENTER>
        RET                             ; NAVRAT
  		; AX=([0000XXXX],[0000XXXX]) ==>
		; AX=([XXXXXXXX],[--------])
		; 0: NULY; X: BITY, KTORE MA ZAUJIMAJU; -: LUBOVOLNA HODNOTA
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA ZISTI ZNAK S MAXIMALNOU ASCII HODNOTOU ***************
PROC 	MAXVALUE
        MOV	BX, OFFSET DATAST
        XOR	CH, CH     		; NASTAVENIE
        MOV	CL, [POCET]             ; POCITADLA NA POCET ZNAKOV STRINGU
        XOR	DL, DL			; MAXIMALNA HODNOTA NULA
@LOOP1:
        CMP	[BX], DL       	; POROVNAJ AKTUALNY ZNAK S NAJVYSSIM
        JL	@L3			; AK JE MENSI TAK --> @L3
        MOV	DL, [BX]		; NAJVACSI=AKTUALNY
   @L3: INC	BX                      ; PRESUN SA NA DALSI ZNAK
   	LOOPNZ	@LOOP1			; CEZ VSETKY ZNAKY...
;	*** VYSTUP ***
        PUSH	DX                      ; SAVENI DX
        MOV	AH, 9                   ; VYPIS STRINGU
        MOV	DX, OFFSET MAXHOD       ; "MAX. HODNOTA JE..."
        INT	21H
        POP	DX			; LOADNI DX
        MOV	AH, 2			; VYPIS ZNAKU; HODNOTA UZ JE V DL
        INT	21H
   @M1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@M1			; OPAKUJ AZ PO <ENTER>
	RET 				; NAVRAT
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA ODSTRANI VSETKY PREBYTOCNE MEDZERY VLAVO OD ZNAKOV ***
PROC    JUSTLEFT
        MOV	SI, OFFSET DATAST	; DO SI - VSTUPNY STRING
        XOR	CH, CH                  ; NASTAVENIE POCITADLA
        MOV	CL, [POCET]             ; CX=POCET
        MOV     BL, 1			; INDIKACIA, ZE PREHLADAVANE MEDZERY SU
        				; NA ZACIATKU STRINGU
@LOOP2:
	CMP	byte ptr [SI], 20H      ; JE MEDZERA?
        JZ	@MZ                     ; AK ANO, SKOC NA @MZ
        MOV	BL, 0			; UZ TO NEBUDE PRVA MEDZERA
        MOV	AH, 2                   ; VYPIS ZNAKU
        MOV	DL, byte ptr [SI] 	; NASTAVENIE NA AKTUALNY ZNAK
        INT	21H			; VOLANIE SLUZBY
   @J0:	INC	SI			; POSUN INDEXU VSTUPU
	CMP	CL, 0			; UZ SA PREBEHLI VSETKY ZNAKY?
   	LOOPNZ	@LOOP2			; AK NIE, SKOK SPAET...
        JMP	@J1			; KONIEC PROCEDURY
   @MZ: CMP	BL, 1			; JE MEDZERA PRED OSTATNYMI ZNAKMI?
	JZ	@L5			; POTOM JU NEVYPIS
        MOV	AH, 2                   ; VYPIS ZNAKU
        MOV	DL, 20H			; VYPIS MEDZERU
        INT	21H			; VOLANIE SLUZBY
   @L5: JMP	@J0			; POKRACUJ DALEJ

   @J1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@J1			; OPAKUJ AZ PO <ENTER>
	RET                             ; NAVRAT
ENDP
;******************************************************************************

;******	PROCEDURA, KTORA ZINVERTUJE PORADIE ZNAKOV V STRINGU ******************
PROC 	INVERT
        MOV	SI, OFFSET DATAST	; DO SI - VSTUPNY STRING
        XOR	CH, CH                  ; NASTAVENIE POCITADLA
        MOV	CL, [POCET]             ; CX=POCET
	ADD	SI, CX                  ; SI DAME NA KONIEC VSTUPU
        DEC	SI                      ; KOREKCIA (1.PRVOK JE NULTY)
        MOV	AH, 2			; SLUZBA 2 - VYPIS ZNAKU
@LOOP3:
	MOV	DL, byte ptr [SI]       ; DO DL ZNAK - VYSTUP
	INT	21H			; VYPIS ZNAKU
        DEC	SI                      ; ZDROJ SA BLIZI K ZACIATKU
        LOOP	@LOOP3                  ; CEZ VSETKY ZNAKY...
   @I1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@I1			; OPAKUJ AZ PO <ENTER>
	RET                             ; NAVRAT
ENDP
;******************************************************************************

END	START

;Program je plne funkn.
;Programov vybavenie: Borland C++ 5.0; Turbo Debugger; na kompilciu je
;potrebn Turbo assembler a linker
;Technick vybavenie: P133, 32MB, 1.6GB HDD, Win98
;Obmedzenie: vstupn daje nesm by Extended ASCII; znak $ je oetren
;Pouit sluby:21h	Dos Functions
;			01H Keyboard Input
;			02H Display Character
;			08H No Echo Console Input
;			09H Display String
;			0aH Buffered Input
;		10h	BIOS Video Services
;			06H scroll window up (or clear window)
;Mon vylepenia: 	vpis znakov blokovo priamo na VideoRAM; volanie cyklu
;			pre 1 znak je zbytone pomal a zaber vea miesta v pamti
;Algoritmy:
;Hadanie medzery: Cyklus cez vetky znaky; ak sa njde medzera, z cyklu sa
;vysko a vype sa jej poradov miesto (uchovva sa v tvare BCD). Ak sa
;medzera nenala, vype sa prslun hlka.
;Zisovanie potu vskytov znaku: Cyklus cez vetky znaky; ak sa njde dan znak,
;inkrementuje sa potadlo (v BCD); po skonen cyklu je v potadle poet
;vskytov => vstup & zpis do CX registra
;Zisovanie maximlnej ASCII hodnoty: Cyklus cez vetky znaky; porovnanie
;aktulneho znaku so zatia maximlnou hodnotou (na zaiatku 0); ak je via,
;zape sa do maxima; po prebehnut cyklu vstup
;Zarovnanie vavo: Cyklus cez vetky znaky; ak sa njde medzera, zist,
;i je naavo od ostatnych znakov; ak no, nevype ju; v opanom prpade
;sa vype kad znak
;Zinvertovanie poradia znakov: Cyklus cez vetky znaky odzadu, priom kad
;natan znak sa hne aj vype na obrazovku
