;ZADANIE c.2
;Vytvorte  program,  ktor  nata  z  textovho sboru postupnost celch sel
;(aspon 10) so znamienkom  v desiatkovej selnej sstave,
;potom ich transformuje na sla v dvojkovej cselnej sstave
;v doplnkovom kde a potom podla priania pouvatea
;a) vypota sumu  vetkych csel a vypise ju
;b) usporiada csla vzostupne a zape usporiadan postupnost csel
;   do novho textovho sboru,
;c) vydel dve vybran csla a vype vsledok
;d) vynsob dve sla a vype vsledok
;e) ukon vykonvanie programu.

;Autor:  Juraj Malcho, B-11
;Termin odovzdania: 14.11.2000
;2.ro., k.rok 2000/2001

.MODEL SMALL
.STACK 100
.DATA
	MENUS	DB	'Vyber si jednu z moznosti:',0AH,0DH
		DB	'a...Suma vsetkych cisel',0DH,0AH
		DB	'b...Usporiadanie cisel vzostupne a zapis do suboru',0DH,0AH
		DB	'c...Vydelenie dvoch vybranych cisel',0DH,0AH
		DB	'd...Vynasobenie dvoch cisel',0DH,0AH
		DB	'e...Koniec programu',0DH,0AH,24H

	FIN	DB	'CISLA.IN',0
        FOUT	DB	'CISLA.OUT',0
       	DUMP	DB 	101 DUP(?)	; MAXIMALNA VELKOST VSTUP. SUBORA JE 100
        DCIS	DB      10 DUP(?)
        DCISS	DB	10 DUP(?)
        SORT	DB	100 DUP(?)
        ERRSTR	DB	0DH,0AH,'Nastalo pretecenie rozsahu pocas vypoctu!',0DH,0AH,24H
        SUMAS	DB	'Suma vsetkych cisel je: $'
        VYBERC	DB	'Vyber cisla (delenec, delitel (poradie vo vypise)): $'
        DIVR	DB	0DH,0AH,'Vysledok delenia je: $'
        DIVZ	DB	0DH,0AH,'Pocas delenia doslo k preteceniu rozsahu!$'
        NVYS	DB      0DH,0AH,'Vysledok nasobenia je: $'
.CODE

;**************************** IMPLEMENTACIE PROCEDUR **************************

;****** CITANIE SUBORU + KONVERZIA ********************************************
PROC	READFILE
        MOV	AH, 3DH			; OTVOR SUBOR
	MOV	AL, 0			; READING MODE
        MOV	DX, OFFSET FIN	        ; SUBOR=CISLA.IN
        INT	21H

        MOV	DX, OFFSET DUMP         ; NASTAV DS:DX NA ADRESU DUMPU
        MOV	CX, 1			; PO JEDNOM ZNAKU
        MOV	BX, AX			; SET HANDLE...

@CITAJ:	MOV	AH, 3FH			; CITAJ SUBOR
	INT	21H			; VOLANIE SLUZBY
        INC	DX                      ; POSUN SA V DUMPE
	CMP	AX, 0                   ; KONIEC SUBORA?
        JNZ	@CITAJ                  ; AK NIE, CITAJ DALSI ZNAK
	MOV	BX, DX                  ; NA
        DEC	BX                      ;    KONIEC DUMPU
        MOV	byte ptr [BX], 0        ;                 DAJ NULU

        MOV	SI, OFFSET DUMP		; SI NA ZACIATOK DAT
        DEC	SI			; KOREKCIA KVOLI ALGORITMU
        MOV	DI, OFFSET DCIS		; DI NA BUFFER UZ KONVERTOVANYCH CISEL
        MOV	CX, 10                  ; CITAJ 10 CISEL

 @RCISL:        ; ******** CITAJ DALSIE CISLO
        XOR	BX, BX			; NULOVANIE PRIZNAKU ZAPORNEHO CISLA A
        				; POCTU CISLIC
	XOR	DL, DL			; PRIZNAK, CI UZ CITAL CISLA
        PUSH	CX                      ; ULOZ DO STACKU CX
 @RZNAK:	; ******** CITAJ DALSI ZNAK
	INC	SI			; DALSI ZNAK ZO VSTUPNEHO BUFFERA
        CMP     byte ptr [SI], 2DH	; JE TO '-'?
        JZ	@CMIN			; AK ANO, SKOC NA CMIN
   	CMP	byte ptr [SI], 30H      ; AK JE MENSI AKO '0'
        JB      @RZNAK0                 ; CITAJ DALSI
   	CMP	byte ptr [SI], 39H      ; AK JE VACSI AKO '9'
        JA      @RZNAK0                 ; CITAJ DALSI

        PUSH	[SI]			; ULOZ CIFRU DO STACKU
        INC	BH			; POCET CIFIER+=1
        MOV	DL, 1			; PRIZNAK, ZE UZ CITAL CISLA
        JMP	@RZNAK			; CITAJ DALSI ZNAK

       @RZNAK0: CMP	DL, 1		; AK UZ CITAL NEJAKU CIFRU
       		JZ	@CKONV		; TAK UZ NECITAJ DALSIE ZNAKY
                JMP	@RZNAK		; INAK CITAJ DALSI ZNAK

       @CMIN: 	MOV	BL, 1		; NASTAV PRIZNAK
        	JMP	@RZNAK		; CITAJ DALSI ZNAK

@CKONV:		; ******** KONVERTOVANIE CISLA V STACKU
   	POP	AX			; VYTIAHNI POSLEDNU CIFRU
        SUB	AX, 30H			; KOREKCIA Z ASCII NA CISLA
    	MOV	DX, AX			; PRESUN JEDNOTKY DO DX

   	CMP	BH, 2			; NACITAL 2 CIFRY?
    	JB	@C1			; AK NIE, PRESKOC
        POP	AX			; VYBER DRUHU CIFRU
        SUB	AX, 30H			; KOREKCIA Z ASCII NA CISLA
        MOV	CL, 10			; NASOBIM:
        MUL	CL			; AX=10*(2.CIFRA)
        ADD	DX, AX			; AX PRIPOCITAJ K DX

        CMP	BH, 3			; NACITAL 3 CIFRY?
        JB	@C1			; AK NIE, PRESKOC
        POP	AX			; VYBER PRVU CIFRU
        SUB	AX, 30H			; KOREKCIA Z ASCII NA CISLA
   	MOV	CL, 100			; NASOBIM:
        MUL	CL			; 100*(1.CIFRA)->AX
        MOV	DX, AX			; ULOZ MEDZIVYSLEDOK DO DX

   @C1: CMP	BL, 1			; BOL TAM MINUS
        JZ	@CKMIN			; KOREKCIA NA MINUS

   @CR: MOV	byte ptr [DI], DL	; ULOZ OBSAH DO VYSTUP. BUFFERA
   	INC	DI			; INKREMENT. POINTER NA VYSTUP
        POP	CX			; VYBER ZO STACKU CX
        LOOP	@RCISL			; OPAKUJ CEZ VSETKY CISLA (10)
        RET 				; SKONCI PROCEDURU

        @CKMIN:
            	NEG	DL		; NEGUJ CIFRU
                JMP	@CR		; VRAT SA
ENDP
;******************************************************************************

;****** PROCEDURA OSETRUJUCA CHYBU ********************************************
PROC	CHYBA
	MOV	DX, OFFSET ERRSTR	; NASTAVENIE DS:DX NA ERRSTR
        MOV	AH, 9			; SLUZBA 9 - VYPIS STRINGU
        INT	21H                     ; VOLANIE OBSLUHY
	RET				; NAVRAT SPAET
ENDP
;******************************************************************************

;****** MAZANIE OBRAZOVKY *****************************************************
PROC	CLS
	MOV	AX, 3			; SLUZBA 0, VIDEOMOD 3
        INT	10H			; VIDEOSERVICE
	RET
ENDP
;******************************************************************************

;****** VYPIS CISLA ***********************************************************
PROC	DISPNUM
        POP	BX			; VYBERIEM UKAZATEL SPAET
        POP	AX                      ; VYBERIEM AX
        PUSH	BX                      ; ULOZIM UKAZATEL SPAET
        PUSH	AX			; ULOZIM AX

        AND	AL, 80H			; JE ZAPORNE?
        CMP     AL, 80H			;
        JZ	@VM                     ; POTOM VYPIS '-'
   @V1: POP	AX			; VYBERIEM CISLO
	XOR	AH, AH			; NULUJ AH
	MOV	BL, 100			; PREDELIM 100
        DIV	BL			; AH=ZVYSOK, AL=AX/BL

        CMP	AL, 0			; AK JE PRVA CIFRA NULA
        JZ	@V2			; PRESKOC
        PUSH	AX			; ULOZ AX
        MOV	AL, AH			; ZVYSOK PO DELENI DO AL
        MOV	AH, 2			; INAK VYPIS ZNAKU
        MOV	DL, 31H			; '1'
        INT	21H                     ; VOLANIE OBSLUHY
        POP	AX			; VYBER AX
   @V2: MOV	AL, AH			; ZVYSOK PO DELENI DO AL
   	XOR	AH, AH			; AH=0 => AX=AL
        AAM				; AH=AL/10, AL=AL MOD 10

        MOV	DH, AL			; PRIPRAVA NA VYSTUP
        MOV	DL, AH			; -||-
        MOV	AH, 2			; SLUZBA 2 - VYPIS ZNAKU
;      	 CMP	DL, 0			; JE PRVA CIFRA NULOVA?
;        JZ	@V3			; AK ANO => SKOK
        ADD	DL, 30H			; KOREKCIA
        INT	21H                     ; VOLANIE OBSLUHY
   @V3: MOV	DL, DH			; NA VYSTUP DRUHA CIFRA
   	ADD	DL, 30H                 ; KOREKCIA
        INT	21H			; VOLANIE OBSLUHY - SLUZBA 2
        RET

   @VM: POP	AX			; VYBERIEM CISLO
   	NEG	AL			; ZNEGUJEM HO
        PUSH 	AX			; ULOZIM HO A NARABAM S NIM AKO S KLADNYM
   	MOV	AH, 2                   ; DISPLAY CHARACTER
   	MOV	DL, 2DH			; DL='-'
        INT	21H			; VOLANIE OBSLUHY
        JMP	@V1			; VRAT SA
ENDP
;******************************************************************************

;****** VYPIS A VYBER CISEL ***************************************************
PROC	PICKNUMS
	MOV	BX, OFFSET DCIS		; NASTAV OFFSET NA ZDROJ
	NOP				; KVOLI CHYBE INTERPRETRA
        MOV	CX, 10			; CEZ VSETKY CISLA
        XOR	SI, SI			; NULUJ SI
   @D1: MOV	AL, byte ptr [BX][SI]   ; DO AX ZDROJ
        PUSH	BX			; ULOZ BASE
        PUSH	SI			; AJ SI
   	PUSH	AX			; VYPIS OBSAH AX
        CALL	DISPNUM                 ; NA OBRAZOVKU
	POP	SI			; VYBER SI
        POP	BX			; AJ BASE
        MOV	DL, 20H			; VYPIS MEDZERU
        MOV	AH, 2			; VYPIS ZNAKU
        INT	21H			; VOLANIE OBSLUHY
        INC	SI			; POSUN SA DALEJ
        LOOP	@D1			; CEZ VSETKY ZNAKY
        MOV	AH, 2			; VYPIS ZNAKU
        MOV	DL, 0AH			; VYPIS LF
        INT	21H			; VOLANIE OBSLUHY
        MOV	DL, 0DH			; VYPIS CR
        INT	21H			; VOLANIE OBSLUHY

        MOV	DX, OFFSET VYBERC	; NASTAV VYPIS HLASKY
        MOV	AH, 9			; VYPIS STRINGU
        INT	21H			; VOLANIE OBSLUHY
	POP	BX			; VYBER NAVRATOVU ADRESU
        MOV     AH, 1			; FETCH CHARACTER
        INT	21H			; VOLANIE OBSLUHY
	SUB     AL, 30H			; KOREKCIA NA CISLO
        PUSH	AX			; ULOZ DELENCA
        MOV	AH, 2			; VYPIS CHARACTER
        MOV	DL, 20H			; MEDZERA
        INT	21H
        MOV     AH, 1			; FETCH CHARACTER
        INT	21H			; VOLANIE OBSLUHY
	SUB     AL, 30H			; KOREKCIA NA CISLO
        PUSH	AX			; ULOZ DELITELA
        PUSH	BX			; ULOZ NAVRATOVU ADRESU
	RET
ENDP
;******************************************************************************

;****** SUMA VSETKYCH CISEL ***************************************************
PROC	SUMA
	MOV	CX, 9			; SCITAVAM 10 CISEL- 1.UZ INICIALIZOVANE
        MOV	SI, OFFSET DCIS		; SI NA CISLA ULOZENE NA DCIS
        XOR	AH, AH
  	MOV	AL, byte ptr [SI]	; PRVE CISLO DAM DO AL
   @S1: INC	SI			; DALSI PRVOK
        MOV	BL, AL                  ; DO BL PRVY OPERAND
        MOV	DL, byte ptr [SI]       ; DO DL DRUHY OPERAND
        XOR	BL, DL			; XORNEM BITY, VYSLEDOK V BL
        AND	BL, 80H			; ZOBERIEM LEN PRVY BIT
        ADD 	AL, byte ptr [SI]	; PRIPOCITAJ K AL DALSIE CISLO
        CMP	BL, 0			; AK MALI OPERANDY ROVNAKE ZNAMIENKO
        JE	@S3			; TAK SKOC
   @S2: LOOP	@S1			; CEZ VSETKY CISLA
        ;*** VYSTUP ***
        PUSH	AX			; ULOZ AX
	MOV	DX, OFFSET SUMAS	; VYPIS "SUMA CISEL JE ..."
        MOV	AH, 9			; VYPIS STRINGU
        INT	21H			; VOLANIE OBSLUHY
        CALL	DISPNUM			; VYPIS SUCET
        JMP	@S5			; KONIEC PROCEDURY

   @S3: MOV	BL, AL                  ; DO BL PRVY OPERAND (SUCET)
        MOV	DL, byte ptr [SI]       ; DO DL DRUHY OPERAND
        XOR	BL, DL			; XORNEM PRVE BITY, VYSLEDOK V BL
        AND	BL, 80H			; ZOBERIEM PRVY BIT
        CMP	BL, 80H			; ZMENILO SA ZNAMIENKO?
        JE      @S4                     ; AK ANO => PRETECENIE
        JMP	@S2			; INAK NORMALNE POKRACUJ

   @S4: CALL	CHYBA			; VOLAJ CHYBU!
   @S5:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@S5			; OPAKUJ AZ PO <ENTER>
        RET
ENDP
;******************************************************************************

;****** BUBBLESORT VZOSTUPNE **************************************************
PROC	BUBBLESORT
   	MOV	AX, SEG MENUS		; NASTAVENIE
        MOV	DS, AX			; SEGMENTU
 	MOV	ES, AX			; AJ ES
	MOV	AX, OFFSET DCIS		; NASTAVENIE
        MOV	SI, AX			; ZDROJA
        MOV	AX, OFFSET DCISS	; NASTAVENIE
        MOV	DI, AX			; VYSTUPU
        MOV	CX, 10			; 10 ZNAKOV
	CLD				; SMEROM HORE
        REP	MOVSB			; PRESUN STARE POLE DO NOVEHO

   	MOV	AX, OFFSET DCISS	; OFFSET NA DUMP HODNOT CISEL - NOVY
        MOV	BX, AX			; DO BX


   @B1:
        XOR	DL, DL			; INDIKATOR VYMENY PRVKOV
        XOR	SI, SI			; PREHLIADAC POLA PRVKOV
   @B2:
        MOV	DH, byte ptr [BX][SI]	; DO DH PRVOK NA ADRESE [SI]
        CMP	byte ptr [BX][SI+1], DH	; A(N+1)<A(N)
        JGE	@B4			; AK PLATI, PRESKOC VYMENU
        MOV	DL, 1			; NASTAV PRIZNAK VYMENY
        XCHG	DH, byte ptr [BX][SI+1]	; VYMEN PRVKY
        MOV	byte ptr [BX][SI], DH	;
   @B4: INC	SI			; POSUN SA O JEDEN PRVOK
        CMP	SI, 9			; CEZ N-1 PRVKOV (10-1=9)
        JNZ	@B2			; AK ESTE NIE JE POSL., ZNOVU
        CMP	DL, 0			; POKIAL NASTALA VYMENA,
        JNZ	@B1			; OPAKUJ

        MOV	AX, OFFSET DCISS	; NASTAV SI NA VSTUPNY BUFFER
        MOV	SI, AX			;
        MOV	AX, OFFSET SORT         ; NASTAV DI NA VYSTUPNY BUFFER
        MOV	DI, AX
        MOV	CX, 10			; NASTAV POCITADLO
        DEC	SI			; KOREKCIA
   @B5: INC	SI			; DALSI PRVOK ZO VSTUPU
   	MOV     AL, byte ptr [SI]	; DO AL HODNOTU ZO VSTUPU
        PUSH	AX			; ULOZ AX
        AND	AL, 80H			; JE ZAPORNE?
        CMP     AL, 80H			;
        JZ	@BVM                    ; POTOM VYPIS '-'
  @BV1: POP	AX			; VYBERIEM CISLO
	XOR	AH, AH			; NULUJ AH
	MOV	BL, 100			; PREDELIM 100
        DIV	BL			; AH=ZVYSOK, AL=AX/BL

        CMP	AL, 0			; AK JE PRVA CIFRA NULA
        JZ	@BV2			; PRESKOC

        MOV	byte ptr [DI], 31H 	; ZAPIS NA VYSTUP '1'
        INC	DI			; POSUN SA NA VYSTUPE
  @BV2: MOV	AL, AH			; ZVYSOK PO DELENI DO AL
   	XOR	AH, AH			; AH=0 => AX=AL
        AAM				; AH=AL/10, AL=AL MOD 10

       	CMP	AH, 0			; JE PRVA CIFRA NULOVA?
        JZ	@BV3			; AK ANO => SKOK
        ADD	AH, 30H			; KOREKCIA
        MOV	byte ptr [DI], AH 	; ZAPIS NA VYSTUP AH
        INC	DI			; POSUN SA NA VYSTUPE
  @BV3: ADD	AL, 30H                 ; KOREKCIA
        MOV	byte ptr [DI], AL 	; ZAPIS NA VYSTUP AL
        INC	DI			; POSUN SA NA VYSTUPE
        MOV	byte ptr [DI], 20H 	; ZAPIS NA VYSTUP MEDZERU
        INC	DI			; POSUN SA NA VYSTUPE
        LOOP	@B5			; CEZ VSETKY CISLA
        JMP	@B6			; SKOC NA B6

  @BVM: POP	AX			; VYBERIEM CISLO
   	NEG	AL			; ZNEGUJEM HO
        PUSH 	AX			; ULOZIM HO A NARABAM S NIM AKO S KLADNYM
        MOV	byte ptr [DI], 2DH 	; '-' NA VYSTUP
        INC	DI			; POSUN SA NA VYSTUPE
        JMP	@BV1			; VRAT SA

  @B6:  MOV 	AH, 3DH			; OPEN FILE
        MOV	AL, 1			; FOR WRITING
        MOV	DX, OFFSET FOUT		; SUBOR 'CISLA.OUT'
        INT	21H			; VOLANIE OBSLUHY

        MOV	BX, AX			; HANDLE NA SUBOR DO BX
	MOV	AH, 40H			; SLUZBA 40H - ZAPIS
        MOV	DX, OFFSET SORT		; BX NA OFFSET VYSTUPU
        SUB	DI, DX			; DO DI POCET ZNAKOV VYSTUPU
        MOV	CX, DI			; POCET ZNAKOV DO CX
        INT     21H			; VOLANIE OBSLUHY
        MOV	AH, 3EH			; CLOSE FILE, V BX JE UZ HANDLE
        INT	21H			; VOLANIE OBSLUHY
	RET                             ; NAVRAT
ENDP
;******************************************************************************

;****** DELENIE DVOCH CISEL ***************************************************
PROC	DELENIE
        CALL	PICKNUMS		; VYBER DVE CISLA
        MOV	BX, OFFSET DCIS		; DO DX OFFSET NA POLE CISEL
        POP	AX			; DELITEL
        XOR	AH, AH			; NULUJ HORNU CAST
        MOV	SI, AX			; DAJ DO SI
        POP	AX			; DELENEC
        XOR	AH, AH			; NULUJ HORNU CAST
        MOV	DI, AX			; DAJ DO DI
        MOV	AL, byte ptr [BX][DI]	; DO AX DELENEC
        MOV	DL, byte ptr [BX][SI]	; DO DX DELITEL
        XOR	AH, AH			; HORNE CASTI
        XOR	DH, DH			; REGISTROV VYNULOVAT

        CMP	DL, 0			; AK JE
        JZ	@DN			; DELITEL NULA => CHYBA!

	PUSH 	AX			; ULOZ AX
        PUSH	DX			; ULOZ DX
        MOV	DX, OFFSET DIVR		; "VYSLEDOK JE"
        MOV	AH, 9			; VYPIS STRINGU
        INT	21H			; VOLANIE OBSLUHY
        POP	DX			; VYBER AX
	POP	AX			; VYBER DX
        XOR	AH, AH			; NULUJ HORNE
        XOR	DH, DH			; CASTI REGISTROV
        XOR	CL, CL			; PRIZNAK ZAP. VYSLEDKU
        CMP	AL, 0			; AL<0?
        JL      @DNA			; POTOM HO ZNEGUJ
 @DNB1: CMP	DL,0			; DL<0?
        JL	@DND			; TAK HO ZNEGUJ
 @DNB2: CMP	AL, DL			; AK JE DELENEC MENSI AKO DELITEL V ABS.
        JB	@D0			; HODNOTE => VYSLEDOK JE NULA
        JMP	@DNB3			; PRESKOC NEGACIE
  @DNA: NEG	AL			; NEGUJ AL
	INC	CL			; ZMEN PRIZNAK VYSLEDKU
  	JMP	@DNB1			; VRAT SA
  @DND:	NEG	DL			; NEGUJ DL
        INC	CL			; ZMEN PRIZNAK VYSLEDKU
  	JMP	@DNB2			; VRAT SA

 @DNB3: CMP	CL, 1			; JE VYSLEDOK ZAPORNY?
 	JE	@DM			; AK ANO, SKOC

 @DNB4:	DIV	DL			; DEL AX/DL
        PUSH	AX			; ULOZ AX AKO PARAMETER PROCEDURY
        CALL	DISPNUM			; VYPIS VYSLEDOK
        JMP	@D3			; SKOC NA @D3

   @DM: PUSH	AX			; ULOZ AX
 	PUSH	DX			; ULOZ DX
        MOV	AH, 2			; VYPIS ZNAKU
        MOV	DL, '-'			; ZAP. CISLO
        INT	21H			; VOLANIE OBSLUHY
        POP	DX			; VYBERIEM DX
        POP	AX			; VYBERIEM AX
 	JMP	@DNB4			; SPAT

   @D0:	MOV	DL, 30H			; DO DL "0"
        MOV	AH, 2			; VYPIS ZNAKU
        INT	21H			; VOLANIE OBSLUHY
   @D3: MOV	AH, 2			; VYPIS ZNAKU
        MOV	DL, '.'			; KONIEC HLASKY - BODKA ZA VETOU
        INT	21H			; VOLANIE OBSLUHY
        JMP	@D5			; SKOC NA KONIEC

   @DN: MOV	DX, OFFSET DIVZ		; "DELENIE NULOU"
   	MOV	AH, 9                   ; VYPIS STRINGU
        INT	21H			; VOLANIE SLUZBY

   @D5:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@D5			; OPAKUJ AZ PO <ENTER>
	RET
ENDP
;******************************************************************************

;****** NASOBENIE DVOCH CISEL *************************************************
PROC	NASOBENIE
        CALL	PICKNUMS		; VYBER DVE CISLA
        POP	AX			; PRVY CINITEL
        XOR	AH, AH			; NULUJ HORNU CAST
        MOV	SI, AX			; DAJ DO SI
        POP	AX			; DRUHY CINITEL
        XOR	AH, AH			; NULUJ HORNU CAST
        MOV	DI, AX			; DAJ DO DI
        MOV	BX, OFFSET DCIS		; DO DX OFFSET NA POLE CISEL
        MOV	AL, byte ptr [BX][DI]	; DO AX PRVY CINITEL
        MOV	DL, byte ptr [BX][SI]	; DO DX DRUHY
        XOR	AH, AH			; HORNE CASTI
        XOR	DH, DH			; REGISTROV VYNULOVAT

        IMUL	DL			; NASOB AL*DL->AX
        CMP	AX, 127			; AK AX>127
        JG	@NERR			; TAK NASTALO PRETECENIE
        CMP	AX, -128		; AK AX<-128
        JL	@NERR			; TAK NASTALO PRETECENIE
        PUSH	AX			; ULOZ AX
        MOV	AH, 9			; VYPIS STRINGU
        MOV	DX, OFFSET NVYS		; "VYSLEDOK NASOBENIA..."
        INT	21H			; VOLANIE OBSLUHY
        POP	AX			; VYBER AX
        PUSH 	AX			; ODOVZDAJ AX AKO PARAMETER
        CALL	DISPNUM			; VYPIS CISLO
        MOV	AH, 2			; VYPIS ZNAKU
        MOV	DL, '.'			; KONIEC VETY
        INT	21H			; VOLANIE OBSLUHY
        JMP	@N1			; PRESKOC CHYBU

 @NERR: MOV	DX, OFFSET ERRSTR	; "NASTALA CHYBA"
 	MOV	AH, 9			; VYPIS STRINGU
        INT	21H			; VOLANIE OBSLUHY

   @N1:	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 0DH			; POROVNAVANIE VSTUPOV
        JNZ	@N1			; OPAKUJ AZ PO <ENTER>

	RET
ENDP
;******************************************************************************

START:

 	MOV	AX, SEG MENUS		; NASTAVENIE DS
        MOV	DS, AX			; NA DATOVY SEGMENT
        CALL	READFILE		; NACITAJ DATA ZO SUBORA CISLA.IN
MENU:
; 	*** VYPIS HLAVNEHO MENU ***
	CALL	CLS			; VYMAZANIE OBRAZOVKY
	MOV	DX, OFFSET MENUS	; NASTAVENIE OFFSETU DO DX
	MOV	AH, 09H			; VYPIS MENU
	INT	21H			; VOLANIE OBSLUHY
CITAJZNAK:
;	*** VSTUP VOLBY & HANDLING ***
	MOV	AH, 08H			; CAKANIE NA 1 ZNAK
	INT	21H			; VOLANIE SLUZBY
	CMP	AL, 'a'			; POROVNAVANIE VSTUPOV
	JE	@SUMA                   ; A SKOK NA PRISLUSNU OBSLUHU
	CMP	AL, 'b'                 ; ...
	JE	@BUBBLE                 ; ...
	CMP	AL, 'c'                 ; ...
	JE	@DELENIE                ; ...
	CMP	AL, 'd'                 ; ...
	JE	@NASOBENIE              ; ...
	CMP	AL, 'e'                 ; ...
	JE	@KONIEC                 ; ...
	JMP	CITAJZNAK	; AK ANI JEDNO NEVYHOVUJE, NAVRAT NA CITAJZNAK
        			; A CITANIE DALSEJ KLAVESY
@SUMA:                    	; PODLA STLACENEJ KLAVESY
	CALL	SUMA            ; VOLANIE PRISLUSNEJ PROCEDURY -
        JMP	MENU		; - JE TO KVOLI OBIDENIU OBMEDZENIA
				; DLZKY SKOKU +127, -128
@BUBBLE:
	CALL	BUBBLESORT
        JMP	MENU

@DELENIE:
	CALL	DELENIE
        JMP	MENU

@NASOBENIE:
     	CALL	NASOBENIE
        JMP	MENU

@KONIEC:
;	*** KONIEC PROGRAMU ***
	MOV	AH, 4CH		; UKONCI S LUBOVOLNYM EXIT CODE
        INT	21H		; VOLANIE OBSLUHY
;******************************************************************************
END	START

;Program nie je plne funkn.
;Programov vybavenie: Borland C++ 5.0; Turbo Debugger; na kompilciu je
;potrebn Turbo assembler a linker
;Technick vybavenie: P133, 32MB, 1.6GB HDD, Win98
;Obmedzenie: vstupn daje musia by v rozsahu <-128, 127>. Program ich nekontroluje.
;Program je napsan pre spracovvanie 10 sel; pre in poet by ho bolo treba
;prepsa. Vpotov rozsah je <-128, 127>.
;Pouit sluby:21h	Dos Functions
;			01H Keyboard Input
;			02H Display Character
;			08H No Echo Console Input
;			09H Display String
;			0aH Buffered Input
;			3dH Open File
;			3eH Close File
;			3fH Read File
;			40H Write File
;
;		10h	BIOS Video Services
;	                00H set video mode
;
;Mon vylepenia: 	kontrola vstupnch dajov, zvenie rozsahu vpotu