;****************************************************************
;                    Zadanie cislo1, praca s retazcom
; Autor: Igor Masarovic                               Kruzok: B11
; Termin odovzdania: 24.10.2000   2.rocnik, skolsky rok 2000/2001
;****************************************************************


.model large               ;definovanie modelu programu
.stack 100h                ;vytvorenie zasobnika o velkosti 100b

DATA SEGMENT  ;zaciatok datoveho segmentu,tu sa deklaruju premenne
color db ?    ;color -premenna,ktorej obsah nie je vopred znamy
null dw ?     ;to iste ako color
retazec db 101 dup(?)  ;definujeme pre retazec 102 bajtov
menu db  'M E N U'       ;definicia textov ktore budeme vypisovat
menu1 db '1)          Vypis retazec na obrazovku           '
menu2 db '2)  Vypis poradove cislo 1. medzery v retazci    '
menu3 db '3) Najdi zadany znak, pocet vyskytov uloz do CX  '
menu4 db '4)          Vypis znak s max. hodnotou           '
menu5 db '5)             Zarovnaj text zlava               '
menu6 db '6)      Vypis retazec v obratenom poradi         '
menu7 db '7)                Ukonci program                 '
retaz db ' Zadaj retazec znakov (max 100):'
chyba1 db ' Retazec uz ma 100 znakov! Stlac enter '
chyba2 db 'Zadany retazec neobsahuje medzeru!'
chyba3 db 'Zadany znak sa v retazci nenachadza!'
zadaj_znak db 'Zadaj hladany znak'
text1 db 'Retazec:'
text2 db 'Pozicia prvej medzery v retazci:'
text3 db 'Zadany znak sa v retazci nachadza,pocet vid register cx'
text4 db 'Znak s maximalnou hodnotou je:'
text5 db 'Retazec zarovnany zlava:'
text6 db 'Retazec v obratenom poradi:'
tabulka db 4,3,5,2,5,4,1,4,5,2,5,4,3,1,0
        db 1,3,1,2,1,8,1,5,1,1,1,7,1,2,1,7,1,4,0
        db 1,3,1,2,1,8,1,5,1,1,1,7,1,2,1,6,1,5,0
        db 4,3,1,8,1,5,1,1,1,6,1,3,1,6,1,5,0
        db 1,1,1,4,3,6,1,5,3,5,1,4,4,3,1,5,0
        db 1,2,1,3,1,8,1,4,1,3,1,3,1,5,1,6,1,5,0
        db 1,3,1,2,1,8,1,4,1,3,1,2,1,6,1,7,1,4,0
        db 1,3,1,2,5,4,1,4,1,3,1,2,5,2,5,4,3,13
tabulka1 db 'Verzia 1.00'
tabulka2 db 'Stlac lubovolnu klavesu...'

DATA ENDS            ;koniec datovej casti

CODE SEGMENT           ;zaciatok vykonnej casti
ASSUME CS:code,ds:data  ;priradenie ds: segment dat, cs:kod

   proc okraje near     ;procedura vytvori graficke okraje na obrazovke
     mov dl,8+130       ;dl-farba
     mov [si+0],dl      ;di pozicia na obrazovke
     mov di,0
     mov dl,201         ;znak
     call zobraz_char   ;zavolame proceduru na vyobrazenie znaku
     mov di,158         ;a tak pokracujeme,az kym nie su hotove vsetky okraje
     mov dl,187
     call zobraz_char
     mov di,3840
     mov dl,200
     call zobraz_char
     mov di,3998
     mov dl,188
     call zobraz_char
     xor cx,cx
     mov di,160
   okraje1:             ;vodorovne a zvisle znaky po stranach
     mov dl,186         ;vykreslujeme v cykle,vzdy zvysime poziciu na obrazovke
     call zobraz_char   ;a znak vykreslime
     add di,160
     inc cx
     cmp cx,23
     jne okraje1
     xor cx,cx
     mov di,318
   okraje2:
     mov dl,186
     call zobraz_char
     add di,160
     inc cx
     cmp cx,23
     jne okraje2
     xor cx,cx
     mov di,2
   okraje3:
     mov dl,205
     call zobraz_char
     inc di
     inc di
     inc cx
     cmp cx,78
     jne okraje3
     xor cx,cx
     mov di,3042
   okraje4:
     mov dl,205
     call zobraz_char
     inc di
     inc di
     inc cx
     cmp cx,78
     jne okraje4
     xor cx,cx
     mov di,3842
   okraje5:                   ;mame pat okrajov,takze aj pat nezavislych
     mov dl,205               ;procedur
     call zobraz_char
     inc di
     inc di
     inc cx
     cmp cx,78
     jne okraje5
     mov di,3040
     mov dl,204
     call zobraz_char
     mov di,3198
     mov dl,185
     call zobraz_char
    ret                      ;vratime cinnost hlavnemu programu
    
    okraje endp              ;koniec procedury na vytvorenie okrajov

    urob_tab proc near       ;procedura nakresli uvodny graficky text
     
     mov bp,offset tabulka   ;tu su zadane hodnoty bodov,pricom
     mov di,990              ;prva hodnota je pocet nakreslenych znakov
     mov dl,219              ;dalsia hodnota pocet vynechanych znakov
     xor cx,cx               ;a na konci kazdeho riadku je nula koli
     mov cl,ds:[bp]          ;posunutiu kurzora na dalsi riadok
    tab_a:                   ;cela tabulka konci hodnotou 13,ktoru porovnavame
     inc di                  ;aby sme vedeli,ci sme uz zobrazili cely text
     inc di
     call zobraz_char        ;tu sa zobrazuju znaky
     loop tab_a
     inc bp
     mov cl,ds:[bp]
     cmp cl,13               ;porovname znak s koncom tabulky
     je tab_d                ;ak sa rovnaju tabulka je hotova
    tab_b:                   ;a vypiseme dalsie prislusne texty
     inc di                  ;ak nie nasleduje vynechanie potrebnych znakov
     inc di                  
    loop tab_b
     inc bp
     mov cl,ds:[bp]
     cmp cl,0                ;porovname ci je uz koniec riadku,ak ano zmenime poziciu kurzora
     je tab_c                ;na dalsi riadok a pokracujeme
     jmp tab_a
    tab_c:
     add di,64
     inc bp
     mov cl,ds:[bp]
     jmp tab_a
    tab_d:
     mov bp,offset tabulka1
     mov cx,11
     mov di,2624
     call zobraz_ret
     mov bp,offset tabulka2
     mov cx,26
     mov di,3572
     call zobraz_ret
    tab_hot:
     mov ah,00h               ;este pockame na stlacenie klavesy
     int 16h
     mov di,0                 ;a vymazeme celu obrazovku
     mov cx,4000              ;cx-pocet pozicii*2
     call vymaz_ret           ;funkcia na vymazanie poctu znakov zadanych v cx
     
     ret                      ;vratime sa do hlavneho programu
    urob_tab endp 
 
    vymaz_ret proc near       ;procedura na vymazanie retazca

    vym:
     mov dl,0                  ;nastavim farbu pozadia
     mov [si+0],dl            ;a vlozime ju do offsetu color
     mov dl,' '               ;znak, ktory sa bude zobrazovat
     call zobraz_char         ;a zavolame proceduru na zobr. znaku
     inc di                   ;posunieme poziciu na obrazovke
     inc di                   ;o jeden
   loop vym                   ;odcitame aporovname register cx s nulou
                              ;ak sa nerovnaju idem na navestie vym
     mov dl,8+130             ;teraz nastavim povodnu farbu
     mov [si+0],dl            ;do premennej color
   ret                        ;vratim cinnost hlavnemu programu

   vymaz_ret endp          ;koniec procedury na vymazanie retazca    

   zobraz_char proc near ;procedura na zobrazenie znaku na obrazovku

     mov es:[di],dl    ;vlozenie znaku do videoram dl-znak
     mov al,[si+0]     ;do al vlozime farbu znaku
     mov es:[di+1],al  ;a potom znova do videoram

     ret               ;vratime cinnost hlavnemu programu

   zobraz_char endp   ;koniec procedury na zobrazenie znaku
 
   zobraz_ret proc near  ;procedura na zobrazenie retazca

   pok:
     mov dl,ds:[bp]      ;z adresy ds:[bp] vyberieme znak       
     mov es:[di],dl      ;a vlozime ho do videoram
     mov al,[si+0]       ;nastavime farbu akou sa ma znak zobrazit
     mov es:[di+1],al    ;aj tu vlozime do videoram
     inc di              ;zvysime register di o jednotku
     inc di              ;a este o jednu jednotku
     inc bp              ;aj register bp zvysime o jednotku
     loop pok            ;pokial cx-1 je rozne od nuly tak cely cyklus
                         ;opakujeme
     ret                 ;vratime cinnost hlavnemu programu

   zobraz_ret endp       ;koniec procedury na zobrazenie retazca

   proc vyber1 near     ;procedura na vypis retazca na obrazovku
   
     mov dl,8+130       ;nastavime farbu a 
     mov [si+0],dl      ;vlozime na adresu offset color (farba znaku)
     mov di,3210        ;pozicia na obrazovke
     mov cx,8           ;pocet miest v retazci
     mov bp,offset text1    ;do bp vlozime adresu retazca text1
     call zobraz_ret       ;zavolame proceduru na zobrazenie retazca
     mov di,3400           ;pozicia na obrazovke
     mov bp,offset retazec ;do bp vlozime adresu nasho retazca 
     xor cx,cx             ;vynulujeme register cx
   vyber1_a:
     inc cx                ;zvysime hodnotu registra cx o jednotku
     mov dl,ds:[bp]        ;do dl vlozime znak s retazca
     cmp dl,13             ;porovname ho s koncom retazca (enterom)
     je vyber1_hot         ;pokial sa rovnaju skocim na koniec proc.
     call zobraz_char      ;inac znak zobrazim
     inc bp                ;prippravim poziciu dalsieho znaku
     inc di                ;dalsia pozicia na obrazovke
     inc di                
     cmp cx,50             ;ak je retazec dlhy rozdelim ho do dvoch    
     je vyber1_b           ;riadkov na navesti vyber1_b
     jmp vyber1_a          ;skocim na zaciatok zobrazovania
   vyber1_b:               ;skok na dalsi riadok
     mov di,3560           ;pozicia na obrazovke
     jmp vyber1_a          ;skok naspat do podprogramu
   vyber1_hot:            

     ret                   ;vratime cinnost hlavnemu programu

   vyber1 endp             ;koniec procedury na zobrazenie retazca


   proc vyber2 near     ;procedura na vyhladanie 1.medzery
     mov bp,offset retazec ;do registra bp vlozime adresu retazca
     xor ax,ax          ;vynulujeme register ax      
   
   vyber2_a:
     mov dl,ds:[bp]     ;vlozime do dl prvy znak retazca               
     inc bp             ;zvysime potrebny register
     inc ax             ;zvysime hodnotu registra ax o jednotku
     cmp dl,13          ;zistime,ci uz boli porovnane vsetky znaky
     je vyber2_chyba    ;ak ano,tak v retazci medzera nie je
     cmp dl,' '         ;porovname znak s retazca s medzerou
     jne vyber2_a       ;pokial sa nerovnaju, opakujeme cyklus znovu
     mov dl,10          ;ak sme nasli medzeru,zobrazime jej poziciu
     div dl             ;register ax vydelime registrom dl,teda 10
     add ah,30h         ;k zvysku pridame zaciatok cisel
     add al,30h         ; a ku podielu to iste
     push ax            ;hodnoty si ulozime do zasobnika
     mov bp,offset text2  ;este pred vypisanim cisla,vypiseme patricny
     mov cx,32            ;text,di pozicia na obrazovke,cx pocet znakov
     mov di,3210
     call zobraz_ret
     pop ax             ;hodnotu vyberieme zo zasobnika
     mov dl,al          ;no a teraz cislo vypiseme
     mov di,3280
     call zobraz_char
     mov di,3282
     mov dl,ah
     call zobraz_char   ;pouzijeme pritom funkciu zobraz_char     
     jmp vyber2_hot     ;a skocime na koniec procedury

   vyber2_chyba:          ;pokial nastala chyba,vypiseme chybove hlasenie cez         
     mov cx,34             ;zobraz_ret
     mov di,3210
     mov bp,offset chyba2  ;adresa zaciatku chyboveho retazca
     call zobraz_ret

   vyber2_hot:      
     ret                   ;vratime cinnost hlavnemu programu

   endp vyber2             ;koniec procedury vyber2

   proc vyber3 near        ;procedura na vyhladanie znaku
     mov di,3210            ;pripravime si miesto na obrazovke
     mov cx,18                 ;pocet znakov v retazci
     mov bp,offset zadaj_znak  ;vypiseme text 'zadaj znak'
     call zobraz_ret
     mov ah,00h                ;vlozime cislo sluzby
     int 16h                   ;vyvolame DOS-ovske prerusenie klavesnice,a pockame na nacitanie 
                               ;znaku
     push ax                   ;vlozenie obsahu registra do zasobnika
     mov di,3210               ;pozicia na obrazovke
     mov cx,50                 ;pocet znakov na vymazanie
     call vymaz_ret            ;zavolanie procedury na vymazanie retazca
     pop ax                    ;vyber obsahu zo zasobnika do ax
     xor cx,cx                 ;vynulujeme register cx
     mov bp,offset retazec     ;vlozime adresu retazca
   vyber3_a:
     mov dl,ds:[bp]            ;zoberime znak z retazca
     inc bp                    ;zvysime register bp
     cmp dl,13                 ;porovname znak s koncom retazca (enterom)
     je vyber3_c               ;ak je koniec skocime na navestie
     cmp dl,al                 ;porovname zadany znak so znakom z retazca
     je vyber3_b               ;ak sa rovnaju skocime na navestie
     jmp vyber3_a              ;vratime sa naspat na zaciatok
   vyber3_b:
     inc cx                    ;tu zvysime register cx (pocet najdenych znakov)
     jmp vyber3_a              ;a vratime sa porovnavat dalej
   vyber3_c:                   
     cmp cx,0                  ;porovname,ci sme nasli aspon jeden znak,ak nie vypiseme
     je vyber3_err             ;hlasenie na navesti 'vyber3_err'
     mov di,3210               ;ak sme nasli aspon jeden znak vypiseme hlasenie
     mov cx,55                 ;di pozicia na obrazovke,cx pocet znakov
     mov bp,offset text3
     call zobraz_ret           ;zobrazime text3
     jmp vyber3_hot            ;a skocime na koniec
   vyber3_err:                 ;pokial sme nenasli ani jeden zhodny znak
     mov di,3210               ;vypiseme o tom spravu na obrazovku
     mov cx,36                 ;di pozicia na obrazovke,cx pocet znakov
     mov bp,offset chyba3
     call zobraz_ret           ;zobrazime retazec chyba3
   vyber3_hot:

     ret                       ;vratime riadenie programu

   vyber3 endp                 ;koniec procedury na najdenie znaku,v registri cx,je pocet                                ;najdenych znakov

                           
   proc vyber4 near         ;procedura vypise najvacsi znak v retazci
     mov bp,offset text4    ;najprv vypiseme,co vlastne robime
     mov cx,30              ;pocet znakov v text 4
     mov di,3210             ;pozicia na obrazovke
     call zobraz_ret         ;volanie procedury na zobrazenie retazca
     mov bp,offset retazec   ;vlozime do bp adresu retazca
     mov al,ds:[bp]          ;do al vlozime prvy prvok retazca
   vyber4_a:                 ;nasleduje cyklus
     inc bp                  ;zvysim hodnotu registra bp,teda zoberiem dalsi znak
     mov dl,ds:[bp]          ;vlozim ho do registra dl
     cmp dl,13               ;porovnam znak s koncom retazca
     je vyber4_hot           ;ak je uz koniec, vykonam funkcie na navesti 
     cmp dl,al               ;porovnam registre dl a al,ak je register dl mensi 
     jna vyber4_a            ;skocim na zaciatok cyklu, v opacnom pripade musim
     mov al,dl               ;vlozit do al (najvacsi znak) register dl
     jmp vyber4_a            ;a skocim naspat na zaciatok cyklu
   vyber4_hot:               ; navestie ukoncenia
     mov dl,al               ;teraz najvacsi najdeny znak zobrazim
     mov di,3272             ;poloha na obrazovke a zavolanie
     call zobraz_char        ;vykreslenia znaku

     ret                     ;vratim sa do hlavneho programu
   vyber4 endp               ;koniec procedury na najvacsi znak

   proc vyber5 near          ;procedura zobrazi zarovnany retazec zlava
     mov cx,24               ;pripravime si parametre na zobrazenie uvodneho riadku
     mov di,3210             ;pocet znakov a pozicia na obrazovke
     mov bp,offset text5     
     call zobraz_ret         ;a uvodny retazec zobrazime
     mov bp,offset retazec   ;potom si ulozime adresu nasho retazca
     xor cx,cx
   vyber5_a:
     mov dl,ds:[bp]          ;vlozime do dl prvy znak z retazca
     inc bp                  ;zvysime register bp o jednotku
     cmp dl,' '              ;porovname znak s medzerou,pokial sa rovna skocime naspat
     je vyber5_a             ;takto opakujeme az kym neziskame pocet medzier na zaciatku
     dec bp                  ;ten je ulozeny v bp,ale bp sme zbytocne o 1 zvysili takze ho 
     mov di,3400             ;o 1 znizime, pripravime si poziciu na obrazovke
   vyber5_b:
     mov dl,ds:[bp]          ;teraz zoberieme prvy znak za medzerami a vypiseme ho
     cmp dl,13               ;pokial je to koniec retazca,skoncime
     je vyber5_hot
     call zobraz_char        ;pokial nie zobrazime znak,a zvysime polohu na obrazovke
     inc di
     inc di
     inc bp
     inc cx                  ;a zoberieme dalsi znak
     cmp cx,50              ;ak je cx=51 skocime na druhy riadok
     je vyber5_c             ;skok na navestie
     jmp vyber5_b            ;no a skocime na zaciatok cyklu vypisu
   vyber5_c:                 ;na tomto navesti zmenime poziciu vypisu znakov (koli estetike)
     mov di,3560             ;nova pozicia na obrazovke
     jmp vyber5_b            ;skok naspat do vypisovania
   vyber5_hot:

     ret                     ;vratime riadenie hlavnemu programu

   vyber5 endp               ;koniec procedury na zarovnanie textu

   proc vyber6 near        ;procedura na vypisanie retazca v opacnom poradi
     mov bp,offset text6   ;zoberieme si adresu textu
     mov di,3210           ;a pomocou procedury zobraz_ret vypiseme uvodny text
     mov cx,27
     call zobraz_ret
     mov bp,offset retazec  ;tu vlozime do bp adresu retazca
     xor cx,cx              ;vymazem hodnotu registra cx
     xor ax,ax
   vyber6_a:
     mov dl,ds:[bp]         ;do dl vlozime jeden znak z retazca
     inc bp                 ;zvysime ukazatel o jedno
     inc ax
     cmp dl,13              ;porovname znak s koncom retazca
     jne vyber6_a           ;pokial sa nerovnaju nacitam dalsi znak
     dec bp                 ;znizim hodnotu bp o dva
     dec bp
     mov di,3398           ;a teraz mam v bp posledne pismeno retazca
   vyber6_b:
     mov dl,ds:[bp]         ;a pomocou procedury zobraz_char,zobrazim
     dec bp                 ;retazec po jednom znaku
     inc cx
     inc di
     inc di                 ;posuniem kurzor o jednu poziciu
     cmp cx,51              ;koli estetike dlhy retazec rozdelime do dvoch riadkov
     je vyber6_c
     push ax           
     call zobraz_char
     pop ax
     cmp cx,ax               ;a kontrolujem ci uz nie som na zaciatku retazca
     jne vyber6_b           ;ak nie proces opakujem,ak ano
     jmp vyber6_hot         ;skocim na koniec
   vyber6_c:
     inc bp
     mov di,3558           ;pozicia na obrazovke
     jmp vyber6_b           ;a spatny skok do vypisovania
   vyber6_hot:

     ret                    ;vratim sa do hlavneho programu
   vyber6 endp              ;koniec procedury na vypis retazca opacne

   proc vyber7 near         ;procedura na ukoncenie prace

     mov ax,4c00h           ;DOS-ovske prerusenie na ukoncenie 
     int 21h                ;beziaceho programu

     ret                    ;vratim cinnost hlavnemu programu

   vyber7 endp              ;koniec procedury na ukoncenie prace

 
start:
     mov ah,02h             ;prerusenie DOS-u na posun kurzora
     mov dh,25              ;kurzor dame 'za' obrazovku aby nezavadzal
     int 10h                ;vyvolame prerusenie
     mov ax,seg data        ;do ax vlozime segment dat
     mov ds,ax              ;a do ds potom vlozime ax
     mov ax,0b800h          
     mov es,ax              ;adresa na zapis do videoram
     xor di,di              ;vynulujeme di           
     mov si,offset color    ;do si vlozime adresu premennej color
     mov dl,8+130           ; do dl vlozime kod farby
     mov [si+0],dl           
     call urob_tab          ;vypiseme uvodny graficky text
     call okraje            ;vykreslime okraje
     mov di,660             ;di-pozicia znaku na obrazovke
     mov cx,32              ;pocet znakov v retazci
     mov bp,offset retaz    ;do bp vlozime adresu retaz
     call zobraz_ret        ;zavolame proceduru na zobrazenie retazca
     mov bp,offset retazec  ;do bp vlozime adresu retazca
     mov di,990             ;nova poloha na obrazovke
     xor cx,cx              ;vynulujeme register cx
     mov dl,8+130           ;farba znaku
     mov [si+0],dl          ;vlozime farbu znaku 
   start1:
     mov ah,00h             ; cislo sluzby,prerusenie 16h na ziskanie
     int 16h                ; znaku z klavesnice
     mov ds:[bp],al         ;nacitany znak vlozime na adresu ds:[bp]
     mov dl,al              ;do dl vlozime al
     call zobraz_char       ;zobrazime znak pomocou procedury
     inc cx                 ;zvysime hodnotu cx o jednotku
     inc bp                 ;zvysime hodnotu bp o jednotku
     inc di
     inc di                 ;a register di o dve
     cmp di,1090            ;porovname di s hodnotou 1090            
     je start2              ;pokial sa rovna skoc na start2
     cmp cx,100             ;porovnaj cx so stovkou
     je start3              ;pokial sa rovna skoc na start3
     cmp dl,13              ;porovnaj dl s hodnotou 13
     jne start1             ;pokial sa nerovna skoc na start1
     jmp start4             ;nepodmieneny skok na start4
   start2:
     mov di,1150            ;do di vloz hodnotu 1150
     jmp start1             ;nepodmieneny skok na start1
   start3:                 
     mov dl,8+130           ;kod farby
     mov [si+0],dl          ;vlozenie kodu farby
     mov di,3720            ;nastavenie pozicie na obrazovke
     mov cx,39              ;pocet znakov v retazci
     mov bp,offset chyba1   ;do bp vloz adresu chyba1
     call zobraz_ret        ;zavolaj proceduru na zobrazenie znaku
     mov ah,00h             ;cislo sluzby
     int 16h                ;prerusenie na vstup s klavesnice
     mov dl,al              ;vloz do dl hodnotu al
     cmp dl,13              ;porovnaj hodnotu dl s 13
     jne start3             ;skoc pokial sa hodnoty nerovnaju
     mov bp,offset retazec
     add bp,100        
     mov ds:[bp],dl         ;na adresu ds:[bp] vlozime obsah dl
     mov cx,39              ;teraz vymazeme retazec.cx-pocet znakov
     mov di,3720            ;zaciatok retazca na obrazovke
     call vymaz_ret         ;zavolam proc. vymazanie retazca     
   start4:             
     mov di,658             
     mov cx,32
     call vymaz_ret
     mov di,988
     mov cx,60
     call vymaz_ret         
     mov di,1148
     mov cx,60              ;tymito riadkami vymazem tri riadky
     call vymaz_ret         ;vypisovane predtym
     mov dl,8+130           ;nastavim farbu textu
     mov [si+0],dl         
     mov di,226             ;pozicia na obrazovke
     mov cx,7               ;pocet znakov v retazci
     mov bp,offset menu     ;adresa retazca menu
     call zobraz_ret
     mov di,668
     mov cx,49
     mov bp,offset menu1
     call zobraz_ret
     mov di,988
     mov cx,49
     mov bp,offset menu2
     call zobraz_ret
     mov di,1308
     mov cx,49
     mov bp,offset menu3      ;v tejto faze programu sa vypisuju
     call zobraz_ret          ;jednotlive riadky menu na obrazovku
     mov di,1628              ;pricom di-poloha zaciatku retazca
     mov cx,49                ;na obrazovke, cx-pocet znakov v retazci
     mov bp,offset menu4      ;a adresa daneho retazca-bp
     call zobraz_ret
     mov di,1948
     mov cx,49
     mov bp,offset menu5
     call zobraz_ret
     mov di,2268
     mov cx,49
     mov bp,offset menu6
     call zobraz_ret
     mov di,2588
     mov cx,49
     mov bp,offset menu7
     call zobraz_ret
   zvol_si:                  
     mov ah,00h           ;DOS-ovske prerusenie na vstup z klavesnice
     int 16h              ;prerusenie 16h
     push ax              ;vlozim hodnotu ax do zasobnika
     mov di,3208          ;vymazanie spodnych troch riadkov,tych kde
     mov cx,74            ;kde sa vypisuju jednotlive vysledky
     call vymaz_ret
     mov di,3368
     mov cx,74
     call vymaz_ret
     mov di,3528
     mov cx,74
     call vymaz_ret
     xor cx,cx
     xor di,di
     pop ax               ;vyberiem hodnotu ax z registra
     mov dl,al            ;do dl vlozim nacitany znak s klavesnice
     cmp dl,'1'          
     je nav1  
     cmp dl,'2'
     je nav2 
     cmp dl,'3'           ;a postupne ho porovnavam s cislami od 1
     je nav3              ;do sedem,a skocim na prislusne navestie 
     cmp dl,'4'           ;odkial volam procedury
     je nav4
     cmp dl,'5'
     je nav5
     cmp dl,'6'
     je nav6
     cmp dl,'7'
     je koniec
     jmp zvol_si
   nav1:
     call vyber1          ;zavolam proceduru podla vyberu a skocim
     jmp zvol_si          ;na nacitanie dalsieho znaku na navestie
   nav2:                  ;zvol_si
     call vyber2
     jmp zvol_si
   nav3:
     call vyber3
     jmp zvol_si
   nav4:
     call vyber4
     jmp zvol_si
   nav5:
     call vyber5
     jmp zvol_si
   nav6:
     call vyber6
     jmp zvol_si
   koniec:                ;koniec celeho programu
     call vyber7          ;procedura na ukoncenie programu
     ends                 ;koniec kodoveho segmentu
     end start            ;definujeme odkial zacina program

;Poznamky: Cely program je rieseny priamym zapisom do videoram,rozlisenie obrazovky je 80*25 a 16 farieb.0b800h je
;je adresa kde je uvedene rozlisenie nastavene. Register es-
;segment videoram,di-offset videoram. Jednotlive znaky sa na
;obrazovku zapisuju tak,ze parne cislo di (zaciatok 0) je znak a
;nasledujuce neparne je jeho farba.Prva cast farby je popredie, druha pozadie. Cely program je rieseny cez procedury nakolko ulahcuju
;pripadne hladanie chyb a sprehladnuju program.
;Program bol pisany v poznamkovom bloku a kompilovany programom
;tasm a tlink
;Chovanie programu vzhladom na vstupne udaje: nie su ziadne obmedzenia