; Zadanie c. 1
;
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) a podla ponkanho menu vykon  jednu z monost:
;B
;a) vype retazec znakov na obrazovku
;b) vype pocet cslic v retazci
;c) zist,ci sa v retazci nachdza pouvatelom zadany znak a vype o tom sprvu
;d) njde znak s min. hodnotou a vype tento znak
;e) mal psmen konvertuje na velk
;f) zarovn text zprava ( vynech prv medzery odkonca)
;g) ukonc vykonvanie programu.

;Po vykonan zvolenej monosti sa program vrti na vpis menu.

; Autor: Marian Mirc, B11

; Termin: 23.10.2000




;program



; zasobnik

ZAS	SEGMENT STACK 'STACK'

	DW 400H DUP(?)

ZAS	ENDS



DATA	SEGMENT

; datovy segment

;

CMD1	DB 'Zadajte retazec (max. 100 znakov): $'	; prva vyzva na zadanie retazca

CMD2	DB 'Zadajte znak na hladanie: $'		; vyzva pre menu3

NEWLINE	DB 13					 	; sekvencia prechod na novy riadok

	DB 10

	DB '$'

TEXTIN	DB 101						;vstupny bufer na vstup retazca - velkost

TEXTLEN	DB 0						; vystup - dlzka retazca

TEXT	DB 101 DUP(?)				        ; vstupny retazec

TEMPON	DB 8 DUP(?)					; pomocny buffer pre vypis cisla

; retazce k menu

MENU1	DB '1. vypis retazca'

	DB 13

	DB 10

	DB '$'

MENU2	DB '2. pocet cislic'

	DB 13

	DB 10

	DB '$'

MENU3	DB '3. hladanie znaku'

	DB 13

	DB 10

	DB '$'

MENU4	DB '4. znak s minimalnou hodnotou'

	DB 13

	DB 10

	DB '$'

MENU5	DB '5. konverzia na velke pismena'

	DB 13

	DB 10

	DB '$'

MENU6	DB '6. zarovnanie zprava'

	DB 13

	DB 10

	DB '$'

MENU7	DB '7. koniec'

	DB 13

	DB 10

	DB '$'

MSG1	DB 'Znak bol prvykrat najdeny na pozicii: $'

MSG2	DB 'Znak nebol najdeny$'

MSG3	DB 'Znak s min. hodnotou je $'

MSG3b	DB ' na pozicii $'

MSG4	DB 'Pocet cislic v retazci je $'

;

DATA	ENDS



; kodovy segment

CODE	SEGMENT

ASSUME CS:CODE, DS:DATA, SS:ZAS

; zaciatok programu

start:	MOV AX, SEG DATA		; init DS registra

	MOV DS, AX

	MOV AX, SEG ZAS			; init SS registra

	MOV SS, AX

	MOV AX, 400H			; init SP registra

	MOV SP, AX

	MOV AH, 09H			; vypisanie ziadosti o retazec cez sluzbu INT 21h - 09h

	MOV DX, OFFSET CMD1

	INT 21H

	MOV DX, OFFSET NEWLINE		; prechod na novy riadok

	MOV AH, 09H			

	INT 21H

	MOV AH,0AH			; citanie retazca

	MOV DX, OFFSET TEXTIN

	INT 21H

	MOV DX, OFFSET NEWLINE		; prechod na novy riadok

	MOV AH, 09H

	INT 21H

	MOV DX, OFFSET TEXT		; pridanie $ na koniec retazca

	MOV BL, TEXTLEN

	MOV BH, 0

	ADD DX, BX			; pricita k adrese dlzku, takze bude ukazovat na koniec

	MOV BL, '$'

	MOV SI, DX			; indexovat nemozno cez DX, tak presunie DX do SI reg.

	MOV byte ptr [SI], BL		; presunie na koniec retazca $

menu:	; postupny vypis menu

	MOV AH,09H

	MOV DX, OFFSET NEWLINE

	INT 21H

	MOV DX, OFFSET MENU1

	INT 21H

	MOV DX, OFFSET MENU2

	INT 21H

	MOV DX, OFFSET MENU3

	INT 21H

	MOV DX, OFFSET MENU4

	INT 21H

	MOV DX, OFFSET MENU5

	INT 21H

	MOV DX, OFFSET MENU6

	INT 21H

	MOV DX, OFFSET MENU7

	INT 21H

	MOV DX, OFFSET NEWLINE

	INT 21H

	MOV AH,08H			; citanie znaku vyberu z menu (1 - 7)

	INT 21H

	CMP AL, '1'			; test znaku na 1 - vypis retazca, skoci na men1

	JZ menuc1

	CMP AL, '2'			; test znaku na 2 - pocet cislic

	JZ menuc2

	CMP AL, '3'			; test znaku na 3 - hladat znak

	JZ menuc3

	CMP AL, '4'			; test znaku na 4 - znak s min. hodnotou

	JZ menuc4

	CMP AL, '5'			; test znaku na 5 - konverzia na velke pismena

	JZ menuc5	

	CMP AL, '6'			; test znaku na 6 - zarovnanie sprava

	JZ menuc6

	CMP AL, '7'			; test znaku na 7 - koniec programu, skoci na koniec

	JZ koniec

	JMP menu



menuc1:	CALL men1

	JMP menu

menuc2:	CALL men2

	JMP menu

menuc3:	CALL men3

	JMP menu

menuc4:	CALL men4

	JMP menu

menuc5:	CALL men5

	JMP menu

menuc6: CALL men6

	JMP menu





koniec:	MOV AX,4C00H			; ukoncenie programu

	INT 21H



men1:	MOV AH,09H			; vypis retazca

	MOV DX, OFFSET TEXT

	INT 21H

	MOV DX, OFFSET NEWLINE		; prechod na novy riadok

	INT 21H

	RET





men2:	; pocitanie cislic: CX - citac, BX - pocet

	MOV BX, 0			; pociatocny pocet cislic je 0

	MOV CX, 101			; max. dlzka stringu je 101

	MOV SI, OFFSET TEXT

loop1:	MOV AL, byte ptr [SI]		; slucka na test cislice

	CMP AL, '$'			; zisti ci neni koniec retazca; ak tak skoci na L1end

	JZ L1end

	CMP AL, '0'			; test na 0

	JL L1cont

	CMP AL, '9'			; test na 9

	JG L1cont

	ADD BX, 1			; ak preslo az sem, je to cislica - zvysi sa cislo v BX

L1cont:	ADD SI, 1				; prechod na dalsi znak - zvysit SI

	LOOP loop1

L1end:	; dopocitane

	MOV AH, 09H			; vypis hlasky

	MOV DX, OFFSET MSG4

	INT 21H

	MOV AX, BX			; cislo na vypisanie musi byt v AX

	CALL outnum			; volanie podprogramu na vypis cisla, musi byt v AX

	MOV DX, OFFSET NEWLINE		; prechod na novy riadok

	MOV AH, 09H

	INT 21H

	RET





men3:	; hladanie uzivatelom zadaneho znaku

	MOV AH, 09H			; vypisanie vyzvy pre zadanie znaku

	MOV DX, OFFSET CMD2

	INT 21H

	MOV AH, 01H			; nacitanie znaku pomocou funkcie 01h

	INT 21H				; v AL je zadany znak

	MOV SI, OFFSET TEXT		; inicializacia registrov

	MOV CX, 101

	MOV DX, 0

	; pre loop: AL hladany znak, CX pocitadlo, BL aktualny znak; DL pozicia, DH=1 najdeny

loop4:	MOV BL, byte ptr [SI]		; nacitanie aktualneho znaku

	CMP BL, '$'			; test na $, ak ano, hladanie konci, skok na L4end

	JZ L4end

	CMP BL, AL			; test, ci su znaky rovnake

	JNZ L4cont			; ak nie, skoci na L4cont

	MOV DH, 1			; znak najdeny -> DH=1, skok na L4end, DL obsahuje pos

	JMP L4end

L4cont:	ADD SI, 1			; prechod na dalsi znak

	ADD DL, 1			; inkrementacia aktualnej pozicie

	LOOP loop4

L4end:	CMP DH, 1			; ak bol najdeny tak DH=1 - test

	JNZ M3nf			; ak nenajdeny, skok na M3nf

	MOV DH, 0			; vynulovanie DH -> DX obsahuje poziciu

	PUSH DX				; uchovanie pozicie na stack

	MOV AH, 09H			; odriadkovanie

	MOV DX, OFFSET NEWLINE

	INT 21H

	MOV DX, OFFSET MSG1		; vypis textu o najdeni znaku

	INT 21H

	POP AX				; obnovenie pozicie do AX registru

	CALL outnum			; podprogram pre vypis cisla /pozicie/

	MOV DX, OFFSET NEWLINE		; novy riadok

	MOV AH, 09H

	INT 21H

	JMP menu			; navrat do menu

M3nf:	MOV DX, OFFSET NEWLINE		; znak sa nenasiel

	MOV AH, 09H			; vypis textu o nenajdeni znaku

	MOV DX, OFFSET MSG2

	INT 21H

	MOV DX, OFFSET NEWLINE		; novy riadok

	INT 21H

	RET



men4:	; hladanie znaku s minimalnou hodnotou

	; CX pocitadlo, DX akt. pozicia, BX min. pozicia, AL min. hodnota

	MOV CX, 101			; init registrov

	MOV DX, 0

	MOV BX, 0

	MOV SI, OFFSET TEXT

	MOV AL, byte ptr [SI]		; najnizsia hodnota je najprv nulty znak

loop5:	MOV AH, byte ptr [SI]		; nacitanie aktualneho znaku

	CMP AH, '$'			; test na koniec retazca; ak tak skok na koniec

	JZ L5end

	CMP AH, AL			; porovnanie aktualneho s najmensim

	JNL L5cont			; ak neni mensi, tak skok na L5cont

	MOV AL, AH			; je mensi, tak do AL ide akt. znak

	MOV BX, DX			; do BX jeho pozicia

L5cont:	ADD DX, 1			; zvysenie pozicie

	ADD SI, 1			; prechod na dalsi znak

	LOOP loop5

L5end:	; v BX je pozicia, v AL hodnota znaku s najmensou hodnotou

	MOV AH, 09H			; vypis hlasenia

	MOV DX, OFFSET MSG3

	INT 21H

	MOV SI, OFFSET TEXT

	ADD SI, BX

	MOV DL, byte ptr [SI]		; vypis najmensieho znaku

	MOV AH, 02H

	INT 21H

	MOV AH, 09H			; vypis hlasenia

	MOV DX, OFFSET MSG3b

	INT 21H

	MOV AX, BX			; vypis pozicie najmensieho znaku

	CALL outnum

	MOV AH, 09H

	MOV DX, OFFSET NEWLINE		; novy riadok

	INT 21H

	RET



men5:	; konvezia na velke pismena

	MOV SI, OFFSET TEXT		; init registrov

	MOV CX, 101

loop6:	MOV AL, byte ptr [SI]		; nacitanie aktualneho znaku do AL

	CMP AL, '$'			; test na koniec retazca

	JZ L6end			; ak je koniec, slucka konci

	CMP AL, 'a'			; porovnanie ci je to male pismeno

	JL L6cont

	CMP AL, 'z'

	JG L6cont	

	SUB AL, 20H			; ak preslo az sem, tak je male -> konv. znaku na velky

	MOV byte ptr [SI], AL		; aktualizovanie skonvertovaneho znaku

L6cont:	ADD SI, 1

	LOOP loop6

L6end:	RET



men6:	; zarovnanie sprava

	MOV SI, OFFSET TEXT		; najdenie posledneho znaku, init registrov
	MOV BX, 0

	MOV CX, 101

loop7:	MOV AL, byte ptr [SI]		; aktualny znak do AL

	CMP AL, '$'			; test na zaverecny znak $

	JZ L7end			; ak ano, slucka konci

	ADD SI, 1			; dalsi znak
	ADD BX, 1

	LOOP loop7			; slucka

	; SI ukazuje na zaverecny $, BX obsahuje jeho poziciu
L7end:	MOV DI, OFFSET TEXT		; init DI na koniec retazca
	ADD DI, 100
	MOV CX, BX			; inicializacia pocitadla, obsahuje pocet znakov
loop8:	MOV AL, byte ptr [SI]		; kopirovanie akt. znaku na koniec retazca
	MOV byte ptr [DI], AL
	SUB SI, 1			; prechod na dalsi znak
	SUB DI, 1
	LOOP loop8			; slucka
	MOV AL, byte ptr [SI]		; v slucke sa neskopiroval prvy znak, tak sa kopiruje
	MOV byte ptr [DI], AL
	SUB DI, 1		; DI sa znizi o 1, aby ukazoval na prvy znak pred retazcom
	MOV CX, DI			; init pocitadla na pocet znakov na premazanie
	SUB CX, OFFSET TEXT
loop9:	MOV byte ptr [DI], ' '		; premazanie akt. znaku medzerou
	SUB DI, 1
	LOOP loop9			; slucka
	MOV byte ptr [DI], ' '		; prvy znak sa nepremazal, tak sa maze
	RET				; navrat do menu



outnum:	; podprogram vypise cislo v registri AX na obrazovku

	PUSH AX				; uchovanie hodnoty registrov

	PUSH BX

	PUSH CX

	PUSH DX

	PUSH SI	

	MOV SI, OFFSET TEMPON		; nastavenie SI na pomocny retazec

	MOV CX, 0			; vynulovanie CX - pocitadlo znakov

loop2:	MOV BL, 10			; do BL 10 - delitel

	DIV BL				; delenie AX 10 - AH zvysok AL vysledok

	ADD AH, 30H			; pricitanie k zvysku 30h - konverzia cislice na znak

	MOV byte ptr [SI], AH		; skonvertovany znak do retazca

	MOV AH, 0			; vynulovanie AH - AX obsahuje nove cislo na delenie

	ADD SI, 1			; prechod na novy znak

	ADD CX, 1			; inkrementacia pocitadla znakov

	CMP AX, 0			; test cisla na 0

	JNZ loop2			; ak neni 0 tak nove delenie

	SUB SI, 1			; odcitanie SI tak, aby ukazoval na posledny znak

loop3:	MOV DL, byte ptr [SI]		; vypisanie znaku v DS:SI

	MOV AH, 2

	INT 21H

	SUB SI, 1			; prechod na dalsi znak

	SUB CX, 1			; dekrementacia pocitadla znakov

	CMP CX, 0			; test pocitadla na 0

	JNZ loop3			; ak neni 0 tak vypisanie dalsieho znaku

	POP SI				; obnovenie povodnej hodnoty registrov

	POP DX

	POP CX

	POP BX

	POP AX

	RET				; navrat



; koniec kodoveho segmentu

	ENDS

	END start


; Zhodnotenie:
; program je funkcny, obmedzenie je vo vst. retazci, ktory nemoze obsahovat znak $
; vsetky znaky za $ budu odrezane vzhladom na pouzitu funkciu DOSu
; program pouziva iba sluzby DOSu pre vstup a vystup znaku, resp. retazca
; nepouziva retazcove instrukcie
; zdrojovy subor zad1.asm bol napisany v standardnom Windows programe Notepad
; kompilacia v programe Turbo Assembler 2.02
; linkovanie v programe Turbo Link 3.01