;Zadanie c. 2 
;Text zadania : Vytvorte  program,  ktory  nacita  z  textoveho suboru postupnost 
;celych cisel (aspon 10) so znamienkom  v desiatkovej ciselnej sustave, potom ich 
;transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom
;podla priania pouzivatela spravi
;Autor : Tomas Picha
;Termin odovzdania: 14.11.2000
;2.roc., sk.rok 2000/2001 

ZAS  SEGMENT STACK               ;zasobnikovy segment 
          dw  64 dup(?)   
ZAS  ENDS                 
;--------------------------------------------------------------------------------------------------
DATA SEGMENT
subor	  db 'zadanie2.in',0     ;definicia vstupneho suboru 
subor2    db 'zadanie2.out',0    ;definicia vystupneho suboru
znam      dw  0                  ;znamienko 1-plus -1-minus
znak      db  0                  ;nacitany znak zo subora
poccis    dw  0                  ;pocet nacitanych cisel (2 bajty)
cisla     dw  100 dup(?)         ;tu sa budu ukladat cisla v 2-ovom zapise (1 cislo 2 Bajty)
cislozn   db  7 dup(?)           ;pri vypise sa sem budu ukladat cifry cisla (znam,5cifier,ukonc znak)
keybin    db  7,9 dup(?)         ;vstup z klavesnice (max,len,znam,5 cifier,0dh)
menu      db  0ah,0dh,0ah,0dh,'n-NACITAJ CISLA',0ah,0dh,'v-VYPIS CISEL'
          db  0ah,0dh,'k-KONIEC',0ah,0dh
          db  'a-SUMA VSETKYCH CISEL',0ah,0dh,'b-UTRIED VZOSTUPNE',0ah,0dh
          db  'c-VYDEL 2 CISLA',0ah,0dh,'d-VYNASOB 2 CISLA',0ah,0dh,'$'
textN     db  0ah,0dh,'Subor nacitany$'
textV     db  0ah,0dh,'Vypis cisel: $'
textU     db  0ah,0dh,'Ukladam do subora...$'
textA     db  0ah,0dh,'Suma=$'
textB     db  0ah,0dh,'Triedim...$'
textCD1   db  0ah,0dh,'Zadaj index cisla: $'
textCD2   db  0ah,0dh,'Cislo=$'
textC1    db  0ah,0dh,'Cela cast podielu cisel=$'
textC2    db  0ah,0dh,'Zvysok po deleni=$'
textD     db  0ah,0dh,'Sucin cisel=$'
textERR   db  0ah,0dh,'Doslo k preteceniu!!!$'
DATA ENDS
;--------------------------------------------------------------------------------------------------
CODE SEGMENT
ASSUME cs:code, ds:data, ss:zas

KONVZN2 proc                     ;zapise cifry cisla (-2^15, 2^15> z adr dx ukoncene 0dh do reg dx (2-bajtove 2-ove cislo)
        push ax                  ;ulozi registre do zasobnika okrem dx - vstup
        push bx
        push cx
        push di
        push si
        push znam
        mov si, dx               ;indexovanie vstupneho buffera cislozn
        mov di, 0                ;do reg di sa bude zapisovat cislo v 2-ovej sustave
        mov znam, 1              ;znamienko nastavi na 1 (kladne cislo)
        mov cx, 7                ;velkost vstupneho buffera cislozn
cyklz2:	cmp byte ptr[si], 0dh	 ;enter za cislom	
        jz konz2
        cmp byte ptr[si], 2dh    ;znamienko minus
        jz minz2
        cmp byte ptr[si], 2bh    ;znamienko plus
        jz opakz2
        mov ax, di               ;konvertuje cifry na cislo (nasobi 10 a priratava cifry), ktore zapisuje na adr si
        mov dx, 0
        mov bx, 10
        imul bx
        mov bx, 0
        mov bl, [si]             ;prevedie znak na cifru
        sbb bl, 30h   
        adc ax, bx
        mov di, ax 
        jmp opakz2
minz2:  mov znam, -1             ;znam bude -1
        jmp opakz2
opakz2: inc si                   ;posunie sa v bufferi cislozn aby mohol nacitat novu cifru
        loop cyklz2
konz2:  mov ax, di               ;vynasobi cislo hodnotou znam (-1,1)
        mov dx, 0
        imul znam
        mov dx, ax               ;vystup v dx
        pop znam
        pop si                   ;vyberie registre zo zasobnika okrem dx - vystup
        pop di
        pop cx 
        pop bx
        pop ax
        ret
KONVZN2 endp

NACSUB  proc                     ;proc nacsub nacita cisla zo subora a ulozi ich na adr cisla, ich pocet v poccis
	mov ah, 3dh              ;otvor subor
	mov al, 0                ;na citanie 
	mov dx, offset subor     ;je to subor zadanie2.in
	int 21h                   
	mov bx, ax               ;do bx daj handler otvoreneho suboru      
        mov si, offset cislozn   ;indexovanie buffera cislozn
        mov di, offset cisla     ;adresa na ktoru sa bude zapisovat za sebou cisla v 2-ovom zapise
        mov word ptr[di], 0
        mov poccis, 0            ;nastavi pocet nacitanych cisel na nulu
citaj:	mov cx, 1
        mov dx, offset znak
        mov ah, 3fh              ;citaj zo subora 1 znak
	int 21h
       	cmp ax, 0                ;bol EOF?
	jz kon1
        cmp znak, 0ah       	 ;novy riadok
        jz oddel                 ;zavola proc KONVZN2 na konverziu
        cmp znak, 0dh            
        jz presk                 ;preskoci znak a nezapise od buffera cislozn
        mov al, znak             ;zapise znak do buffera cislozn
        mov byte ptr[si], al
        inc si
        jmp citaj
oddel:  mov byte ptr[si], 0dh    ;zakonci cislo v znakoch bajtom 0dh
        mov dx, offset cislozn   
        call KONVZN2
        mov [di], dx             ;zapise zkonvertovane cislo v doplnkovom kode
        mov si, offset cislozn   ;skoc na zac buffera cislozn
        add di, 2                ;posunie sa v pameti aby mohol nacitat nove cislo
        mov word ptr[di], 0      ;vynuluje miesto v pameti, kam sa bude cislo zapisovat
        inc poccis               ;zvacsi informaciu o pocte nacitanych cisel
presk:  jmp citaj
kon1:   mov ah, 3eh              ;zavrie subor
        int 21h
        mov dx, offset textN     ;vypise hlasku
        mov ah, 09h
        int 21h
        ret  
NACSUB  endp

KONV2ZN proc                     ;zapise 2bajtove 2-ove cislo (-2^15, 2^15> v bx na adr cislozn ukoci '$'
        push ax                  ;ulozi registre do zasobnika
        push bx
        push cx
        push dx
        push si
        push di
        mov si, offset cislozn   ;na tuto adr bude zapisovat cislo
        mov cx, 7                ;velkost vystupneho buffera cislozn
nuluj:  mov byte ptr[si], 0      ;vynuluje buffer 
        add si, 1
        loop nuluj
        mov cx, 10000            ;maximalny 10-ovy rad cisla
        mov si, offset cislozn   ;sem bude zapisovat cislo
        cmp bx, 32768            ;zisti ci je cislo zaporne, ak ano zneguje ho a ulozi
        jbe opak1
        neg bx
        mov byte ptr[si], 2dh 
        inc si 
opak1:  cmp cx, 1                ;podmienka pre pripad ak je rad 0
        je opak2
        cmp bx, cx               ;ak je cislo mensie ako najvyssi rad - 1.cyklus(zmensuje rad), inak skoci na 2.
        jnb opak2
        mov dx, 0
        mov ax, cx
        mov di, 10
        idiv di
        mov cx, ax
        jmp opak1
opak2:  mov ax, bx               ;2.cyklus - deli sa cislo najvyssim radom 
        mov dx, 0                ;koeficient(-30h cifra) sa vypise, miesto cisla sa napise zvysok  
        idiv cx                  ;cele sa to opakuje so znizovanim radu
        mov bx, dx  
        adc al, 30h
        mov byte ptr[si], al
        inc si
        mov dx, 0
        mov ax, cx
        mov di, 10
        idiv di
        mov cx, ax
        cmp cx, 0
        jz kon2
        jmp opak2
kon2:   mov byte ptr[si], '$'    ;zakonci cislo $ - na vypis
        pop di                   ;vyberie reg zo zasobnika
        pop si
        pop dx
        pop cx
        pop bx                   ;v bx cislo v doplnku (to iste ako na vstupe)
        pop ax
        ret
KONV2ZN endp

ULOZSUB proc                     ;ulozi cisla (ich pocet v poccis) z adr cisla do subora
        mov dx, offset textU     
        mov ah, 09h
        int 21h
	mov ah, 3ch              ;vytvor subor
	mov cx, 0                ;normalny subor
	mov dx, offset subor2    ;je to subor zadanie2.out
	int 21h
        mov bx, ax               ;file handle - v bx
        mov dx, offset cisla     ;v dx adresa cisel, bude sa zvacsovat o 2 Bajty
        mov cx, poccis           ;v cx pocet opakovani cyklu (velkost buffera)
zapis:  push cx                  ;1.cyklus-vypise cisla v znakoch do subora
        push dx                  ;ulozi hodnoty v registroch cx, dx, bx do zasobnika
        push bx
        mov bx, dx
        mov bx, [bx]             ;v bx - cislo na prevod do znakov (param KONVZN)
        call KONV2ZN             ;spravi prevod
        mov bx, offset cislozn   ;v bx adresa cisla v znakoch
        mov cx, 0                 
poczn:  cmp cx, 7                ;2.cyklus(vnutorny)-do cx nastavi pocet bitov, ktore sa jednorazovo zapisu do sub
        je kon3 
        cmp byte ptr[bx], '$'
        je kon3 
        inc bx
        inc cx
        jmp poczn
kon3:   mov byte ptr[bx], 0ah    ;do buffera miesto $ da 0ah - novy riadok
        inc cx
        pop bx                   
        mov dx, offset cislozn   ;vypise cx znakov ukoncenych 0ah z buffera cislozn do subora 
        mov ah, 40h
        int 21h
        pop dx
        add dx, 2
        pop cx
        loop zapis
        mov ah, 3eh              ;zavrie subor
        int 21h
        ret
ULOZSUB endp

VYPVSC  proc                     ;vypise vsetky nacitane cisla zo suboru
        mov dx, offset textV
        mov ah, 09h
        int 21h
        mov cx, poccis           ;pocet krokov = pocet cisel
        mov si, offset cisla
vyp1:   mov bx, [si]
        call KONV2ZN             ;zapise cislo v bx (bin.zapis) do cislozn v znakoch 
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        mov dl, 20h              ;vypise medzeru
        mov ah, 02h
        int 21h
        add si, 2                      
        loop vyp1
        ret
VYPVSC  endp

ZADA    proc                     ;spravi sumu zo vsetkych cisel           
        mov si, offset cisla
        mov cx, poccis
        mov bx, 0                ;v bx bude suma
opakA:  add bx, [si]
        jo overfA
        add si, 2
        loop opakA
        jmp konA
overfA: mov dx, offset textERR   ;skoci sem a ukonci cyklus ak pretecenie
        mov ah, 09h
        int 21h  
konA:   mov dx, offset textA
        mov ah, 09h
        int 21h
        call KONV2ZN             ;zapise cislo v bx (bin.zapis) do cislozn v znakoch
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        ret
ZADA    endp

ZADB    proc                     ;triedi prvky v pameti pomocou maxsortu
        mov dx, offset textB
        mov ah, 09h
        int 21h
        mov cx, poccis           ;cx 1.cykl, ax 2.cykl(vnutorny - na hladanie maxim. prvku)          
opakB1: mov dx, 0
        mov ax, cx
        dec ax
        mov bx, 2
        mul bx  
        mov di, offset cisla
        add di, ax
        mov bx, offset cisla  
        mov ax, 1
opakB2: cmp ax, cx
        je B1                    ;ak je ax=cx ukonci hladanie max. prvku, a vymeni ich
        mov dx, [bx]
        cmp dx, [di]             ;ak v [bx] vacsi prvok ako v [di], bx do di, inak skoci na B2 (iteruje), porovnava v predpatom kode
        jle B2
        mov di, bx
B2:     add ax, 1
        add bx, 2
        jmp opakB2
B1:     mov dx, 0
        mov ax, cx
        dec ax
        mov bx, 2
        mul bx  
        mov bx, offset cisla
        add bx, ax
        mov dx, [bx]             ;vymeni prvky [bx], [di] - max
        mov ax, [di]
        mov [bx], ax
        mov [di], dx
        loop opakB1
        ret 
ZADB    endp

ZADC    proc
        mov znam, 1              ;znamienko-lebo budem delit kladne cisla 
        mov cx, 2
opakC:  mov dx, offset textCD1   ;hlaska
        mov ah, 09h              
        int 21h
        mov dx, offset keybin    ;nacita index 1.cisla   
        mov ah, 0ah
        int 21h
        add dx, 2
        call KONVZN2
        mov bx, offset cisla     ;zisti cislo
        mov ax, dx
        dec ax
        mov dx, 2
        mul dx
        add bx, ax
        mov bx, [bx]             ;ulozi cislo do zasobnika
        call KONV2ZN             ;vypise sa cislo 
        mov dx, offset textCD2
        mov ah, 09h
        int 21h
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        cmp bx, 32768            ;ak je zaporne zmeni na kladne a znamienko vynasobi -1
        jb ulC
        neg bx
        neg znam
ulC:    push bx                                 
        loop opakC
        pop bx                   ;vydeli
        mov dx, 0
        pop ax
        idiv bx
        push dx                  ;zvysok do zasobnika
        mov bx, ax
        cmp znam, -1
        jne vyppC
        neg bx        
vyppC:  call KONV2ZN             ;vypise sa podiel
        mov dx, offset textC1   
        mov ah, 09h
        int 21h 
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        pop bx                   ;vyberie zvysok zo zasobnika
        call KONV2ZN             ;vypise sa zvysok po deleni 
        mov dx, offset textC2    
        mov ah, 09h
        int 21h 
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        ret 
ZADC    endp

ZADD    proc
        mov cx, 2
opakD:  mov dx, offset textCD1   ;hlaska
        mov ah, 09h              
        int 21h
        mov dx, offset keybin    ;nacita index 1.cisla   
        mov ah, 0ah
        int 21h
        add dx, 2
        call KONVZN2
        mov bx, offset cisla     ;zisti cislo
        mov ax, dx
        dec ax
        mov dx, 2
        mul dx
        add bx, ax
        mov bx, [bx]             ;ulozi cislo do zasobnika
        push bx                                 
        call KONV2ZN             ;vypise sa cislo 
        mov dx, offset textCD2
        mov ah, 09h
        int 21h
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        loop opakD               ;cyklus na nacitanie 2 cisel 
        pop bx                   ;vynasobenie cisel
        mov dx, 0
        pop ax
        imul bx
        jno D1
        mov dx, offset textERR   ;ak doslo k preteceniu vypise chybu
        mov ah, 09h
        int 21h
D1:     mov bx, ax               ;vypise sa sucin
        call KONV2ZN             
        mov dx, offset textD   
        mov ah, 09h
        int 21h 
        mov dx, offset cislozn
        mov ah, 09h
        int 21h
        ret 
ZADD    endp


start:  
        mov ax, seg data
	mov ds, ax

        call NACSUB
hlckl:  mov dx, offset menu      ;vypise aj menu
        mov ah, 09h
        int 21h                 
hlckl1: mov ah, 08h              ;bez vypisu menu (ak iny znak ako v case)
        int 21h
        mov dl, al                  
pol1:   cmp dl, 'k'              ;akysi case podla znaku v dl (vykona volanie podprogramu)
        je koniec
pol2:   cmp dl, 'n' 
        jne pol3
        call NACSUB
        call VYPVSC
        jmp hlckl
pol3:   cmp dl, 'v'
        jne pol4
        call VYPVSC
        jmp hlckl
pol4:   cmp dl, 'a'
        jne pol5
        call ZADA
        jmp hlckl
pol5:   cmp dl, 'b'
        jne pol6
        call ZADB
        call ULOZSUB
        call VYPVSC
        jmp hlckl
pol6:   cmp dl, 'c'
        jne pol7
        call VYPVSC
        call ZADC
        jmp hlckl
pol7:   cmp dl, 'd'
        jne pol8
        call VYPVSC
        call ZADD
        jmp hlckl
pol8:   jmp hlckl1

koniec:	mov ax, 4c00h            ;ukonci program
	int 21h
	ends
	end start

;Zhodnotenie : Program bol vytvoreny pre verziu Turbo Assembleru 
;2.02 a vyssiu, kde funguje bez problemov. Co sa tyka technickej 
;vybavy, bol testovany na pocitaci AMD K7 DURON 600MHZ, avsak 
;ziadne zle spravanie programu v dosledku moznej nekompatibility 
;medzi procesormi od AMD a Intelu sa nevyskytli. Program ma iste 
;obmedzenia v ramci vstupnych udajov zo subora, pretoze ich pocet 
;by teoreticky nemal presiahnut 2-Bajtovu hodnotu ( 65536 ). 
;Dovodom je pouzivanie 2-Bajtovych registrov na indexovanie 
;v bufferi s cislami. Prakticky vsak pole s cislami nesmie 
;prekrocit velkost 1-eho segmentu v pamati, takze najviac sa mi 
;podarilo pracovat so 4000-mi hodnotami. Druhe obmedzenie sa tyka 
;velkosti spracovavanych cisel, ktore mozu byt maximalne 2-Bajtove 
;( velkosti registrov ) od -32768 po 32767.
