
;                                Zadanie c.1.
;
; Text zadania:  Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) 
;                a podla ponukaneho menu vykona jednu z moznosti:
;         
;		a) vypise retazec znakov na obrazovku
;		b) vypise poradove cislo miesta, kde sa nachadza prva medzera,
;		c) hlada v retazci zadany znak a pocet jeho vyskytov ulozi do CX 
;		d) najde znak s max. hodnotou a vypise tento znak
;		e) zarovna text zlava (vynecha prve medzery)
;		f) vypise retazec v obratenom poradi,
;		g) ukonci vykonvanie programu.
;
; 			      Autor:  M.Salai  
;		       Termin odovzdania: 24.10.2000
;		           2.roc.,sk.rok 2000/2001


.model large       ;definicia modelu

DATA   SEGMENT     ;definicia datoveho segmentu

;PREMENNE:         DLZKA - dlzka retazca
;                  RETAZEC - retazec o max. dlzke 100 znakov            

DLZKA  DB  0
TEXT        DB    '                                               ',13,10
            DB    '                              M  E  N  U                                                                                                         ',13,10
            DB    '                                                                                      ',13,10
            DB    ' a) vypis retazec znakov na obrazovku',13,10
            DB    ' b) vypis poradov cislo miesta, kde sa nachadza prva medzera',13,10
            DB    ' c) hladaj v retazci zadany znak a pocet jeho vyskytov ulozi do CX',13,10
            DB    ' d) najdi znak s max. hodnotou a vypis tento znak',13,10
            DB    ' e) zarovnaj text zlava (vynechaj prve medzery)',13,10
            DB    ' f) vypis retazec v obratenom poradi',13,10
            DB    ' g) ukonci vykonavanie programu',13,10,13,10
            DB    ' $'
UVOD        DB    'Zadaj retazec (max.100 znakov) :  $'
ERROR       DB    13,10,13,10,13,10,13,10
            DB    '              Retazec uz ma 100 znakov! Stlac enter$'
TEXT2       DB    13,10,13,10,13,10,13,10,13,10
            DB    '              Maximalny znak v retazci je:    $'
TEXT3       DB    13,10,13,10,13,10,13,10
            DB    ' Zadany znak sa v retazci nachadza,pocet jeho vyskytov je: $'
CHYBA2      DB    13,10,13,10,13,10,13,10
            DB    '             Zadany retazec neobsahuje medzeru!                            $'
CHYBA3      DB    13,10,13,10,13,10,13,10
            DB    '            Zadany znak sa v retazci nenachadza!                 $'  
MIESTO      DB    13,10,13,10
RETAZEC     DB    100 DUP(?)

DATA   ENDS                        ;koniec datoveho segmentu


CODE   SEGMENT                     ;zaciatok hlavneho programu
       ASSUME CS:CODE, DS:DATA     ;asociacia

START:                             ;navestie START odkial sa zacne vykonavat program
       MOV  AX, SEG DATA           ;deklaracia  
       MOV  DS, AX
       MOV  SI, OFFSET RETAZEC     ;do SI ulozim adresu retazca
       MOV  DX, OFFSET UVOD        ;do registra DX dam adresu textu UVOD
       XOR  CX,CX                  ;vynulovanie registra
       MOV AX,03H                  ;vycistenie obrazovky
       INT 10H

       MOV AH,09H                  ;vypis obsahu DX t.j. textu UVOD
       INT 21H

NACITAJ:                   ;navestie nacitaj
        MOV  AH,1          ;prerusenie na nacitanie znaku z klavesnice
        INT  21H
  
        MOV [SI],AL        ;vlozim znak do retazca
        INC SI             ;zvysim SI
        MOV DLZKA,CL       ;pocet znakov si odlozim do pomocnej premennej DLZKA
        CMP AL,13          ;zistim, ci bol stlaceny ENTER
        JE PRIDAJ          ;ak ano, skoci na navestie PRIDAJ

        INC CL             ;zvysim pocitadlo znakov
        CMP CL,99          ;zistim ci uz pocet znakov je rovny 100
        JE  CHYBA          ;ak ano, skocim na CHYBU
 
        JMP NACITAJ        ;inak skocim spat na zaciatok navestia

MENU :                     ;navestie menu (sluzi na vykreslenie menu)
        MOV  DX, OFFSET TEXT    
        MOV  SI, OFFSET RETAZEC  ;do SI si dam adresu retazca
        MOV  BH,0          

        MOV AH,02H         ;nastavenie kurzora
        INT 10H            ;prerusenie 

        MOV  AH, 09H       ;vypis menu na obrazovku
        INT  21H

        XOR AX,AX          ;vynulovanie registrov
        XOR DL,DL          
        MOV CL,1           ;priprava registrov
        MOV DH,15          ;nastavenie kurzora na riadok

        MOV  AH,8          ;nacitanie znaku z klavesnice bez echa
        INT  21H
        CMP AL,'a'         ;porovna stlaceny znak s 'a'
        JE VYPIS           ;ak bol stlaceny tak skoci na navestie VYPIS
        CMP AL,'b'         ;inak testuje stlaceny klaves podobnym sposobom dalej
        JE MEDZERA_PR
        CMP AL,'c'
        JE ZNAK1
        CMP AL,'d'
        JE MAX_ZNAK1
        CMP AL,'f'
        JE OPAK
        CMP AL,'e'
        JE ZAROVNAJ1
        CMP AL,'g'
        JE KONIEC1        ;ak nebol stlaceny ziadny zo znakov a az g
        JMP MENU          ;skok naspat na MENU

PRIDAJ:                   ;navestie na pridanie koncoveho znaku retazca
       XOR  CX,CX         ;vynulovanie registra CX
       MOV AX,03H         ;vycistenie obrazovky
       INT 10H

       MOV byte ptr [SI-1],'$'  ;prida ukoncovaci znak retazca

       JMP MENU             ;skoc na navestie MENU

MEDZERA_PR: JMP MEDZERA1    ;medziskoky
MAX_ZNAK1:  JMP MAX_ZNAK
ZNAK1:      JMP ZNAK

CHYBA:                      ;navestie chyba (ak ma retazec uz 100 znakov)
       MOV  DX, OFFSET ERROR
       XOR  CX,CX           ;vynulovanie registra
       MOV AX,03H           ;vycistenie obrazovky
       INT 10H

       MOV AH,09H           ;vypis obsahu DX t.j. textu ERROR
       INT 21H

       MOV byte ptr [SI],'$'  ;prida ukoncovaci znak retazca

       JMP TESTING          ;skoci dalej na navestie TESTING

TESTING:                      ;testuje stlacenie enteru
       MOV  AH,8              ;nacita stlaceny klaves
       INT  21H
       CMP AL,13              ;porovna s enterom
       JE  CISTENIE           ;ak bol stlaceny tak skoci na CISTENIE
       JMP TESTING            ;inak opakuje cyklus

CISTENIE: 
       MOV AX,03H             ;vycistenie obrazovky
       INT 10H
       JMP MENU               ;skok do MENU

OPAK:                          ;vypis retazca v opacnom poradi
     MOV SI,OFFSET RETAZEC     ;vlozime do si adresu retazca
     XOR AX,AX                 ;vynulovanie registra AX
     MOV AL,DLZKA              ;do AL vlozime DLZKU
     ADD SI,AX                 ;pripocitame k SI hodnotu AX (cize dlzku retazca)
                               ;a tym sa dostaneme na koniec retazca
    
VYBER_OB:
     MOV DL,[SI-1]            ;do DL vlozim predposledny znak 
     DEC SI                   ;znizim SI
     MOV AH,02H               ;zobrazim retazec po znaku
     INT 21H
     DEC DLZKA                ;znizim DLZKU 
     CMP DLZKA,0              ;a kontrolujem ci uz nie som na zaciatku retazca
     JNE VYBER_OB             ;ak nie proces opakujem,ak ano
     JMP MENU                 ;skocim naspat do MENU

MENU1: JMP MENU               ;medziskok

VYPIS: INC DL                 ;vypis retazca
       MOV AH,02H             ;nastavenie kurzoru
       INT 10H

       MOV AL,[SI]            ;nacitavam po znakoch retazec     
       CMP AL,'$'             ;porovnavam s koncovym znakom
       JE  MENU1              ;skocim do MENU  

       MOV AH, 0aH            ;vypis na poziciu kurzora
       INT 10H         
       INC SI                 ;zvysim SI, cim sa dostanem na dalsi znak
       JMP VYPIS              ;skok na zaciatok cyklu

KONIEC1:   JMP KONIEC         ;medziskoky
ZAROVNAJ1: JMP ZAROVNAJ

MEDZERA:                        ;zistenie pozicie prvej medzery
        MOV SI, OFFSET RETAZEC  ;nastavenie registrov
        XOR CX,CX
        XOR AX,AX
        JMP  MEDZERA1

MEDZERA1:                       ;cyklus
        MOV AL,[SI]             ;do AL davam jednotlive znaky retazca
        CMP AL,' '              ;porovnavam ich s medzerou
        JE TRUE                 ;ak nasiel medzeru skoci na navestie TRUE
        CMP AL,'$'              ;porovna znak s koncovym znakom retazca
        JE FALSE                ;ak ho nasiel tak skoci na navestie FALSE
        INC CL                  ;zvysi CL a SI
        INC SI
        JMP MEDZERA1            ;skok na zaciatok cyklu

TRUE:                           ;ak nasiel medzeru
         MOV AX,CX              ;do AX dame CX
         MOV DL,10              ;do DL dame 10
         DIV DL                 ;vydelime AX 10 
         MOV DX,AX              ;do DX priradime AX
	 ADD DL,30h             ;k podielu pridame zaciatok pismen
         MOV AH,02H             ;vypis cislice
         INT 21H                
         MOV DL,DH              ;teraz presunieme DH do DL
         ADD DL,30h             ;opat pripocitame k DL hodnotu 30h
         MOV AH,02H             ;a vypiseme druhu cislicu
         INT 21H
         JMP MENU               ;skok naspat do MENU

FALSE:                          ;ak nenasiel medzeru
       MOV  DX, OFFSET CHYBA2   ;vypise text CHYBA2
       MOV AH,09H
       INT 21H
       JMP MENU                 ;skok naspat do MENU

ZNAK:                          ;hladanie zadaneho znaku v retazci
     MOV AH,00H                ;volame cislo sluzby
     INT 16H                   ;vyvolame DOS-ovske prerusenie klavesnice,a pockame na nacitanie znaku
     XOR CX,CX                 ;vynulujeme register cx
     MOV SI,OFFSET RETAZEC     ;vlozime do SI adresu retazca

VYBER_ZA:
     MOV DL,[SI]               ;zoberime znak z retazca
     INC SI                    ;zvysime register si
     CMP DL,'$'                ;porovname znak s koncom retazca
     JE VYBER_ZC               ;ak je koniec skocime na navestie
     CMP DL,AL                 ;porovname zadany znak so znakom z retazca
     JE VYBER_ZB               ;ak sa rovnaju skocime na navestie
     JMP VYBER_ZA              ;vratime sa naspat na zaciatok
VYBER_ZB:
     INC CX                    ;tu zvysime register cx (pocet najdenych znakov)
     JMP VYBER_ZA              ;a vratime sa porovnavat dalej
VYBER_ZC:                   
     CMP CX,0                  ;porovname,ci sme nasli aspon jeden znak,ak nie
     JE VYBER_ERR              ;skocmie na navestie 

     MOV DX, OFFSET TEXT3      ;vypis textu

     MOV AH,09H                ;vypis retazca
     INT 21H

     MOV AX,CX                 ;do AX dame CX
     MOV DL,10                 ;do DL dame 10
     DIV DL                    ;vydelime AX 10 
     MOV DX,AX                 ;do DX priradime AX
     ADD DL,30h                ;k podielu pridame zaciatok pismen
     MOV AH,02H                ;vypis cislice
     INT 21H                
     MOV DL,DH                 ;teraz presunieme DH do DL
     ADD DL,30h                ;opat pripocitame k DL hodnotu 30h
     MOV AH,02H                ;a vypiseme druhu cislicu
     INT 21H
     
     JMP VYBER_ZEND            ;a skocime na koniec

VYBER_ERR:                     ;pokial sme nenasli ani jeden zhodny znak
      MOV  DX, OFFSET CHYBA3   ;vypis textu
      MOV AH,09H
      INT 21H

VYBER_ZEND:                    ;skoc naspat do MENU
      JMP MENU

ZAROVNAJ:                      ;zarovnanie retazca zlava

     MOV SI,OFFSET RETAZEC     ;ulozime si adresu nasho retazca do SI

VYBER_A:
     MOV DL,[SI]          ;vlozime do dl prvy znak z retazca
     INC SI               ;zvysime register si
     CMP DL,' '           ;porovname znak s medzerou, pokial sa rovna skocime naspat
     JE VYBER_A           ;takto opakujeme az kym neziskame pocet medzier na zaciatku
     DEC SI               ;ten je ulozeny v si, pricom musime znizit SI o jedno, pretoze sme ho zvysili o jedno naviac 
VYBER_B:
     MOV DL,[SI]          ;teraz zoberieme prvy znak za medzerami a vypiseme ho
     CMP DL,'$'           ;pokial je to koniec retazca,skoncime
     JE VYBER_END
     MOV AH,02H           ;vypiseme znak
     INT 21H
     INC SI               ;a zoberieme dalsi znak
     JMP VYBER_B          ;no a skocime na zaciatok cyklu vypisu
VYBER_END:
     JMP MENU             ;navrat do menu


MAX_ZNAK:                     ;hladanie max. hodnoty znaku v retazci

     MOV SI,OFFSET RETAZEC    ;vlozime do si adresu retazca
     MOV AL,[SI]              ;do al vlozime prvy prvok retazca

VYBER1:                       ;cyklus
     INC SI                   ;zvysim hodnotu registra si,teda zoberiem dalsi znak
     MOV DL,[SI]              ;vlozim ho do registra dl
     CMP DL,'$'               ;porovnam znak s koncom retazca
     JE VYBER1_END            ;ak je uz koniec, skocim na navestie 
     CMP DL,AL                ;porovnam registre dl a al,ak je register dl mensi 
     JNA VYBER1               ;skocim na zaciatok cyklu, v opacnom pripade
     MOV AL,DL                ;vlozim do al (najvacsi znak) register dl
     JMP VYBER1               ;skocim naspat na zaciatok cyklu

VYBER1_END:                   ;navestie ukoncenia
     MOV DL,AL                ;zobrazim najvacsi najdeny znak

     MOV AH,02H
     INT 21H

     JMP MENU                 ;vratim sa spat do menu

KONIEC: 
        MOV  AX, 4C00H       ;DOS-ovske prerusenie na ukoncenie programu
        INT  21H

CODE    ENDS                 ;koniec hlavneho programu
        END START            ;nastavenie zaciatku programu na navestie START


;ZHODNOTENIE:   Program je funkcny v potrebnom rozsahu.
;               Algoritmus celeho programu je zlozeny z obmedzeneho 
;               poctu instrukcii, pretoze som v Assembleri este zaciatocnik.
;               Co sa tyka zlepsenia, v buducnosti by som namiesto zloziteho
;               pouzivania medziskokov volal navestia ako procedury.

