;******************************************************************
;                         Zadanie c.3
;
;    S vyuzitim retazcovych instrukcii (vsade kde je to mozne) 
;    vytvorte program, ktory:
; a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov
;    (minimalne dlzky 20 Byte),
; b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
; c) porovna posunuty retazec s retazcom v druhom segmente, t.j.
;    zisti, ci su rovnako dlhe a ci su rovnake
; d) zisti, ci sa v niektorom z retazcov nachadza zadany podretazec.
;
;                  Autor:  Miloslav Salai  
;               Termin odovzdania: 5.12.2000
;                  2.roc.,sk.rok 2000/2001
;
;******************************************************************


.model large           ;definovanie typu programu
.stack 100h            ;vytvorenie zasobnika o velkosti 100b

RETAZEC1 SEGMENT       ;datovy segment s nazvom retazec1

 ret1    db  41 dup(?) ;sem sa ulozi prvy nacitany retazec

RETAZEC1 ENDS          ;koniec prveho datoveho segmentu

;-----------------------------------------------------------------------

RETAZEC2 SEGMENT       ;druhy datovy segment retazec2

 ret2    db  31 dup(?) ;sem sa ulozi druhy nacitany retazec

RETAZEC2 ENDS          ;koniec druheho datoveho segmentu

;-----------------------------------------------------------------------

DATA SEGMENT           ;datovy segment (pomocne premenne a texty)

 pom1        db  31 dup(?)     ;sem sa nacita prvy retazec
 pom2	     db  31 dup(?)     ;a sem druhy retazec
 pod_retazec db  31 dup(?)     ;sem sa nacita podretazec

 vstup1      db  'Zadaj prvy retazec (max 30.znakov): $' 
 vstup2      db  'Zadaj druhy retazec (max 30 znakov): $'
 vstup3      db  'Zadaj podretazec (max 30 znakov): $'    
 vypis1      db  'Prvy retazec bol posunuty v segmente o 10 slabik!$'
 vypis2      db  'Zadane retazce sa rovnaju!$'
 vypis3      db  'Zadany podretazec sa nachadza v prvom retazci!$'
 vypis4      db  'Zadany podretazec sa nachadza v druhom retazci!$'
 vypis_er1   db  'Zadane retazce sa nerovnaju!$'
 vypis_er2   db  'Zadany podretazec sa v prvom retazci nenachadza!$'
 vypis_er3   db  'Zadany podretazec sa v druhom retazci nenachadza!$'
 medzera     db  13,10,13,10
             db  '$' 
 medzera2    db  13,10
             db  '$'

DATA ENDS           ;koniec datoveho segmentu

;-----------------------------------------------------------------------

CODE SEGMENT                ;zaciatok hlavneho programu

 assume cs:code             ;priradime do cs kodovy segment

 vypis_ret proc near        ;procedura na zobrazenie retazca

     mov ah,09h             ;prerusenie na vypis retazca na obrazovku
     int 21h

     ret                    ;navrat cinnosti hlavnemu programu
 vypis_ret endp             ;koniec procedury

;-----------------------------------------------------------------------

 nacitaj proc near           ;procedura na nacitanie dvoch retazcov

  mov  dx,offset vstup1      ;do dx vlozime zaciatok textu vstup1
  call vypis_ret             ;vypiseme ho na obrazovku
  mov  bp,offset pom1        ;do bp vlozime zaciatok pom. retazca1
  mov  cx,30                 ;maximalny pocet znakov pre nacitany retazec           
  xor  bl,bl                 ;vynulovanie registra bl

prog:           

  mov  ah,01h                ;sluzba DOS-u na nacitanie znaku 
  int  21h                   ;z klavesnice do registra al
  mov  ds:[bp],al            ;znak vlozime do pomocnej premennej pom1
  inc  bp                    ;zvysime poziciu v retazci
  inc  bl                    ;zvysime pocet nacitanych znakov retazca1
  cmp  al,13                 ;porovname nacitany znak s enterom (koniec)
  je   prog2                 ;ak bol stlaceny enter tak skoc na navestie
  stosb                      ;ulozi obsah al na adresu es:di
  loop prog                  ;skok naspat na navestie porg
  mov  al,'$'                ;do al vlozime ukoncovaci znak
  mov  ds:[bp],al            ;a ten vlozime na koniec retazca
  inc  bl                    ;zvysime pocet znakov o jeden

prog2:                  

  dec  bl                    ;znizime pocet znakov o jeden
  mov  dx,offset medzera     ;do dx vlozime zaciatok textu medzera
  call vypis_ret             ;zobrazime ho na obrazovku
  mov  dx,offset vstup2      ;text vstup2
  call vypis_ret             ;vypis na obrazovku
  mov  bp,offset pom2        ;do bp vlozime zaciatok pomocnej prem. 2
  mov  cx,30                 ;maximalny pocet znakov pre nacitany retazec
  xor  bh,bh                 ;vymazanie registra bh

prog3:

  mov  ah,01h                ;znova DOS-ovske prerusenie na vstup
  int  21h                   ;z klavesnice do al
  mov  ds:[bp],al            ;znak ulozime do retazca
  inc  bp                    ;zvysime polohu v retazci
  inc  bh                    ;zvysime pocet znakov v retazci
  cmp  al,13                 ;porovname znak s enterom
  je   prog4                 ;ak sa rovnaju skok na navestie
  stosb                      ;vyobrazenie znaku na obrazovku
  loop prog3                 ;skok naspat na navestie prog3
  mov  al,'$'                ;do al vlozime ukoncovaci znak
  mov  ds:[bp],al            ;a ten vlozime na koniec retazca
  dec  bp                    ;znizime poziciu v retazci
  inc  bh                    ;zvysime pocet znakov v retazci

prog4:                  

  dec  bh              
  mov  dx,offset medzera     ;do bp vlozime text medzera
  call vypis_ret             ;zobrazime ho na obrazovku
  mov  dx,offset vstup3      
  call vypis_ret           
  mov  bp,offset pod_retazec ;do bp vlozime zaciatok podretazca
  mov  cx,30                 ;maximalny pocet znakov pre nacitany retazec
  xor  dl,dl                 ;vynulujeme register dl

prog5:

  mov  ah,01h                ;DOS-ovska sluzba na nacitanie znaku
  int  21h                   ;do registra al
  mov  ds:[bp],al            ;znaky zapiseme do premennej pod_retazec
  inc  dl                    ;zvysime pocet nacitanych znakov
  inc  bp                    ;zvysime poziciu v retazci
  cmp  al,13                 ;porovname nacitany znak s enterom
  je   prog6                 ;ak sa rovnaju skok na prog6
  stosb                      ;zapis znaku na obrazovku
  loop prog5               
  mov  al,'$'                ;do al vlozime ukoncovaci znak
  mov  ds:[bp],al            ;a ten vlozime na koniec retazca
  inc  dl                    ;zvysime pocet znakov v retazci o jednotku

prog6:          

  dec  dl                    ;znizime pocet znakov o jednotku
  push dx                    ;ulozime si obsah registra dx do zasobnika
  mov  dx,offset medzera     ;do dx vlozime text medzera
  call vypis_ret             ;zobrazime ho na obrazovku
  pop  dx                    ;vyberieme dx zo zasobnika

  ret
 nacitaj endp               ;koniec procedury nacitaj

;-----------------------------------------------------------------------

 kopiruj proc near       ;procedura na prekopirovanie retazcov do 
                         ;dvoch samostatnych segmentov

   mov  ax,seg RETAZEC1  ;do ax dame segment retazec1
   mov  es,ax            ;a ten dame do registra es
   mov  ax,seg DATA      ;do ax dame segment data
   mov  ds,ax            ;a ten dame do registra ds
   mov  di,offset ret1   ;do di vlozime adresu zaciatku retazca ret1
   mov  si,offset pom1   ;do si vlozime adresu zaciatku pomocneho retazca1 
   mov  cx,31            ;pocet kopirovanych znakov
   rep                   ;opakuj retazcovu instrukciu movsb
   movsb                 ;z adresy DS:[SI] kopiruj na ES:[DI]
   mov  ax,seg RETAZEC2  ;teraz do ax dame segment retazec2
   mov  es,ax            ;a ten dame do es
   mov  ax,seg DATA      ;a ds zostava ten isty = segment data
   mov  ds,ax
   mov  di,offset ret2   ;do di dame zaciatok retazca dva (ret2)
   mov  si,offset pom2   ;a do si dame zaciatok pomocneho (nacitaneho)
                         ;retazca dva
   mov  cx,31            ;pocet kopirovanych znakov
   rep                   ;opakuj retazcovu instrukciu movsb
   movsb                 ;kopirovanie cx znakov z DS:[SI] na ES:[DI]

   ret                   ;vrat cinnost hlavnemu programu
 kopiruj endp            ;koniec procedury na kopirovanie retazcov 

;-----------------------------------------------------------------------

  posun proc near          ;procedura na posunutie retazca1
                           ;o 10 slabik na vyssie adresy

   mov  ax,seg RETAZEC1    ;do ax vlozime segment retazec1
   mov  es,ax              ;a ten priradime do es
   mov  ax,seg DATA        ;do ds vlozime segment data
   mov  ds,ax
   xor  cx,cx              ;vymazeme obsah registra cx
   mov  cl,bl              ;do cl vlozime pocet znakov prveho retazca
   mov  si,offset pom1     ;do si dame zaciatok pomocneho retazca pom1 
   mov  di,offset ret1     ;a do di offset nasho retazca1
   add  di,10              ;di zvysime o 10 slabik
   rep                     ;opakuje retazcovu instrukciu movsb
   movsb                   ;kopirujeme pomocny retazec pom1 do retazca
                           ;ret1 na vyssie adresy
   push dx                 ;ulozime obsah dx do zasobnika
   mov  dx,offset medzera2 ;text, ktory budeme vypisovat
   call vypis_ret          ;zobrazenie retazca cez proceduru vypis_ret
   mov  dx,offset vypis1   ;text, ktory budeme vypisovat
   call vypis_ret          ;zobrazenie retazca cez proceduru vypis_ret
   pop  dx                 ;vyberieme obsah dx zo zasobnika

   ret                     ;vratime cinnost hlavnemu programu
 posun endp                ;koniec procedury na posunutie retazca
 
;-----------------------------------------------------------------------
  podretazec proc near     ;procedura na vyhladanie zadaneho podretazca 
                           ;v obidvoch retazcoch

     mov  ax,seg RETAZEC1  ;do ax dame segment retazca1
     mov  es,ax            ;a ten priradime registru es
     mov  ax,seg data     
     mov  ds,ax            ;do ds dame segment data
     mov  di,offset ret1   ;do di vlozime adresu retazca1
     add  di,10            ;zvysime o desat, cim sa dostaneme na jeho zaciatok
     xor  cx,cx            ;vymazeme obsah registra cx
     mov  cl,bl            ;do cl vlozime pocet znakov prveho retazca
     add  cx,10
     inc  cl               ;a o jedno register cl zvysime

   pod4:

     xor  ax,ax            ;vynulujeme register ax
     mov  si,offset pod_retazec ;a do si dame zaciatok premennej pod_retazec
     xor  dh,dh            ;vymazeme register dh         
     lodsb                 ;nacitame znak z DS:[SI] do registra al
     repne                 ;nasledujucu retazcovu instrukciu opakujeme
                           ;pokial nenajdeme dva zhodne znaky
     scasb                 ;poravnava znak v al so znakom na adrese ES:[DI]
     mov  ah,cl            ;do ah vlozime obsah cl (v cykle sa znizuje)
     cmp  cl,0             ;a porovname s nulou 
                           ;ak sa rovna, znamena to, ze sme presli cely prvy 
                           ;retazec presli a nenasli v nom prvy znak podretazca
     je   pod_koniec       ;skocime na koniec

   pod3:               

     lodsb                ;tu nacitame dalsi znak z podretazca
     repne                ;opakujeme scasb, kym nenajdeme dva rovnake znaky             
     scasb            
     dec  ah              ;znizime register ah o jednotku
     inc  dh              ;a zvysime register dh (pocet porovnanych znakov) 
     cmp  dh,dl           ;porovname ho s poctom znakov podretazca
     je   pod_ano_koniec  ;ak sa zhoduju, nasli sme podretazec a skocime
                          ;na koniec
     cmp  ah,cl           ;porovname cl s ah (ak sa rovnaju znamena                          
                          ;to,ze sme nasli dalsi znak podretazca v retazci
     je   pod3            ;a skocime na navestie opakovania
     cmp  dl,cl           ;porvname cl s poctom znakov v retazci
                          ;(ak je cl mensie tak podretazec sa uz v 
                          ;retazci nachadzat nemoze)
     jna  pod4         

   pod_koniec:            ;pokracujeme vypisom hlasenia

     mov  ax,seg data     ;do ds dame segment dat 
     mov  ds,ax          
     push dx              ;uchovame si hodnotu registra dx v zasobniku  
     mov  dx,offset medzera2  ;adresa retazca na vypis
     call vypis_ret       ;pomocou procedury vypis retazca na obrazovku
     mov  dx,offset vypis_er2 ;adresa retazca na vypis
     call vypis_ret       ;pomocou procedury vypis retazca na obrazovku
     pop  dx              ;vyberieme hodnotu registra dx zo zasobnika
     jmp  pod11           ;skok na navestie     

   pod_ano_koniec:        ;to iste ako predosle riadky

     mov  ax,seg data     ;lisia sa iba vypisom na obrazovku
     mov  ds,ax           ;vypisujeme iny text
     push dx
     mov  dx,offset medzera2 ;adresa retazca na vypis
     call vypis_ret       ;pomocou procedury vypis retazca na obrazovku
     mov  dx,offset vypis3
     call vypis_ret
     pop  dx

   pod11:                 ;na tomto navesti porovnavame podretazec
                          ;s retazcom cislo 2
     mov  ax,seg RETAZEC2 
     mov  es,ax           ;porovnanie je uple rovnake ako pri retazci cislo 1
     mov  ax,seg data     
     mov  ds,ax
     mov  di,offset ret2
     xor  cx,cx
     mov  cl,bh           ;jeho dlzka je tentokrat ulozena v registri bh
     inc  cl              

   pod14:

     xor  ax,ax           ;nulovanie registra ax
     mov  si,offset pod_retazec ;do si vlozime zaciatok pod_retacza
     xor  dh,dh           ;nulovanie registra bh
     lodsb                ;nacitanie znaku z DS:[SI] do al
     repne                ;opakuj pokial nie je rovne
     scasb                ;porovnaj al s ES:[DI]
     mov  ah,cl           ;do ah vloz cl
     cmp  cl,0            ;porovnaj cl s nulou
     je   pod2_koniec     ;ak je cl nulovy skoc na koniec,podretazec 
                          ;sme v retazci nenasli
   pod13:

     lodsb                ;inak nacitaj dalsi znak z DS:[SI]
     repne              
     scasb                ;a porovnaj ho s ES:[DI]
     dec ah               ;zniz hodnotu registra ah o jednotku
     inc dh               ;a register dh zvys o jednotku
     cmp dh,dl            ;porovnaj ho s dlzkou retazca
     je  pod2_ano_koniec
     cmp ah,cl            ;porovnaj ci sa nasiel znak hned za predoslym
                          ;znakom
     je  pod13            ;ak ano pokracuj v hladani dalsich znakov
     cmp dl,cl            ;ak nie porovnaj dlzku retazca s este                         
                          ;neprezretymi znakmi 
     jna pod14            ;pokial ich je menej ako dlzka podretazca tak skonci

   pod2_koniec:        

     mov  ax,seg data     ;vypis na obrazovku
     mov  ds,ax          
     mov  dx,offset medzera2 ;adresa retazca na vypis
     call vypis_ret       ;pomocou procedury vypis retazca na obrazovku
     mov  dx,offset vypis_er3 ;text
     call vypis_ret    
     ret                  ;vratime cinnost hlavnemu programu

   pod2_ano_koniec:

     mov  ax,seg data     
     mov  ds,ax
     mov  dx,offset medzera2 ;adresa retazca na vypis
     call vypis_ret       ;pomocou procedury vypis retazca na obrazovku
     mov  dx,offset vypis4
     call vypis_ret
     ret                  ;vratime cinnost hlavnemu programu

  podretazec endp         ;koniec procedury na vyhladanie podretazca  

;-----------------------------------------------------------------------

  porovnaj proc near           ;procedura na porovnanie dlzky a obsahu
                               ;dvoch retazcov
     xor  dl,dl                ;vymazeme obsah registra dl     
     mov  dl,bl                ;vlozime tam pocet znakov retazca1
     mov  ax,seg RETAZEC1      ;do ax vlozime segment retazca1 (datovy)
     mov  es,ax       	       ;ten priradime registru es
     mov  ax,seg RETAZEC2
     mov  ds,ax        	       ;registru ds priradime segment retazec2 
     mov  di,offset ret1       ;do di vlozime zaciatok retazca1
     add  di,10                ;a zvysime ho o 10 slabik 
     mov  si,offset ret2       ;a do si vlozime zaciatok retazca2
     xor  cx,cx                ;vynulujeme register cx
     cmp  bl,bh                ;porovname dlzky retazcov
     jne  por_false            ;ak sa nerovnaju je zbytocne ich dalej porovnavat
     mov  cl,bl    	       ;ak nie do cl vlozime pocet znakov retazca1
     inc  cl                   ;ten zvysime o jednotku
     repe                      ;a opakujeme porovnavanie adries ES:[DI] a
     cmpsb         	       ;DS:[SI] az kym nenarazime na rozne znaky
                               ;alebo cl sa rovna nule
     cmp  cl,0     	       ;porovname cl s nulou
     jne  por_false            ;ak sa rovnaju, aj retazce sa rovnaju
     xor  dx,dx                ;vynulovanie registra dx
     mov  ax,seg data          ;vypis hlasenia na obrazovku
     mov  ds,ax
     mov  dx,offset medzera2   ;text na vypis
     call vypis_ret            ;zobrazenie retazca cez proceduru vypis_ret
     mov  dx,offset vypis2     ;text na vypis
     call vypis_ret            ;procedura na vypis retazca
     ret                       ;vratenie cinnosti hlavnemu programu

    por_false:

     mov  ax,seg data          ;vypisanie textu
     mov  ds,ax
     mov  dx,offset medzera2   ;text na vypis
     call vypis_ret            ;zobrazenie retazca cez proceduru vypis_ret
     mov  dx,offset vypis_er1  ;text na vypis
     call vypis_ret            ;vypisanie na obrazovku
     ret                       ;vratenie cinnosti hlavnemu programu
 
  porovnaj endp                ;koniec procedury na porovnanie retazcov

;-----------------------------------------------------------------------

START:                         ;zaciatok hlavneho programu

  mov  ax,03h                  ;vycistenie obrazovky
  int  10h
  mov  ax,seg data             ;do ax vlozime segmentovu cast dat
  mov  ds,ax
  call nacitaj                 ;volanie jednotlivych procedur
  call kopiruj              
  call posun                
  call podretazec           
  call porovnaj             
  mov  ah,00h                  ;cakanie na stlacenie lubovolnej klavesy
  int  16h 

 koniec:                       ;koniec programu

  mov ax,4c00h          
  int 21h

  ends                         ;koniec kodoveho segmentu
  end start                    ;definujeme na ktorom navesti zacina 
                               ;hlavny program


;*********************************************************************
;                      Z H O D N O T E N I E
;
; Program je funkcny, pricom nie je citlivy na ziadny vstup (pracuje 
; s kazdym retazcom). Je napisany v manazeri FM602 pod DOS-om a bol 
; spracovany pomocou programov TASM verzia 2.02 a TLINK verzia 3.01. 
; Je tvoreny najma procedurami, ktore su volane z programu a nazajom. 
; Sprehladnuje to cely program a ulahcuje hladanie chyb. V programe 
; sa jednotlive moznosti nevyberaju cez menu, ale vykonavaju sa 
; postupne za sebou. 
;*********************************************************************
