;******************************************************************
;                         Zadanie c.2.
;
;   Vytvorte  program, ktory nacita z textoveho usboru postupnost 
;   celych cisel (aspon 10) so znamienkom  v desiatkovej ciselnej 
;   sustave, potom ich transformuje na cisla v dvojkovej ciselnej 
;    sustave v doplnkovom kode a potom podla priania pouzivatela
;
;      a) vypocita sumu  vsetkych cisel a vypise ju
;      b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;         do noveho textoveho suboru,
;      c) vydeli dve vybrane cisla a vypise vysledok
;      d) vynasobi dve cisla a vypise vysledok
;      e) ukonci vykonavanie programu.
;
;                  Autor:  Miloslav Salai  
;               Termin odovzdania: 14.11.2000
;                  2.roc.,sk.rok 2000/2001
;******************************************************************

.model large               ;definovanie modelu programu
.stack 100h                ;vytvorenie zasobnika o velkosti 100b

DATA SEGMENT  	;zaciatok datoveho segmentu,tu sa deklaruju premenne
menu 	     db  ' M E N U '          
menu1 	     db  '1.         Vypis sucet vsetkych cisiel       '
menu2        db  '2.  Usporiadaj cisla vzostupne a zapis do suboru'
menu3 	     db  '3.     Vydel dve cisla a vypis vysledok      '
menu4 	     db  '4.    Vynasob dve cisla a vypis vysledok     '
menu5 	     db  '5.              Koniec programu              '
prava        db  'C I S L A:'       
sucet_text   db  'Sucet vsetkych cisel je:'
sucin_text   db  'Sucin vybranych cisel je:'
podiel_text  db  'Podiel vybranych cisel je:'
zvysok_text  db  'zvysok:'
usp_text     db  'Vzostupne usporiadane cisla: '
cislo1_text  db  'Vyber si 1. cislo:'
cislo2_text  db  'Vyber si 2. cislo:'
cislo2 	     db   ?   
cislo1       db   ?
subor 	     db  'cisla.txt',0  ;nazov suboru,kde su vstupne data(cisla)
subor2       db  'vystup.txt',0 ;nazov suboru na ulozenie cisel
cisla_nac    db   60 dup(?)     ;tu sa ukladaju nacitane cisla zo suboru
cisla_konv   db   10 dup(?)     ;prekonvertovane cisla z nacitaneho suboru
cisla_usp    db   10 dup(?)   	;usporiadane cisla
cisla_vloz   db   60 dup(?)   	;usporiadane cisla na zapis do suboru
DATA ENDS                   	;koniec segmentu dat



CODE SEGMENT             ;zaciatok vykonnej casti
ASSUME CS:code,ds:data   ;priradenie ds: segment dat, cs:kod


   vymaz_ret proc near   ;procedura na vymazanie retazca

    vym:
     mov dl,0+0          ;nastavime farbu pozadia
     mov [si+0],dl       
     mov dl,' '          ;a znak, ktory sa bude zobrazovat
     call zobraz_char    ;zavolame proceduru na zobr. znaku
     inc di              ;posunieme poziciu na obrazovke
     inc di              ;o jeden
    loop vym             ;odcitame a porovname register cx s nulou
                         ;ak sa nerovnaju idem na navestie vym
     mov dl,15+0         ;ak ano nastavim povodnu farbu
     mov [si+0],dl       ;
   ret                   ;vratim cinnost hlavnemu programu

   vymaz_ret endp        ;koniec procedury na vymazanie retazca    

   zobraz_char proc near ;procedura na zobrazenie znaku na obrazovku

     mov es:[di],dl      ;vlozenie znaku do videoram dl-znak
     mov al,[si+0]       ;do al vlozime farbu znaku
     mov es:[di+1],al    ;a potom znova do videoram

     ret                 ;vratime cinnost hlavnemu programu

   zobraz_char endp      ;koniec procedury na zobrazenie znaku
 
   zobraz_ret proc near  ;procedura na zobrazenie retazca

   pok:
     mov dl,ds:[bp]      ;z adresy ds:[bp] vyberieme znak       
     mov es:[di],dl      ;a vlozime ho do videoram
     mov al,[si+0]       ;nastavime farbu akou sa ma znak zobrazit
     mov es:[di+1],al    ;aj tu vlozime do videoram
     inc di              ;zvysime register di o jednotku
     inc di              ;a este o jednu jednotku
     inc bp              ;aj register bp zvysime o jednotku
     loop pok            ;pokial je cx rozne od nuly tak cely cyklus
                         ;opakujeme
     ret                 ;vratime cinnost hlavnemu programu

   zobraz_ret endp       ;koniec procedury na zobrazenie retazca

  proc nacitaj near          ; procedura na nacitanie dat zo suboru
     mov ah,3dh              ; otvor subor
     mov al,0                ; na citanie 
     mov dx,offset subor     ; ide o subor cisla.txt
     int 21h
     mov dx,offset cisla_nac ; bude sa ukladat do pamati
     mov cx,1                ; po jednom znaku
     mov bx,ax               ; do bx daj handler otvoreneho suboru
    citaj:	
     mov ah,3fh              ; citaj subor
     int 21h
     inc dx	             ; priprav adresu pre ulozenie dalsieho
                             ; znaku do pamati
     cmp ax,0                ; bol EOF?
     jne citaj               ; ak ano vyskoc z cyklu
     mov ah,3eh              ; zatvorenie suboru
     mov bx,ax
     int 21h
     ret                     ; a vrat cinnost hlavnemu programu
   nacitaj endp              ; koniec procedury na nacitanie dat z txt 

  proc transf near             ;procedura na transformovanie ziskanych
     xor bx,bx                 ;znakov na cisla
     xor ax,ax        
     xor cx,cx                 ;vynulujeme potrebne registre
     mov di,offset cisla_konv  ;v di je adresa uz prekonvertovanych cisel
     mov bp,offset cisla_nac   ;a v bp adresa nacitanych znakov
    transf1:                   ;v subore su data cisla ulozene 
     mov dl,ds:[bp]            ;na piatich miestach
     cmp dl,'-'                ;kedze cisla su 8-bitove tak 1. miesto 
     je transf2_1              ;je bud medzera alebo minus,ak
                               ;minus skocime na navestie 
    transf2:           
     inc bp            ;druha cifra je bud znamienko
     mov dl,ds:[bp]    ;a teda skocime na znamienkove navestie
     cmp dl,'-'
     je transf2_2
     cmp dl,' '        ;alebo medzera,a vtedy preskocim nasledujucu
     je transf3        ;instrukciu
     add bx,100        ;alebo je to jednotka a tak pridam do vysledneho
                       ;cisla 100
    transf3: 
     inc bp            ;dalsi znak moze byt bud minus,medzera alebo 
     mov dl,ds:[bp]    ;cislo
     cmp dl,'-'        ;podla toho o co sa jedna skocime na znamienko
     je transf2_3      
     cmp dl,' '        ;alebo neurobime nic
     je transf4
     sub dl,30h        ;alebo ak je to cislo na mieste desiatok
     mov al,dl         ;pricitame korekciu 30h
     mov dl,10         ;a vynasobime desiatimi
     mul dl            
     add bx,ax         ;tym dostaneme cislo na mieste desiatok         
                       ;a pricitame ho k vyslednemu cislu
    transf4:        
     inc bp            ;posledny znak moze byt uz iba cislo
     xor dx,dx       
     mov dl,ds:[bp]    ;tak ho nacitame
     sub dl,30h        ;vykoname korekciu
     add bx,dx         ;a pricitame,cim dostaneme hotove cislo
     inc bp            ;potom este porovname nasledujuci znak
     mov dl,ds:[bp]    ;s koncom nacitanych dat *
     cmp dl,'*'        ;ak sa zhoduju mame vsetky cisla prevedene
     je transf_hotovo  ;a skoncime
     inc bp          
     cmp cl,1          ;porovname,ci bolo cislo zaporne,ak ano
     je transf_minus   ;skocime na transf_minus
    transf5:
     mov ds:[di],bx    ;tu este vlozime vysledne cislo na adresu
     inc di            ;transformovanych ulozenych cisel
     xor bx,bx         ;vynulujeme register bx
     jmp transf1       ;a cely cyklus opakujeme s dalsimi znakmi
    transf2_1:         ;navestia na zistenie zaporneho cisla
     mov cl,1          ;ak je zaporne inicializujeme cl
     jmp transf2
    transf2_2:         ;to iste ako predosle naviestie
     mov cl,1
     jmp transf3
    transf2_3:      
     mov cl,1
     jmp transf4
    transf_minus:      ;ak sme zistili,ze cislo je zaporne
     neg bx            ;musime ho tak aj zobrazit cez funkciu neg
     xor cx,cx         ;vynulujeme register cx
     jmp transf5       ;a skocime na zapis cisla na adresu hotovych
    transf_hotovo:
     mov ds:[di],bx    ;ak sme nacitali posledne data ulozime posledne
                       ;este posledne cislo
     ret               ;a vratime cinnost hlavnemu programu
   transf endp         ;koniec procedury transf

   proc vyber1 near    ;procedura realizujuca scitanie vsetkych cisel
     mov dl,15+0       ;kod farby
     mov [si+0],dl     ;ulozenie farby do registra farby
     mov bp,offset sucet_text ;vypiseme text 
     mov di,3370
     mov cx,24
     call zobraz_ret   ;pomocou procedury zobraz_ret
     xor ax,ax         
     xor dx,dx         ;vynulujeme potrebne registre
     mov bp,offset cisla_konv ;do bp dame adresu cisel
     mov cx,10          ;a do registra cx ich pocet
    vybera:
     mov dl,ds:[bp]     ;zoberieme jedno cislo a pricitame do vysledku
     add al,dl          ;v al
     inc bp             ;posunieme ukazovatel na dalsie cislo
     loop vybera        ;a cely cyklus opakujeme az kym nie su scitane
                        ;vsetky cisla
     mov dl,10          ;kedze v tomto pripade je vysledne cislo mensie
     div dl             ;ako sto vydelime ho desiatimi a ziskame
     add ah,30h         ;obidve cifry
     add al,30h         ;k obidvom pricitame zaciatok cisel v ASCII
     mov dl,al          ;a postupne ich zobrazime
     mov di,3420
     call zobraz_char   ;najprv podiel (desiatky)
     mov dl,ah
     mov di,3422        ;a potom zvysok (jednotky)
     call zobraz_char
     jmp zaciatok       ;a skocime znova na zaciatok,do menu
     ret                ;vratime cinnost hlavnemu programu
   vyber1 endp          ;koniec procedury na sucet

   proc vyber2 near     ;procedura na zoradenie cisel
     mov cx,10          ;pocet cisel
     mov bp,offset cisla_konv ;najprv prekopirujeme cisla do
     mov di,offset cisla_usp ;pomocneho pola.pretoze ich budeme mazat
    vyber2_zac:
     mov dl,ds:[bp]     ;po jednom cisla kopirujeme cisla z cisla_konv
     mov ds:[di],dl     ;do cisla_usp
     inc di             ;zvysime ukazovatel v jednom
     inc bp             ;aj druhom poli a opakujeme
    loop vyber2_zac     ;kym nie su vsetky cisla prekopirovane
     xor cx,cx          ;vynulujeme register cx
     mov di,3370        ;poloha na obrazovke,ktoru budeme potrebovat   
     push di            ;neskor a preto ju vlozime do zasobnika
    vyber2_0:
     xor ax,ax          ;vynulujeme register ax
     mov bp,offset cisla_usp ;do bp dame adresu pola cisla_usp
     mov bl,ds:[bp]          ;vyberieme prvy prvok a porovname ho
     cmp bl,'+'              ;s mazacim znakom,ak sa rovnaju-skok
     je vyber2_plus2
    vyber2_a:              
     inc bp                  ;ak nie mame prve cislo
     inc ax                  ;zvysime ax (pocet cisel porovnanych)
     mov dl,ds:[bp]          ;a zoberieme druhe cislo
     cmp dl,'+'              ;pokial je tam mazaci znak (u mna +)
     je vyber2_b             ;nasleduje skok na vyber cisla
     cmp bl,dl               ;tu uz mame obidve cisla a porovname ich
     jg vyber2_vymen         ;ak je bl mensie nasleduje skok
    vyber2_b:
     cmp ax,9                ;tu porovnavame ci uz je posledne cislo
     jne vyber2_a            ;ak nie navrat a dalsie porovnavanie
     mov dl,'+'              ;teraz uz mame v bl najvacsi znak
     mov ds:[di],dl          ;preto na jeho poziciu dame 'nulovy' znak
     xor ah,ah               ;vynulujeme ah
     mov al,bl               ;do al dame cislo
     pop di                  ;teraz vyberieme zo zasobnika poziciu 
     cmp al,0                ;a porovname al z nulou             
     js vyber2_minus         ;ak je al zaporne cislo,dame znamienko
                             ;na navesti vyber2_minus
    vyber2_c:
     cmp al,100              ;pokial nie vypiseme cislo na obrazovku
                             ;zistime ci je vacsie ako sto ak ano-skok
     jg vyber2_up
    vyber2_vup:             ;ak nie jedna sa o cislo mensie ako sto              
     mov dl,10
     div dl                 ;preto ho vydelime desiatimi
     add ah,30h             ;a ziskame obidve cifry
     add al,30h             ;urobime korekciu pricitanim 30h
     inc di                 
     inc di                 ;posunieme kurzor o jednu poziciu
     mov dl,al              ;a vypiseme najprv desiatky
     call zobraz_char       
     mov dl,ah              ;potom znova zvysime poziciu kurzora
     inc di
     inc di
     call zobraz_char        ;a vypisem jednotky
     inc di                  ;potom kvoli prehladnosti este na dalsiu poziciu
     inc di                  ;vlozime ciarku na oddelenie cisel
     mov dl,','
     call zobraz_char        ;pomocou procedury zobraz_char
     push di                 ;potom si ulozime poziciu do zasobnika
     cmp cx,9                ;porovname ci sme uz zobrazili vsetky cisla 
     je vyber2_hot           ;ak ano tak skoncime
     inc cx                  ;ak nie zvysime pocet zobrazenych cisel
     jmp vyber2_0            ;a pokracujeme ziskanim dalsiho cisla na
                             ;zaciatok cyklu
    vyber2_vymen:            ;ak je dl vacsie ako doterajsie cislo
     mov bl,dl               ;tak ich tu vymenime
     mov di,bp            
     jmp vyber2_b            ;a pokracujeme v cykle hore
    vyber2_plus2:            ;pokial sme narazili na 'nulovy' znak         
     inc bp                  ;zoberieme dalsie cislo za nim
     inc ax                  ;zvysime pocet porovnanych cisel
     mov bl,ds:[bp]       
     cmp bl,'+'              ;a porovname cislo s 'nulovym' znakom
     je vyber2_plus2         ;pokial sa rovnaju skusime zobrat dalsie                           ;cislo
     jmp vyber2_a            ;a vratime sa do jadra cyklu
    vyber2_minus:            ;pokial je cislo zaporne
     neg al                  ;tak ho upravime na kladne
     inc di                  ;zvysime pozicu na obrazovke
     inc di        
     push ax                 ;ulozime si cislo do zasobnika
     mov dl,'-'              ;a vypiseme na obrazovku minus
     call zobraz_char
     pop ax                  ;vyberieme cislo zo zasobnika
     jmp vyber2_c            ;a pokracujeme v cykle hore
    vyber2_up:               ;pokial je cislo vacsie ako 100
     inc di                  ;nemozeme ho hned delit
     inc di
     sub al,100              ;ale od neho odcitame 100
     mov dl,'1'              ;a na obrazovkuy vypiseme jednotku na miesto stovak
     push ax       	     ;ulozime si cislo
     call zobraz_char        ;zobrazime jednotku
     pop ax                  ;vyberieme cislo a teraz ho v cykle hore 
                             ;vydelime desiatkou aby sme ziskali zvysne cifry
     jmp vyber2_vup
    vyber2_hot:               ;pokial sme s usporiadanim hotovy
     mov bp,offset cisla_vloz ;treba cisla ulozit do suboru
     mov di,3370              ;pozicia na obrazovke a v bp adresa prazdneho 
                              ;pola urceneho k zapisu
     mov cx,50                ;maximalny pocet znakov
    vyber2_hot2:
     mov dl,es:[di]           ;teraz jednoducho vyberieme znaky z videoram
     mov ds:[bp],dl           ;a vlozime ich do pola na zapis
     inc di                   ;pripravime dalsiu poziciu vo videoram
     inc di             
     inc bp                   ;a v poli na zapis do suboru
     loop vyber2_hot2
    vyber2_uloz:              ;ked sme hotovi,nasleduje zapis do suboru
     mov ah,3ch               ;cislo sluzby
     mov dx,offset subor2     ;nazov suboru
     int 21h                  ;sluzba DOS-u na vytvorenie suboru
     mov bx,ax                ;do bx dame handler suboru,je potrebny na zapis  
     mov cx,29                ;pocet znakov textu
     mov dx,offset usp_text   ;zapis prislusneho textu do suboru
     mov ah,40h               ;cislo sluzby
     int 21h                  ;prerusenie DOS-u,zapis do suboru
     mov cx,50                ;pocet znakov na vlozenie do suboru
     mov dx,offset cisla_vloz ;kde sa znaky nachadzaju
     mov ah,40h               ;cislo sluzby
     int 21h                  ;prerusenie DOS-u,zapis do suboru
     mov ah,3eh               ;zatvorenie suboru
     mov bx,ax
     int 21h
    vyber2_koniec:            ;tym sme skoncili
     jmp zaciatok             ;skocime naspat do menu
     ret                      ;a vratime cinnost hlavnemu programu
  
   vyber2 endp                ;koniec procedury na usporiadanie cisel

   proc vyber3 near           ;procedura realizujuca delenie
     mov bp,offset cislo1_text
     mov di,3370
     mov cx,18
     call zobraz_ret
     call vyber_prave_menu    ;zavolame proceduru na vyber cisel
     mov bp,offset podiel_text ;zobrazime uvodny text
     mov cx,26                ;pocet znakov v retazci
     mov di,3370              ;pozicia na obrazovke           
     call zobraz_ret          ;zobrazenie cez proceduru zobraz_ret
     xor cx,cx
     xor ax,ax
     xor bx,bx                ;vymazeme potrebne registre
     mov bp,offset cislo1 ;a do bp vlozime adresu poz.nacitaneho 1.cisla
     mov cl,ds:[bp]       ;cislo vlozime do cl
     mov bp,offset cisla_konv ;do bp vlozime adresu pola cisel 
     cmp cl,0             ;pokial je to prve cislo preskocime cyklus     
     je vyber3_a         
    vyber3_b:             ;ak nie zistime si poziciu nacitaneho cisla
     inc bp               ;v poli cisel
     loop vyber3_b
    vyber3_a:           
     mov al,ds:[bp]       ;do al vlozime cislo,a porovname s nulou
     cmp al,0            
     js vyber3_minus2     ;pokial je zaporne je urcite zvysok zaporny
                          ;a tak zobrazime minus a upravime
    vyber3_f:            
     mov bp,offset cislo2 ;ak nie nacitame poziciu druheho cisla  
     mov cl,ds:[bp]       ;vlozime ju do cl
     mov bp,offset cisla_konv ;do bp vlozime adresu pola cisel
     cmp cl,0            ;opat poravname poziciu cislo2,ak je nulova
                         ;preskocime cyklus
     je vyber3_c
    vyber3_d:            ;ak nie najdeme si jeho polohu v poli cisel
     inc bp
     loop vyber3_d
    vyber3_c:
     mov dl,ds:[bp]      ;cislo vlozime do dl
     idiv dl             ;a delime ax (teda al) s dl (so znamienkom)
     cmp al,0            ;porovname podiel s nulou
     js vyber3_minus     ;a pokial je zaporny skocime na navestie
     cmp al,0            ;porovname al s nulou
     je vyber3_g         ;ak je to nula preskocime nasl. riadok
     cmp bl,1            ;pretoze tu sa rozhoduje o znamienku
                         ;a nula je 'kladna'
     je daj_minus        ;pokial al je rozne od nuly skontrolujeme znam.
                         ;ak je zaporne tak ho zobrazime na prislus .navesti 
    vyber3_g:         
     mov bl,ah        ;ulozime si zvysok po deleni do bl
     xor ah,ah        ;vynulujeme register ah
     cmp al,100       ;porovname al so 100,ak je vacsi,tak skok
     jg del_2
     cmp al,10        ;potom ak nie porovname al s 10,ak je vacsi-skok
     jg del_1
     add al,30h       ;ak sme presli,tak je tam len jednotkove cislo
     mov dl,al        ;ktore po korekcii 30h,mozeme hned zobrazit
     mov di,3428      ;pozicia na obrazovke
     call zobraz_char ;procedura na zobrazenie znaku
    vyber3_zvysok: 
     mov bp,offset zvysok_text ;bp-adresa sprievodneho textu
     mov cx,7                  ;pocet znakov v retazci
     mov di,3440       ;pozicia prveho znaku na obrazovke    
     call zobraz_ret   ;vypisanie retazca
     xor ax,ax         ;vynulujeme register ax
     mov al,bl         ;a do al dame bl,cize zvysok po deleni
     cmp al,100        ;a opat urobime to iste co predtym, len so zvyskom
     jg del_2z
     cmp al,10
     jg del_1z
     add al,30h
     mov dl,al
     mov di,3460
     call zobraz_char
     jmp zaciatok      ;tym mame vysledok vypisany,mozeme skoncit
     ret               ;skok na zaciatok, a vratenie cinnosti hl.prog
    del_2:           ;pomocne navestie v dosledku skoku> ako 128bitov
     jmp del_3
    vyber3_minus:    ;pokial je podiel cislo zaporne
     neg al          ;tak z neho urobim kladne
     cmp bl,0        ;a ak je znamienko kladne,bude zaporne
     je daj_minus    ;a tak ho vypiseme na obrazovku na prislus. navesti
     jmp vyber3_g    ;skok do hlavneho cyklu
    vyber3_minus2:   ;pokial je prve cislo vchadzajuce do delenia zap. 
     neg al          ;tak z neho urobim kladne
     mov bl,1        ;a nastavim znamienko minus na aktivne (reg bl)
     jmp vyber3_f    ;a skocim naspat so hlavneho cyklu
    daj_minus:
     push ax         ;vlozim hodnotu z ax do zasobnika
     mov dl,'-'      ;do dl dam znamienko minus a zobrazim
     mov di,3426     ;na poziciu di
     call zobraz_char ;zobrazenie znaku
     pop ax          ;vybranie hodnoty zo zasobnika do ax
     jmp vyber3_g    ;skok naspat do cyklu
    del_1:           
     mov dl,10       ;podiel je cislo mensie ako 100
     div dl          ;a preto mi staci vydelit ho desiatimi a
     add al,30h      ;dostanem po korekcii 30h cislo na miste desiatok
     add ah,30h      ;ako aj cislo na mieste jednotiek
     mov dl,al       ;no a potom ich po jednom zobrazim
     mov di,3430      
     call zobraz_char ;tu zobrazim prostrednictvom zobraz_char desiatky
     mov dl,ah 
     mov di,3432
     call zobraz_char  ;a tu stovky
     jmp vyber3_zvysok ;skok naspat do hlavneho cyklu
    del_3:            ;podiel je cislo vacsie ako 100
     sub al,100       ;tak  od cisla odcitame 100
     push ax          ;ulozime hodnotu cisla do zasobnika
     mov dl,'1'       ;a zobrazime jednotku na mieste stoviek
     mov di,3428
     call zobraz_char
     pop ax           ;vlozime uz cislo mensie ako 100 zo zasobnika
                      ;do registra ax    
     jmp del_1        ;a skocime na predosly cyklus
    del_2z:           ;pomocne navestie koli podmienenemu skoku
                      ;vacsiemu ako 128bitov
     jmp del_3z
    del_1z:           ;to iste ako navestia del_1 a del_2
     mov dl,10        ;akurat ze tu pracujeme zo zvyskom
     div dl
     add al,30h
     add ah,30h
     mov dl,al
     mov di,3462
     call zobraz_char
     mov dl,ah 
     mov di,3464
     call zobraz_char
     jmp zaciatok
     ret
    del_3z:
     sub al,100
     push ax
     mov dl,'1'
     mov di,3460
     call zobraz_char
     pop ax
     jmp del_1z
   vyber3 endp       ;koniec procedury na podiel dvoch cisel

   proc vyber4 near  ;procedura na nasobenie dvoch cisel 
     mov bp,offset cislo1_text ;zobrazenie prislusneho textu
     mov di,3370
     mov cx,18
     call zobraz_ret
     call vyber_prave_menu  ;procedura na vyber nasobiacich cisel
     mov bp,offset sucin_text ;sprievodny text
     mov cx,25        ;pocet znakov v retazci
     mov di,3370      ;pozicia na obrazovke
     call zobraz_ret  ;zobrazenie retazca
     xor cx,cx   
     xor ax,ax
     xor bx,bx         ;vynulovanie potrebnych registrov
     mov bp,offset cislo1 ;do bp vlozime adresu pozicie 1 vybraneho cisla
     mov cl,ds:[bp]    ;tuto poziciu vlozime do cl
     mov bp,offset cisla_konv ;do bp vlozime adresu pola cisel
     cmp cl,0          ;porovname cl s nulou
     je vyber4_a       ;pokial je cl=0 preskocime nasledujuci cyklus
    vyber4_b:
     inc bp           ;ak nie tak sa nastavime v poli cisel na
     loop vyber4_b    ;poziciu danu v cislo1
    vyber4_a:
     mov al,ds:[bp]   ;do al,vlozime 1. vybrane cislo
     cmp al,0         ;porovname ho s nulou
     js vyber4_minus2  ;ak je zaporne skocime na navestie vyber4...
    vyber4_f:          
     mov bp,offset cislo2 ;teraz zistime poziciu vybraneho 2.cisla
     mov cl,ds:[bp]    ;vlozime ju do cl
     mov bp,offset cisla_konv ;do bp vlozime adresu pola cisel
     cmp cl,0         ;znova porovname poziciu s nulou
     je vyber4_c      ;ak sa rovnaju preskocime nasl. cyklus
    vyber4_d:
     inc bp          ;ak nie ziskame poziciu v poli cisel
     loop vyber4_d
    vyber4_c:        
     mov dl,ds:[bp]  ;do dl vlozime druhe vyubrane cislo
     imul dl         ;vynasobime kladne cislo v ax(al) cislom so 
                     ;znamienkom v dl
     cmp ax,0        ;provname vysledok s nulou
     js vyber4_minus ;pokial je vysledok zaporny skocime na navestie
     cmp bl,1        ;porovname zmnamienkovy register s jednotkou
     je daj4_minus   ;a ak je cislo zaporne vypiseme na navesti.. -
    vyber4_g:
      cmp ax,10000    ;porovname sucin s 10000
      jg vyber4_4     ;ak je vacsi tak skok
      cmp ax,1000     ;potom s 1000
      jg vyber4_3
      cmp ax,100      ;so 100
      jg vyber4_2
      cmp ax,10       ;a s desiatkou
      jg vyber4_1
     vyber4_y:        ;pokial je mensi ako 10
       add al,30h     ;je to len jedno cislo a to mozeme hned zobrazit
       mov dl,al      ;vykoname korekciu
       mov di,3436    ;pozicia na obrazovke
       call zobraz_char ;vykraslenie znaku
     vyber4_z:         ;pomocne navestie pri podminenom skoku
      jmp vyber4_hot   ;nakolko je skok > ako 128bitov
     vyber4_minus2:    ;to iste ako predtym
      jmp vyber4_minus3
     daj4_minus:       ;to iste ako prve navestie
      jmp daj4_minus2  
    vyber4_4:          
      xor dx,dx        ;vynulujeme obsah registra dx
      mov bx,10000     ;do bx dame 10000
      div bx           ;a vydelime sucin
      push dx          ;zvysok po deleni vlozime do zasobnika
      add al,30h       ;ah je nulovy a al zobrazime,spravime korekciu
      mov dl,al
      mov di,3428      ;a na poziciu di
      call zobraz_char ;ho zobrazime pomocou procedury zobraz_char
      pop dx           ;zoberieme zvysok zo zasobnika
      mov ax,dx        ;a vlozime ho do ax
    vyber4_3:
      xor dx,dx        ;a pokracujeme v deleni teraz 1000
      mov bx,1000
      div bx       
      push dx          ;znova ulozime zvysok do zasobnika
      add al,30h       ;a podiel vypiseme
      mov dl,al
      mov di,3430
      call zobraz_char
      pop dx           ;vyberieme hodnotu zo zasobnika
      mov ax,dx        ;a vlozime zvysok do ax
    vyber4_2:
      xor dx,dx         ;dalsie delenie a to cislom 100
      mov bx,100
      div bx            
      push dx          ;zvysok dame do zasobnika
      add al,30h       ;a podiel po korekcii zobrazime
      mov dl,al
      mov di,3432
      call zobraz_char
      pop dx          ;vybranie zvysku zo zasobnika
      mov ax,dx       ;do ax vlozime zvysok
    vyber4_1:        
      xor dx,dx       ;vynulovanie registra dx        
      mov bl,10       ;a posledne delenie teraz desiatimi
      div bl          ;cim dostaneme aj posledne dve cifry sucinu
      add al,30h      ;najprv zobrazime podiel 
      mov dl,al     
      mov di,3434
      call zobraz_char
      mov al,ah     ;a skocime na koniec,kde sa zobrazia este jednotky
      jmp vyber4_y    
    vyber4_minus:     
     neg ax         ;ak je vysledne cislo zaporne upravime ho na kladne 
     cmp bl,0       ;porovname znamienkovy register
     je daj4_minus  ;ak je nulovy tak dame znamienko pred cislo
     jmp vyber4_g
    vyber4_minus3:  
     neg al         ;ak je prve cislo zaporne musime ho upravit na
                    ;kladne
     mov bl,1      ;a v znamienkovom registri nastavit jednotku 
     jmp vyber4_f
    daj4_minus2:   ;ak je vysledne cislo zaporne zobrazime pred nim
                   ;znamienko minus
     push ax       ;vlozime ax do zasobnika
     mov dl,'-'    ;do dl znamienko minus
     mov di,3426   ;a na pozicu di na obrazovke ho zobrazime
     call zobraz_char
     pop ax        ;vlozenie hodnoty zo zasobnika do registra ax
     jmp vyber4_g  ;skok do hlavneho cyklu
    vyber4_hot:  
     jmp zaciatok ;skok naspat do menu   

     ret          ;vratenie cinnosti hlavnemu programu
   vyber4 endp    ;koniec procedury na nasobenie dvoch cisel

   proc vyber5 near ;procedura na ukoncenie programu
     jmp koniec     ;skok na koniec programu
     ret         
   vyber5 endp      ;koniec procedury na ukoncenie programu
      
  
  proc vytvor_prave_menu near ;vytvorenie menu cisel
     xor bx,bx
     mov cx,10             ;vynulovanie a nastavenie registrov
     mov di,766
     vytvor0:              ;navestie na vytvorenie poradovych cisel (indexov)
      add bl,30h           ;do bl dame cislo 0
      mov dl,bl
      call zobraz_char     ;zobrazime ho
      inc di
      inc di
      mov dl,')'           ;za nim napiseme znak )
      call zobraz_char
      dec di               ;vratime sa spat na zaciatocnu poziciu
      dec di
      add di,160           ;skok na dalsi riadok
      sub bl,30h           ;prekonvertujeme naspat na cislo
      inc bl               ;zvysime o jedno
     loop vytvor0          ;a pokracujeme az kym cx=0
     mov bp,offset cisla_nac ;do bp vlozime adresu retazca znakov zo
                             ;vstupneho suboru
     mov di,774              ;pozicia na obrazovke             
    vytvor1:
     mov dl,ds:[bp]        ;do dl vlozime znak z pola vstupu
     cmp dl,'.'            ;porovname ho z medziciselnym znakom
     je vytvor2            ;ak sa rovnaju skok na vytvor2
     cmp dl,'*'            ;porvname dl s koncom nacitanych dat
     je vytvor_hot         ;ak sa rovnaju koniec
     call zobraz_char      ;inac zobraz znak na obrazovku
     inc bp                ;adresa dalsieho znaku z vstupnych dat
     inc di             
     inc di                ;posun na obrazovke o jedno miesto
     jmp vytvor1           ;skok na nacitanie dalsieho znaku
    vytvor2:
     add di,152            ;pokial to bol medziciselny znak posun
                           ;'kurzor' na dalsi riadok 
     inc bp                ;adresa dalsieho znaku zo vstupnych dat
     jmp vytvor1
    vytvor_hot:           
     ret                   ;vratenie cinnosti hlavnemu programu

   vytvor_prave_menu endp    ;koniec procedury 
       

  proc vyber_prave_menu near ;zabezpecuje vyber v menu cisel
     xor cx,cx
     mov bp,offset cislo1   ;do bp si nastavime adresu cislo1 
    prave1:
     mov ah,00h             ;cislo sluzby
     int 16h                ;preruseniue na vstup z klavesnice
     cmp al,'0'             ;testuje nacitany znak
     jge prave2             ;ci je v rozsahu od 0 po 9 (indexy cisel)
     jmp prave1
    prave2:
     cmp al,'9'
     jng prave3
     jmp prave1
    prave3:
     sub al,30h             ;konvertuje znak na cislo
     mov ds:[bp],al         ;a ulozi ho ako cislo na adresu bp
     cmp cl,1               ;zisti, ci je to uz druhe vybrane cislo
     je prave_koniec        ;ak ano skonci
     mov bp,offset cislo2_text ;ak nie, nastavi do bp adresu cislo2
     mov di,3370
     mov cx,18
     call zobraz_ret
     mov cl,1               ;cl nastavi na jednotku, tym zabezpeci
     mov bp,offset cislo2   ;ukoncenie cyklu
     jmp prave1             ;skok na navestie, kde sa nacita druhy znak
   prave_koniec:
     ret                   ;vratenie cinnosti hlavnemu programu
  vyber_prave_menu endp    ;koniec procedury na pohyb v menu cisel
    	

  proc vytvor_menu near    ;procedura na vytvorenie hlavneho menu
     mov bp,offset menu	   ;do bp vlozime adresu retazca menu 
     mov cx,9              ;pocet znakov
     mov di,210            ;pozicia na obrazovke
     call zobraz_ret       ;zavolanie procedury na vypis
     mov dl,15+0       	   ;kod farby
     mov [si+0],dl         ;vlozenie farby do [si+0]
     mov bp,offset menu1   ;do bp vlozime adresu textu
     mov cx,45             ;pocet znakov (rovnaky pre vsetky polozky)
     mov di,656            ;pozicia na obrazovke
     call zobraz_ret       ;vypisanie postupne vsetkych poloziek menu
     mov bp,offset menu2        
     mov cx,48                   
     mov di,976                 
     call zobraz_ret
     mov bp,offset menu3
     mov cx,45
     mov di,1296
     call zobraz_ret
     mov bp,offset menu4
     mov cx,45
     mov di,1616
     call zobraz_ret
     mov bp,offset menu5
     mov cx,45
     mov di,1936
     call zobraz_ret
     mov bp,offset prava ;vypisanie textu CISLA v pravom menu
     mov cx,10
     mov di,284
     call zobraz_ret
     ret                 ;vratime cinnost hlavnemu programu
  vytvor_menu endp       ;koniec procedury na vytvorenie menu

  proc vyber_menu near  ;procedura na vyber poloziek z hlavneho menu
    moznost:
     mov ah,8           ;cislo sluzby
     int 21h            ;prerusenie na vstup z klavesnice bez echa
     cmp al,'1'         ;porovname co bolo stlacene
     je moznost1        ;podla toho skocime na prislusne navestie
     cmp al,'2'
     je moznost2
     cmp al,'3'
     je moznost3
     cmp al,'4'
     je moznost4
     cmp al,'5'
     je moznost5
     jmp moznost
   moznost1:             
     mov di,3370         ;nastavenie pozicie
     mov cx,240          ;pocet znakov
     call vymaz_ret      ;procedura na vymazanie retazca
     call vyber1         ;volanie prislusnej procedury
     jmp zaciatok        ;navrat na zaciatok
   moznost2:
     mov di,3370
     mov cx,240
     call vymaz_ret
     call vyber2
     jmp zaciatok
   moznost3:
     mov di,3370
     mov cx,240
     call vymaz_ret
     call vyber3
     jmp zaciatok
   moznost4:
     mov di,3370
     mov cx,240
     call vymaz_ret
     call vyber4
     jmp zaciatok
    moznost5:
     mov di,3370
     mov cx,240
     call vymaz_ret
     call vyber5
     jmp zaciatok
 
     ret               ;navrat cinnosti hlavnemu programu
  vyber_menu endp      ;koniec procedury na vyber poloziek v hlavnom menu
     


start:
     mov ax,03h             ;vycistenie obrazovky
     int 10h
     mov ah,02h             ;prerusenie DOS-u na posun kurzora
     mov dh,25              ;odstranenie kurzoru tym, ze ho dame "za" obrazovku
     int 10h                ;vyvolame prerusenie
     mov ax,seg data        ;do ax vlozime segment dat
     mov ds,ax              ;a do ds potom vlozime ax
     mov ax,0b800h          
     mov es,ax              ;adresa na zapis do videoram
     xor di,di              ;vynulujeme di           
     mov dl,15+0            ;do dl vlozime kod farby
     mov [si+0],dl   
     call nacitaj           ;nacitame udaje zo suboru
     call transf            ;pretransformujeme znaky zo suboru na cisla 
    zaciatok:
     call vytvor_menu       ;vytvorime hlavne menu
     call vytvor_prave_menu ;vytvorime menu cisel
     call vyber_menu        ;vyber jednotlivych poloziek z menu
 koniec:                    ;koniec celeho programu
     mov ax,4c00h        
     int 21h
CODE ends                   ;koniec kodoveho segmentu
     end start              ;definujeme odkial zacina program

;*********************************************************************
;ZHODNOTENIE: 
;Program je funkcny pri pouziti mnou vytvoreneho vstupneho suboru.
;Program som napisal v editore manazeru FAR a bol spracovany
;programami TASM verzia 2.02 a TLINK verzia 3.01.
;Program je rieseny priamym zapisom do videram, cize bez pouzitia
;sluzieb DOS-u na vypis znaku resp. retazca. Tym sa lahsie dostanem
;na potrebnu poziciu vypisu. Namiesto navesti som co najviac pouzival 
;procedury, ktore su volane z hlavneho programu aj navzajom medzi sebou. 
;Pri pouziti ineho vstupneho suboru by bolo treba osetrit vstup 
;pri vysokych cislach mimo rozsah <-128,127> a delenie nulou.
;*********************************************************************