;-----------------------------Hlavicka---------------------------------------
;ZADANIE c.3
;Text zadania:
;S vyuzitm  retazcovych  instrukci  (vsade   kde  je  to  mozn) vytvorte program, ktory:
;a) nacta z  klvesnice dva  retazce do  dvoch rznych segmentov
;    (minimlne dlzky 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabk na vyssie adresy,
;c) porovn posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zist, ci s rovnako dlh a ci s rovnak
;d) zist,  ci  sa  v  niektorom   z  retazcov  nachdza  zadany
;   podretazec.
;Autor:  Martin Seckar 
;Termin odovzdania: 5.12.2000
;2.roc.,sk.rok 2000/2001
;---------------------program------------------------------------------------
;---------------------zasobnik-----------------------------------------------
zas     segment     stack
                dw        100 dup(?)
zas     ends
;--------------------udajovi segment-----------------------------------------
data    segment
hlaska1         db      'Zadaj retazec c.1(min.20 znakov):$',10,13
hlaska2         db      'Zadaj retazec c.2(min.20 znakov):$',10,13
hlaska3         db      'Koniec.$',10,13            ;oznamenia
hlaska4         db      'Su rovnake.$',10,13
hlaska5         db      'Nie su rovnake.$',10,13
hlaska6         db      'Zadaj hladany retazec:$',10,13
hlaska7         db      'Nachadza sa v prvom retazci.$',10,13
hlaska8         db      'Nenachadza sa v prvom retazci.$',10,13
hlaska9         db      'Malo znakov.$',10,13
hlaska10        db      'Nachadza sa v druhom retazci.$',10,13
hlaska11        db      'Nenachadza sa v druhom retazci.$',10,13

data    ends
;----------------------------retazec1----------------------------------------
retazec1        segment
ret1            dw     100 dup(?)  ;vyhradene pre prvy retazec
dlzka1          dw      0          ;dlzka retazca ret1
retazec1        ends
;---------------------------retazec2-----------------------------------------
retazec2        segment
ret2            dw      100 dup(?) ;vyhradene pre druhy retazec
dlzka2          dw      0          ;dlzka retazca ret2
retazec2        ends
;---------------------------pomocny1-----------------------------------------
pomocny1        segment
pom1            dw      100 dup(?) ;pomocny pre posun
pom2            dw      100 dup(?) ;pomocny pre hladanie podretazca
dlzka3          dw      0          ;dlzka retazca pomocny1
pomocny1        ends

;---------------------code---------------------------------------------------
code    segment
        assume  cs:code,ss:code
start:
        call    @vymaz_obrazovku        ;volanie proc. pre vymazanie obrazovky  
        call    @push_pop_ds            ;volanie pro. pre naplnenie ds segmentom data
        mov     dx,offset       hlaska1 ;oznam1(zadaj retazec c1..)
        call    @vypis                  ;volanie proc.pre vypis retazca

        push    seg     retazec1
        pop     es                      ;inicializacia segmentu retazec1
        mov     di,offset ret1          ;offset v segmente retazec1 na  ret1=retazec1
        xor     cx,cx ;nulovanie        ;v cx bude dlzka retazca, tak ho prejstotu vynulujeme
        
nacitaj_retazec1:
        call    @readkey                ;vstup z klavesnice/nacitanie znaku
        inc     cx                      ;cx:=cx+1
        stosb                           ;byte ptr es:[di]:=al,di:=di+1
        cmp     al,13                   ;retazec bude ukonceny enterom(13=enter)
        jne     nacitaj_retazec1        ;pokial nebol stlaceny enter,nacitava 

        mov     byte ptr es:[di-1],'$'  ;na posledne miesto dam '$' pre kontrolu vypisom

        mov     di,offset dlzka1        ;offset v segmente retazec1 na dlzku1
        mov     word ptr es:[di],cx     ;ulozi dlzku ret1

osetrenie1:;podm. je,ze ret. bude mat aspon 20 bytov

        cmp     cx,20                   ;je dlzka aspon 20
        jnb     zac                     ;ak je vsetko v poriadku tak skoc na navestie 
        call    @vymaz_obrazovku        
        call    @push_pop_ds
        mov     dx,offset       hlaska9 ;oznam9(Malo znakov.)
        call    @vypis
        call    @readkey
        jmp     start                   ;skoci na start aby sme zadali tych 20 znakov



;------------------------nacitanie ret2-------------------------------------
zac:
        call    @vymaz_obrazovku
        call    @push_pop_ds
        mov     dx,offset       hlaska2 ;oznam2(zadaj ret...)
        call    @vypis

        push    seg     retazec2
        pop     es               ;inicializacia segmentu retazec2
        mov     di,offset ret2   ;offset v segmente retazec2 na  ret2=retazec2
        xor     cx,cx ;nulovanie

nacitaj_retazec2:
        call    @readkey                ;vstup z klavesnice/nacitanie znaku
        inc     cx                      ;cx:=cx+1
        stosb                           ;byte ptr es:[di]:=al,di:=di+1
        cmp     al,13                   ;retazec bude ukonceny enterom(13=enter)
        jne     nacitaj_retazec2        ;pokial nebol stlaceny enter,nacitava 

        mov     byte ptr es:[di-1],'$'  ;na posledne miesto dam '$' pre vypis retazca

        mov     di,offset dlzka2        ;offset v segmente retazec2 na dlzku2
        mov     word ptr es:[di],cx     ;ulozi dlzku ret2
osetrenie2:;podm. pre zadanie retazca je min.20 bytov
                
        cmp     cx,20
        jnb     kontrola
        call    @vymaz_obrazovku
        call    @push_pop_ds
        mov     dx,offset       hlaska9 ;pozri vyssie
        call    @vypis
        call    @readkey
        jmp     zac


;--------------------kontrola vypisom---------------------------------------
kontrola:;pre moju vlastnu kontrolu,inac tu nema co robit
        call    @vymaz_obrazovku

        push    seg      retazec1
        pop     ds
        mov     dx,offset ret1
        call    @vypis

        mov     ah,02h
        mov     dl,10
        int     21h

        mov     ah,02h
        mov     dl,13
        int     21h

        push    seg      retazec2
        pop     ds
        mov     dx,offset ret2
        call    @vypis

        call    @readkey
;-------------------------------moznostb--------------------------------------
;b) prvy retazec presunie v segmente o 10 slabk na vyssie adresy


        push    seg     retazec1
        pop     ds
        push    seg     pomocny1        ;pomocny segment v ktorom sa nachadza pom1
        pop     es
        mov     si,offset       ret1    ;prvy   retazec
        mov     di,offset       pom1    ;pomocny ret. do, kt. prekopirujem ret1
        mov     bx,offset       dlzka1  ;dlzka prveho ret. 
copy1:
        mov     cx,word ptr ds:[bx]     ;dlzku zo segmentu dam do reg. cx
        mov     dx,cx                   ;zapametam si povodnu cx v dx
        repz     movsb                  ;opakujem pokial cx:=!0, es:[di]:=ds:[si],inc si,inc di        
                                        ;repz-->cx:=cx-1,opakuje pokial cx:=!0
posuvanie:;samotne posuvanie v segment o 10 slabik
        push    seg     pomocny1
        pop     ds
        push    seg     retazec1
        pop     es
        mov     si,offset       pom1
        mov     di,offset       ret1
        add     di,10

copy2:; na zmenenu adresu prekopirujem spatne zase ret1(cez pom1)
        mov     cx,dx                   ;cx naplnim dlzkou1
        repz     movsb
;---------------------kontrola vypisom---------------------------------------
        call    @vymaz_obrazovku

        push    seg      retazec1
        pop     ds
        mov     dx,offset ret1
        add     dx,10
        call    @vypis
        call    @readkey
;---------------------moznost c----------------------------------------------
;c) porovn posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zist, ci s rovnako dlh a ci s rovnak

porovnaj_dlzka:
        push    seg     retazec1
        pop     ds
        push    seg     retazec2
        pop     es

        mov     si,offset       dlzka1  ;dlzka prveho ret.  
        mov     di,offset       dlzka2  ;dlzka druheho ret.

        mov     bx,word ptr ds:[si]     ;do bx dam prvu dlzku
        mov     cx,word ptr es:[di]     ;do cx dam druhu dlzku

        cmp     bx,cx                   ;porovna ci su rovnako dlhe
        je      pokracovanie            ;ak ano tak skoc na znakove porovnavanie

nie_su_rovne:;navestie ak nie su rovnakej dlzky
        call    @vymaz_obrazovku
        call    @push_pop_ds
        mov     dx,offset       hlaska5 ;oznam5(nie su rovnake)
        call    @vypis
        call    @readkey
        jmp     zatial_koniec           ;kedze nie su rovnakej dlzky, tak uz nemozu byt rovnake,preto skok prec


pokracovanie:

        push    seg     retazec1
        pop     ds
        push    seg     retazec2
        pop     es

        mov     si,offset       dlzka1  ;vyberam len prvu dlzku preto, ze musia mat obidva rovnaku dlzku
        mov     cx,word ptr ds:[si]     ;dlzku dam do cx

        mov     si,offset ret1
        mov     di,offset ret2
        add     si,10                   ;aby som nepracoval s posunutim tak posuniem offset o10

        repe    cmpsb                   ;opakuj pokial cx!=0,cmp ds:[si],es:[di];inc si,inc di
        cmp     cx,0                    ;Ak je dlzka 0, tak uz sme presli cely retazec
        je      su_rovne                ;vsetky prvy su rovnake a skoc na navestie
        jmp     nie_su_rovne            ;inak nie su rovnake a skoc na navestie

su_rovne:
        call    @vymaz_obrazovku
        call    @push_pop_ds
        mov     dx,offset       hlaska4 ;oznam4(su rovnake)
        call    @vypis
        call    @readkey

zatial_koniec:
;--------------------------------moznost d-----------------------------------
;d) zist,  ci  sa  v  niektorom   z  retazcov  nachdza  zadany
;   podretazec.

hladany_retazec:;zadam si hladany podretazec
        
        call    @vymaz_obrazovku   
        call    @push_pop_ds
        mov     dx,offset       hlaska6 ;oznam6(zadaj hladany..)
        call    @vypis

        push    seg     pomocny1
        pop     es
        mov     di,offset       pom2    ;v segmente pomocny1 sa nam bude nachadzat hladany podretazec v pom2
        xor     cx,cx                   ;nulovanie cx 

nacitanie_hladaneho:
        call    @readkey                ;nacita znak
        inc     cx                      
        stosb                           ;es:[di]=al
        cmp     al,13                   ;opakuj az po enter
        jne     nacitanie_hladaneho     ;skoc pokial nebol stlaceny enter        

        mov     byte ptr es:[di-1],'$'  ;na posledne miesto daj '$' pre kontrolu vypisom
        mov     di,offset       dlzka3  ;sem ulozi dlzku thto (pod)retazca
        mov     word ptr es:[di],cx     
;---------------------kontrola vypisom---------------------------------------
        call    @vymaz_obrazovku

        push    seg      pomocny1
        pop     ds
        mov     dx,offset       pom2
        call    @vypis
        call    @readkey
;----------------------hladanie v prvom retazci------------------------------
;zaciatok samotneho hladania v prvom retazci
        push    seg     retazec1
        pop     ds
        push    seg     pomocny1
        pop     es
        xor	cx,cx
	xor	bx,bx
	                        
        mov     si,offset       dlzka1
        mov     cx,word ptr ds:[si]             ;cx=dlzka retazca1
        mov     di,offset       dlzka3
        mov     bx,word ptr es:[di]             ;bx=dlzka hladaneho retazca=pom1

        mov     di,offset       ret1            ;ret1=retazec1
        mov     si,offset       pom2            ;pom2=hladany podretazec
        
        add     cx,10                           ;posunuty ma dlzku cx+10
        dec     bx                              ;Zbavim sa '$'

hladaj:
        mov     al,byte ptr es:[si]             ;vyberie znak z hladaneho podretazca do al
        inc     si                              ;si=si+1,pre neskorsi vyber dalsieho znaku
        dec     bx                              ;znizujem dlzku pom2
        repne   scasb                           ;porovnanie cmp ds:[di],al v opkovani pokial nenajde ten isty znak
                                                ;opakuje pokial cx=!0(pricom sa cx zmensuje o 1)
        cmp     cx,0                            ;ak dlzka ret1 je 0 tak skoci na navestie
        je      nenasiel_rovnake

        cmp     bx,0                            ;ak dlzka pom2 nie je 0 tak opakuj pre dalsi znak z pom2
        jne     hladaj

        call    @vymaz_obrazovku   
        call    @push_pop_ds
        mov     dx,offset       hlaska7         ; vypis oznamu 7(hladany podret. sa..)
        call    @vypis
        call    @readkey
        jmp     hladanie2			;skok na navestie pre prehladavanie druheho ret.

nenasiel_rovnake:

        call    @vymaz_obrazovku   
        call    @push_pop_ds
        mov     dx,offset       hlaska8         ; vypis oznamu 7(hladany podret. sa..)
        call    @vypis
        call    @readkey
        jmp     hladanie2
;------------------------------Hladanie v druhom retazci----------------------

hladanie2:

        push    seg     retazec2
        pop     ds
        push    seg     pomocny1
        pop     es
        xor	cx,cx
	xor	bx,bx                        
        
	mov     si,offset       dlzka2
        mov     cx,word ptr ds:[si]             ;cx=dlzka retazca2
        mov     di,offset       dlzka3
        mov     bx,word ptr es:[di]             ;bx=dlzka hladaneho retazca=pom1

        mov     di,offset       ret2            ;retazec2
        mov     si,offset       pom2            ;hladany podretazec
       
        dec     bx                              ;Zbavim sa '$'

hladaj1:
        mov     al,byte ptr es:[si]
        inc     si
        dec     bx
        repne   scasb                           ;to iste ako pri prvom
        cmp     cx,0
        je      nenasiel_rovnake1

        cmp     bx,0
        jne     hladaj1

        call    @vymaz_obrazovku   
        call    @push_pop_ds
        mov     dx,offset       hlaska10        ;oznam10(nasiel sa)
        call    @vypis
        call    @readkey
        jmp     koniec

nenasiel_rovnake1:

        call    @vymaz_obrazovku   
        call    @push_pop_ds
        mov     dx,offset       hlaska11        ;oznam11(nenasiel sa)
        call    @vypis
        call    @readkey
        jmp     koniec
        


;-------------------------------procedury------------------------------------------------
@vypis:   ;vypis retazca(lubovolneho cez sluzbu 09h)
        mov     ah,09h ; volanie sluzby 09h pre vypis retazca
	int 	21h
	
        ret
;-------------------------------------------------------------------------------
@readkey:  ;pre cakanie na vstup z klavesnice
        mov     ah,01h ;volanie sluzby(dos) 01h pre vstup z klavesnice
	int	21h
	ret
;-------------------------------------------------------------------------------
@vymaz_obrazovku: ;vycisti obrazovku(clrscr)
        mov     ax,03h ; volanie sluzby 03h pre vycistenie obrazovky
	int	10h
	ret
;-------------------------------------------------------------------------------
@push_pop_ds:;ds naplni segmentom data
        push    seg     data
        pop     ds
        ret
;---------------------------------------------------------------------------
koniec:
        call    @vymaz_obrazovku ; vymaze obrazovku
        call    @push_pop_ds
        mov     dx,offset hlaska3   ;ukazovatel na oznam3(koniec)
	call	@vypis
        mov     ax,4c00h ; volanie sluzby 4c00h pre ukoncenie
        int     21h
;-----------------------------------------------------------------------------
code    ends ;ukoncenie code segmentu
	end	start

;zhodnotie:
;Program je fukcny.Len pri kontrole vypisom by bolo dobre, keby sa do retazca 
;nezadavali '$'.
;-Pouzil som retazove instrukcie movsb,lodsb,stosb,scasb,repz,repne
;-dalej dos sluzby 01h,09h,03h(s int 10h) pre vymazanie obrazovky atd.
