;-------------------------------------hlavicka---------------------------------
;Zadanie c.2
;Text zadania:
;  Vytvorte  program,  ktory  nacta  z  textovho sboru postupnost celych csel (aspon 10)so znamienkom  v desiatkovej cselnej sstave, potom ich transformuje na csla v dvojkovej cselnej sstave v doplnkovom kde a potom podla priania pouzvatela
;A
;a) vypocta sumu  vsetkych csel a vypise ju
;b) usporiada csla vzostupne a zapse usporiadan postupnost csel
;   do novho textovho sboru,
;c) vydel dve vybran csla a vypse vysledok
;d) vynsob dve csla a vypse vysledok
;e) ukonc vykonvanie programu.
;autor:M.Seckar
;termin odovzdania:14.11.2000
;Skolsky rok 2000/2001
;-------------------------------program----------------------------------------

;definicia zasobniku
zas        segment stack
           dw      100 dup(?)
zas        ends

;definicia data segmentu
data       segment
buffer1    db      100 dup(0)   ;pomocne pole, obsahuje cely subor vstup.txt
buffer2    db      100 dup(0)   ;pomocne pole
buffer3    db      100 dup(0)   ;pole pre obrat a zapis do suboru vystup.txt
znaky      db        4 dup(0)

pocetcisel dw      00h          ;pocet cisel v subore
cisla      dw      25 dup(0)    ;max pocet cisel v subore
suma       dw      00h
pom1       dw      00h          ;pomocne premenne
pom2       dw      00h
pom3       dw      00h
pom4       dw      00h
pom5       dw      00h
pom6       dw      00h
m10000     dw      10000        ;konstanty pre konvertovanie cisla
m1000      dw       1000
m100       dw        100
m10        dw         10
mstring    db      "a) Vypocitaj sumu",13,10    ;menu string
           db      "b) Usporiadaj cisla vzostupne a zapis do suboru",13,10
           db      "c) Vydel dve vybrane cisla a vypis vysledok",13,10
           db      "d) Vynasob dve vybrane cisla a vypis vysledok",13,10
           db      "e) Ukonci program",13,10,"$"
fname1     db      "vstup.txt",0
fname2     db      "vystup.txt",0
fhandle1   dw      00h
fhandle2   dw      00h
fsize1     dw      00h
fsize2     dw      00h
hlaska001  db      "Program bol ukonceny.",13,10,"$"
hlaska002  db      "Subor nesiel otvorit !",13,10,"$"
hlaska003  db      "Subor otvoreny.",13,10,"$"
hlaska004  db      "Chyba pri citani zo suboru !",13,10,"$"
hlaska005  db      "Citanie prebehlo v poriadku !",13,10,"$"
hlaska006  db      "Chyba pri zatvarani suboru !",13,10,"$"
hlaska007  db      "Subor bol zatvoreny !",13,10,"$"
hlaska008  db      "Chyba pri nacitavani.(Nenacitalo sa tolto bytov kolko sa malo) !",13,10,"$"
hlaska009  db      "Pretecenie !",13,10,"$"
hlaska010  db      "Prosim zadajte dve cisla (oddelene medzerou, v tvare xx yy) : ",13,10,"$"

choice     db      00h    ;pom. premenna pri volbe z menu
data       ends

;definicia code segmentu
code       segment
           assume  cs:code,ss:zas,ds:data



;-----------------------------------------------------------------------------
start:
           mov      ax,seg data
           mov      ds,ax
;vykona sa pred vypisom vlastneho menu
           call     otvor_subor       ;volanie procedur, pozri nizsie
           call     zisti_velkost
           call     nacitaj_cisla
           call     zavri_subor
           call     konvertuj
;-----------------------------------------------------------------------------
vypis_menu:
;vymaze obrazovku
           call     vymaz_obrazovku
;vypise moznosti
           mov      dx,offset mstring
           call     hlaska              ;vseobecna procedura pre vypis stringu
;caka na klavesu
           call     read_key            ;procedura pre vstup z klavesnice
           mov      choice,al           ;vrati volbu pre vyber v menu
;urcenie volby
           cmp      choice,"a"
           jne      dalej1
           call     choice_a
dalej1:
           cmp      choice,"b"
           jne      dalej2
           call     choice_b
dalej2:
           cmp      choice,"c"
           jne      dalej3
           call     choice_c
dalej3:
           cmp      choice,"d"
           jne      dalej4
           call     choice_d
dalej4:
           cmp      choice,"e"
           jne      dalej5
           call     choice_e
dalej5:
           jmp      vypis_menu                  ;skok na opakovanie volby
;-----------------------------------------------------------------------------
choice_a:                           ;zac. volby a
           call     vymaz_obrazovku

           mov      ax,pocetcisel
           mov      pom1,ax
           mov      si,offset cisla
           xor      cx,cx

choice_a001:
           lodsw                         ;nacita do ax word z ds:[si],si+2 
           add      cx,ax
           jno      choice_a002
           mov      dx,offset hlaska009
           call     hlaska

choice_a002:
           dec      pom1
           jnz      choice_a001
           mov      suma,cx

           mov      pom1,5
           mov      bl,10
           mov      ax,suma
           mov      si,offset buffer2
           add      si,4

           test     ax,32768
           jz       choice_a003
           neg      ax

           push     ax
           mov      ah,02h
           mov      dl,"-"
           int      21h
           pop      ax

choice_a003:
           div      bl
           add      ah,48

           mov      ds:[si],ah
           xor      ah,ah

           dec      si
           dec      pom1
           jnz      choice_a003

           mov      cx,05h
           mov      si,offset buffer2
choice_a004:
           mov      ah,02h
           mov      dl,byte ptr ds:[si]
           int      21h
           inc      si
           loop     choice_a004

           call     read_key
           ret
;-----------------------------------------------------------------------------
choice_b:
           call     vymaz_obrazovku

           cmp      pocetcisel,01h
           je       choice_b999

           mov      ax,pocetcisel
           dec      ax
           mov      pom1,ax

choice_b001:
           mov      si,offset cisla

           mov      ax,pom1
           inc      ax
           mov      pom2,ax
           mov      cx,word ptr ds:[si]
           mov      pom3,si

choice_b002:
           lodsw
           cmp      ax,cx
           jnl      choice_b003

           mov      cx,ax
           mov      pom3,si
           sub      pom3,02h

choice_b003:
           dec      pom2
           jnz      choice_b002

           sub      si,02h
           mov      bx,pom3
           mov      ax,word ptr ds:[si]
           mov      word ptr ds:[si],cx
           mov      word ptr ds:[bx],ax

           dec      pom1
           jnz      choice_b001

choice_b999:
           mov      ax,offset buffer2
           mov      pom5,ax
           mov      ax,pocetcisel
           mov      pom2,ax

           mov      bl,10
           mov      si,offset cisla

choice_b004:
           mov      pom4,00h
           mov      pom1,5
           lodsw
           test     ax,32768
           jz       choice_b005

           mov      pom4,01h
           neg      ax

choice_b005:
           div      bl
           add      ah,48
           push     ax

           push     bx
           mov      bx,pom5
           mov      byte ptr ds:[bx],ah
           inc      pom5
           pop      bx

           pop      ax
           xor      ah,ah

           dec      pom1
           jnz      choice_b005

           cmp      pom4,01h
           jnz      choice_b006
           push     bx
           mov      bx,pom5
           mov      dl,"-"
           mov      byte ptr ds:[bx],dl
           inc      pom5
           pop      bx

choice_b006:
           push     bx
           mov      bx,pom5
           mov      dl," "
           mov      byte ptr ds:[bx],dl
           inc      pom5
           pop      bx

           dec      pom2
           jnz      choice_b004

           sub      pom5,2
           mov      bx,pom5
           mov      cx,pom5
           sub      cx,offset buffer2
           inc      cx
           mov      si,offset buffer3

           mov      fsize2,cx
           cmp      cx,00h
           jz       choice_b008
choice_b007:
           mov      al,byte ptr ds:[bx]
           mov      byte ptr ds:[si],al
           inc      si
           dec      bx
           loop     choice_b007

choice_b008:
           mov      byte ptr ds:[si],"$"
           mov      dx,offset buffer3
           call     hlaska
           call     read_key

           mov      ah,5bh
           mov      dx,offset fname2
           mov      cx,20h
           int      21h
           mov      fhandle2,ax

           mov      ah,40h
           mov      bx,fhandle2
           mov      cx,fsize2
           mov      dx,offset buffer3
           int      21h

           mov       ah,3eh
           mov       bx,fhandle2
           int       21h

           ret
;-----------------------------------------------------------------------------
choice_d:
           call      vymaz_obrazovku
           mov       dx,offset hlaska010
           call      hlaska

           mov       ah,0ah
           mov       dx,offset buffer3
           mov       bx,dx
           mov       byte ptr ds:[bx],06h
           int       21h

           mov       bx,offset buffer3
           add       bx,2
           mov       al,byte ptr ds:[bx-1]
           xor       ah,ah
           add       bx,ax
           mov       byte ptr ds:[bx],"$"

           call      vymaz_obrazovku
           mov       dx,offset buffer3
           add       dx,2
           mov       pom1,dx
           call      hlaska
           call      read_key

           mov       bx,pom1

           sub       byte ptr ds:[bx],48
           sub       byte ptr ds:[bx+1],48
           sub       byte ptr ds:[bx+3],48
           sub       byte ptr ds:[bx+4],48

           mov       al,byte ptr ds:[bx]
           mov       dl,10
           mul       dl
           add       al,byte ptr ds:[bx+1]
           xor       ah,ah
           mov       pom2,ax

           mov       ax,pocetcisel
           sub       ax,pom2
           mov       pom2,ax

           mov       al,byte ptr ds:[bx+3]
           mul       dl
           add       al,byte ptr ds:[bx+4]
           xor       ah,ah
           mov       pom3,ax

           mov       ax,pocetcisel
           sub       ax,pom3
           mov       pom3,ax

           mov       bx,offset cisla
           mov       ax,pom2
           shl       ax,01h
           add       bx,ax
           mov       ax,word ptr ds:[bx]
           mov       pom4,ax

           mov       bx,offset cisla
           mov       ax,pom3
           shl       ax,1
           add       bx,ax
           mov       ax,word ptr ds:[bx]
           mov       pom5,ax
           mov       ax,pom4
           mul       pom5
           mov       pom6,ax

           mov       si,offset buffer2
           mov       byte ptr ds:[si+5],"$"
           add       si,4
           mov       cx,5

           mov       bx,10
	   mov       ax,pom6
           test      ax,32768        ;10000000b-najvysi bit
           jz        choice_d001
           neg       ax

           push      ax
           mov       ah,02h
           mov       dl,"-"
           int       21h
           pop       ax

choice_d001:
           xor       dx,dx
           div       bx
           add       dl,48

           mov       byte ptr ds:[si],dl

           dec       si
           loop      choice_d001

           mov       dx,offset buffer2
           call      hlaska

           call      read_key

           ret
;-----------------------------------------------------------------------------
choice_c:
           ret
;-----------------------------------------------------------------------------
choice_e:
           call     vymaz_obrazovku
           mov      ah,09h
           mov      dx,offset hlaska001
           int      21h
           mov      ah,4ch
           int      21h
           ret
;-----------------------------------------------------------------------------
vymaz_obrazovku:
;vymaze obrazovku
           mov      ax,03h
           int      10h
           ret
;-----------------------------------------------------------------------------
read_key:
;caka na klavesu
           mov      ah,01h
           int      21h
           ret
;-----------------------------------------------------------------------------
hlaska:
           mov      ah,09h
           int      21h
           ret
;-----------------------------------------------------------------------------
dalsi_riadok:
           mov      ah,08h
           mov      dl,13
           int      21h

           mov      ah,08h
           mov      dl,10
           int      21h
           ret
;-----------------------------------------------------------------------------
otvor_subor:
           call     vymaz_obrazovku

           mov      ah,3dh              ;sluzba DOSu pre otvaranie suboru
           mov      dx,offset fname1
           mov      al,00h              ;otvorenie pre citanie
           int      21h

           jnc      otvor_subor001      ;skoci ak nie je chyba

           mov      dx,offset hlaska002 ;ak je chyba vypise chybovu hlasku
           call     hlaska
           call     read_key
           jmp      choice_e            ;ukonci program kvoli chybe

otvor_subor001:
           mov      fhandle1,ax         ;uchovanie ukazovatela na subor pre citanie

           mov      dx,offset hlaska003 ;vypis hlasky ze sa podarilo nacitat
           call     hlaska
           call     read_key

           ret          ;navrat do menu
;-----------------------------------------------------------------------------
zisti_velkost:
           mov      ah,42h              ;sluzba Dosu pre posun ukazovatela vo subore
           mov      bx,fhandle1
           xor      cx,cx
           xor      dx,dx
           mov      al,02h              ;posun od konca suboru o DX*65536+CX
           int      21h

           mov      fsize1,ax           ;ulozim si dlzku suboru

           mov      ah,42h
           mov      bx,fhandle1
           xor      cx,cx
           xor      dx,dx
           mov      al,00h              ;presun ukazovatela od zaciatku o 0 bytov
           int      21h                 ;tym sa dostanem na zaciatok suboru

           ret          ;navrat do menu
;-----------------------------------------------------------------------------
nacitaj_cisla:
           call     vymaz_obrazovku

           mov      ah,3fh            
           mov      bx,fhandle1
           mov      dx,offset buffer1
           mov      cx,fsize1

           int      21h

           jnc      nacitaj_cisla001

           mov      dx,offset hlaska004
           call     hlaska
           call     read_key
           jmp      choice_e

nacitaj_cisla001:

           cmp       ax,fsize1
           je        nacitaj_cisla002

           mov       dx,offset hlaska008
           call      hlaska
           call      read_key
           jmp       choice_e

nacitaj_cisla002:
           mov       dx,offset hlaska005
           call      hlaska
           call      read_key

           ret
;-----------------------------------------------------------------------------
zavri_subor:
           call      vymaz_obrazovku

           mov       ah,3eh
           mov       bx,fhandle1
           int       21h

           jnc       zavri_subor001

           mov       dx,offset hlaska006
           call      hlaska
           call      read_key
           jmp       choice_e

zavri_subor001:
           mov       dx,offset hlaska007
           call      hlaska
           call      read_key

           ret
;-----------------------------------------------------------------------------
konvertuj:
           mov       si,offset buffer1
           mov       al,byte ptr ds:[si]
           sub       al,48
           mov       bl,10
           mul       bl
           mov       cx,ax
           mov       al,byte ptr ds:[si+1]
           sub       al,48
           add       cx,ax
           mov       pocetcisel,cx

           mov       pom1,cx
           mov       pom3,offset cisla
           mov       si,offset buffer1
           add       si,3

konvertuj001:
           mov       pom2,00h
           mov       al,byte ptr ds:[si]
           cmp       al,"-"
           jne       konvertuj002
           inc       si
           mov       pom2,01h

konvertuj002: 
           mov       al,byte ptr ds:[si]
           sub       al,48
           xor       ah,ah
           mul       m10000
           mov       cx,ax

           mov       al,byte ptr ds:[si+1]
           sub       al,48
           xor       ah,ah
           mul       m1000
           add       cx,ax

           mov       al,byte ptr ds:[si+2]
           sub       al,48
           xor       ah,ah
           mul       m100
           add       cx,ax

           mov       al,byte ptr ds:[si+3]
           sub       al,48
           xor       ah,ah
           mul       m10
           add       cx,ax

           mov       al,byte ptr ds:[si+4]
           sub       al,48
           xor       ah,ah
           add       cx,ax

konvertuj003:
           cmp       pom2,01h
           jne       konvertuj004
           neg       cx

konvertuj004:
           mov       bx,pom3
           mov       word ptr ds:[bx],cx
           add       pom3,2

           add       si,6
           dec       pom1
           jnz       konvertuj001

           ret
;-----------------------------------------------------------------------------
code       ends
           end start

;zhodnotenie:
Z casovej tiesne som nestihol dokoncit ulohu c (delenie).
