; MARIAN SEDLACEK B12

JUMPS
ZAS     SEGMENT STACK 'STACK'         ; zaciatok SS(zasobnikoveho segmentu)
        DW      64 DUP(?)             ; definicia 64 slov 
ZAS     ENDS                          ; koniec SS

DATA    SEGMENT                       ; zaciatok DS(datoveho seg.)
RETAZEC DB      'NAPIS RETAZEC:$'     ; vstup retazca

MENU    DB      13,10,'1: VYPIS ZADANY RETAZEC',13,10    ; vypis menu s ponukou
        DB      '2: VYPIS POCET CISLIC V RETAZCI',13,10
        DB      '3: ZISTI HLADANY ZNAK V RETAZCI',13,10
        DB      '4: NAJDI ZNAK S MINIMALNOU HODNOTOU',13,10
        DB      '5: KONVERTUJ MALE PISMENA NA VELKE',13,10
        DB      '6: ZAROVNAJ TEXT ZPRAVA',13,10
        DB      '7: UKONCI PROGRAM',13,10
        DB      'ZADAJTE CISLO ULOHY:$'          ; cislo ulohy???
VETA2   DB      13,10,'POCET CISLIC V RETAZCI JE:$'    ; pomocna veta v ULH2
VETA4   DB      13,10,'ZNAK S MINIMALNOU HODNOTOU JE:$' ; pomocna veta v ULH4
NR      DB      0DH, 0AH                               ; novy riadok
VETA3   DB      13,10,'ZADAJTE HLADANY ZNAK' ; pomocna veta v ULH3
VSTUP   DB      100                        ; deklaracia premenej VSTUP
POCET   DB      0                          ; dekl. prem. POCET znakov retazca
        DB      100 DUP (?)
VYSTUP  DB      103 DUP (?)
ZNAK    DB      1

DATA    ENDS                               ; koniec DS

CODE    SEGMENT                            ; zaciatok CS( kodoveho segmentu)
        ASSUME  DS:DATA, SS:ZAS, CS: CODE  ; priradenie segmentov

START:  MOV     AX, SEG DATA               ; vlozenie segmentovu cast adresy do AX
        MOV     DS, AX                     ; seg.cast adr. presun do DS
        MOV     DX, OFFSET RETAZEC         ; do DX vlozime posunutie retazca v datovom segmente
        MOV     AH, 09H                    ; funkcia vypis retazca
        INT     21H                        ; volanie sluzby MS-Dosu

        MOV     DX, OFFSET VSTUP           ; do DX posunutie vstupu
        MOV     AH, 0AH                    ; funkcia nacitania znaku
        INT     21H

UROB:    MOV     DX, OFFSET MENU            ; do DX posunusite MENU
        MOV     AH, 09H                    ; vypis MENU
        INT     21H

        MOV     AH, 01H                    ; naciatnie jedneho znaku
        INT     21H
        CMP     AL, 31H                    ; porovnavanie AL s '1'
        JE      ULH1                       ; v pripade zhody skok na ULH1
        CMP     AL, 32H                    ; atd.....
        JE      ULH2
        CMP     AL, 33H
        JE      ULH3
        CMP     AL, 34H
        JE      ULH4
        CMP     AL, 35H
        JE      ULH5
      ; CMP     AL, 36H
      ; JE      ULH6
        CMP     AL, 37H
        JE      ULH7
        JMP     UROB

ULH7:   MOV     AH,4CH                    ; funkcia ukoncenia programu
        INT     21H

ULH1:   MOV     DX, OFFSET VSTUP          ; ULOHA1-VYPIS RETAZCA ... do DX posunutie vstupu
        ADD     DX, 2                     ; nutna korekcia - pricitanie dvojky
        MOV     SI, DX                    ; source indexu prirad DX 
        MOV     BX, OFFSET VYSTUP         ; do BX prirad offset vystupu
        XOR     AX, AX                    ; vynulovanie registra AX 
        MOV     CL, POCET                 ; do CL dame dlzku retazca
OPAK1:  MOV     AL, [SI]                  ; do AL dame adresu [SI]
DALEJ1: MOV     [BX], AL                  ; do [BX] vlozime AL
        INC     SI                        ; inkrementujeme SI
        INC     BX
        LOOPNE  OPAK1                     ; spat na OPAKuj1 v pripade SI<POCET
ZOBRAZ1:MOV     byte ptr [BX], 0AH        ; vypis retazca .. korekcia - priadnie ENTERU a noveho riadku
        MOV     byte ptr [BX+1], 0DH
        MOV     byte ptr [BX+2], '$'
        MOV     DX, OFFSET NR
        MOV     AH, 09H                   ; funkcia vypisu znaku 
        INT     21H
        JMP     UROB                       ; spat do menu

ULH2:   MOV     BX, 0                   ; vynulovanie registra B
        MOV     SI, 0                   ; vynulovanie cieloveho indexu
        XOR     CX, CX                  ; vynulovanie reg. C
        MOV     CL, [POCET]             ; ulozenie [pocet] do CL
OPAK2:  MOV     AL, [VSTUP+2+SI]        ; postupne vkladanie znakov retazca do AL
        CMP     AL, 30H                 ; porovnanie s 30H == 0
        JB      NECIS                   ; ak je mensie skok na NECIS
        CMP     AL, 39H                 ; porovn. s 39H == 9
        JA      NECIS

        INC     BX                      ; ak je cislo => inkrementuje BX(pocet cislic v retazci)

NECIS:  INC     SI                      ; inkrementuje SI - source index
        LOOPNE    OPAK2                 ; skok na OPAK2 ak nie je na konci retazca SI=POCET

        MOV     DX, OFFSET VETA2        ; vlozenie VETy2
        MOV     AH, 09H
        INT     21H                     ; vypis DX
        MOV     AX, BX                  ; vloz BX do AX
        MOV     BL, 10                  ; korekcie v pripade ze pocet cislic je dvojciferny
	DIV     BL
        MOV     DX, AX                  
        ADD     DL, 30H                 ; nutna korekcia- posunutie o 30H 
        MOV     AH, 02H
        INT     21H
        MOV     DL, DH
	ADD     DL, 30H
        MOV     AH, 02H                 ; vypis znaku
	INT     21H
        JMP     UROB                     ; spat do hlavneho MENU

ULH4:   MOV     BX, 0                   ; vynulovanie BX
        MOV     SI, 0                   ; vynulovanie SI
        XOR     CX, CX                  ; vynulovanie CX
        MOV     CL, [POCET]             ; adr. premenej POCET do CL
        MOV     BL, [VSTUP+2+SI]        ; do BL vlozime adresu VSTUPU + 2 (korekcia) + SIndex --- v BX je prvy znak retazca
OPAK4:  MOV     AL, [VSTUP+3+SI]        ; do AL vlozime znak za BL 
        
        CMP     AL, BL                  ; porovanavie BL, AL 
        JNB     DALEJ4                  ; ak je AL  vacsie skok na DALEJ4
        MOV     BL, AL                  ; ak je AL mensie tak ho ulozi do BL 
        
DALEJ4: INC     SI                      ; inkrementujem SI
        LOOP    OPAK4
       
        MOV     DX, OFFSET VETA4        ; vypis vety4
        MOV     AH, 09H
        INT     21H
        MOV     DL, BL
        MOV     AH, 02H                  ; funkcia vypisu znaku
	INT     21H
        JMP     UROB                      ; spat do menu


ULH5:   MOV     DX, OFFSET VSTUP           ; ULOHA5-KONVERZIA
        ADD     DX, 2                      ; pricitanie DX dvojku
        MOV     SI, DX                     ; do SI same DX
        MOV     BX, OFFSET VYSTUP          ; do BX posunutie vystupu
        XOR     AX, AX                     ; nulovanie registrov
        XOR     CX, CX
        MOV     CL, POCET                  ; do CL dame POCET
OPAK5:  MOV     AL, [SI]                   ; do AL dame adresu SI
        CMP     AL, 60H                    ; porovanme AL so znakom pred 'a'
        JBE     DALEJ5                     ; v pripade ze je mensi skok na DALEJ5
        CMP     AL, 7BH                    ; porovn. so znakom o jedno vacsim nez 'z'
        JNB     DALEJ5
        SUB     AL, 20H                    ; v pripade ze AL je male pismeno tak odpocita 20H => konvertuje na velke
DALEJ5: MOV     [BX], AL                   ; do [BX] dame AL
        INC     SI                         ; inkrementujeme SI,BX
        INC     BX                         ; v pripade SI<POCET => skok na opak5
        LOOPNE  OPAK5
ZOBRAZ5:MOV     byte ptr [BX], 0AH         ; vypis konvertovaneho retazca
        MOV     byte ptr [BX+1], 0DH
        MOV     byte ptr [BX+2], '$'
        MOV     DX, OFFSET NR
        MOV     AH, 09H
        INT     21H
        JMP     UROB

ULH3: ;  MOV     DX, OFFSET VETA3          ... nedokoncene
      ;  MOV     AX, 09H
      ;  INT     21H

      ;  MOV     DX, OFFSET ZNAK
      ;  MOV     AH, 0AH
      ;  INT     21H

      ;  JMP UROB

CODE    ENDS                               ; koniec kodoveho segmentu
        END     START                      ; koniec suboru - pre assembler
        

             


