;Zadanie c.3
;S vyuzitm retazcovych instrukci (vsade kde je to mozn) vytvorte program, 
;ktory:
;a) nacta z klavesnice dva retazce do dvoch roznych segmentov (minimalne 20B)
;b) prvy retazec presunie v segmente o 10 slabk  na vyssie adresy,
;c) porovna posunuty retazec s retazcom v druhom segmente, t.j. zist, ci 
;   s rovnako dlh a ci s rovnak,
;d) zist, ci sa v niektorom z retazcov nachadza zadany podretazec.
;Vysledky ukazte v ladiacom prostred TurboDebugg.
;Termin odovzdania:     5.12.2000
;Autor:                Marian Sedlacek

;*********************************************************
data1 segment                         ; 1.datovy segment

poc1 db 0                             ; dlzka retaz1
retaz1 db 40 dup (?)                  ; 1.retazec => v data1
txt01 db "Zadajte prvy retazec",0ah,0dh,'$'
txt02 db "Zadajte druhy retazec",0ah,0dh, '$'
txt1 db "Retazce nie su rovnake t.j. su rozne dlhe alebo su rozne",0ah,0dh,'$'
txt2 db "Retazce su rovnake",0ah,0dh,'$'
txt3 db "Zadajte hladany podretazec",0ah,0dh,'$'
txt4 db "Obsahuje hladany podretazec",0ah,0dh,'$'
txt5 db "Neobsahuje hladany podretazec",0ah,0dh,'$'
poc3 db 0                             ; pocet byte hlad. podret.
podret  db 30 dup(?)                  ; hladany podretazec

data1 ends
;*********************************************************
data2 segment

poc2 db 0                             ; dlzka retaz2
retaz2 db 30 dup (?)                  ; 2.retazec => v data2

data2 ends
;*********************************************************
code segment

assume cs:code,ds:data1,es:data2
start:	mov ax,seg data1
	mov ds,ax
        mov dx,offset txt01
	mov ah,09h
        int 21h                       ; vypis poziadavky naciatnia1
	mov dx,offset retaz1
	mov ah,3fh
	xor bx,bx
	mov cx,30
        int 21h                       ;nacitanie retazca1 do data1
	jc chybvst
        mov poc1,al                   ;ulozenie poctu nacitanych byte

        
        mov dx,offset txt02
	mov ah,09h
        int 21h                        ;vypis poziadavky naciatania2
        
        mov ax,seg data2               ; inicializovanie 2.segmentu
	mov ds,ax
	mov es,ax
        mov dx,offset retaz2           ; analogicky postup ako pri retaz1
	mov ah,3fh
	xor bx,bx
        int 21h                 
	jc chybvst
	mov poc2,al
	jmp b

chybvst: jmp koniec
		
b:      mov ax,seg data1        ; presunutie retaz1 v data1 o 10byte smerom na vysie adresy
        mov ds,ax               ; do dat.segm. dame offset data1
        mov es,ax               ; do extra segm. ----||---------
        mov cl,poc1             ; do cl dlzku retaz1
	xor ch,ch
        add bx,cx               ; do bx dame dlzku retazca1
        mov si,bx               ; si nasmerujeme na koniec retaz1  ds:[si]
        add bx,10               ; bx zvysime o 10
        mov di,bx               ; di nasmerujeme na koniec retaz1 plus10bytov
        std                     ; es:[di]
        cli                     
        repz movsb              ; prekopirovanie retazca od konca
	sti
	cld

c:      mov ax,seg data2        ; do ax dame offset data2
        mov es,ax               ; do es <= ax
        mov bx,offset poc1      ; bx offset dlzky retaz1
        mov si,bx               ; si <= bx
        mov cl,ds:[bx]          
        xor ch,ch               
	mov di,offset poc2
	cmpsb			;zisti, ci su retazce rovnako dlhe
	jne rozne
        add si,10               ;nastavenie indexov na prve prvky
c1:	cmpsb
	loopz c1		;porovnanie prvkov
	jnz rozne
        mov dx,offset txt2
	mov ah,09h
        int 21h                 ;vypis textu -> su rovnake
	jmp d

rozne:  mov dx,offset txt1
	mov ah,09h
        int 21h                 ;vypis textu -> nie su rovnake

d:      mov dx,offset txt3
	mov ah,09h
        int 21h                 ;vypis textu na zadanie podretazca
	mov dx,offset podret
	mov ah,3fh
	xor bx,bx
	mov cx,30
        int 21h                 ;nacitanie hladaneho podretazca
	jc chybvst
	mov poc3,al		;ulozi pocet nacitanych byte

        xor ax,ax               ; nulovanie ax
        mov si,offset podret    ; do si posunutie podret
        push ds                 ; ds na zasobnik
        pop es                  ; nastavenie segmentovych registrov
        mov di,offset retaz1 + 10    ;nastavenie indexovych registrov
        mov cl,poc1             
        sub cl,2                ; do cl dlzka retaz1 ale bez entera
	xor ch,ch
	mov dl,poc3
	xor dh,dh
        sub dl,2                ; do dl dlzka podret bez entera
        cmp dl,cl               ; porovnanie dlzky
        jna d1                  
        call nie                ; logicka chyba ak dlzka podret >.. neobs.
        jmp d2                  ; skok hladanie v druhom retazci

d1:     inc al                  ; inkrementujem al
	dec cl
	cmp cl,0ffh
	je p
	cmpsb			;porovnanie byte retazca a podretazca
	je d1
	dec al
	cmp dl,al		;obsahuje, ak sa rovnaju dlzky rovnakych byte
	jne p2
p:	call ano
	jmp d2
p2:	mov si,offset podret	;nastavenie indexu
	mov dl,poc3		;pocet znakov podretazca
	sub dl,2
	inc cl
	xor al,al
	loop d1			;opakovanie cyklu cez cely retazec
	call nie

d2:	mov ax,seg data2	;analogicky pre druhy retazec
	mov es,ax
	xor ax,ax
	mov di,offset retaz2
	mov si,offset podret
	mov cl,poc2
	sub cl,2
	xor ch,ch
	mov dl,poc3
	xor dh,dh
	sub dl,2
	cmp dl,cl
	jna d3
	call nie
	jmp koniec
d3:	inc al
	dec cl
	cmp cl,0ffh
	je s
	cmpsb
	je d3
	dec al
	cmp dl,al
	jne p4
s:	call ano
	jmp koniec
p4:	mov si,offset podret
	mov dl,poc3
	sub dl,2
	inc cl
	xor al,al
	loop d3
	call nie

koniec: mov ax,4c00h
	int 21h

nie:    mov dx,offset txt5     ;vypis textu, ak neobsahuje
	mov ah,09h
	int 21h
	ret

ano:    mov dx,offset txt4     ;vypis textu, ak obsahuje
	mov ah,09h
	int 21h
	ret

code ends
end start

; Zhodnotenie :
;Program je plne funkcny. Program bol prelozeny programom tasm a zlinkovany
;tlink-om. Program nacita dva retazce(max30bytov) do dvoch segmentov.
;najskor posununie prvy retazec o 10B smerom k vyssim adressam.
;porovna ich t.j. zisti ci su rovnake resp. rovnako dlhe a s rovnakym obsahom
;nacita podretazec, ktory hlada v prvom aj v druhom retazci
;.Program pouziva DOS a BIOS prostrednictvom preruseni 10h
; a 21h.


