;Zadanie c.1
;text zadania: NAPISTE PROGRAM, KTORY NACITA Z KLAVESNICE RETAZEC ZNAKOV (MAX 100) A PODL PONUKANEHO MENU VYKONA JE DNU Z TYCHTO MOZNOSTI:
;a) VYPISE RETAZEC ZNAKOV NA OBRAZOVKU
;b) VYPISE POCET CISLIC V RETAZCI
;c) ZISTI, CI SA V RETAZCI NACHADZA POUZIVATELM ZADANY ZNAK A VYPISE O TOM SPRAVU
;d) NAJDE ZNAK S MINIMALNOU HODNOTOU A VYPISE HO
;e) MALE PISMENA KONVERTUJE NA VELKE
;f) ZAROVNA TEXT ZPRAVA (VYNACHANIE PRVYCH MEDZIER OD KONCA)
;g) UKONCI VYKONAVANIE PROGRAMU
;Autor: Marek Skalak
;termin odovzdania: 24.10.2000
;2. roc., sk. rok 2000/2001




model small
data segment	;zaciatok datoveho segmentu
	text1 db 'Menu:',0                                   ;definicia retazca
	text2 db 10,13,10,13,'1. Vypis retazec',0
	text3 db 10,13,'2. Konvertuj male na velke',0	     ;retazce ukoncene	
	text4 db 10,13,'3. Pocet cislic v retazci',0	     ;logickou nulou
	text5 db 10,13,'4. Zadaneho znak v retazci',0
	text6 db 10,13,'5. Znak s minimalnou hodnotou',0
	text20 db 10,13,'6. Zarovnanie retazca zprava',0
	text7 db 10,13,'7. Koniec',0
	text8 db 10,13,10,13,'Volba (1-7)? ',0
	text9 db 'Zadaj retazec: ',0
        text10 db 10,13,10,13,'Stlac nieco ...',0
        text11 db 10,13,10,13,'Retazec: ',0
        text14 db 10,13,10,13,'Zadany retazec neobsahuje cislice!',0
        text15 db 10,13,10,13,'Pocet cislic v retazci je: ',0
        text17 db 10,13,10,13,'Hladany znak: ',0
	text18 db 10,13,'Pozicie najdenych znakov: ',0
	text19 db 10,13,'Pocet najdenych znakov: ',0
	text21 db 10,13,10,13,'',0
	retazec db 100 dup(0)			;definica 100 znakov ukoncenych tiez logickou nulou	
	vout db 100 dup(0)
        CISLO   db 0,0,0
	stack 64


poceti db 100    ;pomocna premenna hovoriaca o maximalnom pocte znakov v retazci


data ends		;koniec segmentu
code segment		;zaciatok jkodoveho segmentu
	assume cs:code,ds:data,ss:data	;direktiva-oznamuje asm aktivne segmenty

start:	mov ax,seg data		;do ax vloz segmentovu cast adresy
	mov ds,ax		;seg. cast adresy presun do ds
        xor cx,cx		;vynulovanie registra cx
	call zmazobr		;zavolanie procedury na zmazanie obrazovky
	call nacitajret		;---------------------- nacitanie retazca
menu:   call zmazobr
	call vypismenu		;vypis menu
	call citajznak		;cako na stlacenie cisla v menu
	cmp al,'1'		;ak bola stacena jednotka
	jz vypisanie		;potom vypis retazec
	cmp al,'2'
	jz konverz		;konvertuj male na velke
	cmp al,'3'
	jz zisticislice		;kolko je v retazci cislic
	cmp al,'4'
	jz vysk			;vyskyt daneho znaku
	cmp al,'5'
	jz najdiznak		;najdi znak s min. hodnotou
	cmp al,'6'
	jz dopravax		;zarovnaj text
	cmp al,'7'
        jz koni			;koniec
	jmp menu
vysk:	jmp zistivyskyt
koni:	jmp koniec

vypisanie:		;vypis povodneho retazca
	mov dx,offset text11	;do dx vloz posunutie retazca v dat segmente
        call vypisret		;vola proceduru na vypis retazca
	mov dx,offset retazec
	call vypisret
	mov dx,offset text10
	call vypisret
	jmp menu		;vrat sa do menu

zisticislice:		;zisti pocet cislic v retazci
        xor cx,cx	
	mov bx,offset retazec
	dec bx		;posunutie adresy bx o 1 nizsie
zac3:   inc bx		;posinutie adresy bx doprava
	cmp byte ptr [bx],0	;porovnava ukozovatel adresy bx typu byte(znak) s 0
        jz kon3			;ak je tak koniec
	cmp byte ptr [bx],48	;zistuje ci je to cislica
	jb zac3
	cmp byte ptr [bx],57
	jg zac3			;ak ano skoc spet
	inc cl
	jmp zac3
kon3:	cmp cl,0			;inak opusti avypis spravu
	jnz kon4
	mov dx,offset text14
	call vypisret
	mov dx,offset text10
	call vypisret
	jmp menu			vrat sa so menu
kon4:   push cx				;vloz do zasobniku
	mov dx,offset text15
	call vypisret
	xor bx,bx
	pop cx				;vyber zo zasobniku
        mov bl,cl
	call vypiscisla			;vola proceduru pre vypis cisla	
	mov dx,offset text10
	call vypisret
	jmp menu			;koniec podprogramu

konverz:
	jmp konverzia

dopravax:
	jmp doprava

najdiznak:				;znak s min hodnotou
	mov dx,offset text17
	call vypisret
	mov si,offset retazec
	mov al,0FFH			;do al da najvacsi znak
c5:	mov ah,ds:[si]	
	cmp al,ah
	jb vacsie
	mov al,ah			;porovnava znaky a ten mensi zapisuje do registra	
vacsie:	inc si				;nakoniec sa vypisre
	cmp byte ptr ds:[si],0
	jnz c5
	mov ah,2
	mov dl,al
	int 21h
	mov dx,offset text10
	call vypisret
	jmp menu


doprava:			;zarovnanie textu doprava
	mov dx,offset text21
	call vypisret
	mov si,offset retazec
	xor cx,cx
c6:	cmp byte ptr ds:[si],0
	jz konx				;zistenie velkosti retazca
	inc si
	inc cx
	jmp c6
konx:	dec si
c7:	cmp byte ptr ds:[si],' '	;zrusi medzery v retazci posledne
	jnz nieme
	dec si
	dec cx
	jmp c7
nieme:	mov ax,80d		;do ax ulozi pocet znakov zmestiacich sa na obrazovku
	sub ax,cx
	mov bx,cx		;vypovita a potom zapise kolko medzier trebanapisat na obrazovku aby retazec mohol byt vypisany na koniec obrazovky
	mov cx,ax
c8: 	mov dl,' '
	mov ah,2
	int 21h
	loop c8
	mov si,offset retazec
	mov cx,bx
ca:	mov dl, ds:[si]
	inc si
	mov ah,2
	int 21h
	loop ca
	
	mov dx,offset text10
	call vypisret
	jmp menu		;koniec podprogramu
	

konverzia:          			;konverzia znakov z malych na velke
	mov si,offset retazec
	mov di,offset vout		;vystup konvertovaneho retazca
	xor cx,cx	
	mov cl,[poceti]
	xor ax,ax
presun3:
	mov al,[si]		;adresa si do al
	cmp al,60h		;al porovna zo znakom
	jb znova3
	cmp al,7bh
	ja znova3
	sub al,20h		;al minus 20h
znova3:
	mov [di],al		;al na adresu di
	inc di
	inc si
        loopne presun3		;pokial nie na konci tak sa bude vracat
	mov byte ptr[di],0	;posunie znak 0 do konca adresy di ;ukoncovaci znak;logicka 0
	mov dx, offset text11
	call vypisret
	mov dx,offset vout
	call vypisret
	mov dx,offset text10
	call vypisret
	jmp menu

zistivyskyt:			;zistenie vyskytu pouzivatelom zadaneho znaku
	mov dx,offset text17
	call vypisret
	xor cx,cx
	call citajznak
	mov bx,offset retazec			;zisty na ktorych miestach sa dany znak nachadza a kolko krat tam je
	mov ah,2
	dec bx
znovu:  inc bx
        inc ch
	cmp byte ptr [bx],0
	jz mimo
	cmp [bx],al
	jnz znovu
	cmp cl,0
        jnz dalej
	push bx
	push cx
        push ax
	mov dx,offset text18
	call vypisret
        pop ax
	pop cx
	pop bx				;pouzity je zasobnik
dalej:	inc cl
	push bx
	push cx
        push ax
        xor bx,bx
	mov bl,ch
	call vypiscisla
	mov dl,' '
	int 21h
	pop ax
	pop cx
	pop bx
	jmp znovu
mimo:   push cx
	mov dx,offset text19
	call vypisret
        pop cx
	xor bx,bx
	mov bl,cl
	call vypiscisla
	mov dx,offset text10
	call vypisret
	jmp menu			;koniec podprogramu


koniec:	mov ah,4ch		;ukoncenie programu
	int 21h

zmazobr proc		;procedura na znazanie obrazovky ;obrazovku prepise medzerami
	mov ah,6
	mov ch,0
	mov cl,0
	mov dh,25
	mov dl,80
	mov al,0
	mov bh,07h
	int 10h		;zmazanie obrazovky
	mov ah,2
	mov dh,0
	mov dl,0
	mov bh,0
	int 10h		;kurzor na (0,0)
	ret
	endp

citajznak proc		;procedura na nacitanie znaku z klavesnice pre ovladanie menu
zac0:	xor cl,cl
zac:	mov ah,8
	int 21h
	cmp al,0
	jnz kon
	mov cl,1
        jmp zac			;znaky cita po jednom a po jednom ich bude aj vypisovat
kon:    cmp ch,1
	jz von1
	cmp cl,1
	jz zac0
        mov ch,dl
	mov dl,al
	mov ah,2
	int 21h
	mov dl,ch
von1:	xor ch,ch
	ret		;ukoncenie 
	endp		;procedury

vypismenu proc		;procedura pre vypis menu
	mov dx,offset text1
	call vypisret
	mov dx,offset text2
	call vypisret
	mov dx,offset text3
	call vypisret
	mov dx,offset text4
	call vypisret
	mov dx,offset text5
	call vypisret
	mov dx,offset text6	
	call vypisret			;vypis menu na obrazovku
	mov dx,offset text20
	call vypisret
	mov dx,offset text7
	call vypisret
	mov dx,offset text8
        call vypisret
        ret
	endp

nacitajret proc			;na nacitanie zadaneho retazca
	mov dx,offset text9
        call vypisret
	mov bx,offset retazec
	mov dx,bx
	add dx,100			;nacita retazec max 100 znakov a ulozi do retazec
citaj:	call citajznak
	cmp al,13
	jz mamret
	cmp al,8
        jnz cit 
	cmp bx,offset retazec
        jz citaj1
        push dx
	dec bx
	mov byte ptr [bx],0
	mov ah,2
	mov dl,' '
	int 21h
	mov dl,8
	int 21h
	pop dx
        jmp citaj
citaj1:	mov ah,2
	mov dl,' '
	int 21h
	jmp citaj
cit:	mov [bx],al
	inc bx
	cmp bx,dx
	jz mamret
	jmp citaj
mamret:	ret
	endp

vypisret proc			;vypis retazca
	mov ah,2
        mov cx,dx
	mov bx,dx
vypis:	mov dl,[bx]
	cmp dl,0
        jz konvyp
	int 21h			
	inc bx
	jmp vypis
konvyp:	mov bx,offset text10
	cmp cx,bx
        jnz von
	mov ch,1
	call citajznak
von:	ret
	endp



vypiscisla PROC			; vypis cisla na obrazovku
	XOR AH, AH		; Tymto sposobom sme do AX (16 bit) dostali
	MOV AL, BL		; osembitove cislo.
        			
	MOV BH, 10		; Do BH si vlozime cislo 10
	DIV BH			; DELENIE: AL = AX / 10
				;	   AH = AX mod 10
	MOV SI, OFFSET CISLO	; Do SI nadstavim pointer CISLO
	ADD AL, 30H		; Cislo typu INT 
	MOV [SI], AL		;
	INC SI			; zvisi adresu si o 1
	ADD AH, 30H		; Cislo typu INT -> do ASSCI tab.
	MOV [SI], AH		; do ah zapise adresu si
	MOV DX, OFFSET CISLO	; 
	call vypisret			

	RET			; navrat z procedury
	ENDP



code ends
end start




;Hodnotenie:
;Program je uplne funkcny nezistil som ziadne nedostatkly.
;Program bol vypracovany a skompilovany v Turbo assemberi 2.02 na pocitaci radu PENTIUM II
;Program by nemal havarovat vzhladom na vstupne udaje (aspon som nezistil ziadne udaje pri ktorych program spadol)
;Retazec bol ukoncovany logickou nulou (co sa mi zdalo lepsia alternativa ako ukoncovanie znakom $)
;Urcite by bolo mozne program optimalizovat vylepsit ale doterajsie skusenosti s tymto programovacim jazykom my to neumoznily.
;Algoritmy su jednoduche a su tu pouzite zakladne instrukcie jazyka