;Zadanie c. 3
;
;Autor: Marek Skalak, B12
;
;Text zadania :
;S vyuzitim  retazcovych  instrukcii  (vsade   kde  je  to  mozne)
;vytvorte program, ktory:
;a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov (minimalne 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;c) porovna  posunuty retazec s  retazcom v druhom  segmente, t.j.
;   zisti, ci su rovnako dlhe a ci su rovnake,
;d) zisti, ci sa v niektorom z retazcov nachadza zadany podretazec.

; Termin odovzdania: 14.11.2000
; 2. rocnik, sk. rok 2000/2001



ZAS SEGMENT STACK	;zasobnik
		  dw 64 dup(?)
ZAS ENDS	

DATA1 SEGMENT	      	;prvy datovy segment
	retazec1  db 32 dup(0)
	sub_ret	  db 22 dup(0)
	msg	  db 13,10,13,10,'Stlac lubovolnu klavesu ...',13,10,'$'
	msg1	  db 13,10,'Zadaj retazec c.1 : ',13,10,'$'
	msg2	  db 13,10,'Zadaj retazec c.2 : ',13,10,'$'	
	msg3	  db 13,10,'Vyber si polozku z MENU :',13,10,'$'
	msg4	  db 13,10,'Retazce su uplne rovnake .',13,10,'$'
	msg5	  db 13,10,'Retazce su rovnako dlhe ale rozne .',13,10,'$'	
	msg6	  db 13,10,'Retazce su roznej dlzky .',13,10,'$'
	msg7	  db 13,10,'Zadaj podretazec ktory chces najst :',13,10,'$'	
	msg8	  db 13,10,'1.retazec neobsahuje hladany podretazec .$'
	msg9	  db 13,10,'2.retazec neobsahuje hladany podretazec .',13,10,'$'
	msg10	  db 13,10,'1.retazec obsahuje hladany podretazec .$'
	msg11	  db 13,10,'2.retazec obsahuje hladany podretazec .',13,10,'$'	
	msg12	  db 13,10,13,10,'Retazec c.1:$'
	msg13	  db 13,10,'Retazec c.2:$'
	nadpis	  db '',13,10,'$'
	menu	  db 13,10,13,10,'MENU :',13,10,'$'	
	menu1	  db 'a) Zadanie novych retazcov ',13,10,'$'
	menu2 	  db 'b) Porovnanie oboch retazcov',13,10,'$'
	menu3 	  db 'c) Vyhladanie podretazca',13,10,'$'
	menu4	  db 'd) Koniec programu',13,10,'$'
DATA1 ENDS

DATA2 SEGMENT		;druhy datovy segment
	retazec2 db 22 dup(255)
DATA2 ENDS

CODE SEGMENT		;segment kodu programu
	assume cs:CODE,ss:ZAS

;		nacitanie stlacenej klavesy

proc STLACENA_KLAVESA	 
	mov ah,01h		;nastavenie sluzby dos-u na nacitanie klavesy
	int 21h			;zavolanie sluzby dos-u
	ret
endp STLACENA_KLAVESA

;	      procedura pre nacitanie retazca

proc NAC_RET
	mov ah,01h		;sluzba dos-u pre nacitanie retazca
	xor cx,cx		;vynulujeme pocitadlo znakov
	cld			;nastavenie direction flagu (+1)
cykl1:  int 21h			;nacitanie retazca z klavesnice
	cmp al,13		;test na stlacenie enteru
	je kon1			;ak bol stlaceny enter ukonci program
	stosb			;ulozenie nacitanej hodnoty
	inc cx			;inkrementovanie pocitadla znakov
	cmp cx,21		;porovnanie ci som nacital 21. znak
	je kon2			;ak ano ukonci cyklus
	jmp cykl1		;nacitaj dalsi znak
kon2:   mov al,13		;pri prekroceni poctu 20 znakov, ulozime stlacenie enteru
kon1:	stosb			;aj stlaceny enter ulozime - sluzi ako zarazka na koniec retazca
	ret			;koniec procedury
endp NAC_RET

;	      procedura pre vypis retazca

proc VYP_RET
	mov ah,02h		;sluzba dos-u pre nacitanie retazca
	cld			;nastavenie direction flagu (+1)
	mov cx,20		;nastavenie maxima
cykln:	lodsb			;nacitanie hodnoty
	dec cx
	cmp al,13		;test na koniec retazca
	je kon
	cmp cx,0		;test na max pocet znakov
	je kon
	mov dl,al
	int 21h			;vypis znaku
	jmp cykln		;nacitaj dalsi znak
kon:	ret			;koniec procedury
endp VYP_RET


;	    procedura pre posunutie retazca

proc POSUN
	mov di,offset retazec1	;pociatocne nastavenie cieloveho indexu
	mov si,offset retazec1  ;pociatocne nastavenie zdrojoveho indexu
	mov al,13		;hladame koniec retazca c.1
	cld			;nastavenie direction flag-u (inkrementujem)
repne	scasb			;ak najdem 13 <return> koncim	
	xor cx,cx		;nulovanie pocitadla
	add cx,di		;nastavenie poctu opakovani
	sub cx,si
	inc cx
	mov si,di		;nastavanie zdrojoveho indexu na vysledok vyhlad.
	add di,10		;posunie cielovy index o hodnotu v prem.pos
	std			;nastavenie direction flag-u (dekrementujem)
rep	movsb			;presun znaky cx-krat
	ret
endp POSUN

;      procedura na vymazanie retazcov

proc VYMAZ
	mov cx,32		;nastavenie pocitadla
	mov di,offset retazec1  ;nastavenie cieloveho indexu
	mov al,0		;do 1.retazca davam nuly
rep	stosb
	push es
	mov ax,seg DATA2	;segment 2.retazca
	mov es,ax
	mov di,offset retazec2  ;nastavenie cieloveho indexu
	mov cx,22		;nastavenie pocitadla
	mov al,255		;do 2.retazca 255
rep	stosb
	pop es			;nacitam spat es
	ret
endp VYMAZ


;      procedura na vymazanie sub - retazca

proc VYMAZ_SUB
	mov cx,22		;nastavenie pocitadla
	push ds
	pop es
	mov di,offset sub_ret   ;nastavenie cieloveho indexu
	mov al,0		;do hladaneho retazca davam nuly
	cld			;nastavenie smeru (+1)
rep	stosb
	ret
endp VYMAZ_SUB

;	procedura pre hladanie vyskytu retazca

proc NAJDI_STRING
	mov cx,20		;nastavenie pocitadla
	cld			;nastavenie direction flagu (+1)
	lodsb			;do al 1.znak podretazca
;	dec si
cykls1:
repne 	scasb			;ked su rozne hladaj dalej
;	dec di
 	cmp cx,0
	je konNOK		;ked sme na konci retazca -> koniec
repe 	cmpsb
	dec di
	dec si
	lodsb			;do al znak
	dec si
	cmp al,13		;ak bol nesuhlasny znak v podretazci <return>
	je konOK		;podretazec sa v retazci nachadza
	dec si			;inac sa pozriem este na predchadzajuci znak
	cmp al,13		;ak bol <return>
	je konOK		;podretazec sa v retazci nachadza
	mov si,offset sub_ret	;znovu nastavim si na zaciatok podretazca
	jmp cykls1		;kontrolujem od dalsej pozicie
konNOK: mov bx,1		;ked som nasiel retazec bx=1
	ret
konOK:  mov bx,0		;ked som nenasiel retazec bx=0
	ret
endp NAJDI_STRING

;	procedura pre porovnanie 2 retazcov

proc POROVNAJ
	mov si,offset retazec1  ;nastavenie zdrojoveho indexu
	add si,10
	mov ax,seg DATA2 	;nastavenie segmentu 2. retazca
	mov es,ax
	mov di,offset retazec2  ;nastavenie cieloveho indexu
	cld			;nstavenie smeru porovnvania (+1)
	mov cx,20		;nastavenie max. poctu porovnani
	xor bx,bx		;vynulujem bx
repe    cmpsb			;kym su rovnake porovnavam
	lodsb			;co je na adrese ds:si dam do al
	dec si
	cmp al,0		;test na koniec prveho retazca
	je b1
pokr1:	push ds si		;ulozim hodnoty ds a si
	mov ax,seg DATA2
	mov ds,ax
	mov si,di
	lodsb			;nacitanie hodnoty adresy ds:si
	pop si ds		;nacitam si a ds naspat
	cmp al,255		;test na koniec druheho retazca
	je b2
pokr2:  cmp bx,3		;test na rovnake retazce
	je dl1
	cmp bx,0		;test ci sa porovnavanie v oboch pripadoch zastavilo niekde v strede
	jne dl3			;inac su retazce roznej dlzky
	mov al,13		;hladam koniec druheho retazca
repne   scasb			;prechadzam az kym nenajdem <enter>
	push di			;hodnotu cieloveho indexu dam do zasobnika
	mov ax,seg DATA1
	mov es,ax		;idem hladat koniec prveho retazca
	mov di,si
	mov al,13
repne	scasb			;prechadzam az kym najdem <enter>
	mov si,di		;do si koniec prveho retazca
	sub si,10		;upravim index podla posunutia
	pop di			;do di koniec druheho retazca
	cmp si,di		;porovnam hodnoty indexov
	je dl2			;ak su rovnake tak hlaska o rovnakej dlzke
dl3:	mov ah,09h		
	mov dx,offset msg6	;hlaska ze retazce su roznej dlzky
	int 21h
	jmp konn		;uknonci porovnanie
b1:	inc bx			;ak som na konci prveho retazca
	jmp pokr1
b2:	add bx,2		;ak som na konci druheho retazca
	jmp pokr2
dl2:	mov ah,09h		;hlaska ze retazce rovnako dlhe ale rozne
	mov dx,offset msg5	
	int 21h
	jmp konn		;ukonci porovnanie
dl1:	mov ah,09h		;retazce su identicke
	mov dx,offset msg4
	int 21h
konn:	mov dx,offset msg	;zaverecna hlaska
	int 21h
	push ds			;ds do es
	pop es
	ret
endp POROVNAJ

;		procedury pre vypis menu

proc HLAVICKA
	mov ah,0		;vymazanie obrazovky (nastavenim text. modu)
	mov al,3
	int 10h
	mov ah,09h		;vypis nadpisu
	mov dx,offset nadpis
	int 21h
	ret
endp HLAVICKA

proc VYPISMENU
zacm:	call HLAVICKA
	mov ah,09h		;Vypis retazcov
	mov dx,offset msg12
	int 21h
	mov si,offset retazec1
	add si,10
	call VYP_RET
	mov ah,09h
	mov dx,offset msg13
	int 21h
	mov si,offset retazec2
	push ds
	mov ax,seg DATA2
	mov ds,ax
	call VYP_RET
	pop ds
	mov ah,09h		;Vypis poloziek menu
	mov dx,offset menu
	int 21h
	mov dx,offset menu1
	int 21h
	mov dx,offset menu2
	int 21h
	mov dx,offset menu3
	int 21h
	mov dx,offset menu4
	int 21h	
	mov ah,09h
	mov dx,offset msg3
	int 21h
	call STLACENA_KLAVESA
	cmp al,'a'		;Overenie vybranej volby
	je nacret
	cmp al,'b'
	je porov
	cmp al,'c'
	je hladaj
	cmp al,'d'
	je koniec2
	jmp zacm
koniec2:mov ax,4c00h		;ukoncenie programu
	int 21h
	ret
nacret:	call VYMAZ		;vyprazdnim oba retazce
	mov ah,09h		;nacitanie retazcov
	mov dx,offset msg1	;hlaska pre prvy retazec
	int 21h
	mov di,offset retazec1	;adresu kam chceme retazec ulozit dame do di
	call NAC_RET 		;nacitam prvy retazec
	mov ah,09h
	mov dx,offset msg2	;hlaska pre druhy retazec
	int 21h
	push es			;ulozim nastavenie sementoveho registru dat
	mov ax,seg DATA2	;nastavim ds na segment 2.datoveho segmentu
	mov es,ax
	mov di,offset retazec2  ;adresu kam chceme retazec ulozit dame do di
	call NAC_RET 		;nacitam druhy retazec
	pop es			;nastavim segment. reg. dat na povodnu hodnotu
	mov ah,09h
	mov dx,offset msg	;hlaska pre stlacenie klavesy
	int 21h
	call POSUN
	call STLACENA_KLAVESA
	jmp zacm		;naspat do menu
porov:  call POROVNAJ		;zavolam proceduru na provnanie retazcov
	call STLACENA_KLAVESA
	jmp zacm		;naspat do menu
hladaj: call VYMAZ_SUB		;vynulujeme hladany retazec
	mov ah,09h  
	mov dx,offset msg7	;hlaska na zadanie hladaneho retazca
	int 21h
	mov di,offset sub_ret
	call NAC_RET		;nacitame hladany retazec
	mov si,offset sub_ret
	mov di,offset retazec1
	add di,10
	call NAJDI_STRING	;hladame v prvom retazci
	mov ah,09h
	cmp bx,0		;test na vyledok procedury
	je vyp1OK
	mov dx,offset msg8	;vypis ze sa podretazec v 1. retazci nenachadza
	int 21h
	jmp druhy
vyp1OK: mov dx,offset msg10	;vypis ze sa podretazec v 1. retazci nachadza
	int 21h
druhy:	push es			;es do zasobnika
	mov ax,seg DATA2
	mov es,ax
	mov si,offset sub_ret
	mov di,offset retazec2
	call NAJDI_STRING	;hladame v druhom retazci
	pop es			;es nastavime na povodnu hodnotu
	mov ah,09h
	cmp bx,0		;test na vyledok procedury
	je vyp2OK
	mov dx,offset msg9	;vypis ze sa podretazec v 2. retazci nenachadza
	int 21h
	jmp tr
vyp2OK: mov dx,offset msg11	;vypis ze sa podretazec v 2. retazci nachadza
	int 21h

tr:	mov ah,09h
	mov dx,offset msg
	int 21h
	call STLACENA_KLAVESA
	jmp zacm		;naspat do menu
koniec:	mov ax,4c00h		;ukoncenie programu
	int 21h
	ret
endp VYPISMENU

;		Hlavny program

start:
        mov ax,seg DATA1
	mov ds,ax		;nastavenie ds na 1.datovy segment	
	mov es,ax		;nastavenie es na 1.datovy segment
	call VYPISMENU		;zobrazenie menu
CODE ends
	end  start



;-----------------------------------------------------------------------------
; Program je funkcny. Bol spracovany pomocou Turbo Assambleru.
; Nezistil som ziadne nedostatky programu. Mal by fungovat pre akykolvek retazec 
; zadanej dlzky cize 20 bytov.
;-----------------------------------------------------------------------------