;Zadanie c.3
;s vyuzitim  retazcovych  instrukcii  (vsade   kde  je  to  mozne) vytvorte program, ktory:
;a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov
;    (minimalne dlzky 20 Byte),
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy,
;c) porovna posunuty retazec s retazcom v druhom  segmente, t.j.
;   zisti, ci su rovnako dlhe a ci su rovnake
;d) zisti, ci  sa  v  niektorom   z  retazcov  nachadza  zadany
;   podretazec.
;
;
;autor:  pavol skocik  
;termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001
;***************************************************************************

zas segment stack
    dw 64 dup(?)
zas ends

data segment
vst1	db 50     ;premenna vstup ma hodnotu 50 (maximalny pocet znakov v 1.retazci)
poc1	db 0
ret1	db 10 dup('$')
ret11	db 50 dup('$')
pom	db 50 dup('$')
vst3	db 50
poc3	db 0
ret3 	db 50 dup(?)
posun   db 0
index   db 0

text0 db 'skuska$'
text1 db 'Prvy retazec: $'
text1a db 'Posunuty prvy retazec: $'
text2 db 'Druhy retazec: $'
text3 db 'Posunutie v retazci bolo realizovane. $'
text4 db 'Podretazec:$'
text5 db 10,13,13,'Porovnanie retazcov. ',10,13
      db 'Vysledok: $'
text6 db 'Retazce nie su rovnako dlhe $'
text7 db 'Nie su rovnake $'
text8 db 'Su rovnake$'
text8a db 'Hladanie podretazca v 1.retazci',10,13
	db 'Vysledok: $'
text9 db 'Je v 1. retazci $'
text10 db 'NIE je v 1.retazci $'

text8aa db 'Hladanie podretazca v 2.retazci',10,13
	db 'Vysledok: $'
text9a db 'Je v 2. retazci $'
text10a db 'NIE je v 2.retazci $'
text11a db 'Podretazec je vacsi ako retazec$'


nr    db 10,13,'$'
nr2   db 10,10,13,'$'
data ends

data2 segment	;druhy datovy segment (tam je druhy retazec)
vst2	db 50
poc2	db 0
ret2	db 50 dup('$')
data2 ends

code segment
     assume cs:code,ss:zas,ds:data,es:data2      ;kazdemu reg.je priradeny jeho segment

start:
	mov ah,00h      ;nastavi textovy mod 80/25 (clear screen)
        mov al,03h
        int 10h	
	mov ax,seg data  ;do ax -> segmentova cast datoveho segmentu - INICIALIZACIA
	mov ds,ax       
	mov ax,seg data		;do ds a es dame seg.adresu data
	mov es,ax

	lea dx,text1
	mov ah,9
	int 21h

	lea dx,vst1
	mov ah,0Ah      ;budeme volat DOS f-ciu 
	int 21h         ;do vstupu sa nacita z klavesnice

	lea dx,nr
	mov ah,9
	int 21h

	xor cx,cx
	mov cl,poc1
	cld
	lea si,ret1	;do si dam adresu ret1(1.retazec)
	lea di,pom	;do di dam adresu ret2(2.retazec)
	rep movsb	;presun retazcov po byteoch do pomocneho retazca a potom na
			;vyssie adresy
	xor cx,cx
	mov cl,poc1
	lea si,pom
	lea di,ret11
	rep movsb	 
			
;	lea dx,text1a
;	mov ah,9
;	int 21h
;
;	lea dx,ret11
;	mov ah,9
;	int 21h
;	lea dx,nr
;	int 21h
;__________________________

	lea dx,text2		;nacitanie druheho retazca
	mov ah,9
	int 21h
	mov ax,seg data2	;do ds dam teraz seg.adr.cieloveho segmentu
	mov ds,ax
	lea dx,vst2
	mov ah,0ah		;sluzba na nacitanie retazca
	int 21h
	mov ax,seg data		;priprava seg.adresy na nacitanie podretazca
	mov ds,ax
	lea dx,nr
	mov ah,9
	int 21h
	lea dx,text4
	mov ah,9
	int 21h
	lea dx,vst3
	mov ah,0ah
	int 21h


;_________________porovnanie retazcov
	mov ax,seg data		;priprava seg.adries do ds a es
	mov ds,ax
	mov ax,seg data2
	mov es,ax
	lea dx,nr2
	mov ah,9
	int 21h	
	lea dx,text5
	mov ah, 9
	int 21h

	mov al,poc1
	cmp al,poc2		;porovnanie dlzky oboch retazcov
	jne r			;ak nie su rovnake nebudu sa porovnavat
	lea si,ret1		;ak su rovnake do di a si sa pripravia ich adresy
	lea di,ret2		;a porovnaju sa
	xor cx,cx
	mov cl,poc1
	rep cmpsb
	jne r2			;ak nie su rovnake vypise sa o tom sprava
	je rovnake		;su rovnake
r:	lea dx,text6
	mov ah,9
	int 21h
	jmp rr
r2:	lea dx,text7
	mov ah,9
	int 21h
	jmp rr
rovnake:
	lea dx,text8
	mov ah,9
	int 21h
rr:

;____________________podretazec
;_prvy ret


	mov ax,seg data
        mov ds,ax       	;ds ukazuje na segment data

        lea dx,nr2
	mov ah,9
	int 21h
	lea dx,text8a           ;text
        mov ah,9
        int 21h
        
        mov al,poc1
        cmp al,poc3
        jb nenachadza1  ;ak je prvy retazec kratsi ako podretazec skoc na dalej

        mov ax,seg data
        mov es,ax       ;es ukazuje na data

        mov index,0     ;vynulovanie indexu
        mov al,poc1     ;priprava na porovnavanie
        mov posun,al
        mov al,poc3
        sub posun,al	;kolkokrat sa bude porovnavat

posun1:
        mov al,index
        cmp al,posun
        ja nenachadza1  ;kontroluje sa od 0 po posun

        cld             ;posuva sa od zaciatku retazca
        mov ch,0
        mov cl,poc3     ;dlzka podretazca
        lea si,ret1  	;adresa na 1.retazec
        lea di,ret3  	;adresa na podretazec
        mov ah,0
        mov al,index
        add si,ax       ;posuvanie prveho prvku ret1 o index
        inc index       ;inex++


        repe cmpsb      ;opakuje porovnavanie stringov po bytoch
        jne posun1      ;ak sa nerovna znak, skoci na navestie
        
        lea dx,text9    ;vypise text 'podretazec za nachadza v 1.retazci'
        mov ah,9
        int 21h
        jmp dalej

nenachadza1:
        lea dx,text10   ;vypise text 'podretazec za nenachadza v 1.retazci'
        mov ah,9
        int 21h
;_ret2
dalej:
        mov ax,seg data
        mov ds,ax       ;ds ukazuje na data
        mov ax,seg data2
        mov es,ax       ;es ukazuje na data2
        
	lea dx,nr2
	mov ah,9
	int 21h
	lea dx,text8aa
	mov ah,9
	int 21h

        mov al,poc2
        cmp al,poc3
        jb nenachadza2  ;ak je podretazec dlhsi ako 2.retazec skoc na dalej2
                    
        mov posun,al
        mov al,poc3
        sub posun,al

        mov index,0     ;vynulovanie indexu
posun2:
        mov al,index
        cmp al,posun
        ja nenachadza2 
                     
        cld          
        xor cx,cx
        mov cl,poc3     ;dlzka podretazca

        lea di,ret2  	;adresa na 2.retazec

        lea si,ret3  	;adresa na podretazec
        mov ah,0
        mov al,index
        add di,ax       ;posuvanie prveho prvku ret1 o index
        inc index       ;inex++
       
        repe cmpsb      ;opakuje porovnavanie stringov po bytoch
        jne posun2      ;ak sa nerovna znak, skoci na navestie
        
        lea dx,text9a    ;vypise text 'podretazec za nachadza v 2.retazci'
        mov ah,9
        int 21h
        jmp dalej2

nenachadza2:
        lea dx,text10a   ;vypise text 'podretazec za nenachadza v 2.retazci'
        mov ah,9
        int 21h
dalej2:


	mov ah,8
	int 21h
koniec:
        mov ax,4c00h    ;funkcia na navrat do DOSu
        int 21h                                                           
code ends
     end start
;ZAVER:
;Program bol editovany v Norton commander Editore, compilovany turbo
;assemblerom v2.02, spajany tlink v3.01, debuggovany pomocou turbo debuggera.
;Program je obmedzeny na vstupe poctom znakov v retazci (max.50) a za koniec retazca povazuje ;znak $. Program po zadani oboch retazcov a podretazca vykona vsetky operacie a vypise vysledky.
;Po stlaceni lubovolnej klavesy sa program ukonci;
