; Zadanie c.1.

; Text zadania:
; Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) a
; podla ponukaneho menu vykona jednu z moznosti:
; a) vypise retazec znakov na obrazovku
; b) vypise pocet cislic v retazci
; c) zisti,ci sa v retazci nachadza pouzivatelom zadany znak a vypise o
;    tom spravu
; d) najde znak s min. hodnotou a vypise tento znak
; e) male pismena konvertuje na velke
; f) zarovna text zprava ( vynecha prve medzery odkonca)
; g) ukonci vykonavanie programu.

;Autor:  Andrej Slamka   os.cislo 99619
;Termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001

zas     segment         stack
	dw              64 dup(?)
zas     ends

data    segment
text0   db              10,13,' Zadaj retazec : $'
text1   db              10,10,13,' Nacitany retazec je : $'
text2   db              10,10,13,' Pocet cislic v retazci je : $'
text31  db              10,10,13,' Zadaj hladany znak : $'
text32  db              10,10,13,' Znak sa v retazci nachadza.$'
text33  db              10,10,13,' Znak sa v retazci nenachadza.$'
text4   db              10,10,13,' Znak s minimalnou hodnotou je : $'
text5   db              10,10,13,' Text po konverzii : $'
text6   db              10,10,13,' Text po zarovnani zprava : $'
polozky db              10,10,13,'        Hlavne menu'
	db              10,10,13,' a) Vypis retazec'
	db              10,13,' b) Zisti pocet cislic v retazci'
	db              10,13,' c) Hladaj znak'
	db              10,13,' d) Hladaj znak s minimalnou hodnotou'
	db              10,13,' e) Konvertuj male pismena na velke'
	db              10,13,' f) Zarovnaj text zlava'
	db              10,13,' g) Koniec'
	db              10,10,13,'      Vyber si polozku : $'
max     db      100
poc     db      0
text    db      100 dup(?)
data    ends

code    segment
	assume DS:data, CS:code, SS:zas
;------------------- zaciatok ------------------------------
start:
	mov ax, 03h
	int 10h              ;zmaz obrazovku
	mov ax, seg data
	mov ds, ax           ;nastav DS
	mov ah, 09h
	mov dx, offset text0
	int 21h               ;vypise text0
	mov ah, 0ah
	mov dx, offset max
	int 21h               ;nacita retazec
	xor bx,bx
	mov bx, offset text
	add bl, poc
	mov byte ptr [bx],'$'
;------------------- hlavne menu ---------------------------
menu:
	mov ax, 03h
	int 10h                  ;zmaze obrazovku
	mov dx, offset polozky
	mov ah, 09h
	int 21h                  ;vypise menu
	xor bx, bx               ;vynuluje bx
	mov ah, 1
	int 21h                  ;nacita znak
	cmp al, 97               ;ak je a tak vypis retaze
	jz poloz1
	cmp al, 98
	jz poloz2               ;ak je b tak vypis pocet cislic
	cmp al, 99               
	jz poloz3_1               ;ak je c tak zisti pritomnost znaku
	cmp al, 100
	jz poloz4_1               ;ak je d tak zisti pritomnost znaku
	cmp al, 101              
	jz poloz5_1               ;ak je e zmeni male na velke
	cmp al, 102              
	jz poloz6_1               ;ak je f tak zarovnaj zprava
	cmp al, 103
	jz koniec               ;ak je g tak skonci
	jmp menu
;------------------- koniec -------------------------------
koniec:
	mov ah, 4ch        ;a koniec programu
	int 21h
;------------------- vypisanie retazca ---------------------
poloz1:
	mov ah, 09h
	mov dx, offset text1
	int 21h            ;vypise text1
	mov ah, 09h
	mov dx, offset text
	int 21h            ;vypise retazec
	mov ah, 08h
	int 21h            ;caka na lubovolny klaves
	jmp menu                ;spat do menu
;------------------- predlzenie skoku  ---------------------
poloz3_1: jmp poloz3
poloz4_1: jmp poloz4
poloz5_1: jmp poloz5
poloz6_1: jmp poloz6
;------------------- zisti pocet cislic --------------------
poloz2:
	mov ah, 09h
	mov dx, offset text2
	int 21h            ;vypise text2
	xor ax,ax       ;vynuluj ax, kvoli zisteniu poctu znakov
pocit:
	cmp bl, poc         ;zisti ci nie je na konci retazca
	jb testuj          ;ak nie je, skoci na testuj
	xor bx, bx              ;vynuluj bx
vypis10:
	cmp ax, 10      ;zisti,ci je cislo mensie ako 10
	jb vypis1       ;ak je skoci na vypis1
	sub ax, 10      ;odcita od cisla 10
	inc bx          ;zvaci bx o 1
	cmp ax, 10      ;zisti ci je ax este stale vacsie ako 10
	jae vypis10     ;ak je vrati sa na vypis10
	add bx, 48      ;ak nie je premeni bx na znak
	mov dl, bl
	mov bx, ax      ;zvysok po docitani ulozime do ax
	mov ah, 02h     ;a vypiseme zvysok ako znak
	int 21h
	mov ax, bx      ;ulozi do ax desiatkovy rad a vypise ho ako znak
vypis1:
	add ax, 48     ;premeni cislo na znak
	mov dl, al
	mov ah, 02h
	int 21h         ;a vypise ho
	mov ah, 08
	int 21h
	jmp menu
testuj:
	cmp text[bx], 47    ;je to menej ako '0'
	jbe dalej               ;ak je skoc dalej
	cmp text[bx], 58        ;je to viac ako '9'
	jae dalej               ;ak je tak skoc dalej
	inc ax                  ;zvacsi pocet
dalej:
	inc bx                  ;posune sa o znak dalej
	jmp pocit               ;skoci na pocit
;------------------- vyhlada urcity znak -------------------
poloz3:
	mov ah, 09h
	mov dx, offset text31
	int 21h            ;vypise text2
	mov ah, 01h
	int 21h         ;nacita do ah nas hladany znak
hladaj:
	cmp bl, poc         ;zisti ci nie je na konci retazca
	jb jetoon          ;ak nie je, skoci na testuj
	mov ah, 09h
	mov dx, offset text33
	int 21h            ;vypise text33
	mov ah, 08h
	int 21h            ;caka na lubovolny klaves
	jmp menu                ;spat do menu
jetoon:
	cmp text[bx], al    ;je to nas znak
	jnz dalej2         ;ak nie je ide na dalsi znak
	mov ah, 09h
	mov dx, offset text32
	int 21h            ;vypise text32
	mov ah, 08h
	int 21h            ;caka na lubovolny klaves
	jmp menu                ;spat do menu
dalej2:
	inc bx                  ;posune sa o znak dalej
	jmp hladaj              ;skoci na pocit
;------------------- hlada znak s minimalnou hodnotou ------
poloz4:
	mov ah, 09h
	mov dx, offset text4
	int 21h            ;vypise text4
	mov bl, 1
	mov dl, text
hladaj2:
	cmp bl, poc         ;zisti ci nie je na konci retazca
	jb jetovac         ;ak nie je, skoci na testuj
	mov ah, 02h
	int 21h                 ;vypise najdeny znak
	mov ah, 08h
	int 21h            ;caka na lubovolny klaves
	jmp menu                ;spat do menu
jetovac:
	cmp text[bx], dl    ;je to mensie alebo rovne
	jae dalej3         ;ak je tak preskoc ulozenie
	mov dl, text[bx]        ;ulozi do al znak s min.hodnotou
dalej3:
	inc bx                  ;posune sa o znak dalej
	jmp hladaj2             ;skoci na pocit
;------------------- konvertuje pismena --------------------
poloz5:
	mov ah, 09h
	mov dx, offset text5
	int 21h            ;vypise text5
	xor bx,bx
convertuj:
	cmp bl, poc
	jb dalej4        ;sme na konci retazca
	mov ah, 09h
	mov dx, offset text
	int 21h          ;vypise konvertovany text
	mov ah, 08h
	int 21h         ;caka na lubovolny klaves
	jmp menu
dalej4:
	mov al, text[bx]
	cmp al, 97
	jb zvacsi
	cmp al, 122
	ja zvacsi       ;zisti, ci je to male pismeno
	sub al, 20h        ;ak je, zmen ho na velke
	mov text[bx], al
zvacsi:
	inc bx
	jmp convertuj           ;skoc spat
;------------------- zarovnanie zlava ----------------------
poloz6:
	mov ah, 09h
	mov dx, offset text6
	int 21h                ;vypise text6
	mov bl, poc           ;nastavi bl na koniec retazca
	dec bl
	xor ax,ax               ;vynuluje ax, pocet medzier od konca
pripoc:
	cmp bl, 0h      ;zisti, ci je na zac.retazca
	ja dalej6       ;ak nie je ide na dalej6
	cmp al, 0       ;ak je pocet medzier od konca, nic nepresuvame a retazec hned vypisujeme
	jz bez_medzery
	mov dx, offset text     ;ak je, tak prehladal uz cely retazec
	mov si, dx              ;do si ulozi adresu retazca
	mov bl, poc             ;bl sa nastavi na prvu nemedzeru od konca
	sub bl, al
	dec bl
	add si, bx		;a si tak isto
spat2:
	cmp bl, 0             ;zisti, ci uz presiel vsetky medzery
	ja dalej5              ;ak ano, tak vypise upraveny retazec 
	lea si, text          ;si nastavime na zac. retazca
	mov dl , [si]         ;potom si do dl odlozime prvy znak	
	push si			;odlozime si do stacku
	add si, ax              ;zvacsime si o pocet medzier
	mov [si], dl		;na mezderu ulozime znak v dl=prvy znak retazca
	pop si			;vytiahneme si zo stacku
	mov byte ptr [si], 32   ;a na prvy znak vlozime medzeru
bez_medzery:
	mov ah, 09h             ;inak zarovnava text dalej
	mov dx, offset text
	int 21h                ;vypise zarovnany retazec
	mov ah, 08h
	int 21h                 ;caka na klavesu
	jmp menu        ;a vrati sa spat do menu
dalej5:
	mov dl, [si]        ;do dl ulozi znak na si
	push si             ;odlozi si
	add si, ax              ;zvacsi o pocet medzier
	mov [si], dl            ;na poziciu medzery vlozi znak
	pop si			;vytiahne si zo stacku
	mov byte ptr [si], 32  ;uloz na poziciu si medzeru
	dec si			;posunie sa znak nizsie
	dec bx			;zmensi pocet medzier, ktoe maju byt presunute o 1
	jmp spat2		;skoci spat na spat2
dalej6:
	cmp text[bx],' '        ;zisti, ci znak je medzera
	jnz spat	 	;ak je tak, posunie sa o jeden znak nizsie
	dec bx 		       ;zvacsi pocet medzier od konca
	inc ax          
	jmp pripoc
spat:
	xor bx,bx       ;ak nie je, tak nastavi bx na 0
	jmp pripoc      ;vrati sa na pripoc
;------------------- koniec ------------------------------
code    ends
	END     start

;Zhodnotenie
; Program takmer funguje. Prvy problem bol s vypisanim poctu
; znakov v retazci. Funguje je to iba ak je pocet cislic max 99. Nevedel som
; vypisat lubovolne velke cislo. Dalej z nepochopitelnych dovodov pri retazci 
; dlhsom ako 8 znakov robi hluposti. Ine problemy myslim, ze nie su.
; Program ma len obmedzenie na maximalny pocet znakov v retazci a to 100.
