;Zadanie c.1
;Text zadania:
;Napste program, ktory nacta z klvesnice retazec znakov (max.100 znakov) a podla
;ponkanho menu vykon  jednu z moznost:
;a) vypse retazec znakov na obrazovku
;b) vypse pocet cslic v retazci
;c) zist,ci sa v retazci nachdza pouzvatelom zadany znak a vypse o tom sprvu
;d) njde znak s min. hodnotou a vypse tento znak
;e) mal psmen konvertuje na velk
;f) zarovn text zprava ( vynech prv medzery odkonca)
;g) ukonc vykonvanie programu.
;Po vykonan zvolenej moznosti sa program vrti na vypis menu.
;Autor: Michal Slamka
;Termin odovzdania: 24.10.2000
;2.roc., sk. rok 2000/2001
;-----------------------------------------------------------------------
JUMPS
;-----------------------------------------------------------------------
ZAS     SEGMENT STACK 'STACK'		  ;zaciatok zasobnikoveho segmentu
        DW      64 DUP(?)                 ;definicia 64-och slov 
ZAS     ENDS				  ;koniec zasobnikoveho segmentu	
;-----------------------------------------------------------------------
DATA    SEGMENT				  ;zaciatok datoveho segmentu
RETAZEC DB      'NAPIS RETAZEC:',13,10,'$'              ;definicia pre vypis
MENU    DB      13,10,'1: VYPIS RETAZEC',13,10		;definicia vypisu menu
        DB      '2: VYPIS POCET CISLIC V RETAZCI',13,10
        DB      '3: ZISTI HLADANY ZNAK',13,10
        DB      '4: NAJDI ZNAK S MINIMALNOU HODNOTOU',13,10
        DB      '5: KONVERTUJ MALE PISMENA NA VELKE',13,10
        DB      '6: ZAROVNAJ TEXT ZPRAVA',13,10
        DB      '7: UKONCI PROGRAM',13,10
        DB      'STLAC ZVOLENE CISLO:$'
VETA2   DB      13,10,'POCET CISLIC V RETAZCI JE:$'	;definicia dalsich vypisov
VETA3	DB	13,10,'ZADAJ ZVOLENY ZNAK:$'
VETA31	DB	13,10,'NASOBNOST ZVOLENEHO ZNAKU JE V DANOM RETAZCI:$'
VETA4   DB      13,10,'ZNAK S NAJMENSOU HODNOTOU JE:$'   
NR      DB      0DH, 0AH				;definicia noveho riadku
VSTUP   DB      100					;definicia retazca
POCET   DB      0					;pocet znakov tohto retazca
        DB      100 DUP (?)
VYSTUP  DB      103 DUP (?)				;vystup retazca+(13,10,'$')
DATA    ENDS						;koniec datoveho segmentu
;--------------------------------------------------------------------------
CODE    SEGMENT						;zaciatok kodoveho segmentu
        ASSUME  DS:DATA, SS:ZAS, CS: CODE		;aktivne segmenty
START:  MOV     AX, SEG DATA				;do AX vloz seg. cast adresy
        MOV     DS, AX					;seg. cast adresy presun do DS
        MOV     DX, OFFSET RETAZEC			;do DX vloz posunutie retazca v dat.seg.
        MOV     AH, 09H					;funkcia vypis retazca
        INT     21H					;sluzba DOSu

        MOV     DX, OFFSET VSTUP			;do DX vloz posunutie VSTUPu v dat.seg.
        MOV     AH, 0AH					;funkcia vstup s vyrovnavacou pamatou
        INT     21H					;sluzba DOSu
;-----------------------------------------------------------------------
ROB:    MOV     DX, OFFSET MENU				;do DX vloz posunutie MENU v dat.seg.
        MOV     AH, 09H					;funkcia vypis MENU	
        INT     21H					;sluzba DOSu

        MOV     AH, 01H					;ziadost o vstup znaku z klavesnice
        INT     21H					;prerusenie-sluzba DOSu
        CMP     AL, 31H					;porovnaj nac. znak s cislom 1 
        JE      UL1					;ak sa rovna, skoc na navestie UL1 
        CMP     AL, 32H                                 ;porovnaj nac. znak s cislom 2
        JE      UL2                                     ;ak sa rovna, skoc na ul2
        CMP     AL, 33H					;porovnaj nac. znak s cislom 3	
        JE      UL3					;ak sa rovna, skok na ul3
        CMP     AL, 34H                                 ;porovnaj  nac. znak scislom 4
        JE      UL4                                     ;skok na ulohu 4
        CMP     AL, 35H                                 ;porovnava s cislom 5
        JE      UL5                                     ;skok na ulohu 5
        CMP     AL, 36H                               	;porovnava s cislom 6
        JE      UL6                                     ;skok na ul6
        CMP     AL, 37H                                 ;porovnava s cislom 7
        JE      KONIEC                                  ;skok na koniec
        JMP     ROB                                     ;ak je stlaceny iny znak, vypis znova MENU
;-------------------------------------------------------------------------
UL1: 	MOV	DX, OFFSET VSTUP		;do DX vloz posunutie MENU v dat.seg.
	ADD	DX, 2				;pripocitaj k DX 2	
	MOV	SI, DX				;do SI daj hodnotu DX 
	MOV	BX, OFFSET VYSTUP	 	;do BX vloz posunutie VYSTUPU
	MOV     CL, POCET			;do CL presun	POCET
OPAK1:  MOV     AL, [SI]		       	;do AL dam prvy znak
        MOV     [BX], AL			
        INC     SI				;inkrementuj(zvacsi o 1)SI
        INC     BX				;inkrementuj BX
        LOOPNE  OPAK1                           ;opakuj cyklus 
ZOBRAZ1:MOV     byte ptr [BX], 0AH              ;novy
        MOV     byte ptr [BX+1], 0DH            ;riadok
        MOV     byte ptr [BX+2], '$'		; a ukoncenie retazca
        MOV     DX, OFFSET NR                   ;vlozenie cisteho riadku
        MOV     AH, 09H                         ;sluzba DOSu
        INT     21H                             ;skok do menu
        JMP     ROB				;skok na zaciatok MENU
;--------------------------------------------------------------------------
UL2:	XOR	SI, SI				;nulovanie SI	
        XOR     CX, CX                          ;vynuluj register CX
        XOR     BX, BX				;nulovanie BX
        MOV     CL, POCET                       ;do  CL presun POCET
OPAK2:  MOV     AL, [VSTUP+2+SI]                ;nacitaj prvy znak
        CMP     AL, 30H                         ;porovna nac. znak s dec. 0
        JB      ZNAK                            ;ak je mensie, skok na ZNAK
        CMP     AL, 39H                         ;porovna nac. znak s dec. 9
        JA      ZNAK                            ;ak je vacsie, skok na ZNAK
        INC     BX                              ;BX zvacsi o jednu
ZNAK:   INC     SI                              ;inkrementuj register SI
        LOOP    OPAK2                           ;prejdi cely retazec
ZOBRAZ2:MOV     DX, OFFSET VETA2                ;do DX vloz posunutie VETY2 v dat.seg.
        MOV     AH, 09H                         ;vypis danej vety na obrazovku
        INT     21H                             ;sluzba DOSu
        MOV     AX, BX                          ;do registra AX daj BX
        MOV	BL, 10H				;do BL daj 10
        DIV	BL				;vydel 10-timi
        MOV	DX, AX				;do DX daj hodnotu v AX
        ADD     DL, 30H                         ;0 je 30H, teda 1 je 31H ...
        MOV     AH, 02H                         ;vypis jedneho znaku
        INT     21H                             ;sluzba DOSu
        MOV	DL, DH				;hodnotu v DH daj do DL
        ADD	DL, 30H				;desiatkova uprava
        INT	21H				;sluzba DOSu
        JMP     ROB                             ;skok do MENU
;-------------------------------------------------------------------------        
UL3:    MOV     DX, OFFSET VETA3                ;do DX vloz posunutie VETY3 v dat.seg.
        MOV     AH, 09H                         ;vypis zadefinovanej vety
        INT     21H                             ;sluzba DOSu
	MOV     AH, 01H				;ziadost o vstup znaku z klavesnice
        INT     21H				;prerusenie-sluzba DOSu
        MOV     CL, POCET                       ;do CL presun adresu POCET    
        XOR	SI, SI				;nulovanie SI
        XOR	BX, BX				;BX
OPAK3:  MOV     AH, [VSTUP+SI+2]                ;do AH daj prvy znak
        CMP     AL, AH                          ;ak AL sa nerovna AH, skok 
        JNE     DALEJ3                          
        INC	BX				;ak sa rovnaju, BX+1	
DALEJ3: INC     SI                              ;inkrementuj SI
        LOOPNE  OPAK3                           ;prejdi cely retazec
ZOBRAZ3:MOV	DX, OFFSET VETA31		;do DX vloz posunutie VETY4
	MOV	AH, 09H				;vypis vety
	INT	21H        			;sluzba DOSu
        MOV     AX, BX				;do AX daj hodnotu v BX
        MOV	BL, 10H				;do BL daj 10
        DIV	BL				;del 10-timi
        MOV	DX, AX				;do DX daj hodnotu v AX
        ADD     DL, 30H                         ;0 je 30H, teda 1 je 31H ...
        MOV     AH, 02H                         ;vypis jedneho znaku
        INT     21H                             ;sluzba DOSu
        MOV	DL, DH				;do DL daj hodnotu v DH
        ADD	DL, 30H				;desiatkova uprava
        INT	21H				;sluzba DOSu
        JMP     ROB                             ;skok do MENU
;--------------------------------------------------------------------------        
UL4:    XOR	SI, SI				;nulovanie SI
	XOR	AX, AX				;nulovanie AX
	XOR	BX, BX				;nulovanie BX
	MOV     CL, POCET                       ;do CL presun adresu POCET
	DEC	CL				;dekrementovanie CL(porovnavani je o 1 menej)
        MOV     BL, [VSTUP+SI+2]                ;do BL daj prvy znak retazca
OPAK4:  MOV     AL, [VSTUP+SI+3]                ;do AL daj druhy znak retazca
	CMP     BL, AL                          ;porovnaj BL, AL
        JB      DALEJ4                          ;ak AL je mensie, skok 
        MOV     BL, AL                          ;ak BL je vacsie, do BL daj AL
DALEJ4: INC     SI                              ;inkrementuj SI
        LOOP    OPAK4                           ;prejdi cely retazec
ZOBRAZ4:MOV     DX, OFFSET VETA4                ;do DX vloz posunutie VETY4 v dat.seg.
        MOV     AH, 09H                         ;vypis zadefinovanej vety
        INT     21H                             ;sluzba DOSu
	MOV	DL, BL				;do DL daj hodnotu v BL
        MOV     AH, 02H                         ;vypis znaku
        INT     21H                             ;sluzba DOSu
        JMP     ROB                             ;skok do MENU
;--------------------------------------------------------------------------
UL5:    MOV     DX, OFFSET VSTUP                ;do DX vloz posunutie VSTUPu v dat.seg.
        ADD     DX, 2                           ;DX zvacsi o 2
        MOV     SI, DX                          ;do SI presun DX
        MOV     BX, OFFSET VYSTUP               ;do DX vloz posunutie VSTUPu v dat.seg.
        XOR     AX, AX                          ;nulovanie AX
        XOR     CX, CX                          ;nulovanie CX
        MOV     CL, POCET                       ;do CL presun pocet znakov
OPAK5:  MOV     AL, [SI]                        ;nacitavam prvy znak
        CMP     AL, 60H                         ;porovnam nac. znak so znakom pred 'a'
        JBE     DALEJ5                          ;skok - netreba konvertovat
        CMP     AL, 7BH                         ;porovnavam nac. znak so znakom za 'z'
        JNB     DALEJ5                          ;skok - netreba konvertovat
        SUB     AL, 20H                         ;male pismeno konvertuj na velke(odpocitaj 20h)
DALEJ5: MOV     [BX], AL                        
        INC     SI                              ;inkrementuj SI
        INC     BX                              ;inkrementuj (zvacsi o 1) BX 
        LOOPNE  OPAK5                           ;prejdi cely retazec
ZOBRAZ5:MOV     byte ptr [BX], 0AH              ;novy 
        MOV     byte ptr [BX+1], 0DH            ;riadok
        MOV     byte ptr [BX+2], '$'		;a jeho ukoncenie
        MOV     DX, OFFSET NR                   ;do DX vloz posunutie noveho riadku v dat.seg.
        MOV     AH, 09H                         ;vypis cisteho riadku
        INT     21H                             ;sluzba DOSu
        JMP     ROB                             ;skok do MENU
;-------------------------------------------------------------------------
UL6:	XOR	CX, CX				;nulovanie CX
	XOR	DX, DX				;nulovanie DX
	MOV	CL, 80				;do CL daj max. dlzku riadku
	SUB	CL, POCET			;odpocitaj dlzku retazca
	MOV	BX, OFFSET VYSTUP		;do BX daj posunutie VYSTUPu
OPAK6:	MOV	DL, ' '				;do DL daj ' '
	MOV	[BX], DL			;postupne posuvanie retazca
	DEC	CL				;zmensovanie CL
	INC 	BX				;zvacsovanie BX
	JNZ	OPAK6				;opakuj kym CL <> 0
	XOR	CX, CX				;nulovanie CX
	MOV	CL, POCET			;daj do CL dlzku retazca
DALEJ6: MOV	AL, [VSTUP+SI+2]		;do AL daj prvy znak retazca
	MOV	[BX], AL			
	INC	BX				;zvacsovanie BX
	INC 	SI				;zvacsovanie SI(pohyb v retazci)
	LOOP	DALEJ6				;prejdi cely retazec
ZOBRAZ6:MOV     byte ptr [BX], 0AH              ;novy 
        MOV     byte ptr [BX+1], 0DH            ;riadok
        MOV     byte ptr [BX+2], '$'		;a jeho ukoncenie
        MOV     DX, OFFSET NR                   ;do DX vloz posunutie noveho riadku v dat.seg.
        MOV     AH, 09H                         ;vypis cisteho riadku
        INT     21H                             ;sluzba DOSu
        MOV     DX, OFFSET VSTUP
        MOV     ah, 09h
        int     21h
        JMP     ROB                             ;skok do MENU
;-------------------------------------------------------------------------
KONIEC: MOV     AX, 4C00H		;ukoncenie programu a navrat do DOSu
        INT     21H
;-------------------------------------------------------------------------
CODE    ENDS        			;koniec kodoveho segmentu
        END     START			
        

;ZHODNOTENIE:
;1:povodny retazec vypisuje; problem: je posunuty
;2:pocet cislic vypisuje
;3:nasobnost zvoleneho znaku vypisuje
;4:vypis znaku s najmensou hodnotou bezi
;5:konvertovany retazec vypisuje; problem: je posunuty 
;6:nebezi, nastava chyba - overflow
;7:ukoncenie programu bezi

