;zadanie c.3
;1. nacita dva  retazce do  dvoch roznych segmentov
;2. prvy retazec presunie v segmente o 10 bytes na vyssie adresy,
;3. porovna posunuty retazec s  retazcom v druhom  segmente, t.j.
;       zisti, ci su rovnako dlhe a ci su rovnake
;4. zisti, ci sa v niektorom z retazcov nachadza zadany podretazec
;Autor : Miroslav Tysler
;Kruzok: B13
;Odovzdane: 5.12.2000

sta segment stack 'stack'	;definovanie zasobnika
    db 64 dup(?)		;velkost
sta ends			

dat1 segment
menutxt        db '1. Nacitanie retazcov',0ah,0dh
            db '2. Posun 1. retazca o 10 bajtov vyssie',0ah,0dh
	    db '3. Porovnaj retazce',0ah,0dh
	    db '4. Hladaj podretazec',0ah,0dh 	
            db '5. Koniec',0ah,0dh
            db '$'
ret1        db 'Zadaj 1. retazec:$'
ret2        db 'Zadaj 2. retazec:$'
ret3	    db 'Zadaj hladany podretazec:$'	
vret1	    db '1. retazec:$'
vret2	    db '2. retazec:$'
cmpinf1	    db 'retazce su zhodne$'
cmpinf2     db 'retazce nie su rovnake, su rovnako dlhe$'
cmpinf3	    db 'su rozne a 1. je dlhsi ako 2.$'
cmpinf4	    db 'su rozne a 1. je kratsi ako 2.$'
scaninf1    db 'v 1. sa nachadza$'
scaninf2    db 'v 2. sa nachadza$'
scaninf3    db 'v 1. sa nenachadza $'
scaninf4    db 'v 2. sa nenachadza $'	
kop         db 'Prekopirovane !$'
offst	    equ 12
vstup1      db 50			;prvy retazec,maximalny pocet znakov	
pocet1      db ?		
            db 50 dup (?)		;priestor pre nacitane slabiky
podret	    db 50 			;poderetazec,maximalny pocet znakov
pocet3	    db ?			;skutocny pocet znakov
	    db 50 dup (?) 		;priestor pre nacitane znaky
nr          db 0ah,0dh,'$'		;novy riadok
dat1 ends

dat2 segment
vstup2      db 50			;vstup2,maximalny pocet znakov 
pocet2      db ?			;skutocny pocet znakov
            db 50 dup (?)		;priestor pre slabiky
dat2 ends

code segment
assume ss:sta,cs:code,ds:dat1,es:dat2

wrtxt macro text,dseg			;vypise text
      push ax
      push ds
      mov ax,seg dseg			;dany segment->ax
      mov ds,ax				;ax->ds	
      lea dx,text			;nacitanie offsetu textu do dx 
      mov ah,09h
      int 21h
      pop ds
      pop ax
endm

loadstr proc				;procedura na nacitanie retazcov	
        wrtxt ret1,dat1
        lea dx,vstup1			;nacitanie 1. retazca v 1.segmente
        mov ah,0ah			;sluzba na nacitanie retazca
        int 21h
	wrtxt nr,dat1			;novy riadok
        wrtxt ret2,dat1
        push ds
        mov ax,seg dat2			;ax<-segment dat1
        mov ds,ax			;ds<-ax
        lea dx,vstup2			;efiktivna adresa->dx
        mov ah,0ah			
        int 21h
        pop ds
	ret
loadstr endp

copyret proc			;procedura na nakopirovanie 1.retazca na vyssie adresy (o 10 bytes)
	xor cx,cx		;vynulovanie registrov	
	xor si,si
	xor di,di
	cld
	lea si,vstup1		;si<-efektivna adresa 
	add si,2		;si=si+2, pretoze znaky su az od 3. bytu 	
	push es
	mov ax,seg dat1		
	mov es,ax		;nakopirujeme ds->es pre instrukciu movsb
	lea di,vstup1		;di<-efektivna adresa
	add di,offst		;di=di+offst,pre posun o 10 bytov=offst
	mov cl,pocet1		;cl<-pocet1
	add di,cx 		;aby sa retazec nenakopiroval do seba 
	rep movsb		;kopirujeme pokial cx<>0
	pop es			;zasobnika->es,vsetko vratime do povodneho stavu
	wrtxt kop,dat1	
	ret
copyret endp

compstr proc			;procedura na porovnavanie retazcov 
	xor cx,cx		;vynulovanie pouzivanych retazcov
	xor si,si		
	xor di,di
	cld			;direction flag=0
	lea si,vstup1
	add si,offst		;si=si+offst
        lea di,vstup1
        add di,2		;di=di+2
	mov cl,pocet1
	add si,cx
	cmp pocet2,cl           ;porovname pocet1 a pocet2
	ja @31			;ak ano skok na @31
	je @32			;ak pocet1=pocet2 skusime ci su rovnake retazce
	wrtxt cmpinf3,dat1
	ret
@31:	wrtxt cmpinf4,dat1
	ret
@32:	repe cmpsb		;opakuje pokial je Z=1
	jne @33			;skok na navestie @nezh	
	wrtxt cmpinf1,dat1
	ret
@33:	wrtxt cmpinf2,dat1
	ret
compstr endp

search 	proc		;procedura na hladanie  podretazca v retazcoch
	xor cx,cx	;vynulovanie pouzivanych registrov
	xor si,si
	xor di,di
	wrtxt ret3,dat1
	lea dx,podret
	mov ah,0ah
	int 21h
	wrtxt nr,dat1
	push es
	mov ax,ds
	mov es,ax
	lea di,vstup1           

;	add di,offst		;di=di+offst,budeme prehladavat posunuty retazec
	add di,2 ;!

	lea si,podret
	add si,2		;si <- offset hladaneho podretazca
	mov cl,pocet1		;v cl <-pocet bajtov prehladavaneho retazca
;	add di,cx		;di=di+cx,lebo prehladavame posunuty retazec
	cmp pocet3,cl		;porovname ci pocet3>pocet1
	ja @nena1		;ak ano tak skok na @nena1 (nie je tam podretazec)
	sub cl,pocet3		;inak odcitame od cx=pocet1-pocet3
	inc cl
	cld
@loop1: push cx			;prehladavanie 1.retazca
	mov cl,pocet3
;	push di
	repe cmpsb
;	pop di	
;	inc di
	pop cx
	je @na1			;ak nasiel zhodu tak skoci na navestie @na1	
	lea si,podret		;si <- offset podret
	add si,2
	loop @loop1
	wrtxt scaninf3,dat1	;vypise,ze sa v 1.retazci nenachadza	
	wrtxt nr,dat1
	pop es
	jmp @42			;skok na @42,nebudeme dalej prehladavat 1. retazec
@na1:	wrtxt scaninf1,dat1	;podretazec sa nachadza 1. retazci	
	wrtxt nr,dat1	
	pop es					
	jmp @42			;neprehladavam dalej 1.retazec
@nena1:	wrtxt scaninf3,dat1	;podretazec sa nenachadza v 1. retazci	
	wrtxt nr,dat1
	pop es
@42:	
	xor cx,cx
	lea di,vstup2
	add di,2
	lea si,podret
	add si,2
	mov cl,pocet2
	cmp pocet3,cl		;porovname ci pocet3>pocet2
	ja @nena2		;ak ano skoc na @nena2	
	sub cl,pocet3		;cl=pocet2-pocet3	
	inc cl
	cld
@loop2: push cx			;prehladavanie 2. retazca
	mov cl,pocet3			
	repe cmpsb 
	pop cx
	je @na2
	lea si,podret
	add si,2
	loop @loop2
	wrtxt scaninf4,dat1
	ret
@na2:	wrtxt scaninf2,dat1
	ret
@nena2:	wrtxt scaninf4,dat1
	ret			
search	endp

start:
      mov ax,seg dat1
      mov ds,ax			;do segmentoveho registra ds<-dat1
      mov ax,seg dat2		
      mov es,ax			;es<-dat2 
@menu:
      wrtxt menutxt,dat1	;vypise text menu
      mov ah,01h		;nacitanie znaku
      int 21h
      wrtxt nr,dat1		;novy riadok
      cmp al,'1'
      je @1
      cmp al,'2'
      je @2
      cmp al,'3'
      je @3
      cmp al,'4'
      je @4
      cmp al,'5'
      jne @menu
      mov ax,4c00h		;korektne ukonci vykonavanie programu
      int 21h

@1:   call loadstr	;nacitanie retazcov	
      wrtxt nr,dat1
      jmp @menu

@2:   call copyret	;kopirovanie retazca
      wrtxt nr,dat1
      jmp @menu

@3:   call compstr	;porovnavanie retazcov
      wrtxt nr,dat1	
      jmp @menu

@4:   call search	;vyhladavanie podretazca v retazci
      wrtxt nr,dat1
      jmp @menu

code ends
     end start

;zhodnotenie:
;v programe su pouzite retazove instrukcie: cmpsb,movsb
;su tu pouzite standardne sluzby DOSu
