;Zadanie c.1.
;Uloha: Napiste program, ktory nacita z klavesnice retazec znakov
;        (max.100 znakov) a podla  menu vykona  jednu z moznosti:
;       1) vypise retazec znakov na obrazovku
;       2) vypise poradove miesto uzivatelom zadaneho znaku 
;       3) najde znak s min hodnotou
;       4) vypise pocet cislic v retazci
;       5) male pismena konvertuje na velke
;       6) zarovna text zprava 
;       7) ukonci vykonavanie programu.
;       Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;
;Autor: Miroslav Tysler
;rocnik: 2.
;sk.rok 2000/2001
;
data     segment
Menu     db      13,10,'MENU:',13,10
         db      '1 - Vypis retazca na obrazovku',13,10
         db      '2 - Najdi znak v retazci',13,10
         db	 '3 - Najdi znak s min hodnotou',13,10
         db      '4 - Zistenie poctu cislic v retazci',13,10
	 db 	 '5 - Konvertovanie malych pismen na velke',13,10
	 db 	 '6 - Zarovnanie textu z prava',13,10 	
         db      '7 - Koniec',13,10,'$'

Retazec  db      101                                 ;maximalny pocet znakov 
pocet    db      ?                                   ;pocet nacitanych znakov
R        db      103 dup (?)                         ;dane znaky (3 znaky na novy riadok a '$')
Rvelke   db      103 dup (?)                         ;pom pole znakov pouzivane pri bode '5'
ENT       db      13,10                             ;novy riadok
Koniec   db      '$'                                 ;koniec vypisovania na obrazovku
Buffer   db      3 dup (?),13,10,'$'                 ;pre vypis cisiel
Vypis    db      13,10,'Zadany retazec je:',13,10,'$'
Cisl     db      13,10,'Pocet cislic v retazci je: $'
PorCis   db      13,10,'znak sa nachadza na poradovom mieste: $'
Upper    db      13,10,'Konvertovany retazec ma tvar:',13,10,'$'
vypis_m  db	 13,10,'Znak s minimalnou hodnotou je: $'
Vyzva    db      'Zadaj retazec:',13,10,'$'
Znak     db      13,10,'Zadaj hladany znak: ',13,10,'$'
Chyba    db      13,10,'V retazci sa dany znak nenachadza',13,10,'$'
Chyba2   db      13,10,'treba zadat cislo od 1 do 7',13,10,'$'
data     ends

code     segment
start:   assume      ds:data,cs:code,es:data

         mov         ax,seg data        ;inicializacia registra DS
         mov         ds,ax
         mov         dx,offset Vyzva    ;vypise Vyzvu
         mov         ah,09h
         int         21h
         mov         dx,offset Retazec  ;nacita dany retazec (max 100 znakov) a
         mov         ah,0Ah             ;do premennej pocet vrati pocet nacitanych znakov
         int         21h
@menu:   mov         dx,offset Menu     ;vypise menu na obrazovku
         mov         ah,09h
         int         21h


	mov         ah,01h             ;nacita znak do registra al
         int         21h

         cmp         al,'1'             ;Zisti, ci nacitany znak v registri al je 'A' alebo 'a'.
         jz          @vypis
	 jnz	     @1
@vypis:  
         xor         cx,cx		;pridame enter a ukoncovaci znak
         xor         si,si
         mov         cl,pocet
         mov         si,cx
         mov         [R+si],13
         inc         si
         mov         [R+si],10
         inc         si
         mov         dl,koniec
         mov         [R+si],dl
         mov         dx,offset Vypis    ;vypise 'Dany retazec je'
         mov         ah,09h
         int         21h
         mov         dx,offset R        ;vypise dany retazec
         mov         ah,09h
         int         21h
         jmp         @menu              ;vrati sa do menu


@1:      cmp         al,'2'             ;zisti, ci bola stlacena '2'
         jz          @znak
	 jnz	     @2
@znak:   mov         dx,offset Znak     ;vypise 'zadaj znak'
         mov         ah,09h
         int         21h
         mov         ah,01h             ;nacita znak do reg al
         int         21h
         xor         si,si              ;zisti poradove cislo daneho znaku
         dec         si
         xor         cx,cx
         mov         cl,pocet
@sl1:    inc         si             ;cyklus pre prehladavanie retazca
         cmp         [R+si],al
         jnz         @loop
         jmp         @sk2
@loop:   loop        @sl1
         jmp         @Chyba
@sk2:    mov         ax,si          ;ak sa znak nachadza vypise poradove cislo
         inc         ax		;prevod poradoveho cisla z reg ax do bufferu
         mov         si,3
@sl2:    dec         si             
         mov         bx,10
         xor         dx,dx
         div         bx
         mov         di,dx
	 add 	     dl,30h
         mov         [buffer+si],dl
         and         ax,ax
         jnz         @sl2
         mov dx,offset PorCis		;vypis PorCis
         mov ah,09h
         int 21h
         mov dx,offset buffer		;vypise na ktorom mieste sa nachadza
         mov ah,09h
         int 21h
         jmp         @menu           ;navrat do menu
@Chyba:  mov         dx,offset Chyba	;vypise chybu
         mov         ah,09h
         int         21h
         jmp         @menu           ;navrat do menu


@2:      cmp         al,'3'             ;zisti ci bol straceny kl. '3'
         jz          @minim
	 jnz	     @3
@minim:  mov         dx,offset vypis_m ;vypise 'znak s minimalnou hodnotou je'
         mov         ah,09h
         int         21h
	 xor         cx,cx   
	 xor 	     ax,ax	        
         mov 	     cl,pocet
         mov         bx,offset R
	 mov         dl,[bx]
         dec         cl    	          
@sl3:		              		;prehladavanie
         cmp         dl,[bx]
         jb	     @jmin
         mov         dl,[bx] 
@jmin:   inc         bx
         loopne      @sl3
         mov         ah,02h
         int         21h
         jmp         @menu


@3:      cmp         al,'4'             ;Zisti, ci nacitany znak v registri al je '4'
         jz          @cislic
	 jnz	     @4
@cislic: xor         cx,cx             ;zisti pocet cislic v retazci
         mov         cl,pocet          ;nastavanie parametrov pre slucku
         xor         si,si
         dec         si
         xor         bx,bx
@sl4:    inc         si                ;samotna slucka ktora to zistuje
         cmp         [R+si],30h
         jb          @loop2
         cmp         [R+si],39h
         ja          @loop2
         inc         bx                ;pocet cislic ide do registra bx
@loop2:  loop        @sl4
         mov         dx,offset Cisl    ;vypise 'Pocet cislic v retazci je:'
         mov         ah,09h
         int         21h
         mov         ax,bx
         mov         si,3
@sl6:    dec         si             ;prevod cisla z reg ax do bufferu
         mov         bx,10
         xor         dx,dx
         div         bx
         mov         di,dx
	 add	     dl,30h
         mov         [buffer+si],dl
         and         ax,ax
         jnz         @sl6
         mov         dx,offset Buffer   ;vypise pocet cisiel v retazci z premennej buffer
         mov         ah,09h
         int         21h
         jmp         @menu              ;spat do menu


@4:      cmp         al,'5'             ;Zisti ci bola stlacena '5'
         jz          @upcase
	 jnz	     @5
@upcase: 
	MOV AX,SEG DATA
	MOV DS,AX
	MOV DX,OFFSET R			;DX->RETAZ
	MOV SI,DX
	MOV BX,OFFSET Rvelke		;BX->UPCS
	XOR AX,AX
	XOR CX,CX	
	MOV CL,POCET			;pocet opakovani = dlzka retazca
 loop4:	
	MOV AL,[SI]
	CMP AL,60H
	JBE DAL8			;ak al<=60H goto DAL8
	CMP AL,7BH
	JNB DAL8			;ak al>7BF goto DAL8
	SUB AL,20H			;odcita 20H (konvert male na VELKE)
 dal8:
	MOV [BX],AL	
	INC SI				;zvacsime index RETAZca
	INC BX
	LOOPNE loop4
	MOV byte ptr[BX],'$'
	MOV DX,OFFSET Rvelke
	MOV AH,09H
	INT 21H
	MOV DX,OFFSET ENT
	MOV AH,09H
	INT 21H
        jmp         @menu           ;vrati sa do menu


@5:      cmp         al,'6'             ;Zisti, ci nacitany znak v registri al je 'F' alebo 'f'
         jz          @zarov
  	 jnz	     @6



@zarov: 
	mov dx,offset ENT		;vypis ENT
	mov ah,09H
	int 21H
	cmp pocet,80
	ja @nad80			;ak je pocet znakov > 80 goto nad80
	xor cx,cx	;toto sa vykona ak je retazec kratsi ako 80 znakov
	xor ax,ax
	mov al,80
	sub al,pocet
	mov cx,ax			;cx=ax=pocet-80
@za1:					;vypiseme patricny pocet medzier
	mov dl,' '
	mov ah,2
	int 21h
	loopne @za1
	xor cx,cx
	mov cl,pocet			;nastavime pocet opakovani pre cyklus
	mov bx,2			;nastavime offset retazca
@za2:					;vypiseme retazec
	mov dx,offset [Retazec+bx]	;vypiseme znak
	mov ah,02H
	int 21H
	inc bx				;zvacsime offset
	loopne @za2
        jmp         @menu           ;vrati sa do menu

@nad80:
	mov cl,80
	mov bx,2
@za3:					;vypiseme cely prvy riadok
	mov dx,offset [Retazec+bx]
	mov ah,02H
	int 21H
	inc bx
	loopne @za3

	xor cx,cx                       ;zistime polko medzier treba vytpacit v 2. riadku
	xor ax,ax
	mov al,160
	sub al,pocet			
	mov cx,ax			;cx=ax=160-pocet
@za4:					;tlacime medzery
	mov dl,' '
	mov ah,2
	int 21h
	loopne @za4

	xor ax,ax
	mov al,pocet
	sub al,80
	mov cx,ax			;cx=ax=pocet-80
@za5:					;vytlacime zvysok retazca
	mov dx,offset [Retazec+bx]
	mov ah,02H
	int 21H
	inc bx
	loopne @za5
	
	jmp @menu

@6:      cmp         al,'7'             ;Zisti, ci nacitany znak v al je '7'
         jz          @koniec
	 mov         dx,offset Chyba2
         mov         ah,09h
         int         21h
         jmp         @menu              ;skok na zaciatok

@koniec: mov         ax,4c00h        ;ukoncenie programu
         int         21h             

code     ends
         end         start

;zhodnotenie:
;program je funkcny
;obmedzenia: ak pri zadavani retazca napiseme znak $, prva funkcia (vypis retazca)
;nevytlaci retazec cely, ale len po tento znak. je to zapricinene konstrukciou tejto
;sluzby, pre ktoru $ znamena, ze bol dosiahnuty koniec retazca
;vyriesit by sa to dalo takym sposobom, aky je pouzity v inych castiach
;programu, teda ze by sme vypisovali znaky v cykle (parameter LOOPu by bol
;skutocny pocet znakov v retazci
;program bol napisany pre jazyk assembler
;v niektorych castiach programu sa iste sekvencie opakuju, co by sa dalo nahradit
;volanim podprogramu
;program vyuziva funkcie DOSu a BIOSu: 01h - nacitanie znaku, 02h - vypis znaku,
09h - vypis retazca
