;Zadanie c.2
;Text zadania : Vytvorte program, ktroy nacita z textoveho suboru postupnost celych cisel
;		 so znamienkom v desiatkovej ciselnej sustave (aspon 10), potom ich transformuje
;		 na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom podla priania
;		 uzivatela:
;		a) vypocita sumu vsetkych cisel a vypise ju
;		b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;		   do noveho textoveho suboru
;               c) usporiada cisla zostupne a zapise usporiadanu postupnost cisel
;		   do noveho textoveho suboru
;		c) vydeli dve dane cisla a vypise vysledok
;		d) ukonci vykonavanie programu

;Autor: Martin Herchl
;Termin odvzdania:14.11.2000
;2.roc.,sk.rok 2000/2001

;program bol skompilovany programom tasm 3.2, zlinkovany tlink5.2
;program bol napisany na pocitaci Cyrix686-200MHz, 32 MB RAM, Win98
;obmedzenia programu: vstupne hodnoty musia byt cisla z intervalu -128 az 127 
;musi existovat vstupny subor
;maximalna dlzka vstupneho retazca 256 znakov

;cls        	vymaze obrazovku
;setcur        	nastav kurzor na polohu x,y na obrazovke
;menu     	vypise menu
;strtono	ulozi cisla z retazca do pola cisel v rozsahu -128 az 127
;strtono2     	vo vysledok je adresa vysledku DS:BX zapisany ako string
;readno       	otvori subor, nacita cisla ako retazec a zatvori subor
;vyppol        	vypise pole cisel
;vypcisl        vypise cislo ktore je v ax
;suma 		spocita cisla v pole a vypise vysledok. Ak pretecenie hlasi chybu
;zostup		usporiadane pole (zostupne) zapise do suboru
;readnokey	nacita cislo z klavesnice
;divide		vydeli 2 cisla
;multiply	vynasobi 2 cisla
;error	       	vypise chybove hlasenie


pushx equ push ax bx cx dx si di ;uloz hodnoty v registroch do zasobnika
popx equ pop di si dx cx bx ax   ;vyber hodnoty zo zasobnika a uloz ich v registroch

 .model small  
 .stack 100h   ; zasobnik velky 256B
 .data	       ; datova cast

cisla db "0123456789"
buffer db 5 dup(?),"$"
menutitle db "           Martin Herchl - zadanie c.2$",10,13 
menuitem1 db 10,13,"                Vypocitaj sumu .......................... 1$"
menuitem2 db 10,13,"                Usporiadaj zostupne a zapis do suboru ... 2$"
menuitem3 db 10,13,"                Vydel 2 cisla ........................... 3$"
menuitem4 db 10,13,"                Vynasob 2 cisla ......................... 4$"
menuitem5 db 10,13,"                Ukonci program .......................... 5$"
message	db 10,13," Nacitane cisla: $"
message1 db 10,13," Sucet nacitanych cisiel: $"
message2 db 10,13," Aritmeticka chyba $"
message3 db 10,13," Zapisane do zostup.txt $"
message5 db 10,13," Zadaj indexy prvkov ktore chces delit (1..n): $"
message6 db 10,13," Zadaj indexy prvkov ktore chces nasobit (1..n): $"
message7 db 10,13," Vysledok: $"
message8 db ", zvysok po deleni: $"
subor   db "vstup.txt",0
subor2  db "zostup.txt",0
retazec db ' ',100h dup("$")
decade db 10
medzera db ' $'
pole    db 50h dup(?)
cislo   db 3,4 dup(' ')
stdout	db ?
ktorys  dw ?
vysledok db ?
point   dw ?
pocet   dw ?
vstup   dw ?
vystup1 dw ?



	.code			;kodova cast

cls proc near 			;vymaze obrazovku
    pushx
    mov ax,3  			;volanie modu c.3 (text 80x25)
    int 10h
    popx
cls endp

setcur proc near
    pushx
    mov ah,02 			;do dh,dl musim dat najskor poziciu x,y kurzora
    mov bx,0	
    int 10h		
    popx
    ret
setcur endp

menu proc near
    pushx
    mov dx,0605h		;nastavi polohu kurzora na obrazovke
    call setcur
    mov ah,09			;ah=9 sluzba na vypis
    mov dx,offset menutitle	;do dx offset premennej menutitle (zaciatok)	
    int 21h
    mov dx,offset menuitem1     ;vypisujem polozky menu
    int 21h
    mov dx,offset menuitem2
    int 21h
    mov dx,offset menuitem3
    int 21h
    mov dx,offset menuitem4
    int 21h
    mov dx,offset menuitem5
    int 21h
    popx
    ret  
menu endp

readno proc near
    pushx
    mov dx,offset subor
    mov ax,3d00h
    int 21h
    mov vstup,ax		;otvori subor
    mov ah,3fh
    mov bx,vstup		;do premennej vstup ulozi handle otvereneho suboru
    mov dx,offset retazec	;nacita cisla ako retazec znakov
    inc dx			;prida 1 medzeru na zaciatok (preskoci 1 znak)
    mov cx,100h                 ;maximalna dlzka vstupneho retazca je 256 znakov
    int 21h
    mov bx,ax
    mov [retazec+bx],' '	;nacita retazec zo suboru a prida na koniec 1 medzeru
    mov ah,3eh			;funkcia na citanie zo suboru (BIOS)
    mov bx,vstup
    int 21h
    popx
    ret
readno endp

strtono proc near
    pushx
    mov bx,offset retazec
    mov di,0
f1 :inc bx		;opakuj
    mov al,ds:[bx]    
    cmp al,' '		;nastavi na prvu cifru cisla
    jz f1
    cmp al,'$'		;zisti ci nie je koniec retazca
    jz o2               ;ak ano tak o2
    call strtono2 	;prevediem na cislo
    mov al,vysledok	
    mov [pole+di],al	;ulozim cislo do pola
    inc di
    mov bx,point	;obnov ukazovatel
    jmp f1
o2: mov pocet,di	;do pocet ulozi pocet nacitanych cisiel
    popx
    ret
strtono endp

strtono2 proc near
    pushx
loo:inc bx	
    mov al,ds:[bx]
    cmp al,' '
    jz o5
    cmp al,0dh
    jz o5
    jmp loo
o5: mov point,bx
    dec bx
    mov cx,1		
    mov dx,0
lo1:mov al,ds:[bx]	;do al znak
    cmp al,'-'		;ak uz minus
    jz min		
    cmp al,' '		;alebo medzera
    jz o		;koniec
    sub al,30h   	;v al cislo
    mul cl       	;ax=al*cl
    add dl,al    	;dl=vysledok 
    mov al,cl	 
    mul decade	 	;vynasob al*10=ax
    mov cl,al	 
    dec bx
    jmp lo1
min:mov al,dl
    neg	al		;vynasob -1 ak bolo minus
    mov vysledok,al
    jmp o1
o :mov vysledok,dl		
o1:popx
    ret
strtono2 endp

vyppol proc
    pushx
    mov dx,offset medzera
    mov di,0

fo8:cmp di,pocet        ;for di:=0 to pocet do
    jz ef8
    mov al,[pole+di]	
    cbw			;znamienkova uprava al->ax
    call vypcisl	;vypis ax
    mov cx,1
    mov ah,stdout		;v stdout 09 ak na obrazovku inak 40h ak do suboru
    mov bx,ktorys	;v bx rukojet suboru
    int 21h
    inc di
    jmp fo8
ef8:      
    popx
    ret
vyppol endp 

vypcisl proc		
    pushx
    mov bx,10       ;zaklad
    mov cx,ax       ;neskor koli znamienku
    cmp ax,0 	    ;ak > 0 potom vypis
    jg va1	    ;inak	
    not ax	    ;preved na doplnkovy kod
    inc ax	    ;a vypis	

va1:mov di,5
lll:dec di		; di ukazuje do buffera
    mov dx,0
    idiv bx             ;dx = ax mod bx
    mov si,dx           ;do si zbytok
    mov dl,[cisla+si]   ;do dl pismeno (si vyberie z retazca cisel podla svojej hodnoty)
    mov [buffer+di],dl  ;a zapis. do buff. (odzadu)
    cmp ax,0		;je cela cast nula?
    jnz lll
    cmp cx,0
    jge vat		;je < 0
    dec di 
    mov [buffer+di],'-' ;vypis aj minus
vat:mov dx,offset buffer;je >=0  
    add dx,di		; korekcia koli neplneniu buffera odpredu
    mov ah,stdout
    mov bx,ktorys
    mov cx,5
    sub cx,di
    int 21h		;vypis buffer
    popx
    ret
vypcisl endp

suma proc near
    pushx
    call cls
    mov dx,offset message
    mov ah,9
    int 21h
    mov stdout,09h         	;vypise nacitane cisla na obrazovku
    call vyppol
    mov ah,9
    mov dx,offset message1 
    int 21h
    mov cx,pocet
    mov bx,0
    mov si,0
o02:mov al,byte ptr[pole+si]	;do al pole[si]
    cbw				;al->ax
    add bx,ax			;bx=bx+ax
    jo er1			;zistim ci to nahodou nepretieklo
    inc si			
    loop o02
    mov ax,bx			
    mov stdout,09h		;na obrazovku
    call vypcisl		
    jmp o04
er1:call error			;vypis chybu
o04:mov ah,0
    int 16h
    popx
    ret 
suma endp

zost proc near
    pushx
poc dw ?
    mov ax,pocet		;uporiadanie vyberom najvacsiho prvku
    mov poc,ax
    dec poc
    mov cx,0
fo1:cmp cx,poc
    jz ef1
    mov di,cx
    mov al,[pole+di]
    mov bx,cx
    inc bx
fo2:cmp bx,pocet
    jz ef2
    cmp byte ptr [pole+bx],al
    jg nic
    mov di,bx
    mov al,[pole+bx]
nic:inc bx
    jmp fo2
ef2:mov si,cx
    mov ah,[pole+si]
    mov [pole+di],ah
    mov [pole+si],al
    inc cx
    jmp fo1
ef1:
    popx
    ret
zost endp

zostup proc
    pushx
count1 dw ?
    mov ax,pocet	;vyberom najmensieho prvku
    mov count1,ax
    dec count1
    mov cx,0
fo5:cmp cx,count1
    jz ef5
    mov di,cx
    mov al,[pole+di]
    mov bx,cx
    inc bx
fo6:cmp bx,pocet
    jz ef6
    cmp byte ptr [pole+bx],al
    jl nic1
    mov di,bx
    mov al,[pole+bx]
nic1:inc bx
    jmp fo6
ef6:mov si,cx
    mov ah,[pole+si]
    mov [pole+di],ah
    mov [pole+si],al
    inc cx
    jmp fo5
ef5:mov ah,3ch
    mov dx,offset subor2
    mov cx,0
    int 21h 
    mov vystup1,ax	;zbytocne
    mov ktorys,ax	
    mov stdout,40h		;do suboru
    call vyppol
    call cls
    mov ah,9 
    mov dx,offset message3
    int 21h
    mov ah,00
    int 16h
    popx
    ret
zostup endp

readnokey proc
    pushx
    mov ah,0ah
    mov dx,offset cislo
    int 21h			;nacitaj retazec
    mov bx,offset cislo		
    inc bx
    mov byte ptr ds:[bx],' '    ;korekcia pre proc. preved na c
    inc bx			;nastav ukayovatel
    call strtono2		;preved na cisl
    popx
    ret
readnokey endp

divide proc 
    pushx
    call cls
    mov dx,0101h
    call setcur
    mov ah,9
    mov dx,offset message       ;vypise spravu na obrazovku
    int 21h
    mov stdout,09h
    call vyppol
    mov dx,offset message5
    mov ah,9
    int 21h
    call readnokey		;nacitaj cisl
    mov al,vysledok		;v al cislo
    cbw				;al->ax
    dec ax			;zniz o jedno koli indexovaniu od nuly
    mov si,ax			;si ukozovatel na citatela
    mov dx,0334h
    call setcur
    call readnokey		;to iste
    mov al,vysledok
    cbw
    dec ax
    mov di,ax
    mov al,[pole+si]
    cbw
    mov bl,[pole+di]
    idiv bl		        ;vydeli al s bl
    mov bx,ax                   ;do al podiel, do ah zvysok cele do bx
    mov ah,9
    mov dx,offset message7
    int 21h
    mov al,bl                   
    cbw
    call vypcisl
    mov ah,9
    mov dx,offset message8
    int 21h
    mov al,bh
    cbw
    call vypcisl
    mov ah,0
    int 16h
    popx
    ret
divide endp    

multiply proc near
    pushx
    call cls
    mov dx,0101h
    call setcur
    mov ah,9
    mov dx,offset message       ;vypise spravu na obrazovku
    int 21h
    mov stdout,09h
    call vyppol
    mov dx,offset message6
    mov ah,9
    int 21h
    call readnokey
    mov al,vysledok
    cbw                         ;convert byte to word (kvoli vypisu)
    dec ax                      ;znizi ax o 1
    mov si,ax
    mov dx,0334h
    call setcur
    call readnokey              ;nacitaj indexy prvkov z klavesnice
    mov al,vysledok
    cbw
    dec ax
    mov di,ax
    mov al,[pole+si]
    mov bl,[pole+di]
    imul bl                     ;vynasob al s bl
    mov bx,ax
    mov ah,9
    mov dx,offset message7
    int 21h
    mov ax,bx
    call vypcisl
    mov ah,0
    int 16h
    popx
    ret
multiply endp    

error proc near			;vypise chybove hlasenie
  pushx
  mov ah,9
  mov dx,offset message2
  int 21h
  popx
  ret
error endp

start:  mov ax,@data
        mov ds,ax		; ds:data
opak:	call cls
	call menu
	call readno
        call strtono
case:   mov ah,0
        int 16h
        cmp al,'1' 		; vyber si jednu z moznosti
        jz c1
        cmp al,'2'
        jz c2
        cmp al,'3'
        jz c3
        cmp al,'4'
        jz c4
        cmp al,'5'
        jz c5
        jmp case
c1:      call suma
         jmp opak
c2:      call zostup
	 jmp opak
c3:      call divide
	 jmp opak
c4:      call multiply
         jmp opak
c5:      call konec
konec:	mov ax,4c00h    ;navrat riadenia dosu
        int 21h
end start