;Zadanie c.1.
;Text zadania: 
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) a podla ponkanho menu vykon  jednu z monost:
;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prv medzera,
;c) hlad v retazci zadan znak a pocet jeho vskytov ulo do CX 
;d) njde znak s max. hodnotou a vype tento znak
;e) zarovn text zlava (vynech prv medzery)
;f) vype retazec v obrtenom porad,
;g) ukonc vykonvanie programu.

;Autor:  M.Juriga  
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001


ZAS 	SEGMENT STACK
	DW 64 DUP(?)
ZAS ENDS

DATA 	SEGMENT			;definovanie datovej casti
TEXT	DB 101 DUP(0)		;def.pam. miesta pre vstupny text
PONUKA  DB '1 VYPIS RETAZEC',0AH,0DH
	DB '2 VYPIS PORADIE PRVEJ MEDZERY',0AH,0DH
	DB '3 ZISTI POCET ZADANEHO ZNAKU',0AH,0DH
	DB '4 VYPIS ZNAK S MAX. HODNOTOU',0AH,0DH
	DB '5 ZAROVNAJ TEXT ZLAVA',0AH,0DH
	DB '6 VYPIS RETAZEC V OPACNOM PORADI',0AH,0DH
	DB '7 KONEC',0AH,0DH
	DB 'ZADAJ VOLBU  : $'
HLASKA  DB 0AH,0AH,0DH,'PRESS ANY KEY$'
UVODHL	DB 'ZADAJ LUBOVOLNY TEXT MAX. 100 ZNAKOV. PRI STLACENI ENTER NACITAVANIE'
	DB ' KONCI AJ KED NEBOLO ZADANYCH 100 ZNAKOV',0AH,0DH,'$'
V21	DB 'PORADIE PRVEJ MEDZERY JE  $'
V22	DB 'V RETAZCI NEBOLA NAJDENA ZIADNA MEDZERA$'
VYSL2	DB '                   $'
V31	DB 0AH,0DH,'VYSKYT ZNAKU   V DANOM RETAZCI JE $'
V32	DB 0AH,0DH,'ZADAJ HLADANY ZNAK $' 
V41	DB 'ZNAK S MAX. HODNOTOU JE  $'
DATA	ENDS

CODE	SEGMENT
	ASSUME	CS:CODE,DS:DATA

START:	MOV AX, SEG DATA
	MOV DS,AX
	
	CALL MAZ_OBRAZOVKU	;zavola podprogram pre zmazanie obrazovky.
	XOR SI,SI		;vynuluje SI
	MOV CX,100		;do CX ulozi hodnotu 100
	MOV DX,OFFSET UVODHL	;do DX ulozi offsetovu cast adresy UVODHL
	MOV AH,09H		;sluzba na vypisanie
	INT 21H			;textu nachadzajuceho sa na adrese DX
	MOV BX,OFFSET TEXT	;do BX offsetovu cast TEXT

CITAJ:	MOV AH,1H 		;NACITA ZNAK Z KLAVESNICE VYSTUP AL
	INT 21H
	CMP AL,13		;porovna AL s 13
	JZ DALEJ		;ak AL=13 skoc na dalej
	MOV [BX+SI],AL 		;ZAPISE AL DO PAMATE na adresu BX+SI
	INC SI			;zvys hodnotu SI o 1
	LOOP CITAJ		;ak CX!=0 skoc na citaj

DALEJ:	MOV AL,'$'		;do AL hodnotu znaku $
	MOV [BX+SI],AL		;na adresu BX+SI uloz AL

MENU:	CALL MAZ_OBRAZOVKU	;zmaze obrazovku
	MOV DX,OFFSET PONUKA 
	MOV AH,09H  		;VYPISE PONUKU MOZNOSTI
	INT 21H
	MOV AH,01H 		;NACITA ZNAK
	INT 21H
	CMP AL,'1'		;porovna AL a 1
	JNZ VOL1_1		;ak A!=1 skoc na vol1_1
	CALL VOL1		;spusti vol1

VOL1_1:	CMP AL,'2'
	JNZ VOL2_1		;AL!=2 skoc 
	CALL VOL2         	;zavolaj vol2

VOL2_1:	CMP AL,'3'
	JNZ VOL3_1		;AL!=3 skoc
	CALL VOL3               ;zavolaj vol3

VOL3_1:	CMP AL,'4'
	JNZ VOL4_1		;AL!=4 skoc
	CALL VOL4               ;zavolaj vol4

VOL4_1:	CMP AL,'5'
	JNZ VOL5_1		;AL!=5
	CALL VOL5               ;zavolaj vol5

VOL5_1:	CMP AL,'6'
	JNZ VOL6_1		;AL!=6
	CALL VOL6		;zavolaj vol6

VOL6_1:	CMP AL,'7' 
	JNZ MENU		;AL!=7
	MOV AH,4CH		;ukoncenie programu
	INT 21H

VOL1:	CALL MAZ_OBRAZOVKU	;zmaz obrazovku
	MOV DX,OFFSET TEXT	
	MOV AH,09H              ;vypis obsah TEXT
	INT 21H
	CALL ANY		;zavolaj any
	RET			;ukoncenie podpogramu zabezpeci vykonanie 
				;instrukcie nasledujucej po instrukcii, ktora
				;vola tento podprogram

VOL2:	CALL MAZ_OBRAZOVKU	;zmaz obrazovku
	XOR CX,CX		;vynuluj CX
	MOV BX,OFFSET TEXT
V2_1:	MOV AL,[BX]		;do AL hodnotu z adresy BX
	INC BX			;BX=BX+1
	INC CL			;CL=CL+1
	CMP AL,'$'		;porovna AL a $
	JZ V2_2			;AL=$ skoc
	CMP AL,' '		;porovna AL a medzeru
	JNZ V2_1		;AL!=' ' skoc
	MOV DX,OFFSET V21	
	MOV AH,09H              ;vypise obsah V21
	INT 21H
	MOV AL,CL		;do al daj cl
	CALL KOREKCIA		;zavolaj korekcia
	MOV DX,OFFSET VYSL2	;vypisanie poradia prvej medzery. hodnota je 
	MOV AH,09H		;ulozena v VYSL2
	INT 21H
	CALL ANY		;zavolaj any
	RET			;navrat do hlavneho programu

V2_2:	MOV DX,OFFSET V22
	MOV AH,09H       	;vypise obsah V22
	INT 21H
	CALL ANY		;zavolaj any
	RET                     ;navrat na miesto odkial bolo volane V2_2

VOL3:	CALL MAZ_OBRAZOVKU	;zmaze obrazovku
	MOV BX,OFFSET TEXT      ;do bx offset. adresu TEXT
	XOR CX,CX         	;zmaz obsah cx
	MOV DX,OFFSET V32
	MOV AH,09H		;vypis obsah V32
	INT 21H
	MOV AH,01H
	INT 21H			;nacitaj znak
	MOV AH,AL		;uloz al do ah
V3_1:	MOV AL,[BX]		;do al obsah adresy BX
	CMP AL,'$'
	JZ K3     		;al=$ skoc na k3
	CMP AL,AH		
	JNZ V3_2                ;al!=ah skoc na v3_2
	INC CL			;zvys cl o 1
V3_2:	INC BX			;zvys bx o 1
	JMP V3_1		;skoc na v3_1
K3:	MOV BX,OFFSET V31	;do bx offset. adr. V31
	ADD BX,15		;zvys bx o 15
	MOV [BX],AH		;na adresu BX uloz ah
	MOV DX,OFFSET V31
	MOV AH,09H       	;vypis obsah V31
	INT 21H
	MOV AL,CL		;do al daj cl
	MOV CX,3
	MOV BX,OFFSET VYSL2
	MOV AH,0
V3_3:	MOV [BX],AH
	INC BX
	LOOP V3_3
	CALL KOREKCIA
	MOV DX,OFFSET VYSL2
	MOV AH,09H
	INT 21H
	CALL ANY
	RET

VOL4:	CALL MAZ_OBRAZOVKU
	XOR AH,AH
	MOV BX,OFFSET TEXT
V4_3:	MOV AL,[BX]
	CMP AL,'$'
	JZ V4_2
	CMP AH,AL
	JNC V4_1
	MOV AH,AL
V4_1:	INC BX
	JMP V4_3
V4_2:	MOV CL,AH
	MOV DX,OFFSET V41	
	MOV AH,09H
	INT 21H
	MOV DL,CL
	MOV AH,02H
	INT 21H
	CALL ANY
	RET

VOL5:	CALL MAZ_OBRAZOVKU
	MOV CX,CX
	MOV BX,OFFSET TEXT
V5_2:	MOV AL,[BX]
	CMP AL,'$'
	JZ V5_1
	CMP CX,1
	JZ V5_4
	CMP AL,' '
	JZ V5_3
V5_4:	MOV DL,AL
	MOV AH,02H
	INT 21H
	MOV CX,1
V5_3:	INC BX
	JMP V5_2
V5_1:	CALL ANY
	RET

VOL6:	CALL MAZ_OBRAZOVKU
	XOR CX,CX
	MOV BX,OFFSET TEXT
V6_1:	MOV AL,[BX]
	CMP AL,'$'
	JZ V6_2
	INC CX
	INC BX
	JMP V6_1
V6_2:	DEC BX
V6_3:	MOV DL,[BX]
	MOV AH,02H		;vypisanie znaku v DL
	INT 21H
	DEC BX
	LOOP V6_3
	CALL ANY
	RET

MAZ_OBRAZOVKU:
	MOV AH,0H		;nastavenie graf.modu.
	MOV AL,3		;mod 80x25x16
	INT 10H			;prerusenie graf.
	RET
	
KOREKCIA:
	MOV BX,OFFSET VYSL2
	CMP AL,10		;porovnaj AL a 10
	JNC KD1			;AL>10 skoc
	ADD AL,30H		;AL=AL+48   hodnota cislice 0
	MOV [BX],AL		;do pam. BX uloz AL
	JMP KK			;skoc na kk
KD1:	CMP AL,20		;AL?20
	JNC KD2			;AL>20 skoc
	MOV AH,'1'		;
	MOV [BX],AH		;na adr. BX zapis 1    VYSL2=1
	INC BX			;Zvys hodnotu BX  o 1
	SUB AL,10		;AL=AL-10
	ADD AL,30H		
	MOV [BX],AL		;na adr. BX zapis AL  VYSL2=1x  x cislica  AL
	JMP KK	
KD2:	CMP AL,30		;vid k1
	JNC KD3
	MOV AH,'2'
	MOV [BX],AH
	INC BX
	SUB AL,20
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD3:	CMP AL,40		;vid kd1
	JNC KD4
	MOV AH,'3'
	MOV [BX],AH
	INC BX
	SUB AL,30
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD4:	CMP AL,50		;vid kd1
	JNC KD5
	MOV AH,'4'
	MOV [BX],AH
	INC BX
	SUB AL,40
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD5:	CMP AL,60		;vid kd1
	JNC KD6
	MOV AH,'5'
	MOV [BX],AH
	INC BX
	SUB AL,50
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD6:	CMP AL,70		;vid kd1
	JNC KD7
	MOV AH,'6'
	MOV [BX],AH
	INC BX
	SUB AL,60
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD7:	CMP AL,80		;vid kd1
	JNC KD8
	MOV AH,'7'
	MOV [BX],AH
	INC BX
	SUB AL,70
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD8:	CMP AL,90		;vid kd1
	JNC KD9
	MOV AH,'8'
	MOV [BX],AH
	INC BX
	SUB AL,80
	ADD AL,30H
	MOV [BX],AL
	JMP KK
KD9:	CMP AL,100		;vid k1
	JNC KK
	MOV AH,'9'
	MOV [BX],AH
	INC BX
	SUB AL,90
	ADD AL,30H
	MOV [BX],AL
KK:	RET

ANY:	MOV DX,OFFSET HLASKA
	MOV AH,09H
	INT 21H
	MOV AH,01H
	INT 21H
	RET

CODE	ENDS
	END	START

;zhodnotrenie
;Program je z mojho hladiska funkcny a pracoval tak ako som predpokladal. 
;Program bol napisany na pocitaci pentium pod OS W98. Verzia kompilera 
;TASM 2.02 a linkera TLINK 3.01. Vstupny retazec sa zadava po spusteni 
;programu. Vstup sa zadava bud do stlacenia klavesy ENTER alebo automaticky 
;sa ukonci po nacitani 100 znakov. Kedze na vypisanie textu pouzivam funkciu 
;09h int 21h ,ktora vypisuje text od zadanej pamate v DX do znaku $, nemozme 
;pouzit v vstupnom retazci tento znak.Inak sa chova program korektne.
;Pouzil som tu aj podprogramy volane funkciou call. Podprogramy su : 
;maz_obrazovku,korekcia,any,vol1,vol2,vol3,vol4,vol5,vol6. Podprogram 
;maz_obrazovku sluzi k mazaniu obrazovky a pracuje tak, ze nastavuje mod 3
;co je 80x25 znakov pri 16 farbach. Podprog. korekcia sluzi na zabezpecenie
;vypisu cislice v registri AL. Kedze som zvolil metodu porovnavania cislice
;s intervalmi, je zbytocne dlhy, a funguje len pre 2 ciferne cislice.Z toho 
;dovodu nevypise korektne cislice vacsie ako 99.
;Podprog. any pracuje tak, ze caka nastlacenie lubovlnej klavesy.Vyuziva sa 
;vtedy, ked treba nechat zbrazeny text po potrebnu dobu. Podprog. vol1 az vol6
;sluzia na vykonanie funkcii podla menu a zodpovedaju polozkam v menu.
;Vylepsenie tohto programu je mozne hlavne hlavne zmenou algoritmu na konverziu
;Lepsia metoda by bola delit obsah registra 10. Zvysok po deleni ukladat 
;do pamati od konca. Vysledok po deleni delit znova a opakovat predchadzajuci 
;krok.