;Zadanie c.1.
;Text zadania: Napiste program, ktory nacita retazec a potom ho vypise, najde v nom prvu medzeru
;najde zadany znak, najde znak s maximalnou hodnotou, zarovna retazec zlava a obrati retazec.
;Autor:  Milan Melicherck
;2.roc.,k.rok 2000/2001

        assume  ss:stac, ds: data, cs: code
dolar   equ     '$'
zero    equ     '0'
one     equ     '1'
two     equ     '2'
three   equ     '3'
four    equ     '4'
five    equ     '5'
six     equ     '6'
seven   equ     '7'
spc     equ     ' '
stac    segment stack
        dw      64 dup(?)
stac    ends

data    segment
eol     db      0ah,0dh,'$'
nacitaj db      'Zadaj retazec: ',0ah,0dh,'$'
s1      db      100,0,100 dup(?)
menu    db      0ah,0dh,0ah,0dh
        db      '1-Vypis retazca',0ah,0dh
        db      '2-Najdi prvu medzeru',0ah,0dh
        db      '3-Najdi znak',0ah,0dh
        db      '4-Najdi znak s maximalnou hodnotou',0ah,0dh
        db      '5-Zarovna text zlava',0ah,0dh
        db      '6-Obratit retazec',0ah,0dh
        db      '7-Koniec',0ah,0dh
        db      0ah,0dh,'Vyber: $'
spcno   db      'Retazec neobsahuje medzeru',0ah,0dh,'$'
spcnum  db      'Prva medzera je na pozicii: $'
chrfnd  db      'Zadaj hladany znak: $'
chrno   db      'Retazec neobsahuje hladany znak',0ah,0dh,'$'
chrnum  db      'Pocet vyskytov hladaneho znaku v retazci: $'
smax    db      'Znak: $'
s2      db      100 dup(?)
data    ends

code    segment
write   proc                            ;procedura vypisujuca cislo v AX
        mov     dl,10
        div     dl
        mov     dh,ah
        cmp     al,1
        jb      wr1                     ;nema desiatky?
        add     al,zero                 ;vypis desiatok
        mov     dl,al
        mov     ah,02h
        int     21h
wr1:    mov     ah,02h                  ;vypis jednotiek
        mov     dl,dh
        add     dl,zero
        int     21h
        ret
write   endp

start:
        mov     ax,seg data
        mov     ds,ax
        mov     dx,offset nacitaj               ;vypis textu pre nacitanie vstupneho retazca
        mov     ax,0900h
        int     21h
        mov     dx,offset s1                    ;nacitanie retazca
        mov     ah,0Ah
        int     21h
        xor     ax,ax
        mov     al,[s1+1]
        add     al,2
        mov     di,ax
        mov     byte ptr s1[di],dolar           ;ukoncenie retazca $        
m:      mov     dx,offset menu                  ;vypis menu
        mov     ax,0900h
        int     21h
readch: mov     ax,0c08h                        ;nacitanie stlacenaj klavesy
        int     21h
        cmp     al,one                          ;jej spracovanie
        je      f1
        cmp     al,two
        je      f2
        cmp     al,three
        je      f3
        cmp     al,four
        je      f4
        cmp     al,five
        je      f5
        cmp     al,six
        je      f6
        cmp     al,seven
        je      f7
        jmp     readch                          ;ak nezavola ani jedny f-ciu, ignoruj

f1:     jmp     f1m                             ;skoky na jednotlive f-cie (dalej ako 127 B)
f2:     jmp     f2m
f3:     jmp     f3m
f4:     jmp     f4m
f5:     jmp     f5m
f6:     jmp     f6m
f7:     jmp     f7m

f1m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h                          ;novy riadok
        mov     dx,offset eol
        int     21h
        mov     ah,09h                          ;vypis retazca dos sluzbou 09h
        mov     dx,offset s1
        add     dx,2
        int     21h
        jmp     m                               ;koniec (vypis menu)

f2m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h                          ;novy riadok
        mov     dx,offset eol
        int     21h
        xor     cx,cx                           ;po koniec retazca...
        mov     cl,s1+1
        mov     si,2
        xor     ax,ax
        mov     al,spc
fndspc: cmp     al,s1[si]                       ;hladaj 1. medzeru
        je      spc1                            ;ak medzera, vypis poziciu
        inc     si
        loop    fndspc
        mov     dx,offset spcno                 ;medzera nenajdena
        mov     ah,09h
        int     21h
        jmp     m                               ;koniec
spc1:   mov     ax,si                           ;vypis pozicie medzery
        dec     ax
        push    ax
        mov     ah,09h
        mov     dx,offset spcnum
        int     21h
        pop     ax
        call    write
        jmp     m

f3m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h
        mov     dx,offset eol
        int     21h
        mov     dx,offset chrfnd                ;ktory znak hladat?
        int     21h
        mov     ax,0c01h
        int     21h
        push    ax
        mov     ah,09h
        mov     dx,offset eol
        int     21h
        xor     cx,cx
        mov     cl,s1+1                         ;po koniec retazca...
        mov     si,2
        pop     ax
        xor     bx,bx
fndchr: cmp     al,s1[si]                       ;hladaj zadany znak
        jne     chr1                            ;ak najdeny, zvac jeho pocitadlo vyskytu
        inc     bl
chr1:   inc     si
        loop    fndchr
        xor     cx,cx
        mov     cl,bl                           ;koli zadaniu (ma byt v cx)
        push    cx
        cmp     bl,0
        je      nochr                           ;ak sa nevyskytuje
        mov     ah,09h
        mov     dx,offset chrnum                ;vypis pocet
        int     21h
        xor     ax,ax
        mov     al,bl
        call    write
        pop     cx
        jmp     m                               ;koniec (menu)
nochr:  mov     ah,09h                          ;znak nenajdeny
        mov     dx,offset chrno
        int     21h
        pop     cx
        jmp     m                               ;koniec (menu)

f4m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h
        mov     dx,offset eol
        int     21h
        xor     cx,cx
        mov     dx,cx
        mov     ax,cx
        mov     cl,s1+1                         ;po koniec retazca...
fndmch: mov     bp,cx
        mov     al,s1[bp]+1
        cmp     al,dl                           ;hladaj znak s max. ASCII hodnotou
        jna     nxtloo                          
        mov     dl,al                           ;ak vacsi ako doteraz, zapamataj si novy
nxtloo: loop    fndmch
        push    dx
        mov     ah,09h
        mov     dx,offset smax                  ;vypis znaku s max. hodnotou
        int     21h
        pop     dx
        mov     ah,02h
        int     21h
        jmp     m                               ;koniec (menu)

f5m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h
        mov     dx,offset eol
        int     21h
        xor     ax,ax
        xor     bp,bp
        xor     cx,cx
        mov     cl,s1+1                         ;po koniec retazca...
fndnsp: mov     al,s1[bp]+2
        cmp     al,spc                          ;ak medzera, posun zaciatok o 1 do prava
        jne     spa1
        inc     bp
        loop    fndnsp
spa1:   mov     dx,offset s1+2
        add     dx,bp                           ;pricitaj k povodnemu zaciatku pocet uvodnych medzier
        mov     ah,09h  
        int     21h                             ;a vypis
        jmp     m                               ;koniec (menu)

f6m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h
        mov     ah,09h
        mov     dx,offset eol
        int     21h
        xor     cx,cx
        mov     cl,s1+1                         ;od konieca po zaciatok retazca...
        mov     dx,cx
        xor     ax,ax
rev1:   mov     si,cx
        mov     al,s1[si]+1
        mov     di,dx
        sub     di,cx
        mov     s2[di],al                       ;zapis na opacny koniec noveho retazca
        loop    rev1
        mov     s2[di]+1,dolar                  ;ukonci novy retazec
        mov     dx,offset s2
        mov     ah,09h
        int     21h
        jmp     m                               ;koniec (menu)

f7m:    mov     dl,al                           ;identifikacia f-cie
        mov     ah,02h
        int     21h                             
        mov     ax,4c00h
        int     21h                             ;koniec programu
code    ends
        end     start

;program je funkcny, bol vypracovany pre DOS (pouziva jeho sluzby), program vypisuje retazec iba
;po 1 znak $, dal by sa upravit pouzitim ASCIIZ retazcov a naslednym upravenim rutin sluziacich
;na vypis retazcov