;Zadanie c.1.
;Text zadania: 
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) 
;a podla ponkanho menu vykon  jednu z monost:

;a) vype retazec znakov na obrazovku
;b) vype pocet cslic v retazci
;c) zist,ci sa v retazci nachdza pouvatelom zadany znak a vype o tom sprvu
;d) njde znak s min. hodnotou a vype tento znak
;e) mal psmen konvertuje na velk
;f) zarovn text zprava ( vynech prv medzery odkonca)
;g) ukonc vykonvanie programu.


;Autor:  J. Olbert
;Termin odovzdania: 24.10.2000
;2.roc.,k.rok 2000/2001



zas	segment	stack			;alokovanie pamate pre zasobnik
	dw	64 dup(?)
zas	ends



data    segment
vstup   db      'Zadaj retazec (max 100 znakov)',0dh,0ah,'$'
inp     db      100,101 dup(?)
menu    db      0dh,0ah,0dh,0ah
	db      '            M E N U ',0dh,0ah
	db      'a) vypis retazec znakov na obrazovku ',0dh,0ah
	db      'b) vypis poctu cislic v retazci ',0dh,0ah
	db      'c) hladanie zadaneho znaku v retazci ',0dh,0ah
	db      'd) najdenie znaku s minimalnou hodnotou a jeho vypisanie',0dh,0ah
	db      'e) konvertovanie malych pismen v retazci na velke ',0dh,0ah
	db      'f) zarovnanie textu retazca zprava',0dh,0ah
	db      'g) ukoncenie programu ',0dh,0ah
sel     db      0dh,0ah,'Vyber si z menu (a..g)   $'
sa      db      0dh,0ah,'Retazec obsahuje tieto znaky : $'
sa1	db	0dh,0ah,'Ziadny retazac nebol zadany $'
sb      db      0dh,0ah,'Pocet cislic v retazci je $'
sc1     db      0dh,0ah,'Zadaj znak, ktory chces v retazci najst: $'
sc2     db      0dh,0ah,'Znak sa v retazci vyskytuje na $'
sc21    db      ' - om mieste $'
sc3     db      0dh,0ah,'Hladany znak sa v etazci nevyskytuje $'
sd1     db      0dh,0ah,'Znak s minimalnou hodnotou je  ''$'
sd2     db      ''' a nachadza sa na $'
sd3     db      ' - om mieste retazca $'
se      db      0dh,0ah,'Skonvertovany retazec obsahuje tieto znaky : $'


data    ends


prog    segment
	assume ss:zas,cs:prog,ds:data

start:  mov     ax,seg data
	mov     ds,ax			;nastavenie adresy datoveho sementu
	mov     dx,offset vstup
	mov     ah,9
	int     21h			;vypis rezazca 'Zadaj retazec '

	mov     dx,offset inp
	mov     ah,0ah
	int     21h			;nacitanie retazca
	mov	si,offset inp+1		;na adrese [si] je pocet skutocne napisanych znakov
	cmp	byte ptr [si],0		;zistenie ci bol zadany retazac
	jnz	next
	mov	dx,offset sa1		;ak nie vypise chybovu hlasku a skoci na ukoncenie programu
	mov	ah,9
	int 	21h

	jmp	mg			;skok na ukoncenie programu

next:	mov     dx,offset menu
	mov     ah,9
	int     21h			;vypis menu na obrazovku




vyber:  mov     ah,8
	int     21h

	cmp     al,'a'			;zistenie ci bol stlaceny klaves a
	jnz     y1
	jmp	ma
y1:	cmp     al,'b'			;zistenie ci bol stlaceny klaves b
	jnz     y2
	jmp	mb
y2:	cmp     al,'c'			;zistenie ci bol stlaceny klaves c
	jnz     y3
	jmp	mc
y3:	cmp     al,'d'			;zistenie ci bol stlaceny klaves d
	jnz     y4
	jmp	md
y4:	cmp     al,'e'			;zistenie ci bol stlaceny klaves e
	jnz     y5
	jmp	me
y5:	cmp     al,'f'			;zistenie ci bol stlaceny klaves f
	jnz     y6
	jmp	mf
y6:	cmp     al,'g'			;zistenie ci bol stlaceny klaves g
	jnz     vyber
	jmp	mg			;vyber z menu


ma:     				;zaciatok vyberu a) s menu
	call    standard		;nastavenie registrov CX a SI

	mov     dx,offset sa		
	mov     ah,9
	int     21h			;vypis retzca sa

	mov     ah,02h
a1:     mov     dl,ds:[si]		;do registra dl vlozit znak z ds:[si]
	int     21h			;vypisanie znaku retazca
	inc     si
	loop    a1			;opakovanie vypisu do vypisania vsetkych znakov
	call    men			;zobrazenie menu
	jmp     vyber			;skok na vyber z menu


mb:     call    standard		;zaciatok vyberu b) s menu
	mov     bl,0
	
b1:     cmp     byte ptr ds:[si],'0'
	jc      b2
	cmp     byte ptr ds:[si],3ah	;zistovanie ci znak v retazci je cislo
	jnc     b2
	inc     bl			;spocitavanie cisel v retazci
b2:     inc     si
	loop    b1			;opakovanie zistovania do odskusania vsetkych znakov

	mov     ah,9
	mov     dx,offset sb
	int     21h			;vypisanie retazca sb

	call    vypis			;vypisanie poctu cislic v retazci
	call    men			;zobrazenie menu
	jmp     vyber			;skok na vyber z menu

mc:     				;zaciatok vyberu c) z menu	
	call    standard	        ;nastavenie registrov CX aSI
	mov     ah,9
	mov     dx,offset sc1
	int     21h			;vypis retazca sc1

	mov     ah,1
	int     21h			;nacitanie hladaneho znaku

	mov     bl,al
c1:     cmp     bl,byte ptr ds:[si]	;porovnanie znaku v retazci s hladanym znakom
	jz      c2
	inc     si			;zistenie jeho poradoveho cisla
	loop    c1

	mov     dx,offset sc3
	mov     ah,9
	int     21h			;vypisanie retazca sc3

	call    men     		;zobrazenie menu
	jmp     vyber			;skok na vyber z menu

c2:	mov     dx,offset sc2		
	mov     ah,9
	int     21h			;vypis retazca sc2
	
	sub     si,offset inp+2
	mov     bx,si
	inc	bx			;aby nepocital od nuly
	call    vypis			;vypis poradoveho cisla hladaneho znaku

	mov     ah,9
	mov     dx,offset sc21
	int     21h			;vypis retazca sc21

	call    men			;zobrazenie menu
	jmp     vyber			;skok na vyber z menu



md:     				;zaciatok vyberu d) z menu
	call    standard		;nastavenie registra CX a SI
	mov     bl,ds:[si]		;vlozenie prveho znaku retazca do registra bl
	inc     si
	dec     cx

d1:     cmp     bl,byte ptr ds:[si]	;porovnanie najmensieho znaku so znakom na ds:[si]
	jle      d2
	mov     bl,byte ptr ds:[si]	;ak znak v ds:[si] bol mensi ako najmensi znak 
					;tak sa znak s ds:[si] vlozi do bl
	mov     ax,si
	sub     ax,offset inp+2
	mov     di,ax			;poradove cislo najmensieho znaku je ulozene v DI
d2:     inc     si
	loop    d1			;opakuje sa porovnavanie az do vycerpania vsetkych znakov v retazci

	mov     dx,offset sd1
	mov     ah,9
	int     21h			;vypisanie retazca sd1

	mov     dl,bl
	mov     ah,2
	int     21h			;vypisanie najmensieho znaku

	mov     ah,9
	mov     dx,offset sd2
	int     21h			;vypisanie retazca sd2

	mov     bx,di
	inc	bx
	call    vypis			;vypisanie poradove cislo najmensieho znaku
	mov     dx,offset sd3
	mov     ah,9
	int     21h			;vypisanie retazca s3

	call    men			;zobrazenie menu
	jmp     vyber			;skok na vyber s menu

me:     call    standard		;nastavenie registrov SI a CX
	mov     dx,offset se
	mov     ah,9
	int     21h			;vypis retazca se

e1:     cmp     byte ptr ds:[si],'a'	;zistovanie ci je dany znak v retazci vacsi ako znak a
	jc      e2
	cmp     byte ptr ds:[si],'z'+1	;zistovanie ci je dany znak v retazci mensi ako znak z
	jnc     e2
	sub     byte ptr ds:[si],32	;skonvetrovanie maleho pismena na velke

e2:     mov     ah,2
	mov     dl,ds:[si]
	int     21h			;vypisanie znaku retazca
	inc     si
	loop    e1			;opakovanie do vypisania vsekyh znakov v retazci
	jmp     vyber			;skok na vyber z menu

mf:     call    standard		;nastavenie registrov SI a CX
	add     si,cx			;nastavenie registra SI aby ukazoval na posledny znak v retazci
	dec	si
	
f1:     cmp     byte ptr ds:[si],' '	;zistovanie ci je posledny znak v retazci medzera
	jnz     f2
	mov     bx,offset inp+1
	dec     byte ptr ds:[bx]	;ak ano, tak nasleduje skratenie retazca sprava o jednu medzeru
	dec     si
	loop    f1			;opakovanie hladanie medzery az do zacitku retazca, alebo do najdenia ineho znaku ako medzery

f2:     mov     ah,9
	mov     dx,offset se
	int     21h			;vypisanie retazca se
	call    standard		;nastavenie registrov sI a CX
	
	mov     ah,2
f3:     mov     dl,byte ptr ds:[si]	;nacitanie aktualneho znaku do registra dl
	int     21h			;a jeho vypis na obrazovku
	inc     si
	loop    f3			;opakovanie az do vypisu celeho retazca

	call    men			;zobrazenie menu
	jmp     vyber			;skok na vyber z menu

mg:     mov     ah,4ch
	int     21h			;ukoncenie programu





vypis:					;vypise na obrazovku obsah registra bl
	mov     ah,0
	mov     al,bl			;obsah bl ulozi do al
	mov     bh,10			;do registra bh vlozi cislo 10
	div     bh			;hodnotu v registri ax vydeli 10-kou
	mov	cx,ax			;cislo z bl je rozdelene na dve cifry a ulozene v cl,ch
	mov	ah,2
	cmp	cl,0
	je	x3			;ak je prva cifra 0, tak nebude vypisana
	mov	dl,cl
	add 	dl,30h
	int	21h			;vypis prvej cifry
x3:	mov	dl,ch
	add	dl,30h
	int	21h			;vypis druhej cifry
	ret

men:    mov     dx,offset sel
	mov     ah,9
	int     21h				;vypis menu
	ret


standard:       ;do cx da pocet znakov v retazci a do si da ofset prveho znaku
	mov     si,offset inp+1
	mov     cl,ds:[si]
	mov     ch,0
	inc     si
	ret

prog    ends
	end     start





;Zhodnotenie:   Program je plne funkcny a osetreny proti zadaniu prazdneho retazca
;		Je skompilovanu pod compilatorom  TASM 2.02  Program sa chova korektne v kazdej
;		beznej, autorom testovanej situacii.  Dal by sa vylepsit o farebne vypisy menu,
;		co je vzhladom na jeho jednoduchost zrejme zbytocne. V programe su pouzite 
;		standartne DOS-ove sluzby a nepouziva ziadne sluzby BIOS-u.
;		