;zadanie c. 2
;vytvorte program ktory nacita z textoveho suborupostupnost celych cisel
;{aspon 10}so znamienkom v desitkovej ciselnej sustave,potom ich transformuje
;na cisla v dvojkovej ciselnej sustave v doplnkovom kode a potom podla priania
;pouzivayela
;a 	vypocita sumu vsetkych cisel a vypise ju
;usporiada cisla vzostupne a zapise usp.postupnost cisel do text suboru
;vydeli 2 vybrane cisla a vypise vysledok
;vynasobi 2 cisla a vypise vysledok
;ukonci svoje vykonavanie
;
;autor Tomas Palenik b 12
;datum odovzdania 8 tyzden 
;2roc sk rok 2000/2001
;
	.model small
zas	segment		stack     		;zasobnikovy segment
	db	100H dup(?)
zas	ends

data	segment                                 ;datovy segment
vstup	db	10                              ;riadiaca premenna pre nacitanie retazca
pocet	db	0				;kontrolna prem pre nacit retazca
inret	db	10 dup(0)			;buffer pre nacit retazca
	db	'$'                             ;ukoncenie buffera pre jeho nudzovy vypis
bufc	db	10 dup(0)			;
	db	'$'                             ;
subori	db	'input.txt'                     ;vstupny subor
	db	0                               ;ukoncenie mena vstup sub
suboro	db	'output.txt'			;vystupny subor
	db	0                               ;ukonc mena
desat	dw	10                              ;pomocna pri prevode cisel. sustav
cisla	dw	100 dup(0)			;pole cisel
indci	db	0          			;pocet cisel v poli
index 	dw	0                               ;pomocny index pri pristupe do pola
nr	db	0Dh                             ;novy riadok
	db	0Ah
	db	'$'
poper	dw	0                               ;
signum	db	0                              	;znamienko pom. premenna
jedna	dw	1                               ;
cislo	dw      0                               ;
mmsg0	db	'Vstupny subor input.txt $'     ;menu a chybove hlasky programu
mmsg1	db	'S - vypocitaj sumu $'
mmsg2	db	'U - usporiadaj a zapis $'
mmsg3	db	'D - vydel vybrane $'
mmsg4	db	'M - nasob vybrane $'
mmsg5	db	' Chyba $'
mmsg6	db	' outchyba $'
mmsg7	db	'K - koniec$' 		
mmsg8   db      ' prevod ok$'
mmsg9  	db	'zadaj index : $'
mmsg10 	db	' mimo index $'
mmsg11 	db	' mimo range $'
data	ends

code	segment					;zaciatok code segmentu
	assume ds:data,ss:zas,cs:code

; vykova odriadkovanie na obraze tj vypise
; sekvenciu CR LF
odriadkuj	proc	near
	mov	dl,	13      ; vypis znaku 0Dh na obraz
	mov	ah,	2       ; sluzbou cislo 2
	int	21h         	
	mov	dl,	10 	; vypis znaku 0Ah na obraz
	mov	ah,	2
	int 	21h
	mov	ah,	09h     ;
	ret
odriadkuj	endp

; prevedie cislo v doplnkovom kode na je ekvivalenty textovy retazec
; reprezentujuci jeho hodnotu v desiatkovej sustave
prevbak	proc	near                         	
	push	bx                              ;ulozenie registrov
	push	cx
	push	dx
	push	ax

	mov	bx,	dx			;v dx je adresa bin cisla v mem
	mov	ax,	word ptr [bx]		;cez bx da cislo do ax a cx
	mov	cx,	ax
	rcl	ax,	1                       ;zisti znamienko cisla
	jc	znam
	mov	bx,	offset inret            ;ak kladne do vystupneho retazca
	mov	byte ptr [bx],	'+'		;zapise +
	mov	ax,	cx
	jmp	eznam
		
znam:   mov	bx,	offset inret            ;inak zapise -
	mov	byte ptr [bx], 	'-'             ;a cislo v ax prevedie do prir
	mov	ax,	cx			;kodu z doplnkoveho
	dec	ax
	not	ax
eznam:	
	xor	cx,	cx                      ;prevod do 10 sustavy
	mov	bx,	offset bufc             ;do pomocneho buffera
	cmp	ax,	000Ah                   ;pomocou delenia 10
	jae	niter                           ;v cykle realizovanom
	jmp	prok				;skokmi
	
niter:	xor	dx,	dx                      ;nulovanie dx
	div	desat				;delenie 10
	add	dx,	30h                     ;uprava zvysku na tlacitelny znak
	mov	byte ptr [bx],	dl              ;zapis cifri do buffera
	inc	bx		
	inc	cx
	cmp	ax,	000Ah   		;cyklus pokial ax>=10
	jae	niter
prok:
	add	al,	30h                     ;uprava poslednej cifry
	mov	byte ptr [bx],	al              ;a jej zapis do buff
	inc	cx                              ;
	inc     cx
	mov	pocet,	cl	                ; do prem pocet vrati dlzku
	                                        ; prevedeneho cisla v bytoch
	mov	dx,	offset inret
	inc	dx
	
kyklop:	mov	al, byte ptr[bx]                ;prepis z reverzneho bufera
	xchg	bx,	dx			;do priameho
	mov	byte ptr[bx],	al              ;v cykle riadenom cx poctom prvkov
	xchg	bx,	dx
	inc	dx
	dec	bx
	loop kyklop

	mov	cl,	pocet      		;uprava vystup buffera
	mov	bx,	dx			;pomocou adresovania cez bx
	dec	bx
	mov	byte ptr[bx],	0Dh             ;odriadkovanie a ukoncenie
	inc	bx				;retazca
	mov	byte ptr[bx],	0Ah
	inc	bx
	inc	cx
	mov	byte ptr[bx], 	'$'
	inc	cx
	mov	pocet,  cl
		
	pop	ax                              ;nacitanie povodnych registrov
	pop	dx
	pop	cx
	pop	bx
	
	ret
	
prevbak	endp

;utriedenie pola prvkov int v pamati
;pomocou algoritmu maxsort
msort	proc	near                        	;
        xor	cx,	cx                      ;nastavenie pocitadla
	mov	cl,	indci
	mov	bx,	offset cisla            ;pointer na zaciatok pola
	 
scyk:	mov 	ax,	word ptr[bx]            ;prevod pola do predpateho kodu
	add	ax,	8000h                   ;v cykle
	mov	word ptr[bx],	ax
	add	bx,	02h
	loop 	scyk	


	xor	cx,	cx                    	;nastavenie pocitadla
	mov	cl,	indci
	dec	cx

acykl:	push	cx                             ;

	inc	cx  	;;;                    ;docasne zvysenie indexu
	
	mov	bx,	offset cisla           ;adresa do bx
	mov	dx,	bx
	xor	ax,	ax	               ;do ax 0

mckkk:	cmp	ax,	word ptr[bx]           ;najdenie max prvku v poli
	jae	sez
	mov	ax,	word ptr[bx]           ;porovanie z najnizsim
	mov	dx,	bx                     ;a zapis vyssieho do ax
sez:
	inc	bx                             ;posun pointera
	inc	bx
	loop	mckkk                          ;v cykle
	
	dec	bx	;;;                    ;posun pointera na koniec
	dec	bx	;;;			;docasneho pola	
	
	mov	ax,	word ptr[bx]    ;vymena maximalneho prvku
	xchg	bx,	dx		;a posledneho prvku
	mov	cx,	word ptr[bx]    ;subpola
	mov	word ptr[bx],	ax
	xchg	bx,	dx
	mov	word ptr[bx],	cx	

	pop	cx                      ;vnutorny cylkus opakuje pocet krat 
	loop	acykl
kvit:


        xor	cx,	cx                    ;spatny prevod do doplnkoveho 
	mov	cl,	indci			;kodu
	mov	bx,	offset cisla
	 
sbcyk:	mov 	ax,	word ptr[bx]
	add	ax,	8000h
	mov	word ptr[bx],	ax
	add	bx,	02h                     ;v cykle
	loop 	sbcyk	

	ret
msort	endp	

;vypocita vyslednu sumu vsetkych prvkov pola v doplnkovom kode
suma	proc	near
	mov	bx,	offset cisla		;nastavenie na zaciatok
	xor	cx,	cx                      ;inicializacia pocitadla
	mov	cl,	indci
	xor	ax,	ax                      ;vysledok 0
ssck:
	add	ax,	[bx]                    ;cyklicke pripocitavanie
;	jnc	sumc
;	jno	sumer
;sumc:	
	jo	sumer
	inc	bx                              ;cez pointer bx
	inc	bx
	loop 	ssck

	mov	index,	ax                      
	mov	dx,	offset index
	call	prevbak                         ;prevod vysledku  v bin kode
	mov	dx,	offset inret            ;na retazec a vypise ho na obr.
	mov	ah,	09h
	int 	21h
	mov	index, 	0000h
	ret
sumer:	mov	ah,	09h
	mov	dx,	offset mmsg11
	int 	21h 
	mov	index,	0000h	
	ret
suma	endp

;nacitanie dvojciferneho indexu prvku v poli z klavesnice
chore	proc	near
	push	ax                         ;ulozenie reg
	
	mov	ah,	09h                ;vypis ziadosti o vstup z klav
	mov	dx,	offset mmsg9
	int	21h

	xor	ax,	ax                 ;nacitanie znaku z klav
	mov	bx,	offset cisla
	mov	ah,	01h
	int	21h

	xor	cx,	cx                 ;prevod znaku na cislo
	add	cl,	al
	sub	cl,	30h                ;odpocet 30
	mov	ax,	cx                 ;nasob 10
	mul	desat
	mov	cx,	ax

	mov	ah,	01h                ;vstup druheho znaku
	int	21h
                                           ;a jeho pripocitanie k predch
	sub	al,	30h
	mov	ah,	00h
	add	cl,	al
	cmp	cl,	indci              ;ak je vysledny index vacsi
	ja	cchc		           ;ako index posledneho prvku
chc:                                       ;nastavi index na 0
	inc	bx                         ;nastavi do bx pointer na dany
	inc	bx			   ;prvok pola
	loop 	chc
cchc:   pop	ax
	ret
chore	endp

;vynasobi dve cisla v poli a ak je vysledok platny vypise ho
vynasob	proc	near
	call chore           		;vola proc na nacitanie indexu 1 sucinitela
	mov	ax,	word ptr[bx]	;prvy operand do ax	
	push	ax
	call	odriadkuj               ;self explanatory
	pop	ax
	call chore                      ;vola proc na nacit index 2 operandu
	mov	cx,	word ptr[bx]    ; druhy operand do cx

	cmp	ax,	7fffh           ;zisti znamienko ax
	jna	vnsa			;kladne
	dec	ax                      ;ax je zap prevod do prir kodu
	not	ax
	jmp	vnsc

vnsa:	cmp	cx,	7fffh           ;zisti znamienko cx
	jna	vnsb                    ;kladne
	dec	cx                      ;zaporne  prevod do prir kodu
	not	cx
	mul	cx                      ;nasobenie v prir kode
	jc	vnse			;overflow error
	not	ax                      ;vysledok zaporny v doplnk kode
	inc	ax
	jmp	vnsk                    ;jump end
vnsc:	cmp	cx,	7fffh           ;ax zap
	jna	vnsd                    ;cx klad
	dec	cx                      ;cx zap prevod do prir kodu
	not	cx
	mul	cx                      ;nasobenie v prirodzenom
	jc	vnse			;overflow error
	jmp	vnsk
vnsb:	mul	cx                      ;ax + cx + nasobenie
	jc	vnse                    ;overflow errror
	jmp	vnsk                    ;jump end
vnsd:	mul	cx                      ;ax - cx+
	jc	vnse                    ;nasobenie
	not	ax                      ;a prevod do doplnk kodu
	inc	ax
vnsk:	mov	cislo,	ax
	mov	dx,	offset cislo
	call	prevbak                 ;prevod cisla na desiatkovy retazec
	mov	dx,	offset inret
	mov	ah,	09h             ;vypis cisla na obraz
	int	21h				
	ret

vnse:   mov	dx,	offset mmsg11   ;vypis chyboveho hlasenia
	mov	ah, 	09h
	int	21h
	ret
vynasob	endp

;vydeli dve cisla z pola cisiel v doplnkovom kode
vydel	proc	near
	call chore                      ;vola nacitanie indexu delenca
	mov	ax,	word ptr[bx]	;pointer na delenca do ax	
	push	ax
	call	odriadkuj
	pop	ax
	call chore                      ;vola nacitanie indexu delitela
	mov	cx,	word ptr[bx]    ;pointer na delitela do cx

	cmp	ax,	7fffh           ;zisti znamienko delenca
	jna	vdsa		;
	dec	ax                      ;ak zap prevod do prir kodu
	not	ax
	jmp	vdsc
                                        ;zisti znamienko delitele 
vdsa:	cmp	cx,	7fffh
	jna	vdsb
	dec	cx                      ;ak zap prev do prr kodu
	not	cx
	xor	dx,	dx              ;nulovanie dx pre 16 bit delenie
	cmp	cx,	0000h           ;ak je delitel nula
	jz	vdse                    ;skok na obsluhu
	div	cx
	not	ax                      ;vydelenie a uprava znamienka
	inc	ax
	jmp	vdsk
vdsc:	cmp	cx,	7fffh           ;ax zap
	jna	vdsd                    ;cx klad
	dec	cx                      ;prev cx do prir kodu
	not	cx
	cmp	cx,	0000h           ;test na nulu
	jz	vdse
	xor	dx,	dx              ;priprava dx registra
	div	cx
	jmp	vdsk                    ;jmp koniec
vdsb:   xor	dx,	dx              ; oba operandy kladne
	cmp	cx,	0000h           ;ak cx <>0 tak vydeli
	jz	vdse
	div	cx
	jmp	vdsk
vdsd:	xor	dx,	dx              ;ax + cx -
	cmp	cx,	0000h           ;test na nulu
	jz	vdse
	div	cx                      ;uprava vysledku
	not	ax
	inc	ax
vdsk:	mov	cislo,	ax              ;vysledok do pamati
	mov	dx,	offset cislo
	call	prevbak                 ;prevod na retazec
	mov	dx,	offset inret
	mov	ah,	09h             ;vypis vysledku
	int	21h				
	ret

vdse:   mov	dx,	offset mmsg11    ;vypis chybovej hlasky
	mov	ah, 	09h
	int	21h
	ret
vydel	endp

;vypise pole prvkov do vystupneho suboru
vytsub2	proc	near
	
	mov	ah,	3Dh             ;otvorenie suboru
	mov	al,	01h
	mov	dx,	offset suboro
	xor	cx,	cx
	int	21h                     ;ak bola chyba skonci
	jc	v2er
	
	mov	bx,	ax              ;do bx handler suboru
	xor	cx,	cx              ;nastavenie pocitadla
	mov	cl,	indci
	mov	dx,	offset cisla    ;nastavi pointer na zac pola

v2cyk:
	mov	ah,	40h             ;cyklicky
	call	prevbak                 ;vola prevod aktualneho prvku na retazec
	push	cx
	push 	dx

	mov	dx,	offset inret    ;zapise tento retazec do sub
	mov	cl,	pocet
	int	21h
	
	pop	dx
	pop	cx
	
	add	dx,	02h             ;posun pointera v poli
	loop	v2cyk                   ;cylkus riadeny cx
	
v2er:   mov	ah,	3Eh             ;zatvori vystupny subor
	int	21h
	ret
vytsub2	endp

;vypise menu na obrazovku
vyp_menu	proc	near	
	mov	ax,	seg data     	;presunie do segmnetoveho reg ds
	mov	ds,	ax		;adresu data segmentu
	mov	dx,	offset mmsg1    ;do dx ide relativna adresa jednot
	mov	ah,	09h		;livich premennych menu
	int	21h                     ;a nasledne je vypisovana sluzbou
	call	odriadkuj		;na vypis retazca na obrazovku
	mov	dx,	offset mmsg2    ;na odriadkovanie je volana procedura
	int	21h			;odriadkuj
	call	odriadkuj
	mov	dx,	offset mmsg3
	int	21h
	call	odriadkuj
	mov	dx,	offset mmsg4
	int 	21h
	call	odriadkuj
	mov	dx,	offset mmsg7
	int 	21h
	call	odriadkuj
	ret
vyp_menu	endp

;nacita znak z klavesnice a podla jeho hodnoty vola prislusnu polozku menu
nacitaj_znak	proc	near
	mov	ah,	01h    	;nacitanie znaku z klav sluzbou na to urcenou
	int	21h
	cmp	al,	64h     ;porovnavanie znaku a skoky na prislusne
	je	proc3		;volania procedur
	cmp	al,	6Bh
	je	proc7
	cmp	al,	6Dh
	je	proc4
	cmp	al,	75h
	je	proc2
	cmp	al,	73h
	je	proc1
	call odriadkuj       	
	ret
proc1:	call odriadkuj          ; vypise sucet cisel
	call suma
	call odriadkuj
	ret
proc2:	call odriadkuj       	;usortuje pomocou maxsort
	call msort
	call odriadkuj
	ret
proc3:	call odriadkuj		;vydeli dve cisla
	call vydel
	call odriadkuj
	ret
proc4:	call odriadkuj          ;vynasobi dve cisla
	call vynasob
	call odriadkuj
	ret
proc7:	call odriadkuj          ; nastavi koniec pre hlavnu cast programu
	mov	ah,	4Ch	; ktora potom skonci
	ret	
nacitaj_znak	endp

;prevedie textovy retazec na binarne cislo v doplnkovom kode
prevod	proc	near
	push	dx                    	;ulozi registre
	push	bx
	push	ax
	push	cx

	;mov	dx,	offset inret    ;pointer na zaciatok buffera
	;xor	bx,	bx
	;mov	bl,	pocet
	;add	bx,	dx	
	;mov	byte ptr [bx],	'$'    
	;mov	ah,	09h
	;int	21h

	mov	bx,	offset inret	;pointer na zaciatok buffera
	xor	cx,	cx
	mov	cl,	pocet           ;do cx dlzka nacitaneho retazca
	cmp	byte ptr [bx],	2Dh	;-znamienko
	jne	nie
	dec	cx
	mov	signum,	01h            ;do pom premennej signalizuje zaporne c
	inc	bx
	jmp	proces                 ;skok na samotny prevod
nie:	mov	signum,	00h            ;signum signalizuje kladne cislo
	cmp	byte ptr [bx],	2Bh     ;+
	jne	proces
	dec	cx                     ;posun pointeru a oprava poctu
	inc	bx
proces:
	mov	poper,	0000h          ;nulovanie pom buffera
	xor	ax,	ax             ;
	mov	al,	byte ptr [bx]  ;do al cifra
	sub	al,	30h            ;uprava cifry na cislo
	mov	poper,	ax             ;do vysledku cislo
	cmp	cl,	01h
	jz	hotovo                 ;akjednociferne koniec
	dec	cx
cykl:	
	mov	ax,	000Ah          ;ciklicky prevod 
	xor	dx,	dx
	mul	poper                  ;pomocou nasobenia 10
	jc	outcar1                ;overflow chyba
	inc	bx
	xor	dx,	dx
	mov	dl,	[bx]           ;prevod dalsej cifry
	sub	dl,	30h	       ; na cislo
	add	ax,	dx             ; a pripocitanie k vysledku
	jc	outcar1
	jo	outcar1
	mov	poper,	ax             ; do poper vysledok
	loop	cykl
	jmp	hotovo

outcar1:                               ;obsluha chyby
	mov	ah,	09h
	mov	dx,	offset mmsg5   ;vypise ze cislo je zadane chybne
	int	21h
	jmp	konc
hotovo:
	mov	bl,	signum         ;do bl znamienko
	mov	ax,	poper
	cmp	bl,	01h
	jz	zapor	               ;
	cmp	ax,	7FFFh          ;ak kladne cislo <23767 tak OK
	ja	outcar1                ;inak skok prec
	mov	poper,	ax
	jmp 	kknc
zapor:	cmp	ax,	8000h          ;ak je cislo zaporne invertuje sa
        ja	outcar1                ;bit po bite a pripacia sa 1
	not	ax
	inc	ax
	mov	poper,	ax
kknc:                                  ;
	xor	ax,	ax             ;nulovanie ax
	mov	al,	indci          ;do ax index posledneho znaku
	cmp	ax,	64h            ;ak uz nieje miesto v poli koniec
	jae	konc
	mov	bx,	offset cisla   ;ak nieje na konci 
	add	bx,	ax
	add	bx,	ax
	mov	dx,	poper          ;zapise prevodene cislo z buffera 
	mov	word ptr[bx],	dx	;do pola
	inc	ax
	mov	indci,	al             ;zvisi index posledneho

konc:

	pop	cx                     ;vrati registre
	pop	ax
	pop	bx
	pop	dx
	ret
prevod	endp


;nacita vstupny subor
nacsub	proc 	near
	clc
	mov	ax,	3D00h             ;vola sluzbu na otvorenie 
	mov	dx,	offset subori     ;existujuceho suboru
	int	21h
	jnc	ner                       ;ak chyba tak koniec
	
	mov	ah,	4Ch               ;odovzda hl prog chybu--koniec
	ret
ner:	
	mov	bx,	ax                ;do bx handler suboru

	mov	pocet,	00h               ;pocet nacitanych znakov
	mov	dx,	offset inret      ;nastavi vstupny buffer
nacit:
	mov	ah,	3Fh               ;nacitanie 1 znaku zo suboru
	mov	cx,	0001h
	int 	21h
	
	jc	er                        ;ak chyba skok na jej obsluhu
	cmp	ax,	0000h
	jne	nekosub                   ;ak nieje koniec suboru
	cmp	pocet,	00h
	je	zavri                     ;ak je koniec suboru tak ho zavrie
	call	prevod                    ;prevedie posledne nacitane
zavri:	mov	ah,	3Eh
	int	21h                       ;sluzba uzavrie subor
	jmp	norek
nekosub:
	push	bx                        ;ak subor nekonci
	mov	bx,	dx                ;nacita do al znak
	mov	al,	[bx]
	pop	bx
	cmp	al,	0Dh               ;ak je znak koniec riadka
	jne	nekoriad
	mov	ah,	3Fh               ;tak docita riadok do konca
	mov	cx,	0001h             ;po jednotlivych znakoch
	int	21h
	cmp	pocet,	00h               ;ak je koniec a este nic nenacital
	je	prazd                     ;
	call	prevod                    ;ak nacital prevedie to
	mov	pocet,	00h
prazd:	mov	dx,	offset inret      ;inak ide na dalsi riadok
	jmp	nacit                     ;opakuje cyklicky
nekoriad:
	cmp	pocet,	06h               ;ak jeriadku viac znakov ako
	ja	ciri			;povolena dlzka skok na  ciri
	inc 	pocet
	inc	dx
	jmp	nacit                     ;ak nie tak cyklus pokracuje
ciri:
	dec	pocet                     ;prevedie uz nacitane
	call	prevod
dokpj:	mov	ah,	3Fh               ;docita riadok do konca
	clc
	mov	cx,	0001h             ;vycita znak
	int 	21h
	
	jc	er                        ;carry =error
	cmp	ax,	0000h
	je	zavri                    ;ak koniec tak zavrie subor
	push 	bx
	mov	bx,	dx
	mov	al,	[bx]
	pop	bx

	cmp	al,	0Dh              ;vycita koniec riadka zo suboru
	jne	dokpj
	mov	ah,	3Fh              ;pomocou sluzby dos
	int	21h
	mov	pocet,	00h
	mov	dx,	offset inret     
	jmp	nacit                    ;zacne nacitavat dalsi riadok
er:
	mov	dx,	offset mmsg5     ;vypise chybovu hlasku
	mov	ah,	09h
	int 	21h
	ret		
norek:
	ret		
nacsub	endp

;hlavna cast pro gramu 
start:
	mov 	ax,	seg data      	;nastavenie datoveho segm do reg ds
	mov 	ds,	ax
	mov	dx,	offset mmsg0    ;
	mov	ah,	09h
	int	21h

	call	odriadkuj
	call 	nacsub                  ;nacita vstupny subor
	cmp	ah,	4Ch             ;ak nacitanie suboru vratilo chybu
	je	koniec                  ;tak ide na koniec
                 
cyklus:	
	call 	vyp_menu                ;vypisuje menu
	call	nacitaj_znak            ;nacita riadiaci znak a vola prislusny
	cmp	ah,	4Ch		;kod pri znaku K skonci cyklus
	je	koniec                  ;a cely program
	jmp	cyklus
koniec:
	call	vytsub2                 ;vypise pole do suboru output.txt
	mov	ah,	4Ch	
	int 	21h
code	ends
	end start
;program je funkcny 
;mozu sa vyskytnut problemove reakcie na exoticke vstupy
;program kontroluje pracu so subormi
;kontrolute pretecenia pri nasobeni, prevode do bin sustavy,aj sumacii
;na triedenie bol pouzity algoritmus maxsort,ktory pre male polia dava
;obstojne vysledky ale pre velke polia je takmer nepouzitelny
