;Zadanie c.3
;S vyuzitim retazcovych instrukcii (vsade kde je to mozne) vytvorte program,ktory:
;a) nacita z klavesnice dva retazce do dvoch roznych segmentov
;   (minimalne dlzky 20 byte)
;b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy
;c) porovna posunuty retazec s retazcom v druhom segmente, t.j.
;   zisti, ci su rovnako dlhe a ci su rovnake
;d) zisti, ci sa v niektorom z retazcov nachadza zadany podretazec.
;
;Autor: Lubomir Paulik
;Termin odovzdania: 5.12.2000
;2.roc.,sk.rok 2000/2001
;
;Zaciatok zdrojoveho textu
;
zasobnik   SEGMENT      STACK           ;definovanie zasobnikoveho segmentu
           DW           100 DUP(?)      ;vyhradenie 100 slov
zasobnik   ENDS
;
data1      SEGMENT                      ;definovanie 1.datoveho segmentu
retazec1   DB           101 DUP(?)      ;vytvori miesto v pamati pre retazec1
podretazec DB           101 DUP(?)      ;vytvori miesto v pamati pre podretazec
posun      DB           0Ah,0Dh,24h     ;enter
zad_ret1   DB           'Zadajte prvy retazec: ',24h       ;vypisy na obrazovku
zad_ret2   DB           0Ah,0Dh,'Zadajte druhy retazec: ',24h
zad_podret DB           0Ah,0Dh,'Zadajte hladany podretazec: ',24h
vypis0A    DB           'Zadane retazce sa zhoduju.',0Ah,0Dh,24h
vypis0N    DB           'Zadane retazce sa nezhoduju.',0Ah,0Dh,24h
vypis1A    DB           'Hladany podretazec sa nachadza v prvom retazci.',0Ah,0Dh,24h
vypis1N    DB           'Hladany podretazec sa nenachadza v prvom retazci.',0Ah,0Dh,24h
vypis2A    DB           'Hladany podretazec sa nachadza v druhom retazci.',0Ah,0Dh,24h
vypis2N    DB           'Hladany podretazec sa nenachadza v druhom retazci.',0Ah,0Dh,24h
dlzka_ret1 DW           ?               ;dlzky retazcov
dlzka_ret2 DW           ?
dlz_podret DW           ?
data1      ENDS                         ;koniec 1.datoveho segmentu
;
data2      SEGMENT                      ;definovanie 2.datoveho segmentu
retazec2   DB           101 DUP(?)      ;vytvori miesto v pamati pre retazec2
data2      ENDS                         ;koniec 2.datoveho segemntu
;
code       SEGMENT                                  ;zaciatok kodoveho sagmentu
           ASSUME       CS:code, SS:zasobnik        ;definovanie registrov pre pracu s jednotlivymi segmentmi
;
seg1       PROC                         ;procedura vlozi do DS adresu 1.dat.segmentu
           PUSH         AX              ;AX odlozi na zasobnik
           MOV          AX, SEG data1
           MOV          DS, AX
           POP          AX              ;do AX vlozi vrchnu polozku zasobnika
           RET
seg1       ENDP
;
seg2       PROC                         ;procedura vlozi do DS adresu 2.dat.segmentu
           PUSH         AX              ;AX odlozi na zasobnik
           MOV          AX, SEG data2
           MOV          DS, AX
           POP          AX              ;do AX vlozi vrchnu polozku zasobnika
           RET
seg2       ENDP
;
;
start:     CALL         seg1                ;zavola proceduru seg1
           MOV          AH, 09h             ;vypis na obrazovku
           MOV          DX, OFFSET zad_ret1
           INT          21h
;
           XOR          DI, DI
zadaj1:    MOV          AH, 01h              ;funkcia DOSu pre vstup znaku
           INT          21h
           MOV          retazec1[DS:DI], AL  ;na miesto v retazci s indexom DI vlozi znak z registra AL
           INC          DI                   ;inkrementuje DI
           CMP          AL,0Dh               ;porovna zadany znak s enterom
           JNZ          zadaj1               ;ak nebol stlaceny enter skoci na navestie zadaj1
           DEC          DI                   ;dekrementuj DI
           MOV          retazec1[DS:DI], 24h ;pripoj k retazcu znak $
           MOV          DS:dlzka_ret1, DI    ;ulozi dlzku retazca
;
           MOV          AH, 09h             ;vypis na obrazovku
           MOV          DX, OFFSET zad_ret2
           INT          21h
           CALL         seg2                ;zavola proceduru seg2
;
           XOR          DI, DI
zadaj2:    MOV          AH, 01h             ;funkcia DOSu pre vstup znaku
           INT          21h
           MOV          retazec2[DS:DI], AL  ;na miesto v retazci s indexom DI vlozi znak z registra AL
           INC          DI                   ;inkrementuje DI
           CMP          AL,0Dh               ;porovna zadany znak s enterom
           JNZ          zadaj2               ;ak nebol stlaceny enter skoci na navestie zadaj2
           DEC          DI                   ;dekrementuj DI
           MOV          retazec2[DS:DI], 24h ;pripoj k retazcu znak $
           CALL         seg1                 ;zavola proceduru seg1
           MOV          DS:dlzka_ret2, DI    ;ulozi dlzku retazca
;
           MOV          AH, 09h               ;vypis na obrazovku
           MOV          DX, OFFSET zad_podret
           INT          21h
;
           XOR          DI, DI
zadaj3:    MOV          AH, 01h             ;funkcia DOSu pre vstup znaku
           INT          21h
           MOV          podretazec[DS:DI], AL  ;na miesto v retazci s indexom DI vlozi znak z registra AL
           INC          DI                     ;inkrementuje DI
           CMP          AL,0Dh                 ;porovna zadany znak s enterom
           JNZ          zadaj3                 ;ak nebol stlaceny enter skoci na navestie zadaj3
           DEC          DI                     ;dekrementuj DI
           MOV          podretazec[DS:DI], 24h ;pripoj k retazcu znak $
           MOV          DS:dlz_podret, DI      ;ulozi dlzku retazca
;
           MOV          AH, 09h             ;odriadkuje
           MOV          DX, OFFSET posun
           INT          21h
           MOV          AH, 09h
           INT          21h
;
posun_ret: CALL         seg1                ;specifikuje zdrojovy retazec
           MOV          SI, OFFSET retazec1 ;SRC - DS:SI
           MOV          AX, SEG data1
           MOV          ES, AX              ;specifikuje cielovy retazec
           MOV          DI, SI              ;DST - ES:DI
           MOV          CX, DS:dlzka_ret1   ;do CX vlozi dlzku retazca1
           ADD          SI, CX              ;ukazovatel posunie na koniec retazca1
           ADD          DI, CX
           ADD          DI, 10              ;ukazovatel posunie o 10 bitov
           ADD          CX, 1
           STD                              ;set direction flag -
;retazce sa budu spracovavat smerom dozadu, SI a DI sa budu dekrementovat
REP        MOVSB                            ;posun retazca1 o 10 bitov
;bude presuvat po 1 bite CX-krat (CX=dlzka retazca)
;
porovnaj:  CALL         seg1                ;specifikuje zdrojovy retazec
           MOV          SI, OFFSET retazec1 ;SRC - DS:SI
           ADD          SI, 10              ;porovnava posunuty retazec
           MOV          AX, SEG data2       ;specifikuje cielovy retazec
           MOV          ES, AX              ;DST - ES:DI
           MOV          DI, OFFSET retazec2
           XOR          AX, AX
           MOV          AX, DS:dlzka_ret1
           CMP          AX, DS:dlzka_ret2   ;porovna dlzky retazcov
           JNZ          rozne               ;ak nie su rovnako dlhe skoc na rozne
           XOR          CX, CX
           MOV          CX, DS:dlzka_ret1
           CLD                              ;clear direction flag -
;retazce sa budu spracovavat smerom dopredu, SI a DI sa budu inkrementovat
REP        CMPSB                            ;porovna retazce
;bude porovnavat po 1 bite CX-krat (CX=dlzka retazca)
           JNZ          rozne               ;ak nie su rovnake skoc na rozne
;
           CALL         seg1                ;vypise, ze su rovnake
           MOV          AH, 09h
           MOV          DX, OFFSET vypis0A
           INT          21h
           JMP          hladaj              ;preskoci navestie rozne
;
rozne:     CALL         seg1                ;vypise, ze su rozne
           MOV          AH, 09h
           MOV          DX, OFFSET vypis0N
           INT          21h
;
hladaj:    CALL         seg1                   ;podretazec specifikuje ako
           MOV          SI, OFFSET podretazec  ;zdrojovy retazec
           MOV          AX, SEG data1
           MOV          ES, AX                 ;retazec1 specifikuje ako
           MOV          DI, OFFSET retazec1    ;cielovy retazec
           ADD          DI, 10                 ;retazec1 je posunuty 10 bitov
           XOR          AX, AX
           ADD          AX, DS:dlz_podret
znovu:     CLD                                 ;clear direction flag -
;retazce sa budu spracovavat smerom dopredu, SI a DI sa budu inkrementovat
           XOR          CX, CX
           MOV          CX, DS:dlz_podret      ;vlozi do CX dlzku podretazca
REP        CMPSB                               ;porovna retazce
           JZ           rovnake                ;ak sa nachadza, skoc na rovnake
;v nasledujucom cykle sa bude podretazec porovnavat
;s rovnako dlhou castou retazca1 na adrese o 1 bit vyssej
;po vykonani instrukcii REP CMPSB sa automaticky inkremantuje SI a DI
;SI musime dekrementovat, lebo potrebujeme adresu podretazca v dalsom cykle
           DEC          SI
           INC          AX                     ;pocet posunuti adresy uklada do AX
           CMP          AX, DS:dlzka_ret1      ;porovnava dlzku zvysku retazca s dlzkou podretazca
           JA           skonci                 ;ak je zvysok mensi, tak skonci
           JMP          znovu                  ;inak posun adresu a opakuj
;
rovnake:   CALL         seg1                ;vypise, ze sa nachadza
           MOV          AH, 09h
           MOV          DX, OFFSET vypis1A
           INT          21h
           JMP          hladaj2             ;skoci na navestie hladaj2
;
skonci:    CALL         seg1                ;vypise, ze sa nenachadza
           MOV          AH, 09h
           MOV          DX, OFFSET vypis1N
           INT          21h
;
hladaj2:   CALL         seg1                   ;podretazec specifikuje ako
           MOV          SI, OFFSET podretazec  ;zdrojovy retazec
           MOV          AX, SEG data2
           MOV          ES, AX                 ;retazec2 specifikuje ako
           MOV          DI, OFFSET retazec2    ;cielovy retazec
           XOR          AX, AX
           ADD          AX, DS:dlz_podret
znovu2:    CLD                                 ;clear direction flag -
;retazce sa budu spracovavat smerom dopredu, SI a DI sa budu inkrementovat
           XOR          CX, CX
           MOV          CX, DS:dlz_podret      ;vlozi do CX dlzku podretazca
REP        CMPSB                               ;porovna retazce
           JZ           rovnake2               ;ak sa nachadza, skoc na rovnake2
;v nasledujucom cykle sa bude podretazec porovnavat
;s rovnako dlhou castou retazca1 na adrese o 1 bit vyssej
;po vykonani instrukcii REP CMPSB sa automaticky inkremantuje SI a DI
;SI musime dekrementovat, lebo potrebujeme adresu podretazca v dalsom cykle
           DEC          SI
           INC          AX                     ;pocet posunuti adresy uklada do AX
           CMP          AX, DS:dlzka_ret2      ;porovnava dlzku zvysku retazca s dlzkou podretazca
           JA           skonci2                ;ak je zvysok mensi, tak skonci2
           JMP          znovu2                 ;inak posun adresu a opakuj
;
rovnake2:  CALL         seg1                ;vypise, ze sa nachadza
           MOV          AH, 09h
           MOV          DX, OFFSET vypis2A
           INT          21h
           JMP          koniec              ;skoci na navestie koniec
;
skonci2:   CALL         seg1                ;vypise, ze sa nenachadza
           MOV          AH, 09h
           MOV          DX, OFFSET vypis2N
           INT          21h
;

koniec:    MOV          AX, 4C00h            ;odovzdanie spravy operacnemu systemu
           INT          21h
;
code       ENDS                              ;koniec kodoveho segmentu
           END          start                ;koniec programu
;
;ZAVERECNE HODNOTENIE
;
;program je plne funkcny
;
;program bol vypracovany na PC 486 DX4, pouzite prekladace:
;Turbo Assembler v 2.2
;Turbo Link v 3.01
;
;na vstup retazca je pouzita DOS-funkcia 01h
;nie je osetreny vstup specialnych znakov
;do retazca je mozne zapisat maximalne 100 znakov
;pouzitie klavesi BACKSPACE na vymazanie predchadzjuceho znaku je chybne,
;v programe sa javi ako vstup dalsieho znaku do retazca