;Zadanie c.1
;Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov)
;a podla ponukaneho menu vykona jednu z moznosti:
;a) vypise retazec znakov na obrazovku
;b) vypise poradove cislo miesta, kde sa nachadza prva medzera
;c) hlada v retazci zadany znak a pocet jeho vyskytov ulozi do CX
;d) najde znak s max. hodnotou a vypise tento znak
;e) zarovna text zlava (vynecha prve medzery)
;f) vypise retazec v obratenom poradi
;g) ukonci vykonavanie programu
;
;Autor: Lubomir Paulik
;Termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001
;
;Zaciatok zdrojoveho textu
;
zasobnik   SEGMENT      STACK           ;definovanie zasobnikoveho segmentu
           DW           100 DUP(?)      ;vyhradenie 100 slov
zasobnik   ENDS
;
data       SEGMENT                      ;definovanie datoveho segmentu
uvod       DB           'Zadajte retazec (maximalne 100 znakov):',0Ah,0Dh,24h
retazec    DB           101 DUP(?)      ;vytvori miesto pre vstupny retazec
retazec2   DB           101 DUP(?)      ;vytvori miesto pre zarovnany retazec
posun      DB           0Ah,0Dh,24h     ;enter
vyp_menu0  DB           'MENU:',0Ah,0Dh,24h    ;vytvori miesto pre retazce znakov pouzite na vypis menu
vyp_menu1  DB           '1.Vypis retazca zadanych znakov',0Ah,0Dh,24h
vyp_menu2  DB           '2.Vypis poradoveho cisla miesta, kde sa nachadza prva medzera',0Ah,0Dh,24h
vyp_menu3  DB           '3.Hladanie zadaneho znaku (pocet jeho vyskytov sa ulozi do CX)',0Ah,0Dh,24h
vyp_menu4  DB           '4.Hladanie znaku s maximalnou ASCII hodnotou a jeho vypis',0Ah,0Dh,24h
vyp_menu5  DB           '5.Zarovnanie textu zlava (vynechanie prvych medzier)',0Ah,0Dh,24h
vyp_menu6  DB           '6.Vypis retazca v obratenom poradi',0Ah,0Dh,24h
vyp_menu7  DB           '7.Koniec programu',0Ah,0Dh,24h
zle_cislo  DB           'Zadali ste zle cislo!',0Ah,0Dh,24h
zad_znak   DB           'Zadajte znak: ',24h                      ;miesto pre hladany znak
bezmedzery DB           'V zadanom retazci sa nenachadza medzera!',24h
vyskyt     DB           'Pocet vyskytov zadaneho znaku v retazci: ',24h
dlzka      DW           ?                                         ;miesto pre ulozenie dlzky retazca
data       ENDS                 ;koniec datoveho segmentu
;
code       SEGMENT              ;zaciatok kodoveho sagmentu
           ASSUME       CS:code, DS:data, SS:zasobnik             ;definovanie registrov pre pracu s jednotlivymi segmentmi
;
start:     MOV          AX, SEG data        ;do AX vlozi bazovu adresu datoveho segmentu
           MOV          DS, AX
           MOV          AH, 09h             ;funkcia DOSu pre vypis retazca
           MOV          DX, offset posun    ;do DX vlozi adresu retazca v datovom segmente
           INT          21h                 ;volanie prerusenia DOSu
           MOV          DX, offset uvod
           INT          21h                 ;vypise uvodny dialog
           XOR          DI,DI               ;vynulovanie registra
;
zadaj:     MOV          AH, 01h             ;funkcia DOSu pre vstup znaku
           INT          21h
           MOV          retazec[DI], AL     ;na miesto v retazci s indexom DI vlozi znak z registra AL
           INC          DI                  ;inkrementuje DI
           CMP          AL,0Dh              ;porovna zadany znak s enterom
           JNZ          zadaj               ;ak nebol stlaceny enter skoci na navestie zadaj
           DEC          DI                  ;dekrementuj DI
           MOV          retazec[DI], 24h    ;pripoj k retazcu znak $
;
menu:      MOV          AH, 09h             ;odriadkuje a vypise menu pomocou funkcie 09h
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu0
           INT          21h
           MOV          DX, offset vyp_menu1
           INT          21h
           MOV          DX, offset vyp_menu2
           INT          21h
           MOV          DX, offset vyp_menu3
           INT          21h
           MOV          DX, offset vyp_menu4
           INT          21h
           MOV          DX, offset vyp_menu5
           INT          21h
           MOV          DX, offset vyp_menu6
           INT          21h
           MOV          DX, offset vyp_menu7
           INT          21h
;
           MOV          AH,08h          ;caka na stlacenie klavesi
           INT          21h
           CMP          AL, 31h         ;porovna zadany znak s 1
           JZ           menu1p          ;ak bola stlacena 1 skoci na navestie menu1p
           CMP          AL, 32h
           JZ           menu2p
           CMP          AL, 33h
           JZ           menu3p
           CMP          AL, 34h
           JZ           menu4p
           CMP          AL, 35h
           JZ           menu5p
           CMP          AL, 36h
           JZ           menu6p
           CMP          AL, 37h
           JZ           menu7p
           MOV          AH, 09h
           MOV          DX,offset posun ;odriadkuje
           INT          21h
           MOV          DX,offset zle_cislo   ;ak bola stlacena chybna klavesa vypise o tom hlasenie
           INT          21h
           JMP          menu                  ;skoci na navestie menu (osetrenie zleho vstupu)
;
menu1p:    JMP          menu1                 ;vzdialene skoky
menu2p:    JMP          menu2
menu3p:    JMP          menu3
menu4p:    JMP          menu4
menu5p:    JMP          menu5
menu6p:    JMP          menu6
menu7p:    JMP          menu7
;
menu1:     MOV          AH, 09h               ;odradkuje a vypise prvu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu1
           INT          21h
           MOV          DX, offset posun
           INT          21h
           XOR          DI,DI                 ;vynuluje register DI
;
vyp_znak:  MOV          AH, 02h               ;funkcia DOSu pre vypis znaku
           MOV          DL, retazec[DI]
           INT          21h
           INC          DI
           MOV          dlzka, DI             ;vlozi hodnotu z DI na miesto v pamati vyhradene pre dlzku retazca
           CMP          retazec[DI], 24h
           JZ           menup                 ;skoci na navestie menup (podmieneny skok)
           JMP          vyp_znak              ;skoci na navestie vyp_znak
;
menup:     JMP          menu                  ;skoci na navestie menu (nepodmieneny skok)
;
menu2:     MOV          AH, 09h               ;odriadkuje a vypise druhu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu2
           INT          21h
           XOR          DI,DI
;
hladaj:    CMP          retazec[DI], 20h      ;porovnava znak z retazca s medzerou
           JZ           nasiel                ;ak priznak Z=1 skoci na navestie nasiel
           CMP          retazec[DI], 24h      ;porovnava znak z retazca so znakom $ (ukoncujucim retazec)
           JZ           nenasiel              ;ak priznak Z=1 skoci na navestie nenasiel
           INC          DI
           JMP          hladaj                ;nepodmieneny skok na hladaj
;
nasiel:    INC          DI
           MOV          AH, 02h               ;funkcia DOSu na vypis znaku
           MOV          CX, DI                ;do CX vloz obsah DI
           SHR          CL, 1                 ;posun o styri miesta vpravo
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           ADD          CL, 30h               ;pripocitaj hexadecimalne cislo 30h k obsahu CL
           MOV          DL, CL
           INT          21h
           MOV          CX, DI
           SHL          CL, 1                 ;posun o styri miesta vlavo
           SHL          CL, 1
           SHL          CL, 1
           SHL          CL, 1
           SHR          CL, 1                 ;posun o styri miesta vpravo
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           CMP          CL, 9
           JA           AF                    ;skoc na navestie AF ak je vacsie ako 9
           ADD          CL, 30h
           JMP          uprav                 ;skoc na navestie uprav
;
AF:        ADD          CL, 37h               ;pripocitaj hexadecimalne cislo 37h k obsahu CL
;
uprav:     MOV          DL, CL
           INT          21h
           JMP          menu                  ;skoc do menu
;
nenasiel:  MOV          AH, 09h               ;vypise hlasenie, ze v retazci sa nenachadza ziadna medzera
           MOV          DX, offset bezmedzery
           INT          21h
           JMP          menu
;
menu3:     MOV          AH, 09h               ;odriadkuje a vypise tretiu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu3
           INT          21h
           MOV          DX, offset zad_znak
           INT          21h
           MOV          AH, 01h               ;funkcia DOSu na vstup znaku
           INT          21h
           XOR          BX, BX                ;vynuluje registre BX, DI
           XOR          DI, DI
           DEC          DI                    ;dekrementuje DI
;
hladaj2:   INC          DI                    ;inkrementuje DI
           CMP          retazec[DI], 24h      ;testuje koniec retazca
           JZ           vypis3
           CMP          AL, retazec [DI]      ;porovnava znak z retazca s hladanym znakom
           JNZ          hladaj2               ;skoc na hladaj2 ak to neboli rovnake znaky
           INC          BX                    ;inkrementuj BX
           JMP          hladaj2
;
vypis3:    MOV          AH, 09h
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyskyt
           INT          21h
           MOV          AH, 02h
           MOV          CX, BX
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           ADD          CL, 30h
           MOV          DL, CL
           INT          21h
           MOV          CX, BX
           SHL          CL, 1
           SHL          CL, 1
           SHL          CL, 1
           SHL          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           SHR          CL, 1
           CMP          CL, 9
           JA           AF2
           ADD          CL, 30h               ;pripocitaj k hodnote v CL hexadecimalne cislo 30h
           JMP          uprav2
;
AF2:       ADD          CL, 37h               ;pripocitaj k hodnote v CL hexadecimalne cislo 37h
;
uprav2:    MOV          DL, CL
           INT          21h
           JMP          menu
;
menu4:     MOV          AH, 09h               ;odriadkuje a vypise stvrtu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu4
           INT          21h
           MOV          DX, offset posun
           INT          21h
           XOR          DI, DI
           MOV          CL, retazec[DI]       ;do CL presunie prvy znak retazca
;
porovnaj1: INC          DI
           CMP          retazec[DI], 24h      ;testuje koniec retazca
           JZ           vypis
           CMP          retazec[DI], CL       ;porovnava ASCII hodnotu znaku v CL (docasne maximum) s prave porovnavanym znakom retazca
           JA           vymena                ;ak je znak v retazci vacsi ako v CL skoci na navestie vymena
           JMP          porovnaj1
;
vymena:    MOV          CL, retazec[DI]       ;do CL vlozi momentalne max znak
           JMP          porovnaj1
;
vypis:     MOV          AH, 02h               ;vypise znak s max ASCII hodnotou
           MOV          DL, CL
           INT          21h
           JMP          menu
;
menu5:     MOV          AH, 09h               ;odriadkuje a vypise piatu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu5
           INT          21h
           XOR          DI, DI
           DEC          DI
;
porovnaj2: INC          DI
           CMP          retazec[DI], 20h     ;porovnava znaky v retazci s medzerou
           JZ           porovnaj2            ;ak Z=1 skoci na porovnaj2
           MOV          DX, DI
           XOR          CX, CX
;
posun_ret: MOV          DI, CX               ;do DI vlozi hodnotu z CX
           ADD          DI, DX               ;pripocita k nej hodnotu z DX
           MOV          AL, retazec[DI]      ;do AL vlozi znak z retazca s indexom DI
           MOV          DI, CX
           MOV          retazec2[DI], AL     ;do noveho retazca vloz znak z AL, ale na miesto posunute oproti staremu retazcu o DX znakov dopredu)
           INC          CX
           MOV          DI, CX
           ADD          DI, DX
           CMP          retazec[DI], 24h     ;testuje koniec retazca
           JNZ          posun_ret
           MOV          DI, CX
           MOV          retazec2[DI], 24h    ;vypise posunuty retazec
           MOV          AH, 09h
           MOV          DX, offset retazec2
           INT          21h
           JMP          menu
;
menu6:     MOV          AH, 09h              ;odriadkuje a vypise siestu volbu
           MOV          DX, offset posun
           INT          21h
           MOV          DX, offset vyp_menu6
           INT          21h
           MOV          DI, dlzka            ;do DI vlozi dlzku retazca
           DEC          DI
;
vypis2:    MOV          AH, 02h
           MOV          DL, retazec[DI]      ;vypisuje retazec odzadu
           INT          21h
           DEC          DI                   ;dekrementuje DI
           CMP          DI, 0                ;porovnava DI s 0 (testuje zaciatok vstupneho retazca)
           JNZ          vypis2
           JMP          menu
;
menu7:     MOV          AX, 4C00h            ;odovzdanie spravy operacnemu systemu
           INT          21h
;
code       ENDS                              ;koniec kodoveho segmentu
           END          start                ;koniec programu
;
;ZAVERECNE HODNOTENIE
;
;program je plne funkcny
;
;program bol vypracovany na PC 486 DX4, pouzite prekladace:
;Turbo Assembler v 2.2
;Turbo Link v 3.01
;
;na vstup retazca je pouzita DOS-funkcia 01h
;nie je osetreny vstup specialnych znakov
;do retazca je mozne zapisat maximalne 100 znakov
;pouzitie klavesi BACKSPACE na vymazanie predchadzjuceho znaku je chybne,
;v programe sa javi ako vstup dalsieho znaku do retazca
;
;vstup volby z menu je osetreny, nie je mozne zadat inu ako ziadanu hodnotu
;
;ako hladany znak moze vstupit lubovolny ascii kod