;Zadanie c.2
;Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
;(aspon 10) so znamienkom v desiatkovej ciselnej sustave,
;potom ich transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom kode
;a potom podla priania pouzivatela:
;a) vypocita sumu vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;   do noveho textoveho suboru
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.
;
;Autor: Lubomir Paulik
;Termin odovzdania: 14.11.2000
;2.roc.,sk.rok 2000/2001
;
;Zaciatok zdrojoveho textu
;
zasobnik   SEGMENT      STACK           ;definovanie zasobnikoveho segmentu
           DW           100 DUP(?)      ;vyhradenie 100 slov
zasobnik   ENDS
;
data       SEGMENT                      ;definovanie datoveho segmentu
subor      DB           'vstup.txt',0   ;definicia vstupneho suboru
subor2     DB           'vystup.txt',0   ;definicia vystupneho suboru
retazec    DB           101 DUP(?)      ;obsah suboru sa ulozi do retazca
retazec2   DB           101 DUP(?)      ;retazec2 ulozi do vystupneho suboru
posun      DB           0Ah,0Dh,24h     ;enter
vyp_uvod   DB           'Postupnost cisel nacitana zo suboru:',0Ah,0Dh,24h
vyp_menu0  DB           'MENU:',0Ah,0Dh,24h    ;vytvori miesto pre retazce znakov pouzite na vypis menu
vyp_menu1  DB           '1.Sucet vsetkych cisel',0Ah,0Dh,24h
vyp_menu2  DB           '2.Usporiadanie cisel vzostupne (zapisanie postupnosti do suboru vystup.txt)',0Ah,0Dh,24h
vyp_menu3  DB           '3.Delenie dvoch vybranych cisel',0Ah,0Dh,24h
vyp_menu4  DB           '4.Vynasobenie dvoch vybranych cisel',0Ah,0Dh,24h
vyp_menu5  DB           '5.Koniec programu',0Ah,0Dh,24h
cislo_sub  DW           ?
cislo_sub2 DW           ?
vyp_neotv  DB           'Subor VSTUP.TXT sa nepodarilo otvorit!',0Ah,0Dh,24h
zle_cislo  DB           'Zadali ste zle cislo!',0Ah,0Dh,0Ah,0Dh,24h
cisla      DW           50 DUP (?)      ;pole nacitanych cisel zo suboru
cisla2     DW           50 DUP (?)      ;pole zoradenych cisel
pocet_byte DW           ?
vyp_sucet  DB           'Sucet vsetkych cisel v subore je:',24h
vyp_zor    DB           'Postupnost vzostupne zoradenych cisel:',0Ah,0Dh,24h
vyp_vyber  DB           'Vyberte dve cisla:',0Ah,0Dh,24h
vyp_index  DB           ' #0   #1   #2   #3   #4   #5   #6   #7   #8   #9',0Ah,0Dh,24h
vyp_prve   DB           'Index prveho cisla:',24h
vyp_druhe  DB           'Index druheho cisla:',24h
vyp_sucin  DB           'Sucin vybranych cisel:',24h
vyp_podiel DB           'Podiel vybranych cisel:',24h
vyp_zvysok DB           'Zvysok po deleni:',24h
zvysok     DW           ?
vyp_of     DB           0Dh,'Pri sucine cisel doslo k preteceniu!',0Ah,0Dh,24h
data       ENDS                         ;koniec datoveho segmentu
;
code       SEGMENT                                         ;zaciatok kodoveho sagmentu
           ASSUME       CS:code, DS:data, SS:zasobnik      ;definovanie registrov pre pracu s jednotlivymi segmentmi
;
start:     MOV          AX, SEG data        ;do AX vlozi bazovu adresu datoveho segmentu
           MOV          DS, AX              ;do DS ulozi obsah registra AX
           MOV          AH, 3Dh             ;funkcia DOSu na otvorenie suboru
           MOV          AL, 0               ;otvorenie na citanie
           MOV          DX, OFFSET subor    ;do DX ulozi offsetovu cast adresy (ukazuje na subor vstup.txt)
           INT          21h
           JC           neotvoril           ;ak CF=1 skoc na navestie neotvoril
           MOV          cislo_sub, AX       ;do premennej cislo_sub ulozi handler otvoreneho suboru
;
           MOV          CX, 1               ;bude citat po jednom znaku
           MOV          BX, cislo_sub       ;do BX ulozi handler suboru
           MOV          DX, OFFSET retazec  ;nacitane znaky bude ukladat do retazca
           XOR          DI,DI               ;vynuluj register DI
;
citaj:     MOV          AH, 3Fh             ;funkcia DOSu na citanie zo suboru
           INT          21h
           INC          DX                  ;nasledujuci znak sa ulozi do retazca na adrese [DX]+1
           INC          DI                  ;inkrementuj DI
           CMP          AX, 00h             ;porovnava nacitavany znak s EOF
           JNE          citaj               ;ak sa nerovnaju, skoc na navestie citaj
           DEC          DI                  ;dekrementuj DI
           MOV          retazec[DI], 24h    ;retazec zakonci znakom $
           JMP          zatvor
;
neotvoril: MOV          AH, 09h             ;oznami, ze sa nepodarilo otvorit vstupny subor
           MOV          DX, OFFSET vyp_neotv
           INT          21h
           MOV          AX, 4C00h           ;ukonci vykonavanie programu
           INT          21h
;
zatvor:    MOV          AH, 3Eh             ;funkcia DOSu na uzatvorenie suboru
           MOV          BX, cislo_sub
           INT          21h
           XOR          DI, DI              ;vynuluje registre SI a DI
           XOR          SI, SI
;
zmen:      XOR          AH, AH              ;vynuluje horne byty registrov AX,BX
           XOR          BH, BH
           MOV          AL, retazec[DI+1]   ;zmeni znak na cislo
           SUB          AL, 30h
           MOV          CL, 100
           MUL          CL                  ;vynasobi cislo radom stoviek
           MOV          BX, AX
           XOR          AH, AH
           MOV          AL, retazec[DI+2]
           SUB          AL, 30h
           MOV          CL, 10
           MUL          CL                  ;vynasobi cislo radom desiatiek
           ADD          AX, BX              ;scita stovky a desiatky
           MOV          BL, retazec[DI+3]
           SUB          BL, 30h
           XOR          BH, BH
           ADD          AX, BX              ;pripocita jednotky
           CMP          retazec[DI], 2Dh
           JNZ          kladne0              ;ak pred cislom nie je '-' skoc na navestie kladne0
           MOV          CX, -1
           IMUL         CX                  ;vynasobi cislo -1
;
kladne0:   MOV          cisla[SI], AX       ;do retazca cisla nacita cisla zo suboru
           ADD          SI, 2
           MOV          pocet_byte, SI      ;pocet cisel (pocet bytov v pamati * 2)
           ADD          DI, 5
           CMP          retazec[DI-1],0Dh
           JNZ          zmen                ;ak nie je posun o jeden riadok dole, tak pokracuj
;
uvod:      MOV          AH, 09h              ;funkcia DOSu na vypis nasledovnych retazcov textu na obrazovku
           MOV          DX, OFFSET vyp_uvod
           INT          21h
           MOV          DX, OFFSET retazec
           INT          21h
           MOV          DX, OFFSET posun     ;odriadkuje
           INT          21h
           MOV          DX, OFFSET posun
           INT          21h
;
menu:      MOV          DX, OFFSET vyp_menu0 ;vypis menu na obrazovku
           INT          21h
           MOV          DX, OFFSET vyp_menu1
           INT          21h
           MOV          DX, OFFSET vyp_menu2
           INT          21h
           MOV          DX, OFFSET vyp_menu3
           INT          21h
           MOV          DX, OFFSET vyp_menu4
           INT          21h
           MOV          DX, OFFSET vyp_menu5
           INT          21h
;
           MOV          AH, 08h              ;funkcia DOSu pre vstup klavesy bez odozvy
           INT          21h
           CMP          AL, 31h              ;vyber z menu
           JZ           menu1p
           CMP          AL, 32h
           JZ           menu2p
           CMP          AL, 33h
           JZ           menu3p
           CMP          AL, 34h
           JZ           menu4p
           CMP          AL, 35h
           JZ           menu5p
           MOV          AH, 09h
           MOV          DX,offset posun ;odriadkuje
           INT          21h
           MOV          DX,offset zle_cislo   ;ak bola stlacena chybna klavesa vypise o tom hlasenie
           INT          21h
           JMP          menu                  ;skoci na navestie menu (osetrenie zleho vstupu)
;
menu1p:    JMP          menu1                 ;vzdialene skoky
menu2p:    JMP          menu2
menu3p:    JMP          menu3
menu4p:    JMP          menu4
menu5p:    JMP          menu5
;
menu1:     MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           XOR          AX, AX                ;vynuluje registre AX,DI
           XOR          DI, DI
;
scit_dal:  ADD          AX, cisla[DI]         ;scita cislo v registri AX s aktulnym cislom z pola cisel
           ADD          DI, 2                 ;posun na dalsie cislo v poli
           CMP          pocet_byte, DI        ;porovnava pocet_byte(pocet_cisel*2) s poctom scitanych cisel
           JAE          scit_dal              ;scitava pokial je pocet scitanych cisel mensi alebo rovny
           MOV          BX, AX
           MOV          AH, 09h
           MOV          DX, OFFSET vyp_sucet
           INT          21h
;
           CMP          BX, 00h               ;zisti ci v BX je kladne cislo
           MOV          AX, BX
           JAE          kladne1               ;ak ano pokracuje na kladne2
           MOV          AH, 02h
           MOV          DL, 2Dh
           INT          21h                   ;vypise znamienko minus
           MOV          AX, BX
           MOV          CX, -1
           IMUL         CX                    ;cislo v AX vynasobi -1
;
kladne1:   XOR          BX,BX
           XOR          CX,CX
           XOR          DX,DX
           MOV          BX, 1000              ;BX je delitelom
           DIV          BX                    ;vydeli cislo v AX
           MOV          CX, DX                ;zvysok v DX presunie do CX
           ADD          AL, 30h               ;prevedie cislo na znak
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 4 rad cisla
           XOR          DX, DX
           MOV          AX, CX                ;zvysok bude delencom
           MOV          BX, 100
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 3 rad cisla
           XOR          AH, AH
           MOV          AL, CL                ;AL je delenec (8bit reg)
           MOV          BL, 10                ;delitelom je BL
           DIV          BL                    ;vydeli cislo v AL
           MOV          CL, AH                ;zvysok v AH presunie do CL
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 2 rad cisla
           ADD          CL, 30h
           MOV          AH, 02h
           MOV          DL, CL
           INT          21h                   ;vypise 1 rad cisla
           MOV          AH, 09h
           MOV          DX, OFFSET posun      ;odriadkuje
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h                   ;skoci na navestie menu
           JMP          menu
;
menu2:     XOR          DI, DI
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_zor
           INT          21h
;
duplik:    XOR          AX, AX                ;duplikuje pole cisel
           MOV          AX, cisla[DI]         ;bude pracovat s polom cisla2
           MOV          cisla2[DI], AX
           ADD          DI, 2
           CMP          pocet_byte, DI
           JA           duplik                ;testuje koniec pola
;
           XOR          DI, DI
           XOR          AX, AX
           XOR          BX, BX

vymen:     MOV          SI, DI
;
vymen2:    MOV          AX, cisla2[DI]
           CMP          AX, cisla2[SI]
           JL           nezmen                ;ak je mensie, tak vymiena cisla
           MOV          BX, cisla2[SI]        ;vymena pozicii cisel
           MOV          cisla2[DI], BX
           MOV          cisla2[SI], AX
nezmen:    ADD          SI, 2
           CMP          pocet_byte, SI        ;testuje koniec pola
           JA           vymen2                
           ADD          DI, 2
           CMP          pocet_byte, DI        ;testuje koniec pola
           JA           vymen
           XOR          DI, DI
           XOR          SI, SI
dalsie:    MOV          AX, cisla2[DI]
           ADD          DI, 2
           MOV          BX, AX
           MOV          retazec2[SI], 2Bh     ;do retazca vlozi +
           CMP          BX, 00h               ;zisti ci v BX je kladne cislo
           JNS          kladne2               ;ak ano pokracuje na kladne2
           MOV          retazec2[SI], 2Dh     ;do retazca vlozi -
           MOV          AX, BX
           MOV          CX, -1
           IMUL         CX                    ;cislo v AX vynasobi -1
;
kladne2:   XOR          BX,BX
           XOR          CX,CX
           XOR          DX,DX
           MOV          BX, 1000              ;BX je delitelom
           DIV          BX                    ;vydeli cislo v AX
           MOV          CX, DX                ;zvysok v DX presunie do CX
           ADD          AL, 30h               ;prevedie cislo na znak
           MOV          retazec2[SI+1], AL    ;do retazca vlozi 1 cifru
           XOR          DX, DX
           MOV          AX, CX                ;zvysok bude delencom
           MOV          BX, 100
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          retazec2[SI+2], AL    ;do retazca vlozi 2 cifru
           XOR          AH, AH
           MOV          AL, CL                ;AL je delenec (8bit reg)
           MOV          BL, 10                ;delitelom je BL
           DIV          BL                    ;vydeli cislo v AL
           MOV          CL, AH                ;zvysok v AH presunie do CL
           ADD          AL, 30h
           MOV          retazec2[SI+3], AL    ;do retazca vlozi 3 cifru
           ADD          CL, 30h
           MOV          retazec2[SI+4], AL    ;do retazca vlozi 4 cifru
           MOV          AH, 09h
           MOV          retazec2[SI+5], 20h   ;prida medzeru
           ADD          SI, 6
           CMP          pocet_byte, DI
           JA           dalsie
           MOV          retazec2[SI], 24h     ;na koniec prida znak $
;
           MOV          AH, 3Ch               ;funkcia DOSu pre vytvorenie suboru
           XOR          CX, CX                ;nastavi normalne paramentre
           MOV          DX, SEG subor2        ;specifikacia vytvoreneho suboru
           MOV          DS, DX
           MOV          DX, OFFSET subor2
           INT          21h
           MOV          cislo_sub2, AX        ;do cislo_sub2 vlozi handler suboru
;
           MOV          AH, 40h               ;funkcia DOSu pre zapis do suboru
           MOV          BX, cislo_sub2        ;do BX vlozi handler suboru
           MOV          CX, 60                ;pocet zapisovanych znakov
           MOV          DX, SEG retazec2      ;specifikacia zapisovaneho retazca
           MOV          DS, DX
           MOV          DX, OFFSET retazec2
           INT          21h
;
           MOV          AH, 3Eh               ;funkcia DOSu pre zatvorenie suboru
           MOV          BX, cislo_sub2
           INT          21h
;
           MOV          AH, 09h               ;vypise zoradene cisla na obrazovku
           MOV          DX, OFFSET retazec2
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET posun      ;odriadkuje
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           JMP          menu
;
menu3:     MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET vyp_vyber
           INT          21h
           MOV          DX, OFFSET vyp_index
           INT          21h
           MOV          DX, OFFSET retazec
           INT          21h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_prve
           INT          21h
           MOV          AH, 01h               ;nacita index prveho cisla z klavesnice
           INT          21h
           XOR          AH, AH
           SUB          AL, 30h               ;zmeni nacitany znak na cislo
           CBW                                ;prevedie BYTE na WORD
           MOV          CX, 2                 ;vynasobi index *2 (cislo zabera v poli 1 slovo)
           MUL          CX
           MOV          DI, AX                ;do pola budeme pristupovat cez DI
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_druhe
           INT          21h
           MOV          AH, 01h               ;nacita index druheho cisla z klavesnice
           INT          21h
           XOR          AH, AH
           SUB          AL, 30h
           CBW
           MOV          CX, 2
           MUL          CX
           MOV          SI, AX                ;do pola budeme pristupovat k druhemu cislu cez SI
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_podiel
           INT          21h
           XOR          AX, AX
           XOR          DX, DX
           CMP          cisla[DI], 00h
           JNS          klad                  ;ak je delenec zaporny, tak DX -1
           SUB          DX, 1
;
klad:      MOV          AX, cisla[DI]
           IDIV         cisla[SI]             ;vydeli so znamienkom cisla
           MOV          zvysok, DX
;
           MOV          BX, AX
           CMP          BX, 00h               ;zisti ci v BX je kladne cislo
           JNS          kladne3               ;ak ano pokracuje na kladne3
           MOV          AH, 02h
           MOV          DL, 2Dh
           INT          21h                   ;vypise znamienko minus
           MOV          AX, BX
           MOV          CX, -1
           IMUL         CX                    ;cislo v AX vynasobi -1
;
kladne3:   XOR          BX,BX
           XOR          CX,CX
           XOR          DX,DX
           MOV          BX, 10000             ;BX je delitelom
           DIV          BX                    ;vydeli cislo v AX
           MOV          CX, DX                ;zvysok v DX presunie do CX
           ADD          AL, 30h               ;prevedie cislo na znak
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 5 rad cisla
           XOR          DX, DX
           MOV          AX, CX                ;zvysok bude delencom
           MOV          BX, 1000
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 4 rad cisla
           XOR          DX, DX
           MOV          AX, CX
           MOV          BX, 100
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 3 rad cisla
           XOR          AH, AH
           MOV          AL, CL                ;AL je delenec (8bit reg)
           MOV          BL, 10                ;delitelom je BL
           DIV          BL                    ;vydeli cislo v AL
           MOV          CL, AH                ;zvysok v AH presunie do CL
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 2 rad cisla
           ADD          CL, 30h
           MOV          AH, 02h
           MOV          DL, CL
           INT          21h                   ;vypise 1 rad cisla
           MOV          AH, 09h
           MOV          DX, OFFSET posun      ;odriadkuje
           INT          21h
           MOV          DX, OFFSET vyp_zvysok
           INT          21h
           MOV          AX, zvysok
           MOV          BX, AX
           CMP          BX, 00h               ;zisti ci v BX je kladne cislo
           JNS          kladne3b              ;ak ano pokracuje na kladne3b
           MOV          AH, 02h
           MOV          DL, 2Dh
           INT          21h                   ;vypise znamienko minus
           MOV          AX, BX
           MOV          CX, -1
           IMUL         CX                    ;cislo v AX vynasobi -1
;
kladne3b:  XOR          BX,BX
           XOR          CX,CX
           XOR          DX,DX
           MOV          BX, 10000             ;BX je delitelom
           DIV          BX                    ;vydeli cislo v AX
           MOV          CX, DX                ;zvysok v DX presunie do CX
           ADD          AL, 30h               ;prevedie cislo na znak
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 5 rad cisla
           XOR          DX, DX
           MOV          AX, CX                ;zvysok bude delencom
           MOV          BX, 1000
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 4 rad cisla
           XOR          DX, DX
           MOV          AX, CX
           MOV          BX, 100
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 3 rad cisla
           XOR          AH, AH
           MOV          AL, CL                ;AL je delenec (8bit reg)
           MOV          BL, 10                ;delitelom je BL
           DIV          BL                    ;vydeli cislo v AL
           MOV          CL, AH                ;zvysok v AH presunie do CL
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 2 rad cisla
           ADD          CL, 30h
           MOV          AH, 02h
           MOV          DL, CL
           INT          21h                   ;vypise 1 rad cisla
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h                   ;skoci na navestie menu
           MOV          DX, OFFSET posun
           INT          21h
           JMP          menu
;
menu4:     MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET vyp_vyber
           INT          21h
           MOV          DX, OFFSET vyp_index
           INT          21h
           MOV          DX, OFFSET retazec
           INT          21h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_prve
           INT          21h
           MOV          AH, 01h               ;nacita index prveho cisla z klavesnice
           INT          21h
           XOR          AH, AH
           SUB          AL, 30h               ;zmeni nacitany znak na cislo
           CBW                                ;prevedie BYTE na WORD
           MOV          CX, 2                 ;vynasobi index *2 (cislo zabera v poli 1 slovo)
           MUL          CX
           MOV          DI, AX                ;do pola budeme pristupovat cez DI
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_druhe
           INT          21h
           MOV          AH, 01h               ;nacita index druheho cisla z klavesnice
           INT          21h
           XOR          AH, AH
           SUB          AL, 30h
           CBW
           MOV          CX, 2
           MUL          CX
           MOV          SI, AX                ;do pola budeme pristupovat k druhemu cislu cez SI
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h
           MOV          DX, OFFSET vyp_sucin
           INT          21h
           MOV          AX, cisla[DI]
           IMUL         cisla[SI]             ;vynasobi so znamienkom cisla
           JO           overflow              ;ak doslo k preteceniu, skoc na overflow
;
           MOV          BX, AX
           CMP          BX, 00h               ;zisti ci v BX je kladne cislo
           JNS          kladne4               ;ak ano pokracuje na kladne4
           MOV          AH, 02h
           MOV          DL, 2Dh
           INT          21h                   ;vypise znamienko minus
           MOV          AX, BX
           MOV          CX, -1
           IMUL         CX                    ;cislo v AX vynasobi -1
;
kladne4:   XOR          BX,BX
           XOR          CX,CX
           XOR          DX,DX
           MOV          BX, 10000             ;BX je delitelom
           DIV          BX                    ;vydeli cislo v AX
           MOV          CX, DX                ;zvysok v DX presunie do CX
           ADD          AL, 30h               ;prevedie cislo na znak
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 5 rad cisla
           XOR          DX, DX
           MOV          AX, CX                ;zvysok bude delencom
           MOV          BX, 1000
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 4 rad cisla
           XOR          DX, DX
           MOV          AX, CX
           MOV          BX, 100
           DIV          BX
           MOV          CX, DX
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 3 rad cisla
           XOR          AH, AH
           MOV          AL, CL                ;AL je delenec (8bit reg)
           MOV          BL, 10                ;delitelom je BL
           DIV          BL                    ;vydeli cislo v AL
           MOV          CL, AH                ;zvysok v AH presunie do CL
           ADD          AL, 30h
           MOV          AH, 02h
           MOV          DL, AL
           INT          21h                   ;vypise 2 rad cisla
           ADD          CL, 30h
           MOV          AH, 02h
           MOV          DL, CL
           INT          21h                   ;vypise 1 rad cisla
           MOV          AH, 09h
           MOV          DX, OFFSET posun      ;odriadkuje
           INT          21h
           MOV          AH, 09h
           MOV          DX, OFFSET posun
           INT          21h                   ;skoci na navestie menu
           JMP          menu
;
overflow:  MOV          AH, 09h
           MOV          DX, OFFSET vyp_of
           INT          21h
           MOV          DX, OFFSET posun
           INT          21h
           JMP          menu
;
menu5:     MOV          AX, 4C00h            ;odovzdanie spravy operacnemu systemu
           INT          21h
;
code       ENDS                              ;koniec kodoveho segmentu
           END          start                ;koniec programu
;
;ZAVERECNE HODNOTENIE
;
;program je plne funkcny
;
;program bol vypracovany na PC 486 DX4, pouzite prekladace:
;Turbo Assembler v 2.2
;Turbo Link v 3.01
;
;vstupny subor musi byt presne specifikovany(znamienko,tri cifry,medzera)
;neotvorenie vstupneho suboru je osetrene
;nespravna volba v menu je osetrena
;nespravny vyber cisel nie je osetreny(musi byt zadane cislo v rozsahu 0-9)
;nie je osetrene delenie nulou