;Zadanie c.3
;Text zadania:
;S vyuzitim  retazcovich  instrukcii  (vsade   kde  je  to  mozne) vytvorte 
;program, ktory:
;	a) nacita z  klavesnice dva  retazce do  dvoch roznych segmentov
;    	   (minimalne dlzky 20 Byte),
;	b) prvy retazec presunie v segmente o 10 slabik na vyssie adresy
;	c) porovna posunuty retazec s retazcom v druhom segmente,
;	   t.j. zisti ci su rovnake a rovnako dlhe
;	d) zisti,  ci  sa  v  niektorom   z  retazcov  nachadza zo
;   	   vstupu zadany podretazec.

;Autor: Teodor PETRIK
;Termin odvzdania:5.12.2000
;2.roc.,sk.rok 2000/2001

;program bol skompilovany programom tasm 3.2, zlinkovany tlink5.2
;program bol napisany na pocitaci 486DX2/66, 16 MB RAM, Win95
;obmedzenia programu: maximalna dlzka retazcov je 80 znakov 

;cls        	vymaze obrazovku
;setcur        	nastav kurzor na polohu x,y na obrazovke
;menu     	vypise menu
;compare	porovna dva retazce
;sbstr		hlada retazec v 2 nacitanych retazcoch

.model small
.stack 100h   			;zasobnik  velkosti 256kB

popx equ pop di si dx cx bx ax	;definujem makro popx, pushx
pushx equ push ax bx cx dx si di;ulozenie a nacitanie stavu procesora

zasobnik segment stack  	;zasobnikovy segment
	dw 64 dup(?)
zasobnik ends
	                        ;zaciatok datoveho segmentu
data1 segment
	vstup1 db 80		;premenne do ktorych sa ulozi info	
	pocet1 db (0)           ; o premennych po volani BIOS funkcie 0ah
	retazec1 db 80 dup('$')

	vstup3 db 80            ;max pocet znakov
	pocet3 db (0)           ;pocet nacitanych znakov
	retazec3 db 80 dup('$') ;nacitany retazec

        autor db 10,13,10,13,10,13,"                              Teodor PETRIK  B12$"
	menutitle db "                	    Zadanie  c.3$"
	menuitem2 db 10,13,10,13,"                 a) .......... Nacita 2 retazce ..........$"
	menuitem3 db 10,13,"                 b) .. Posunie prvy retazec o 10 slabik ..$"
	menuitem4 db 10,13,"                 c) ...... Porovna  obidva  retazce ......$"
	menuitem5 db 10,13,"                 d) .... Hlada podretazec v retazcoch ....$"
	menuitem6 db 10,13,10,13,"                 k) ........... Ukonci program ...........$"
	message1 db "Zadajte retazec: $"
	message2 db "Retazce su rovnake$"
	message3 db "Retazce su rozne$"
	message4 db "Zadajte hladany podretazec: $"
	message5 db "Hladany retazec sa NEnachadza v 2. retazci",10,13,"$"
	message6 db "Hladany retazec sa nachadza v 2. retazci",10,13,"$"
	message7 db "Hladany retazec sa NEnachadza v 1. retazci",10,13,"$"	
	message8 db "Hladany retazec sa nachadza v 1. retazci",10,13,"$"	
data1 ends

data2 segment
	vstup2 db 80		;to iste ako v segmente data1	
	pocet2 db (0)
	retazec2 db 80 dup('$')
data2 ends
  
code segment                    ;zaciatok code segmentu
	assume cs:code, ds:data1, es:data2, ss:zasobnik  ;priradenie registrov 
				;jednotlivym segmentom

cls proc near			;vymaze obrazovku
	pushx
	mov ax,3                ;nastavi mod 3 (80x25)
	int 10h
	popx
	ret
cls endp

setcur proc near	 	;nastavi kurzor na poziciu
	pushx         		;dh=riadok, dl=stlpec
	mov bh,0
	sub dx,0100h
	mov ah,02
	int 10h
	popx
	ret
setcur endp

menu proc near
	mov dx,0705h   		;riadok=5 stlpec=5
	call setcur             ;nastavenie polohy kurzora na obrazovke
	mov ah,09               ;vypisanie menu na obrazovku
	mov dx,offset menutitle 
	int 21h
	mov dx,offset menuitem2
	int 21h
	mov dx,offset menuitem3
	int 21h
	mov dx,offset menuitem4
	int 21h
	mov dx,offset menuitem5
	int 21h
	mov dx,offset menuitem6
	int 21h
	mov dx,offset autor
	int 21h
        ret
menu endp

readtext proc near
   	pushx
	call cls
	mov dx,0505h   			;riadok=5 stlpec=5
	call setcur
	mov ah,09h
	mov dx,offset message1		;vypisanie spravy na obrazovku
	int 21h
	mov ah,0ah
	mov dx,offset vstup1		;nacitanie 1 retazca 			
	int 21h
	mov dx,0605h 	  		;riadok=6 stlpec=5
	call setcur
	mov ah,09h
	mov dx,offset message1		;vypisanie spravy na obrazovku
	int 21h
	push ds                         ;ulozenie hodnoty v ds
	mov ax,seg data2                ;nastavenie es->ds, kvoli
	mov ds,ax                       ;pouzitej funkcii 0ah
	mov dx,offset vstup2            ;ktora nacitava do ds:dx
	mov ah,0ah
	int 21h
	pop ds                          ;vyvolanie ds zo stack
	popx
	ret
readtext endp

compare proc near
	pushx
	call cls
	mov dx,0810h   		;riadok=8 stlpec=10
	call setcur
	mov al,pocet1		;porovnanie poctu znakov
	cmp al,pocet2
	jne nmatch              ;ak nie je rovnaky tak nmatch
	mov si,offset retazec1  ;do si offset retazca1
	mov di,offset retazec2  ;do di retazca2
	cld                     ;clear direction flag - smer spracovania retazcov
	mov cl,pocet1           ;do cx pocet znakov 1 retazca
	repe cmpsb              ;opakuj pokial rovne - porovnaj byte
	jne nmatch              ;ak nerovnake tak nmatch
	mov dx,offset message2	;vypis spravu ak su rovnake
	jmp endcmp              ;skoc na koniec proc
nmatch: mov dx,offset message3  ;ak nie su rovnake -> sprava
endcmp:	mov ah,09h              ;vypis na obr.
	int 21h
	mov ah,0                ;cakaj na stlacenie klavesy
	int 16h
	popx
	ret
compare endp

sbstr proc near
	pushx
	call cls
	mov dx,0505h   		;riadok=5 stlpec=5
	call setcur
	mov ah,09h
	mov dx,offset message4	;vypisanie spravy na obrazovku
	int 21h
	mov ah,0ah
	mov dx,offset vstup3    ;nacitanie hladaneho podretazca
	int 21h
	mov dx,0800h   		;riadok=8 stlpec=0
	call setcur             ;najskor porovname 2 retazec (mame ho v es)
	mov cl,pocet2           ;do cx pocet znakov 2 retazca
	mov di,offset retazec2  ;do di zaciatok 2 retazca
find:	mov al,retazec3[0]      ;do al prvy znak hlad. retazca
	repne scasb	        ;opakuj pokial sa nerovna prvy znak
	je find1                ;ak sa rovna tak find1
	mov dx,offset message5  ;ak nenasiel v 2 retazci vypis spravu
	mov ah,09h
	int 21h
finds:  mov ax,ds               ;to iste pre 1 retazec, ale najskor
	mov es,ax               ;musim zamenit segmenty
	mov cl,pocet1
	mov di,offset retazec1
findx:	mov al,retazec3[0]
	repne scasb	
	je findx1
        mov dx,offset message7
	mov ah,09h
	int 21h
        jmp endsbstr

find1:	push cx                	;ak nasiel tak uloz cx a di
	push di
	dec di                  ;vrat sa o jeden znak
	mov cl,pocet3           ;do cx pocet znakov hladaneho retazca
	mov si,offset retazec3  ;do si zaciatok hlad. retazca
	repe cmpsb              ;porovnaj tak ako v COMPARE procedure
	jne nfind2
	mov ah,09h
	mov dx,offset message6  ;ak nasiel tak vypis spravu
	int 21h
	pop di                  ;nacitaj spat stav registrov pred find1
	pop cx
	jmp finds
nfind2: pop di                  ;ak nenasiel tak navrat
	pop cx
	jmp find

findx1:	push cx di
	dec di
	mov cl,pocet3
	mov si,offset retazec3
	repe cmpsb
	jne nfindx2
	mov ah,09h
	mov dx,offset message8
	int 21h
	pop di cx
	jmp endsbstr
nfindx2:pop di cx
	jmp findx

nfind:	mov ah,09h
	int 21h
endsbstr:mov ah,0
	int 16h
	popx
	ret
sbstr endp

posun proc near
	pushx
	call cls		
	mov ax,seg data1
	mov es,ax
	std
	mov cl,pocet1
	mov si,offset retazec1
	mov di,offset retazec1
	add di,10
        add di,cx
	sub di,1
        add si,cx
	sub si,1
	rep movsb
	add pocet1,10
	mov ax,es
	mov ds,ax
	mov dx,offset retazec1
	mov ah,09h
	int 21h
	mov ah,0
	int 16h
	popx
	ret
posun endp		
	

start:	nop
repeat: mov ax,seg data1        ;nastav spravne segmentove registre
	mov ds,ax
	mov ax,seg data2
	mov es,ax
	call cls		;zmaz obrazovku
	call menu	        ;vypis menu
case:	mov ah,0                ;cakaj na vstup z klavesnice
        int 16h	                
	cmp al,'a'              ;porovnaj nacitany znak
	jz m2                   ;ak sa zhoduje vykonaj mx
	cmp al,'b'
	jz m3
	cmp al,'c'
	jz m4
	cmp al,'d'
	jz m5
	cmp al,'k'
	jz m6
	jmp case                ;ak sa nezhoduje ani s jednym opakuj
		                ;volaj jednotlive procedury
			        ;vrat sa do menu
m2:	call readtext
        jmp repeat
m3:	call posun
	jmp repeat
m4:	call compare
	jmp repeat
m5:	call sbstr
	jmp repeat
m6:	jmp koniec
koniec:	mov ax,4c00h            ;ukoncenie vykonavania programu
	int 21h
code ends
end start
